SystemOrganization addCategory: #'GBT-DSL'!
SystemOrganization addCategory: 'GBT-DSL-Actions-Beh-depr'!
SystemOrganization addCategory: 'GBT-DSL-M-Contexts'!
SystemOrganization addCategory: 'GBT-DSL-M-Directives'!
SystemOrganization addCategory: 'GBT-DSL-M-Messaging'!
SystemOrganization addCategory: 'GBT-DSL-M-Runtime'!
SystemOrganization addCategory: 'GBT-DSL-M-Server'!
SystemOrganization addCategory: 'GBT-DSL-M-Things'!
SystemOrganization addCategory: 'GBT-DSL-M-Traits'!
SystemOrganization addCategory: 'GBT-DSL-M-core'!
SystemOrganization addCategory: 'GBT-DSL-Parser'!
SystemOrganization addCategory: 'GBT-DSL-Tests'!
SystemOrganization addCategory: 'GBT-DSL-Tests-AppService'!
SystemOrganization addCategory: 'GBT-DSL-Tests-GUI'!
SystemOrganization addCategory: 'GBT-DSL-Tests-Parser'!
SystemOrganization addCategory: 'GBT-DSL-UI-Thing'!
SystemOrganization addCategory: 'GBT-DSL-UI-Thing-Leaves'!
SystemOrganization addCategory: 'GBT-DSL-UI-context'!
SystemOrganization addCategory: 'GBT-DSL-Utilities'!

Trait named: #TGbtAccessSerialized
	uses: {}
	category: 'GBT-DSL-M-Traits'!

!TGbtAccessSerialized commentStamp: 'hk 3/31/2017 13:24' prior: 0!
either STON or JSON 

I read thing attributes out of the serialized string using patterns

My implementaion relates to the structure of names and ids in things!

!TGbtAccessSerialized classSide methodsFor: 'longName parts' stamp: 'hk 3/30/2017 12:52'!
classInitialAndIdOf: aLongName
	^(self matchesOf: aLongName)
		subexpression: 3	
	

	! !

!TGbtAccessSerialized classSide methodsFor: 'private' stamp: 'hk 3/30/2017 12:52'!
matchesOf: aLongName
	"values are longNames of the Form (\w+)\:([T|U]\d+)(v\d+) 
	answer the matches of the parts"
	^ '(\w+)\:([T|U]\w*\d+)(v\d+)' asRegex matchesPrefix: aLongName; yourself! !

!TGbtAccessSerialized classSide methodsFor: 'longName parts' stamp: 'hk 3/30/2017 12:52'!
svoNameOf: aLongName
	^(self matchesOf: aLongName)
		subexpression: 2	
	

	! !

!TGbtAccessSerialized classSide methodsFor: 'longName parts' stamp: 'hk 3/30/2017 12:52'!
versionOf: aLongName
	^(self matchesOf: aLongName)
		subexpression: 4	
	

	! !

!TGbtAccessSerialized methodsFor: 'accessing serialized node' stamp: 'hk 3/30/2017 12:37'!
classInitialAndIdOf: aSerializedNode 
	"aSerializedNode classInitialAndId "
	| searchString |
	searchString := '#id\s\:\s\''(\w+)\''\,'.
	^ 'T',	((searchString asRegex search: aSerializedNode; yourself) subexpression: 2) ! !

!TGbtAccessSerialized methodsFor: 'accessing serialized node' stamp: 'hk 2/7/2017 14:24'!
longNameOf: aSerializedNode
	"aSerializedNode longName"
	^(self svoNameOf: aSerializedNode), ':', (self classInitialAndIdOf: aSerializedNode), (self versionStringOf: aSerializedNode)! !

!TGbtAccessSerialized methodsFor: 'accessing serialized node' stamp: 'hk 2/7/2017 14:25'!
svoNameOf: aSerializedNode
	"aSerializedNode svoName"
	^('#svoName\s\:\s[''|#](\w+)' asRegex search: aSerializedNode; yourself) subexpression: 2 ! !

!TGbtAccessSerialized methodsFor: 'accessing serialized node' stamp: 'hk 2/7/2017 14:25'!
versionStringOf: aSerializedNode 
	"aSerializedNode versionString"
	^ 'v',	(('#version\s\:\s([0-9]+)' asRegex search: aSerializedNode; yourself) subexpression: 2)! !

Trait named: #TGbtBareID
	uses: {}
	category: 'GBT-DSL-M-Traits'!

!TGbtBareID commentStamp: 'hk 9/28/2017 13:21' prior: 0!
allow to set an id for non-GbtObjects.

instance-vars required: 	
	id: 	<Integer>
		
class instance vars required:
	bareID: 	<Interger> 	to be iitialized on retrieve!

!TGbtBareID classSide methodsFor: 'id' stamp: 'hk 9/28/2017 17:36'!
incrementBareID
	"leaf IDs are constrained to an image !!"
	
	self bareID: (self bareID + 1) \\65536.
	^self bareID! !

!TGbtBareID methodsFor: 'initialization' stamp: 'hk 9/28/2017 13:13'!
setID
	self id: self class incrementBareID! !

Trait named: #TGbtEvolve
	uses: {}
	category: 'GBT-DSL-M-Traits'!

!TGbtEvolve commentStamp: 'hk 5/20/2017 18:35' prior: 0!
I hold the core  behavior for  evolution
Evolution is an implementation for persistent Store of slots,
keeping the evolution history in previous and next for undo/redo.

Slots are copied lazy, i.e. only when a copy is needed because of a new value


Used accessors / instance variables:  
	slots
	previous
	next
	beDirty
	
Implementation points 
 	since any change causes me to be dirty up to my root, 
	an undo or redo cannot remove the dirty flag!

!TGbtEvolve methodsFor: 'evolve' stamp: 'hk 1/19/2018 12:18'!
becomeNext
	"become my next; set my previous. insert a new previous"

	self next ifNil: [^self].
	self previous: (self shallowCopy previous: self previous).
	self previous slots: self slots.
	self slots: self next slots.
	self setEvolveCountFromNext.
	self next: self next next.
	self buildContainerHierarchy ! !

!TGbtEvolve methodsFor: 'evolve' stamp: 'hk 1/19/2018 12:18'!
becomePrevious
	"become my previous; insert a new next"
	
	self previous ifNil: [^self].
	self next: (self shallowCopy next: self next).
	self next slots: self slots.
	self slots: self previous slots.
	self setEvolveCountFromPrevious.
	self previous: self previous previous.
	self buildContainerHierarchy ! !

!TGbtEvolve methodsFor: 'evolve' stamp: 'hk 7/31/2017 16:49'!
clearEvolution
	self previous ifNotNil: [:p| p clearEvolution].
	self next ifNotNil: [:n| n clearEvolution].
	self previous: nil.
	self next: nil.
	self resetEvolveCount! !

!TGbtEvolve methodsFor: 'evolve' stamp: 'hk 8/18/2017 16:40'!
evolve
	"is called before writing a slot. Also see GbtWidget.write"
	
	self previous: self shallowCopy copyEvolveCount.
	self copySlots.
	self beDirty .
	self incrEvolveCount.
	^self previous 

! !

!TGbtEvolve methodsFor: 'evolve' stamp: 'hk 10/4/2017 14:55'!
evolve: aSlotName write: aValue
	"set the slot value"
	"PRE aSlotName denotes an existing leaf slot"
	
	([aValue isThing] ifError: [false]) ifTrue: [^self evolveNode: aSlotName write: aValue].
	^self evolveLeaf: aSlotName write: aValue
	
! !

!TGbtEvolve methodsFor: 'evolve' stamp: 'hk 1/19/2018 17:32'!
evolveAddSlot: aGbtSlotAssociation
	self evolve.
	^self writeSlot: aGbtSlotAssociation

! !

!TGbtEvolve methodsFor: 'evolve' stamp: 'hk 10/4/2017 15:00'!
evolveLeaf: aSlotName write: aValue
	"set the slot value"
	"PRE aSlotName denotes an existing leaf slot"
	
	|vo previous newVO | 
	vo := self slotSVOAt: aSlotName.
	previous := self evolve.
	newVO := vo copy inputValue: aValue; container: self.
	self slots at: aSlotName put: 
		((self slots at: aSlotName) copy value: newVO ).
	vo container: previous.
	self next: nil.
	^newVO


! !

!TGbtEvolve methodsFor: 'evolve' stamp: 'hk 11/30/2017 11:38'!
evolveNode: aSlotName write: aThing
	"^nil if slot is missing, set the slot value (SVO) otherwise
	PRE node slot aSlotName exists"
	
	| sv previous |
	([aThing isNode] ifError: [false]) ifFalse: [^self error: 'NaThing: ', aThing asString].
	previous := self evolve.
	sv := self slotSVOAt: aSlotName.
	self slots at: aSlotName put: ((self slots at: aSlotName) copy value: aThing).
	aThing container: self.
	sv replaceContainer: previous.
	self next: nil.
! !

!TGbtEvolve methodsFor: 'evolve' stamp: 'hk 7/29/2017 14:43'!
evolveRemoveSlot: aGbtSlotAssociation
	| prev |
	prev := self evolve.
	self slots removeKey: (aGbtSlotAssociation newValueContainer: prev) key! !

Trait named: #TGbtExecutable
	uses: {}
	category: 'GBT-DSL-M-Traits'!

!TGbtExecutable commentStamp: 'hk 3/16/2017 13:02' prior: 0!
I hold the delegation protocoll for the  instance variable programStore!

!TGbtExecutable methodsFor: 'executable' stamp: 'hk 1/5/2018 18:20'!
add: anSVO full: aFullVO   
	self executable add: anSVO full: aFullVO! !

!TGbtExecutable methodsFor: 'executable' stamp: 'hk 9/7/2017 19:26'!
addAC: anAC 
	^self executable addAC: anAC ! !

!TGbtExecutable methodsFor: 'executable' stamp: 'hk 9/25/2017 15:44'!
addDirective: anSVO 
	^self executable addDirective: anSVO ! !

!TGbtExecutable methodsFor: 'thing cache' stamp: 'hk 9/7/2017 19:23'!
addThing: anSVO 
	self tecNoPolicy adaptTo: anSVO id.
	^(self executable thingsAt: anSVO svoName) addLast: anSVO 
! !

!TGbtExecutable methodsFor: 'template editor' stamp: 'hk 11/30/2017 15:44'!
allACsWithTemplates
	"answer all ACs with templates for the template editor"
	^self allContexts select: [:c| c thingTemplates isNotEmpty].
! !

!TGbtExecutable methodsFor: 'executable' stamp: 'hk 9/7/2017 19:26'!
allContexts
	^self executable allContexts! !

!TGbtExecutable methodsFor: 'executable' stamp: 'hk 9/25/2017 15:42'!
allDirectives
	^self executable allDirectives! !

!TGbtExecutable methodsFor: 'executable' stamp: 'hk 9/7/2017 19:26'!
allFsvosWithTemplates
	^self executable allFsvosWithTemplates! !

!TGbtExecutable methodsFor: 'template editor' stamp: 'hk 3/23/2017 15:41'!
allSlotAssocsWithTemplates
	^self allACsWithTemplates! !

!TGbtExecutable methodsFor: 'thing cache' stamp: 'hk 12/5/2017 16:13'!
allThings
	^self executable allThings! !

!TGbtExecutable methodsFor: 'executable' stamp: 'hk 5/5/2017 15:48'!
contextNamed: anACname  
	^self type: #context named: anACname ifAbsent: []! !

!TGbtExecutable methodsFor: 'executable' stamp: 'hk 9/7/2017 19:26'!
contextNoPolicyOf: anACname  
	^self executable contextNoPolicyOf: anACname  ! !

!TGbtExecutable methodsFor: 'executable' stamp: 'hk 9/7/2017 19:26'!
contextNoPolicyOf: anACname getter: aSelector
	"set the getter"
	(self executable contextNoPolicyOf: anACname) getter: aSelector ! !

!TGbtExecutable methodsFor: 'executable' stamp: 'hk 9/7/2017 19:26'!
contextNoPolicyOf: anACname prefix: aString
	"set the prefix"
	(self executable contextNoPolicyOf: anACname) prefix: aString! !

!TGbtExecutable methodsFor: 'executable' stamp: 'hk 9/24/2017 15:39'!
directiveNamed: aName 
	"answer the decl with aName "

	^self type: #decl named: aName ifAbsent: []! !

!TGbtExecutable methodsFor: 'executable' stamp: 'hk 5/5/2017 15:41'!
fullThingNamed: aName
	^self type: #fullThing named: aName ifAbsent: []! !

!TGbtExecutable methodsFor: 'executable' stamp: 'hk 3/21/2017 19:37'!
hasContext: anACName
	(self contextNamed: anACName) ifNil: [^false].
	^true! !

!TGbtExecutable methodsFor: 'testing' stamp: 'hk 12/5/2017 16:20'!
hasContexts
	^self executable allContexts isNotEmpty! !

!TGbtExecutable methodsFor: 'testing' stamp: 'hk 12/5/2017 16:20'!
hasDecls
	^self executable allDirectives isNotEmpty! !

!TGbtExecutable methodsFor: 'testing' stamp: 'hk 12/5/2017 16:21'!
hasThings
	^self executable allThings isNotEmpty! !

!TGbtExecutable methodsFor: 'testing' stamp: 'hk 12/5/2017 16:21'!
isCompiled
	^self executable mainCtxtName isNotNil! !

!TGbtExecutable methodsFor: 'api' stamp: 'hk 12/5/2017 16:15'!
loadList: svoName 
	| list |
	list := self executable reader loadList: svoName .
	list do: [:th| th registerWith: self].
	^list! !

!TGbtExecutable methodsFor: 'executable' stamp: 'hk 9/7/2017 19:27'!
mainContext  
	^self type: #context named: self executable mainCtxtName ifAbsent: []! !

!TGbtExecutable methodsFor: 'executable' stamp: 'hk 3/16/2017 12:37'!
nextIdOfContextNoPolicy: anACname  
	^(self contextNoPolicyOf: anACname) nextID! !

!TGbtExecutable methodsFor: 'executable' stamp: 'hk 11/1/2017 17:25'!
policyPrefixOf: anACname 
	"get the prefix"
	^(self executable contextNoPolicyOf: anACname) prefix! !

!TGbtExecutable methodsFor: 'analysis' stamp: 'hk 12/5/2017 16:22'!
selectedNodesInHierarchy
	^self executable selectedNodesInHierarchy! !

!TGbtExecutable methodsFor: 'template editor' stamp: 'hk 3/23/2017 15:39'!
svoName
	"used by the template editor"  
	^'Context Templates'! !

!TGbtExecutable methodsFor: 'accessing' stamp: 'hk 12/5/2017 16:23'!
tecNoPolicy
	^self executable tecNoPolicy! !

!TGbtExecutable methodsFor: 'thing cache' stamp: 'hk 5/7/2017 22:21'!
thingNamed: aName 
	"answer the svo with aName = svoName:id-version or svoName(with lowest id-version)"
	^self type: #thing named: aName ifAbsent: []! !

!TGbtExecutable methodsFor: 'api' stamp: 'hk 12/5/2017 16:16'!
type: aType named: aName ifAbsent: absentBlock
	^self executable type: aType named: aName ifAbsent: absentBlock! !

!TGbtExecutable methodsFor: 'thing cache' stamp: 'hk 12/5/2017 16:19'!
withBizId: aBizId
	^self executable withBizId: aBizId ! !

Trait named: #TGbtSerializer
	uses: {}
	category: 'GBT-DSL-M-Traits'!

!TGbtSerializer commentStamp: 'hk 2/7/2017 14:49' prior: 0!
either STON or JSON

I know about GbtThing>>versionedNodes & stripped!

!TGbtSerializer classSide methodsFor: 'deserializing' stamp: 'hk 5/11/2017 12:40'!
fromString: aSerializedNode 
	^STON fromString: aSerializedNode ! !

!TGbtSerializer methodsFor: 'serializing' stamp: 'hk 5/15/2017 23:18'!
serializedNodes2Store
	^self versionedNodes2Store collect: [:n| n stripped toString]
! !

!TGbtSerializer methodsFor: 'serializing' stamp: 'hk 2/6/2017 13:58'!
toString
	^STON toStringPretty: self! !

Trait named: #TGbtThingMeta
	uses: {}
	category: 'GBT-DSL-M-Traits'!

!TGbtThingMeta commentStamp: 'hk 9/14/2017 14:20' prior: 0!
I hold all meta functions of Things: 
- interpreting the slotName or a tag as getter message
- direct slot access 
- interpreting smart paths

====
a smartPath is defined by the  atSmartPath: method.
A  smartPathArray may start with 'G' or 'L' denoting global- or localRoot.
Then the search starts at the global or localRoot.
Otherwise it starts at  self
!

!TGbtThingMeta methodsFor: 'meta path' stamp: 'hk 2/16/2017 15:08'!
addNodesTo: nodesToVisit withPath: aPath
	"breadth-first search: add subnodes to nodesToVisit "

	self slots do: [ :a |  |p|
		p := aPath copy add: a key; yourself.
		nodesToVisit add: {p . a} ].
! !

!TGbtThingMeta methodsFor: 'meta-smart path' stamp: 'hk 9/4/2017 13:14'!
atFullPath: aSmartPathArray
	"^nil or the result of accessing self with aSmartPathArray 					-			 used by GbtActions 
	POST as a side effect the branch denoted by aSmartPathArray exists"
	
	| res |
	res := self.  
	aSmartPathArray do: [:tag| res := res perform: tag asSymbol].
	^res! !

!TGbtThingMeta methodsFor: 'meta-smart path' stamp: 'hk 1/3/2018 10:36'!
atSmartPath: aSmartPathArray
	"^ the result of accessing self with aSmartPathArray.
	a smartPathArray may start with 'G' or 'L' denoting global- or localRoot
	this method has NO side effects"
	
	| start spa |
	start := self.
	spa := aSmartPathArray.
	spa ifNotEmpty: [
		(spa first = #G) ifTrue: [start := self globalRoot. spa := spa allButFirst].
		(spa first = #L) ifTrue: [start := self localRoot. spa := spa allButFirst]].
	^start atSmartPath: spa with: OrderedCollection new! !

!TGbtThingMeta methodsFor: 'meta-smart path' stamp: 'hk 1/24/2018 18:55'!
atSmartPath: aSmartPathArray with: pathSoFar
	"^nil or the node or val found"
	
	|tag res restPath|  
	(aSmartPathArray size =1) ifTrue: [^self atTag: aSmartPathArray first asSymbol with: pathSoFar].
	tag := aSmartPathArray first.
	restPath := aSmartPathArray allButFirst.
	pathSoFar addAll: ((self pathTo: tag) ifNil: [^nil]).
	res := self perform: tag asSymbol. 
	(res isKindOf: GbtSmartNode) ifFalse: 
			[pathSoFar addLast: restPath first. ^self error: 'NaP: ', pathSoFar asArray printSmartPath].
	^res atSmartPath: restPath with: pathSoFar 
! !

!TGbtThingMeta methodsFor: 'meta-smart path' stamp: 'hk 1/25/2018 18:40'!
atTag: aTag with: pathSoFar
	"^nil or val or slot found"
	
	(self respondsTo: aTag asSymbol) ifTrue: [^self perform: aTag asSymbol]. 
	^(self pathTo: aTag) ifNotNil: [self perform: aTag asSymbol]
	
! !

!TGbtThingMeta methodsFor: 'meta path' stamp: 'hk 9/5/2017 14:04'!
broadPathTo: aTag onPath: aPath with: nodesToVisit
	"^<nil|OrderedCollection of Symbol>, the path of the node or leaf with the unique tag or slotName aTag"

	self addNodesTo: nodesToVisit withPath: aPath.

	[nodesToVisit isNotEmpty] whileTrue: [ | a p |
		a := nodesToVisit first at: 2.
		p := nodesToVisit first at: 1.
		(a hasTag: aTag) ifTrue: 
			[^{ #success . p} ] .
		a value ifNotNil: [:v | 
			v isNode ifTrue: 
				[v addNodesTo: nodesToVisit withPath: p]].
		nodesToVisit removeFirst ].
	^{ #failure . aPath}! !

!TGbtThingMeta methodsFor: 'meta path' stamp: 'hk 9/5/2017 13:12'!
deepPathTo: aTag onPath: aPath 
	"^<nil|OrderedCollection of Symbol>, the path of the node or leaf with the unique tag or slotName aTag"

	| res |  
	self slots do: [ :a | 
		(a hasTag: aTag) ifTrue: 
			[^{ #success . aPath add: a key; yourself} ] .
		a value ifNotNil: [:v | |p|
			v isNode ifTrue: 
				[(p := aPath copy) add: a key.
				res := v deepPathTo: aTag onPath: p .
				(res at: 1) = #success ifTrue: [^res] ] ] ].
	^{ #failure . aPath}! !

!TGbtThingMeta methodsFor: 'meta' stamp: 'hk 9/18/2017 21:42'!
doesNotUnderstand: aMessage
	"answer or change the named slot content respecting evolution.
	answer nil when the slot is not present in me smart thing.
	aMessage may refer to a slotName or a tag"

	| tag node slotName failBlock sa|  
	failBlock := [super doesNotUnderstand: aMessage].
	tag := aMessage selector asSymbol.	"may be a slotName or a tag"
	[sa := self slotAssocOf: tag] 		"will be created in smart thing"
		ifError: [^failBlock value].			"slot not found in full thing"
	node := sa container. 
	slotName  := sa key. 
	tag isKeyword ifTrue: [  	"= setter:"
		node slotAt: slotName write: aMessage argument].
	^(node slotValueAt: slotName) ifNil: [^failBlock value]			! !

!TGbtThingMeta methodsFor: 'meta path' stamp: 'hk 9/5/2017 15:33'!
pathTo: aTag 
	"^<nil|OrderedCollection of Symbol>, the path to the node or leaf with aTag"
	| res |
	self searchStrategy
		ifNotNil: [res := self deepPathTo: aTag onPath: OrderedCollection new]
		ifNil: [res := self broadPathTo: aTag onPath: OrderedCollection new with: OrderedCollection new].
	^(res at: 1) = #success
		ifTrue: [res at: 2] 	"the path"
		ifFalse: [nil]! !

!TGbtThingMeta methodsFor: 'meta' stamp: 'hk 9/18/2017 15:58'!
slotAssocOf: aSelectorOrTag
	"answer the node and slotAssoc of aSlotName|tag, 
	smartAddBranch will raise an error, when called with a non-full-existing tag or slotName
	POST smart thing is grown"

	| path slotNameOrTag |
	slotNameOrTag := (aSelectorOrTag trimRight: [ :c | c = $: ]) asSymbol.
	path := (self pathTo: slotNameOrTag) ifNil: 
		[self smartAddBranch: slotNameOrTag.
		self pathTo: slotNameOrTag].
	^self slotAssocOnPath: path ! !

!TGbtThingMeta methodsFor: 'meta path' stamp: 'hk 9/18/2017 17:08'!
slotAssocOnPath: aPath
	"answer the subNode slot aSlotName. 
	PRE aPath is valid and isNotEmpty"
	
	| res |
	res := self slotAt: aPath first asSymbol.
	^res value slotAssocOnPath: (aPath allButFirst ifEmpty: [^res])! !

!TGbtThingMeta methodsFor: 'meta path' stamp: 'hk 9/18/2017 15:58'!
slotOnPath: aPath
	"answer the subNode slot addressed by aPath. 
	PRE aPath is valid and isNotEmpty"
	
	^(self slotAssocOnPath: aPath) value! !

!TGbtThingMeta methodsFor: 'meta' stamp: 'hk 9/18/2017 16:53'!
slotTagged: aSymbol
	^self slotOnPath: ((self pathTo: aSymbol) ifNil: [^nil]) ! !

!TGbtThingMeta methodsFor: 'meta' stamp: 'hk 8/27/2017 14:03'!
smartAddBranch: aSlotNameOrTag 

	| startNode refNode path|
	startNode := self.
	refNode := self fullThing. 
	path := (refNode pathTo: aSlotNameOrTag) ifNil: [ self error: 'no path to ',aSlotNameOrTag ].
	path do: [ :slotn |  |sn |
			sn := slotn asSymbol.
			startNode := startNode slotSVOAt: sn ifAbsent: [startNode smartAddSlotSVO: sn].
			refNode := refNode slotSVOAt: sn]! !

!Array methodsFor: '*GBT-DSL' stamp: 'hk 7/21/2017 17:48'!
printSmartPath
	|stream|
	stream := WriteStream on: ''.
	self do: [:e| stream nextPutAll: e; nextPut: $:].
	^stream contents allButLast! !

!ComposableModel methodsFor: '*GBT-DSL' stamp: 'hk 11/9/2016 14:06'!
notify: aString
	owner notify: aString! !

ComposableModel subclass: #GbtWidget
	instanceVariableNames: 'widgetValue slotVO changeFlag slotLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing-Leaves'!

!GbtWidget commentStamp: 'hk 1/24/2018 13:02' prior: 0!
abstract superclass of all  widgets contained in a GbtSlotWidget

    Instance Variables
	changeFlag:		<ValueHolder>			used to indicate value changes for calc slots
	slotLabel:		<String>					label for the slot name
	slotVO:			<GbtCell | GbtSmartNode>		leaf ot thing to be displayed
	widgetValue:		<ComposableModel>		the real widget  

We need the changeFlag to handle horizontal dependencies between the widgets of a thing,
see GbtThingEditor>>initializePresenter  and GbtThingDiEditor>>initializeRightPresenter!

GbtWidget subclass: #GbtChoiceWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing-Leaves'!

!GbtChoiceWidget commentStamp: 'hk 11/1/2017 15:24' prior: 0!
I display a EnumVO
!

!GbtChoiceWidget methodsFor: 'initialization' stamp: 'hk 5/7/2017 15:09'!
initializePresenter
	self widgetValue whenSelectedItemChanged: 
		[:item | self write: item] ! !

!GbtChoiceWidget methodsFor: 'initialization' stamp: 'hk 12/1/2017 10:13'!
initializeWidgets
	self instantiateModels: #(widgetValue	DropListModel ) .	
	self widgetValue 
		items: slotVO list;
		displayBlock: [ :item | item asString ] .
	self read.
	super initializeWidgets
! !

!GbtChoiceWidget methodsFor: 'basic read-write' stamp: 'hk 8/1/2017 17:16'!
read
	self widgetValue selectedItem = slotVO val asString ifTrue: [^nil].
	self widgetValue setSelectedItem: slotVO val asString! !

GbtWidget subclass: #GbtDateWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing-Leaves'!

!GbtDateWidget commentStamp: 'hk 11/1/2017 15:23' prior: 0!
I display a GbtCell typed dateModel!

!GbtDateWidget class methodsFor: 'specs' stamp: 'hk 1/20/2016 14:37'!
defaultSpec
	<spec>
	
	^ SpecLayout composed
		add: #widgetValue;
		yourself! !

!GbtDateWidget methodsFor: 'initialization' stamp: 'hk 7/23/2017 14:06'!
entryStringOf: aDateString
	(aDateString beginsWith: 'NaD:') ifTrue: [^aDateString].
	[Date readFrom: aDateString readStream] ifError: [^'NaD: ', aDateString]. 
	^aDateString ! !

!GbtDateWidget methodsFor: 'initialization' stamp: 'hk 10/20/2017 11:53'!
initializePresenter
	"whenDateChanged: is called by the calendar widget"
	widgetValue whenDateChanged: [self write: (self entryStringOf: (self widgetValue getText)) ]
! !

!GbtDateWidget methodsFor: 'initialization' stamp: 'hk 10/20/2017 11:55'!
initializeWidgets
	self instantiateModels: #(widgetValue GbtDateModel ) .	
	self widgetValue 
		autoAccept: false;
		ghostText: slotVO ghostText ;
		acceptBlock: [ :date| self write: (self entryStringOf: date); read];
		text: slotVO val asString.
	self initializeFocusChange.
	super initializeWidgets
! !

!GbtDateWidget methodsFor: 'basic read-write' stamp: 'hk 10/20/2017 11:54'!
read
	self widgetValue getText = slotVO val asString ifTrue: [^self].
 	widgetValue date: slotVO val asString! !

!GbtDateWidget methodsFor: 'accessing' stamp: 'hk 10/20/2017 11:58'!
widgetValue 
	"redefined to answer the real widget (inputField) instead of the GbtDateModel"
	^widgetValue dateModel! !

GbtWidget subclass: #GbtListWidget
	instanceVariableNames: 'editBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing-Leaves'!

!GbtListWidget commentStamp: 'hk 11/1/2017 15:25' prior: 0!
I display a UlistVO 

    Instance Variables
	editBlock:		<Block>
!

!GbtListWidget class methodsFor: 'specs' stamp: 'hk 1/20/2016 14:42'!
defaultSpec
	<spec>
	
	^ SpecLayout composed
		add: #widgetValue;
		yourself! !

!GbtListWidget methodsFor: 'ui actions' stamp: 'hk 10/6/2016 19:05'!
add
	"add a list element"  
	self askForEntry ifNil: [^self].
	widgetValue items: slotVO list.
	self buildWithSpec.
	self changeFlag valueChanged.
! !

!GbtListWidget methodsFor: 'ui actions' stamp: 'hk 9/7/2017 16:19'!
askForEntry 
	"the widget is not initialized yet - 
	add the first list element from the list templates.
	if the container context has a choose context, let the user choose"
	
	| tmplt sel purp elem simpleReturn ctxt dialogWindow ctxtDecl decl res |  
	tmplt := (self chooseTemplate) ifNil: [ ^nil].  
	elem := tmplt copy.
	tmplt purposes ifNotEmpty:  "if the template has purposes, choose or add one"
		[purp := (self choosePurposeFrom: tmplt purposes).
		elem purposes: (purp ifNil: [#()] ifNotNil: [{purp}] )].
	purp := elem purposes.
	simpleReturn := [ ^slotVO newEntry: elem].
	ctxt := slotVO container embeddingContext.
	ctxt ifNil: simpleReturn .
	ctxtDecl := ctxt choiceContextAt: slotLabel label ifAbsent: [simpleReturn value].
	decl := ctxtDecl first.
	ctxt := ctxtDecl second.
	dialogWindow := (GbtListUI on: ctxt) openDialogWithSpec .
	dialogWindow 
		okAction: [(sel := dialogWindow model selection) 
			ifNil: []
			ifNotNil: [elem := sel]];
		cancelAction: [elem := nil];
		title: ctxt displayName  ;
		centeredRelativeTo: self currentWorld ;
		modalRelativeTo: self currentWorld.
	elem ifNil: [^nil].
	res := elem copyWith: decl.
	res purposes: purp.
	^slotVO newEntry: res.! !

!GbtListWidget methodsFor: 'ui actions' stamp: 'hk 1/16/2016 19:56'!
choosePurposeFrom: aList
	"^nil or the chosen purpose"
	
	^UIManager default 
				chooseOrRequestFrom: aList 
				title: 'choose a purpose'.! !

!GbtListWidget methodsFor: 'ui actions' stamp: 'hk 3/27/2017 20:56'!
chooseTemplate
	"^nil or the chosen template"
	
	^GbtWidget chooseTemplateFrom: slotVO templateThings .
! !

!GbtListWidget methodsFor: 'ui actions' stamp: 'hk 2/23/2017 12:32'!
deleteSelection
	"delete the selected list element"  
	self widgetValue selectedItem remove.
	widgetValue items: slotVO list.
	self buildWithSpec.
	self changeFlag valueChanged.! !

!GbtListWidget methodsFor: 'accessing' stamp: 'hk 1/21/2016 12:05'!
editBlock: aBlock  
	editBlock :=  aBlock! !

!GbtListWidget methodsFor: 'ui actions' stamp: 'hk 8/2/2017 17:05'!
editSelection
	"edit a list element"  
	self widgetValue selectedItem ifNotNil:
		[editBlock  value: self widgetValue selectedItem] ! !

!GbtListWidget methodsFor: 'initialization' stamp: 'hk 8/2/2017 17:14'!
initializePresenter
	widgetValue whenListChanged: [self buildWithSpec].
	widgetValue whenSelectedItemChanged: [self editSelection]! !

!GbtListWidget methodsFor: 'initialization' stamp: 'hk 6/30/2016 13:22'!
initializeWidgets
	widgetValue := self newList  .
	widgetValue items: slotVO list.
	widgetValue displayBlock: [:item | item listIndex, ':   ', item summaryEnriched].
	widgetValue menu: [ :m | self listMenu: m ] .
	super initializeWidgets
! !

!GbtListWidget methodsFor: 'ui actions' stamp: 'hk 1/20/2016 13:51'!
inspect
	"inspect a list element"  
	self widgetValue selectedItem inspect! !

!GbtListWidget methodsFor: 'ui actions' stamp: 'hk 8/2/2017 17:09'!
listMenu: m
	(m add: #inspect target: self selector:  #inspect) 
		enablementSelector: [ self widgetValue selectedItem isNotNil ] .
	(m add: #add target: self selector:  #add) .
	(m add: #delete target: self selector:  #deleteSelection) 
		enablementSelector: [ self widgetValue selectedItem isNotNil ] .
	^m! !

!GbtListWidget methodsFor: 'basic read-write' stamp: 'hk 2/23/2017 13:14'!
read
	"do nothing"! !

!GbtListWidget methodsFor: 'accessing' stamp: 'hk 10/3/2016 13:18'!
widgetHeight
	^(((widgetValue listSize max: 3) /2) min: 3) * self singleHeight! !

GbtWidget subclass: #GbtNumberWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing-Leaves'!

!GbtNumberWidget commentStamp: 'hk 11/1/2017 15:25' prior: 0!
I display a Cell typed as number
!

!GbtNumberWidget methodsFor: 'initialization' stamp: 'hk 8/23/2017 18:04'!
entryStringOf: aStringOrNumber
	^aStringOrNumber asString
! !

!GbtNumberWidget methodsFor: 'initialization' stamp: 'hk 10/20/2017 11:45'!
initializeWidgets
	self instantiateModels: #(widgetValue	TextInputFieldModel ) .
	self widgetValue 
		autoAccept: false;
		ghostText: slotVO ghostText ;
		acceptBlock: [ :no| self write: (self entryStringOf: no); read];
		text: slotVO val asString.
	self initializeFocusChange.
	super initializeWidgets
! !

GbtWidget subclass: #GbtStringWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing-Leaves'!

!GbtStringWidget commentStamp: 'hk 11/1/2017 15:26' prior: 0!
I display a Cell typed as Strring



!

!GbtStringWidget class methodsFor: 'specs' stamp: 'hk 7/26/2017 19:30'!
defaultSpec
	<spec>
	
	^SpecLayout composed newRow: [ :r| r
		add: #slotLabel width: self labelWidth;
		add: #widgetValue]! !

!GbtStringWidget methodsFor: 'initialization' stamp: 'hk 11/1/2017 15:21'!
initializeWidgets
	self instantiateModels: #( widgetValue	TextInputFieldModel ) .
	self widgetValue 
		autoAccept: false;
		acceptBlock: [:text|  self write: text].
	self initializeFocusChange.
	self read.
	super initializeWidgets
! !

GbtWidget subclass: #GbtTextWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing-Leaves'!

!GbtTextWidget commentStamp: 'hk 11/1/2017 15:26' prior: 0!
I display a Cell typed as Text (wich cr's)!

!GbtTextWidget class methodsFor: 'specs' stamp: 'hk 2/21/2017 10:47'!
defaultSpec
	<spec>
	^SpecLayout composed newRow: [ :r| r
			add: #slotLabel width: self labelWidth;
			add: #widgetValue] 
					height: (2 * self toolbarHeight)! !

!GbtTextWidget methodsFor: 'initialization' stamp: 'hk 10/20/2017 11:45'!
initializeWidgets
	self instantiateModels: #(widgetValue	TextModel ) .
	self widgetValue acceptBlock: [:item | self write: item] .
	self initializeFocusChange.
	self read .
	super initializeWidgets
! !

!GbtTextWidget methodsFor: 'accessing' stamp: 'hk 1/16/2016 13:40'!
widgetHeight
	^2 * self singleHeight! !

GbtWidget subclass: #GbtVoWidget
	instanceVariableNames: 'editBlock editButton widgetHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing-Leaves'!

!GbtVoWidget commentStamp: 'hk 1/21/2016 14:40' prior: 0!
I display a ThingVO.

In case the thing (slotVO) has  subnodes, a label with the summary is assignet to widgetValue.
Otherwise, a VoBoxWidget is assignet to widgetValue.

Instance Variables
	editBlock:		<Block>
	editButton:		<ButtonModel | LabelModel>
	widgetHeight:	<Number>
!

!GbtVoWidget class methodsFor: 'specs' stamp: 'hk 1/20/2016 17:28'!
defaultSpec
	<spec>
	
	^ (SpecLayout composed newRow: [ :r| r
			add: #slotLabel width: self labelWidth;
			add: #widgetValue;
			add: #editButton width: 20] )! !

!GbtVoWidget methodsFor: 'accessing' stamp: 'hk 1/21/2016 19:57'!
editBlock: aBlock     
	editBlock :=  aBlock! !

!GbtVoWidget methodsFor: 'accessing' stamp: 'hk 1/16/2016 15:36'!
editButton
	^editButton! !

!GbtVoWidget methodsFor: 'initialization' stamp: 'hk 10/6/2016 15:19'!
initializeWidgets
	
	editBlock := [:vo|(GbtThingEditor on: vo) openWithSpec].
	editButton := self newButton .	
	widgetValue := self newLabel 
		label: slotVO summaryEnriched  .	
	widgetHeight := self singleHeight .
	self editButton
		icon: (GbtIcons at: #edit) ;
		action: [ editBlock value: slotVO. 
					self editButton state: true];	"put some emphasis"
		state: false.
	super initializeWidgets
! !

!GbtVoWidget methodsFor: 'basic read-write' stamp: 'hk 2/23/2017 13:15'!
read
	"do nothing"! !

!GbtVoWidget methodsFor: 'ui actions' stamp: 'hk 5/24/2017 13:40'!
resetEditButton   
	self editButton state: false.
	self buildWithSpec! !

!GbtVoWidget methodsFor: 'accessing' stamp: 'hk 1/16/2016 18:19'!
widgetHeight
	^widgetHeight! !

!GbtWidget class methodsFor: 'helpers' stamp: 'hk 1/29/2016 16:46'!
chooseTemplateFrom: templates
	| ind tmpltLines |  
	ind := (templates size =1) 
				ifTrue: [1]
				ifFalse: [tmpltLines := templates collect: [ :e | e summaryEnriched ]. 
							UIManager default chooseFrom: tmpltLines lines: #() message: 'choose a template'].
	ind = 0 ifTrue: [ ^nil].
	^templates at: ind	
! !

!GbtWidget class methodsFor: 'specs' stamp: 'hk 1/20/2016 14:56'!
defaultSpec
	<spec>
	
	^ SpecLayout composed newRow: [ :r |  r
			add: #slotLabel width: self labelWidth;
			add: #widgetValue];
		yourself! !

!GbtWidget class methodsFor: 'specs' stamp: 'hk 1/25/2016 13:05'!
labelWidth
	^100! !

!GbtWidget class methodsFor: 'instance creation' stamp: 'hk 10/11/2016 16:37'!
on: aVO
	^self basicNew slotVO: aVO; label: aVO svoName! !

!GbtWidget class methodsFor: 'instance creation' stamp: 'hk 1/25/2016 12:18'!
on: aVO label: aString
	^self basicNew slotVO: aVO; label: aString; initialize! !

!GbtWidget methodsFor: 'ui actions' stamp: 'hk 12/12/2017 13:56'!
askForValue    
	self write: (self valuesDialog ifNil: [^self]).
	self read.! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 1/19/2016 16:12'!
changeFlag
	^changeFlag! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 10/6/2016 19:04'!
changeFlag: aBoolean
	changeFlag value: aBoolean! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 1/21/2016 12:03'!
editBlock: aBlock! !

!GbtWidget methodsFor: 'focus' stamp: 'hk 10/19/2017 21:35'!
gotFocus
	self readInput! !

!GbtWidget methodsFor: 'initialization' stamp: 'hk 10/20/2017 11:47'!
initializeFocusChange
	self widgetValue on: MorphLostFocus send: #lostFocus to: self.
	self widgetValue on: MorphGotFocus send: #gotFocus to: self
! !

!GbtWidget methodsFor: 'initialization' stamp: 'hk 6/10/2016 21:00'!
initializeWidgets
	self focusOrder add: self widgetValue.
	changeFlag := false asValueHolder.
	self needRebuild: false! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 1/21/2016 13:40'!
label: aString
	slotLabel	 := self newLabel label: aString! !

!GbtWidget methodsFor: 'focus' stamp: 'hk 10/19/2017 21:35'!
lostFocus
	self read! !

!GbtWidget methodsFor: 'basic read-write' stamp: 'hk 10/19/2017 21:24'!
read  
	self widgetValue text = slotVO val asString ifTrue: [^self].
	self widgetValue text: slotVO val asString
	! !

!GbtWidget methodsFor: 'ui actions' stamp: 'hk 7/26/2017 17:53'!
readInput
	self widgetValue text: slotVO inputValue
	! !

!GbtWidget methodsFor: 'ui actions' stamp: 'hk 1/16/2016 15:28'!
resetEditButton! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 1/16/2016 13:33'!
singleHeight
	^self class toolbarHeight! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 1/20/2016 14:27'!
slotLabel
	^slotLabel! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 10/6/2016 18:27'!
slotVO
	^slotVO ! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 18:55'!
slotVO: aLeaf
	slotVO := aLeaf! !

!GbtWidget methodsFor: 'ui actions' stamp: 'hk 7/26/2017 19:35'!
valuesDialog
	| values res |
	slotVO container ifNil: 
		[self inform: 'no container' . ^nil].  
	values := slotVO container valuesOf: self slotLabel label.
	values ifEmpty: [^nil].
	values size =1 ifTrue: [^values at: 1].
	res := UIManager default chooseFrom: values values: values.
	^res! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 1/16/2016 13:34'!
widgetHeight
	^self singleHeight! !

!GbtWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 18:55'!
widgetValue
	^widgetValue
! !

!GbtWidget methodsFor: 'basic read-write' stamp: 'hk 8/18/2017 17:11'!
write: aValue
	"all GUI writes to slotVO must use #write - see evolve"  
	(slotVO inputValue = aValue) ifTrue: [^self].
	self slotVO: (slotVO container evolveLeaf: owner slotName write: aValue).
	self changeFlag: true! !

!GbtWidget methodsFor: 'ui actions' stamp: 'hk 12/12/2017 13:59'!
xresetValue
	self read.! !

!TextInputFieldModel methodsFor: '*GBT-DSL' stamp: 'hk 12/12/2017 13:56'!
ensureKeyBindingsFor: widget

	super ensureKeyBindingsFor: widget.
	self bindKeyCombination: ($i meta) toAction: [self owner ifNotNil: [:o|o  slotVO val inspect]].
	self bindKeyCombination: ($d meta) toAction: [self owner ifNotNil: [:o|o  slotVO debugVal]].
	self bindKeyCombination: ($e meta) toAction: [self owner ifNotNil: [:o|o readInput]].
	self bindKeyCombination: ($a meta) toAction: [self owner ifNotNil: [:o|o askForValue]].
	self bindKeyCombination: Character escape toAction: [self owner ifNotNil: [:o|o read]]! !

!OrderedDictionary methodsFor: '*GBT-DSL' stamp: 'hk 2/14/2017 17:15'!
assocsSelect: aBlock
	"do not copy the associations into a new Array, take the GbtAssociations directly"
	| res |
	res := self species new.
	self associationsDo: [:a| (aBlock value: a) ifTrue: [res add: a] ].
	^res! !

TestCase subclass: #GbtTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTests commentStamp: 'hk 4/3/2015 17:04' prior: 0!
The SpoTests class

for manual experience evaluate ...!

GbtTests subclass: #GbtClearPermanentTraces
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-AppService'!

!GbtClearPermanentTraces methodsFor: 'tests' stamp: 'hk 3/14/2017 10:37'!
testClearBizNet
	GbtBizNetMockUp messageDir ensureDeleteAllChildren.
	GbtBizNetMockUp stopPolling ! !

!GbtClearPermanentTraces methodsFor: 'tests' stamp: 'hk 8/16/2017 17:15'!
testClearStore
	GbtServer clearStore! !

GbtTests subclass: #GbtGUITests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

GbtGUITests subclass: #GbtGUITestDefBehaviors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

!GbtGUITestDefBehaviors methodsFor: 'tests' stamp: 'hk 3/16/2017 13:22'!
testBehaviors
	self exampleContextBehaviors ui buildWithSpec
! !

GbtGUITests subclass: #GbtGUITestDefConstraints
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

!GbtGUITestDefConstraints methodsFor: 'tests' stamp: 'hk 3/16/2017 13:22'!
testBehaviors
	self exampleContextConstraints ui buildWithSpec
! !

!GbtGUITests methodsFor: 'examples' stamp: 'hk 3/22/2017 13:14'!
exampleContextBehaviors

	^GbtPlainAC struct: 'GCEmailContext' define: {
		{#displayAs: . 'Email'  } .
		{#uiSpec:icon: . #GbtItemUI . #email} .
		{#vo: . GbtVOGUITests new dialogThing } .

		{#onReceiveDo: . #(beh1 beh2) }.
		{#menu:items: . #GbtBizNetMockUp . #(beh3 beh4) }.
		{#menu: . #beh1}.

		{#behavior:actions: . #beh1 . #(HALT viod)}.
		{#behavior:actions: . #beh2 . #(HALT viod)}.
		{#behavior:actions: . #beh3 . #(HALT viod)}.	
		{#behavior:actions: . #beh4 . #(HALT viod)}.
	}! !

!GbtGUITests methodsFor: 'examples' stamp: 'hk 3/22/2017 13:14'!
exampleContextConstraints

	^GbtPlainAC struct: 'GCEmailContext' define: {
		{#displayAs: . 'Email'  } .
		{#uiSpec:icon: . #GbtItemUI . #email} .
		{#vo: . GbtVOGUITests new dialogThing } .

		{#constraints: . #(constr1 constr2) } .
		{#constraint:left:right: . #constr1 . #(HALT viod) . #(HALT viod)}.
		{#constraint:left:right: . #constr2 . #(HALT viod) . #(HALT viod)}.
	}
	
! !

GbtTests subclass: #GbtTestActions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestActions methodsFor: 'helpers' stamp: 'hk 3/22/2017 13:14'!
activeContext 
	
	^GbtPlainAC struct: 'ActiveContext' define: { 
		{#vo: . self thing }.
		{ #aspect:on: . self aspectContext . #aspect } .
		{#behavior:actions: . #val2Slot . #(ASSIGNVAL #(zehn neu1)) }.
		{#behavior:actions: . #set2Slot . #(BEHAVIORS #("VO" void neu2)) }.

 	}  ! !

!GbtTestActions methodsFor: 'helpers' stamp: 'hk 3/22/2017 13:14'!
aspectContext 

	^GbtPlainAC struct: 'AspectContext' define: { 
		{#behavior:actions: . #aspectVO . #(ASSUREVO void) }.
		{#behavior:actions: . #aspectVoBeh . #(BEHAVIORS #(aspectVO)) }.
	}
	
! !

!GbtTestActions methodsFor: 'helpers' stamp: 'hk 8/16/2017 17:21'!
aspectVO
	"self new aspectVO edit"
	
	^GbtSmartNode struct: 'AspectVO' define: { 
		{ #val . #val: . '4711' }}.! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/5/2016 19:05'!
testAssignVO
	| aspectContext |
	aspectContext := self activeContext subcontexts first .
	self should: [ aspectContext vo isNil ].
	aspectContext doBehaviors: #(aspectVO).
	self should: [ aspectContext vo isNotNil ]! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/5/2016 19:05'!
testBehaviorCall
	| aspectContext |
	aspectContext := self activeContext subcontexts first .
	aspectContext doBehaviors: #(aspectVoBeh).
	self should: [ aspectContext vo isNotNil ]! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/3/2016 11:29'!
testCompose
	"tbd"! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/3/2016 11:29'!
testEmbed
	"tbd"! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/3/2016 11:28'!
testGetAspect
	"tbd"! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/3/2016 11:28'!
testGetSlot
	"tbd"! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/3/2016 12:19'!
testMatch
	"tbd"! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/3/2016 11:28'!
testSetToList
	"tbd"! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/3/2016 11:29'!
testSetToSlot
	"tbd"! !

!GbtTestActions methodsFor: 'tests' stamp: 'hk 6/5/2016 20:27'!
testSetValToSlot
	self activeContext 
	 	doBehaviors: #(val2Slot).
	self should: [self activeContext vo neu1 = 'zehn' ]! !

!GbtTestActions methodsFor: 'helpers' stamp: 'hk 8/16/2017 17:21'!
thing
	
	^GbtSmartNode struct: 'testActiveVO' define: { 
		{ #aspect . #thing: . self aspectVO }.
		{ #neu1 . #val: . '' }.
		{ #neu2 . #thing: . self aspectVO }.
	}.! !

GbtTests subclass: #GbtTestAppService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-AppService'!

!GbtTestAppService methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testStoreAndReconstruct
	| th th2 |
	th := GbtSmartNode struct: 'superThing' define: { 
		{ #theThing . #thing: . self theThing }}.
	th storeSubtree. 

	th2 := (th bizApp loadList: #superThing) first.
	self should: [ th2 theThing isThing ].	
	self should: [ th2 sub isThing ].	
	self should: [ th2 sub1 = #Blondie ].	
	self should: [ th2 sub2 = #Devote ].	
! !

!GbtTestAppService methodsFor: 'tests' stamp: 'hk 5/13/2017 18:08'!
testStoreAndRetrieveSimple
	| th th2 list |
	th := self theThing storeSubtree. 

	list := th bizApp  loadList: th svoName.
	self should: [ list size = 1 ].
	th2 := list first.
	self should: [ th slots size = th2 slots size ].	
	self should: [ th fullThing = th2 fullThing ].	
! !

!GbtTestAppService methodsFor: 'tests' stamp: 'hk 5/13/2017 18:08'!
testStoreTecNoPolicy
	|  sub id |
	sub := self theSub storeSubtree. 

	sub bizApp tecNoPolicy initialize.
	self should: [sub bizApp tecNoPolicy next = 1 ].
	
	id := (sub bizApp loadList: sub svoName) first id .
	self should: [sub bizApp tecNoPolicy next -1 = id asNumber].
! !

!GbtTestAppService methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testThingStore
	| th |
	th := GbtSmartNode struct: 'superThing' define: { 
		{ #theThing . #thing: . self theThing }}.
	"program store"
	self should: [(th bizApp fullThingNamed: #FsuperThing ) isNotNil].
	self should: [(th bizApp fullThingNamed: #FtestThing ) isNotNil].
	self should: [(th bizApp fullThingNamed: #FtestSub ) isNotNil].
	"program store"
	self should: [(th bizApp thingNamed: #superThing ) isNotNil].
	self should: [(th bizApp thingNamed: #testThing ) isNotNil].
	self should: [(th bizApp thingNamed: #testSub ) isNotNil].
	"thing cache"
	self should: [(th bizApp thingNamed: #superThing ) isNotNil].
	self should: [(th bizApp thingNamed: #testThing ) isNotNil].
	self should: [(th bizApp thingNamed: #testSub ) isNotNil].! !

!GbtTestAppService methodsFor: 'helpers' stamp: 'hk 8/16/2017 17:21'!
theSub 
	^GbtSmartNode struct: 'testSub' define: { 
		{ #sub1 . #val:tag: . 'Blondie' . #foo31 }.
		{ #sub2 . #val:tag: . 'Devote' . #foo32} }! !

!GbtTestAppService methodsFor: 'helpers' stamp: 'hk 8/16/2017 17:21'!
theThing 
	^GbtSmartNode struct: 'testThing' define: { 
		{ #nname . #val:tag: . 'Master' . #foo1 }.
		{ #vname . #val:tag: . 'Max' . #foo2}.
		{ #sub . #thing:tag: . self theSub . #foo3}.
	}	full: { 
		{ #misc . #val: . 'miscelaneous'} }! !

GbtTests subclass: #GbtTestAuthoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testDefineDate
	| bla |
	bla := (GbtSmartNode new)
		define: #jan1st date: '1.1.2015';
		define: #today date: Date today;
		yourself.
	self should: [ bla today = Date today ]! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 8/25/2017 20:52'!
testDefineNo
	| bla |
	bla := GbtSmartNode struct: #bla define: {
		 {#foo2 . #no:tag: . 0 . #abc}.
		 {#foo4 . #no:tag: . -5  . #abc}.
		 {#foo6 . #no:tag: . 'abc' . nil}}.
	self should: [ bla foo2 = 0 ].
	self should: [ bla foo4 = -5 ].
	self should: [ bla foo6 = 'NaN: at 0' ].
! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 8/27/2017 13:46'!
testDefineThing
	| bla bla2 |
	bla := (GbtSmartNode struct: #bla).
	bla2 := GbtSmartNode struct: #bla2 define: { {#slot . #thing: . bla} }.
	self should: [ bla2 slot isNode ].
! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 8/26/2017 12:44'!
testDefineUlist1
	| bla foo1 foo2 |
	foo1 := GbtSmartNode struct: #foo1.
	foo2 := GbtSmartNode struct: #foo2.
	
	bla := GbtSmartNode struct: #bla define: {
		{#ulist . #list:of: . {foo1 . foo2} . #()}} .
	
	self should: [ (bla ulist slotSVOAt: #'1') = foo1 ].
	self should: [ (bla ulist slotSVOAt: #'2') = foo2 ]! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testDefineUlist1e
	self should: [GbtSmartNode new define: #ulist list: {#foo1. #foo2} of: #() display: nil for: nil tag: #() private: nil]
		   raise: Error! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testDefineUlist3
	| bla foo1 |
	foo1 := GbtSmartNode struct: #foo1.
	(bla := GbtSmartNode new) define: #ulist listOf: #foo1.  
	bla ulist newEntry.
	
	self should: [ (bla ulist slotSVOAt: #'1') fullThing longName = foo1 fullThing longName].
! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 8/26/2017 12:46'!
testDefineVal
	| bla |
	bla := GbtSmartNode struct: #bla define: 
		{{#foo . #val: . Date today asString}}.
	self should: [bla foo isString ]! !

!GbtTestAuthoring methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testThingAspectEnrich
	| thing |
	thing := GbtSmartNode struct: 'Thing' define: { 
		{#summary . 'In #city gibt es den #str'} .
		{#street . #val:tag: . 'Hofweg' . #str } .
		{#addressLocation . #val: . #bla} .
		{#city . #val: . 'Hamburg'} 
	} full: {  } .
	
	self should: [thing summaryEnriched = 'In Hamburg gibt es den Hofweg '  ]! !

GbtTests subclass: #GbtTestConstraints
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestConstraints methodsFor: 'helpers' stamp: 'hk 8/16/2017 17:21'!
aThingWithFalseConstraints
	^GbtSmartNode struct: 'F' define: { 
		{ #slotf1 . #val: . 'Krasemann'  }.
		{ #slotf2 . #val: . 'Crasemann' } .
		{ #slotf7 . #constraint: . ' #slotf1 = ''Krase'' ' } .
		{ #slotf8 . #constraint: . ' #slotf1 = #slotf2' } .
	}! !

!GbtTestConstraints methodsFor: 'helpers' stamp: 'hk 8/16/2017 17:21'!
aThingWithTrueConstraints 
	"GbtTestConstraints new aThingWithConstraint"
	
	^GbtSmartNode struct: 'T' define: { 
		{ #slott1 . #val: . 'Krasemann'  }.
		{ #slott2 . #val: . 'Krasemann' } .
		{ #slott7 . #constraint: . ' #slott1 = #slott2' } .
		{ #slott8 . #constraint: . ' ''Krasemann'' = #slott1 ' } .
	}! !

!GbtTestConstraints methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testConstraintErrors
	| bla |  
	bla := GbtSmartNode struct: 'E' define: { 
		{ #slot1 . #val: . 'Krase'  }.
		{ #slot2 . #val: . 'Krase' } .
		{ #slot7 . #constraint: . ' #slot1 = #slot2' } .
		{ #slot8 . #constraint: . ' #slot1 = 7 ' }.
		{ #slot9 . #constraint: . ' #slot1 + 4 = 3' } .
	}.
	self should: [bla slot7 = true ]. 
	self should: [ bla checkConstraints = nil] .
	self should: [ bla slot8  = 'NaStr: 7'].
	self should: [ bla slot9 = 'NaN: Krase'] ! !

!GbtTestConstraints methodsFor: 'tests' stamp: 'hk 8/25/2017 19:13'!
testConstraintsInHierarchy
	| bla |  
	bla := GbtSmartNode struct: 'M' define: { 
		{ #slotX . #thing: . self aThingWithTrueConstraints }.
		{ #slotY . #thing: . self aThingWithFalseConstraints } .
		{ #slotZ . #val: . 'Crasemann' } .
		{ #constraintA . #constraint: . '#slott1 = #slotf1' } .
		{ #constraintB . #constraint: . '#G:slotZ = #G:slotf2' } .
		{ #constraintC . #constraint: . '#G:slott2 = #G:slotf2' }}.
	self should: [bla constraintA = true].
	self should: [bla constraintB = true].
	self should: [bla constraintC = false]! !

!GbtTestConstraints methodsFor: 'tests' stamp: 'hk 8/25/2017 19:13'!
testConstraintsOnThingsWithPaths
	| bla blaS1 blaS2 constr|  
	blaS1 := GbtSmartNode struct: 'S1' define: {	}.
	blaS2 := GbtSmartNode struct: 'S2' define: { }.
	bla := GbtSmartNode struct: 'Bla' define: { 
		{ #slotbla1 . #thing: . blaS1 }.
		{ #slotbla2 . #thing: . blaS2 }.
	} .    
	constr := GbtSmartNode struct: 'C' define: { 
		{ #slot0 . #thing: . bla}.
		{ #slot1 . #constraint: . ' #slot0:slotbla1 = #slotbla2' }.
		{ #slot2 . #constraint: . ' #G:slotbla1 = #G:slotbla2' }.
		{ #slot3 . #constraint: . ' #slot0:slotbla1 = #slotbla1' }.
		{ #slot4 . #constraint: . ' #G:slotbla1 = #slotbla1' }.
	} .   
	self should: [ constr slot1 = false ].	
	self should: [ constr slot2 = false ].	
	self should: [ constr slot3 = true ].	
	self should: [ constr slot4 = true ].	! !

!GbtTestConstraints methodsFor: 'tests' stamp: 'hk 11/16/2017 11:22'!
testFalseConstraints
	| bla |  
	bla := self aThingWithFalseConstraints .
	self should: [ bla slotf7 = false].
	self should: [ bla slotf1 = 'Krasemann'].
	self should: [ bla slotf2 = 'Crasemann'].
	self should: [ (bla slotSVOAt: #slotf8) val = false].
	bla checkConstraints .
	self should: [ bla isConsistent not].
	self should: [ bla violationString  = 'violated: 
 #slotf1 = ''Krase'' 
 #slotf1 = #slotf2']! !

!GbtTestConstraints methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testNumberConstraints
	| bla |  
	bla := GbtSmartNode struct: 'N' define: { 
		{ #slotno7 . #no: . 7  }.
		{ #slotno8 . #val: . '7'  }.
		{ #slotno13 . #no: . 13 } .
		{ #slotf7 . #constraint: . ' #slotno7 = #slotno13' } .
		{ #slott8 . #constraint: . ' #slotno7 > 6 ' }.				"numerically true"
		{ #slott9 . #constraint: . ' #slotno7 > 10 ' }. 			"numerically false"
		{ #slott10 . #constraint: . ' #slotno8 > ''6'' ' }.		"lexically true"
		{ #slott11 . #constraint: . ' #slotno8 > ''10'' ' }. 	"lexically true"
	} .    
	self should: [bla slotf7 not].
	self should: [bla slott8 ].
	self should: [bla slott9 not].
	self should: [bla slott10].
	self should: [bla slott11 ].
	bla checkConstraints .
	self should: [bla isConsistent not]! !

!GbtTestConstraints methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testPredicateSmartPath
		| th |
	th := GbtSmartNode struct: 'Thing' define: { 
		{ #slot . #val: . '4711' }.
		{ #constraint . #constraint: . '#slot = ''4711'' ' }}.
		
	self should: [ th constraint ]! !

!GbtTestConstraints methodsFor: 'tests' stamp: 'hk 8/2/2017 14:01'!
testTrueConstraints
	| bla |  
	bla := self aThingWithTrueConstraints .
	self should: [bla slott7 ].
	self should: [(bla slotSVOAt: #slott8) val ].
	self should: [bla checkConstraints]! !

GbtTests subclass: #GbtTestCopying
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testCopyBasics
	| bla blabla | 
	"erzeuge smart + full thing !!"
	bla := GbtSmartNode struct: #bla define: {{#zip . #val: . #private}}.  
	"kopiere smart thing"  
	blabla := bla copy.
	self shouldnt: [ bla == blabla ].
	self should: [ bla id asNumber + 1 = blabla id asNumber].	
	blabla zip: #new.
	self should: [ blabla zip = #new ].
	self should: [ bla zip = #private ].
! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 8/26/2017 12:48'!
testCopyCalcSlots
	"test the copy semantics on a calc slot"
	| bla bla1 bla2 |  
	bla := GbtSmartNode struct: #bla define: {
		{#calculate . #no: . '( #abc + #foo2 ) * #foo3' }.
		{ #foo2 . #no: . 13 }.
		{ #foo3 . #no: . 5 }.
		{ #abc . #val: . '74' }}. 
	bla1 := bla copy.
	bla2 := bla1 copy.
	bla1 foo2: 6.
	bla1 foo3: 3.
	bla2 foo2: 1.
	bla2 foo3: 1.
	self should: [ bla calculate  = 435].
	self should: [ bla1 calculate  = 240 ].
	self should: [ bla2 calculate  = 75].

! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 11/23/2017 09:12'!
testCopyFreezeHierarchy
	| bla blabla blaSub|
	blaSub := GbtSmartNode struct: #blaSub define: {
		{#slot1 . #val:tag: . '7' . #sum}.
		{#slot2 . #val:tag: . '8' . #sum}.
		{#slot4 . #no: . '#slot1 + #slot2'}.
		{#slot5 . #no: .'sumTag (sum)'}.
		{#slot6 . #no: . 'prodTag (sum)'}.
		{#slot7 . #ref: . 'ref  (#slot1)'}.
	}.
	bla := GbtSmartNode struct: #bla define: {
		{#slot3 . #thing: . blaSub} 
	}.
	blabla := bla copyFreeze.
	self should: [ blabla slot4 = 15 ].
	self should: [ blabla slot5 = 15 ].
	self should: [ blabla slot6 = 56 ].
	self should: [ blabla slot7 = '7' ].
	blabla slot1: #abc.
	blabla slot2: '1'.
	self should: [ blabla slot4 = 15 ].
	self should: [ blabla slot5 = 15 ].
	self should: [ blabla slot6 = 56 ].
	self should: [ blabla slot7 = '7' ]. 

	! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 11/23/2017 09:05'!
testCopyFreezeSlots
	| bla bla2 bla3 |
	bla := GbtSmartNode struct: #bla define: {
		{#slot1 . #val:tag: . '7' . #sum}.
		{#slot2 . #val:tag: . '8' . #sum}.
		{#slot3 . #val: . #slot1}.
		{#slot4 . #no: . '#slot1 + #slot2'}.
		{#slot5 . #no: .'sumTag (sum)'}.
		{#slot6 . #no: . 'prodTag (sum)'}.
		{#slot7 . #ref: . 'ref  (#slot1)'}.
		{#slot8 . #ref: . 'lookup (slot3)'}.
		}.
	bla2 := bla copyFreeze.
	self should: [ bla2 slot1 = '7' ].
	self should: [ bla2 slot2 = '8' ].
	self should: [ bla2 slot3 = 'slot1' ].
	self should: [ bla2 slot4 = 15 ].
	self should: [ bla2 slot5 = 15 ].
	self should: [ bla2 slot6 = 56 ].
	self should: [ bla2 slot7 = '7' ].
	self should: [ bla2 slot8 = '7' ].
	
	bla2 slot1: #abc.
	bla2 removeSmart: #slot1.
	bla2 removeSmart: #slot2.
	self should: [ bla2 slot4 = 15 ].
	self should: [ bla2 slot5 = 15 ].
	self should: [ bla2 slot6 = 56 ].
	self should: [ bla2 slot7 = '7' ]. 
	self should: [ bla2 slot8 = '7' ].

	bla3 := bla2 copy.
	self should: [ bla3 slot4 = 15 ].
	self should: [ bla3 slot5 = 15 ].
	self should: [ bla3 slot6 = 56 ].
	self should: [ bla3 slot7 = '7' ]. 
	self should: [ bla3 slot8 = '7' ].
	! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testCopySlotAssocs
	| foo bar foo2|
	bar := GbtSmartNode struct: 'bar' define: {{#val . #val: . 'bar'}} .
	foo := GbtSmartNode struct: #foo define: {
		{#val . #val: . 'foo'}.
		{#thing . #thing: . bar}.
	 }.
	foo2 := foo copy.
	self should: [ (foo2 slotAt: #val) isKindOf: GbtSlotAssociation ].
	self should: [ (foo2 slotAt: #thing) isKindOf: GbtSlotAssociation ].
	self should: [ ((foo2 slotSVOAt: #thing) slotAt: #val) isKindOf: GbtSlotAssociation ].
! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testCopySlotTag
	| foo bla |
	foo := GbtSmartNode struct: #foo define: {{#zag . #val:tag: . #priv . #blabla}} .
	bla := foo copy.
	self should: [ bla slotValues anyOne hasTag: #blabla ]! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 11/30/2017 17:36'!
testCopySlots
	"test the copy semantics on a sample of slots"
	| foo foo2 |
	foo := GbtSmartNode struct: #foo define: {
		{#zag . #val: . 'private' }.
		{#enum . #val: . #(#a #b)}
		}.
	foo2 := foo copy.	
	self should: [ (foo2 slotAt: #zag) isKindOf: GbtSlotAssociation ].
	self should: [ foo2 zag = foo zag ].
	self shouldnt: [ (foo2 slotSVOAt: #zag) == (foo slotSVOAt: #zag) ].
	self should: [ foo2 enum = foo enum ].
	self shouldnt: [ (foo2 slotSVOAt: #enum) == (foo slotSVOAt: #enum) ].
	
	foo2 zag: #changed.
	foo2 enum: #b.
	self should: [ foo zag = #private ].
	self should: [ foo2 zag = #changed ].
	self should: [ foo enum = #a ].
	self should: [ foo2 enum = #b ]! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 8/26/2017 12:51'!
testCopySlotsInHierarchy
	"test the copy semantics"
	| foo foo2 email |
	email := GbtSmartNode struct: 'GCemail' define: {{#val1 . #val: . 'bla'}} .
	foo := GbtSmartNode struct: #foo define: {
		{#email . #thing: . email}}.
		
	foo2 := foo copy.	"so far no slots have changed but nodes"
	self should: [ (foo2 slotAt: #email) isKindOf: GbtSlotAssociation ].
	self should: [ (foo2 email slotAt: #val1) isKindOf: GbtSlotAssociation ].
	self shouldnt: [ foo2 email == foo email ].
	self should: [ foo2 val1 = foo val1 ].
	self shouldnt: [ (foo2 email slotAt: #val1) == (foo email slotAt: #val1) ].
		
	foo2 val1: #blau.
	self should: [ foo2 val1 = #blau ].
	self should: [ foo val1 = #bla ]! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testCopyText
	| foo foo2 th |
	th := GbtSmartNode struct: 'GCth' define: {{#note . #text: . ''}}.
	(foo := th copy) note: 'bla'.
	(foo2 := foo copy) note: 'blabla'.
	self should: [ th note = '' ].
	self should: [ foo note = 'bla' ].
	self should: [ foo2 note = 'blabla']! !

!GbtTestCopying methodsFor: 'tests' stamp: 'hk 8/19/2017 18:06'!
testEquality
	"= and hash"	
	| th address|
	address := GbtSmartNode struct: 'Address' define: {  
		{ #street . #val:tag: . 'street' . #foo1}}.
	th := address copy.
	self should: [ th street = address street ].
	self shouldnt: [ th id = address id ].
	self should: [ th = address ].! !

GbtTests subclass: #GbtTestCreation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestCreation methodsFor: 'tests' stamp: 'hk 9/24/2017 15:34'!
testDefineDirective
	| bla bla1  |
	bla := GbtDirective struct: 'GCView' define: { 
		{'street' . #tag: . #strasse} .
		{#city}} .
	bla1 := GbtDirective struct: 'GCView'.		"same"
		
	self should: [ bla = bla1  ].
! !

!GbtTestCreation methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testNoDoubleUseOfThings
	| bla  thing |
	bla := GbtSmartNode struct: 'GCAddressLocation' define: { 
		{#street . #val: . 'Astrasse'}
	} full: {  } .
	thing := GbtSmartNode struct: 'GCAddress' define: {  
		{#addressLocation . #thing: . bla} }.
"	self should: [(GbtThing typed: 'GCAddress') define: #addr thing: bla ]
		  raise: Error description: 'cant be double used in GCAddress' "! !

!GbtTestCreation methodsFor: 'tests' stamp: 'hk 8/19/2017 17:40'!
testSlotAssocs
	| foo bar|
	bar := GbtSmartNode struct: #bar define: { 
		{ #s1 . #val: . #bar }}.
	foo := GbtSmartNode struct: #foo define: { 
		{ #s1 . #val: . #bar1 }.
		{ #s2 . #val: . 'bar2' }.
		{ #s3 . #thing: . bar }.
		{ #s4 . #thing: . bar copy }.
	}.	
		
	self should: [ foo leafs size = 2 ]. 	
	"alas - not a GbtSlotAssiciation"
	self should: [ (foo slotSVOAt: #s1) isSmartValue ].
	self should: [ foo subnodes size = 2 ].
	self should: [ foo allLeafSVOs size = 4 ].
! !

!GbtTestCreation methodsFor: 'tests' stamp: 'hk 8/21/2017 17:30'!
testSlotContainers
	| foo |
	foo := GbtSmartNode struct: #foo define: { 
		{ #s1 . #val: . #bar }.
		{ #s2 . #no: . 'sum  #xyz' }.
		{ #s3 . #no: . '6 * 7' }.
		{ #s4 . #enum: . #(aa bb cc) }.
		{ #s5 . #ref: . 'ref  #abc:xyz' }.     
	}.	
		
	self should: [ (foo slotSVOAt: #s1) container = foo ].
	self should: [ (foo slotSVOAt: #s2) container = foo ].
	self should: [ (foo slotSVOAt: #s3) container = foo ].
	self should: [ (foo slotSVOAt: #s4) container = foo ].
	self should: [ (foo slotSVOAt: #s5) container = foo ].
! !

!GbtTestCreation methodsFor: 'tests' stamp: 'hk 8/21/2017 17:21'!
testThingContainers
	"	{Full, original, copies ... }
	bla3 			T2 		T1 		T3 		T7 		T12
		container					|	 	|		|
	bla2 					T5 		T4 		T6 		T11 	
		container							|		|				
	bla1							T9 		T8 		T10
	"
	| bla1 bla2 bla3 bla2c bla3c |
	bla3 := GbtSmartNode struct: #bla3 define: {  "T3"
		{ #xyz . #val: . #b }.
		{ #ref1 . #ref: . 'ref #xyz' }.
		{ #ref2 . #ref: . 'ref #def:xyz' }.
		{ #ref3 . #ref: . 'ref #abc:def:xyz '}.
		{ #ref4 . #ref: . 'ref #abc:xyz' }.      "smartPath may be incomplete"
	}.	
	bla2 := GbtSmartNode struct: #bla2 define: {  "T6"
		{ #def . #thing: . bla3 }. 
		{ #ghi . #val: . #a }	.
	}.	
	bla1 := GbtSmartNode struct: #bla1 define: {  "T10"
		{ #abc . #thing: . bla2 }.
	}. 
	bla2c := bla1 abc. 	"T11"
	bla3c := bla2c def. 	"T12"
		
	self should: [ bla3c container = bla2c ].
	self should: [ bla2c container = bla1 ].
	
	self should: [ bla2 container autoName = #T8v0].
	self should: [ bla3 container autoName = #T4v0].! !

!GbtTestCreation methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testThingNewOfTypeDefine
	| bla bla1 thing |
	bla := GbtSmartNode struct: 'GCAddressLocation' define: { 
		{#street . #val: . 'Astrasse'}
	} full: {  }.
	bla1 := GbtSmartNode struct: 'GCAddressLocation'.	"copy master exists"
	thing := GbtSmartNode struct: 'GCAddress' define: {  
		{#addressLocation . #thing: . bla} .
		{#anotherAddressLocation . #thing: . bla1} . 
		{#cityName . #val: . '<city name>'} 
	} full: {  } .  
	thing anotherAddressLocation street: 'Bstrasse' .	
		
	self shouldnt: [ bla == bla1 ].
	self should: [ bla fullThing = bla1 fullThing ].	
	self should: [thing addressLocation street = 'Astrasse' ].
	self should: [thing anotherAddressLocation street = 'Bstrasse' ] . 
! !

!GbtTestCreation methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testVONamedAccessThings
	| original |
	original := GbtSmartNode struct: #original .
	GbtPlainAC struct: 'PlainContext' define: {{#vo: . original}}.
	self should: [ original longName = 'original:T3v0'] .
	self should: [ original version = 0 ] .
	original storeSubtree .
	original storeSubtree .
	original storeSubtree .
	original storeSubtree .
	self should: [ original longName  = 'original:T3v4' ] .
	self should: [ original version = 4 ] ! !

GbtTests subclass: #GbtTestDirectives
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestDirectives methodsFor: 'authoring access' stamp: 'hk 11/23/2017 10:28'!
address 

	^GbtSmartNode struct: 'Address' define: {  
		{#summary . '#city '} .
		{ #street . #val:tag: . 'street' . #foo1}.
		{ #zip . #val: . '9999'}.
		{ #city . #val:tag: . 'city' . #foo2 }}! !

!GbtTestDirectives methodsFor: 'authoring access' stamp: 'hk 11/23/2017 10:29'!
contact 

	^GbtSmartNode struct: 'Contact' define: { 
		{#summary . '#nname '} .
		{ #nname . #val:tag: . 'Krasemann' . #foo8 }.
		{ #adr . #thing:tag: . self address . #foo7}.
		{ #vname . #val: . 'Hartmut'}}! !

!GbtTestDirectives methodsFor: 'authoring access' stamp: 'hk 9/24/2017 15:31'!
customerDecl
		
	^GbtDirective struct: 'Customer' define: {  
		{ #vorname . #tag: . #vname}.
		{ #nachname . #tag: . #nname}.
		{ #strasse . #tag: . #street}.
		{ #adresse . #tag: . #foo7}}.
! !

!GbtTestDirectives methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testCombinatorHierarchy
	| contact subView addrView thing |
	contact := GbtSmartNode struct: 'Contact' define:  {
		{ #stadt . #val: . 'myCity'}.
		{ #strasse . #val: . 'myStrasse'}.
		{ #firma . #val: . 'myFirma'}} .
	subView := GbtDirective struct: 'SubDecl' define: { 
		{#street . #tag: . #strasse} .
		{#city . #tag: . #stadt}}.
	addrView := GbtDirective struct: 'Decl' define: { 
		{#company . #tag: . #firma }.
		{#sub . #decl: . subView} }.

	thing := addrView transform: contact.

	self should: [ thing company = 'myFirma' ].
	self should: [ thing sub isNode ].
	self should: [ thing city = 'myCity' ].
	self should: [ thing street = 'myStrasse' ]! !

!GbtTestDirectives methodsFor: 'tests' stamp: 'hk 11/23/2017 10:34'!
testCreate
	"create a new structure"
	
	| th |
	th := self customerDecl compose: { self address . self contact }.

	self should: [ th svoName = #Customer ].
	self should: [ th fullThing svoName = 'Customer' ].
	
	self should: [ th vorname = #Hartmut ].
	self should: [ th nachname = #Krasemann ].
	self should: [ th strasse = #street ].
	self shouldnt: [ th adresse id = self address id ].
	self should: [ th adresse = self address ]. 
	self should: [ th summary = 'city , Krasemann ' ].! !

!GbtTestDirectives methodsFor: 'tests' stamp: 'hk 9/24/2017 15:45'!
testCreate2nd
	"copy into existing structure and add new one"
	
	| th1 th2 |
	th1 := GbtSmartNode struct: 'Customer' define: {  
		{ #vorname . #val: . #Karl}.
		{ #zweitname . #val: . #Wilhelm}.
		{ #nachname . #val: . #Heinz}.
		{ #strasse . #val: . #foo}}.
	self customerDecl.	"creates Directive #Customer"
	th2 := (GbtDirective definedAs: #Customer) 
					transform: self contact.
	self should: [ th1 nachname = #Heinz ].
	self should: [ th1 vorname = #Karl ].

	self should: [ th2 nachname = #Krasemann ].
	self should: [ th2 vorname = #Hartmut ].
	self should: [ th2 zweitname = #Wilhelm ].
	self should: [ (th2 slotSVOAt: #strasse) val = #street ].	
	self should: [ th2 slots size = 5 ].
	self should: [ th2 adresse street = #street ]. 		"neu"
	self should: [ th2 adresse slots size = 3 ].
! !

!GbtTestDirectives methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testCreateHierarchy
	"copy a structure into existing things with new structure"
	
	| father subView view thing son |
	father := GbtSmartNode struct: 'Father' define:  {
		{ #company . #val: . 'firma' }.
		{ #chef . #val: . 'person'}} .
	son := GbtSmartNode struct: 'Son' define:  {
		{ #plz . #val: . '1234'}} .
	subView := GbtDirective struct: 'Son' define: { 
		{#street } .
		{#city }}.
	view := GbtDirective struct: 'Father' define: { 
		{#chef . #tag: . #nname }.
		{#adresse . #decl: . subView} }.
		
	thing := view transform: self contact.

	self should: [ thing slots size = 3 ].
	self should: [ thing svoName  = #Father ].
	self should: [ thing company = #firma ].
	self should: [ thing chef = #Krasemann ].
	self should: [ thing adresse slots size = 3 ].
	self should: [ thing street = #street ].
	self should: [ thing city = #city ].
	self should: [ thing plz = '1234' ].
! !

!GbtTestDirectives methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testFilterError
	
	|  filter |
	filter := GbtSmartNode struct: 'Filter' define: {  
		{ #constr3 . #constraint: . '#city = 3/0 '}.
	}.
	self should: [ (self contact testWith: filter) = nil].

! !

!GbtTestDirectives methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testFilterMismatch
	
	|  filter |
	filter := GbtSmartNode struct: 'Filter' define: {  
		{ #constr1 . #constraint: . '#vname = #nname '}.
	}.
	self should: [ (self contact testWith: filter) = false].

! !

!GbtTestDirectives methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testFilterPrimeList
	| filter ctxt constraint1 constraint2 |
	ctxt := GbtPrimeListAC 	struct: 'Rolodex' define:
			{{#templates:. (self contact)}}.
	ctxt newEntry: (self contact vname: #a; nname: #A; yourself).
	ctxt newEntry: (self contact vname: #b; nname: #A; yourself).
	ctxt newEntry: (self contact vname: #a; nname: #B; yourself).
	ctxt newEntry: (self contact vname: #b; nname: #B; yourself).
	
	filter := GbtDirective struct: 'Filter' define: {{#nname}}.
	constraint1 := GbtSmartNode struct: 'Constraint1' define:
		{{#constr1. #constraint:. '#vname = ''a'' '}.
		{#constr2. #constraint:. '#nname = ''A'' '}}.
	constraint2 := GbtSmartNode struct: 'Constraint2' define:
		{{#constr1. #constraint:. '#nname = ''B'' '}}.
		
	self should: [ (filter transform: (constraint1 filter: ctxt list)) size = 1 ].
	self should: [ (filter transform: (constraint2 filter: ctxt list)) size = 2 ].
	self should: [ (filter transform: (constraint2 filter: ctxt list)) first slots size = 1 ]! !

!GbtTestDirectives methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testFilterRepeated
	
	| contact filter |
	filter := GbtSmartNode struct: 'Filter' define: {  
		{ #constr1 . #constraint: . '#vname = ''Hartmut'' '}.
		{ #constr2 . #constraint: . '#nname = ''Krasemann'' '}.
		{ #constr3 . #constraint: . '#city = #vname '}.
	}.
	contact := self contact.
	self should: [ (contact testWith: filter) = false].
	contact city: #Hartmut.
	self should: [ (contact testWith: filter) = true].

! !

!GbtTestDirectives methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testFilterSimple
	
	| filter |
	filter := GbtSmartNode struct: 'Filter' define: {  
		{ #constr1 . #constraint: . '#vname = ''Hartmut'' '}.
		{ #constr2 . #constraint: . '#nname = ''Krasemann'' '}.
	}.
	self should: [ (self contact testWith: filter) = true]
! !

!GbtTestDirectives methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testFullThingCreation
	| contact subView addrView thing |
	contact := GbtSmartNode struct: 'Contact' define:  {
		{ #stadt . #val:tag: . 'myCity' . #tag1 }.
		{ #strasse . #val: . 'myStrasse'}.
		{ #firma . #val: . 'myFirma'}} .
	subView := GbtDirective struct: 'SubDecl' define: { 
		{#street . #tag: . #strasse} .
		{#city . #tag: . #stadt}}.
	addrView := GbtDirective struct: 'Decl' define: { 
		{#company . #tag: . #firma }.
		{#sub . #decl: . subView} }.
		
	thing := addrView transform: contact.

	self should: [ thing svoName  = #Decl ].

	self should: [ thing slots size = 2 ].
	self should: [ thing sub slots size = 2 ].

	self should: [ thing fullThing svoName  = #Decl ].
	self should: [ thing fullThing slots size = 2 ]! !

!GbtTestDirectives methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testListTransformation
	"feld1 	feld2 					  			  num1 	  num2
		4 			6 			--SubDecl->			6 			4
	 	2 			3 									3 			2"
					
	| listElem subDecl decl thing listCont |
	listElem := GbtSmartNode struct: 'ListElem' define:  {
		{ #feld1 . #no: . 0 }.
		{ #feld2 . #no: . 0  }.
	} .
	listCont := GbtSmartNode struct: 'ListCont' define:  {
		{ #list . #listOf: . listElem}.
	} .
	listCont list newEntry: (listElem copy feld1: 4; feld2: 6; yourself).
	listCont list newEntry: (listElem copy feld1: 2; feld2: 3; yourself).

	subDecl := GbtDirective struct: #SubDecl define: {
		{ #num1 . #tag: . #feld2}.
		{ #num2 . #tag: . #feld1}}.
	decl := GbtDirective struct: #anonymous define: {
		{ #liste . #list: . {#list . subDecl}}}.
 
	thing := decl transform: listCont.  
 
	self should: [ (thing liste slotSVOAt: #'1') num1 = 6 ].
	self should: [ (thing liste slotSVOAt: #'2') num2 = 2]! !

GbtTests subclass: #GbtTestDirectivesAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestDirectivesAccess methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testDefaultMultiTargetAccess
	| contact address newView |
	address := (GbtSmartNode struct: 'GCAddress')
		define: #street val: 'street';
		define: #zip val: '9999';
		define: #city val: 'city'.
	contact := (GbtSmartNode struct: 'GCContact')
		define: #nname val: 'Krase';
		define: #adr thing: address;
		define: #vname val: 'Hartmut'.
	newView := GbtDirective struct: #Decl define: {
		{ #stadt . #tag: . #city}. 
		{ #nachname . #tag: . #nname}}.
	newView
		sources: {contact . address}.
	self should: [ newView nachname = 'Krase' ].	"do the references work?"
	self should: [ newView stadt = 'city' ].	"do the references work?"
	newView stadt: 'Hamburg'.	"original slots changed"
	newView nachname: 'Bonn'.	"to prove the copy"
	self should: [ newView stadt = 'Hamburg' ].	"copied slots are not changed"
	self should: [ newView nachname = 'Bonn' ]! !

!GbtTestDirectivesAccess methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testDefaultTagsSimple
	| tmp1 tmp2 tmp3 tmp4 |
	tmp1 := GbtSmartNode
		struct: 'GCAddress'
		define:
			{{#street . #val: . 'street'}.
			{#zip . #val: . '9999'}.
			{#city . #val: . 'city'}}.
	tmp3 := GbtDirective
		struct: 'AdrComb'
		define:
			{{#Postleitzahl . #tag: . #zip}.
			{#Straße . #tag: . #street}.
			{#Stadt . #tag: . #city}}.
	tmp2 := tmp3 transform: tmp1.
	tmp4 := self.
	tmp4
		should: [ (tmp2 slotSVOAt: #Postleitzahl) val = '9999' ];
		should: [ (tmp2 slotSVOAt: #Stadt) val = 'city' ];
		should: [ (tmp2 slotSVOAt: #Straße) val = 'street' ]! !

!GbtTestDirectivesAccess methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testDefaultTagsVOstructure
	| tmp1 tmp2 tmp3 tmp4 tmp5 |
	tmp2 := GbtSmartNode
		struct: 'GCAddress'
		define:
			{{#street . #val: . 'street'}.
			{#zip . #val: . '9999'}.
			{#city . #val: . 'city'}}.
	tmp1 := GbtSmartNode
		struct: 'GCContact'
		define:
			{{#nname . #val: . 'Krase'}.
			{#adr.
			#thing:.
			tmp2}.
			{#vname . #val: . 'Hartmut'}}.
	tmp4 := GbtDirective
		struct: 'AdrComb'
		define:
			{{#vorname . #tag: . #vname}.
			{#nachname . #tag: . #nname}.
			{#Straße . #tag: . #street}.
			{#Stadt . #tag: . #city}}.
	tmp3 := tmp4 transform: tmp1.
	tmp5 := self.
	tmp5
		should: [ (tmp3 slotSVOAt: #vorname) val = 'Hartmut' ];
		should: [ (tmp3 slotSVOAt: #nachname) val = 'Krase' ];
		should: [ (tmp3 slotSVOAt: #Stadt) val = 'city' ];
		should: [ (tmp3 slotSVOAt: #Straße) val = 'street' ]! !

!GbtTestDirectivesAccess methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testMultiTargetAccess
	| contact address newView |
	address := (GbtSmartNode struct: 'GCAddress')
		define: #street val: 'street' tag: #foo1;
		define: #zip val: '9999' tag: #foo2;
		define: #city val: 'city' tag: #foo3.
	contact := (GbtSmartNode struct: 'GCContact')
		define: #nname val: 'Krase' tag: #foo9;
		define: #adr thing: address tag: #foo7;
		define: #vname val: 'Hartmut' tag: #foo8.
	newView := GbtDirective struct: #Decl define: {
		{ #stadt . #tag: . #foo3}. 
		{ #nachname . #tag: . #foo9}}.
	newView sources: {contact . address}.
	self should: [ newView nachname = 'Krase' ].	"do the references work?"
	self should: [ newView stadt = 'city' ].	"do the references work?"  
	newView stadt: 'Hamburg'.	"original slots changed"
	newView nachname: 'Bonn'.	"to prove the copy"
	self should: [ newView stadt = 'Hamburg' ].	"copied slots are not changed"
	self should: [ newView nachname = 'Bonn' ]! !

!GbtTestDirectivesAccess methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testTagsBasic
	| bla  |
	bla := GbtDirective struct: 'GCView' define: { 
		{'street' . #tag: . #strasse} .
		{#city}} .
	self should: [ (bla slotAt: #city) value = #city ].
	self should: [ (bla slotAt: #street) value = #strasse ]! !

!GbtTestDirectivesAccess methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testTagsSimple
	| tmp1 tmp2 tmp3 tmp4 |
	tmp1 := GbtSmartNode
		struct: 'GCAddress'
		define:
			{{#street . #val:tag: . 'street' . #foo1}.
			{#zip . #val:tag: . '9999' . #foo2}.
			{#city . #val:tag: . 'city' . #foo3}}.
	tmp3 := GbtDirective
		struct: 'AdrComb'
		define:
			{{#Postleitzahl . #tag: . #foo2}.
			{#Straße . #tag: . #foo1}.
			{#Stadt . #tag: . #foo3}}.
	tmp2 := tmp3 transform: tmp1.
	tmp4 := self.
	tmp4
		should: [ (tmp2 slotSVOAt: #Postleitzahl) val = '9999' ];
		should: [ (tmp2 slotSVOAt: #Stadt) val = 'city' ];
		should: [ (tmp2 slotSVOAt: #Straße) val = 'street' ]! !

!GbtTestDirectivesAccess methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testTagsVOnodes
	| contact address myAddr adrComb |
	address := GbtSmartNode struct: 'GCAddress' define: {
		{ #street . #val: . 'street'}.
		{ #zip . #val: . '9999'}.
		{ #city . #val: . 'city'}}.
	contact := GbtSmartNode struct: 'GCContact' define: {
		{ #nname . #val:tag: . 'Krase' . #foo9} .
		{ #adr . #thing:tag: . address . #foo7 }.
		{ #vname . #val:tag: . 'Hartmut' . #foo8 }}.
	adrComb := GbtDirective struct: 'AdrComb' define: {
		{ #vorname . #tag: . #foo8 }.
		{ #nachname . #tag: . #foo9 }.
		{ #adresse . #tag: . #foo7 }}.
	myAddr := adrComb transform: contact.
	self should: [ (myAddr slotSVOAt: #vorname) val = 'Hartmut' ].
	self should: [ (myAddr slotSVOAt: #nachname) val = 'Krase' ].
	self should: [ ((myAddr slotSVOAt: #adresse) slotSVOAt: #city) val = 'city' ].
	self should: [ ((myAddr slotSVOAt: #adresse) slotSVOAt: #street) val = 'street' ] ! !

!GbtTestDirectivesAccess methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testTagsVOstructure
	| tmp1 tmp2 tmp3 tmp4 tmp5 |
	tmp2 := GbtSmartNode
		struct: 'GCAddress'
		define:
			{{#street . #val:tag: . 'street' . #foo1}.
			{#zip . #val: . '9999'}.
			{#city . #val:tag: . 'city' . #foo3}}.
	tmp1 := GbtSmartNode
		struct: 'GCContact'
		define:
			{{#nname . #val:tag: . 'Krase' . #foo9}.
			{#adr.
			#thing:.
			tmp2}.
			{#vname . #val:tag: . 'Hartmut' . #foo8}}.
	tmp4 := GbtDirective
		struct: 'AdrComb'
		define:
			{{#vorname . #tag: . #foo8}.
			{#nachname . #tag: . #foo9}.
			{#Straße . #tag: . #foo1}.
			{#Stadt . #tag: . #foo3}}.
	tmp3 := tmp4 transform: tmp1.
	tmp5 := self.
	tmp5
		should: [ (tmp3 slotSVOAt: #vorname) val = 'Hartmut' ];
		should: [ (tmp3 slotSVOAt: #nachname) val = 'Krase' ];
		should: [ (tmp3 slotSVOAt: #Stadt) val = 'city' ];
		should: [ (tmp3 slotSVOAt: #Straße) val = 'street' ]! !

!GbtTestDirectivesAccess methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testTagsVOstructureError
	| tmp1 tmp2 tmp3 tmp4 tmp5 |
	tmp2 := GbtSmartNode
		struct: 'GCAddress'
		define:
			{{#street . #val:tag: . 'street' . #foo1}.
			{#zip . #val: . '9999'}.
			{#city . #val:tag: . 'city' . #foo3}}.
	tmp1 := GbtSmartNode
		struct: 'GCContact'
		define:
			{{#nname . #val:tag: . 'Krase' . #foo9}.
			{#adr.
			#thing:.
			tmp2}.
			{#vname . #val:tag: . 'Hartmut' . #foo8}}.
	tmp4 := GbtDirective
		struct: 'AdrComb'
		define:
			{{#vorname . #tag: . #foo8}.
			{#nachname . #tag: . #foo9}.
			{#Straße . #tag: . #foo1}.
			{#Stadt . #tag: . #foo3}}.
	tmp3 := tmp4 transform: tmp2.
	tmp5 := self.
	tmp5
		should: [ (tmp3 slotSVOAt: #vorname) = nil ];
		should: [ (tmp3 slotSVOAt: #nachname) = nil ];
		should: [ (tmp3 slotSVOAt: #Stadt) val = 'city' ];
		should: [ (tmp3 slotSVOAt: #Straße) val = 'street' ]! !

!GbtTestDirectivesAccess methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testTagsVOstructureNodes
	| contact address myAddr adrComb |
	address := GbtSmartNode struct: 'GCAddress' define: {
		{ #street . #val: . 'street'}.
		{ #zip . #val: . '9999'}.
		{ #city . #val: . 'city'}}.
	contact := GbtSmartNode struct: 'GCContact' define: {
		{ #nname . #val:tag: . 'Krase' . #foo9} .
		{ #adr . #thing:tag: . address . #foo7 }.
		{ #vname . #val:tag: . 'Hartmut' . #foo8 }}.
	adrComb := GbtDirective struct: 'AdrComb' define: {
		{ #vorname . #tag: . #foo8 }.
		{ #nachname . #tag: . #foo9 }.
		{ #adresse . #tag: . #foo7 }}.
	myAddr := adrComb transform: contact.

	self should: [ (myAddr slotSVOAt: #vorname) val = 'Hartmut' ].
	self should: [ (myAddr slotSVOAt: #nachname) val = 'Krase' ].
	self should: [ ((myAddr slotSVOAt: #adresse) slotSVOAt: #city) val = 'city' ].
	self should: [ ((myAddr slotSVOAt: #adresse) slotSVOAt: #street) val = 'street' ]! !

!GbtTestDirectivesAccess methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testTagsWithPathAccessGet
	| contact address myAddr adrComb |
	address := GbtSmartNode struct: 'GCAddress' define: {
		{ #street . #val: . 'street'}.
		{ #zip . #val: . '9999'}.
		{ #city . #val: . 'city'}}.
	contact := GbtSmartNode struct: 'GCContact' define: {
		{ #nname . #val:tag: . 'Krase' . #foo9} .
		{ #adr . #thing:tag: . address . #foo7 }.
		{ #vname . #val:tag: . 'Hartmut' . #foo8 }}.
	adrComb := GbtDirective struct: 'AdrComb' define: {
		{ #vorname . #tag: . #foo8 }.
		{ #nname . #tag: . #foo9 }.
		{ #adresse . #tag: . #foo7 }}.
	myAddr := adrComb transform: contact.

	self should: [ myAddr vorname = 'Hartmut' ].
	self should: [ myAddr nname = 'Krase' ].
	self should: [ myAddr adresse city = 'city' ].
	self should: [ myAddr adresse street = 'street' ]! !

!GbtTestDirectivesAccess methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testTagsWithPathAccessSet
	| contact address myAddr adrComb |
	address := GbtSmartNode struct: 'GCAddress' define: {
		{ #street . #val: . 'street'}.
		{ #zip . #val: . '9999'}.
		{ #city . #val: . 'city'}}.
	contact := GbtSmartNode struct: 'GCContact' define: {
		{ #nname . #val:tag: . 'Krase' . #foo9} .
		{ #adr . #thing:tag: . address . #foo7 }.
		{ #vname . #val:tag: . 'Hartmut' . #foo8 }}.
	adrComb := GbtDirective struct: 'AdrComb' define: {
		{ #vorname . #tag: . #foo8 }.
		{ #nachname . #tag: . #foo9 }.
		{ #adresse . #tag: . #foo7 }}.
	myAddr := adrComb transform: contact.
	myAddr vorname: 'Karl'.
	myAddr nachname: 'Weller'.
	myAddr city: 'Hamburg'.
	myAddr street: 'ABCstrasse'.
	self should: [ myAddr vorname = 'Karl' ].
	self should: [ myAddr nachname = 'Weller' ].
	self should: [ myAddr adresse city = 'Hamburg' ].
	self should: [ myAddr adresse street = 'ABCstrasse' ]! !

!GbtTestDirectivesAccess methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testUlistAccess
	| bla foo1 foo2 view |
	foo1 := GbtSmartNode struct: #foo1.	
	foo2 := foo1 copy.
	bla := (GbtSmartNode struct: #bla)
		define: #ulist
			list: {foo1 . foo2}
			of: { }
			display: nil
			for: #()
			tag: #bla1
			private: nil;
		yourself .
	(view := GbtDirective struct: #Decl) 
		sources: bla; 
		define: #theList tag: #bla1 .
	
	self should: [((view slotSVOAt: #theList) slotSVOAt: #'1') = foo1 ].! !

GbtTests subclass: #GbtTestDirectivesEmbed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestDirectivesEmbed methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testEmbedDeepNode
	| target source newData combinator thing oldData newSub oldSub |
	newSub := GbtSmartNode struct: 'NewSub' define: {
		{ #no . #val: . '42'} }.
	oldSub := GbtSmartNode struct: 'OldSub' define: {
		{ #no . #val: . ''} }.	
	newData := GbtSmartNode struct: 'NewData' define: {
		{ #street . #val: . 'street'}.
		{ #city . #val: . 'city'} .
		{ #sub . #thing: . newSub} .
		}.
	oldData := GbtSmartNode struct: 'OldData' define: {
		{ #street . #val: . ''}.
		{ #city . #val: . ''}.
		{ #sub . #thing: . oldSub} .
		}.
	source := GbtSmartNode struct: 'Source' define: {
		{ #globalSlot . #thing:  . newData} }.
	target := GbtSmartNode struct: 'Target' define: {
		{ #localSlot . #thing: . oldData } }.
	combinator := GbtDirective struct: #Decl define: {{#globalSlot . #tag: . #localSlot}}.
	
	thing := target copy embed: source with: combinator.

	self should: [ target city = '' ].
	self should: [ target street = '' ].
	self should: [ target no = '' ].
	
	self should: [ thing city = 'city' ].
	self should: [ thing street = 'street' ].
	self should: [ thing no = '42' ].
! !

!GbtTestDirectivesEmbed methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testEmbedDeepNodeExpand
	| target source newData combinator thing oldData newSub oldSub |
	newSub := GbtSmartNode struct: 'NewSub' define: {
		{ #no . #val: . '42'} }.
	oldSub := GbtSmartNode struct: 'OldSub' define: {
		{ #no . #val: . ''} }.	
	newData := GbtSmartNode struct: 'NewData' define: {
		{ #street . #val: . 'street'}.
		{ #city . #val: . 'city'} .
		{ #sub . #thing: . newSub} }.
	oldData := GbtSmartNode struct: 'OldData' define: {} full: { 
			{ #city . #val: . ''}.
			{ #street . #val: . ''}.
			{ #sub . #thing: . oldSub}}.
	source := GbtSmartNode struct: 'Source' define: {
		{ #globalSlot . #thing:  . newData} }.
	target := GbtSmartNode struct: 'Target' define: {
		{ #localSlot . #thing: . oldData } }.
	combinator := GbtDirective struct: #Decl define: {{#globalSlot . #tag: . #localSlot}}.
	
	thing := target copy embed: source with: combinator.

	self should: [ target city = '' ].
	self should: [ target street = '' ].
	self should: [ target no = '' ].
	
	self should: [ thing city = 'city' ].
	self should: [ thing street = 'street' ].
	self should: [ thing no = '42' ].
! !

!GbtTestDirectivesEmbed methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testEmbedIncompleteSlots
	| target source combinator thing |
	source := GbtSmartNode struct: 'Source' define: {
		{ #city . #val: . 'city'} }.
	target := GbtSmartNode struct: 'Target' define: {
		{ #stadt . #val: . ''}.
		{ #strasse . #val: . ''} } .
	combinator := GbtDirective struct: #Decl define: {
		{ #street . #tag: .#strasse}.
		{ #city . #tag: . #stadt}}.
		
	thing := target embed: source with: combinator.
	
	self should: [ thing stadt = 'city' ] .
	self should: [ thing strasse = '' ].
! !

!GbtTestDirectivesEmbed methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testEmbedNodeWithDelete
	| target source newData combinator thing oldData |
	newData := GbtSmartNode struct: 'NewData' define: {
		{ #city . #val: . 'city'} }.
	oldData := GbtSmartNode struct: 'OldData' define: {
		{ #street . #val: . ''}.
		{ #city . #val: . ''} }.
	source := GbtSmartNode struct: 'Source' define: {
		{ #globalSlot . #thing:  . newData} }.
	target := GbtSmartNode struct: 'Target' define: {
		{ #localSlot . #thing: . oldData } }.
	combinator := GbtDirective struct: #Decl define: {{#globalSlot . #tag: . #localSlot}}.
	
	thing := target copy embed: source with: combinator.

	self should: [ target city = '' ].
	self should: [ target street = '' ].
	
	self should: [ thing city = 'city' ].
	self should: [ (thing slotSVOAt: #street) = nil] .

! !

!GbtTestDirectivesEmbed methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testEmbedNodeWithPrivate
	| target source newData combinator thing oldData subData subsubData |
	newData := GbtSmartNode struct: 'NewData' define: {
		{ #city . #val: . 'city'} }.
	subsubData := GbtSmartNode struct: 'SubSubData' define: {
		{ #blabla . #val: . 'blabla' }}.
	subData := GbtSmartNode struct: 'SubData' define: {
		{ #bla . #val:private: . 'bla' . true}.
		{ #bla2 . #val: . 'bla2' }.
		{#subsub . #thing:private: . subsubData . true }}.
	oldData := GbtSmartNode struct: 'OldData' define: {
		{ #street . #val:private: . 'local' . true}.
		{ #city . #val: . '' }.
		{ #sub . #thing: . subData } }.
	source := GbtSmartNode struct: 'Source' define: {
		{ #globalSlot . #thing:  . newData} }.
	target := GbtSmartNode struct: 'Target' define: {
		{ #localSlot . #thing: . oldData } }.
	combinator := GbtDirective struct: #Decl define: {{#globalSlot . #tag: . #localSlot}}.
	
	thing := target copy embed: source with: combinator.

	self should: [ target city = '' ].
	self should: [ target street = 'local' ].
	
	self should: [ thing city = 'city' ].
	self should: [ thing street = 'local' ] .
	self should: [ thing bla = 'bla' ] .
	self should: [ (thing sub slotSVOAt: #bla2) = nil] .
	self should: [ thing blabla = 'blabla' ] ! !

!GbtTestDirectivesEmbed methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testEmbedSimpleNode
	| target source newData combinator thing oldData |
	newData := GbtSmartNode struct: 'NewData' define: {
		{ #street . #val: . 'street'}.
		{ #city . #val: . 'city'} }.
	oldData := GbtSmartNode struct: 'OldData' define: {
		{ #street . #val: . ''}.
		{ #city . #val: . ''} }.
	source := GbtSmartNode struct: 'Source' define: {
		{ #globalSlot . #thing:  . newData} }.
	target := GbtSmartNode struct: 'Target' define: {
		{ #localSlot . #thing: . oldData } }.
	combinator := GbtDirective struct: #Decl define: {{#globalSlot . #tag: . #localSlot}}.
	
	thing := target copy embed: source with: combinator.

	self should: [ target city = '' ].
	self should: [ target street = '' ].
	
	self should: [ thing city = 'city' ].
	self should: [ thing street = 'street' ].
! !

!GbtTestDirectivesEmbed methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testEmbedSimpleSlots
	| target source combinator thing |
	source := GbtSmartNode struct: 'Source' define: {
		{ #street . #val: . 'street'}.
		{ #city . #val: . 'city'} }.
	target := GbtSmartNode struct: 'Target' define: {
		{ #stadt . #val: . ''}.
		{ #strasse . #val: . ''} } .
	combinator := GbtDirective struct: #Decl define: {
		{ #street . #tag: .#strasse}.
		{ #city . #tag: . #stadt}}.
		
	thing := target embed: source with: combinator.
	
	self should: [ thing stadt = 'city' ].
	self should: [ thing strasse = 'street' ].
! !

!GbtTestDirectivesEmbed methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testEmbedSmartNode
	| target source newData combinator thing oldData |
	newData := GbtSmartNode struct: 'NewData' define: {
		{ #street . #val: . 'street'}.
		{ #city . #val: . 'city'} }.
	oldData := GbtSmartNode struct: 'OldData' define: {
		{ #street . #val: . ''}.
		{ #city . #val: . ''} }.
	source := GbtSmartNode struct: 'Source' define: { } 
	full: { { #globalSlot . #thing:  . newData} }.
	target := GbtSmartNode struct: 'Target' define: {
		{ #localSlot . #thing: . oldData } }.
	combinator := GbtDirective struct: #Decl define: {{#globalSlot . #tag: . #localSlot}}.
	
	thing := target copy embed: source with: combinator.

	self should: [ target city = '' ].
	self should: [ target street = '' ].
	
	self should: [ thing city = 'city' ].
	self should: [ thing street = 'street' ].
! !

!GbtTestDirectivesEmbed methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testEmbedWithCombinatorHierarchy
	| target source2 source1 subComb comb thing dummy |
	dummy := GbtSmartNode struct: 'dummy'.
	source1 := GbtSmartNode struct: 'Source1' define: {
		{ #street . #val: . 'street'} .
		{ #city . #val: . 'city'}}.
	source2 := GbtSmartNode struct: 'Source2' define: {
		{ #company . #val: . 'myCompany'} .
		{ #addr . #thing: . source1}}.
	target := GbtSmartNode struct: 'Target' define:  {
		{ #stadt . #val: . ''}.
		{ #strasse . #val: . ''}.
		{ #firma . #val: . ''}} .
	subComb := GbtDirective struct: #SubDecl define: {
		{ #street . #tag: .#strasse}.
		{ #city . #tag: . #stadt}}.
	comb := GbtDirective struct: 'Decl' define: { 
		{#company . #tag: . #firma }.
		{#addr . #decl: . subComb} }.
		
	thing := target embed: source2 with: comb.

	self should: [ thing stadt = 'city' ].
	self should: [ thing firma = 'myCompany' ].
	self should: [ thing strasse = 'street' ]! !

!GbtTestDirectivesEmbed methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testEmbedWithTargetHierarchy
	| target subtarget source  comb thing  |
	source := GbtSmartNode struct: 'Source' define: {
		{ #company . #val: . 'myCompany'} .
		{ #street . #val: . 'street'} .
		{ #city . #val: . 'city'}}.
	subtarget := GbtSmartNode struct: 'Subtarget' define:  {
		{ #strasse . #val: . ''}.
		{ #firma . #val: . ''}} .
	target := GbtSmartNode struct: 'Target' define:  {
		{ #stadt . #val: . ''}.
		{ #sub . #thing: . subtarget}} .
	comb := GbtDirective struct: #Decl define: {
		{ #company . #tag: .#firma}.
		{ #street . #tag: .#strasse}.
		{ #city . #tag: . #stadt}}.
		
	thing := target embed: source with: comb.

	self should: [ thing stadt = 'city' ].
	self should: [ thing firma = 'myCompany' ].
	self should: [ thing strasse = 'street' ]! !

GbtTests subclass: #GbtTestEvolve
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testAddAndRemove
	|  thing th1 th3 |
	th1 := GbtSmartNode struct: 'GCTh1' define: {} .	
	th3 := GbtSmartNode struct: 'GCTh3' define: {} .	
	thing := GbtSmartNode struct: 'GCThing' define: { } full: {		
		{#slot1 . #thing: . th1 }.
		{#slot2 . #val: . #original}.
		{#slot3 . #thing: . th3}} .	
			
	thing slot1.	
	thing slot2.	
	thing removeSlotAt: #slot1.
	thing slot3.
	thing removeSlotAt: #slot2.
	
	self should: [thing slots size = 1].
	self should: [thing slot3 svoName = 'GCTh3' ].

	self should: [thing previous slots size = 2].
	self should: [thing previous slot2 = #original ].
	self should: [thing previous slot3 svoName = 'GCTh3' ].

	self should: [thing previous previous slots size = 1].
	self should: [thing previous previous slot2 = #original ].

	self should: [thing previous previous previous slots size = 2].
	self should: [thing previous previous previous slot1 svoName = 'GCTh1' ].
	self should: [thing previous previous previous slot2 = #original ].

	self should: [thing previous previous previous previous slots size = 1].
	self should: [thing previous previous previous previous previous slots size = 0].
! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testAddNodesAndValues
	|  thing th1 th3 |
	th1 := GbtSmartNode struct: 'GCTh1' define: {} .	
	th3 := GbtSmartNode struct: 'GCTh3' define: {} .	
	thing := GbtSmartNode struct: 'GCThing' define: { } full: {		
		{#slot1 . #thing: . th1 }.
		{#slot2 . #val: . #original}.
		{#slot3 . #thing: . th3}} .	
			
	thing slot1.	
	thing slot2.	
	thing slot3.
	thing removeSlot: thing slot1.
	
	self should: [thing slots size = 2].
	self should: [thing slot2 = #original ].
	self should: [thing slot3 svoName = 'GCTh3' ].

	self should: [thing previous slots size = 3].
	self should: [thing previous slot1 svoName = 'GCTh1' ].
	self should: [thing previous slot2 = #original ].
	self should: [thing previous slot3 svoName = 'GCTh3' ].

	self should: [thing previous previous slots size = 2].
	self should: [thing previous previous previous slots size = 1].
	self should: [thing previous previous previous previous slots size = 0].
! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 8/26/2017 13:50'!
testEvolveCalcSlots
	"test the evolve semantics on a calc slot"
	| bla |  
	bla := (GbtSmartNode struct: #bla)
		define: #calculate no: '( #abc + #foo2 ) * #foo3' ;
		define: #foo2 no: 5 ;
		define: #foo3 no: 2 ;
		define: #abc val: '5' ;
		fullVO: #self.
	self should: [ bla calculate  = 20 ].

	bla evolveLeaf: #foo2 write: 1.
	self should: [ bla calculate  = 12 ].

	bla evolveLeaf: #foo2 write: 0.
	bla evolveLeaf: #foo3 write: 1.
	self should: [ bla calculate  = 5 ].! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 1/21/2018 11:51'!
testNestedLists
	|  thing th1 th2 |
	th1 := GbtSmartNode struct: 'GCTh1' define: {
		{#summary . '#longName count: #evolveCount'}}
		full: { 
		{#wert . #val: . '0' } }.
	th2 := GbtSmartNode struct: 'GCTh2' define: {
		{#summary . '#longName count: #evolveCount'}.
		{#listb1 . #listOf: . th1 }.
		{#listb2 . #listOf: . th1 }} .	
	thing := GbtSmartNode struct: 'GCThing' define: {  
		{#summary . '#longName count: #evolveCount ' }.
		{#lista1 . #listOf: . th2 }.
		{#lista2 . #listOf: . th2 }} .	
	self should: [thing lista2 list isEmpty].
	thing lista1 newEntry  .
	thing lista2 newEntry listb2 newEntry wert: #abc.
	self should: [(thing lista2 slotValueAt: #'1') listb1 list isEmpty].
	self should: [(thing lista2 slotValueAt: #'1') listb2 list size = 1]
! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testNextVersion
	|  thing th1 |
	th1 := GbtSmartNode struct: 'GCTh1' define: {
		{#slotv1 . #val:. #original }} .	
	thing := GbtSmartNode struct: 'GCThing' define: {  
		{#slott . #thing: . th1 }} .	
	thing slotv1: #changed.
	self should: [thing slott previous svoName = (thing slott svoName)].
	self should: [(thing slott slotAt: #slotv1) value  val = #changed ].
	thing storeSubtree.
	self should: [thing slott previous isNil]! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testPreviousMultiNodes
	|  thing th1 th2 th3 |
	th1 := GbtSmartNode struct: 'GCTh1' define: {} .	
	th2 := GbtSmartNode struct: 'GCTh2' define: {} .	
	th3 := GbtSmartNode struct: 'GCTh3' define: {} .	
	thing := GbtSmartNode struct: 'GCThing' define: {  
		{#slot1 . #thing: . th1 }.
		{#slot2 . #thing: . th1 copy}} .	
	thing slot1: th2.	
	thing slot2: th3.
	self should: [thing slot1 svoName = 'GCTh2' ].
	self should: [thing slot2 svoName = 'GCTh3' ].
	self should: [thing previous slot1 svoName = 'GCTh2' ].
	self should: [thing previous slot2 svoName = 'GCTh1' ].
	self should: [thing previous previous slot1 svoName = 'GCTh1' ].
	self should: [thing previous previous slot2 svoName = 'GCTh1' ].
! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testPreviousMultiValues
	|  thing |
	thing := GbtSmartNode struct: 'GCThing' define: {  
		{#slot1 . #val:. #original }.
		{#slot2 . #val:. #original }} .	
	thing slot1: #change1. 
	thing slot2: #change2.
	self should: [thing slot1 = #change1 ].
	self should: [thing slot2 = #change2 ].
	self should: [thing previous slot1 = #change1 ].
	self should: [thing previous  slot2 = #original ].
	self should: [thing previous previous slot1 = #original ].
	self should: [thing previous previous slot2 = #original ].

! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testPreviousMultiValues2
	|  thing |
	thing := GbtSmartNode struct: 'GCThing' define: {  
		{#slot1 . #no:. 0 }.
		{#slot2 . #val:. #original }} .	
	thing slot1: 1. 
	thing slot2: #change2.
	thing slot2: #change3.
	thing slot1: 4. 
	self should: [thing slot1 = 4 ].
	self should: [thing slot2 = #change3 ].
	self should: [thing previous slot1 = 1 ].
	self should: [thing previous  slot2 = #change3 ].
	self should: [thing previous previous slot1 = 1 ].
	self should: [thing previous previous slot2 = #change2 ].
	self should: [thing previous previous previous previous slot1 = 0 ].
	self should: [thing previous previous previous previous slot2 = #original ].

! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testPreviousNodes
	|  thing th1 th2 th3 |
	th1 := GbtSmartNode struct: 'GCTh1' define: {} .	
	th2 := GbtSmartNode struct: 'GCTh2' define: {} .	
	th3 := GbtSmartNode struct: 'GCTh3' define: {} .	
	thing := GbtSmartNode struct: 'GCThing' define: {  
		{#slotv . #val:. #original }.
		{#slott . #thing: . th1 }} .	
	self should: [thing slott svoName = 'GCTh1' ].
	thing slott: th2.
	thing slott: th3.
	self should: [thing slott svoName = 'GCTh3' ].
	self should: [thing previous slott svoName = 'GCTh2' ].
	self should: [thing previous previous slott svoName = 'GCTh1' ].
! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testPreviousValues
	|  thing |
	thing := GbtSmartNode struct: 'GCThing' define: {  
		{#slotv . #val:. #original }} .	
	self should: [thing slotv = #original ].
	thing slotv: #change1.
	thing slotv: #change2.
	self should: [thing slotv = #change2 ].
	self should: [thing previous slotv = #change1 ].
	self should: [thing previous previous slotv = #original ].

! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testPreviousValuesAndNodes
	|  thing th1 th2 th3 |
	th1 := GbtSmartNode struct: 'GCTh1' define: {} .	
	th2 := GbtSmartNode struct: 'GCTh2' define: {} .	
	th3 := GbtSmartNode struct: 'GCTh3' define: {} .	
	thing := GbtSmartNode struct: 'GCThing' define: {  
		{#slot1 . #val:. #original }.
		{#slot2 . #thing: . th1 }.
		{#slot3 . #val:. #original } .	
		{#slot4 . #thing: . th1 copy}} .	
	thing slot1: #change1. 
	thing slot2: th2.	
	thing slot3: #change2.
	thing slot4: th3.

	self should: [thing slot1 = #change1 ].
	self should: [thing slot2 svoName = 'GCTh2' ].
	self should: [thing slot3 = #change2 ].
	self should: [thing slot4 svoName = 'GCTh3' ].

	self should: [thing previous slot1  = #change1 ].
	self should: [thing previous slot2 svoName = 'GCTh2' ].
	self should: [thing previous slot3  = #change2 ].
	self should: [thing previous slot4 svoName = 'GCTh1' ].

	self should: [thing previous previous slot1  = #change1 ].
	self should: [thing previous previous slot2 svoName = 'GCTh2' ].
	self should: [thing previous previous slot3  = #original ].
	self should: [thing previous previous slot4 svoName = 'GCTh1' ].

	self should: [thing previous previous previous  slot1  = #change1 ].
	self should: [thing previous previous previous  slot2 svoName = 'GCTh1' ].
	self should: [thing previous previous previous  slot3  = #original ].
	self should: [thing previous previous previous  slot4 svoName = 'GCTh1' ].

	self should: [thing previous previous previous previous slot1  = #original ].
	self should: [thing previous previous previous previous slot2 svoName = 'GCTh1' ].
	self should: [thing previous previous previous previous slot3  = #original ].
	self should: [thing previous previous previous previous slot4 svoName = 'GCTh1' ].
! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testRemove
	|  thing |
	thing := GbtSmartNode struct: 'GCThing' define: {  
		{#slotv . #val:. #original }} .	
	thing removeSlotAt: #slotv.
	self should: [(thing slotAt: #slotv) isNil].
	self should: [thing previous slotv = #original ].
	self should: [(thing previous slotSVOAt: #slotv) container == thing previous ].

! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testRemoveNodesAndValues
	|  thing th1 th2 th3 |
	th1 := GbtSmartNode struct: 'GCTh1' define: {} .	
	th2 := GbtSmartNode struct: 'GCTh2' define: {} .	
	th3 := GbtSmartNode struct: 'GCTh3' define: {} .	
	thing := GbtSmartNode struct: 'GCThing' define: {  
		{#slot0 . #val: . #original}.
		{#slot1 . #thing: . th1 }.
		{#slot2 . #thing: . th1 copy}} .	
	thing slot1: th2.	
	thing slot2: th3.
	thing removeSlot: th3.
	thing slot0: #change.
	thing removeSlot: th2.
	
	self should: [thing slots size = 1].
	self should: [thing slot0 = #change ].

	self should: [thing previous slots size = 2].
	self should: [thing previous slot0 = #change ].
	self should: [thing previous slot1 svoName = 'GCTh2' ].

	self should: [thing previous previous slots size = 2].
	self should: [thing previous previous slot0 = #original ].
	self should: [thing previous previous slot1 svoName = 'GCTh2' ].

	self should: [thing previous previous previous slots size = 3].
	self should: [thing previous previous previous slot0 = #original ].
	self should: [thing previous previous previous slot1 svoName = 'GCTh2' ].
	self should: [thing previous previous previous slot2 svoName = 'GCTh3' ].

	self should: [thing previous previous previous previous previous slots size = 3].
	self should: [thing previous previous previous previous previous slot0 = #original ].
	self should: [thing previous previous previous previous previous slot1 svoName = 'GCTh1' ].
	self should: [thing previous previous previous previous previous slot2 svoName = 'GCTh1' ].
! !

!GbtTestEvolve methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testUnchangedSlots
	|  thing th1 th2 |
	th1 := GbtSmartNode struct: 'GCTh1' define: {} .	
	th2 := GbtSmartNode struct: 'GCTh2' define: {} .	
	thing := GbtSmartNode struct: 'GCThing' define: {  
		{#slotv1 . #val:. #original }.
		{#slotv2 . #val:. #original }.
		{#slott . #thing: . th1 }} .	
	self should: [thing slott svoName = 'GCTh1' ].
	thing slott: th2.
	thing slotv1: #changed.
	self should: [thing slotv2  = 'original' ].
! !

GbtTests subclass: #GbtTestHooks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestHooks methodsFor: 'as yet unclassified' stamp: 'hk 6/7/2017 10:49'!
listContext 
	
	^GbtPrimeListAC struct: 'ListContext' define: { 
		{#templates: . self thing }.
		{#subcontext: . self plainContext }.
		{#uiSpec:icon: . #GbtListAndItemUI . #edit }.
		{#onRemoveDo: . #(remove) } .
		{#behavior:actions: . #remove . #(ASSIGNVAL #(BAR s2) ) }}  ! !

!GbtTestHooks methodsFor: 'as yet unclassified' stamp: 'hk 3/22/2017 13:15'!
plainContext 
	
	^GbtPlainAC struct: 'PlainContext' define: { 
		{#vo: . self thing }.
		{#uiSpec:icon: . #GbtItemUI . #edit }.
		{#onEditDo: . #(save) } .
		{#onSaveDo: . #(save) } .
		{#behavior:actions: . #save . #(ASSIGNVAL #(BAR s2) ) } }  ! !

!GbtTestHooks methodsFor: 'as yet unclassified' stamp: 'hk 9/23/2016 12:07'!
testCreate
	"todo after refaktoring insideTransport and the hook"
! !

!GbtTestHooks methodsFor: 'as yet unclassified' stamp: 'hk 7/14/2017 20:42'!
testEdit
	| context thing appUI |
	context := self listContext.
	appUI := context ui.
	thing := context newEntry.
	self should: [ thing previous s2 = 'foo' ].
	self should: [ thing s2 = 'BAR' ]
! !

!GbtTestHooks methodsFor: 'as yet unclassified' stamp: 'hk 11/30/2016 12:03'!
testRemove
	| context one two |
	context := self listContext.
	one := context newEntry.
	two := context newEntry.
	self should: [ two s2 = 'foo' ].
	context deleteListElement: two .
	self should: [ two s2 = 'BAR' ]
! !

!GbtTestHooks methodsFor: 'as yet unclassified' stamp: 'hk 9/6/2017 17:49'!
testSave
	| context |
	context := self plainContext.
	self should: [ context vo s2 = 'foo' ].  
	context vo beTransient; save.
	self should: [ context vo s2 = 'BAR' ]
! !

!GbtTestHooks methodsFor: 'as yet unclassified' stamp: 'hk 9/20/2017 11:56'!
thing
	^GbtSmartNode struct: 'test2ActiveVO' define: { 
		{ #s1 . #val: . 'bar' }.
		{ #s2 . #val: . 'foo' } }! !

GbtTests subclass: #GbtTestNodeTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestNodeTree methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testHierarchySlotAccessTagged
	| bla  thing |
	bla := GbtSmartNode struct: 'GCAddressLocation' define: { 
		{#street . #val:tag: . 'Astrasse' . #tagAstrasse }
	} full: {  } .
	thing := GbtSmartNode struct: 'GCAddress' define: {  
		{#addressLocation . #thing: . bla} .
		{#cityName . #val: . '<city name>'} 
	} full: {  } .
	self should: [thing  tagAstrasse = 'Astrasse' ].

	thing tagAstrasse: 'Bstrasse' .		
	self should: [thing  tagAstrasse = 'Bstrasse' ] ! !

!GbtTestNodeTree methodsFor: 'tests' stamp: 'hk 8/27/2017 13:50'!
testHierarchyThingAccess
	| tmp1 tmp2 tmp3 |
	tmp3 := GbtSmartNode struct: 'GCALocation2' define: {
		{#str . #val: . 'Bstrasse'}}.
	tmp1 := GbtSmartNode struct: 'GCALocation' define: {
		{#test. #thing: . tmp3}	
		} full: {
		{#street . #val: . 'Astrasse'}}.
	tmp2 := GbtSmartNode struct: 'GCAddress' define: {
			{#addressLocation. #thing:. tmp1}.
			{#cityName . #val: . '<city name>'}}.
	self should: [ tmp2 street = 'Astrasse'].
	tmp2 test str: #Cstraße.
	self should: [ tmp2 str = 'Cstraße' ].
	tmp2 str: #Dstraße.
	self should: [ tmp2 test str = 'Dstraße' ]! !

!GbtTestNodeTree methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testHierarchyValueAccess
	| bla  thing |
	bla := GbtSmartNode struct: 'GCAddressLocation' define: { 
		{#street . #val: . 'Astrasse'}
	} full: {  } .
	thing := GbtSmartNode struct: 'GCAddress' define: {  
		{#addressLocation . #thing: . bla} .
		{#cityName . #val: . '<city name>'} 
	} full: {  } .
	self should: [thing  street = 'Astrasse' ].

	thing street: 'Bstrasse' .		
	self should: [thing  street = 'Bstrasse' ] .
	self should: [thing city ] raise: Error.
! !

GbtTests subclass: #GbtTestNumberSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestNumberSlot methodsFor: 'tests' stamp: 'hk 8/23/2017 16:37'!
testNumber0
	|thing|
	thing := GbtSmartNode struct: #thing define: {
			{#slot1 . #val: . '3' }.
			{#slot2 . #no: . 7 }.
			{#slot3 . #no: . '#slot1 + #slot2 ' }.
			{#slot4 . #no: . '7 - 3' }}.

	self should: [thing slot3 = 10].
	self should: [thing slot4 = 4].


! !

!GbtTestNumberSlot methodsFor: 'tests' stamp: 'hk 8/23/2017 16:37'!
testNumber1
	|thing|
	thing := GbtSmartNode struct: #thing define: {
			{#slot1 . #val: . '3' }.
			{#slot2 . #no: . 7 }.
			{#slot3 . #no: . ' #slot1 + #slot2 + 10' }.
			{#slot4 . #no: . '#slot1 * #slot2 - 1' }}.

	self should: [thing slot3 = 20].
	self should: [thing slot4 = 20].


! !

!GbtTestNumberSlot methodsFor: 'tests' stamp: 'hk 11/6/2017 18:33'!
testNumber2
	|thing|
	thing := GbtSmartNode struct: #thing define: {
			{#slot1 . #val: . '3' }.
			{#slot2 . #no: . 7 }.
			{#slot3 . #no: . ' sum ( #slot1 ; #slot2 ; -5)' }.
			{#slot4 . #no: . ' average ( #slot1 ; 5 ; #slot2 )' }}.

	self should: [thing slot3 = 5].
	self should: [thing slot4 = 5].


! !

!GbtTestNumberSlot methodsFor: 'tests' stamp: 'hk 8/26/2017 13:49'!
testNumber3
	| bla |  
	bla := (GbtSmartNode struct: #bla)
		define: #calculate no: '( #abc + #foo2 ) * #foo3' ;
		define: #foo2 no: 13 ;
		define: #foo3 no: 5 ;
		define: #abc val: '74' ;
		fullVO: #self.
	self should: [ bla calculate  = 435].
! !

!GbtTestNumberSlot methodsFor: 'tests' stamp: 'hk 1/3/2018 10:41'!
testNumberE1
	| t1 |
	t1 := (GbtSmartNode struct: #bla)
		define: #calculate no: '( #abc + #foo4 ) * #foo3';
		define: #foo2 no: 13;
		define: #foo3 no: 5;
		define: #abc val: '74';
		fullVO: #self.
	self should: [ t1 calculate = 'NaRef: foo4' ] ! !

!GbtTestNumberSlot methodsFor: 'tests' stamp: 'hk 1/3/2018 10:42'!
testNumberE2
	|thing|
	thing := GbtSmartNode struct: #thing define: {
			{#slot1 . #val: . '3' }.
			{#slot2 . #no: . 7 }.
			{#slot3 . #no: . ' #slot1 + #slota + 10' }}.

	self should: [thing slot3 = 'NaRef: slota'] 


! !

!GbtTestNumberSlot methodsFor: 'tests' stamp: 'hk 8/23/2017 16:39'!
testNumberProd
	|thing|
	thing := GbtSmartNode struct: #thing define: {
			{#slot0 . #val:tag: . 'abc' . #tag}.
			{#slot1 . #val:tag: . '2' . #tag}.
			{#slot2 . #no:tag: . 3 . #tag}.
			{#slot3 . #no: . 'prodTag (tag)' }.
			{#tag . #no: . 4 }.
			}.

	self should: [thing slot3 = 24]! !

!GbtTestNumberSlot methodsFor: 'tests' stamp: 'hk 8/23/2017 16:39'!
testNumberSum
	|thing|
	thing := GbtSmartNode struct: #thing define: {
			{#slot0 . #val:tag: . 'abc' . #tag}.
			{#slot1 . #val:tag: . '3' . #tag}.
			{#slot2 . #no:tag: . 7 . #tag}.
			{#slot3 . #no: . 'sumTag (tag)' }.
			{#tag . #no: . 7 }.
			}.

	self should: [thing slot3 = 17]! !

!GbtTestNumberSlot methodsFor: 'tests' stamp: 'hk 8/21/2017 17:31'!
testOnNodeTree
	| bla bla1 |
	bla1 := GbtSmartNode struct: #bla1 define: {
		{#foo2 . #no:tag: . 13 . #abc}.
		{#foo3 . #no:tag: . 5 . #abc} }.
	bla := GbtSmartNode struct: #bla define: {
		{ #sum . #no: . 'sumTag (abc)' } .
		{#bla1 . #thing: . bla1} }.
	self should: [ bla sum = (13+5)  ]! !

!GbtTestNumberSlot methodsFor: 'tests' stamp: 'hk 8/21/2017 17:30'!
testSumOnNodeTree
	| bla bla1 |
	bla1 := GbtSmartNode struct: #bla1 define: {
		 {#foo2 . #no:tag: . 13 . #abc}.
		 {#foo3 . #no:tag: . 5 . #abc }}.
	bla := GbtSmartNode struct: #bla define: {
		 {#sum . #no: . 'sumTag (abc)' }.
		 {#bla1 . #thing: . bla1 }}.
	self should: [ bla sum = (13+5)  ]! !

!GbtTestNumberSlot methodsFor: 'tests' stamp: 'hk 8/21/2017 17:22'!
testSumOnNodeTreeWithUlist
	| bla templ |
	templ := GbtSmartNode struct: #templ define: {
		{#foo . #no: . 13} }.
	bla := GbtSmartNode struct: #bla define: {
		{#sum . #no: . 'sumTag (foo)' }.
		{#list1 . #listOf: . #templ} }.
	self should: [ bla sum = 0 ].  
	bla list1 newEntry .  
	self should: [ bla sum = 13].
	bla list1 newEntry .
	self should: [ bla sum = (2 * 13) ]! !

!GbtTestNumberSlot methodsFor: 'tests' stamp: 'hk 8/26/2017 13:50'!
testSumWithRecursion
	| bla |
	bla := (GbtSmartNode struct: #bla)
		define: #sum no: 'sumTag (abc)' tag: #def;
		define: #sum2 no: 'sumTag (def)' ;
		define: #foo2 no: 13 tag: #abc;
		define: #foo3 no: 5 tag: #abc;
		define: #def val: '74' ;
		fullVO: #self.
	self should: [ bla sum = (13+5)  ].
	self should: [ bla sum2 = (13+5+74)  ].
! !

GbtTests subclass: #GbtTestPathExpressions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:21'!
testSameNode

	| bla |
	bla := GbtSmartNode struct: #bla define: {  
		{ #summary . ' #abc #def '}.
		{ #abc . #val: . #a }.
		{ #def . #val: . #b }. 
	}.
	self should: [ bla summaryEnriched = 'a b ' ].
! !

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:21'!
testSameNodeTagged
	"find slots by tag"
	| bla |
	bla := GbtSmartNode struct: #bla define: {  
		{ #summary . ' #abc #def'}.
		{ #slot1 . #val:tag: . #a . #abc}.
		{ #slot2 . #val:tag: . #b . #def}. 
	}.
	self should: [ bla summaryEnriched = 'a b ' ].
! !

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:21'!
testSubNode

	| bla1 bla2 bla3|
	bla2 := GbtSmartNode struct: #bla2 define: {  
		{ #summary . '#ghi'}.
		{ #ghi . #val: . #a }	.
	}.
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #summary . '#xyz'}.
		{ #xyz . #val: . #b }.
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #summary . ' #abc & #def '}.
		{ #abc . #thing: . bla2 }.
		{ #def . #thing: . bla3 }. 
	}.
	self should: [bla1 summaryEnriched = 'a  & b  '].
! !

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:21'!
testSubNodeChain

	| bla1 bla2 bla3|
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
	}.
	bla2 := GbtSmartNode struct: #bla2 define: {  
		{ #def . #thing: . bla3 }. 
		{ #ghi . #val: . #a }	.
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #summary . ' #ghi & #xyz '}.
		{ #abc . #thing: . bla2 }.
	}.
	self should: [bla1 summaryEnriched = 'a & b ' ].
! !

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:21'!
testSubNodeList

	| bla1 bla2 bla3|
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
	}.
	bla2 := GbtSmartNode struct: #bla2 define: {  
		{ #def . #thing: . bla3 }. 
		{ #ghi . #val: . #a }	.
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #summary . ' #ghi & #xyz '}.
		{ #abc . #listOf: . bla2 }.
	}.
	bla1 abc newEntry: bla2 copy.
	
	self should: [bla1 summaryEnriched = 'a & b ' ].
! !

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:21'!
testSubNodePath

	| bla1 bla2 bla3|
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
	}.
	bla2 := GbtSmartNode struct: #bla2 define: {  
		{ #def . #thing: . bla3 }. 
		{ #ghi . #val: . #a }	.
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #summary . ' #abc:def:xyz #abc:ghi'}.
		{ #abc . #thing: . bla2 }.
	}.
	self should: [bla1 summaryEnriched = 'b a ' ].
! !

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:21'!
testSubNodeWithCycle

	| bla1 bla2 bla3|
	bla2 := GbtSmartNode struct: #bla2 define: {  
		{ #summary . ' #abc '}.
		{ #abc . #val: . #a }	.
	}.
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #summary . ' #abc '}.
		{ #abc . #val: . #b }.
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #summary . ' #abc & #def '}.
		{ #abc . #thing: . bla2 }.
		{ #def . #thing: . bla3 }. 
	}.
	self should: [bla1 summaryEnriched = 'a  & b  '].
! !

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 8/21/2017 17:20'!
testUpOneNode

	| bla1  bla3 header |
	header := GbtSmartNode struct: #header define: {  
		{ #ref . #ref: . 'ref (#def:ghi)'}.
	}.
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #ghi . #val: . #a }	.
		{ #xyz . #val: . #b }.
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #abc . #thing: . header }.
		{ #def . #thing: . bla3 }. 
	}.
	self should: [header ref  = 'a'].
! !

!GbtTestPathExpressions methodsFor: 'as yet unclassified' stamp: 'hk 8/21/2017 17:20'!
testUpOneNodeWithThingRef

	| bla1  bla3 header |
	header := GbtSmartNode struct: #header define: {  
		{ #ref . #ref: . 'ref (#def)' }.
	}.
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #summary . ' #ghi & #xyz '}.
		{ #ghi . #val: . #a }	.
		{ #xyz . #val: . #b }.
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #abc . #thing: . header }.
		{ #def . #thing: . bla3 }. 
	}.  
	self should: [bla1  ref = bla1 def  ]! !

GbtTests subclass: #GbtTestProgramVOCopying
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestProgramVOCopying methodsFor: 'tests' stamp: 'hk 9/25/2017 16:24'!
testMultiTargetCombinatorCopy
	| contact address newView copyView |
	address := (GbtSmartNode struct: 'GCAddress')
		define: #street val: 'street' tag: #foo1;
		define: #zip val: '9999' tag: #foo2;
		define: #city val: 'city' tag: #foo3.
	contact := (GbtSmartNode struct: 'GCContact')
		define: #nname val: 'Krase' tag: #foo9;
		define: #adr thing: address tag: #foo7;
		define: #vname val: 'Hartmut' tag: #foo8.
	newView := GbtDirective struct: #Decl define: {
		{#strasse . #tag: . #foo1}.
		{#myName . #tag: . #foo8}.
		{#stadt . #tag: . #foo3}.
		{#nachname . #tag: . #foo9 }}.
	copyView := newView compose: {contact . address}.
	self should: [ copyView isKindOf: GbtSmartNode ].
	self should: [ copyView nachname = 'Krase' ].	"do the references work?"
	address define: #city val: 'Hamburg'.	"original slots changed"
	contact define: #nname val: 'Hamburg'.	"to prove the copy"
	self should: [ copyView stadt = 'city' ].	"copied slots are not changed"
	self should: [ copyView nachname = 'Krase' ]! !

!GbtTestProgramVOCopying methodsFor: 'tests' stamp: 'hk 9/24/2017 15:31'!
testSimpleViewCopy
	| tmp1 tmp2 tmp3 tmp4 tmp5 tmp7 |
	tmp7 := GbtSmartNode struct: 'GCAddress'.
	tmp7 define: #street val: 'street' tag: #foo1.
	tmp4 := tmp7 define: #zip val: '9999' tag: #foo2.
	tmp1 := tmp4 define: #city val: 'city' tag: #foo3.
	tmp5 := (GbtDirective struct: 'MyAddr') define: #Stadt tag: #foo3.
	tmp2 := tmp5 define: #Straße tag: #foo1.
	tmp3 := tmp2 transform: tmp1.
	self
		should: [ tmp3 isKindOf: GbtSmartNode ];
		should: [ (tmp3 slotSVOAt: #Stadt) isSmartValue ];
		should: [ tmp3 svoName = 'MyAddr' ];
		should: [ (tmp3 slotSVOAt: #Straße) val = 'street' ].
	tmp1 define: #city val: 'Hamburg'.
	self should: [ (tmp3 slotSVOAt: #Stadt) val = 'city' ]! !

GbtTests subclass: #GbtTestRefSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestRefSlot methodsFor: 'tests' stamp: 'hk 8/23/2017 16:31'!
testLinkAccess
	| root level21 level22 |
	level21 := GbtSmartNode struct: 'Level21' define: {{#str . #val: . 'Bstrasse'}}.
	level22 := GbtSmartNode struct: 'Level22' define: {{#link . #ref: . '#bla21'}}.
	root := GbtSmartNode struct: 'root' define:
			{{#bla21. #thing:. level21}.
			{#bla22. #thing:. level22}}.
	self	should: [ root str = 'Bstrasse' ].
	self	should: [ root link str = 'Bstrasse' ].
	root str: #Cstraße.
	self	should: [ root str = 'Cstraße' ].
	self	should: [ root link str = 'Cstraße' ]! !

!GbtTestRefSlot methodsFor: 'tests' stamp: 'hk 8/23/2017 16:31'!
testLinkAccessCopy
	|root level21 level22 level31 level32 root2 |
	level31 := GbtSmartNode struct: 'Level31' define: {{#str . #val: . 'Bstrasse'}} .    
	level32 := GbtSmartNode struct: 'Level32' define: {{#str . #val: . 'Cstrasse'}} .    

	level21 := GbtSmartNode struct: 'Level21' define: {{#node . #thing: . level31}} .
	level22 := GbtSmartNode struct: 'Level22' define: {{#link . #ref: . '#bla21'}}.

	root := GbtSmartNode struct: 'root' define: { 
		{#bla21 . #thing: . level21 }.		"bla21 - level21 - node - level31 - str"
		{#bla22 . #thing: . level22 }.		"bla22 - level22 - link - node"
	} .

	self should: [root node str = 'Bstrasse' ].
	self should: [root link str = 'Bstrasse' ].

	root2 := root copy.
	root2 node: level32 .		
	self should: [root2 node str = 'Cstrasse' ] .
	self should: [root2 link str = 'Cstrasse' ] .
! !

!GbtTestRefSlot methodsFor: 'tests' stamp: 'hk 8/23/2017 16:31'!
testLinkAccessFull
	| root level21 level22 |
	level21 := GbtSmartNode struct: 'Level21' define: {}
		full: {{#str . #val: . 'Bstrasse'}}.
	level22 := GbtSmartNode struct: 'Level22' define: {}
		full: {{#link . #ref: . '#bla21'}}.
	root := GbtSmartNode struct: 'root' define:
			{{#bla21. #thing:. level21}.
			{#bla22. #thing:. level22}}.
	self should: [ root str = 'Bstrasse' ].
	self should: [ root link str = 'Bstrasse' ].
	root str: #Cstraße.
	self should: [ root str = 'Cstraße' ].
	self should: [ root link str = 'Cstraße' ]! !

!GbtTestRefSlot methodsFor: 'tests' stamp: 'hk 8/23/2017 16:31'!
testLinkAccessList
	|root  level22 bElement cElement|
	bElement := GbtSmartNode struct: 'Level31' define: {{#str . #val: . 'Bstrasse'}} .    
	cElement := GbtSmartNode struct: 'Level32' define: {{#str . #val: . 'Cstrasse'}} .    

	level22 := GbtSmartNode struct: 'Level22' define: {{#link . #ref: . '#bla21:2' }}.

	root := GbtSmartNode struct: 'root' define: { 
		{#bla21 . #listOf: . bElement }.		"bla21 - level21 - node - level31 - str"
		{#bla22 . #thing: . level22 }.			"bla22 - level22 - link - node"
	} .
	root bla21 newEntry: bElement.
	root bla21 newEntry: cElement.
	
	self should: [(root bla21 perform: #'1') str = 'Bstrasse' ].
	self should: [(root bla21 perform: #'2') str = 'Cstrasse' ].
	self should: [root link str = 'Cstrasse' ].

	root bla22 link: '#bla21:1'.
	self should: [root link str = 'Bstrasse' ].
! !

!GbtTestRefSlot methodsFor: 'tests' stamp: 'hk 8/23/2017 16:31'!
testLinkAccessNode
	|root level21 level22 level31 level32|
	level31 := GbtSmartNode struct: 'Level31' define: {{#str . #val: . 'Bstrasse'}} .    
	level32 := GbtSmartNode struct: 'Level32' define: {{#str . #val: . 'Cstrasse'}} .    

	level21 := GbtSmartNode struct: 'Level21' define: {{#nada . #thing: . level31}} .
	level22 := GbtSmartNode struct: 'Level22' define: {{#link . #ref: . '#nada'}}.

	root := GbtSmartNode struct: 'root' define: { 
		{#bla21 . #thing: . level21 }.		"bla21 - level21 - node - level31 - str"
		{#bla22 . #thing: . level22 }.		"bla22 - level22 - link - node"
	} .

	self should: [root nada str = 'Bstrasse' ].
	self should: [root link str = 'Bstrasse' ].

	root nada: level32 .		
	self should: [root nada str = 'Cstrasse' ] .
	self should: [root link str = 'Cstrasse' ] .
! !

!GbtTestRefSlot methodsFor: 'tests' stamp: 'hk 8/23/2017 16:31'!
testLinkSummary
	|root level21 level22 |
	level21 := GbtSmartNode struct: 'Level21' define: {
		{#str . #val: . 'Bstrasse'}.
		{ #summary . '#str' }
		} .
	level22 := GbtSmartNode struct: 'Level22' define: {
		{#link . #ref: . '#bla21'}.
		{ #summary . '#link' }.
		}.

	root := GbtSmartNode struct: 'root' define: { 
		{#bla21 . #thing: . level21 }.		"bla21 - str"
		{#bla22 . #thing: . level22 }.		"bla22 - link - level21"
		{ #summary . '#bla21 #bla22'}.
	} .

	self should: [root  summaryEnriched = 'Bstrasse  Bstrasse   '].
! !

!GbtTestRefSlot methodsFor: 'tests' stamp: 'hk 8/21/2017 17:31'!
testREFDown

	| bla1 bla2 bla3|
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
	}.
	bla2 := GbtSmartNode struct: #bla2 define: {  
		{ #def . #thing: . bla3 }. 
		{ #ghi . #val: . #a }	.
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #REF1 . #ref: . 'ref  (#xyz)' }.
		{ #REF2 . #ref: . 'ref (#def:xyz)' }.
		{ #REF3 . #ref: . 'ref (#abc:xyz)' }.
		{ #REF4 . #ref: . 'ref (#abc:def:xyz)' }.
		{ #abc . #thing: . bla2 }.
	}.
	self should: [bla1 REF1 = 'b' ].
	self should: [bla1 REF2 = 'b' ].
	self should: [bla1 REF3 = 'b' ].
	self should: [bla1 REF4 = 'b' ].
! !

!GbtTestRefSlot methodsFor: 'tests' stamp: 'hk 8/21/2017 17:31'!
testREFUp1

	| bla1 bla2 bla3|
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
		{ #REF1 . #ref: . 'ref (#xyz)' }.
		{ #REF2 . #ref: . 'ref (#def:xyz)' }.
		{ #REF3 . #ref: . 'ref (#abc:def:xyz)' }.
		{ #REF4 . #ref: . 'ref (#abc:xyz) '}.      "smartPath may be incomplete"
	}.
	bla2 := GbtSmartNode struct: #bla2 define: {  
		{ #def . #thing: . bla3 }. 
		{ #ghi . #val: . #a }	.
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #abc . #thing: . bla2 }.
	}.
	self should: [bla1 REF1 = 'b' ].
	self should: [bla1 REF2 = 'b' ].
	self should: [bla1 REF3 = 'b' ].
	self should: [bla1 REF4 = 'b' ]! !

!GbtTestRefSlot methodsFor: 'tests' stamp: 'hk 8/21/2017 17:31'!
testREFUp2
	"shall work from bottom too"
	| bla1 bla2 bla3|
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
		{ #REF1 . #ref: . 'ref (#xyz)' }.
		{ #REF2 . #ref: . 'ref (#def:xyz) '}.
		{ #REF3 . #ref: . 'ref (#abc:def:xyz) '}.
		{ #REF4 . #ref: . 'ref (#abc:xyz) '}.      "smartPath may be incomplete"
	}.
	bla2 := GbtSmartNode struct: #bla2 define: {  
		{ #def . #thing: . bla3 }. 
		{ #ghi . #val: . #a }	.
	}.	
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #abc . #thing: . bla2 }.
	}.   
	bla3 := bla1 def.  "see testThingContainers"
	self should: [bla3 REF1 = 'b' ].
	self should: [bla3 REF2 = 'b' ].
	self should: [bla3 REF3 = 'b' ].
	self should: [bla3 REF4 = 'b' ]! !

!GbtTestRefSlot methodsFor: 'tests' stamp: 'hk 8/25/2017 19:12'!
testREFUp2Root
	"up REFerence across a list via #R for Root"
	| bla1 bla2 bla3|
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
		{ #REF1 . #ref: . 'ref (#G:xyz)' }.
		{ #REF4 . #ref: . 'ref (#G:abc:xyz)' }.      
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #xyz . #val: . #a }.
		{ #abc . #listOf: . bla3 }.
	}.   
	bla2 := bla1 abc newEntry.  
	self should: [bla2 xyz = 'b' ].
	self should: [bla2 REF1 = 'a' ].
	self should: [bla2 REF4 = 'b' ].
	self should: [bla1 REF1 = 'a' ].
	self should: [bla1 REF4 = 'b' ]! !

!GbtTestRefSlot methodsFor: 'tests' stamp: 'hk 1/3/2018 10:42'!
testREFUpLocal
	"local up REFerence does not cross a list"
	| bla1 bla2 bla3|
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #xyz . #val: . #b }.
		{ #REF1 . #ref: . 'ref (#xyz) ' }.
		{ #REF2 . #ref: . 'ref (#xyz2) '}.
		{ #REF4 . #ref: . 'ref (#abc:xyz) ' }.      
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #xyz2 . #val: . #a }.
		{ #abc . #listOf: . bla3 }.
	}.   
	bla2 := bla1 abc newEntry.  
	self should: [bla1 REF1 = 'b' ].
	self should: [bla2 REF2 = 'NaRef: xyz2'].
	self should: [bla1 REF4 = 'NaRef: abc:xyz'] ! !

!GbtTestRefSlot methodsFor: 'tests' stamp: 'hk 8/21/2017 17:31'!
testRefError

	| bla bla2 |
	bla2 := GbtSmartNode struct: #bla2 define: {  
		{ #ghi . #val: . #a }	.
	}.
	bla := GbtSmartNode struct: #bla1 define: {  
		{ #ref1 . #ref: . 'ref (#ghi:xyz)' }.
		{ #abc . #thing: . bla2 }.
	}.
	self should: [bla ref1 = 'NaP: abc:ghi:xyz' ] 
! !

GbtTests subclass: #GbtTestRefSlotLookup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestRefSlotLookup methodsFor: 'tests' stamp: 'hk 8/21/2017 17:32'!
testLookupDown

	| bla1 bla2 bla3|
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #slot31 . #val: . #b }.
	}.
	bla2 := GbtSmartNode struct: #bla2 define: {  
		{ #slot21 . #thing: . bla3 }. 
		{ #slot22 . #val: . #slot31 }	.
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #slot11 . #thing: . bla2 }.
		{ #slot12 . #val: . #slot11 }.
		{ #slot13 . #ref: . 'lookup (slot12 slot22) ' }.
		{ #slot14 . #ref: . 'lookup (slot12 ) ' }.
		{ #slot15 . #ref: . 'lookup (slot22 ) ' }.
	}.
	self should: [bla1 slot14 longName = 'bla2:T11v0' ].
	self should: [bla1 slot15 = 'b' ].
	self should: [bla1 slot13 = 'b' ].
! !

!GbtTestRefSlotLookup methodsFor: 'tests' stamp: 'hk 8/21/2017 17:32'!
testLookupError

	| bla1 bla2 bla3|
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #slot31 . #val: . #b }.
		{ #slot33 . #ref: . 'lookup (slot12 slot22 )' }.
	}.
	bla2 := GbtSmartNode struct: #bla2 define: {  
		{ #slot21 . #thing: . bla3 }. 
		{ #slot22 . #val: . #slot31 }	.
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #slot11 . #thing: . bla2 }.
		{ #slot12 . #val: . #slot11 }.
	}.
	self should: [bla1 slot33 = 'b' ].
! !

!GbtTestRefSlotLookup methodsFor: 'tests' stamp: 'hk 1/3/2018 10:42'!
testLookupErrorNoPath
	"path does not exist"
	| bla1 bla2 bla3|
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #slot31 . #val: . #b }.
		{ #slot33 . #ref: . 'lookup (slot12 slot12 )' }.
	}.
	bla2 := GbtSmartNode struct: #bla2 define: {  
		{ #slot21 . #thing: . bla3 }. 
		{ #slot22 . #val: . #slot31 }	.
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #slot11 . #thing: . bla2 }.
		{ #slot12 . #val: . #slot11 }.
	}.
	self should: [bla1 slot33 = 'NaRef: slot11:slot11' ].
! !

!GbtTestRefSlotLookup methodsFor: 'tests' stamp: 'hk 8/21/2017 17:32'!
testLookupErrorThingButValue
	"no value found but thing "
	| bla1 bla2 bla3|
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #slot31 . #val: . #b }.
		{ #slot33 . #ref: . 'lookup (slot12 slot11 )' }.
	}.
	bla2 := GbtSmartNode struct: #bla2 define: {  
		{ #slot21 . #thing: . bla3 }. 
		{ #slot22 . #val: . #slot31 }	.
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #slot11 . #thing: . bla2 }.
		{ #slot12 . #val: . #slot11 }.
	}.
	self should: [bla1 slot33 = 'NaStr: slot11' ].
! !

!GbtTestRefSlotLookup methodsFor: 'tests' stamp: 'hk 8/21/2017 17:32'!
testLookupUp

	| bla1 bla2 bla3|
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #slot31 . #val: . #b }.
		{ #slot33 . #ref: . 'lookup (slot12 slot22) ' }.
	}.
	bla2 := GbtSmartNode struct: #bla2 define: {  
		{ #slot21 . #thing: . bla3 }. 
		{ #slot22 . #val: . #slot31 }	.
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #slot11 . #thing: . bla2 }.
		{ #slot12 . #val: . #slot11 }.
	}.
	self should: [bla1 slot33 = 'b' ].
! !

!GbtTestRefSlotLookup methodsFor: 'tests' stamp: 'hk 1/3/2018 10:42'!
testLookupUp2Local

	| bla1 bla2 bla3|
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #slot31 . #val: . #b }.
		{ #slot32 . #val: .  #slot31 }.
		{ #slot33 . #ref: . 'lookup (slot32) ' }.
		{ #slot36 . #ref: . 'lookup (slot13) ' }.
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #slot11 . #listOf: . bla3 }.
		{ #slot13 . #val: . #slot11 }.
	}.
	bla2 := bla1 slot11 newEntry.
	self should: [bla1 slot33 = 'b' ].
	self should: [bla2 slot33 = 'b' ].
	self should: [bla2 slot36 = 'NaRef: slot13' ] .

! !

!GbtTestRefSlotLookup methodsFor: 'tests' stamp: 'hk 8/21/2017 17:32'!
testLookupUp2Root

	| bla1 bla2 bla3|
	bla3 := GbtSmartNode struct: #bla3 define: {  
		{ #slot31 . #val: . #b }.
		{ #slot32 . #val: .  #slot31 }.
		{ #slot33 . #ref: . 'lookupR (slot13) ' }.
		{ #slot34 . #ref: . 'lookupR (slot12) ' }.
		{ #slot36 . #ref: . 'lookupR (slot13 slot32) ' }.
	}.
	bla1 := GbtSmartNode struct: #bla1 define: {  
		{ #slot11 . #listOf: . bla3 }.
		{ #slot12 . #val: .  #slot31 }.
		{ #slot13 . #val: . #slot11 }.
		{ #slot31 . #val: . #a }.
	}.
	bla2 := bla1 slot11 newEntry.
	self should: [bla1 slot33 asString = 'Ulist:U9v0 (1 items)' ].
	self should: [bla1 slot34 = 'a' ].
	self should: [bla1 slot36 = #b ].
	self should: [bla2 slot36 = #b ].

! !

GbtTests subclass: #GbtTestRightAndRoles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:15'!
installFilter1Role
	| role |
	role := GbtRole forExecute 
			addFilter: '#country = ''Germany''' for: #GCContactsContext;
			yourself.
	GbtServer default addUser: #Test withRole: role! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:15'!
installFilter2Role
	| role |
	role := GbtRole forExecute 
			addFilter: '#country = ''Germany''' for: #GCContactsContext;
			addFilter: '#street = ''Germany''' for: #GCContactsContext;
			yourself.
	GbtServer default addUser: #Test withRole: role! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 6/7/2017 10:49'!
listContext 
	^GbtPrimeListAC struct: 'ListContext' define: { 
		{#templates: . self thing }.
		{#subcontext: . self plainContext }.
		{#uiSpec:icon: . #GbtListAndItemUI . #edit }.
	}  ! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 3/22/2017 12:39'!
plainContext
	
	^GbtPlainAC struct: 'PlainContext' define: { 
		{#vo: . self thing }.
		{#uiSpec:icon: . #GbtItemUI . #edit }.
	}  ! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:15'!
testExecuteRole
	| app appUI |
	GbtServer default addUser: #Test withRole: GbtRole forExecute.
	self listContext. 
	app := (GbtServer default registerAppFor: #Test) mainContext.
	appUI := app ui.
	appUI newElement.
	self should: [ app list size = 1 ].
	! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:15'!
testExecuteRole2
	| app appUI |
	GbtServer default addUser: #Test withRole: GbtRole forWrite.
	self listContext. 
	app := (GbtServer default registerAppFor: #Test) mainContext.
	appUI := app ui.
	self should: [ appUI	newElement] raise: Exception.
			! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:15'!
testFilterRole
	| app  role|
	role := GbtRole forWrite 
			addFilter: '#v1 = ''Germany''' for: #ListContext;
			addFilter: '#v2 = ''Austria''' for: #ListContext;
			yourself.
	GbtServer default addUser: #Test withRole: role.
	self listContext. 
	app := (GbtServer default registerAppFor: #Test) mainContext.
	self thing v1: #Germany; v2: #Austria; storeSubtree.
	self thing v2: #Austria; storeSubtree.
	app loadAll.
	
	self should: [ app list size = 1 ]! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:15'!
testNothingRole
	"so far nothing is equivalent to read"
	| app appUI |
	GbtServer default addUser: #Test withRole: GbtRole forRead.
	self listContext. 
	app := (GbtServer default registerAppFor: #Test) mainContext.
	appUI := app ui.
	app newEntry.

	self should: [ app subcontext ui mode value = #text ].
	self should: [( app subcontext ui widgets at: #item) isKindOf: GbtUiTextWidget ]
	! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:15'!
testReadRole
	| app appUI |
	GbtServer default addUser: #Test withRole: GbtRole forRead.
	self listContext. 
	app := (GbtServer default registerAppFor: #Test) mainContext.
	appUI := app ui.
	app newEntry.
	
	self should: [ app subcontext ui mode value = #text ].
	self should: [( app subcontext ui widgets at: #item) isKindOf: GbtUiTextWidget ]
	! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:15'!
testWriteRole
	| app appUI |
	GbtServer default addUser: #Test withRole: GbtRole forWrite.
	self listContext. 
	app := (GbtServer default registerAppFor: #Test) mainContext.
	appUI := app ui.		
	app newEntry.	
	self should: [ app subcontext ui mode value ~= #text ].
	self should: [ #(GbtThingDiEditor GbtThingEditor) includes: ( app subcontext ui widgets at: #item ) className]
	! !

!GbtTestRightAndRoles methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:21'!
thing
	^GbtSmartNode struct: 'listElementVO' define: { 
		{ #v1 . #val: . 'var1' }.
		{ #v2 . #val: . 'var2' }.
		{ #v3 . #val: . 'var3' }.
		{ #v4 . #val: . 'var4' }.
	}! !

GbtTests subclass: #GbtTestRootMap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-AppService'!

!GbtTestRootMap methodsFor: 'as yet unclassified' stamp: 'hk 1/8/2018 20:41'!
dirOf: aSvoName
	^(FileSystem workingDirectory / 'default' /'things' / aSvoName) 
					ensureCreateDirectory ! !

!GbtTestRootMap methodsFor: 'as yet unclassified' stamp: 'hk 1/8/2018 20:44'!
testDBStructure1
	| primeThingMap key keyColl thColl dir fileContent |
	self testWriteNestedThing .
	dir := self dirOf: #th1.
	fileContent := (dir / 'primeThingMap') readStream contents.
	primeThingMap := GbtPrimeThingMap fromString: fileContent.
	key := primeThingMap keys first.
	self should: [key = 'T10'].
	keyColl := primeThingMap at: key. 
	thColl := OrderedCollection new: 3.
	keyColl do: [:k| thColl add: (GbtServer default executable reader loadNode: k)] .
	self should: [ (thColl first slotSVOAt: #s2) val = #s12 ].
	self should: [ (thColl second slotSVOAt: #s2) val = #s22 ].
	self should: [( thColl third slotSVOAt: #s2 ) val = #s32 ]! !

!GbtTestRootMap methodsFor: 'as yet unclassified' stamp: 'hk 4/6/2017 17:24'!
testReadEmpty
	| re |
	re := GbtPrimeThingMap fromString: ''.
	self should: [re lines isEmpty]! !

!GbtTestRootMap methodsFor: 'as yet unclassified' stamp: 'hk 4/28/2017 11:35'!
testReadNestedThing
	| primeThingMap key dir fileContent|
	self testWriteNestedThing .
	dir := self dirOf: #th1.
	fileContent := (dir / 'primeThingMap') readStream contents.
	primeThingMap := GbtPrimeThingMap fromString: fileContent.
	self should: [primeThingMap lines size = 1].
	key := primeThingMap  keys first.
	self should: [key = 'T10'].
	self should: [(primeThingMap at: key) includes: 'th2:T11v1'].
	self should: [(primeThingMap at: key) includes: 'th3:T12v1'].
	^primeThingMap! !

!GbtTestRootMap methodsFor: 'as yet unclassified' stamp: 'hk 4/28/2017 11:05'!
testUpdateRootMap
	| th1 dir fileContent |
	th1 := self testWriteNestedThing .
	th1 s2: #s99.
	th1 store.
	dir := self dirOf: #th1.
	fileContent := (dir / 'primeThingMap') readStream contents.
	self should: [fileContent = 'th1:T10v2 th2:T11v1 th3:T12v1 
']! !

!GbtTestRootMap methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:21'!
testWrite3
	| th dir fileContent |
	(th := GbtSmartNode struct: 'th' define: { 
		{ #s1 . #val: . 's11' }.
		{ #s2 . #val: . #s12 }}) storeSubtree.
	(th copy) storeSubtree.
	(th copy) storeSubtree.
	dir := self dirOf: #th.
	fileContent := (dir / 'primeThingMap') readStream contents.
	self should: [fileContent = 
'th:T3v1 
th:T4v1 
th:T5v1 
'].
	^fileContent! !

!GbtTestRootMap methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:21'!
testWriteNestedThing
	| th3 th2 th1 dir fileContent |
	th3 := GbtSmartNode struct: 'th3' define: { 
		{ #s1 . #val: . 's31' }.
		{ #s2 . #val: . #s32 }}.
	th2 := GbtSmartNode struct: 'th2' define: { 
		{ #s1 . #thing: . th3 }.
		{ #s2 . #val: . #s22 }}.
	th1 := GbtSmartNode struct: 'th1' define: { 
		{ #s1 . #thing: . th2 }.
		{ #s2 . #val: . #s12 }}.
	th1 storeSubtree.
	dir := self dirOf: #th1.
	fileContent := (dir / 'primeThingMap') readStream contents.
	self should: [fileContent = 'th1:T10v1 th2:T11v1 th3:T12v1 
'].
	^th1! !

GbtTests subclass: #GbtTestScripting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestScripting methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testAddChoice
	| bla |
	bla := (GbtSmartNode struct: #bla)
		define: #street enum: #(#private #biz);
		yourself.
	self should: [ (bla slotSVOAt: #street) val = #private ].
	self should: [ (bla slotSVOAt: #street) list first = #private ]! !

!GbtTestScripting methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testAddMultipleValues
	| address |
	address := (GbtSmartNode struct: 'GCAddress')
		define: #street val: 'street';
		define: #zip val: '9999';
		define: #city val: 'city';
		yourself.
	self should: [ (address slotSVOAt: #street) val = #street].
	self should: [ (address slotSVOAt: #city) val = #city].
	self should: [ (address slotSVOAt: #zip) val = '9999' ]! !

!GbtTestScripting methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testAddVO
	| bla blabla |
	bla := GbtSmartNode struct: #bla define: {
			{#street . #enum: . #(#private #biz)}
		} full: {}.  
	blabla := GbtSmartNode struct: #blabla define: {
			{#bla . #thing: . bla}
		} full: {}.
	self should: [ ((blabla slotSVOAt: #bla) slotSVOAt: #street) val = #private ].
! !

!GbtTestScripting methodsFor: 'tests' stamp: 'hk 11/6/2017 21:06'!
testDefaultNaming
	| vo1  |
	vo1 := GbtNodeList new.
	self should: [ vo1 longName = 'Ulist:U1v0'] .
! !

!GbtTestScripting methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testPathScripting
	| bla blabla end |
	end := GbtSmartNode struct: #end define: {
		{ #street . #val: . #private }.
		{ #zip . #val: . #mobile} }.
	bla := GbtSmartNode struct: #bla define: {
		{#end . #thing: . end }}.
	blabla := GbtSmartNode struct: #blabla define: {
		{#bla . #thing: . bla} }.
	self should: [ bla end street = #private ].
	self should: [ blabla bla end zip = #mobile ].
	bla end street: #irgend.
	blabla bla end zip: 'was'.
	self should: [ bla end street = #irgend ].
	self should: [ blabla bla end zip = #was ]! !

!GbtTestScripting methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testRetreiveByQualifiedName
	"longNmae = thingName:autoName "
	| vo1  vo3|
	GbtSmartNode struct: #default define: #() full: #().		"create default SVO"
	GbtSmartNode struct: #default define: #() full: #().		"copy of same"	
	vo1 := GbtSmartNode definedAs: #default . "retrieve from program store"
	vo3 := vo1 bizApp thingNamed: #default:T3v0. "retrieve from thing cache"
	self should: [ vo1 longName = 'default:T1v0'] . 
	self should: [ vo3 longName = 'default:T3v0'] . 
! !

GbtTests subclass: #GbtTestSmartFullThings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestSmartFullThings methodsFor: 'helpers' stamp: 'hk 8/16/2017 17:21'!
address 

	^GbtSmartNode struct: 'A' 
		define: {  
		{ #city . #val:tag: . 'city' . #foo2 } }
		full: { 		
		{ #street . #val:tag: . 'street' . #foo1} }! !

!GbtTestSmartFullThings methodsFor: 'helpers' stamp: 'hk 8/16/2017 17:21'!
contact 
	"SVOTestSmartFullThings new contact"
	
	^GbtSmartNode struct: 'C' define: { 
		{ #nname . #val:tag: . 'Krasemann' . #foo8 }.
		{ #adr1 . #thing:tag: . self address . #foo7} }
		full: { 
		{ #adr2 . #thing:tag: . self address . #foo7}.
		{ #vname . #val: . 'Hartmut'} }! !

!GbtTestSmartFullThings methodsFor: 'tests' stamp: 'hk 5/3/2017 15:21'!
testDefineSimpleHierarchySmartFull
	
	| smart full |
	smart := self contact.
	full := smart fullThing. 
	self should: [ full adr2 city = 'city' ].
	self should: [ full adr1 street = 'street' ].
	self should: [ full adr1 fullThing == full adr2 fullThing].
	self should: [ (full allSlotSVOsTagged: #foo7) size = 2 ].
	self should: [ full adr1 isSmart not].
	self should: [ full adr2 isSmart not].
	
	self should: [ (smart slotSVOAt: #vname) isNil ].
	self should: [ (smart allSlotSVOsTagged: #foo7) size = 1 ].  
	
	smart adr2.  	"this will force the adr2 slot into smart"
	self should: [ (smart allSlotSVOsTagged: #foo7) size = 2].
	self should: [ smart adr1 isSmart ].
	self should: [ smart adr2 isSmart ].! !

!GbtTestSmartFullThings methodsFor: 'tests' stamp: 'hk 2/17/2017 15:50'!
testDefineSimpleSmartFull
	
	| smart full |
	smart := self address.
	full := smart fullThing.
	self should: [ full svoName = ('F', smart svoName) ].
	self should: [ full city = 'city' ].
	self should: [ full street = 'street' ].
	self should: [ (smart slotSVOAt: #city) val = 'city' ].
	self should: [ (smart slotSVOAt: #street) isNil ].

! !

!GbtTestSmartFullThings methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testDefineSmartNativeSlots
	
	| smart  |
	smart := GbtSmartNode struct: 'A' 
		define: {  
		{ #summary . 'a new summary' } .
		{ #purpose . #purp } .
		{ #purposes . #(abc def purp) } .
		{ #idNumberPolicy . #noPol } .
		}
		full: { 		
		{ #city . #val:tag: . 'city' . #foo2 } .
		{ #street . #val:tag: . 'street' . #foo1} }.
		
	self should: [ (smart slotSVOAt: #city) isNil ].
	self should: [ (smart slotSVOAt: #street) isNil ].
	self should: [ smart street = 'street' ].


! !

!GbtTestSmartFullThings methodsFor: 'tests' stamp: 'hk 8/28/2017 15:43'!
testDefineSmartUlist
	
	| smart  |
	smart := GbtSmartNode struct: 'X' 
		define: { }
		full: { { #cust . #listOf: . { self contact } } }.
	self should: [ (smart slotSVOAt: #cust) isNil].
	self should: [ smart nname ] raise: MessageNotUnderstood .
	self should: [ (smart slotSVOAt: #cust) isNil].
	self should: [ smart cust isNotNil].
	
	smart cust newEntry.	
	self should: [ smart nname = 'Krasemann'].
	self should: [ smart cust list first isSmart].
	self should: [( smart cust list first slotSVOAt: #vname) isNil ].


! !

!GbtTestSmartFullThings methodsFor: 'tests' stamp: 'hk 8/27/2017 13:52'!
testRemoveSmart
	
	| smart  |
	smart := self address.	
		smart removeSmart: #city.
	self should: [ (smart slotAt: #city) isNil].


! !

!GbtTestSmartFullThings methodsFor: 'tests' stamp: 'hk 8/27/2017 13:53'!
testRemoveSmart2
	
	| smart  |
	smart := self contact.	
		smart removeSmart: #city.
	self should: [ (smart slotAt: #city) isNil].


! !

!GbtTestSmartFullThings methodsFor: 'tests' stamp: 'hk 8/27/2017 13:54'!
testSmartSlotAccess
	
	| smart  |
	smart := self address.	
	self should: [ smart city = #city].
	self should: [ smart foo2 = #city].
	self should: [ (smart slotAt: #street) isNil].
	self should: [ smart street = 'street'].


! !

!GbtTestSmartFullThings methodsFor: 'tests' stamp: 'hk 8/27/2017 13:55'!
testSmartSlotAccess2
	
	| smart  |
	smart := self contact.	
	self should: [ smart city = #city].
	self should: [ smart foo2 = #city].
	self should: [ (smart slotAt: #street) isNil].
	self should: [ smart street = 'street'].


! !

!GbtTestSmartFullThings methodsFor: 'tests' stamp: 'hk 8/27/2017 14:25'!
testSmartSlotAccessError
	
	| smart  |
	smart := self contact.	
	self should: [ smart unsinn ] raise: MessageNotUnderstood.
	self should: [ smart vname = #Hartmut] .
	self should: [ smart vname unsinn]  raise: MessageNotUnderstood.


! !

!GbtTestSmartFullThings methodsFor: 'tests' stamp: 'hk 8/27/2017 14:22'!
testSmartSlotAccessTags
	
	| smart  |
	smart := self contact.	
	self should: [ smart foo8 = #Krasemann].
	self should: [ smart foo7 svoName = #A].
	self should: [ smart foo7 foo2 = #city].
	self should: [ smart foo2 = #city].
	self should: [ smart foo1 = #street]! !

GbtTests subclass: #GbtTestSton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-AppService'!

!GbtTestSton methodsFor: 'running' stamp: 'hk 8/3/2015 11:47'!
stonIsHere
	Smalltalk at: #STON ifAbsent: [ self error: 'no STON in image' ]
! !

!GbtTestSton methodsFor: 'tests' stamp: 'hk 8/21/2017 16:43'!
testStonAttributes
	| a0 a1 a2 |
	self stonIsHere .
	a0 := GbtSmartNode struct: 'GCSList'.
	a0 copy.
	a1 := (GbtSmartNode struct: 'GCActivity')
		define: #type enum: #(#elementary #basic #composite);
		define: #tariff val: 'standard tariff';
		define: #quantity
			no: 0
			tag: #();
		define: #deadline date: '1.1.00';
		yourself.
	a2 := (STON fromString: (STON toStringPretty: a1))  .
	self should: [ a2 type = a1 type ].
	self should: [ a2 tariff = a1 tariff ].
	self should: [ a2 quantity = a1 quantity ].
	self should: [ a2 deadline = a1 deadline ]! !

!GbtTestSton methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testStonSlotAssociations
	| a0 a1 a2 |
	self stonIsHere .
	a0 := GbtSmartNode struct: 'Type1'.
	a1 := (GbtSmartNode struct: 'Type2')
		define: #node thing: a0.
		
	a2 := (STON fromString: (STON toStringPretty: a1)) .
	
	self should: [ a2 slots size = 1 ].
	self should: [ a2 slotValues anyOne isKindOf: GbtSlotAssociation ].! !

!GbtTestSton methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testStonUlist
	| a0 a1 a2 |
	self stonIsHere .
	a0 := GbtSmartNode struct: 'GCSList'.
	a1 := (GbtSmartNode struct: 'GCActivity')
		define: #list listOf: #GCSList .
	a1 list newEntry.
		
	a2 := (STON fromString: (STON toStringPretty: a1))  .
	
	self should: [ a2 list listSize = 1 ]! !

GbtTests subclass: #GbtTestTransactions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-AppService'!

!GbtTestTransactions methodsFor: 'helpers' stamp: 'hk 8/16/2017 17:15'!
installUsers
	#(Tom Lisa) do: [:u| 
		GbtServer default addUser: u withRole: GbtRole forExecute]! !

!GbtTestTransactions methodsFor: 'helpers' stamp: 'hk 3/22/2017 13:01'!
itemContext
	^GbtPlainAC struct: 'ItemContext' define: {
		{#displayAs: . 'Item'  } .
		{#uiSpec:icon: . #GbtItemUI . #nil}.
		{#txThings: . #(transferSource transferSink) }
		}
! !

!GbtTestTransactions methodsFor: 'helpers' stamp: 'hk 6/7/2017 10:49'!
listContext 
	^GbtPrimeListAC struct: 'ListContext' define: {
		{#displayAs: . 'List'} .
		{#noPolicyPrefix: . 'X'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #nil} .
		{#templates: . self thing1} .
		{#subcontext: . self itemContext}
		}

! !

!GbtTestTransactions methodsFor: 'tests' stamp: 'hk 9/6/2017 17:49'!
testNotifyChanges
	| th ctxt1 ctxt2 |
	self installUsers.
	self listContext.
	ctxt1 := (GbtServer default registerAppFor: #Tom) mainContext.
	ctxt2 := (GbtServer default registerAppFor: #Lisa) mainContext.

	th := ctxt1 newEntry.
	ctxt1 subcontext  newEntry: th.	"th's now in a plain context"
	th beTransient; save. 
	self should: [ctxt2 list isNotEmpty ].
	self should: [ctxt2 list first version = 1].

	th storeSubtree.
	
	self shouldnt: [ctxt2 list first == (ctxt1 list first)].
	self should: [ctxt2 list first = (ctxt1 list first)].
	self should: [ctxt1 list first version = 2]! !

!GbtTestTransactions methodsFor: 'tests' stamp: 'hk 8/16/2017 17:15'!
testNotifyNew
	| th ctxt1 ctxt2 |
	self installUsers.
	self listContext.
	ctxt1 := (GbtServer default registerAppFor: #Tom) mainContext.
	ctxt2 := (GbtServer default registerAppFor: #Lisa) mainContext.
	th := ctxt1 newEntry. 
	self should: [ctxt2 list isEmpty ].
	ctxt1 subcontext vo: th.
	th storeSubtree.

	self should: [ctxt2 list isNotEmpty].
	self should: [ctxt2 list first = th].
	self shouldnt: [ctxt2 list first == th].
! !

!GbtTestTransactions methodsFor: 'tests' stamp: 'hk 9/6/2017 17:49'!
testTxWithRoles
	|th ctxt1 ctxt2 th2 th3 |
	self installUsers.
	self listContext.
	ctxt1 := (GbtServer default registerAppFor: #Tom) mainContext.
	th := ctxt1 newEntry.
	ctxt2 := ctxt1 subcontext.
	ctxt2 newEntry: th beTransient.	
	ctxt2 assign: (th2 := self thing2) beTransient toTxThing: #transferSource. 
	ctxt2 assign: (th3 := self thing3) beTransient toTxThing: #transferSink.
	ctxt2 store.
	self should: [(th bizApp  loadList: th svoName) size = 1].
	self should: [(th bizApp  loadList: th2 svoName) size = 1].
	self should: [(th bizApp  loadList: th3 svoName) size = 1].
! !

!GbtTestTransactions methodsFor: 'helpers' stamp: 'hk 8/16/2017 17:21'!
thing1 
	^GbtSmartNode struct: 'Thing1' define: {}! !

!GbtTestTransactions methodsFor: 'helpers' stamp: 'hk 8/16/2017 17:21'!
thing2 
	^GbtSmartNode struct: 'Thing2' define: {}! !

!GbtTestTransactions methodsFor: 'helpers' stamp: 'hk 8/16/2017 17:21'!
thing3 
	^GbtSmartNode struct: 'Thing3' define: {}! !

GbtTests subclass: #GbtTestUlist
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests'!

!GbtTestUlist methodsFor: 'tests' stamp: 'hk 11/6/2017 21:06'!
testCreation
	| list node1 node2 |
	node1 := GbtSmartNode struct: 'GCUnode1' define: {{#n1 . #val:. #bla1} }.
	node2 := GbtSmartNode struct: 'GCUnode2' define: {{#n2 . #val:. #bla2} }.
	(list := GbtNodeList new)
		newEntry: node1;
		newEntry: node2.
		
	self should: [ list listSize  = 2 ].
	self should: [ ((list slotSVOAt: #'1') slotSVOAt: #n1) val = #bla1 ].
	self should: [ (list slotSVOAt: #'2') n2 = #bla2 ].
! !

!GbtTestUlist methodsFor: 'tests' stamp: 'hk 11/6/2017 21:06'!
testTemplate1
	| list node1  |
	(node1 := GbtSmartNode struct: 'GCUnode1') define: #n1 val: #bla1 .
	(list := GbtNodeList new) 
		addTemplate: node1;
		newEntry .	
	self should: [ list listSize  = 1 ].
	self should: [ ((list slotSVOAt: #'1') slotSVOAt: #n1) val = #bla1 ].
! !

!GbtTestUlist methodsFor: 'tests' stamp: 'hk 12/29/2017 18:07'!
testTemplate2
	| list node1 node2 |
	node1 := GbtSmartNode struct: 'GCUnode1' define: {{#n1 . #val:. #bla1} }.
	node2 := GbtSmartNode struct: 'GCUnode2' define: {{#n2 . #val:. #bla2} }.
	list := (GbtNodeList new)
		addTemplate: node1;
		addTemplate: node2 .	
	list newEntry: list templateThing copy.
	list newEntry: list templateThings last copy.
	self should: [ list listSize = 2 ].
	self should: [ list templates size = 2 ].
	self should: [ (list slotSVOAt: #'2') n1 = #bla1 ].
! !

!GbtTestUlist methodsFor: 'tests' stamp: 'hk 11/6/2017 21:06'!
testView
	| list node1 node2 view1 view2|
	(node1 := GbtSmartNode struct: 'GCUnode1') define: #n1 val: #bla1.
	(node2 := GbtSmartNode struct: 'GCUnode2') define: #n2 val: #bla2.
	list := (GbtNodeList new).  
	list	newEntry: node1.
	list	newEntry: node2.
	view1 := (GbtDirective struct: #Decl define: {
		{ #eins . #tag: . #n1}.
		{ #zwei . #tag: . #n2} }).
	view2 := view1 viewOn: list.
	self should: [ (view1 transform: list) isKindOf: GbtSmartNode ].
	self should: [ view2 eins = #bla1 ].
	self should: [ view2 zwei = #bla2 ] ! !

!GbtTestUlist methodsFor: 'tests' stamp: 'hk 11/6/2017 21:06'!
testViewDisplay
	"Test loopt bei slot-Zugriff in displayStringFor:"
	| list node1  |
	node1 := GbtSmartNode struct: 'GCUnode1' define: {
		{#n1 . #val:. #bla1}.
	 	{#n2 . #val:. #bla2}}.
	(list := GbtNodeList new)
		displayColumns: #(n1 n2);
		newEntry: node1.
		
	self should: [ ((node1 displayArrayFrom: list displayColumns) first: 3) = {'nil'  .	'bla1' . 'bla2'} ].
! !

!GbtTestUlist methodsFor: 'tests' stamp: 'hk 11/6/2017 21:06'!
testViewDisplayE
	"Test loopt bei slot-Zugriff in displayStringFor:"
	| list node1 space2 |
	space2 := '  '.
	(node1 := GbtSmartNode struct: 'GCUnode1') 
		define: #n1 val: #bla1;
	 	define: #n2 val: #bla2.
	(list := GbtNodeList new)
		displayColumns: #(bla1 bla2);
		newEntry: node1.
		
	self should: [ ((node1 displayArrayFrom: list displayColumns) first: 3) = (Array with: #'nil' with: '''-''' with: '''-''')  ].
! !

!GbtTests methodsFor: 'running' stamp: 'hk 12/12/2016 19:48'!
setUp
	self tearDown! !

!GbtTests methodsFor: 'running' stamp: 'hk 1/5/2018 16:39'!
tearDown 
	GbtServer clearStore; initialize. 
	GbtBizNetMockUp stopPolling! !

GbtTests subclass: #GbtVOGUITests
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

GbtVOGUITests subclass: #GbtGUITestSuiteCalcSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

!GbtGUITestSuiteCalcSlot methodsFor: 'tests' stamp: 'hk 8/1/2017 17:39'!
testCalcSlot
	|   value calc |
	editor addFromFull: #slot2.
	editor addFromFull: #slot3.
	value := ((editor widgets at: #lbl_slot2) subWidget ) widgetValue .
	value accept: '3'.
	calc := ((editor widgets at: #lbl_slot3) subWidget ) widgetValue.
	self should: [ calc text =  '63' ].
	self should: [ editor smartVO slot3 =  63 ]


! !

!GbtGUITestSuiteCalcSlot methodsFor: 'tests' stamp: 'hk 8/2/2017 14:08'!
testCalcSlotHierarchy
	| calcInputField |
	editor addFromFull: #slot1.
	editor addFromFull: #slot3. 		"leads to an error -> no number summed up"
	editor addFromFull: #sum4.
	calcInputField := ((editor widgets at: #lbl_sum4) subWidget) widgetValue.
	self should: [ calcInputField text =  '3' ].
	self should: [ editor smartVO sum4 =  3 ].
	editor addFromFull: #slot8.		"has a street no = 3 with #calc tag"
	self should: [ editor smartVO sum4 =  6 ]

! !

!GbtGUITestSuiteCalcSlot methodsFor: 'tests' stamp: 'hk 8/1/2017 19:57'!
testProdSlot
	|  value prod |
	editor addFromFull: #slot1.
	editor addFromFull: #slot2.
	editor addFromFull: #slot3.
	editor addFromFull: #prod5.
	value := ((editor widgets at: #lbl_slot2) subWidget) widgetValue.
	value accept: '2'.
	prod := ((editor widgets at: #lbl_prod5) subWidget) widgetValue.
	self should: [ prod text =  '252' ].
	self should: [ editor smartVO prod5 =  252 ]


! !

!GbtGUITestSuiteCalcSlot methodsFor: 'tests' stamp: 'hk 8/1/2017 19:56'!
testSumSlot
	|   value  sum |
	editor addFromFull: #slot1.
	editor addFromFull: #slot2.
	editor addFromFull: #slot3.
	editor addFromFull: #sum4.
	value := ((editor widgets at: #lbl_slot2) subWidget) widgetValue.
	value accept: '2'.
	sum := ((editor widgets at: #lbl_sum4) subWidget) widgetValue.
	self should: [ sum text =  '47' ].
	self should: [ editor smartVO sum4 =  47 ]


! !

GbtVOGUITests subclass: #GbtGUITestSuiteListSlots
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

GbtVOGUITests subclass: #GbtGUITestSuiteSimpleSlots
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

!GbtGUITestSuiteSimpleSlots methodsFor: 'tests' stamp: 'hk 5/13/2017 14:54'!
testEnumSlotInput
	| tifModel |
	editor addFromFull: #slot1.
	tifModel := ((editor widgets at: #lbl_slot1) subWidget) widgetValue.
	tifModel setSelectedItem: '7'.
	self should: [ (editor smartVO slotSVOAt: #slot1) val  = '7' ].
! !

!GbtGUITestSuiteSimpleSlots methodsFor: 'tests' stamp: 'hk 5/13/2017 14:54'!
testValueSlotInput
	| tifModel |
	editor addFromFull: #slot2.
	tifModel := ((editor widgets at: #lbl_slot2) subWidget) widgetValue.
	tifModel accept: 'abcxyz'.
	self should: [ tifModel text = 'abcxyz' ].
! !

GbtVOGUITests subclass: #GbtGUITestSuiteVOSlots
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

!GbtVOGUITests class methodsFor: 'examples' stamp: 'hk 5/19/2017 20:52'!
exampleDialogBL
	(self new tearDown; exampleDialogBL) openWithSpec! !

!GbtVOGUITests class methodsFor: 'examples' stamp: 'hk 11/26/2015 23:03'!
exampleDialogD
	(self new tearDown; exampleDialogD) openWithSpec! !

!GbtVOGUITests class methodsFor: 'examples' stamp: 'hk 7/5/2016 20:27'!
exampleDialogFull
	(self new tearDown; exampleDialogFull) openWithSpec! !

!GbtVOGUITests class methodsFor: 'examples' stamp: 'hk 8/17/2016 22:10'!
exampleDialogFullFreeze
	(self new tearDown; exampleDialogFullFreeze) openWithSpec! !

!GbtVOGUITests methodsFor: 'things' stamp: 'hk 2/23/2017 17:48'!
dialogFullThing
	"self new dialogFullThing editD"
	^ self dialogThing 
		slot1 ;
		slot2 ;
		slot2a ;
		slot3 ;
		sum4 ;
		prod5 ;
		slot6 ;
		slot7 ;
		no ;
		addresses ;
		slot8 ;
		slot9 ;
		slot10 ;
		slotB ;
		slotC ;
		slotD ;
		yourself! !

!GbtVOGUITests methodsFor: 'things' stamp: 'hk 12/13/2017 13:13'!
dialogThing
| addr1 addr2 |
addr1 := GbtSmartNode struct: #addr1 define:  {
		{ #summary . ' #city  #street ' }.
		{ #uiClassName . #GbtAddressBoxWidget }.
		{ #purposes . #(business private)}.
		{ #city . #val: . #Hamburg }.
		{ #street . #val: . 'an der Alster' } }.
addr2 :=		GbtSmartNode struct: #addr2 define:  {
		{ #summary . ' #city am #street ' }.
"		{ #uiClassName . #GcAddressBoxWidget }.
"		{ #purposes . #(private spouse)}.
		{ #city . #val: . #Berlin }.
		{ #street . #val: . #Kuhdamm }.
		{ #no . #val:tag: . '3' . #calc} .
		{ #adr . #thing: .  addr1 }.	
	 }.
^ GbtSmartNode struct: #demo define: {
			{#summary . 'slot#1 and slot#6 touched in summary - #slot1 - #slot6'}}
		full: {
			{#slot1. #enum:for:tag:. #('3' '4' '7').
				#(#purp1 #purp2 #purp3). #calc}. {#slot2 . #val:tag: . #city . #calc}.
			{#slot2a . #val: . 'slot9'}.
			{#slot3 . #no:tag: . '7 * 3 * #slot2 ' . #calc}.
			{#sum4 . #no: . 'sumTag (calc)'}.
			{#prod5 . #no: . 'prodTag (calc)'}.
			{#slot6. #date:. Date today}.
			{#slot7. #no:for:tag:. '42'. #(#purp1 #purp2). nil}.
			{#no . #no: . '0'}.
			{#addresses. #listOf:. { addr1.  addr2}}.
			{#slot8. #thing:for:.  addr2. #(#geschaeft #privat #anlieferung #dienstboten)}.
			{#slot9. #thing:.  addr1}.
			{#slot10. #text:for:. 'Beispieltext'. #(#abc #def)}.
			{#slotB . #ref: . 'ref (#city)'}.
			{#slotC . #ref: . 'lookup (slot2a slot2 )'}.
			{#slotD . #constraint: . '#slot7 = 42 '}}! !

!GbtVOGUITests methodsFor: 'running' stamp: 'hk 5/19/2017 20:52'!
exampleDialogBL
	^GbtThingEditor on: self dialogThing

! !

!GbtVOGUITests methodsFor: 'running' stamp: 'hk 2/23/2017 17:48'!
exampleDialogD
	^GbtThingDiEditor on: (self dialogThing copy)  

! !

!GbtVOGUITests methodsFor: 'running' stamp: 'hk 2/23/2017 17:56'!
exampleDialogFull
	"GbtVOGUITests new dialogFullThing"  
	^GbtThingEditor on: (self dialogFullThing)  

! !

!GbtVOGUITests methodsFor: 'running' stamp: 'hk 10/6/2016 19:01'!
exampleDialogFullFreeze
	"self new dialogFullThing copyFreeze editD"
	^GbtThingEditor on: (self dialogFullThing copyFreeze)  

! !

!GbtVOGUITests methodsFor: 'running' stamp: 'hk 5/19/2017 20:52'!
setUp
	super setUp.
	(editor := self exampleDialogBL) buildWithSpec! !

GbtTests subclass: #GbtVOListGUITests
	instanceVariableNames: 'th0Ctxt listCtxt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-GUI'!

!GbtVOListGUITests methodsFor: 'as yet unclassified' stamp: 'hk 11/23/2017 11:27'!
editor 
	^listCtxt subcontext ui item editor1


! !

!GbtVOListGUITests methodsFor: 'as yet unclassified' stamp: 'hk 8/20/2017 14:19'!
exampleDialogBL
	| th thCtxt  |  
	th := GbtSmartNode struct: #demo define: {
			{#slot . #val: . 'abc'}
	}.	
	thCtxt := GbtPlainAC struct: 'ThCtxt' define: {
		{#uiSpec:icon: . #GbtItemUI . #nil}.
	}.
	listCtxt := GbtPrimeListAC struct: 'ListCtxt' define: {
		{#uiSpec:icon: . #GbtListAndItemUI . #nil} .
		{#templates: . th} .
		{#subcontext: . thCtxt}	}.
	listCtxt newEntry
! !

!GbtVOListGUITests methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 17:21'!
exampleDialogUL
	| th thCtxt th0 |
	th := GbtSmartNode struct: #demo define: {
			{#slot . #val: . 'abc'}
	}.	
	thCtxt := GbtPlainAC struct: 'ThCtxt' define: { 
		{#uiSpec:icon: . #GbtItemUI . #nil}.
	}.
	listCtxt := GbtPrimeListAC struct: 'UlistCtxt' define: {
		{#uiSpec:icon: . #GbtListAndItemUI . #nil} .
		{#templates: . th} .
		{#subcontext: . thCtxt}	
	}.
	th0 := GbtSmartNode struct: #demo0 define: { 
			{#slot . #listOf: . th}
	}.	
	th0Ctxt := GbtPlainAC struct: 'Th0Ctxt' define: {
		{#uiSpec:icon: . #GbtItemUI . #nil}.
		{#aspect:on: . listCtxt . #slot}
	}.
	listCtxt newEntry
! !

!GbtVOListGUITests methodsFor: 'as yet unclassified' stamp: 'hk 5/20/2017 14:48'!
testListUpdate
	| value |
	self exampleDialogBL.
	listCtxt ui buildWithSpec.
	self should: [listCtxt list first slot = #abc].
	listCtxt ui setSelection: listCtxt list first.
	value := (self editor widgets at: #lbl_slot) subWidget widgetValue.
	value accept: #def.
	self should: [listCtxt list first slot = #def]! !

!GbtVOListGUITests methodsFor: 'as yet unclassified' stamp: 'hk 8/19/2017 21:23'!
testListUpdateAfterSave
	| value listElem |
	self exampleDialogBL.
	listCtxt ui buildWithSpec.
	listElem := listCtxt list first.
	self should: [listElem slot = #abc].
	listCtxt ui setSelection: listCtxt list first.
	value := (self editor widgets at: #lbl_slot) subWidget widgetValue.
	value accept: #def.
	self editor save. 
	value accept: #ghi.
	self should: [listElem slot = #ghi].
! !

!GbtVOListGUITests methodsFor: 'as yet unclassified' stamp: 'hk 6/7/2017 10:54'!
testListUpdatePrimeListAfterUndo
	| value |
	self exampleDialogBL.
	listCtxt ui buildWithSpec.
	self should: [listCtxt list first slot = #abc].
	listCtxt ui setSelection: listCtxt list first.
	value := (self editor widgets at: #lbl_slot) subWidget widgetValue.
	value accept: #def.
	self editor undo.
	self should: [listCtxt list first slot = #abc].
! !

!GbtVOListGUITests methodsFor: 'as yet unclassified' stamp: 'hk 5/20/2017 14:49'!
testListUpdateUlistAfterUndo
	| value |
	self exampleDialogUL.
	listCtxt ui buildWithSpec.
	self should: [listCtxt list first slot = #abc].
	listCtxt ui setSelection: listCtxt list first.
	value := (self editor widgets at: #lbl_slot) subWidget widgetValue.
	value accept: #def.
	self editor undo.
	self should: [listCtxt list first slot = #abc].
! !

!GbtVOListGUITests methodsFor: 'as yet unclassified' stamp: 'hk 8/20/2017 13:26'!
testListUpdateWithSave
	| value listElem |
	self exampleDialogBL.
	listCtxt ui buildWithSpec.
	listElem := listCtxt list first.
	self should: [listElem slot = #abc].
	listCtxt ui setSelection: listCtxt list first.
	value := (self editor widgets at: #lbl_slot) subWidget widgetValue.
	value accept: #def.
	self should: [listElem slot = #def].
	self editor save. 
	value accept: #ghi.
	self should: [listElem slot = #ghi].
! !

PPCompositeParserTest subclass: #GbtTestBasicGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

!GbtTestBasicGrammar methodsFor: 'accessing' stamp: 'hk 4/19/2017 12:22'!
parserClass 
	^ GbtBasicGrammar! !

!GbtTestBasicGrammar methodsFor: 'as yet unclassified' stamp: 'hk 1/9/2018 17:57'!
testGbtSmartPath0
	self parse: 'abc' rule: #gbtSmartPath.
	self assert: result equals: #(abc).
	self parse: 'abc:def:ghi' rule: #gbtSmartPath.
	self assert: result equals: #(abc def ghi).
	
! !

!GbtTestBasicGrammar methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 11:37'!
testInteger
	self parse: ' -123 ' rule: #integer.
	self assert: result equals: -123 .

	self parse: ' 789 ' rule: #integer.
	self assert: result equals: 789 .

	self fail: '123.789' rule: #integer! !

!GbtTestBasicGrammar methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 11:36'!
testNumber
	self parse: '-123' rule: #number.
	self assert: result equals: -123 .

	self parse: '789' rule: #number.
	self assert: result equals: 789 .

	self parse: '-123.789' rule: #number.
	self assert: result equals: -123.789 .
! !

!GbtTestBasicGrammar methodsFor: 'as yet unclassified' stamp: 'hk 12/1/2017 10:38'!
testString
	| tmp1 tmp2 tmp4 |
	tmp1 := ' 25 some 234 !!? ÄÖÜ € @ things '.
	tmp2 := ' '' 25 some 234 !!? ÄÖÜ € @ things '' '.
	tmp4 := self.
	tmp4
		assert: (self parse: tmp1 rule: #slotStringUnquoted)
			equals: tmp1 trim;
		assert: (self parse: tmp2 rule: #stringQuoted) equals: tmp1! !

PPCompositeParserTest subclass: #GbtTestBehaviorGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

GbtTestBehaviorGrammar subclass: #GbtTestBehaviorCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

!GbtTestBehaviorCompiler methodsFor: 'as yet unclassified' stamp: 'hk 10/1/2017 12:50'!
parserClass 
	^ GbtCielBehCompiler! !

!GbtTestBehaviorCompiler methodsFor: 'as yet unclassified' stamp: 'hk 10/2/2017 13:36'!
testCielBehavior
	super testCielBehavior.
	self should: [result isKindOf: GbtCielBehavior].
	self assert: result svoName equals: #myBeh.
	self assert: result slots size equals: 2.
	self assert: (result slotSVOAt: #someone) inputValue equals: 'aCielExpression (gets , here)'! !

!GbtTestBehaviorGrammar methodsFor: 'as yet unclassified' stamp: 'hk 10/1/2017 12:50'!
parserClass 
	^ GbtCielBehGrammar! !

!GbtTestBehaviorGrammar methodsFor: 'as yet unclassified' stamp: 'hk 10/1/2017 15:35'!
testCielBehavior
	self parse: 	'behavior myBeh { 
		someone 	: 	aCielExpression (gets , here)
		sometwo 	: 	another expression there
	 } ' .! !

PPCompositeParserTest subclass: #GbtTestCIELGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

GbtTestCIELGrammar subclass: #GbtTestCIELCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

!GbtTestCIELCompiler methodsFor: 'running' stamp: 'hk 9/28/2017 20:20'!
directive	
	^GbtDirective struct: 'Directive' define: { 
		{ #vorname }.
		{ #stadt }	
	}.
! !

!GbtTestCIELCompiler methodsFor: 'running' stamp: 'hk 11/13/2017 14:11'!
listBehavior
	^GbtCielBehavior new: #test define: {	  }! !

!GbtTestCIELCompiler methodsFor: 'running' stamp: 'hk 11/14/2017 17:54'!
listContext 
	
	^(GbtPrimeListAC struct: 'ListContext' define: { 
		{#templates: . self thing }.
		{#poolThings: . {self pthingArg1 . self pthingArg2} }.
		{#subcontext: . self plainContext }})  
			addBehavior: self listBehavior;
			newEntry;
			newEntry; yourself! !

!GbtTestCIELCompiler methodsFor: 'accessing' stamp: 'hk 9/29/2017 15:58'!
parserClass 
	^ GbtCielCompiler! !

!GbtTestCIELCompiler methodsFor: 'running' stamp: 'hk 11/13/2017 14:06'!
plainBehavior
	^GbtCielBehavior new: #test define: { 
		{ #thing . #PoolThing1} .
		{ #direc . #Directive } .
		{ #test . #direc } 
		}! !

!GbtTestCIELCompiler methodsFor: 'running' stamp: 'hk 11/14/2017 17:55'!
plainBehaviorArgs
	^GbtCielBehavior new: #testArgs define: { 
		{ #arg1 . #PoolThing1} .
		{ #testArgs . 'arg1:result' } 
		}! !

!GbtTestCIELCompiler methodsFor: 'running' stamp: 'hk 11/14/2017 17:54'!
plainContext 
	"GbtTestCIELCompiler new plainContext"
	
	^(GbtPlainAC struct: 'PlainContext' define: { 
		{#vo: . self thing }.
		{#poolThings: . {self pthing1 . self pthing2 . self directive } }.
		{#txThings: . #(source sink) }})  
			addBehavior: self plainBehavior;
			addBehavior: self plainBehaviorArgs;
			assign: self txthing toTxThing: #source! !

!GbtTestCIELCompiler methodsFor: 'as yet unclassified' stamp: 'hk 9/28/2017 19:14'!
pthing1
	^GbtSmartNode struct: 'PoolThing1' define: { 
		{#summary . '#vorname #nachname'} .
		{#vorname . #val: .  'Hans'} .
		{#nachname . #val: . 'Muster'} .
	}! !

!GbtTestCIELCompiler methodsFor: 'as yet unclassified' stamp: 'hk 9/28/2017 20:20'!
pthing2
	^GbtSmartNode struct: 'PoolThing2' define: { 
		{#summary . '#vorname #nachname'} .
		{#vorname . #val: . 'Klaus'} .
		{#nachname . #val: . 'Mann'} .
		{#stadt . #val: . 'HH'} .
	}! !

!GbtTestCIELCompiler methodsFor: 'as yet unclassified' stamp: 'hk 11/14/2017 17:58'!
pthingArg1
	^GbtSmartNode struct: 'PoolThingArg1' define: { 
		{#a . #no: . 7 } .
		{#b . #no: .  8 } .
		{#result . #no: . '#a + #b'} .
	}! !

!GbtTestCIELCompiler methodsFor: 'as yet unclassified' stamp: 'hk 11/14/2017 17:58'!
pthingArg2
	^GbtSmartNode struct: 'PoolThingArg2' define: { 
		{#a . #no: . 3 } .
		{#b . #no: .  3 } .
		{#result . #no: . '#a * #b'} .
	}! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 9/28/2017 17:53'!
setParserListBehavior
	parser container: (self listContext behaviors at: #test)
! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 9/28/2017 17:53'!
setParserPlainBehavior
	parser container: (self plainContext behaviors at: #test)
! !

!GbtTestCIELCompiler methodsFor: 'running' stamp: 'hk 9/20/2017 11:53'!
setUp
	self tearDown. 
	super setUp! !

!GbtTestCIELCompiler methodsFor: 'running' stamp: 'hk 1/5/2018 16:38'!
tearDown
	GbtServer initialize. 
	super tearDown! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 11/16/2017 16:41'!
testCApply
	"for an interactive test decomment the line with PoolThing2"
	self setParserListBehavior.
	self parse: 	' apply(	PlainContext:test )' .
	self assert: result svoName equals: #Directive! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 11/16/2017 16:42'!
testCApplyArgs
	"same behavior 2 calls with different args"
	self setParserListBehavior.
	self parse: 	' apply(	PlainContext:testArgs PoolThingArg1)' .
	self assert: result  equals: 15.
	self parse: 	' apply(	PlainContext:testArgs PoolThingArg2)' .
	self assert: result  equals: 9! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 1/9/2018 17:30'!
testCAskUser
	"for an interactive test decomment the line with PoolThing2"
	self setParserPlainBehavior.
	self parse: 	' askUser ( Title list (thing ', 
	"  ' PoolThing2 ' , "
	') )' .
	self assert: result svoName equals: #PoolThing1! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 9/28/2017 17:19'!
testCDirective
	self setParserPlainBehavior.
	self parse: 	' Directive ' rule: #cielDirective.
	self assert: result svoName equals: #Directive! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 9/28/2017 18:22'!
testCDirectiveE
	self setParserPlainBehavior.
	self should: [self parse: ' AnyThing ' rule: #cielDirective] raise: GbtCielExistsError! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 9/28/2017 18:29'!
testCDirectiveVar
	self setParserPlainBehavior.
	self parse: 	' direc ' .
	self assert: result svoName equals: #Directive! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 9/28/2017 18:55'!
testCThing
	self setParserPlainBehavior.
	self parse: 	' PoolThing1 ' .
	self assert: result svoName equals: #PoolThing1! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 9/28/2017 18:23'!
testCThingE
	self setParserPlainBehavior.
	self should: [self parse: 'AnyThing' rule: #cielThing] raise: GbtCielExistsError! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 9/28/2017 18:54'!
testCThingVar
	self setParserPlainBehavior.
	self parse: 	' thing ' rule: #cielThing.
	self assert: result svoName equals: #PoolThing1! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 9/28/2017 17:16'!
testContextList
	self setParserListBehavior.
	super testContextList .
	self assert: result first svoName equals: #MyThing! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 9/28/2017 17:16'!
testContextListForeign
	self setParserPlainBehavior.
	self listContext.
	super testContextListForeign .
	self assert: result first svoName equals: #MyThing! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 9/28/2017 17:14'!
testContextThing
	self setParserPlainBehavior.
	super testContextThing .
	self assert: result svoName equals: #MyThing! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 9/28/2017 17:15'!
testContextThingForeign
	self setParserListBehavior.
	self plainContext.
	super testContextThingForeign.
	self assert: result svoName equals: #MyThing! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 9/28/2017 20:30'!
testFctCheckConstraints
	self setParserPlainBehavior.
	super testFctCheckConstraints.
	self should: [result isConsistent ]
! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 9/29/2017 15:39'!
testFctCommit
	self setParserPlainBehavior.
	super testFctCommit.
	self assert: result first version equals: 1.
	self assert: result second version equals: 1.
! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 10/10/2017 21:22'!
testFctFilter
	self setParserPlainBehavior.
	self listContext list second nachname: #Hans.
	super testFctFilter.
	self assert: result size equals: 1! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 1/9/2018 20:19'!
testFctSystemCall
	super testFctSystemCall.
	self should: [result = (3@2)].
! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 11/23/2017 11:16'!
testFctTransform
	self setParserPlainBehavior.
	super testFctTransform.
	self assert: result  vorname equals: #Klaus.
! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 10/19/2017 19:55'!
testFctTransformList
	self setParserPlainBehavior.
	super testFctTransformList.
	self assert: result  size equals: 2.
	self assert: result first slots size equals: 1.
	self assert: result second slots size equals: 2.
! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 9/28/2017 20:05'!
testFctTransformSingle
	self setParserPlainBehavior.
	super testFctTransformSingle.
	self assert: result vorname equals: #Hans! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 10/10/2017 17:13'!
testGet1
	self setParserPlainBehavior.
	self parse: 	' PoolThing1:nachname ' .
	self assert: result equals: #Muster! !

!GbtTestCIELCompiler methodsFor: 'tests' stamp: 'hk 10/10/2017 17:17'!
testSet1
	self setParserPlainBehavior.
	self parse: 	' PoolThing1:nachname := PoolThing2:nachname' .
	self assert: result nachname equals: #Mann! !

!GbtTestCIELCompiler methodsFor: 'running' stamp: 'hk 10/10/2017 21:21'!
thing
	^GbtSmartNode struct: 'MyThing' define: {
		{#vorname . #val: .  'Hans'} .
		{#nachname . #val: . 'Muster'} .
		{#constraint . #constraint: .  '#vorname = #nachname'} .
	}! !

!GbtTestCIELCompiler methodsFor: 'running' stamp: 'hk 9/20/2017 12:34'!
txthing
	^GbtSmartNode struct: 'TxThing' define: { }! !

!GbtTestCIELGrammar methodsFor: 'accessing' stamp: 'hk 9/29/2017 15:57'!
parserClass 
	^ GbtCielGrammar! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 9/28/2017 16:11'!
testCielVar
	self parse: 	'foo ' .
						! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 9/28/2017 17:16'!
testContextList
	self parse: 	'contextList ' .
						! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 9/28/2017 17:16'!
testContextListForeign
	self parse: 	'contextList ( ListContext) ' .
						! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 9/28/2017 17:13'!
testContextThing
	self parse: 	'contextThing ' .
! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 9/28/2017 17:14'!
testContextThingForeign
	self parse: 	'contextThing (PlainContext)' .
! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 11/16/2017 16:38'!
testFctAppend
	self parse: 	' appendBL (contextList list2) ' .

! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 11/16/2017 16:41'!
testFctApply
	self parse: 	' apply (behavior) ' .
	self parse: 	' apply (behavior arg1) ' .
	self parse: 	' apply (TargetContext:behavior) ' .
	self parse: 	' apply  (TargetContext:behavior arg1 ) ' .
	self parse: 	' apply (TargetContext:behavior arg1 arg2 arg3) ' .
! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 1/9/2018 17:30'!
testFctAskUser
	self parse: 	'askUser ( Title list (poolThing)) ' ! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 9/26/2017 14:23'!
testFctCheckConstraint
	self parse: 	'checkConstraints(PoolThing) ' .! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 9/28/2017 20:27'!
testFctCheckConstraints
	self parse: 	'checkConstraints ( PoolThing1 ) ' .! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 9/29/2017 15:41'!
testFctCommit
	self parse: 	'commit(thing PoolThing2) ' .! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 10/10/2017 21:38'!
testFctFilter
"	self parse: 	'filter(contextList(ListContext) contextThing:constraints) ' ."
	self parse: 	'filter(contextList(ListContext) contextThing) ' ! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 10/10/2017 21:39'!
testFctFilter1
	self parse: 	'filter(contextList(ListContext) contextThing:constraints) '! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 1/9/2018 20:16'!
testFctSystemCall
	self parse: 	'gbt (''Point x:3 y:2'') ' .! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 11/24/2017 15:36'!
testFctTransform
	self parse: 	'transform (direc PoolThing2  thing) ' .! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 11/24/2017 15:37'!
testFctTransformList
	self parse: 	'transform (direc list(PoolThing1 PoolThing2)  ) ' .! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 11/24/2017 15:37'!
testFctTransformSingle
	self parse: 	'transform(Directive PoolThing1  ) ' .
! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 10/10/2017 20:55'!
testGet
	self parse: 	' contextThing:slot1:slot2:slot3 ' .
	self parse: 	' contextThing:slot1:slot2 ' .
	self parse: 	' contextThing:slot1 ' ! !

!GbtTestCIELGrammar methodsFor: 'tests' stamp: 'hk 10/10/2017 20:55'!
testSet
	self parse: 	'contextThing:slot1:slot2:slot3 := abc ' .
	self parse: 	'contextThing:slot1:slot2 := abc ' .
	self parse: 	' contextThing:slot1 := abc ' .
! !

PPCompositeParserTest subclass: #GbtTestContextGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

!GbtTestContextGrammar methodsFor: 'accessing' stamp: 'hk 5/31/2017 17:32'!
parserClass 
	^ GbtContextGrammar! !

!GbtTestContextGrammar methodsFor: 'tests' stamp: 'hk 1/18/2018 13:41'!
testContextAttribute
	self fail: 	'blabla 		: 	AName ' rule: #simpleSlot.
	self parse: 	'icon: 	AName ' rule: #simpleSlot.
	self parse: 	'uiSpec 		: 	AName ' rule: #simpleSlot.
				
	self assert: result value first equals: #uiSpec: . 	
	self assert: result value second equals:	'AName' ! !

!GbtTestContextGrammar methodsFor: 'tests' stamp: 'hk 1/26/2018 13:34'!
testMenu
	self parse: 	'menu 			: 	AName ' rule: #menu.
						
	self assert: result value first equals: #menu: . 	
	self assert: result value second first equals: #AName . 	
	self should: [result value second allButFirst isEmpty].
! !

!GbtTestContextGrammar methodsFor: 'tests' stamp: 'hk 5/31/2017 17:39'!
testPoolThings
	self parse: 	'poolThings 	: 	bla1 bla2 ' rule: #poolThings.
				
	self assert: result value first equals: #poolThings: . 	
	self assert: result value second second svoName equals: 	#bla2 .! !

PPCompositeParserTest subclass: #GbtTestDeclGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

GbtTestDeclGrammar subclass: #GbtTestDeclCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

!GbtTestDeclCompiler methodsFor: 'accessing' stamp: 'hk 5/8/2017 20:00'!
parserClass 
	^ GbtDeclCompiler! !

!GbtTestDeclCompiler methodsFor: 'tests' stamp: 'hk 5/9/2017 10:57'!
testAllTags1
	super testAllTags1 .
	self assert: result value size equals: 4.
	self should: [result value first isKindOf: GbtSlotAssociation].
	self assert: result value first value equals: #ident1.
	self assert: result value fourth value equals: #ident4! !

!GbtTestDeclCompiler methodsFor: 'tests' stamp: 'hk 11/4/2017 21:30'!
testAllTags2
	super testAllTags2 .
	self assert: result value size equals: 4.
	self should: [result value fourth isKindOf: GbtSlotAssociation].
	self should: [result value fourth value second isKindOf: GbtObject]! !

!GbtTestDeclCompiler methodsFor: 'tests' stamp: 'hk 11/3/2017 13:41'!
testDeclTag
	super testDeclTag .
	self assert: result value size equals: 2.
	self should: [result value second isKindOf: GbtObject]! !

!GbtTestDeclCompiler methodsFor: 'tests' stamp: 'hk 5/8/2017 20:06'!
testExplicitTag
	super testExplicitTag .
	self assert: result value size equals: 2! !

!GbtTestDeclCompiler methodsFor: 'tests' stamp: 'hk 5/8/2017 20:05'!
testListTag
	super testListTag .
	self assert: result value size equals: 2.
	self should: [result value second second isKindOf: GbtObject]! !

!GbtTestDeclCompiler methodsFor: 'tests' stamp: 'hk 1/5/2018 16:38'!
testParseDecl
	GbtServer initialize. 
	super testParseDecl .
	self assert: result slots size equals: 3.
	self assert: result summary equals: 'some text'.
	self assert: result idNumberPolicy equals: #MyPolicy.
	self assert: (result slotAt: #abc) value equals: #abc.
	self assert: (result slotAt: #ghi) value equals: #ghi! !

!GbtTestDeclCompiler methodsFor: 'tests' stamp: 'hk 5/9/2017 11:00'!
testSimpleTag
	super testSimpleTag .
	self assert: result value size equals: 2.
	self assert: result value second equals: #aName.
	self assert: result value first equals: #aName.
! !

!GbtTestDeclGrammar methodsFor: 'accessing' stamp: 'hk 5/8/2017 19:55'!
parserClass 
	^ GbtDeclGrammar! !

!GbtTestDeclGrammar methodsFor: 'tests' stamp: 'hk 9/15/2017 14:01'!
testAllTags1
	self parse: 	'{ ident1 ident2 ident3 ident4 }' rule: #allTags.! !

!GbtTestDeclGrammar methodsFor: 'tests' stamp: 'hk 9/24/2017 15:54'!
testAllTags2
	self parse: 	' 
		{
		ident1 
		tag aName1  :  aTag  
		decl aName  :  Directive  
		list aName  :  oldList  Directive
		}
	' rule: #allTags.! !

!GbtTestDeclGrammar methodsFor: 'tests' stamp: 'hk 9/24/2017 15:44'!
testDeclTag
	self parse: 	' decl aName  :  Directive  ' rule: #declTag.! !

!GbtTestDeclGrammar methodsFor: 'tests' stamp: 'hk 5/8/2017 19:58'!
testExplicitTag
	self parse: 	' tag aName  :  aSlot  ' rule: #explicitTag.! !

!GbtTestDeclGrammar methodsFor: 'tests' stamp: 'hk 9/24/2017 15:44'!
testListTag
	self parse: 	' list aName  :  aSlot  Directive ' rule: #listTag.! !

!GbtTestDeclGrammar methodsFor: 'tests' stamp: 'hk 9/24/2017 15:44'!
testParseDecl
	 self parse: 	'
		directive myDecl 
			summary 		:  ''some text''
			bizIdPolicy 	: 	MyPolicy
			{abc def ghi}
	'! !

!GbtTestDeclGrammar methodsFor: 'tests' stamp: 'hk 5/8/2017 19:49'!
testSimpleTag
	self parse: 	' aName ' rule: #simpleTag.! !

PPCompositeParserTest subclass: #GbtTestELDateGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

GbtTestELDateGrammar subclass: #GbtTestELDateCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

!GbtTestELDateCompiler methodsFor: 'as yet unclassified' stamp: 'hk 9/17/2017 14:57'!
parserClass 
	^ GbtSELDateCompiler! !

!GbtTestELDateCompiler methodsFor: 'tests' stamp: 'hk 7/29/2017 18:40'!
testfunctionDate1
	super testfunctionDate1.
	self assert: result asString equals: '1 January 2011'! !

!GbtTestELDateCompiler methodsFor: 'tests' stamp: 'hk 7/29/2017 18:40'!
testfunctionDate2
	super testfunctionDate2.
	self assert: result asString equals: '31 December 2011'! !

!GbtTestELDateCompiler methodsFor: 'tests' stamp: 'hk 7/29/2017 18:40'!
testfunctionDate3
	super testfunctionDate3.
	self assert: result asString equals: '31 December 2011'! !

!GbtTestELDateCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testfunctionDate4
	| th |
	th := GbtSmartNode struct: 'TH' define: { 
		{ #date . #date: . Date today }}.

	parser container: th.
	super testfunctionDate4.
	self assert: result  equals: Date today ! !

!GbtTestELDateCompiler methodsFor: 'tests' stamp: 'hk 12/13/2017 12:57'!
testfunctionDate5
	super testfunctionDate5.
	self assert: result  equals: Date today! !

!GbtTestELDateGrammar methodsFor: 'as yet unclassified' stamp: 'hk 10/11/2017 12:43'!
parserClass 
	^ GbtSELGrammar! !

!GbtTestELDateGrammar methodsFor: 'tests' stamp: 'hk 8/15/2017 15:24'!
testfunctionDate1
	self parse: 	' date (1-1-11)' rule: #fctDate! !

!GbtTestELDateGrammar methodsFor: 'tests' stamp: 'hk 8/15/2017 15:28'!
testfunctionDate2
	self parse: 	'date+d( date+m (date (1-1-11),11), 30)' ! !

!GbtTestELDateGrammar methodsFor: 'tests' stamp: 'hk 8/15/2017 15:24'!
testfunctionDate3
	self parse: 	'silvester(date (1-1-11))' rule: #fctDate! !

!GbtTestELDateGrammar methodsFor: 'tests' stamp: 'hk 8/10/2017 19:51'!
testfunctionDate4
	self parse: 	'#date' ! !

!GbtTestELDateGrammar methodsFor: 'tests' stamp: 'hk 12/13/2017 12:57'!
testfunctionDate5
	self parse: 	'date(today)' rule: #termDate! !

PPCompositeParserTest subclass: #GbtTestELGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

GbtTestELGrammar subclass: #GbtTestELCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

!GbtTestELCompiler methodsFor: 'accessing' stamp: 'hk 9/17/2017 14:57'!
parserClass 
	^ GbtSELCompiler! !

!GbtTestELCompiler methodsFor: 'running' stamp: 'hk 8/10/2017 20:01'!
setUp
	self tearDown. 
	super setUp! !

!GbtTestELCompiler methodsFor: 'running' stamp: 'hk 1/5/2018 16:38'!
tearDown
	GbtServer initialize. 
	super tearDown! !

!GbtTestELCompiler methodsFor: 'tests' stamp: 'hk 8/21/2017 17:20'!
testfunctionRef
	|  th |
	th := GbtSmartNode struct: 'THE' define: { 
		{ #abc . #no: . 7 } .
		{ #def . #ref: . 'ref (#abc)' } .
	}.
	parser container: th.
	super testfunctionRef.
	self assert: result equals: 7! !

!GbtTestELCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testfunctionRefName
	| th th2|
	th := GbtSmartNode struct: 'THE' define: { 
		{ #abc . #no: . 7 } }.
	th2 := GbtSmartNode struct: 'THE2' define: { 
		{ #def . #no: . 9 } }.

	parser container: th2.
	super testfunctionRefName.
	self assert: result asString equals: 'THE:T1v0'! !

!GbtTestELCompiler methodsFor: 'tests' stamp: 'hk 8/21/2017 18:25'!
testfunctionRefThingSlot
	| sub th |
	sub := GbtSmartNode struct: 'SUB' define: { }.
	th := GbtSmartNode struct: 'THE' define: { 
		{ #abc . #thing: . sub } .
		{ #def . #ref: . 'ref (#abc)' } .
	}.
	parser container: th.
	self should: [th abc svoName = 'SUB'].
	self should: [th def svoName = 'SUB']	 ! !

!GbtTestELCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testfunctionSmartPath0
	|  th |
	th := GbtSmartNode struct: 'THE' define: { 
		{ #abc . #no: . 7 }}.
	parser container: th.
	super testfunctionSmartPath0.
	self assert: result equals: 7! !

!GbtTestELGrammar methodsFor: 'accessing' stamp: 'hk 10/11/2017 12:43'!
parserClass 
	^ GbtSELGrammar! !

!GbtTestELGrammar methodsFor: 'tests' stamp: 'hk 8/14/2017 13:28'!
testNegativeNumber
	self parse: 	' -4 ' rule: #termNumber.
	self assert: result equals: -4! !

!GbtTestELGrammar methodsFor: 'tests' stamp: 'hk 8/14/2017 13:25'!
testNumber
	self parse: 	' 4 ' .
	self assert: result equals: 4! !

!GbtTestELGrammar methodsFor: 'tests' stamp: 'hk 8/15/2017 14:58'!
testStringQuoted
	self parse: 	' ''abc'' ' .
	self assert: result equals: #abc! !

!GbtTestELGrammar methodsFor: 'tests' stamp: 'hk 8/13/2017 14:41'!
testfunctionPath
	self parse: 	' ref (#abc:def)' ! !

!GbtTestELGrammar methodsFor: 'tests' stamp: 'hk 8/10/2017 19:55'!
testfunctionRef
	self parse: 	' ref (#abc)' ! !

!GbtTestELGrammar methodsFor: 'tests' stamp: 'hk 8/10/2017 19:54'!
testfunctionRefName
	self parse: 	' ref (THE)' ! !

!GbtTestELGrammar methodsFor: 'tests' stamp: 'hk 8/13/2017 19:34'!
testfunctionSmartPath0
	self parse: 	' #abc ' ! !

PPCompositeParserTest subclass: #GbtTestELNumberGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

GbtTestELNumberGrammar subclass: #GbtTestELNumberCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

!GbtTestELNumberCompiler methodsFor: 'accessing' stamp: 'hk 9/17/2017 14:57'!
parserClass 
	^ GbtSELNumberCompiler! !

!GbtTestELNumberCompiler methodsFor: 'accessing' stamp: 'hk 7/22/2017 14:10'!
setUp
	self tearDown. 
	super setUp! !

!GbtTestELNumberCompiler methodsFor: 'accessing' stamp: 'hk 1/5/2018 16:38'!
tearDown
	GbtServer initialize. 
	super tearDown! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 6/30/2017 19:01'!
testCalc2
	super testCalc2.
	self assert: result equals: 20
! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 8/23/2017 16:37'!
testNumber1
	super testNumber1.
	self assert: result equals: 10
! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testPath1
	|  th |
	th := GbtSmartNode struct: 'TH' define: { 
		{ #abc . #no: . 7 } .
		{ #def . #no: . 3 }}.
	parser container: th.
	self parse: 	' #abc + #def ' .
	self assert: result equals: 10
! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testPath1E
	|  th |
	th := GbtSmartNode struct: 'THE42' define: { 
		{ #abc . #no: . 7 } .
		{ #def . #val: . #ghi } .
	}.
	parser container: th.
	self should: [self parse: '#abc + #def ' ] raise: GbtPNumberError .
! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testPath1d
	| th th1|
	th1 := GbtSmartNode struct: 'TH1' define: { 
		{ #ghi . #no: . 3 }}.
	th := GbtSmartNode struct: 'TH' define: { 
		{ #abc . #no: . 7 } .
		{ #def . #thing: . th1 }}.
	parser container: th.
	self parse: 	' #abc + #def:ghi'.
	self should: [result = 10]
! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 6/13/2017 21:14'!
testTerm1
	super testTerm1.
	self assert: result equals: 7
! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 6/13/2017 13:16'!
testfunctionAvg
	super testfunctionAvg.
	self assert: result equals: 5
! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 6/13/2017 15:06'!
testfunctionIf
	super testfunctionIf.
	self assert: result equals: 4
! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 7/30/2017 14:53'!
testfunctionIfBool
	super testfunctionIfBool.
	self assert: result equals: -4
! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 6/13/2017 15:05'!
testfunctionIfNot
	super testfunctionIfNot.
	self assert: result equals: -4
! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 6/13/2017 15:23'!
testfunctionMax
	super testfunctionMax.
	self assert: result equals: 4
! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 6/13/2017 15:23'!
testfunctionMin
	super testfunctionMin.
	self assert: result equals: -4
! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testfunctionRefRecursion
	| th th2 th3|
	th2 := GbtSmartNode struct: 'THE2' define: { 
		{ #abc . #no: . 7 } }.
	th := GbtSmartNode struct: 'THE' define: { 
		{ #abc . #thing: . th2 } }.
	th3 := GbtSmartNode struct: 'THE3' define: {  }.

	parser container: th3.
	super testfunctionRefRecursion.
	self assert: result equals: 7! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 8/21/2017 17:20'!
testfunctionRefRecursionOnSlot
	| th th2 th3|
	th2 := GbtSmartNode struct: 'THE2' define: { 
		{ #abc . #no: . 7 } }.
	th := GbtSmartNode struct: 'THE' define: { 
		{ #abc . #thing: . th2 } .
		{ #def . #ref: . 'ref(#abc)' } }.
	th3 := GbtSmartNode struct: 'THE3' define: {  }.

	parser container: th3.
	super testfunctionRefRecursion.
	self assert: result equals: 7! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testfunctionSmartPath1
	| sub th |
	sub := GbtSmartNode struct: 'SUB' define: { }.
	th := GbtSmartNode struct: 'THE' define: { 
		{ #abc . #thing: . sub }}.
	parser container: th.
	self parse: 	' (#abc )' .
	self assert: result svoName equals: 'SUB'! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testfunctionSmartPath3
	| sub th |
	sub := GbtSmartNode struct: 'SUB' define: { 
		{ #def . #no: . 7 }}.
	th := GbtSmartNode struct: 'THE' define: { 
		{ #abc . #thing: . sub }}.
	parser container: th.
	self parse: 	' #abc:def - 4 ' .
	self assert: result equals: 3! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testfunctionSmartPath4
	| sub th |
	sub := GbtSmartNode struct: 'SUB' define: { 
		{ #def . #no: . 7 }}.
	th := GbtSmartNode struct: 'THE' define: { 
		{ #abc . #thing: . sub }}.
	parser container: th.
	super testfunctionSmartPath4.
	self assert: result equals: 9! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 6/13/2017 13:17'!
testfunctionSum
	super testfunctionSum.
	self assert: result equals: 5
! !

!GbtTestELNumberCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testfunctionSumTag
	|  th |
	th := GbtSmartNode struct: 'THE' define: { 
		{ #abc . #no:tag: . 7 . #sum} .
		{ #def . #no:tag: . 3 . #sum } } .

	parser container: th.
	super testfunctionSumTag.
	self assert: result equals: 10! !

!GbtTestELNumberGrammar methodsFor: 'accessing' stamp: 'hk 10/11/2017 12:43'!
parserClass 
	^ GbtSELGrammar! !

!GbtTestELNumberGrammar methodsFor: 'tests' stamp: 'hk 6/30/2017 19:01'!
testCalc2
	self parse: 	' (7 + 3) * 2 ' ! !

!GbtTestELNumberGrammar methodsFor: 'tests' stamp: 'hk 8/23/2017 16:37'!
testNumber1
	self parse: 	' 7 + 3 ' ! !

!GbtTestELNumberGrammar methodsFor: 'tests' stamp: 'hk 7/15/2017 15:55'!
testTerm1
	self parse: 	' 7 ' .! !

!GbtTestELNumberGrammar methodsFor: 'tests' stamp: 'hk 11/6/2017 18:31'!
testfunctionAvg
	self parse: 	' average ( 3 ; 7 ; 5)' ! !

!GbtTestELNumberGrammar methodsFor: 'tests' stamp: 'hk 8/4/2017 14:50'!
testfunctionIf
	self parse: 	' if ( 4=4 ; 4 ; -4)' ! !

!GbtTestELNumberGrammar methodsFor: 'tests' stamp: 'hk 8/13/2017 14:21'!
testfunctionIfBool
	self parse: 	' if ( ''true'' = ''true''; 4 ; -4)' .
	self parse: 	' if ( ''true'' = ''false''; 4 ; -4)' ! !

!GbtTestELNumberGrammar methodsFor: 'tests' stamp: 'hk 8/4/2017 14:57'!
testfunctionIfNil
	self parse: 	' if ( 4 = #tag; 4 ; -4)' ! !

!GbtTestELNumberGrammar methodsFor: 'tests' stamp: 'hk 8/4/2017 14:58'!
testfunctionIfNot
	self parse: 	' if ( 3 = 4 ; 4 ; -4)' ! !

!GbtTestELNumberGrammar methodsFor: 'tests' stamp: 'hk 11/6/2017 18:32'!
testfunctionMax
	self parse: 	' max ( 3 ; 4 ; -4)' ! !

!GbtTestELNumberGrammar methodsFor: 'tests' stamp: 'hk 11/6/2017 18:32'!
testfunctionMin
	self parse: 	' min ( 3 ; 4 ; -4)' ! !

!GbtTestELNumberGrammar methodsFor: 'tests' stamp: 'hk 7/22/2017 16:22'!
testfunctionRefRecursion
	self parse: 	' ref (ref (THE) #abc:abc )' ! !

!GbtTestELNumberGrammar methodsFor: 'tests' stamp: 'hk 7/22/2017 16:23'!
testfunctionRefRecursionOnSlot
	self parse: 	'ref(ref(ref(THE)#def) #abc)' ! !

!GbtTestELNumberGrammar methodsFor: 'tests' stamp: 'hk 9/26/2017 14:46'!
testfunctionSmartPath3
	self parse: 	' #abc:def - 4 ' rule: #termNumber.
	self fail: 	' #abc:def - 4 ' rule: #termDate.
"	self fail: 	' #abc:def - 4 ' rule: #termString.
"	self fail: 	' #abc:def - 4 ' rule: #termBool.
	self parse: 	' (#abc:def - 4) ' .
	self parse: 	' #abc:def - 4 ' .
"	self assert: result equals: {'abc:def' . $- . '4'}"! !

!GbtTestELNumberGrammar methodsFor: 'tests' stamp: 'hk 8/16/2017 16:38'!
testfunctionSmartPath4
	self parse: 	' 2 + #abc:def ' rule: #termNumber.
	self fail: 	' 2 + #abc:def ' rule: #termDate.
	self fail: 	' 2 + #abc:def ' rule: #termBool.
	self parse: 	' 2 + #abc:def ' rule: #termString.
	self parse: 	' 2 + #abc:def ' .
"	self assert: result equals: { '2'. $+ . 'abc:def'}"! !

!GbtTestELNumberGrammar methodsFor: 'tests' stamp: 'hk 11/6/2017 18:32'!
testfunctionSum
	self parse: 	' sum ( 3 ; 7 ; -5)' ! !

!GbtTestELNumberGrammar methodsFor: 'tests' stamp: 'hk 7/15/2017 18:29'!
testfunctionSumTag
	self parse: 	' sumTag (sum)' ! !

PPCompositeParserTest subclass: #GbtTestELPredicateGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

GbtTestELPredicateGrammar subclass: #GbtTestELPredicateCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

!GbtTestELPredicateCompiler methodsFor: 'accessing' stamp: 'hk 9/17/2017 14:57'!
parserClass 
	^ GbtSELPredicateCompiler! !

!GbtTestELPredicateCompiler methodsFor: 'running' stamp: 'hk 7/22/2017 14:10'!
setUp
	self tearDown. 
	super setUp! !

!GbtTestELPredicateCompiler methodsFor: 'running' stamp: 'hk 1/5/2018 16:38'!
tearDown
	GbtServer initialize. 
	super tearDown! !

!GbtTestELPredicateCompiler methodsFor: 'tests' stamp: 'hk 11/22/2017 15:59'!
testBoolFalse
	super testBoolFalse.
	self should: [result not]
! !

!GbtTestELPredicateCompiler methodsFor: 'tests' stamp: 'hk 11/22/2017 15:59'!
testBoolTrue
	super testBoolTrue.
	self should: [result ]
! !

!GbtTestELPredicateCompiler methodsFor: 'tests' stamp: 'hk 7/22/2017 14:08'!
testConstraint0
	super testConstraint0.
	self should: [result not]
! !

!GbtTestELPredicateCompiler methodsFor: 'tests' stamp: 'hk 7/22/2017 14:08'!
testConstraint1
	super testConstraint1.
	self should: [result]
! !

!GbtTestELPredicateCompiler methodsFor: 'tests' stamp: 'hk 7/22/2017 14:08'!
testConstraint2
	super testConstraint2.
	self should: [result]
! !

!GbtTestELPredicateCompiler methodsFor: 'tests' stamp: 'hk 7/22/2017 14:08'!
testConstraint3
	super testConstraint3.
	self should: [result]
! !

!GbtTestELPredicateCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testConstraint4
	| th |
	th := GbtSmartNode struct: 'TH' define: { 
		{ #city . #val: . 'HH' }}.
	parser container: th.
	self should: [super testConstraint4] raise: GbtPDiv0Error
! !

!GbtTestELPredicateCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testConstraint5
	| th |
	th := GbtSmartNode struct: 'TH' define: { 
		{ #city . #val: . 'HH' }}.
	parser container: th.
	self should: [super testConstraint5] raise: GbtParserError
! !

!GbtTestELPredicateCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testConstraintWithPath
	| th |
	th := GbtSmartNode struct: 'TH' define: { 
		{ #slot1 . #no: . 1 } .
		{ #slot2 . #val: . '2' }}.
	parser container: th.
	super testConstraintWithPath.
	self should: [result] ! !

!GbtTestELPredicateCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testConstraintWithPath0
	| th |
	th := GbtSmartNode struct: 'TH' define: { 
		{ #slot1 . #no: . 1 } .
		{ #slot2 . #no: . 2 }}.
	parser container: th.
	super testConstraintWithPath0 .
	self should: [result]
! !

!GbtTestELPredicateCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testConstraintWithPath1
	| u1 u2 th |
	u2 := GbtSmartNode struct: 'U2' define: { }.
	u1 := GbtSmartNode struct: 'U1' define: {
		{ #slotu1 . #thing: . u2 } }.
	th := GbtSmartNode struct: 'TH' define: { 
		{ #slot0 . #thing: . u1 } .
		{ #slotu2 . #thing: . u2 }}.
	parser container: th.
	super testConstraintWithPath1.
	"self parse: 	' #slot0:slotu1 = #slotu2 ' "
	self should: [result ]
! !

!GbtTestELPredicateCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testConstraintWithPath2
	| u1 u2 th |
	u2 := GbtSmartNode struct: 'U2' define: { }.
	u1 := GbtSmartNode struct: 'U1' define: {
		{ #slotu1 . #thing: . u2 } }.
	th := GbtSmartNode struct: 'TH' define: { 
		{ #slot0 . #thing: . u1 } .
		{ #slotu2 . #thing: . u2 }}.
	parser container: th.
	super testConstraintWithPath2. 
	"self parse: 	' #slotu1 = #R:slotu2 ' "
	self should: [result]
! !

!GbtTestELPredicateCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testConstraintWithPathE
	| u1 u2 th |
	u2 := GbtSmartNode struct: 'U2' define: { }.
	u1 := GbtSmartNode struct: 'U1' define: {
		{ #slotu1 . #thing: . u2 } }.
	th := GbtSmartNode struct: 'TH' define: { 
		{ #slot0 . #thing: . u1 } .
		{ #slotu2 . #thing: . u2 }}.
	parser container: th.
	super testConstraintWithPathE. 
	"self parse: ' #slot0:slotu1 = #R:slot0 ' "
	self should: [result not]
! !

!GbtTestELPredicateCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testConstraintWithPathError
	| th |
	th := GbtSmartNode struct: 'TH' define: { 
		{ #slot1 . #no: . 1 } .
		{ #slot2 . #val: . 'abc' }}.
	parser container: th.
	self should: [super testConstraintWithPath] raise: GbtPNumberError ! !

!GbtTestELPredicateGrammar methodsFor: 'as yet unclassified' stamp: 'hk 10/11/2017 12:43'!
parserClass 
	^ GbtSELGrammar! !

!GbtTestELPredicateGrammar methodsFor: 'tests' stamp: 'hk 11/22/2017 15:45'!
testBoolFalse
	self parse: 	' false ' rule: #termBool! !

!GbtTestELPredicateGrammar methodsFor: 'tests' stamp: 'hk 11/22/2017 15:45'!
testBoolTrue
	self parse: 	' true ' rule: #termBool! !

!GbtTestELPredicateGrammar methodsFor: 'tests' stamp: 'hk 7/31/2017 18:20'!
testConstraint0
	self parse: 	' ''99'' < ''100'' ' rule: #termBool! !

!GbtTestELPredicateGrammar methodsFor: 'tests' stamp: 'hk 7/31/2017 18:20'!
testConstraint1
	self parse: 	' date(15 June 2000) < date(11 July 2000) ' rule: #termBool! !

!GbtTestELPredicateGrammar methodsFor: 'tests' stamp: 'hk 7/31/2017 18:21'!
testConstraint2
	self parse: 	' 99 < 100 ' rule: #termBool! !

!GbtTestELPredicateGrammar methodsFor: 'tests' stamp: 'hk 7/31/2017 18:21'!
testConstraint3
	self parse: 	' 10 - 5 >= 0 ' rule: #termBool! !

!GbtTestELPredicateGrammar methodsFor: 'tests' stamp: 'hk 8/4/2017 18:43'!
testConstraint4
	self parse: 	' #city = 3/0 'rule: #termBool! !

!GbtTestELPredicateGrammar methodsFor: 'tests' stamp: 'hk 7/31/2017 18:21'!
testConstraint5
	self parse: 	' 3 = #city ' rule: #termBool! !

!GbtTestELPredicateGrammar methodsFor: 'tests' stamp: 'hk 8/16/2017 16:51'!
testConstraintWithPath
	self parse: 	' #slot1 = #slot2 - 1' rule: #termBool! !

!GbtTestELPredicateGrammar methodsFor: 'tests' stamp: 'hk 7/31/2017 18:20'!
testConstraintWithPath0
	self parse: 	' #slot1 = #slot2 - 1' rule: #termBool! !

!GbtTestELPredicateGrammar methodsFor: 'tests' stamp: 'hk 7/31/2017 18:21'!
testConstraintWithPath1
	self parse: 	' #slot0:slotu1 = #slotu2 ' rule: #termBool! !

!GbtTestELPredicateGrammar methodsFor: 'tests' stamp: 'hk 8/25/2017 19:11'!
testConstraintWithPath2
	self parse: 	' #slotu1 = #G:slotu2 ' rule: #termBool! !

!GbtTestELPredicateGrammar methodsFor: 'tests' stamp: 'hk 8/25/2017 19:11'!
testConstraintWithPathE
	self parse: 	' #slot0:slotu1 = #G:slot0 ' rule: #termBool! !

!GbtTestELPredicateGrammar methodsFor: 'tests' stamp: 'hk 7/31/2017 18:21'!
testPredicateSmartPath
	self parse: 	' #Thing:slot = 4711 ' rule: #termBool! !

PPCompositeParserTest subclass: #GbtTestELRefGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

GbtTestELRefGrammar subclass: #GbtTestELRefCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

!GbtTestELRefCompiler methodsFor: 'accessing' stamp: 'hk 9/17/2017 14:57'!
parserClass 
	^ GbtSELRefCompiler! !

!GbtTestELRefCompiler methodsFor: 'running' stamp: 'hk 8/16/2017 12:25'!
setUp
	self tearDown. 
	super setUp! !

!GbtTestELRefCompiler methodsFor: 'running' stamp: 'hk 1/5/2018 16:38'!
tearDown
	GbtServer initialize. 
	super tearDown! !

!GbtTestELRefCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 12:01'!
testPath0E
	self should: [self parse: '#abc:def ' ] raise: GbtPContainerError ! !

!GbtTestELRefCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testfunctionSmartPath2
	| sub th |
	sub := GbtSmartNode struct: 'SUB' define: { 
		{ #def . #no: . 7 }}.
	th := GbtSmartNode struct: 'THE' define: { 
		{ #abc . #thing: . sub }}.
	parser container: th.
	super testfunctionSmartPath2.
	self assert: result equals: 7! !

!GbtTestELRefGrammar methodsFor: 'accessing' stamp: 'hk 10/11/2017 12:43'!
parserClass 
	^ GbtSELGrammar! !

!GbtTestELRefGrammar methodsFor: 'tests' stamp: 'hk 8/16/2017 12:01'!
testPath0
	self parse: 	'#abc:def ' ! !

!GbtTestELRefGrammar methodsFor: 'tests' stamp: 'hk 8/16/2017 15:47'!
testfunctionSmartPath2
	self parse: 	' #abc:def ' ! !

PPCompositeParserTest subclass: #GbtTestELStringGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

GbtTestELStringGrammar subclass: #GbtTestELStringCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

!GbtTestELStringCompiler methodsFor: 'as yet unclassified' stamp: 'hk 9/17/2017 14:57'!
parserClass 
	^ GbtSELStringCompiler! !

!GbtTestELStringCompiler methodsFor: 'tests' stamp: 'hk 7/29/2017 18:02'!
testTerm2
	super testTerm2.
	self assert: result equals: '7'
! !

!GbtTestELStringCompiler methodsFor: 'tests' stamp: 'hk 7/29/2017 18:02'!
testTerm3
	super testTerm3.
	self assert: result equals: 'abc'
! !

!GbtTestELStringCompiler methodsFor: 'tests' stamp: 'hk 7/29/2017 18:02'!
testTerm4
	super testTerm4.
	self assert: result equals: 'abc'
! !

!GbtTestELStringCompiler methodsFor: 'tests' stamp: 'hk 8/16/2017 17:21'!
testfunctionResolve
	|  th |
	th := GbtSmartNode struct: 'THE' define: { 
		{ #abc . #no:tag: . 7 . #sum} .
		{ #def . #no:tag: . 3 . #sum } } .

	parser container: th.
	super testfunctionResolve.
	self assert: result equals: 'ein Text mit 7 '! !

!GbtTestELStringGrammar methodsFor: 'as yet unclassified' stamp: 'hk 10/11/2017 12:43'!
parserClass 
	^ GbtSELGrammar! !

!GbtTestELStringGrammar methodsFor: 'tests' stamp: 'hk 7/30/2017 14:39'!
testTerm2
	self parse: 	' ''7'' ' rule: #termString.! !

!GbtTestELStringGrammar methodsFor: 'tests' stamp: 'hk 7/30/2017 14:39'!
testTerm3
	self parse: 	' abc '  rule: #termString.! !

!GbtTestELStringGrammar methodsFor: 'tests' stamp: 'hk 7/30/2017 14:40'!
testTerm4
	self parse: 	' ''abc'' '  rule: #termString.! !

!GbtTestELStringGrammar methodsFor: 'tests' stamp: 'hk 8/16/2017 16:36'!
testfunctionResolve
	self parse: 	' resolve (ein Text mit #sum)' ! !

PPCompositeParserTest subclass: #GbtTestGbtGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

GbtTestGbtGrammar subclass: #GbtTestGbtCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

!GbtTestGbtCompiler methodsFor: 'accessing' stamp: 'hk 4/23/2017 13:32'!
parserClass 
	^ GbtCompiler! !

!GbtTestGbtCompiler methodsFor: 'as yet unclassified' stamp: 'hk 1/13/2018 16:24'!
setUp
	self tearDown. 
	super setUp! !

!GbtTestGbtCompiler methodsFor: 'as yet unclassified' stamp: 'hk 1/13/2018 16:24'!
tearDown
	GbtServer initialize. 
	super tearDown! !

!GbtTestGbtCompiler methodsFor: 'tests' stamp: 'hk 1/13/2018 15:05'!
test2Contexts
	super test2Contexts .
	self assert: result third size equals: 2.
	self assert: result third first thingTemplates size equals: 1! !

!GbtTestGbtCompiler methodsFor: 'tests' stamp: 'hk 6/7/2017 12:49'!
test2Things
	super test2Things .
	self assert: result first size equals: 2! !

!GbtTestGbtCompiler methodsFor: 'tests' stamp: 'hk 1/13/2018 15:14'!
testContextBehavior
	GbtServer initialize. 
	super testContextBehavior .
	self assert: result third size equals: 1.  	"the context"
	self assert: result third first behaviors size equals: 2.  
	self assert: (result third first behaviors at: #doit) class equals: GbtCielBehavior.  
	self assert: (result third first expandHooks at: #slot) equals: #expand.  ! !

!GbtTestGbtCompiler methodsFor: 'tests' stamp: 'hk 1/13/2018 15:17'!
testContextBehaviorAlt
	| ctxt |
	GbtServer initialize. 
	self parse: 
	' plain MyCtxt  { 
		menu 	: 	doit
		behaviors : doit
		} 
	behavior doit { 
		doit : some action
 		}'.
	ctxt := result third first.
	self assert: result third size equals: 1.  
	self assert: ctxt behaviors size equals: 1.  
	self assert: (ctxt behaviors at: #doit) class equals: GbtCielBehavior.  ! !

!GbtTestGbtCompiler methodsFor: 'tests' stamp: 'hk 1/13/2018 15:05'!
testContextHierarchy
	super testContextHierarchy .
	self assert: result third size equals: 3.  
	self should: [result third first subcontext subcontexts first = result third third ]! !

!GbtTestGbtCompiler methodsFor: 'tests' stamp: 'hk 1/13/2018 15:06'!
testContextWithThings
	super testContextWithThings .
	self assert: result first size equals: 3.  
	self assert: result third size equals: 2.  
	self should: [result third first thingTemplates first isThing ].
	self should: [result third first subcontext thingTemplates first isThing].
	self should: [result third first subcontext poolThings first isThing].
! !

!GbtTestGbtCompiler methodsFor: 'tests' stamp: 'hk 10/19/2017 13:04'!
testFullThingHierarchy
	super testFullThingHierarchy .
	self assert: result first size equals: 3.  
	self should: [ result first second thing2 thing3 = result first third ]! !

!GbtTestGbtCompiler methodsFor: 'tests' stamp: 'hk 6/7/2017 14:27'!
testThingHierarchy
	super testThingHierarchy .
	self assert: result first size equals: 3.  
	self should: [ result first second thing2 thing3 = result first third ]! !

!GbtTestGbtGrammar methodsFor: 'accessing' stamp: 'hk 4/23/2017 13:32'!
parserClass 
	^ GbtGrammar! !

!GbtTestGbtGrammar methodsFor: 'tests' stamp: 'hk 1/5/2018 16:38'!
test2Contexts
	GbtServer initialize. 
	self parse: 
	'
	primeList LCtxt1 of Thing1 {subcontext:  PCtxt1}	
	plain PCtxt2  { subcontexts: PCtxt3}	
	'! !

!GbtTestGbtGrammar methodsFor: 'tests' stamp: 'hk 1/5/2018 16:38'!
test2Things
	GbtServer initialize.
	self parse:
	'
	thing myThing1 { }	
	thing myThing2 { }	
	'! !

!GbtTestGbtGrammar methodsFor: 'tests' stamp: 'hk 1/13/2018 15:12'!
testContextBehavior
	self parse: 
	'
	plain MyCtxt  { 
		menu 			: 	doit
		behaviors 	: doit expand
		onExpand 		: slot expand
	}
	behavior doit { 
		doit : some action
 	}
	behavior expand { 
		expand : some action
 	}
	
	'! !

!GbtTestGbtGrammar methodsFor: 'tests' stamp: 'hk 1/13/2018 16:23'!
testContextHierarchy
	GbtServer initialize. 
	self parse: 
	'
	primeList LCtxt11 of Thing1 { subcontext :  PCtxt11	}	
	plain PCtxt11  { subcontexts : PCtxt12 }	
	plain PCtxt12  {  }
	'! !

!GbtTestGbtGrammar methodsFor: 'tests' stamp: 'hk 1/13/2018 16:25'!
testContextWithThings
	GbtServer initialize.
	self parse:
	'
	thing myThing1 { }	
	thing myThing2 { }	
	thing myThing3 { }	
		
	primeList LCtxt21 of myThing1 {subcontext:  PCtxt21}	
	plain PCtxt21  { 
		templates: myThing2 
		poolThings : myThing3
		}	

	'! !

!GbtTestGbtGrammar methodsFor: 'tests' stamp: 'hk 1/5/2018 16:38'!
testFullThingHierarchy
	GbtServer initialize. 
	self parse: 
	'
	thing myThing2 { node thing3 : myThing3 }	
	thing myThing1 { node thing2 : myThing2 }	
	thing myThing3 { }	
	'! !

!GbtTestGbtGrammar methodsFor: 'tests' stamp: 'hk 1/5/2018 16:39'!
testThingHierarchy
	GbtServer initialize. 
	self parse: 
	'
	thing myThing2 { *node thing3 : myThing3 }	
	thing myThing1 { *node thing2 : myThing2 }	
	thing myThing3 { }	
	'! !

PPCompositeParserTest subclass: #GbtTestListContextGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

GbtTestListContextGrammar subclass: #GbtTestListContextCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

!GbtTestListContextCompiler methodsFor: 'accessing' stamp: 'hk 5/30/2017 19:45'!
parserClass 
	^ GbtListContextCompiler ! !

!GbtTestListContextCompiler methodsFor: 'running' stamp: 'hk 5/29/2017 14:00'!
setUp
	self tearDown. 
	super setUp
! !

!GbtTestListContextCompiler methodsFor: 'running' stamp: 'hk 1/5/2018 16:39'!
tearDown
	GbtServer initialize. 
	super tearDown! !

!GbtTestListContextCompiler methodsFor: 'tests' stamp: 'hk 5/28/2017 13:32'!
testListColumns
	super testListColumns.
	self assert: result value first equals: #display: . 	
	self should: [result value second = 	#( bla1 #(bla2 bla3 ) bla4 ) ].! !

!GbtTestListContextCompiler methodsFor: 'tests' stamp: 'hk 5/28/2017 13:28'!
testListPrefix
	super testListPrefix.
	self assert: result value first equals: #noPolicyPrefix: . 	
	self assert: result value second equals:	'12bla3' ! !

!GbtTestListContextCompiler methodsFor: 'tests' stamp: 'hk 5/28/2017 13:37'!
testLoadPolicy
	super testLoadPolicy.
	self assert: result value first equals: #loadPolicy: . 	
	self assert: result value second equals:	'autoload' ! !

!GbtTestListContextCompiler methodsFor: 'tests' stamp: 'hk 6/7/2017 10:51'!
testPrimeListContext
	super testPrimeListContext.
	self should: [result value isPrimeListAc]. 	
	self assert: result value template svoName equals:	'ListTemplate'.
	self assert: result value menus first key equals:	'AName'.
 	self assert: result value uiSpec equals: 'CName'.
	self assert: result value subcontext svoName equals: 'DName'.	
	self assert: result value displayName equals: 'EName'.
	self assert: result value uiKey equals: 'BName'.
	self should: [result value displayColumns = #(bla1 #(bla2 bla3 ) bla4) ].
	self should: [(result value bizApp contextNoPolicyOf: result value svoName) prefix = '12bla3'].
! !

!GbtTestListContextCompiler methodsFor: 'tests' stamp: 'hk 11/30/2017 15:33'!
testPrimeListContext2
	super testPrimeListContext2.
	self should: [result value isPrimeListAc]. 	
	self assert: result value thingTemplates first svoName equals: #ListTemplate1 .
	self assert: result value thingTemplates second svoName equals: #ListTemplate2 .
! !

!GbtTestListContextGrammar methodsFor: 'accessing' stamp: 'hk 5/30/2017 17:51'!
parserClass 
	^ GbtListContextGrammar! !

!GbtTestListContextGrammar methodsFor: 'tests' stamp: 'hk 5/28/2017 13:29'!
testListColumns
	self parse: 	'listColumns 	: 	bla1 (bla2 bla3 ) bla4 ' rule: #listColumns! !

!GbtTestListContextGrammar methodsFor: 'tests' stamp: 'hk 5/28/2017 13:27'!
testListPrefix
	self parse: 	'listPrefix 	: 	12bla3 ' rule: #listPrefix! !

!GbtTestListContextGrammar methodsFor: 'tests' stamp: 'hk 5/28/2017 13:36'!
testLoadPolicy
	self fail: 	'loadPolicy 	: 	autobla ' rule: #loadPolicy.
	self parse: 	'loadPolicy 	: 	autoload ' rule: #loadPolicy! !

!GbtTestListContextGrammar methodsFor: 'tests' stamp: 'hk 5/29/2017 14:41'!
testPrimeListContext
	self parse: 	'primeList MyBigList of ListTemplate
					{ menu 		: 	AName 
					icon 			: 	BName 
					uiSpec 		: 	CName 
					subcontext 	: 	DName 
					displayAs 	: 	EName 
					loadPolicy 	: 	autoload 
					listColumns 	: 	bla1 (bla2 bla3 ) bla4 
					listPrefix 	: 	12bla3 
							} ' ! !

!GbtTestListContextGrammar methodsFor: 'tests' stamp: 'hk 5/29/2017 17:05'!
testPrimeListContext2
	self parse: 	'primeList MyBigList of ListTemplate1 ListTemplate2
					{ 	} ' ! !

PPCompositeParserTest subclass: #GbtTestPlainContextGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

GbtTestPlainContextGrammar subclass: #GbtTestPlainContextCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

!GbtTestPlainContextCompiler methodsFor: 'accessing' stamp: 'hk 5/30/2017 19:46'!
parserClass 
	^ GbtPlainContextCompiler! !

!GbtTestPlainContextCompiler methodsFor: 'running' stamp: 'hk 5/30/2017 19:43'!
setUp
	self tearDown. 
	super setUp
! !

!GbtTestPlainContextCompiler methodsFor: 'running' stamp: 'hk 1/5/2018 16:39'!
tearDown
	GbtServer initialize. 
	super tearDown! !

!GbtTestPlainContextCompiler methodsFor: 'tests' stamp: 'hk 6/2/2017 16:27'!
testMainContext
	super testMainContext.
	self assert: result value svoName equals: 'BuddyWallet' . 	
	self should: [result value isActiveContext] .	
	self should: [result value isListAc not] .	
	self assert: result value extent equals: (800@600) .
	self assert: result value subcontexts size equals: 3.
	self assert: result value subcontexts first svoName equals: 'MyAccounts'! !

!GbtTestPlainContextCompiler methodsFor: 'tests' stamp: 'hk 11/30/2017 15:33'!
testPlainContext
	super testPlainContext.
	self assert: result value svoName equals: 'BuddyWallet' . 	
	self should: [result value isActiveContext] .	
	self should: [result value isListAc not] .	
	self assert: result value extent equals: (800@600) .
	self assert: result value subcontexts size equals: 3.
	self assert: result value subcontexts first svoName equals: 'MyAccounts'.
	self assert: result value uiSpec equals: 'GbtMainUI'.
	self assert: result value uiKey equals: 'walletBig'.
	self assert: result value poolThings size equals: 2.
	self assert: result value legalText  equals: 'legal'.
	self assert: result value thingTemplates second svoName equals: 'Bname'.
! !

!GbtTestPlainContextCompiler methodsFor: 'tests' stamp: 'hk 6/2/2017 14:43'!
testlegalText
	super testlegalText.
	self assert: result value first equals: #legalText: . 	
	self assert: result value second equals: 'some text' .! !

!GbtTestPlainContextCompiler methodsFor: 'tests' stamp: 'hk 11/6/2017 18:25'!
testsubcontexts
	super testsubcontexts.
	self assert: result value first equals: #subcontexts: . 	
	self assert: result value second first svoName equals: 'ACa' .
	self assert: result value second second svoName equals: 'ACb' .
	self assert: result value second third svoName equals: 'ACc' .
! !

!GbtTestPlainContextGrammar methodsFor: 'accessing' stamp: 'hk 5/30/2017 19:42'!
parserClass 
	^ GbtPlainContextGrammar! !

!GbtTestPlainContextGrammar methodsFor: 'tests' stamp: 'hk 6/2/2017 16:26'!
testMainContext
	self parse: 	
	' plain  BuddyWallet 	
			{ subcontexts 	: 	MyAccounts Buddies Tranfers
			windowSize 		: 	800 @ 600
		 	}'! !

!GbtTestPlainContextGrammar methodsFor: 'tests' stamp: 'hk 1/25/2018 19:35'!
testPlainContext
	self
		parse:
			' main  BuddyWallet 	
			{ subcontexts 	: 	MyAccounts Buddies Tranfers
			uiSpec 			: 	GbtMainUI
			icon 				: 	walletBig
			windowSize 		: 	800 @ 600
			poolThings 		: 	Athing Bthing		
			templates 		: 	AName Bname
			legalText 		: 	''legal''
			behaviors 		:  doit userName % comment
			menu 				: 	doit
			onCreate 			:  userName
		 	}'! !

!GbtTestPlainContextGrammar methodsFor: 'tests' stamp: 'hk 7/21/2017 14:46'!
testlegalText
	self parse: 	'legalText 	: 	some text ' rule: #legalText.
	self parse: 	'legalText 	: 	''some text'' ' rule: #legalText! !

!GbtTestPlainContextGrammar methodsFor: 'tests' stamp: 'hk 11/6/2017 18:24'!
testsubcontexts
	self parse: 	'subcontexts 	: 	ACa ACb ACc ' rule: #subcontexts! !

PPCompositeParserTest subclass: #GbtTestThingGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

GbtTestThingGrammar subclass: #GbtTestThingCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Tests-Parser'!

!GbtTestThingCompiler methodsFor: 'accessing' stamp: 'hk 4/17/2017 20:25'!
parserClass 
	^ GbtThingCompiler! !

!GbtTestThingCompiler methodsFor: 'running' stamp: 'hk 4/25/2017 14:12'!
setUp
	self tearDown. 
	super setUp
! !

!GbtTestThingCompiler methodsFor: 'running' stamp: 'hk 1/5/2018 16:39'!
tearDown
	GbtServer initialize. 
	super tearDown
! !

!GbtTestThingCompiler methodsFor: 'tests' stamp: 'hk 4/22/2017 14:18'!
testParseCalc
	super testParseCalc.
	self assert: result value inputValue equals: '5 * 7'! !

!GbtTestThingCompiler methodsFor: 'tests' stamp: 'hk 8/2/2017 13:09'!
testParseConstraintSlot
	super testParseConstraintSlot.
	self assert: result value inputValue equals: 'aConstraint' .
	self assert: result value violationString equals: 'abc def'.
	self assert: result tags size equals: 2.! !

!GbtTestThingCompiler methodsFor: 'tests' stamp: 'hk 8/1/2017 17:21'!
testParseDate
	super testParseDate.
	self assert: result value inputValue equals: '11 Feb 2000'! !

!GbtTestThingCompiler methodsFor: 'tests' stamp: 'hk 4/23/2017 12:12'!
testParseEmptyThing
	super testParseEmptyThing ! !

!GbtTestThingCompiler methodsFor: 'tests' stamp: 'hk 12/29/2017 18:55'!
testParseListSlot
	super testParseListSlot.
	self assert: result value templates asArray equals: #(abc def).
	self assert: result isProtected.
	self assert: result value displayColumns equals: #(abc #(def ghi) kjl) .! !

!GbtTestThingCompiler methodsFor: 'tests' stamp: 'hk 8/21/2017 16:55'!
testParseNoSlot
	super testParseNoSlot.
	self assert: result value val equals: -34.23.
	self assert: result tags size equals: 2.
	self assert: result purposes size equals: 2 ! !

!GbtTestThingCompiler methodsFor: 'tests' stamp: 'hk 4/25/2017 13:56'!
testParseNode
	super testParseNode.
	self assert: result value svoName equals: #aThingName! !

!GbtTestThingCompiler methodsFor: 'tests' stamp: 'hk 11/30/2017 15:13'!
testParseStandardSlot
	super testParseStandardSlot .
	self assert: result value val equals: #abcdef .
	self assert: result tags size equals: 2.
	self assert: result isProtected.
	self assert: result purposes equals: {#aaa} .
	self assert: result value uiClass name equals: #GbtWidget .
	self should: [result value templates includes: #abc] .
	self should: [result value templates includes: 'de fg'] .
	
! !

!GbtTestThingCompiler methodsFor: 'tests' stamp: 'hk 4/22/2017 14:52'!
testParseText
	super testParseText.
	self assert: result value val equals: 'a lazy brown fox'! !

!GbtTestThingCompiler methodsFor: 'tests' stamp: 'hk 11/27/2017 21:14'!
testParseThing
	super testParseThing .
	self assert: result slots size equals: 1.
	self assert: result fullThing slots size equals: 3.
	self assert: result summary equals: 'some text'.
	self assert: result purposes first equals: #abc.
	self assert: result idNumberPolicy equals: #MyPolicy.
	self assert: result uiClassName equals: #GbtThingDiEditor.

! !

!GbtTestThingCompiler methodsFor: 'tests' stamp: 'hk 11/27/2017 21:14'!
testParseThingWithComment
	super testParseThingWithComment .
	self assert: result slots size equals: 1.
	self assert: result fullThing slots size equals: 3.
	self assert: result summary equals: 'some text'.
	self assert: result purposes first equals: #abc.
	self assert: result idNumberPolicy equals: #MyPolicy.
	self assert: result uiClassName equals: #GbtThingDiEditor.

! !

!GbtTestThingCompiler methodsFor: 'tests' stamp: 'hk 12/1/2017 07:42'!
testParseVal
	super testParseVal.
	self assert: result value inputValue  equals: #abc.
	self should: [result value list includes: 'def ghi' ]! !

!GbtTestThingGrammar methodsFor: 'accessing' stamp: 'hk 4/17/2017 20:25'!
parserClass 
	^ GbtThingGrammar! !

!GbtTestThingGrammar methodsFor: 'tests' stamp: 'hk 9/14/2017 13:37'!
testParseAllSlots
	 self parse: 	'
			{
			val myValue1 	: 	abcdef  
	  		val myValue2 	: 	 
	  		*val myValue3 	: 	abcdef 
			node myValue4 	: 	aThingName
			}	' rule: #allSlots! !

!GbtTestThingGrammar methodsFor: 'tests' stamp: 'hk 8/21/2017 18:41'!
testParseCalc
	self parse: 	'no  myValue 	: 	5 * 7' rule: #no.
	self parse: 	'no  myValue 	: 	''5 * 7''' rule: #no.
! !

!GbtTestThingGrammar methodsFor: 'tests' stamp: 'hk 7/21/2017 14:35'!
testParseConstraintSlot
	self parse: 'constraint myValue 	: aConstraint {ifViolated: ''abc def''}' rule: #constraintSlot.
	self parse: 'constraint myValue 	: aConstraint {tags: abc def}' rule: #constraintSlot.
	self parse: 'constraint myValue 	: aConstraint {ifViolated: abc def, tags: abc def}' rule: #constraintSlot.
! !

!GbtTestThingGrammar methodsFor: 'tests' stamp: 'hk 12/1/2017 10:34'!
testParseDate
	self parse: 	'date myValue 	: 	''11 Feb 2000'' ' rule: #date.
	self parse: 	'date myValue 	: 	date(today) | 11 Feb 2000 ' rule: #date.
	self parse: 	'date myValue 	: 	11 Feb 2000 ' rule: #date.
! !

!GbtTestThingGrammar methodsFor: 'tests' stamp: 'hk 4/23/2017 12:12'!
testParseEmptyThing
	 self parse: 	'
		thing myThing
			{
			}	'! !

!GbtTestThingGrammar methodsFor: 'tests' stamp: 'hk 9/14/2017 12:24'!
testParseListSlot
	self parse: 	'list myValue 	: 	abc def { display: abc (def ghi) kjl , protected: true } ' rule: #listSlot.
! !

!GbtTestThingGrammar methodsFor: 'tests' stamp: 'hk 8/24/2017 18:55'!
testParseNoSlot
	self parse: 	'no myValue 	: 	-34.23 {tags: abc def, purposes: red blue} ' rule: #standardSlot.
! !

!GbtTestThingGrammar methodsFor: 'tests' stamp: 'hk 9/14/2017 13:37'!
testParseNode
	self parse: 	'node myValue 	: 	aThingName' rule: #node.
! !

!GbtTestThingGrammar methodsFor: 'tests' stamp: 'hk 5/29/2017 15:52'!
testParseSlot
"standard slot"
	self parse: 	'val myValue 	: 	abcdef ' rule: #slot.
"special slots"
	self parse: 	'list myValue 	: 	abc def ' rule: #slot.
	self parse: 		'no myValue 	: 	-34.23 ' rule: #slot.
	self parse: 'constraint myValue 	: aConstraint  ' rule: #slot.
! !

!GbtTestThingGrammar methodsFor: 'tests' stamp: 'hk 11/28/2017 17:30'!
testParseStandardSlot
	self parse: 'val myValue1 	: 	abcdef {tags: gh0}' rule: #standardSlot.
	self parse: 'no myValue2 	: 	7 + 4  {tags: gh1 jkl nmo}' rule: #standardSlot.
	self parse: 'no myValue2 	: 	''7 + 4''  {tags: gh1 jkl nmo}' rule: #standardSlot.
	self parse: 'val myValue3 	: 	abcdef {tags: gh2 jkl, protected: true}' rule: #standardSlot.
	self parse: 'val myValue4 	: 	abcdef {purposes: bbb aaa, protected: true}' rule: #standardSlot.
	self parse: 'val myValue5 	: 	abcdef {purposes: aaa } ' rule: #standardSlot.
	self parse: 'val myValue6 	: 	abcdef {tags: gh3 jkl, purposes: aaa, protected: true, ui: GbtWidget, templates: abc ''de fg''}' rule: #standardSlot.

! !

!GbtTestThingGrammar methodsFor: 'tests' stamp: 'hk 7/21/2017 14:30'!
testParseText
	self parse: 	'text myValue 	: 	''a lazy brown fox''' rule: #text.
	self parse: 	'text myValue 	: 	a lazy brown fox' rule: #text.
! !

!GbtTestThingGrammar methodsFor: 'tests' stamp: 'hk 9/14/2017 13:37'!
testParseThing
	 self parse: 	'
		thing myThing
			summary 		:  some text
			purposes 		: 	abc
			bizIdPolicy 	: 	MyPolicy
			ui 				: 	GbtThingDiEditor
			{
			val myValue1 	: 	abcdef  
	  		*val myValue2 	: 	abcdef 
			node myVaue3 	: 	aThingName
			}	'! !

!GbtTestThingGrammar methodsFor: 'tests' stamp: 'hk 10/11/2017 10:53'!
testParseThingWithComment
	 self parse: 	'
		thing myThing
			summary 		:  some text			% a comment
			purposes 		: 	abc
						
			bizIdPolicy 	: 	MyPolicy
			ui 				: 	GbtThingDiEditor
			{
			val myValue1 	: 	abcdef  		% a comment
	  		*val myValue2 	: 	abcdef 
					
			node myVaue3 	: 	aThingName
			}	'! !

!GbtTestThingGrammar methodsFor: 'tests' stamp: 'hk 12/1/2017 07:41'!
testParseVal
	self parse: 	'val  myValue 	: 	abcdef ' rule: #val.
	self parse: 	'val  myValue 	: 	' rule: #val.
	self parse: 	'val  myValue 	: 	''5 * 7''' rule: #val.
	self parse: 	'val  myValue 	: 	5 * 7' rule: #val.
	self parse: 	'val  myValue 	: 	abc def ' rule: #val.
	self parse: 	'val  myValue 	: 	abc | def ghi ' rule: #val.
! !

PPCompositeParser subclass: #GbtBasicGrammar
	instanceVariableNames: 'integer identifier listOfIdentifierOrPair number colon identifierPair ident stringQuoted comment comment0 simpleStringUnquoted slotStringUnquoted stringUnquoted gbtSmartPath string slotString simpleString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtBasicGrammar commentStamp: 'hk 1/9/2018 20:27' prior: 0!
The BasicGrammar provides some basic parsers.

    Instance Variables
	colon:					<PPParser>
	comment:				<PPParser>		end line comment (includes newline)
	comment0:				<PPParser> 		starts with %, no newline
	gbtSmartPath0:			<PPParser>
	ident:					<PPParser>
	identifier:				<PPParser>
	identifierPair:			<PPParser>
	integer:					<PPParser>
	listOfIdentifierOrPair:		<PPParser>
	number:					<PPParser>
	simpleStringUnquoted:	<PPParser>		String without '%{}|(),' for slots
	slotStringUnquoted:		<PPParser>		String without '%{}|' for slots
	stringQuoted:			<PPParser>
	stringUnquoted:			<PPParser> 		String without whitespace
	string					<PPParser>		String without whitespace
	slotString 				<PPParser> 		String without '%{}|' for slots
	simpleString				<PPParser>		String without '%{}|(),' for slots!

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 4/29/2017 13:04'!
colon
	^ $: asParser trimBlanks! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 10/11/2017 11:18'!
comment
	
	^comment0, #newline asParser! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 10/11/2017 11:17'!
comment0
	
	^($% asParser, (PPPredicateObjectParser anyExceptAnyOf: {Character lf. Character cr}) star) optional! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 12/1/2017 12:45'!
forbiddenSimpleChars
	"no brackets, no comma for use in attributes"	
	^ '(),', self forbiddenSlotChars ! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 1/9/2018 20:26'!
forbiddenSlotChars
	"no {, }, %, | and ' "
	^{ $% . ${ . $} . $| . Character lf. Character cr} ! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 1/9/2018 17:58'!
gbtSmartPath
	^ (#word asParser star separatedBy: ':' asParser) flatten ==> [:n| n substrings: ':' ]! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 7/12/2017 14:12'!
ident
	^ (#letter asParser, #word asParser star) flatten 
	! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 7/6/2017 14:54'!
identifier
	^ ident trimBlanks
	! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 4/22/2017 19:36'!
identifierPair
	^ ($( asParser token, identifier , identifier, $) asParser token) trimBlanks 
		==> [:n| n reject: [:e| e class = PPToken]]
	! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 8/16/2017 11:35'!
integer
	^ ($- asParser optional, #digit asParser plus) flatten trimBlanks ==> #asNumber! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 7/15/2017 17:13'!
listOfIdentifierOrPair
	^ (identifier / identifierPair) plus 
	! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 8/14/2017 13:33'!
number
	"parse a simple integer or float - no scientific format yet" 
	^ ($- asParser optional , #digit asParser plus , ($. asParser , #digit asParser plus) optional) flatten trimBlanks ==> #asNumber! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 11/7/2017 15:28'!
simpleString 
	^ stringQuoted / simpleStringUnquoted ! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 1/9/2018 17:18'!
simpleStringUnquoted
	"with forbidden chars use stringQuoted"
	^ (PPPredicateObjectParser anyExceptAnyOf: self forbiddenSimpleChars) star flatten trimBlanks ! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 12/1/2017 10:41'!
slotString 
	^ stringQuoted / slotStringUnquoted! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 12/1/2017 10:38'!
slotStringUnquoted
	"with forbidden chars use stringQuoted"
	^ (PPPredicateObjectParser anyExceptAnyOf: self forbiddenSlotChars) star flatten ==> #trim! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 12/1/2017 12:13'!
start
	"needs a start - meaningless"
	^identifier end  ! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 1/9/2018 17:40'!
string 
	^ stringQuoted / stringUnquoted! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 8/14/2017 14:49'!
stringQuoted
	^ ($' asParser, (PPPredicateObjectParser anyExceptAnyOf: {$'}) star flatten, $' asParser) trimBlanks ==> #second! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 1/9/2018 17:39'!
stringUnquoted
	"without whitespace"
	^ (PPPredicateObjectParser anyExceptAnyOf: Character separators) star flatten trimBlanks! !

!GbtBasicGrammar methodsFor: 'parsers' stamp: 'hk 7/11/2017 14:36'!
tag
	^($# asParser, ident) trim ! !

PPCompositeParser subclass: #GbtCielBehGrammar
	instanceVariableNames: 'ident allSlots cielBehavior slot comment slots identifier colon slotString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

GbtCielBehGrammar subclass: #GbtCielBehCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtCielBehCompiler methodsFor: 'parsers' stamp: 'hk 11/16/2017 11:18'!
cielBehavior
	^ super cielBehavior ==> [:n| |slots|
		slots := n third collect: [:m| 
			GbtSlotAssociation key: m first asSymbol value: (GbtBehaviorCell withValue: m third)].		
		GbtCielBehavior new: n second def: slots]! !

!GbtCielBehGrammar class methodsFor: 'accessing' stamp: 'hk 9/29/2017 16:04'!
dependencies
	^ {GbtBasicGrammar}! !

!GbtCielBehGrammar methodsFor: 'parsers' stamp: 'hk 12/1/2017 12:09'!
allSlots
	^ ${ asParser trim, slots, $} asParser trim ==> #second ! !

!GbtCielBehGrammar methodsFor: 'parsers' stamp: 'hk 10/1/2017 14:32'!
cielBehavior
	^ 'behavior' asParser trim, ident, allSlots! !

!GbtCielBehGrammar methodsFor: 'parsers' stamp: 'hk 12/1/2017 12:12'!
colon
^ (self dependencyAt: GbtBasicGrammar) colon! !

!GbtCielBehGrammar methodsFor: 'parsers' stamp: 'hk 12/1/2017 12:09'!
comment
^ (self dependencyAt: GbtBasicGrammar) comment! !

!GbtCielBehGrammar methodsFor: 'parsers' stamp: 'hk 9/29/2017 16:05'!
ident
^ (self dependencyAt: GbtBasicGrammar) ident! !

!GbtCielBehGrammar methodsFor: 'parsers' stamp: 'hk 12/1/2017 12:12'!
identifier
^ (self dependencyAt: GbtBasicGrammar) identifier! !

!GbtCielBehGrammar methodsFor: 'parsers' stamp: 'hk 12/1/2017 12:33'!
slot
	^ identifier , colon, slotString ! !

!GbtCielBehGrammar methodsFor: 'parsers' stamp: 'hk 12/1/2017 12:34'!
slotString
^ (self dependencyAt: GbtBasicGrammar) slotString! !

!GbtCielBehGrammar methodsFor: 'parsers' stamp: 'hk 12/1/2017 12:09'!
slots
	^ (slot trimLeft delimitedBy: comment token) optional 
		==> [:n| n ifNil: [#()] ifNotNil: [ n reject: [:each| each class = PPToken]]] ! !

!GbtCielBehGrammar methodsFor: 'parsers' stamp: 'hk 10/1/2017 13:05'!
start
	^ cielBehavior end! !

PPCompositeParser subclass: #GbtCielGrammar
	instanceVariableNames: 'fctFilter fctTransform fctAskUser ident cielThing cielList fctList fctApply cielVar cielDirective cielContext fctCheckConstraints fctCommit fctSelect cielThingOrContext setExpr getExpr comment gbtSmartPath fctAskCtxt cielThingOrList fctNodeList cielExpression cielListContext cielPlainContext cielBehavior fctAppendBL fctApplyOnList fctFreeze fctContextThing fctContextList fctAppend fctNewContextThing cielNodeList fctDirectInto string fctSystemCall'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtCielGrammar commentStamp: 'hk 1/23/2018 15:14' prior: 0!
i am the grammar of the CIEL language.

CIEL is an expression  language with lazy evaluation.
Calling a CIELBehavior means to evaluate that CIEL cell carrying the behavior name. 
Other CIEL cells are evaluated when needed. Argument cells arg1, arg2, arg3, ... may contain defaults.
args not filled on call contain their defined default. 
Surplus arguments may be used on call to enforce evaluation of cells.
Evaluation of a cell may cause a side effect.
During execution of a CIELBehavior each cell is evaluated only once (thru caching)
!

GbtCielGrammar subclass: #GbtCielCompiler
	instanceVariableNames: 'gbtBehavior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtCielCompiler commentStamp: 'hk 10/2/2017 18:39' prior: 0!
I hold the productions for GbtCielGrammar

    Instance Variables
	gbtBehavior:		<Object>

!

!GbtCielCompiler class methodsFor: 'accessing' stamp: 'hk 9/28/2017 13:59'!
ignoredNames 
	^ super ignoredNames , #(gbtBehavior)! !

!GbtCielCompiler methodsFor: 'helpers' stamp: 'hk 10/16/2017 15:25'!
askCtxt: aCtxt okAction: okBlock cancelAction: cancelBlock
	| dialogWindow |
	dialogWindow := (GbtListUI on: aCtxt) openDialogWithSpec .
	dialogWindow 
		okAction: [okBlock value: dialogWindow model selection];
		cancelAction: cancelBlock;
		title: aCtxt displayName  ;
		centeredRelativeTo: self currentWorld ;
		modalRelativeTo: self currentWorld! !

!GbtCielCompiler methodsFor: 'helpers' stamp: 'hk 1/22/2018 15:02'!
askUser: elements title: aString
	"let the user select from a list of things, projectors, contexts or strings"
	| res |
	(elements size = 1) ifTrue: [^elements first]. 
	res := UIManager default 
		chooseFrom: (elements collect: [:t| t isString ifTrue: [t] ifFalse: [t choiceName]])
		values: elements
		title: aString.
	^res ifNil: [GbtPUserAbortError signal]! !

!GbtCielCompiler methodsFor: 'accessing' stamp: 'hk 9/28/2017 13:53'!
bizApp
	^self context bizApp! !

!GbtCielCompiler methodsFor: 'parsers typing' stamp: 'hk 1/12/2018 13:52'!
cielBehavior
	^super cielBehavior ==> [:n| |res|
		res := n.
		n ifString: [res := gbtBehavior slotAt: n ifAbsent: [GbtCielExistsError signal: n]]. 
		(res isKindOf: GbtCielBehavior) ifFalse: [GbtCielTypeError signal: 'Behavior: ', n asString].
		res]! !

!GbtCielCompiler methodsFor: 'parsers typing' stamp: 'hk 10/2/2017 18:42'!
cielContext
	^super cielContext ==> [:n| |res|
		res := n.
		n ifString: [res := self contextNamed: n].
		res isActiveContext ifFalse: [GbtCielTypeError signal: 'Context: ', n asString].
		res]! !

!GbtCielCompiler methodsFor: 'parsers typing' stamp: 'hk 10/10/2017 19:25'!
cielDirective
	^super cielDirective ==> [:n| |res|
		res := n. 
		n ifString: [res := self slotOrName: n].
		(res isKindOf: GbtDirective) ifFalse: [GbtCielTypeError signal: 'Directive: ', n asString].	
		res]! !

!GbtCielCompiler methodsFor: 'parsers typing' stamp: 'hk 11/22/2017 14:22'!
cielList
	^super cielList ==> [:n| |res|
		res := n.
		n ifString: [res := gbtBehavior slotAt: n ifAbsent: [GbtCielExistsError signal: n]].
		res isCollection ifFalse: [GbtCielTypeError signal: 'List: ', n asString].
		res]! !

!GbtCielCompiler methodsFor: 'parsers typing' stamp: 'hk 11/15/2017 12:58'!
cielListContext
	^super cielListContext ==> [:n| |res|
		res := n.
		n ifString: [res := self contextNamed: n].
		res isListAc ifFalse: [GbtCielTypeError signal: 'ListContext: ', n asString].
		res]! !

!GbtCielCompiler methodsFor: 'parsers typing' stamp: 'hk 11/21/2017 13:08'!
cielNodeList
	^super cielNodeList ==> [:n| |res|
		res := n.
		n ifString: [res := self slotOrName: n].  
		(res isKindOf: GbtNodeList) ifFalse: [GbtCielTypeError signal: 'NodeList: ', n asString].
		res]! !

!GbtCielCompiler methodsFor: 'parsers typing' stamp: 'hk 11/15/2017 13:02'!
cielPlainContext
	^super cielPlainContext ==> [:n| |res|
		res := n.
		n ifString: [res := self contextNamed: n].
		res isPlainAc ifFalse: [GbtCielTypeError signal: 'PlainContext: ', n asString].
		res]! !

!GbtCielCompiler methodsFor: 'parsers typing' stamp: 'hk 11/27/2017 14:27'!
cielThing
	^super cielThing ==> [:n| |res|
		res := n.
		n ifString: [res := self slotOrName: n].  
		(res isKindOf: GbtSmartNode) ifFalse: [GbtCielTypeError signal: 'Thing: ', n asString].
		res]! !

!GbtCielCompiler methodsFor: 'parsers typing' stamp: 'hk 10/4/2017 14:22'!
cielThingOrContext
	^super cielThingOrContext ==> [:n| |res|
		res := n.
		n ifString: [res := self slotOrName: n].  
		((res isKindOf: GbtSmartNode) or: [res isActiveContext]) 
			ifFalse: [GbtCielTypeError signal: 'Thing or Context: ', n asString].
		res]
	

! !

!GbtCielCompiler methodsFor: 'parsers typing' stamp: 'hk 10/19/2017 19:39'!
cielThingOrList
	^super cielThingOrList ==> [:n| |res|
		res := n.
		n ifString: [res := self slotOrName: n].  
		(res isCollection or: [res isKindOf: GbtSmartNode]) ifFalse: [GbtCielTypeError signal: 'ThingOrList: ', n asString].
		res]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 1/12/2018 13:15'!
cielVar
	"slot or pool thing or global context by name or behavior of this context"
	^super cielVar ==> [:n| 
		n isString ifFalse: [GbtCielTypeError signal: 'Name: ', n asString].	
		(self slotOrName: n) ifNil: 
			[self context behaviors at: n ifAbsent: 
				[GbtCielExistsError signal: n]]]! !

!GbtCielCompiler methodsFor: 'accessing' stamp: 'hk 9/28/2017 17:53'!
container: aNewBehavior
	gbtBehavior :=  aNewBehavior ! !

!GbtCielCompiler methodsFor: 'accessing' stamp: 'hk 9/28/2017 13:58'!
context
	^gbtBehavior container ! !

!GbtCielCompiler methodsFor: 'accessing' stamp: 'hk 11/9/2017 14:51'!
contextNamed: aString    
	^(gbtBehavior slotAt: aString ifAbsent: [^self bizApp contextNamed: aString]) value! !

!GbtCielCompiler methodsFor: 'accessing' stamp: 'hk 11/14/2017 19:31'!
contextThingOf: aCtxtOrName
	aCtxtOrName ifString: [^(self contextNamed: aCtxtOrName)  vo].
	(aCtxtOrName isKindOf: GbtPlainAC) ifTrue: [^aCtxtOrName vo].
	GbtCielTypeError signal: 'PlainContext: ', aCtxtOrName asString! !

!GbtCielCompiler methodsFor: 'accessing' stamp: 'hk 9/28/2017 13:54'!
contextThingOfSelf
	^self context vo! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 11/23/2017 08:48'!
fctAppend
	^ super fctAppend ==> [ :arg1 | 
			arg1 fourth isCollection
				ifTrue: [ arg1 third newEntryAll: arg1 fourth ]
				ifFalse: [ arg1 third newEntry: arg1 fourth ].
			arg1 third container "need some better way for triggerg side effects"]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 11/16/2017 15:19'!
fctAppendBL
	^super fctAppendBL ==> [:n| n fourth isCollection 
									ifTrue: [n third newEntryAll: n fourth] 
									ifFalse: [n third newEntry: n fourth]]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 11/15/2017 14:11'!
fctApply
	^super fctApply ==> [:n| n third executeWith: n fourth]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 1/23/2018 13:06'!
fctApplyOnList
	^super fctApplyOnList ==> [:n| 
		n fourth collect: [:arg| n third executeWith: {arg}, (n fifth ifNil: [#()])]]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 10/16/2017 15:30'!
fctAskCtxt
	^super fctAskCtxt ==> [:n| |res|
		self askCtxt: n third okAction: [:x| res := x] cancelAction: [GbtPUserAbortError signal] .
		res ]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 1/13/2018 17:15'!
fctAskUser
	^super fctAskUser ==> [:n| self askUser: n fourth title: n third ]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 11/15/2017 17:33'!
fctCheckConstraints
	^super fctCheckConstraints ==> [:n| |th|
		th := n third.
		(th checkConstraints ifNil: [GbtConstraintError signal: th errorString])
			ifFalse: [GbtConstraintError signal: th violationString].
		th]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 9/29/2017 15:50'!
fctCommit
	^super fctCommit ==> [:n| self context commit: n third . n third]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 11/21/2017 13:58'!
fctContextList
	^super fctContextList ==> [:n|  n second
			ifNil: [self context list] 
			ifNotNil: [n second second list]]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 11/21/2017 13:58'!
fctContextThing
	^super fctContextThing ==> [:n| n second
		ifNil: [self context vo] 
		ifNotNil: [n second second vo]]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 11/24/2017 15:22'!
fctDirectInto
	^super fctDirectInto ==> [:n| n third copy: n fifth onto: n fourth]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 10/10/2017 21:44'!
fctFilter
	^super fctFilter ==> [:n| |constraintThing|
		constraintThing := n fourth.
		(constraintThing isKindOf: GbtSmartNode) ifFalse: [GbtCielTypeError signal: 'Thing: ', constraintThing asString].
		constraintThing filter: n third]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 11/22/2017 18:00'!
fctFreeze
	^super fctFreeze ==> [:n| |res list|
		list := n third isCollection ifTrue: [n third] ifFalse: [{n third}].
		res := list collect: [:e| e copyFreeze].
		n third isCollection ifTrue: [res] ifFalse: [res first]]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 9/28/2017 19:03'!
fctList
	^super fctList ==> #third! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 1/23/2018 14:17'!
fctNewContextThing
	^super fctNewContextThing ==> [:n| n second 
		ifNil: 	[self newEntryFor: self context with: nil] 
		ifNotNil: [self newEntryFor: n second second with: n second third]]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 1/18/2018 17:27'!
fctNodeList
	^super fctNodeList ==> [:n| |res|
		res := GbtNodeList new. 
		n third do: [:e| res newEntry: e copy].
		res ]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 10/10/2017 17:35'!
fctSelect
	^super fctSelect ==> [:n| n third select: [:elem| elem contains: n fourth ]]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 1/11/2018 12:18'!
fctSystemCall
	^super fctSystemCall ==> [:n| Compiler evaluate: n third, (n fourth ifNotNil: [:x|'#',x ] ifNil: [''])]! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 11/24/2017 15:35'!
fctTransform
	^super fctTransform ==> [:n| |res|
		res := n third transform: n fourth withSource: n fifth]! !

!GbtCielCompiler methodsFor: 'accessing' stamp: 'hk 11/30/2017 15:43'!
gbtObjectNamed: aString   
	"try context vo, pool and all contexts. ^nil if not found"

	aString = #contextThing ifTrue: [^self context vo].
	(self context isListAc and: [self context templateNames includes: aString])
		ifTrue: [^self context thingTemplates detect: [:t| t svoName = aString]].
	(self context isListAc not and: [self context vo ifNil: [false] ifNotNil: [:vo| vo svoName = aString]]) 
		ifTrue: [^self context vo].
	^self context poolFrameNamed: aString ifAbsent: 
			[self bizApp contextNamed: aString]
	 ! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 1/25/2018 18:28'!
getExpr
	^super getExpr ==> [:n| |anchor| "thing or context"  
		anchor := (self slotOrName: n first) ifNil: [GbtCielExistsError signal: n first].  
		((anchor isKindOf: GbtFrame) or: [anchor isActiveContext]) 
			ifFalse: [GbtCielTypeError signal: 'Thing or Context: ', n asString].
		anchor atSmartPath: n third]! !

!GbtCielCompiler methodsFor: 'accessing' stamp: 'hk 1/23/2018 14:10'!
newEntryFor: aCtxt with: aThing  
	"make a new contextVO from aThing or the first template of the elder list context"

	| listCtxt |
	listCtxt := aCtxt container.
	listCtxt isListAc ifFalse: [GbtCielTypeError signal: 'ListContext: ', listCtxt asString].
	^aThing ifNil: [listCtxt newEntry] ifNotNil: [listCtxt newEntry: aThing]
	! !

!GbtCielCompiler methodsFor: 'parsers' stamp: 'hk 1/18/2018 19:25'!
setExpr
	^super setExpr ==> [:n| |anchor p s| "for things only"  
		anchor := (self slotOrName: n first) ifNil: [GbtCielExistsError signal: n first].  
		(anchor isKindOf: GbtSmartNode) ifFalse: [GbtCielTypeError signal: 'Thing: ', n first asString].
		p := n third allButLast. 
		s := n third last asSymbol asMutator.
		(anchor atFullPath: p) perform: s with: n fifth .  
		anchor ]! !

!GbtCielCompiler methodsFor: 'accessing' stamp: 'hk 10/4/2017 12:40'!
slotOrName: aString   
	^(gbtBehavior slotSVOAt: aString ifAbsent: 
		[^self gbtObjectNamed: aString]) val
	 ! !

!GbtCielCompiler methodsFor: 'accessing' stamp: 'hk 9/28/2017 13:55'!
txThingAt: aSymbol
	^self context txThingAt: aSymbol! !

!GbtCielGrammar class methodsFor: 'accessing' stamp: 'hk 9/29/2017 16:04'!
dependencies
	^ {GbtBasicGrammar}! !

!GbtCielGrammar class methodsFor: 'accessing' stamp: 'hk 1/23/2018 15:47'!
documentation
	"self documentation"
	| stream parsersTyping parsers |
	(stream := TextStream on: (Text new: 10)) 
		nextPutAll: self name asText allBold; cr; 
		nextPutAll: self comment; cr; cr.
		
	parsersTyping := self selectorsInCategory: 'parsers typing'.	
	stream nextPutAll: 'parsers typing' asText allBold; cr. 
	parsersTyping do: [:p|
		stream nextPutAll: p asText allItalic; cr; 
		nextPutAll: ((self commentsAt: p) at: 1 ifAbsent: ['comment missing']); cr; cr].

	parsers := self selectorsInCategory: 'parsers'.
	stream nextPutAll: 'parsers' asText allBold; cr. 
	parsers do: [:p|
		stream nextPutAll: p asText allItalic; cr; 
		nextPutAll: ((self commentsAt: p) at: 1 ifAbsent: ['comment missing']) ; cr; cr].
	
	^stream contents! !

!GbtCielGrammar methodsFor: 'parsers typing' stamp: 'hk 11/15/2017 13:57'!
cielBehavior
	"for type check"
	^cielExpression! !

!GbtCielGrammar methodsFor: 'parsers typing' stamp: 'hk 11/15/2017 12:43'!
cielContext
	"for type check"
	^cielExpression! !

!GbtCielGrammar methodsFor: 'parsers typing' stamp: 'hk 11/15/2017 12:43'!
cielDirective
	"for type check"
	^cielExpression! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 1/12/2018 13:28'!
cielExpression
	"behavior cell content: a value, thing, list, context, behavior or directive"
	^ (setExpr 
	/ getExpr 
	/ fctContextList 
	/ fctContextThing 
	/ fctNewContextThing 
	/ fctFilter
	/ fctFreeze
	/ fctTransform
	/ fctDirectInto
	/ fctCheckConstraints
	/ fctCommit
	/ fctAskUser
	/ fctAskCtxt
	/ fctSelect
	/ fctApply
	/ fctApplyOnList
	/ fctAppendBL
	/ fctAppend
	/ fctList
	/ fctNodeList
	/ fctSystemCall
	/ cielVar) , comment optional ==> #first! !

!GbtCielGrammar methodsFor: 'parsers typing' stamp: 'hk 11/15/2017 12:43'!
cielList
	"for type check"
	^cielExpression! !

!GbtCielGrammar methodsFor: 'parsers typing' stamp: 'hk 11/15/2017 12:58'!
cielListContext
	"for type check"
	^cielExpression! !

!GbtCielGrammar methodsFor: 'parsers typing' stamp: 'hk 11/21/2017 13:08'!
cielNodeList
	"for type check"
	^cielExpression! !

!GbtCielGrammar methodsFor: 'parsers typing' stamp: 'hk 11/15/2017 12:59'!
cielPlainContext
	"for type check"
	^cielExpression! !

!GbtCielGrammar methodsFor: 'parsers typing' stamp: 'hk 11/15/2017 12:43'!
cielThing
	"for type check"
	^cielExpression! !

!GbtCielGrammar methodsFor: 'parsers typing' stamp: 'hk 11/15/2017 12:43'!
cielThingOrContext
	"for type check"
	^cielExpression! !

!GbtCielGrammar methodsFor: 'parsers typing' stamp: 'hk 11/15/2017 12:43'!
cielThingOrList
	"for type check"
	^cielExpression! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 9/26/2017 12:25'!
cielVar
	"slot or pool content or global context by name"
	^ident trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 10/11/2017 11:18'!
comment
^ (self dependencyAt: GbtBasicGrammar) comment0! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 11/21/2017 13:09'!
fctAppend
	"append the thing or list to a uList"
	^ 'append' asParser trimLeft, $( asParser trimBlanks, cielNodeList,  cielThingOrList trimBlanks, $) asParser trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 11/16/2017 15:20'!
fctAppendBL
	"append the thing or list to the list context"
	^ 'appendBL' asParser trimLeft, $( asParser trimBlanks, cielContext,  cielThingOrList trimBlanks, $) asParser trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 1/11/2018 11:14'!
fctApply
	"call a behavior with all arguments cielExpr"
	^ 'apply' asParser trimLeft, $( asParser trimBlanks, cielBehavior, cielExpression star, $) asParser trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 11/21/2017 17:11'!
fctApplyOnList
	"call a behavior for each element of cielList and eventually further arguments cielThing"
	^ 'applyOnList' asParser trimLeft, $( asParser trimBlanks, cielBehavior, cielList, cielExpression star, $) asParser trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 10/16/2017 15:37'!
fctAskCtxt
	"answer the user selection of a temporary list context"
	
	^ 'askContext' asParser trimLeft, $( asParser trimBlanks, cielContext, $) asParser trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 1/9/2018 17:27'!
fctAskUser
	"answer the user selection of a list"
	^ 'askUser' asParser trimLeft, $( asParser trimBlanks, string, cielList, $) asParser trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 9/26/2017 13:36'!
fctCheckConstraints
	"my production casts an exception when the constraints of cielThing are violated"
	^ 'checkConstraints' asParser trimLeft, $( asParser trimBlanks, cielThing, $) asParser trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 9/29/2017 15:49'!
fctCommit
	"commit all cielThings"
	^ 'commit' asParser trimLeft, $( asParser trimBlanks, (cielThing star), $) asParser trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 11/21/2017 12:10'!
fctContextList
	^'contextList' asParser trimBlanks, 
		($( asParser trimBlanks, cielListContext, $) asParser trimBlanks) optional! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 11/21/2017 13:57'!
fctContextThing
	^ 'contextThing' asParser trimBlanks, 
		($( asParser trimBlanks, cielPlainContext, $) asParser trimBlanks) optional! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 1/23/2018 14:48'!
fctDirectInto
	"transform the cielThing with each of ThingOrList into a new list - projectInto ???"
	^ 'directInto' asParser trimLeft, $( asParser trimBlanks, cielDirective, cielThing, cielThingOrList, $) asParser trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 11/21/2017 13:30'!
fctFilter
	"filter the list with the constraints in cielThing"
	^ 'filter' asParser trimLeft, $( asParser trimBlanks, cielList, cielThing, $) asParser trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 11/16/2017 17:04'!
fctFreeze
	"freeze a thing or list of things"
	^ 'freeze' asParser trimLeft, $( asParser trimBlanks, cielThingOrList, $) asParser trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 11/21/2017 16:49'!
fctList
	"make a list from things"
	^ 'list' asParser trimLeft, $( asParser trimBlanks, cielThing plus, $) asParser trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 1/23/2018 14:13'!
fctNewContextThing
	^'newContextThing' asParser trimBlanks, 
		($( asParser trimBlanks, cielPlainContext, cielThing optional, $) asParser trimBlanks) optional! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 11/11/2017 15:12'!
fctNodeList
	"make a GbtNodeList from copies of a list of things"
	^ 'nodeList' asParser trimLeft, $( asParser trimBlanks, cielList, $) asParser trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 11/10/2017 18:15'!
fctSelect
	"filter the list with the values provided"
	^ 'select' asParser trimLeft, $( asParser trimBlanks, cielList, cielVar star, $) asParser trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 1/11/2018 11:26'!
fctSystemCall
	"evaluate an expression in GbtMachineLanguage - 0 or 1 string argument only"
	^ 'gbt' asParser trimLeft, $( asParser trimBlanks, string, cielVar optional, $) asParser trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 11/24/2017 15:30'!
fctTransform
	"transform the thingOrList with the decl and optional source"
	^ 'transform' asParser trimLeft, $( asParser trimBlanks, cielDirective, cielThingOrList, cielThing star, $) asParser trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 1/9/2018 17:57'!
gbtSmartPath
^ (self dependencyAt: GbtBasicGrammar) gbtSmartPath! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 11/16/2017 15:53'!
getExpr
	"anchor:slot{:slot} no fct for anchor"
	^ (ident, $: asParser, gbtSmartPath) trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 9/18/2017 21:57'!
ident
^ (self dependencyAt: GbtBasicGrammar) ident! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 11/15/2017 12:43'!
setExpr
	"anchor:slot{:slot}: something"
	^ (ident, $: asParser, gbtSmartPath, ':=' asParser trimBlanks, cielExpression) trimBlanks! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 11/15/2017 12:43'!
start
	^cielExpression end! !

!GbtCielGrammar methodsFor: 'parsers' stamp: 'hk 1/9/2018 17:37'!
string
^ (self dependencyAt: GbtBasicGrammar) string! !

PPCompositeParser subclass: #GbtContextGrammar
	instanceVariableNames: 'identifier listOfIdentifierOrPair colon size windowSize poolThings menu behaviors onCreate integer slot comment slots elderSlot displayAs simpleSlot selString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtContextGrammar class methodsFor: 'accessing' stamp: 'hk 10/13/2017 12:08'!
dependencies
	^ {GbtBasicGrammar}! !

!GbtContextGrammar class methodsFor: 'accessing' stamp: 'hk 1/3/2018 15:46'!
ignoredNames 
	^ super ignoredNames , #(appName)! !

!GbtContextGrammar methodsFor: 'parsers' stamp: 'hk 10/13/2017 12:16'!
allSlots
	^ ${ asParser trim, slots, $} asParser trim ==> #second! !

!GbtContextGrammar methodsFor: 'context parsers' stamp: 'hk 1/26/2018 13:01'!
behaviors
	^ 'behaviors' asParser trimLeft, colon, identifier star
			==> [:n| {#behaviors: . n third}]! !

!GbtContextGrammar methodsFor: 'parsers' stamp: 'hk 10/13/2017 12:10'!
colon
^ (self dependencyAt: GbtBasicGrammar) colon! !

!GbtContextGrammar methodsFor: 'context parsers' stamp: 'hk 10/13/2017 12:15'!
comment
^ (self dependencyAt: GbtBasicGrammar) comment! !

!GbtContextGrammar methodsFor: 'context attribute parsers' stamp: 'hk 1/18/2018 13:00'!
displayAs
	^ 'displayAs' asParser trimLeft, colon, selString
	==> [:n| { #displayAs: . n third} ]! !

!GbtContextGrammar methodsFor: 'context attribute parsers' stamp: 'hk 1/26/2018 13:41'!
elderSlot
	^ ('elderSlot' asParser, colon, identifier optional) ==> [:n| { #targetSlotname: . n third}]
! !

!GbtContextGrammar methodsFor: 'context parsers' stamp: 'hk 1/26/2018 14:00'!
expandHook
	^ 'onExpand' asParser trimLeft, colon, (identifier , identifier) optional
			==> [:n| {#expandHook: . n third}]! !

!GbtContextGrammar methodsFor: 'parsers' stamp: 'hk 10/13/2017 12:08'!
identifier
^ (self dependencyAt: GbtBasicGrammar) identifier! !

!GbtContextGrammar methodsFor: 'parsers' stamp: 'hk 10/13/2017 12:13'!
integer
^ (self dependencyAt: GbtBasicGrammar) integer! !

!GbtContextGrammar methodsFor: 'parsers' stamp: 'hk 10/13/2017 12:10'!
listOfIdentifierOrPair
^ (self dependencyAt: GbtBasicGrammar) listOfIdentifierOrPair! !

!GbtContextGrammar methodsFor: 'context attribute parsers' stamp: 'hk 1/26/2018 13:34'!
menu
	^ 'menu' asParser trimLeft, colon, identifier star 
			==> [:n| {#menu: . n third }]! !

!GbtContextGrammar methodsFor: 'context parsers' stamp: 'hk 1/26/2018 13:37'!
onCreate
	^ 'onCreate' asParser trimLeft, colon, identifier star
			==> [:n| {#createBehaviors: . n third}]! !

!GbtContextGrammar methodsFor: 'context attribute parsers' stamp: 'hk 1/26/2018 13:18'!
poolThings
	^ 'poolThings' asParser trimLeft, colon, identifier star trimBlanks 
			==> [:n| { #poolThings:  . n third collect: [:nme| GbtParseMock svoName: nme]} ]
	! !

!GbtContextGrammar methodsFor: 'parsers' stamp: 'hk 1/18/2018 12:57'!
selString
^ (self dependencyAt: GbtBasicGrammar) slotString! !

!GbtContextGrammar methodsFor: 'context attribute parsers' stamp: 'hk 1/26/2018 13:51'!
simpleSlot
	"this parser is for all attributes with one-Symbol value"
	
	^ ('icon' asParser 
		/ 'uiSpec' asParser
		) trimLeft, colon, identifier optional
	==> [:n| {n first asSymbol asMutator . n third} ]! !

!GbtContextGrammar methodsFor: 'context attribute parsers' stamp: 'hk 10/13/2017 12:13'!
size
	^ integer, $@ asParser, integer  ==> [:n| Point x: n first asNumber y: n third asNumber] 
	! !

!GbtContextGrammar methodsFor: 'context attribute parsers' stamp: 'hk 1/18/2018 12:51'!
slot
	^ simpleSlot 
	/ displayAs
	/ windowSize
	/ poolThings
	/ menu
	/ behaviors
	/ onCreate
	/ elderSlot 
! !

!GbtContextGrammar methodsFor: 'parsers' stamp: 'hk 10/13/2017 12:15'!
slots
	^ (slot trimLeft delimitedBy: comment token) optional 
		==> [:n| n ifNil: [#()] ifNotNil: [ n reject: [:each| each class = PPToken]]] ! !

!GbtContextGrammar methodsFor: 'parsers' stamp: 'hk 5/31/2017 18:50'!
start
	"we need a start that does not create o loop"
	^ menu end! !

!GbtContextGrammar methodsFor: 'context attribute parsers' stamp: 'hk 6/2/2017 15:21'!
windowSize
	^ 'windowSize' asParser trimLeft, colon, size 
			==> [:n| { #extent:  . n third} ]! !

GbtContextGrammar subclass: #GbtListContextGrammar
	instanceVariableNames: 'subcontext listPrefix listColumns primeListContext uListContext listContext prefix allSlots loadPolicy aLoadPolicy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

GbtListContextGrammar subclass: #GbtListContextCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtListContextCompiler methodsFor: 'parsers' stamp: 'hk 1/26/2018 14:10'!
listColumns
	^ super listColumns ==> [:n| { #display:  . n third ifNil: [#()]} ]
	! !

!GbtListContextCompiler methodsFor: 'parsers' stamp: 'hk 11/6/2017 17:34'!
listContext
	^ super listContext ==> [:n|  |res|
		res := n first  defineFrom: n fourth.
		n third do: [:nme| res addTemplate: (GbtParseMock svoName: nme)].
		res ]
	! !

!GbtListContextCompiler methodsFor: 'parsers' stamp: 'hk 1/26/2018 14:07'!
listPrefix
	^ super listPrefix ==> [:n| { #noPolicyPrefix:  . n third ifNil: ['']} ]
	! !

!GbtListContextCompiler methodsFor: 'parsers' stamp: 'hk 5/27/2017 15:47'!
loadPolicy
	^ super loadPolicy ==> [:n| { #loadPolicy:  . n third} ]
	! !

!GbtListContextCompiler methodsFor: 'parsers' stamp: 'hk 1/8/2018 14:44'!
primeListContext
	^ super primeListContext ==> [:n| GbtPrimeListAC new: n second define: #()]
	! !

!GbtListContextCompiler methodsFor: 'parsers' stamp: 'hk 11/6/2017 17:33'!
subcontext
	^ super subcontext 
			==> [:n| { #subcontext: . GbtParseMock svoName: n third}]! !

!GbtListContextCompiler methodsFor: 'parsers' stamp: 'hk 1/8/2018 14:45'!
uListContext
	^ super uListContext ==> [:n|  GbtNodeListAC new: n second define: #()]
	! !

!GbtListContextGrammar methodsFor: 'attribute attribute parsers' stamp: 'hk 1/26/2018 14:16'!
aLoadPolicy
	^ ('autoload' asParser / 'simpleload' asParser / 'filterload' asParser) flatten trimBlanks! !

!GbtListContextGrammar methodsFor: 'context attribute parsers' stamp: 'hk 1/26/2018 14:10'!
listColumns
	"hat reichere Struktur: Paare in der Liste"
	^ 'listColumns' asParser trimLeft, colon, listOfIdentifierOrPair optional! !

!GbtListContextGrammar methodsFor: 'context attribute parsers' stamp: 'hk 11/6/2017 16:41'!
listContext
	^ (primeListContext / uListContext),
			'of' asParser, identifier plus,
			allSlots ! !

!GbtListContextGrammar methodsFor: 'context attribute parsers' stamp: 'hk 1/26/2018 14:06'!
listPrefix
	"prefix my have leading digits"
	^ 'listPrefix' asParser, colon, prefix optional! !

!GbtListContextGrammar methodsFor: 'context attribute parsers' stamp: 'hk 1/26/2018 14:18'!
loadPolicy
	^ 'loadPolicy' asParser trimLeft, colon, aLoadPolicy optional! !

!GbtListContextGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 22:02'!
prefix
	^ (#letter asParser / #digit asParser) plus flatten trimBlanks  ! !

!GbtListContextGrammar methodsFor: 'context parsers' stamp: 'hk 11/6/2017 16:41'!
primeListContext
	^ 'primeList' asParser trimLeft, identifier ! !

!GbtListContextGrammar methodsFor: 'parsers' stamp: 'hk 11/8/2017 12:32'!
slot
	^ super slot 
		/ listColumns 
		/ listPrefix 
		/ loadPolicy 
		/ subcontext
! !

!GbtListContextGrammar methodsFor: 'parsers' stamp: 'hk 5/31/2017 18:15'!
start
	^ listContext end ! !

!GbtListContextGrammar methodsFor: 'context attribute parsers' stamp: 'hk 1/26/2018 14:27'!
subcontext
	^ 'subcontext' asParser, colon, identifier
! !

!GbtListContextGrammar methodsFor: 'context parsers' stamp: 'hk 11/6/2017 16:41'!
uListContext
	^ 'uList' asParser trimLeft, identifier ! !

GbtContextGrammar subclass: #GbtPlainContextGrammar
	instanceVariableNames: 'subcontexts legalText plainContext mainContext mainOrPlain allSlots expandHook subject templates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

GbtPlainContextGrammar subclass: #GbtPlainContextCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtPlainContextCompiler methodsFor: 'parsers' stamp: 'hk 5/31/2017 17:20'!
legalText
	^ super legalText ==> [:n| {#legalText: . n third} ]! !

!GbtPlainContextCompiler methodsFor: 'parsers' stamp: 'hk 1/8/2018 14:45'!
mainOrPlain
	^ super mainOrPlain ==> [:n| |res|
		res := GbtPlainAC new: n second define: n fourth.
		n third ifNotNil: [res vo: (GbtParseMock svoName: n third)].
		res]
	
! !

!GbtPlainContextCompiler methodsFor: 'parsers' stamp: 'hk 11/6/2017 17:35'!
subcontexts
	^ super subcontexts ==> [:n| 
			{#subcontexts: . n third collect: [:svoN| GbtParseMock svoName: svoN]}]! !

!GbtPlainContextCompiler methodsFor: 'parsers' stamp: 'hk 11/27/2017 14:53'!
templates
	^super templates ==> [:n| { #templates: . n third collect: [:nme| GbtParseMock svoName: nme]}]! !

!GbtPlainContextGrammar class methodsFor: 'accessing' stamp: 'hk 5/30/2017 19:59'!
ignoredNames 
	^ super ignoredNames , #(listPrefix listColumns primeListContext listContext)! !

!GbtPlainContextGrammar methodsFor: 'context attribute parsers' stamp: 'hk 10/13/2017 12:37'!
legalText
	^ 'legalText' asParser, colon, selString 
	! !

!GbtPlainContextGrammar methodsFor: 'context parsers' stamp: 'hk 11/7/2017 12:30'!
mainContext
	^ 'main' asParser ! !

!GbtPlainContextGrammar methodsFor: 'as yet unclassified' stamp: 'hk 11/7/2017 15:30'!
mainOrPlain
	^ (mainContext / plainContext) trimLeft, identifier, subject optional, allSlots 
! !

!GbtPlainContextGrammar methodsFor: 'context parsers' stamp: 'hk 11/7/2017 12:30'!
plainContext
	^ 'plain' asParser ! !

!GbtPlainContextGrammar methodsFor: 'as yet unclassified' stamp: 'hk 11/27/2017 14:50'!
slot
	^ super slot 
		/ templates
		/ subcontexts
		/ expandHook
		/ legalText
		! !

!GbtPlainContextGrammar methodsFor: 'as yet unclassified' stamp: 'hk 5/31/2017 18:18'!
start
	^ mainOrPlain end ! !

!GbtPlainContextGrammar methodsFor: 'context attribute parsers' stamp: 'hk 1/26/2018 13:56'!
subcontexts
	^ 'subcontexts' asParser, colon, identifier star! !

!GbtPlainContextGrammar methodsFor: 'context parsers' stamp: 'hk 11/27/2017 14:46'!
subject
	"the contextVO"
	^ 'on' asParser trimLeft, identifier ==> #second! !

!GbtPlainContextGrammar methodsFor: 'context attribute parsers' stamp: 'hk 1/26/2018 13:55'!
templates
	^ 'templates' asParser trimLeft, colon, identifier star trimBlanks ! !

PPCompositeParser subclass: #GbtGrammar
	instanceVariableNames: 'gbt allThings allContexts allDirectives thing directive listContext mainOrPlain cielBehavior appName contextWithBehaviors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

GbtGrammar subclass: #GbtCompiler
	instanceVariableNames: 'things contexts directives'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtCompiler commentStamp: 'hk 1/13/2018 14:41' prior: 0!
Instance Variables
	things:			<Collection> 		Cache of all compiled things
	contexts:		<Dictionary> 		Cache of all compiled svoName -> (context -> behaviors) 	directives:		<Collection> 		Cache of all compiled directives
	behaviors:		<Collection> 		Cache of all compiled behaviors

!

!GbtCompiler methodsFor: 'as yet unclassified' stamp: 'hk 1/13/2018 16:40'!
addCtxt: aCtxt
	self ensureContexts.
	contexts at: aCtxt svoName put: (aCtxt -> aCtxt behaviors)
	! !

!GbtCompiler methodsFor: 'parsers' stamp: 'hk 1/13/2018 15:38'!
allContexts
	^super allContexts ==>  [:n| n do: [:e| e isPetitFailure ifTrue: [ e inspect ]. self updateContext: e] . n ]
	! !

!GbtCompiler methodsFor: 'parsers' stamp: 'hk 10/3/2017 19:29'!
allDirectives
	^super allDirectives ==>  [:n| n do: [:e| e isPetitFailure ifTrue: [ e inspect ]. self updateDirective: e] . n ]
	! !

!GbtCompiler methodsFor: 'parsers' stamp: 'hk 10/17/2017 22:30'!
allThings
	^super allThings ==>  [:n| n do: [:e| e isPetitFailure ifTrue: [e inspect]. self updateThing: e] . n ]
	! !

!GbtCompiler methodsFor: 'accessing' stamp: 'hk 1/12/2018 17:58'!
behaviorsOf: anACname
	^(contexts at: anACname) value asOrderedCollection! !

!GbtCompiler methodsFor: 'parsers' stamp: 'hk 1/13/2018 14:38'!
contextWithBehaviors
	^super contextWithBehaviors ==> [:n| n second do: [:beh| n first replaceBehavior: beh]. n first ]
! !

!GbtCompiler methodsFor: 'accessing' stamp: 'hk 1/12/2018 17:57'!
contexts
	self ensureContexts.
	^(contexts values collect: #key) asOrderedCollection ! !

!GbtCompiler methodsFor: 'compiler cache' stamp: 'hk 9/24/2017 15:38'!
declNamed: aSvoName
	^self directives detect: [:d | d svoName = aSvoName ]! !

!GbtCompiler methodsFor: 'accessing' stamp: 'hk 9/24/2017 15:53'!
directives
	^directives ifNil: [directives := GbtServer default allDirectives]! !

!GbtCompiler methodsFor: 'accessing' stamp: 'hk 1/12/2018 17:56'!
ensureContexts
	contexts ifNil: 
		[contexts := Dictionary new.
		GbtServer default allContexts do: 
			[:ctxt| contexts add: ctxt svoName -> (ctxt -> ctxt behaviors asOrderedCollection)]]! !

!GbtCompiler methodsFor: 'parsers' stamp: 'hk 1/13/2018 14:18'!
gbt
	^super gbt ==> [:n| 
		n third do: [:ctxt | self replaceAllIn: ctxt].
		n]! !

!GbtCompiler methodsFor: 'accessing' stamp: 'hk 1/13/2018 16:03'!
remove: aGBTObject orMockFrom: aColl
	aColl removeAllSuchThat: [:e| e svoName = aGBTObject svoName]! !

!GbtCompiler methodsFor: 'accessing' stamp: 'hk 1/13/2018 16:39'!
removeCtxtOrMock: aCoM
	self ensureContexts.
	contexts removeKey: aCoM svoName ifAbsent: []
	! !

!GbtCompiler methodsFor: 'accessing' stamp: 'hk 1/13/2018 16:33'!
removeDirOrMock: aDoM 
	self directives removeAllSuchThat: [:e| e svoName = aDoM svoName]! !

!GbtCompiler methodsFor: 'accessing' stamp: 'hk 1/13/2018 16:33'!
removeThingOrMock: aToM 
	self things removeAllSuchThat: [:e| e svoName = aToM svoName]! !

!GbtCompiler methodsFor: 'compiler cache' stamp: 'hk 1/13/2018 14:25'!
replaceAllIn: aCtxt
	self things do: [:th| aCtxt replaceThing: th].
	self directives do: [:dir| aCtxt replaceDirective: dir]! !

!GbtCompiler methodsFor: 'compiler cache' stamp: 'hk 11/9/2017 09:39'!
replaceDirTagsOf: aDecl with: newDecl
	aDecl slots do: [:sa| 
		((sa isKindOf: GbtParseMock) and: [sa value svoName = newDecl svoName] ) 
			ifTrue: [sa value: (newDecl copy container: aDecl)]].
	aDecl declSlots do: [:sn| self replaceDirTagsOf: sn with: newDecl].
! !

!GbtCompiler methodsFor: 'thing cache' stamp: 'hk 11/9/2017 11:59'!
replaceNodesOf: aThing with: aNode
	"replace parseMocks as well as previously compiled smart and full nodes.
	ananymous Ulists are not replaced "
	| fNode fThing | 
	fNode := aNode fullThing.
	fThing := aThing fullThing.
	fThing slotNames do: [:sn| |slotSVO fslotSVO|
		slotSVO := aThing slotSVOAt: sn.  
		(((slotSVO isNotNil and: [slotSVO isNodeList not])and: [slotSVO svoName = aNode svoName]) and: [slotSVO ~= aNode]) 
			ifTrue: [aThing slotSVOAt: sn put: aNode copy]. "replace smart side mock node "
		fslotSVO := fThing slotSVOAt: sn.  
		(fslotSVO isParseMock and: [fslotSVO svoName = aNode svoName])
			ifTrue: [fThing slotSVOAt: sn put: fNode copy]. "replace full side mock "
		((fslotSVO isNodeList not and: [fslotSVO svoName = fNode svoName]) and: [slotSVO ~= aNode])
			ifTrue: [fThing slotSVOAt: sn put: fNode copy]]. "replace full side node"
! !

!GbtCompiler methodsFor: 'compiler cache' stamp: 'hk 11/9/2017 09:59'!
replaceSubcontextsOf: ctxt with: aCtxt
	"contexts should not be copied"
	| sctxt |
	ctxt isListAc ifTrue: 
		[^(ctxt hasSubcontext and: [ctxt subcontext svoName = aCtxt svoName]) ifTrue: [ctxt subcontext: aCtxt]].
	sctxt := ctxt subcontexts detect: [:sc | sc svoName = aCtxt svoName] ifNone: [^self].
	ctxt subcontexts at: (ctxt subcontexts indexOf: sctxt) put: (aCtxt container: ctxt)! !

!GbtCompiler methodsFor: 'compiler cache' stamp: 'hk 4/23/2017 13:54'!
thingNamed: aSvoName
	^self things detect: [:th | th svoName = aSvoName ]! !

!GbtCompiler methodsFor: 'accessing' stamp: 'hk 1/5/2018 20:51'!
things
	^things ifNil: [things := (GbtServer default) allThings]! !

!GbtCompiler methodsFor: 'compiler cache' stamp: 'hk 1/13/2018 16:41'!
updateContext: aCtxt

	self removeCtxtOrMock: aCtxt .
	self contexts do: [:ctxt | self replaceSubcontextsOf: ctxt with: aCtxt].
	self contexts do: [:ctxt | self replaceSubcontextsOf: aCtxt with: ctxt].
	self addCtxt: aCtxt
! !

!GbtCompiler methodsFor: 'compiler cache' stamp: 'hk 1/13/2018 16:36'!
updateDirective: aDir
	self removeDirOrMock: aDir.  
	self directives do: [:d | self replaceDirTagsOf: d with: aDir].
	self directives do: [:d | self replaceDirTagsOf: aDir with: d].
	self directives add: aDir.
	self contexts do: [:ctxt| ctxt replaceDirective: aDir]! !

!GbtCompiler methodsFor: 'compiler cache' stamp: 'hk 1/13/2018 16:36'!
updateThing: aThing
	self removeThingOrMock: aThing .  
	self things do: [:th | self replaceNodesOf: th with: aThing. th buildContainerHierarchy].
	self things do: [:th | self replaceNodesOf: aThing with: th. aThing buildContainerHierarchy].
	self things add: aThing.
	self contexts do: [:ctxt| ctxt replaceThing: aThing]! !

!GbtGrammar class methodsFor: 'accessing' stamp: 'hk 11/27/2017 15:10'!
dependencies
	^ {GbtThingCompiler . GbtDeclCompiler . GbtListContextCompiler . GbtPlainContextCompiler . GbtCielBehCompiler}! !

!GbtGrammar class methodsFor: 'accessing' stamp: 'hk 1/12/2018 17:22'!
ignoredNames 
	^ super ignoredNames , #(things directives contexts appName)! !

!GbtGrammar methodsFor: 'parsers' stamp: 'hk 1/13/2018 14:59'!
allContexts
	^ contextWithBehaviors star! !

!GbtGrammar methodsFor: 'parsers' stamp: 'hk 11/27/2017 15:13'!
allDirectives
	^ directive star! !

!GbtGrammar methodsFor: 'parsers' stamp: 'hk 11/27/2017 15:12'!
allThings
	^ thing star! !

!GbtGrammar methodsFor: 'accessing' stamp: 'hk 1/5/2018 18:21'!
appName: aString
	appName := aString! !

!GbtGrammar methodsFor: 'parsers' stamp: 'hk 11/27/2017 15:15'!
cielBehavior
	^ (self dependencyAt: GbtCielBehCompiler ) cielBehavior ! !

!GbtGrammar methodsFor: 'parsers' stamp: 'hk 1/13/2018 14:20'!
contextWithBehaviors
	^ listContext / mainOrPlain , cielBehavior star ! !

!GbtGrammar methodsFor: 'parsers' stamp: 'hk 1/8/2018 14:50'!
directive
	^ (self dependencyAt: GbtDeclCompiler) decl ! !

!GbtGrammar methodsFor: 'parsers' stamp: 'hk 1/12/2018 16:31'!
gbt
	^ allThings, allDirectives, allContexts ! !

!GbtGrammar methodsFor: 'parsers' stamp: 'hk 1/8/2018 14:50'!
listContext
	^ (self dependencyAt: GbtListContextCompiler) listContext ! !

!GbtGrammar methodsFor: 'parsers' stamp: 'hk 1/8/2018 14:50'!
mainOrPlain
	^ (self dependencyAt: GbtPlainContextCompiler) mainOrPlain ! !

!GbtGrammar methodsFor: 'parsers' stamp: 'hk 4/15/2017 21:44'!
start
	^ gbt end ! !

!GbtGrammar methodsFor: 'parsers' stamp: 'hk 1/8/2018 14:50'!
thing  
	^ (self dependencyAt: GbtThingCompiler)  thing ! !

PPCompositeParser subclass: #GbtSELGrammar
	instanceVariableNames: 'prod prim termPlus termMinus prodMul prodDiv predicate functionIf predicateOP lookupContent lookupContentRoot expression gbtSmartPathResolved termString termDate termNumber termBool fctArgs fctBool fctAvg fctDate fctDateEoY fctDateFromString fctDatePlusD fctDatePlusM fctDatePlusW fctLookup fctLookupR fctMax fctMin fctSumTag fctSum fctString fctResolveAllTags fctRef fctProdTag fctNumber resolveString termRef dateString gbtSmartPath selString integer ident identifier gbtSmartPath0 number simpleString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtSELGrammar commentStamp: 'hk 8/10/2017 19:34' prior: 0!
Arithmetic
	+  -  *  /
functions
	sum ( list )
	average ( list )
	if ( conditionTerm , thenTerm , elseTerm )
	
predicates:    <, >, =, ~=, =<, >=
	
special Excel like functions:
	sumTag    	
	prodTtag 	
are  tolerant against strings  and  interpret  strings  as  numbers  if possible

functionResolveTag handles all slot lookups:
	ref (  { ref (smartPath) } smartPath)
	lookup{R}  listOfTags    	(like ref with smartPath derived from the listOfTags)   aka Excel INDIRECT
	smartPathResolved 		local root lookup like prefix
possible types are: number, date, string, thing, boolean!

GbtSELGrammar subclass: #GbtSELCompiler
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtSELCompiler class methodsFor: 'accessing' stamp: 'hk 9/17/2017 15:01'!
ignoredNames 
	^ super ignoredNames , #(container)! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 8/13/2017 18:44'!
allToNumber: anArray
	^anArray collect: [:e| self asNumber: e ] thenSelect: [:e| e isNotNil]! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 8/13/2017 19:32'!
asNumber: anExpr 
	"answer anExpr asNumber or nil - used in vector functions"  
	
	{'NaN' . 'Float nan'} do: [:s| (anExpr asString beginsWith: s) ifTrue: [^nil]].
	^[anExpr asNumber] ifError: []
! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 8/16/2017 17:15'!
bizApp
	^(container ifNil: [^GbtServer default]) bizApp ! !

!GbtSELCompiler methodsFor: 'accessing' stamp: 'hk 9/17/2017 14:59'!
container: aThing
	container := aThing! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 8/12/2017 17:20'!
contentOf: aSmartPath global: aBoolean
	|root aSmartPathArray| 
	aSmartPathArray := aSmartPath isArray 
		ifTrue: [aSmartPath ] 
		ifFalse: [aSmartPath substrings: ':'] .
	root := aBoolean 
		ifTrue: [self globalRoot] 
		ifFalse: [self localRoot].
	^self contentOf: aSmartPathArray inThing: root
! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 9/4/2017 13:13'!
contentOf: aSmartPathArray inThing: aThing
	|res| 
	[res := aThing atSmartPath: aSmartPathArray] on: GbtError do: [:err| err signal]. 
	^res ifNil:[GbtPTypeError signal: aSmartPathArray printSmartPath]! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 8/4/2017 14:43'!
eval: firstArg and: lastArg with: anOP 
	"must be numbers: self new eval: 99 and: 100 with: $<"
	lastArg isNumber ifFalse: [^GbtPNumberError signal: firstArg printString].
	firstArg isNumber ifFalse: [^GbtPNumberError signal: firstArg printString].
	^firstArg perform: anOP asSymbol withArguments: {lastArg}
! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 8/4/2017 14:43'!
evalDiv: firstArg and: lastArg with: anOP 
	"must be numbers, second one nonzero"
	lastArg isZero ifTrue: [GbtPDiv0Error signal: firstArg printString, anOP, lastArg printString].
	^self eval: firstArg and: lastArg  with: anOP ! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:12'!
fctArgs
	^super fctArgs ==> [:n| n reject: [:e| e class = PPToken]]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:13'!
fctAvg
	^super fctAvg ==> [:n| (self allToNumber: n third) average]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/16/2017 11:46'!
fctBool	
	^super fctBool	==> [:n| self toBool: n]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:14'!
fctDateEoY
	^super fctDateEoY ==> [:n| n third asYear end asDate]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/15/2017 15:25'!
fctDateFromString
	^super fctDateFromString ==> [:n| |str|
		str := n third.  
		(str = 'today')
			ifTrue:  [ Date today ]
			ifFalse: [[Date fromString: str] ifError: [GbtPDateError signal: str]]]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:15'!
fctDatePlusD
	^super fctDatePlusD ==> [:n| n third addDays: n fifth asNumber]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:16'!
fctDatePlusM
	^super fctDatePlusM ==> [:n| n third addMonths: n fifth asNumber]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:17'!
fctDatePlusW
	^super fctDatePlusW ==> [:n| n third addDays: (n fifth asNumber * 7)]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:17'!
fctLookup
	^super fctLookup ==> [:n| self contentOf: n third global: false]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:17'!
fctLookupR
	^super fctLookupR ==> [:n| self contentOf: n third global: true]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:19'!
fctMax
	^super fctMax ==> [:n| (self allToNumber: n third) max]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:19'!
fctMin
	^super fctMin ==> [:n| (self allToNumber: n third) min ]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:24'!
fctProdTag
	^super fctProdTag ==> [:n| self multiplyTags: n third ]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:24'!
fctRef 
	"ref({ref(thingName|smartPathArray)} smartPathArray) or  ref(thingName|smartPathArray) "
	^super fctRef ==> [:n| |th sp|  
		(th := n third) 
			ifNil: [(sp := n fourth) isArray 
					ifTrue: [self contentOf: sp inThing: self localRoot]
					ifFalse: [self thingNamed: sp]]
			ifNotNil: [(sp := n fourth) isArray ifFalse: [GbtPTagError signal: sp printString].
					th ifString: [GbtPThingError signal: th asString ].
					self contentOf: n fourth inThing: th]]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 11/4/2017 21:18'!
fctResolveAllTags
	^super fctResolveAllTags ==> [:n| (container ifNil: [GbtPContainerError signal] ifNotNil: [container]) enrichFromTags: n third ]
	! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:21'!
fctSum
	^super fctSum ==> [:n| (self allToNumber: n third) sum]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:21'!
fctSumTag
	^super fctSumTag ==> [:n| self sumTags: n third ]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/4/2017 15:05'!
functionIf
	^super functionIf ==> [:n|n third ifTrue: [n at: 5] ifFalse: [n at: 7]]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 11/9/2017 16:16'!
gbtSmartPathResolved
	^super gbtSmartPathResolved ==> [:n| self contentOf: n global: false]! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 8/4/2017 14:43'!
globalRoot
	^(container ifNil: [GbtPContainerError signal]) globalRoot! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 8/4/2017 14:43'!
localRoot
	^(container ifNil: [GbtPContainerError signal]) localRoot! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/4/2017 14:39'!
lookupContent	
	^super lookupContent  ==> [:n| self lookupPathOf: n global: false]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/4/2017 14:40'!
lookupContentRoot
	^super lookupContentRoot ==> [:n| self lookupPathOf: n global: true]! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 8/4/2017 14:41'!
lookupPathOf: anArrayOfSlotnames global: aBoolean
	| elements sp |  
	elements := anArrayOfSlotnames collect: [:e| |res|
		res := self contentOf: e global: aBoolean. 
		res isString ifFalse: [^GbtPStringError signal: e].
		res].
	sp := ''. 
	elements do: [:e| sp := sp, e, ':'].
	^sp allButLast asSymbol! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 8/4/2017 14:31'!
multiplyTags: aTag
	| slotValues |
	container ifNil: [GbtPContainerError signal].  
	slotValues := container slotValuesTaggedWith: aTag.
	^(self allToNumber: slotValues) inject: 1 into: [:pr :e| pr * e]
	

! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/11/2017 11:53'!
predicate
	"type of first arg requires same type of second arg"
	^super predicate ==> [:n| |typeS1 typeS3|
		typeS1 := self typeFailOf: n first.
		typeS3 := self typeFailOf: n third.
		typeS1 = typeS3 ifFalse: [GbtParserError signal: typeS1, n third printString].
		n first perform: n second asSymbol withArguments: {n third}]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 7/22/2017 14:11'!
predicateOP
	^super predicateOP  ==> [:n | n asString]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 7/7/2017 13:34'!
prodDiv 
	^super prodDiv ==> [:n | self evalDiv: (self toNumber: n first) and: (self toNumber: n third) with: n second asString] ! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 7/7/2017 13:34'!
prodMul 
	^super prodMul ==> [:n | self eval: (self toNumber: n first) and: (self toNumber: n third) with: n second asString] ! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 8/1/2017 19:54'!
sumTags: aTag
	| slotValues |
	container ifNil: [GbtPContainerError signal].  
	slotValues := container slotValuesTaggedWith: aTag.
	^(self allToNumber: slotValues) sumNumbers: [:e| e]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 12/13/2017 12:17'!
termDate 
	^super termDate ==> [:n | [n asDate] ifError: [GbtPDateError signal: n asString]]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/13/2017 16:15'!
termMinus 
	^super termMinus ==> [:n | self eval: (self toNumber: n first) and: (self toNumber: n third) with: n second asString]! !

!GbtSELCompiler methodsFor: 'parsers' stamp: 'hk 8/16/2017 16:00'!
termPlus 
	^super termPlus ==> [:n |self eval: (self toNumber: n first) and: (self toNumber: n third) with: n second asString]! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 8/4/2017 14:35'!
thingNamed: aName
	container ifNil: [GbtPContainerError signal].
	^container bizApp thingNamed: aName! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 8/16/2017 17:00'!
toBool: anExpr 
	"answer the thing or the slot val as Boolean if possible"  
	(anExpr == false or: [anExpr == true]) ifFalse: [GbtParserError signal: 'NaBool: anExpr asString'].
	^anExpr! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 8/4/2017 14:15'!
toDate: aStringOrThing 
	^[aStringOrThing asDate] ifError: [GbtPDateError signal: aStringOrThing printString]
! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 8/16/2017 16:16'!
toNumber: anExpr 
	"answer the thing or the slot val asNumber if possible"  
	{'NaN' . 'Float nan'} do: [:s| (anExpr asString beginsWith: s) ifTrue: [GbtParserError signal: anExpr asString]].
	anExpr ifNil: [GbtPTagError signal: anExpr asString].
	^[anExpr asNumber] ifError: [GbtPNumberError signal: anExpr asString].
! !

!GbtSELCompiler methodsFor: 'private' stamp: 'hk 8/16/2017 11:58'!
typeFailOf: aNode 
	"answer the failString associated to the node type"  
	aNode ifNil: [^GbtPTypeError signal: aNode printString, ' isNil' ].
	aNode isNumber ifTrue: [^'NaN: '] .
	(aNode isKindOf: Date) ifTrue: [^'NaD: '].
	(aNode isKindOf: Boolean) ifTrue: [^'NaB: '].
	aNode ifString: [^'NaStr: '].
	[(aNode isNode) ifTrue: [^'NaTh: ']] ifError: 
		[^'Illegal Type ']! !

GbtSELCompiler subclass: #GbtSELDateCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtSELDateCompiler methodsFor: 'parsers' stamp: 'hk 7/29/2017 19:58'!
start
	^termDate end! !

GbtSELCompiler subclass: #GbtSELNumberCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtSELNumberCompiler methodsFor: 'parsers' stamp: 'hk 7/29/2017 20:00'!
start
	^termNumber end! !

GbtSELCompiler subclass: #GbtSELPredicateCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtSELPredicateCompiler methodsFor: 'parsers' stamp: 'hk 7/29/2017 20:08'!
start
	^termBool end! !

GbtSELCompiler subclass: #GbtSELRefCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtSELRefCompiler methodsFor: 'as yet unclassified' stamp: 'hk 8/16/2017 12:05'!
start
	^termRef  end! !

GbtSELCompiler subclass: #GbtSELStringCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtSELStringCompiler methodsFor: 'parsers' stamp: 'hk 7/29/2017 19:58'!
start
	^termString end! !

!GbtSELGrammar class methodsFor: 'accessing' stamp: 'hk 10/12/2017 22:39'!
dependencies
	^ {GbtBasicGrammar}! !

!GbtSELGrammar class methodsFor: 'accessing' stamp: 'hk 1/23/2018 15:50'!
documentation
	"self documentation"
	| stream  parsers |
	(stream := TextStream on: (Text new: 10)) 
		nextPutAll: self name asText allBold; cr; 
		nextPutAll: self comment; cr; cr.
		
	parsers := self selectors.
	stream nextPutAll: 'parsers' asText allBold; cr. 
	parsers do: [:p|
		stream nextPutAll: p asText allItalic; cr; 
		nextPutAll: ((self commentsAt: p) at: 1 ifAbsent: ['comment missing']); cr; cr].
	^stream contents! !

!GbtSELGrammar methodsFor: 'expression parsers' stamp: 'hk 12/13/2017 12:30'!
dateString
	"parse only when a valid date"
	^simpleString ==> [ :n| 
			(self isDate: n) 
				ifTrue: [n]
				ifFalse: [ PPFailure message: 'NaD: ', n asString  ]]	! !

!GbtSELGrammar methodsFor: 'expression parsers' stamp: 'hk 8/16/2017 17:38'!
expression 
	^ termRef end 		"nothing more if a Reference"									"?????"
	/ termNumber 		"must be tried before Date / String"
	/ termDate trim 	"ohne trim Fehler in GbtELGrammar>>testStringQuoted"		"?????"
	/ termString 		"last resort"
! !

!GbtSELGrammar methodsFor: 'expression parsers' stamp: 'hk 11/6/2017 18:31'!
fctArgs
	^ termNumber delimitedBy: $; asParser token trim ! !

!GbtSELGrammar methodsFor: 'parsers numbers' stamp: 'hk 8/10/2017 19:13'!
fctAvg
	^'average' asParser trim, $( asParser trim, fctArgs, $) asParser trim ! !

!GbtSELGrammar methodsFor: 'expression parsers' stamp: 'hk 8/16/2017 17:30'!
fctBool	
	^termRef "to be moved to termBool"! !

!GbtSELGrammar methodsFor: 'parsers date' stamp: 'hk 8/15/2017 14:09'!
fctDate
	^ fctDatePlusM
	/ fctDatePlusD
	/ fctDatePlusW
	/ fctDateFromString
	/ fctDateEoY! !

!GbtSELGrammar methodsFor: 'parsers date' stamp: 'hk 8/10/2017 19:14'!
fctDateEoY
	^'silvester' asParser trim, $( asParser trim, termDate, $) asParser trim ! !

!GbtSELGrammar methodsFor: 'parsers date' stamp: 'hk 11/7/2017 15:28'!
fctDateFromString
	^'date' asParser trim, $( asParser, simpleString, $) asParser trimRight! !

!GbtSELGrammar methodsFor: 'parsers date' stamp: 'hk 8/10/2017 19:15'!
fctDatePlusD
	^'date+d' asParser trim, $( asParser trim, termDate, $, asParser, integer, $) asParser trim ! !

!GbtSELGrammar methodsFor: 'parsers date' stamp: 'hk 10/12/2017 22:42'!
fctDatePlusM
	^'date+m' asParser trim, $( asParser trim, termDate, $, asParser, integer, $) asParser trim! !

!GbtSELGrammar methodsFor: 'parsers date' stamp: 'hk 8/10/2017 19:17'!
fctDatePlusW
	^'date+w' asParser trim, $( asParser trim, termDate, $, asParser, integer, $) asParser trim ! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:17'!
fctLookup
	^'lookup' asParser trim, $( asParser trim, lookupContent, $) asParser trim ! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:17'!
fctLookupR
	^'lookupR' asParser trim, $( asParser trim, lookupContentRoot, $) asParser trim ! !

!GbtSELGrammar methodsFor: 'parsers numbers' stamp: 'hk 8/10/2017 19:19'!
fctMax
	^'max' asParser trim, $( asParser trim, fctArgs, $) asParser trim ! !

!GbtSELGrammar methodsFor: 'parsers numbers' stamp: 'hk 8/10/2017 19:19'!
fctMin
	^'min' asParser trim, $( asParser trim, fctArgs, $) asParser trim ! !

!GbtSELGrammar methodsFor: 'parsers numbers' stamp: 'hk 8/14/2017 05:03'!
fctNumber
	^fctSumTag
	/ fctProdTag
	/ fctSum 
	/ fctAvg 
	/ functionIf 
	/ fctMax
	/ fctMin! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 22:42'!
fctProdTag
	^'prodTag' asParser trim, $( asParser trim, ident , $) asParser trim! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 22:43'!
fctRef
	"identifier = ThingName"
	^ 'ref' asParser trim , $( asParser trim , fctRef optional, (identifier/ gbtSmartPath), $) asParser trim! !

!GbtSELGrammar methodsFor: 'parsers string' stamp: 'hk 11/4/2017 21:28'!
fctResolveAllTags
	^'resolve' asParser trim, $( asParser, simpleString, $) asParser trimBlanks ! !

!GbtSELGrammar methodsFor: 'parsers string' stamp: 'hk 8/16/2017 11:53'!
fctString
	^ fctResolveAllTags
	/ resolveString
"	/ functionTrimUpTo 
	/ functionTrimFrom"! !

!GbtSELGrammar methodsFor: 'parsers numbers' stamp: 'hk 8/10/2017 19:21'!
fctSum
	^'sum' asParser trim, $( asParser trim, fctArgs , $) asParser trim ! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 8/10/2017 19:21'!
fctSumTag
	^'sumTag' asParser trim, $( asParser trim, ident , $) asParser trim ! !

!GbtSELGrammar methodsFor: 'expression parsers' stamp: 'hk 8/4/2017 15:10'!
functionIf
	^'if' asParser trim, $( asParser trim, termBool, $; asParser trim, expression, $; asParser trim, expression, $) asParser trim ! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 22:44'!
gbtSmartPath
	^ ($# asParser, gbtSmartPath0) trimBlanks ==> #second! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 1/9/2018 17:57'!
gbtSmartPath0
^ (self dependencyAt: GbtBasicGrammar) gbtSmartPath! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 8/15/2017 14:53'!
gbtSmartPathResolved
	^ gbtSmartPath! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 22:43'!
ident
^ (self dependencyAt: GbtBasicGrammar) ident! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 22:41'!
identifier
^ (self dependencyAt: GbtBasicGrammar) identifier! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 22:41'!
integer
^ (self dependencyAt: GbtBasicGrammar) integer! !

!GbtSELGrammar methodsFor: 'private' stamp: 'hk 8/13/2017 18:19'!
isDate: aStringOrThing 
	[aStringOrThing asDate] ifError: [^false].
	^true
! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 21:59'!
lookupContent	
	^ identifier plus  ! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 21:59'!
lookupContentRoot
	^ identifier plus ! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 22:41'!
number
^ (self dependencyAt: GbtBasicGrammar) number! !

!GbtSELGrammar methodsFor: 'parsers boolean' stamp: 'hk 8/10/2017 20:26'!
predicate
	^expression, predicateOP, expression! !

!GbtSELGrammar methodsFor: 'parsers boolean' stamp: 'hk 8/2/2017 16:51'!
predicateOP
	^('=<' asParser
	/ '>=' asParser
	/ '!!=' asParser
 	/ $= asParser
	/ $> asParser
	/ $< asParser
	) ! !

!GbtSELGrammar methodsFor: 'expression parsers' stamp: 'hk 10/12/2017 22:44'!
prim 
	^ ( ($( asParser  , termNumber , $) asParser  ==> #second) 
	/ termRef      "will only be checked in calculations"
	/ fctNumber 
	/ number
	) trim! !

!GbtSELGrammar methodsFor: 'expression parsers' stamp: 'hk 6/16/2017 16:13'!
prod 
	^prodMul / prodDiv / prim! !

!GbtSELGrammar methodsFor: 'expression parsers' stamp: 'hk 6/30/2017 19:07'!
prodDiv 
	^prim , $/ asParser trim , prod ! !

!GbtSELGrammar methodsFor: 'expression parsers' stamp: 'hk 6/30/2017 19:07'!
prodMul 
	^prim , $* asParser trim , prod ! !

!GbtSELGrammar methodsFor: 'parsers string' stamp: 'hk 8/16/2017 16:02'!
resolveString
	^  termRef ==> [:n| (n isString) ifTrue: [n] ifFalse: [PPFailure message: 'NaStr: ', n asString]]! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 12/1/2017 10:41'!
selString
^ (self dependencyAt: GbtBasicGrammar) slotString! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 11/4/2017 21:27'!
simpleString
^ (self dependencyAt: GbtBasicGrammar) simpleString! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 7/30/2017 19:51'!
start
	^expression end! !

!GbtSELGrammar methodsFor: 'expression parsers' stamp: 'hk 11/22/2017 16:03'!
termBool
	"parse & return aBoolean"
	^ ($( asParser  , termBool , $) asParser  ==> #second) 
	/ ('true' asParser trimBlanks ==> [:n| true ])
	/ ('false' asParser trimBlanks ==> [:n|false])
	/  predicate
	/ 	fctBool
! !

!GbtSELGrammar methodsFor: 'expression parsers' stamp: 'hk 12/13/2017 13:00'!
termDate
	"parse & return aDate"
	^fctDate 
	/ termRef 
	/ dateString! !

!GbtSELGrammar methodsFor: 'expression parsers' stamp: 'hk 7/29/2017 20:00'!
termMinus
	^prod , $- asParser trim , termNumber  ! !

!GbtSELGrammar methodsFor: 'expression parsers' stamp: 'hk 8/11/2017 12:28'!
termNumber
	"parse & return aNumber"
	^termPlus / termMinus / prod ! !

!GbtSELGrammar methodsFor: 'expression parsers' stamp: 'hk 7/29/2017 20:00'!
termPlus
	^prod , $+ asParser trim , termNumber! !

!GbtSELGrammar methodsFor: 'parsers' stamp: 'hk 8/16/2017 12:04'!
termRef
	^ gbtSmartPathResolved 
	/ fctLookup 
	/ fctLookupR 
	/ fctRef! !

!GbtSELGrammar methodsFor: 'expression parsers' stamp: 'hk 10/12/2017 21:50'!
termString
	"parse & return aString"
	^  fctString
	/ selString! !

PPCompositeParser subclass: #GbtThingGrammar
	instanceVariableNames: 'constraintSlot listSlot constraint constraintViolated list listDisplay val date text node summary purposes bizIdPolicy tags purposeAttributes private no thing standardSlot ui slotAttributes slotAttribute constraintAttributes listAttributes reference buildinSlot boolean mandatory colon identifier comment listOfIdentifierOrPair slot allSlots slots predicate slotUi templates stringQuoted simpleString slotString slotStrings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

GbtThingGrammar subclass: #GbtDeclGrammar
	instanceVariableNames: 'decl allTags tag explicitTag declTag listTag simpleTag buildinDirSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

GbtDeclGrammar subclass: #GbtDeclCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtDeclCompiler methodsFor: 'parsers' stamp: 'hk 1/8/2018 14:46'!
decl
	^super decl ==> [:n| |defArray|
		defArray := n third collect: [:bislot| {self selectorFor: bislot first . bislot third}].
		GbtDirective 
			new: n second 
			def: defArray
			tags: n fourth ]! !

!GbtDeclCompiler methodsFor: 'parsers' stamp: 'hk 11/6/2017 17:33'!
declTag
	^super declTag ==> [:n| { n second . GbtParseMock svoName: (n fourth) } ]! !

!GbtDeclCompiler methodsFor: 'parsers' stamp: 'hk 5/8/2017 17:46'!
explicitTag
	^super explicitTag ==> [:n| {n second . n fourth } ]! !

!GbtDeclCompiler methodsFor: 'parsers' stamp: 'hk 11/6/2017 17:33'!
listTag
	^super listTag ==> [:n| {n second . {n fourth . GbtParseMock svoName: (n fifth)} } ]! !

!GbtDeclCompiler methodsFor: 'parsers' stamp: 'hk 5/9/2017 10:58'!
simpleTag
	^super simpleTag ==> [:n| {n . n} ]! !

!GbtDeclCompiler methodsFor: 'parsers' stamp: 'hk 5/8/2017 18:00'!
tag
	^super tag ==> [:n| GbtSlotAssociation key: n first asSymbol value: n second]! !

!GbtDeclGrammar methodsFor: 'parsers' stamp: 'hk 9/15/2017 13:59'!
allTags
	^ ${ asParser trim, tag trimLeft star, $} asParser trim ==> #second! !

!GbtDeclGrammar methodsFor: 'parsers' stamp: 'hk 10/11/2017 10:59'!
buildinDirSlot
	^ (summary / bizIdPolicy ) , comment optional ==> #first! !

!GbtDeclGrammar methodsFor: 'parsers' stamp: 'hk 10/11/2017 10:59'!
decl
	^ 'directive' asParser trimLeft, identifier,
			buildinDirSlot star,
			allTags! !

!GbtDeclGrammar methodsFor: 'parsers' stamp: 'hk 5/8/2017 14:59'!
declTag
	^ 'decl' asParser trim, identifier, colon, identifier! !

!GbtDeclGrammar methodsFor: 'parsers' stamp: 'hk 5/8/2017 14:59'!
explicitTag
	^ 'tag' asParser trim, identifier, colon, identifier! !

!GbtDeclGrammar methodsFor: 'parsers' stamp: 'hk 5/8/2017 14:59'!
listTag
	^ 'list' asParser trim, identifier, colon, identifier, identifier! !

!GbtDeclGrammar methodsFor: 'parsers' stamp: 'hk 5/8/2017 17:15'!
simpleTag
	^ identifier! !

!GbtDeclGrammar methodsFor: 'parsers' stamp: 'hk 5/8/2017 14:09'!
start
	^ decl trim end ! !

!GbtDeclGrammar methodsFor: 'parsers' stamp: 'hk 5/8/2017 20:00'!
tag
	"simpleTag must be last"
	^ explicitTag / declTag / listTag / simpleTag! !

GbtThingGrammar subclass: #GbtThingCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Parser'!

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 4/19/2017 12:06'!
allSlots
	^super allSlots ==> [:n| |smartSlots fullSlots|
		smartSlots := OrderedCollection new.
		fullSlots := OrderedCollection new.
		n do: [:e| 
			e first ifNotNil: [smartSlots add: e second] .
			fullSlots add: e second].
		Array with: smartSlots with: fullSlots ]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 10/17/2017 13:18'!
constraint 
	^ super constraint ==> [:n| n second asSymbol -> (GbtConstraintCell withValue: n fourth)]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 4/22/2017 19:01'!
constraintAttributes
	^ super constraintAttributes  ==> [:n| n 
			ifNil: [#()] 
			ifNotNil: [n reject: [:each| each class = PPToken ]]]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 4/22/2017 18:54'!
constraintSlot
	^ super constraintSlot
		==> [ :n | | sa |
			sa := GbtSlotAssociation key: n first key value: n first value.
			n second ifNotNil: [ :arr | 			"add the contraintViolation string"
					arr second do: [:cViol| n first value violationString: cViol second].
					arr third do: [:sAttr| 			"add the general slot attributes"
					sa perform: sAttr first asSymbol withArguments: {sAttr second}]].
			sa ]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 8/16/2017 17:19'!
date
	^ super date ==> [:n| n second asSymbol -> (GbtDate withValue: n fourth)]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 11/6/2017 21:06'!
list
	^ super list ==> [:n| n second asSymbol -> (GbtNodeList withTemplates: n fourth)]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 4/22/2017 19:08'!
listAttributes
	^ super listAttributes  ==> [:n| n 
			ifNil: [#()] 
			ifNotNil: [n reject: [:each| each class = PPToken ]]]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 4/22/2017 19:26'!
listSlot
	^ super listSlot ==> [ :n | | sa |
			sa := GbtSlotAssociation key: n first key value: n first value.
			n second ifNotNil: [ :arr | 			"add the display columns"
				arr second do: [:dC| n first value displayColumns: dC second].
				arr third do: [:sAttr| 			"add the general slot attributes"
					sa perform: sAttr first asSymbol withArguments: {sAttr second}]].
			sa ]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 8/16/2017 17:19'!
no
	^ super no ==> [:n| n second asSymbol -> (GbtNumber withValue: n fourth)]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 4/21/2017 13:35'!
noAttributes
	^ super noAttributes  ==> [:n|n ifNil: [#()] ifNotNil: [n reject: [:each| each class = PPToken ]]]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 11/6/2017 17:33'!
node
	^ super node ==> [:n| n second asSymbol -> (GbtParseMock svoName: n fourth) ]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 12/1/2017 09:48'!
predicate 
	^ super predicate ==> [:n| n second asSymbol -> (GbtPredicate withValue: n fourth)]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 12/1/2017 09:50'!
reference
	^ super reference ==> [:n| n second asSymbol -> (GbtReference withValue: n fourth)]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 4/20/2017 21:25'!
slot
	^ super slot ==> [ :n | n sliceFrom: 1 to: 2]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 4/22/2017 18:59'!
slotAttributes
	^ super slotAttributes  ==> [:n|n 
			ifNil: [#()]
			ifNotNil: [n reject: [:each| each class = PPToken]]]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 4/21/2017 13:07'!
standardSlot
	^ super standardSlot
		==> [ :n | | sa |
			sa := GbtSlotAssociation key: n first key value: n first value.
			n second ifNotNil: [ :arr |
					arr second do: [:sAttr|			"add the general slot attributes"
					sa perform: sAttr first asSymbol withArguments: {sAttr second}]].
			sa ]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 8/16/2017 17:19'!
text
	^ super text ==> [:n| n second asSymbol -> (GbtText withValue: n fourth)]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 1/8/2018 14:43'!
thing
	^ super thing ==> [:n| |defArray|  
		defArray := n third collect: [:bislot| {self selectorFor: bislot first . bislot third}] .	 
		GbtSmartNode new: n second 
					def: defArray
					add: (n at: 4) first
					full:  (n at: 4) second]! !

!GbtThingCompiler methodsFor: 'parsers' stamp: 'hk 12/1/2017 09:48'!
val
	^ super val ==> [:n| n second asSymbol -> (GbtString withValue: n fourth)]! !

!GbtThingGrammar class methodsFor: 'accessing' stamp: 'hk 10/12/2017 22:22'!
dependencies
	^ {GbtBasicGrammar}! !

!GbtThingGrammar class methodsFor: 'accessing' stamp: 'hk 1/3/2018 16:01'!
ignoredNames 
	^ super ignoredNames , #(appName)! !

!GbtThingGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 22:30'!
allSlots
	^ ${ asParser trim, slots, $} asParser trim ==> #second! !

!GbtThingGrammar methodsFor: 'thing attribute parsers' stamp: 'hk 10/12/2017 22:24'!
bizIdPolicy
	^ 'bizIdPolicy' asParser trim, colon, identifier  ! !

!GbtThingGrammar methodsFor: 'parsers' stamp: 'hk 10/11/2017 14:02'!
boolean
	"self new boolean parse: #true "
	^ ('true' asParser / 'false' asParser) flatten trimBlanks! !

!GbtThingGrammar methodsFor: 'thing parsers' stamp: 'hk 10/12/2017 22:25'!
buildinSlot
	^ (summary /	purposes / bizIdPolicy / ui ), comment optional ==> #first ! !

!GbtThingGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 22:23'!
colon
^ (self dependencyAt: GbtBasicGrammar) colon! !

!GbtThingGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 22:24'!
comment
^ (self dependencyAt: GbtBasicGrammar) comment! !

!GbtThingGrammar methodsFor: 'thing slot parsers' stamp: 'hk 12/1/2017 12:46'!
constraint 
	^ 'constraint' asParser, identifier , colon, slotString! !

!GbtThingGrammar methodsFor: 'thing parsers' stamp: 'hk 4/22/2017 19:00'!
constraintAttributes
	^ (constraintViolated delimitedBy: $, asParser token) optional! !

!GbtThingGrammar methodsFor: 'thing parsers' stamp: 'hk 4/22/2017 19:01'!
constraintSlot
	^ constraint, (${ asParser, constraintAttributes, slotAttributes, $} asParser) trimBlanks optional ! !

!GbtThingGrammar methodsFor: 'thing slot attribute parsers' stamp: 'hk 12/1/2017 12:25'!
constraintViolated
	^ 'ifViolated:' asParser trim, simpleString! !

!GbtThingGrammar methodsFor: 'thing slot parsers' stamp: 'hk 12/1/2017 12:38'!
date
	^ 'date' asParser, identifier , colon, slotStrings ! !

!GbtThingGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 22:23'!
identifier
^ (self dependencyAt: GbtBasicGrammar) identifier! !

!GbtThingGrammar methodsFor: 'thing slot parsers' stamp: 'hk 10/12/2017 21:59'!
list 
	^ 'list' asParser, identifier , colon, identifier plus ! !

!GbtThingGrammar methodsFor: 'thing parsers' stamp: 'hk 4/22/2017 19:07'!
listAttributes
	^ (listDisplay delimitedBy: $, asParser token) optional! !

!GbtThingGrammar methodsFor: 'thing slot attribute parsers' stamp: 'hk 10/12/2017 22:25'!
listDisplay
	^ 'display:' asParser trim, listOfIdentifierOrPair! !

!GbtThingGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 22:23'!
listOfIdentifierOrPair
^ (self dependencyAt: GbtBasicGrammar) listOfIdentifierOrPair! !

!GbtThingGrammar methodsFor: 'thing parsers' stamp: 'hk 4/22/2017 19:09'!
listSlot
	^ list, (${ asParser, listAttributes, slotAttributes, $} asParser) trimBlanks optional ! !

!GbtThingGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 22:04'!
mandatory
	^$* asParser! !

!GbtThingGrammar methodsFor: 'thing slot parsers' stamp: 'hk 12/1/2017 12:38'!
no
	^ 'no' asParser, identifier , colon, slotStrings! !

!GbtThingGrammar methodsFor: 'thing slot parsers' stamp: 'hk 9/14/2017 13:36'!
node
	^ 'node' asParser, identifier , colon, identifier! !

!GbtThingGrammar methodsFor: 'thing slot parsers' stamp: 'hk 12/1/2017 12:38'!
predicate 
	^ 'bool' asParser, identifier , colon, slotStrings! !

!GbtThingGrammar methodsFor: 'thing slot attribute parsers' stamp: 'hk 9/14/2017 12:23'!
private
	^ 'protected:' asParser trim, boolean! !

!GbtThingGrammar methodsFor: 'thing slot attribute parsers' stamp: 'hk 10/12/2017 21:59'!
purposeAttributes
	^ 'purposes:' asParser trim, identifier plus ! !

!GbtThingGrammar methodsFor: 'thing attribute parsers' stamp: 'hk 10/12/2017 21:59'!
purposes
	^ 'purposes' asParser trim, colon, identifier plus 
! !

!GbtThingGrammar methodsFor: 'thing slot parsers' stamp: 'hk 12/1/2017 12:38'!
reference 
	^ 'ref' asParser, identifier , colon, slotStrings! !

!GbtThingGrammar methodsFor: 'helpers' stamp: 'hk 11/27/2017 21:14'!
selectorFor: aString
	(aString = 'ui') ifTrue: [^#uiClassName].
	(aString = 'bizIdPolicy') ifTrue: [^#idNumberPolicy].
	^aString asSymbol! !

!GbtThingGrammar methodsFor: 'parsers' stamp: 'hk 12/1/2017 12:26'!
simpleString
^ (self dependencyAt: GbtBasicGrammar) simpleString! !

!GbtThingGrammar methodsFor: 'thing parsers' stamp: 'hk 8/24/2017 18:52'!
slot
	^ mandatory optional , (standardSlot / constraintSlot / listSlot)! !

!GbtThingGrammar methodsFor: 'thing slot attribute parsers' stamp: 'hk 11/28/2017 17:22'!
slotAttribute
	^ tags / purposeAttributes / private / slotUi / templates! !

!GbtThingGrammar methodsFor: 'thing slot attribute parsers' stamp: 'hk 7/15/2017 17:11'!
slotAttributes
	^ (slotAttribute  delimitedBy: $, asParser token ) optional! !

!GbtThingGrammar methodsFor: 'parsers' stamp: 'hk 12/1/2017 12:35'!
slotString
^ (self dependencyAt: GbtBasicGrammar) slotString! !

!GbtThingGrammar methodsFor: 'thing slot parsers' stamp: 'hk 12/1/2017 12:38'!
slotStrings
	^(slotString delimitedBy: $| asParser token) optional ==> [:n| n 
			ifNil: [#()] 
			ifNotNil: [n reject: [:each| each class = PPToken ]]]! !

!GbtThingGrammar methodsFor: 'thing slot attribute parsers' stamp: 'hk 11/27/2017 21:26'!
slotUi
	^ ('ui:' asParser trim, identifier) ! !

!GbtThingGrammar methodsFor: 'parsers' stamp: 'hk 10/12/2017 22:38'!
slots
	"same as in basic grammar"
	^ (slot trimLeft delimitedBy: comment token) optional 
		==> [:n| n ifNil: [#()] ifNotNil: [ n reject: [:each| each class = PPToken]]]! !

!GbtThingGrammar methodsFor: 'thing parsers' stamp: 'hk 11/30/2017 17:32'!
standardSlot
	^ (val / reference / date / text / node / no / predicate) trimBlanks, (${ asParser, slotAttributes, $} asParser) trimBlanks optional  ! !

!GbtThingGrammar methodsFor: 'parsers' stamp: 'hk 4/18/2017 13:48'!
start
	^ thing trim end ! !

!GbtThingGrammar methodsFor: 'parsers' stamp: 'hk 11/28/2017 17:29'!
stringQuoted
^ (self dependencyAt: GbtBasicGrammar) stringQuoted! !

!GbtThingGrammar methodsFor: 'thing attribute parsers' stamp: 'hk 12/1/2017 12:36'!
summary
	^ 'summary' asParser trim, colon, slotString! !

!GbtThingGrammar methodsFor: 'thing slot attribute parsers' stamp: 'hk 10/12/2017 21:59'!
tags
	^ ('tags:' asParser trim, identifier plus ) ! !

!GbtThingGrammar methodsFor: 'thing slot attribute parsers' stamp: 'hk 11/28/2017 17:29'!
templates
	^ ('templates:' asParser trim, (identifier / stringQuoted) plus ) ! !

!GbtThingGrammar methodsFor: 'thing slot parsers' stamp: 'hk 12/1/2017 12:38'!
text 
	^ 'text' asParser, identifier , colon, slotStrings! !

!GbtThingGrammar methodsFor: 'thing parsers' stamp: 'hk 10/12/2017 22:25'!
thing
	^ 'thing' asParser trimLeft, identifier,
			buildinSlot star, 
			allSlots ! !

!GbtThingGrammar methodsFor: 'thing attribute parsers' stamp: 'hk 10/11/2017 10:35'!
ui
	^ 'ui' asParser trim, colon, identifier ! !

!GbtThingGrammar methodsFor: 'thing slot parsers' stamp: 'hk 12/1/2017 12:38'!
val
	^ 'val' asParser, identifier , colon, slotStrings! !

!MorphicTextInputFieldAdapter methodsFor: '*GBT-DSL' stamp: 'hk 10/19/2017 21:49'!
adapt: aModel
	"original method expanded, see https://stackoverflow.com/questions/31506637/how-to-respond-to-focus-changes-on-composablemodel-spec  
	HK 19.10.2017"
	
	super adapt: aModel.
	aModel whenBuiltDo: [ :w | 
      w widget color: Smalltalk ui theme backgroundColor.
      w widget textMorph 
         onAnnouncement: MorphGotFocus, MorphLostFocus  
         send: #announce: to: aModel ]! !

DynamicComposableModel subclass: #GbtAddressBoxWidget
	instanceVariableNames: 'slotVO fields slotName wh'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing-Leaves'!

!GbtAddressBoxWidget commentStamp: 'hk 1/19/2016 12:42' prior: 0!
Box widget for an address

    Instance Variables
	fields:		<OrderedIdentityDictionary>
	slotVO:		<ThingVO>
	slotName:	<Symbol>
	wh: 			<Number>		widget height

=========================================================
|th|
SVO initializeAll.
th := ThingVO newOfType: 'GCAddress' define: { 
		{ #widgetClass . #GcAddressBoxWidget}.
		{ #street . #val: . ''}.		
		{ #streetNo . #val: . ''}.
		{ #cityCode . #val: . ''}.		
		{ #cityName . #val: . ''}.	}.
(self on: th key: nil  for: nil) openWithSpec!

!GbtAddressBoxWidget methodsFor: 'initialization' stamp: 'hk 1/19/2016 12:00'!
addColDivider: aColumn height: aNumber
	"corresponding method: hDivider"
	aColumn newRow: [:r| r add: #hDivider] height: aNumber! !

!GbtAddressBoxWidget methodsFor: 'accessing' stamp: 'hk 10/20/2017 12:14'!
changeFlag
	"GbtWidget compatibility"
	^nil! !

!GbtAddressBoxWidget methodsFor: 'api' stamp: 'hk 1/20/2016 15:08'!
initialExtent
	
	^600 @ self widgetHeight! !

!GbtAddressBoxWidget methodsFor: 'initialization' stamp: 'hk 11/1/2016 17:36'!
initializeLayout
	
	wh := (fields collect: [:f| (self widgets at: f) widgetHeight]) reduce: [:wh1 :wh2| wh1 max: wh2].
	self layout: 
		(SpecLayout composed newColumn: [:c| 
			c newRow: [:r| r add: #hDivider1] height: 8.
			c newRow: [:r| fields do: [:wl| r add: wl]] height: wh.
			c newRow: [:r| r add: #hDivider2] height: 8 ]
		).
	wh := wh + 16.		
	self needFullRebuild: false ! !

!GbtAddressBoxWidget methodsFor: 'initialization' stamp: 'hk 2/16/2017 14:46'!
initializeWidgets
	self instantiateModels: #(
		hDivider1 ButtonModel
		hDivider2 ButtonModel
		).
	self hDivider1 state: true.
	self hDivider2 state: true.
	fields := OrderedIdentityDictionary new.
	slotVO slots do: 
		[ :s |  |wl sw k v|
		k := s key. v := s value.
		wl:= ('lbl_',k) asSymbol.
		fields add: k -> wl .
		(sw := v uiClass basicNew)
				slotVO: v; 
				label: k;
				initialize.		
	self assign: sw to: wl].		
	self initializeLayout
	

! !

!GbtAddressBoxWidget methodsFor: 'accessing' stamp: 'hk 1/18/2016 11:44'!
label: aSymbol
	slotName := aSymbol! !

!GbtAddressBoxWidget methodsFor: 'compatibility' stamp: 'hk 10/20/2017 13:08'!
read! !

!GbtAddressBoxWidget methodsFor: 'compatibility' stamp: 'hk 1/19/2016 12:28'!
resetEditButton! !

!GbtAddressBoxWidget methodsFor: 'compatibility' stamp: 'hk 1/13/2016 16:16'!
rightEditBlock: aBlock! !

!GbtAddressBoxWidget methodsFor: 'compatibility' stamp: 'hk 1/18/2016 13:18'!
signalChangeToOwner
	""! !

!GbtAddressBoxWidget methodsFor: 'accessing' stamp: 'hk 1/13/2016 16:15'!
singleHeight
	^self class toolbarHeight! !

!GbtAddressBoxWidget methodsFor: 'accessing' stamp: 'hk 1/18/2016 11:18'!
slotName: aSymbol
	slotName := aSymbol! !

!GbtAddressBoxWidget methodsFor: 'accessing' stamp: 'hk 1/13/2016 15:34'!
slotVO: anObject
	slotVO := anObject! !

!GbtAddressBoxWidget methodsFor: 'initialization' stamp: 'hk 10/20/2017 12:03'!
someValueHasChanged  
	"GbtWidget compatibility"! !

!GbtAddressBoxWidget methodsFor: 'accessing' stamp: 'hk 1/19/2016 11:51'!
widgetHeight
	^wh! !

DynamicComposableModel subclass: #GbtCustomSDBoxWidget
	instanceVariableNames: 'slotVO wh'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing'!

!GbtCustomSDBoxWidget commentStamp: 'hk 2/24/2016 16:25' prior: 0!
I display the service Data ahead all aspects

    Instance Variables
	slotVO:		<Object>
	wh:		<Object>

=======================================

SVO initializeAll.
(self on: IntegrationTestThings serviceData_BtoHB_2Items ) openWithSpec!

!GbtCustomSDBoxWidget class methodsFor: 'instance creation' stamp: 'hk 4/15/2017 14:40'!
on: aVO 
	^self on: aVO key: #key for: #() tags: #()! !

!GbtCustomSDBoxWidget class methodsFor: 'instance creation' stamp: 'hk 6/12/2016 15:20'!
on: aVO key: aSymbol for: anArray tags: void
	^self basicNew 
		slotVO: aVO; 
		initialize! !

!GbtCustomSDBoxWidget class methodsFor: 'instance creation' stamp: 'hk 1/25/2016 14:57'!
on: aVO label: aString
	^self on: aVO! !

!GbtCustomSDBoxWidget class methodsFor: 'instance creation' stamp: 'hk 2/23/2016 15:58'!
on: aVO stopSlots: anObject
	^self on: aVO ! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 9/8/2017 13:30'!
contentChanged
	"compatibility with GbtThingEditor & GbtItemUI"
	^nil asValueHolder ! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/25/2016 14:15'!
dividerHeight
	^8! !

!GbtCustomSDBoxWidget methodsFor: 'initialization' stamp: 'hk 1/28/2016 13:44'!
initializeLayout
	self layout: (SpecLayout composed newColumn: [ :col| col 
		newRow: [ :r | r 
			add: #serviceData width: self labelWidth1;
			add: #serviceDataStatus width: self labelWidth0;
			add: #serviceDataStatusCont width: self labelWidth1;
			add: #serviceDataSummary
			] height: self singleHeight;
		newRow: [ :r | r add: #divider1 ] height: self dividerHeight;
		newRow: [ :r | r
			add: #transport width: self labelWidth1;
			add: #transportSummary;
			add: #editButton width: 24 
			] height: self singleHeight;
		newRow: [ :r | r
			add: #shipment width: self labelWidth1;
			add: #shipmentSummary 
			] height: self singleHeight;
		newRow: [ :r | r add: #divider2 ] height: self dividerHeight;
		newRow: [ :r | r
			add: #emptyLabel width: self insetWidth;
			add: #routeDate width: self labelWidth2;
			add: #routeDateSummary 
			] height: self singleHeight;
		newRow: [ :r | r add: #divider3 ] height: self dividerHeight;
		newRow: [ :r | r 
			newColumn: [ :c | c ] width: self insetWidth;
			newColumn: [ :c | c
				newRow: [ :r1 | r1 
					newColumn: [ :c1 | c1 add: #origin ] width: self labelWidth1;
					newColumn: [ :c1 | c1 
						add: #pickupLocation;
						add: #pickupDateTime
						] ] ];
			newColumn: [ :c | c add: #divider4] width: self dividerHeight;
			newColumn: [ :c | c 
				newRow: [ :r1 | r1 
					newColumn: [ :c1 | c1 add: #destination ] width: self labelWidth1;
					newColumn: [ :c1 | c1
						add: #destLocation;
						add: #destDateTime						
						] ] ]
			] height: 2 * self singleHeight;
		newRow: [ :r | r add: #emptyLabel ]
	]).
	wh := 6 * self singleHeight + (4 * self dividerHeight)! !

!GbtCustomSDBoxWidget methodsFor: 'initialization' stamp: 'hk 4/30/2016 18:29'!
initializeWidgets
	|tr|
	slotVO serviceDataItems list ifEmpty: [ slotVO serviceDataItems newEntry ].
	tr := slotVO serviceDataItems list first.		"needs to be extendet !!!!!! "
	self instantiateModels: #(
		editButton	ButtonModel 
		divider1 		ButtonModel
		divider2 		ButtonModel
		divider3 		ButtonModel
		divider4 		ButtonModel
		divider5 		ButtonModel
		emptyLabel	LabelModel
		serviceData	LabelModel
		serviceDataSummary			LabelModel
		serviceDataStatus			LabelModel
		serviceDataStatusCont		LabelModel
		transport		LabelModel
		transportSummary			LabelModel
		shipment		LabelModel
		shipmentSummary				LabelModel
		routeDate		LabelModel
		routeDateSummary			LabelModel
		origin			LabelModel
		pickupLocation				LabelModel
		pickupDateTime				LabelModel
		destination	LabelModel
		destLocation					LabelModel
		destDateTime					LabelModel
		).
	self editButton 
		icon: (GbtIcons at: #edit) ;
		action: [(GbtThingDiEditor on: tr) openWithSpec ];
		state: true.
	self divider1 state: true.
	self divider2 state: true.
	self divider3 state: true.
	self divider4 state: true.
	self divider5 state: true.
		self serviceData label: #ServiceData.
		self serviceDataSummary label: slotVO summaryEnriched.
		self serviceDataStatus label: #ASPECT:.
		self serviceDataStatusCont label: slotVO aspectStatus.
		self transport label: #Transport.
		self transportSummary label: tr summaryEnriched.
		self shipment label: #Shipment.
		self shipmentSummary label: tr serviceDataItemTransportHeader summaryEnriched.
		self routeDate label: 'Shipment Route & Date'.
		self routeDateSummary label: tr shipmentRouteAndDate summaryEnriched.
		self origin label: #Origin.
		self pickupLocation label: tr pickupLocation summaryEnriched.
		self pickupDateTime label: tr pickupDateAndTime summaryEnriched.
		self destination label: #Destination.
		self destLocation label: tr deliveryLocation summaryEnriched.
		self destDateTime label: tr deliveryDateAndTime summaryEnriched.
	
	self initializeLayout
	

! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/26/2016 11:47'!
insetWidth
	^20! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/26/2016 11:59'!
labelWidth0
	^60! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/26/2016 11:59'!
labelWidth1
	^120! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/26/2016 11:43'!
labelWidth2
	^160! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/25/2016 14:01'!
singleHeight
	^self class toolbarHeight! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/25/2016 13:23'!
slotVO: aVO
	slotVO := aVO! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/26/2016 11:56'!
white
	^(BorderedMorph new color: Color white) asSpecAdapter! !

!GbtCustomSDBoxWidget methodsFor: 'accessing' stamp: 'hk 1/25/2016 14:48'!
widgetHeight
	^wh! !

DynamicComposableModel subclass: #GbtEmptyWidget
	instanceVariableNames: 'slotName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing-Leaves'!

!GbtEmptyWidget commentStamp: 'hk 1/21/2016 14:47' prior: 0!
I displayx an empty smart slot

    Instance Variables
	slotName:		<String>
!

!GbtEmptyWidget class methodsFor: 'instance creation' stamp: 'hk 1/15/2016 17:00'!
key: aSlotName
	^self basicNew 
		slotName: aSlotName;
		initialize! !

!GbtEmptyWidget methodsFor: 'initialization' stamp: 'hk 1/16/2016 13:51'!
contentLayout: aRow
	aRow add: #emptyLabel! !

!GbtEmptyWidget methodsFor: 'initialization' stamp: 'hk 1/16/2016 13:47'!
initializeCommonWidgets
	self instantiateModels: #( 
	emptyLabel	LabelModel
	button			ButtonModel
	label			LabelModel) ! !

!GbtEmptyWidget methodsFor: 'initialization' stamp: 'hk 1/20/2016 14:53'!
initializeLayout
	self layout: (SpecLayout composed newRow: [ :row |  row
		newColumn: [ :c | c
			newRow: [ :r | 
				r add: #button width: 24.
				r add: #label.
				self purposeLayout: r]] width: 160;
		newColumn: [ :c |  ] width: 24;
		newColumn: [ :c | c
			newRow: [ :r | self contentLayout: r] height: self widgetHeight ] ] 
		).
	self needRebuild: false ! !

!GbtEmptyWidget methodsFor: 'initialization' stamp: 'hk 5/13/2017 14:50'!
initializeWidgets
	self initializeCommonWidgets.
		
	self label label: slotName .
	self button 
		icon: (GbtIcons at: #add);
		action: [ self owner addFromFull: slotName ].
	self initializeLayout
! !

!GbtEmptyWidget methodsFor: 'initialization' stamp: 'hk 1/16/2016 13:53'!
purposeLayout: aRow! !

!GbtEmptyWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 16:50'!
singleHeight
	^self class toolbarHeight! !

!GbtEmptyWidget methodsFor: 'accessing' stamp: 'hk 2/22/2017 12:09'!
slotName
	^slotName ! !

!GbtEmptyWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 16:51'!
slotName: anObject
	slotName := anObject! !

!GbtEmptyWidget methodsFor: 'accessing' stamp: 'hk 1/20/2016 13:15'!
widgetHeight
	^self singleHeight ! !

GbtEmptyWidget subclass: #GbtSlotWidget
	instanceVariableNames: 'slotVO purposes tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing-Leaves'!

!GbtSlotWidget commentStamp: 'hk 11/30/2017 11:28' prior: 0!
I displayx a filled smart slot

    Instance Variables
	purposes:	<OrderedCollection>			first entry = selection
	slotVO:		<GbtCell | GbtSmartNode>		only used on startup to initialize subwidget
	tags: 		<nil | Array of String>!

!GbtSlotWidget class methodsFor: 'instance creation' stamp: 'hk 4/15/2017 14:41'!
on: aVO key: aSymbol for: anArray tags: aColl
	^self basicNew 
		slotVO: aVO; 
		slotName: aSymbol; 
		purposes: anArray;
		tags: aColl ;
		initialize
! !

!GbtSlotWidget methodsFor: 'adding' stamp: 'hk 5/13/2017 13:48'!
addPurpose: aString
	purposes remove: aString ifAbsent: []. 
	purposes addFirst: aString .
	(owner smartVO slotAt: slotName) purposes: purposes! !

!GbtSlotWidget methodsFor: 'ui actions' stamp: 'hk 1/16/2016 13:11'!
chooseNewPurpose
	| purp |
	purp := (self choosePurposeFrom: self purposes) ifNil: [^self].
	self addPurpose: purp.
	self label label: self labelContent.
	self needFullRebuild: false.
	(widgets at: #label) needRebuild: true.
	self buildWithSpec! !

!GbtSlotWidget methodsFor: 'ui actions' stamp: 'hk 1/15/2016 16:55'!
choosePurposeFrom: aList
	"^nil or the chosen purpose"
	
	^UIManager default 
				chooseOrRequestFrom: aList 
				title: 'choose a purpose'.! !

!GbtSlotWidget methodsFor: 'initialization' stamp: 'hk 10/6/2016 15:41'!
contentLayout: aRow
	aRow add: #subWidget ! !

!GbtSlotWidget methodsFor: 'testing' stamp: 'hk 11/1/2016 17:39'!
hasPurposes
	^self purposes isNotEmpty 
! !

!GbtSlotWidget methodsFor: 'initialization' stamp: 'hk 11/27/2017 21:22'!
initializeWidgets
	| sw |
	self initializeCommonWidgets.
	self instantiateModels: #(purpChooseButton 	ButtonModel) .
	(sw := slotVO uiClass basicNew)
				slotVO: slotVO; 
				owner: self;
				label: slotName;
				initialize.		
	self assign: sw to: #subWidget.	
	slotVO := nil.	"der Mohr hat seine Schuldigkeit getan"					
	self label label: self labelContent.
	self button 
		icon: (GbtIcons at: #delete);
		action: [ self owner remove: slotName ].
	self purpChooseButton 
		icon: (GbtIcons at: #goto);
		action: [ self chooseNewPurpose ];
		state: false.
	self focusOrder add: self subWidget.
	self initializeLayout
! !

!GbtSlotWidget methodsFor: 'initialization' stamp: 'hk 6/12/2016 15:07'!
labelContent
	^self hasPurposes 
		ifFalse: [slotName, self tagString] 
		ifTrue: [self selectedPurpose, self tagString].! !

!GbtSlotWidget methodsFor: 'initialization' stamp: 'hk 1/16/2016 13:55'!
purposeLayout: aRow
	self hasPurposes ifTrue: [ aRow add: #purpChooseButton width: 20]! !

!GbtSlotWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 16:58'!
purposes
	^purposes ifNil: [purposes := OrderedCollection new]! !

!GbtSlotWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 16:57'!
purposes: anArrayOfString
	purposes := anArrayOfString asOrderedCollection! !

!GbtSlotWidget methodsFor: 'initialization' stamp: 'hk 10/20/2017 12:57'!
putChangeFlagOn
	self subWidget changeFlag ifNotNil: [:cf| cf whenChangedDo: [self owner someValueChanged: true]]! !

!GbtSlotWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 17:06'!
selectedPurpose
	^purposes at: 1 ifAbsent: [^nil] ! !

!GbtSlotWidget methodsFor: 'accessing' stamp: 'hk 1/15/2016 16:57'!
slotVO: anObject
	slotVO := anObject! !

!GbtSlotWidget methodsFor: 'initialization' stamp: 'hk 10/20/2017 13:04'!
someValueHasChanged  
	self subWidget read! !

!GbtSlotWidget methodsFor: 'accessing' stamp: 'hk 11/1/2016 17:44'!
tagString
	| res |
	res := WriteStream on: ''.
	tags ifNotNil: 
		[res nextPut: $(. 
		tags do: [:t| res nextPutAll: t; nextPut: $ ].
		res nextPut: $)].
	^res contents! !

!GbtSlotWidget methodsFor: 'accessing' stamp: 'hk 11/30/2017 11:24'!
tags: anArrayOrNil
	tags := anArrayOrNil! !

!GbtSlotWidget methodsFor: 'accessing' stamp: 'hk 10/6/2016 15:38'!
widgetHeight
	 ^self subWidget widgetHeight! !

DynamicComposableModel subclass: #GbtTableListUI
	instanceVariableNames: 'list emptyLabel header displayColumns titleColumns template'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtTableListUI commentStamp: 'hk 1/13/2017 12:28' prior: 0!
A TableListUI is a list widget with row titles 
(may be replaced by a more sophisticated widget).

Hence the list items must respond to: 			This dependence can be weakened
-  displayArray and 								by introducing two inst vars:
-  displayLabelArray 							- one for the displayBlock of the list 
and it must carry an automatic id !!!!!!				- one for the header text (asReactiveVar))

Instance Variables
	emptyLabel:		<LabelModel> 				needed for fill in the blanks
	list:				<MultiColumnListModel>	
	header: 			<LabelModel>
	displayColumns: 	<Array of Symbol | nil>		for list display & filtering
	titleColumns: 	<Array of Symbol | nil>		for list header
	template: 		<GbtThing> 					for list elements

======= Tests ======

| ct |
(ct := GCContact  contact) copy .
(TableListUI new items: ct copies asOrderedCollection ) openWithSpec!

!GbtTableListUI class methodsFor: 'instance-creation' stamp: 'hk 6/8/2017 14:13'!
on: aTemplateThing columns: displayColumns
	^self basicNew addTemplate: aTemplateThing ; displayColumns: displayColumns ! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 6/8/2017 14:13'!
addTemplate: aThing
	template := aThing! !

!GbtTableListUI methodsFor: 'drop down filters' stamp: 'hk 1/13/2017 16:48'!
dcWidth
		^self class  buttonWidth *2
! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 7/1/2016 12:26'!
displayColumns
	^displayColumns ! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 1/13/2017 16:04'!
displayColumns: argArray
	"the argArray contains Symbols or Pairs of display and title symbol"
	displayColumns := argArray collect: [:e| e isArray ifTrue: [e first] ifFalse: [e]].
	titleColumns := argArray collect: [:e| e isArray ifTrue: [e second] ifFalse: [e]]
! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 2/14/2015 18:08'!
emptyLabel
	^ emptyLabel! !

!GbtTableListUI methodsFor: 'drop down filters' stamp: 'hk 1/13/2017 16:25'!
filterList: aSlotName for: aValue
	owner filteredList: aSlotName for: aValue
! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 2/15/2015 17:00'!
header
	^ header ! !

!GbtTableListUI methodsFor: 'initialization' stamp: 'hk 1/13/2017 16:46'!
headerRow: aColumn
	aColumn newRow: [:r| 
		r add: #header width: self dcWidth.
		displayColumns do: [:dc| r add: dc asSymbol width: self dcWidth ].
		r add: #emptyLabel
	] height: self class toolbarHeight ! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 8/26/2016 13:19'!
height
	^(((self list listSize max:2) / 2) min: 5)* self class toolbarHeight! !

!GbtTableListUI methodsFor: 'initialization' stamp: 'hk 1/13/2017 19:08'!
initializeColumnFilters
	1 to: titleColumns size do: [:i|  |w dc tc|
		dc := displayColumns at: i.
		tc := titleColumns at: i.
		self instantiateModels: { dc . #DropListModel }.
		w := widgets at: dc asSymbol.
		w addItemLabeled: tc do: [self resetList; resetDropDownListFor: dc ]].		"first item"
	self resetDropDownLists ! !

!GbtTableListUI methodsFor: 'initialization' stamp: 'hk 1/13/2017 16:33'!
initializeLayout
	self layout: (SpecLayout composed
		newColumn: [ :c | 
			self headerRow: c .  
			c  add: #list  ] )! !

!GbtTableListUI methodsFor: 'initialization' stamp: 'hk 1/13/2017 17:51'!
initializeWidgets
	emptyLabel := self newLabel  .
	list := self newMultiColumnList  .	
	header := self newLabel label: #bizId.	
	self initializeColumnFilters .	
	list displayBlock: [:item| self wrapItem: (item displayArrayFrom: self displayColumns)] .
	list menu: [ :m | self listMenu: m ] .
	self focusOrder add: list .
	self needFullRebuild: false . 
	self initializeLayout! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 2/14/2015 17:15'!
items: aCollection
	list items: aCollection! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 2/14/2015 18:08'!
list
	^ list! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 2/21/2015 14:38'!
listItems
	^list listItems! !

!GbtTableListUI methodsFor: 'initialization' stamp: 'hk 1/6/2017 18:09'!
listMenu: m
	| item |
	item := m add: #inspect target: self selectedItem selector: #inspect .
	item enablementSelector: [ self selectedItem isNotNil ] .
	^m! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 12/5/2016 13:40'!
listSize
	^list listSize! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 2/14/2015 18:02'!
menu:  aBlock
	" [ :menu :shifted | nil ] "
	list menu: aBlock  ! !

!GbtTableListUI methodsFor: 'drop down filters' stamp: 'hk 1/13/2017 19:03'!
resetDropDownListFor: aSlot
	| dropList first wgt |
	wgt := widgets at: aSlot asSymbol.
	dropList := wgt getList. 
	first := dropList first.
	dropList removeAll; add: first.
		(self valuesOf: aSlot) do: [:v|		"other items"
				wgt addItemLabeled: v 
					 do: [self filterList: aSlot for: v]]
	
	
	! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 1/13/2017 19:07'!
resetDropDownLists
	displayColumns do: [:dc| self resetDropDownListFor: dc ]! !

!GbtTableListUI methodsFor: 'drop down filters' stamp: 'hk 1/13/2017 16:14'!
resetList
	owner resetList.
	"erzeuge die dropdown listen neu"! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 3/27/2015 16:46'!
resetSelection
	list resetSelection! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 6/10/2015 10:18'!
selectedItem
	^list selectedItem! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 2/21/2015 14:42'!
setSelectedItem: anItem
	list setSelectedItem: anItem! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 3/23/2015 12:09'!
size
	^self list listSize ! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 1/13/2017 12:28'!
template
	^ template! !

!GbtTableListUI methodsFor: 'api' stamp: 'hk 11/1/2016 16:49'!
title
	^#TableList! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 7/1/2016 13:04'!
titleColumns
	^titleColumns ! !

!GbtTableListUI methodsFor: 'drop down filters' stamp: 'hk 1/13/2017 16:41'!
valuesOf: aSlot
	^owner context valuesOf: aSlot! !

!GbtTableListUI methodsFor: 'accessing' stamp: 'hk 8/10/2015 17:36'!
view
	^displayColumns ! !

!GbtTableListUI methodsFor: 'api-events' stamp: 'hk 12/3/2016 20:11'!
whenListChanged: aBlock
	list whenListChanged: aBlock! !

!GbtTableListUI methodsFor: 'api-events' stamp: 'hk 2/14/2015 17:18'!
whenSelectedItemChanged: aBlock
	list whenSelectedItemChanged: aBlock! !

!GbtTableListUI methodsFor: 'api-events' stamp: 'hk 1/9/2017 16:23'!
whenSelectionChanged: aBlock
	list whenSelectionChanged: aBlock! !

!GbtTableListUI methodsFor: 'private' stamp: 'hk 8/2/2017 16:18'!
wrapItem: anArray
	"set all strings of anArray to equal size"
	
	^anArray collect: [ :s | s asString padRightTo: 45 ] 
	
	
	! !

DynamicComposableModel subclass: #GbtTemplatesEditor
	instanceVariableNames: 'thingList thing slotList headline templateList slot headIcon emptyLabel hasTemplateEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtTemplatesEditor commentStamp: 'hk 8/21/2016 15:12' prior: 0!
I am a system special editor to manage the pre- and user defined templates
I allow to delete and modify them. Creation is in a concrete business context on the fly.

    Instance Variables
	headIcon:		<Object>
	headline:		<Object>
	slot:				<Object>	selected slot
	slotList:			<Object>	slots of the thing that carry templates
	templateList:	<Object>	all templates found
	thing:			<Object>	selected thing
	thingList:		<Object>	of the things that carry templates


    Implementation Points!

!GbtTemplatesEditor methodsFor: 'testing' stamp: 'hk 8/21/2016 19:03'!
clearTemplateEditor 
	hasTemplateEditor := false.
	self reBuild! !

!GbtTemplatesEditor methodsFor: 'menu' stamp: 'hk 11/30/2017 13:33'!
deleteSelectedTemplate 
	self slot thingTemplates remove: templateList selectedItem.
	templateList items: self templateListItems ; resetSelection! !

!GbtTemplatesEditor methodsFor: 'menu' stamp: 'hk 12/16/2016 18:50'!
editSelectedTemplate 
	| vo |
	vo := templateList selectedItem ifNil: 
		[hasTemplateEditor := false.
		^self reBuild].
	self assign: (GbtThingEditor on: vo) to: #subUi.
	hasTemplateEditor := true.
	self reBuild.! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/21/2016 18:25'!
emptyLabel
	^emptyLabel ! !

!GbtTemplatesEditor methodsFor: 'testing' stamp: 'hk 8/21/2016 18:27'!
hasTemplateEditor 
	^hasTemplateEditor = true! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/3/2016 13:19'!
headIcon 
	^headIcon ! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/3/2016 11:08'!
headline 
	^headline! !

!GbtTemplatesEditor methodsFor: 'initialization' stamp: 'hk 8/21/2016 18:45'!
initializeLayout
	self layout: (SpecLayout composed newColumn: [ :c |  c
			newRow: [:r| r
					add: #headIcon width: 24;
					add: #headline ] height: self class toolbarHeight;
			newRow: [:r| r
					add: #thingList;
					add: #slotList ;
					add: #templateList].
			self hasTemplateEditor 
				ifTrue: [ c add: #subUi ] 
				ifFalse: [ c add: #emptyLabel ] ];
		yourself)! !

!GbtTemplatesEditor methodsFor: 'initialization' stamp: 'hk 8/21/2016 19:42'!
initializePresenter
	thing whenChangedDo: [slotList	items: self slotListItems; resetSelection ].
	thingList whenSelectedItemChanged: [:item| thing value: item ].

	slot whenChangedDo: [templateList resetSelection; items: self templateListItems] .
	slotList whenSelectedItemChanged: [:item| slot value: item] .
	
	templateList whenSelectedItemChanged: [:item| self editSelectedTemplate ] .! !

!GbtTemplatesEditor methodsFor: 'initialization' stamp: 'hk 3/15/2017 10:14'!
initializeWidgets
	"GbtTemplatesEditor new openWithSpec"
	(headIcon := self newButton)
		icon: (GbtIcons at: #settings).
	(headline := self newLabel)
		label: 'Edit or Remove Templates'.
	thing := nil asValueHolder .
	thingList	 := self newList
		items: self tmplHolders;
		autoDeselect: true;
		displayBlock: [:item | item svoName].
	slot := nil asValueHolder .
	slotList	:= self newList 
		items: self slotListItems;
		autoDeselect: true;
		displayBlock: [:item | item key].
	templateList := self newList
		items: self templateListItems ;
		autoDeselect: true;
		displayBlock: [:item| item isString ifTrue: [item] ifFalse: [item summary] ];
		menu: [:m | self templateListMenu: m ] . 
	emptyLabel := self newLabel.
	self initializeLayout! !

!GbtTemplatesEditor methodsFor: 'initialization' stamp: 'hk 8/21/2016 18:35'!
reBuild
	self initializeLayout.
	self needFullRebuild: false .
	self buildWithSpec! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/3/2016 12:22'!
slot
	^slot value! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/3/2016 11:05'!
slotList 
	^slotList! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 11/22/2016 16:31'!
slotListItems
	^self thing ifNil: [#()] ifNotNil: [self thing allSlotAssocsWithTemplates]
	! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/3/2016 11:27'!
templateList
	^templateList ! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 11/30/2017 13:33'!
templateListItems
	^self slot ifNil: [#()] ifNotNil: [self slot thingTemplates]
	! !

!GbtTemplatesEditor methodsFor: 'menu' stamp: 'hk 12/1/2017 02:30'!
templateListMenu: m 
	| item  |
	item := m add: #remove target: self selector: #deleteSelectedTemplate .
	item enablementSelector: [ self templateList selectedItem isNotNil ] .
	^m! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/3/2016 11:16'!
thing 
	^thing value! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 8/3/2016 11:06'!
thingList
	 ^thingList ! !

!GbtTemplatesEditor methodsFor: 'accessing' stamp: 'hk 3/17/2017 12:13'!
tmplHolders
	| app |
	app := owner context bizApp.
	^app asOrderedCollection 
		addAll: app allFsvosWithTemplates; 
		yourself! !

DynamicComposableModel subclass: #GbtThingDiEditor
	instanceVariableNames: 'vo stopSlots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing'!

!GbtThingDiEditor commentStamp: 'hk 5/24/2017 13:24' prior: 0!
I am an IphoneEditor with 2 panes,
the right pane for node editing

    Instance Variables
	stopSlots:		<Array of Symbolo> 		the slots not to show
	vo:				<GbtThing>				to be edited
									
Implementation Points:
  	 editor 2 cannto react on a save/store in editor 1
	because the vo cannot be reloaded without knowing the slotName!

!GbtThingDiEditor class methodsFor: 'instance creation' stamp: 'hk 11/23/2015 16:35'!
on: aVO 
	^self basicNew 
		vo: aVO; 
		initialize
! !

!GbtThingDiEditor class methodsFor: 'instance creation' stamp: 'hk 2/23/2016 15:53'!
on: aVO stopSlots: arrayOfSlotNames
	^self basicNew 
		vo: aVO; 
		stopSlots: arrayOfSlotNames;
		initialize
! !

!GbtThingDiEditor methodsFor: 'adding' stamp: 'hk 1/19/2016 12:19'!
addRowDivider: aRow width: aNumber
	"corresponding method: vDivider"
	aRow newColumn: [:c| c add: #vDivider] width: aNumber! !

!GbtThingDiEditor methodsFor: 'accessing' stamp: 'hk 5/12/2017 13:42'!
contentChanged
	^self editor1 contentChanged! !

!GbtThingDiEditor methodsFor: 'accessing' stamp: 'hk 1/9/2018 20:53'!
contentChanged: aBoolean
	^self editor1 contentChanged: aBoolean! !

!GbtThingDiEditor methodsFor: 'ui actions' stamp: 'hk 6/14/2016 13:51'!
editRight: aVO 
	self editor1 resetEditButton.
	self assign: (GbtThingEditor on: aVO) to: #editor2.
	self initializeLayout .
	self initializeRightPresenter .
	self needFullRebuild: false.
	self buildWithSpec
! !

!GbtThingDiEditor methodsFor: 'api' stamp: 'hk 11/23/2015 16:41'!
initialExtent
		^ (widgets at: #editor1) initialExtent * (2@1) + (24@0)! !

!GbtThingDiEditor methodsFor: 'initialization' stamp: 'hk 1/22/2016 11:57'!
initializeLayout
	self layout: (SpecLayout composed newRow: [ :r | 
		r newColumn:  [ :c | c add: #editor1].
		self addRowDivider: r width: 8.
		r addSplitter.
		r newColumn:  [ :c | c add: #editor2]]).
	self needFullRebuild: false 
		 
! !

!GbtThingDiEditor methodsFor: 'initialization' stamp: 'hk 5/24/2017 13:11'!
initializeRightPresenter
	self editor2 slotwidgets do: 
		[:w | w subWidget changeFlag whenChangedDo: 
			[self editor2 someValueChanged: true]	 ].
	self editor2 someValueChanged whenChangedDo: 
		[self editor1 someValueChanged: true ].
	self editor2 contentChanged whenChangedDo: 
		[self editor1 someValueChanged: true. "sorgt für die Berechungen"
		self editor1 contentChanged: true]! !

!GbtThingDiEditor methodsFor: 'initialization' stamp: 'hk 4/30/2016 16:48'!
initializeWidgets
	self instantiateModels: #(vDivider ButtonModel).
	self assign: (GbtThingEditor on: vo stopSlots: self stopSlots) to: #editor1.
	self assign: (LabelModel new) to: #editor2.
	self editor1 editBlock: [:v|(self class on: v) openWithSpec].
	self editor1 slotEditBlock: [:v|self editRight: v].
	self vDivider state: true.
	self initializeLayout

	! !

!GbtThingDiEditor methodsFor: 'accessing' stamp: 'hk 2/23/2016 15:54'!
stopSlots
	^stopSlots ifNil: [ #() ]! !

!GbtThingDiEditor methodsFor: 'accessing' stamp: 'hk 2/23/2016 15:52'!
stopSlots: anArrayOfSlotNames
	stopSlots := anArrayOfSlotNames! !

!GbtThingDiEditor methodsFor: 'accessing' stamp: 'hk 1/21/2016 18:32'!
vDividerMorph
    | morph |
    
    morph := BorderedMorph new 
					color: Color white;
					borderColor: Color black;
					bounds: (0@0 extent: 4@ (self initialExtent y) ).
	
    ^ morph asSpecAdapter! !

!GbtThingDiEditor methodsFor: 'accessing' stamp: 'hk 11/23/2015 16:45'!
vo: aVO
	vo := aVO! !

DynamicComposableModel subclass: #GbtThingEditor
	instanceVariableNames: 'smartVO fullVO widgetHeight editBlock someValueChanged slotEditBlock stopSlots consistent redoStack contentChanged'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing'!

!GbtThingEditor commentStamp: 'hk 5/13/2017 17:39' prior: 0!
the iPhone editor for smart things allows to add and remove (smart) slots that are defined in the full thing

Instance Variables
	smartVO:			<ThingVO>
	fullVO:				<ThingVO>				the master of smartVO (cache)
	widgetHeight:		<Number>				used in  layout 
	editBlock:			<Block>
	contentChanged: 	<ValueHolder> 			used to update gui owners
	someValueChanged:	<ValueHolder> 			used to update smartVO  slots
	consistent: 			<ValueHolder>
	slotEditBlock:		<Block>
	stopSlots:			<Object>
	redoStack: 			<OrdferedCollection> 		of undone SVOs

GUI updates:
1. all slots have a changeFlag.
2. any change of the changeFlag sets someValueChanged = true.
3. in turn all slots are notified 'someValueHasChanged'.
3. all Calc widgets recalculate (and eventually change their value).
4 this loops until nothing changes any more

GUI functions must update the widget when necessary, cf. GbtCalcWidget>>chooseNewCalcInput.

Domain functions use GbtActiveContext>>refreshUI
=============================

|th|
GbtSVO initializeAll.
th := GbtThing newStruct: 'some' define: { 
		{ #street . #val: . ''}.		
		{ #streetNo . #val: . ''}.
		{ #cityCode . #val: . ''}.		
		{ #cityName . #enum: .  #(one two) }.
		{ #cityCode . #date: . Date today}.		
	}.
(self on: th ) openWithSpec 
!

GbtThingEditor subclass: #GbtCIELEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing'!

!GbtCIELEditor class methodsFor: 'as yet unclassified' stamp: 'hk 11/1/2017 15:05'!
title
	^ 'Behavior Editor'! !

!GbtCIELEditor methodsFor: 'ui actions' stamp: 'hk 11/1/2017 14:55'!
checkConsistency! !

!GbtCIELEditor methodsFor: 'ui actions' stamp: 'hk 11/1/2017 14:59'!
checkUndoRedo! !

!GbtCIELEditor methodsFor: 'accessing' stamp: 'hk 12/13/2017 15:44'!
cielSubWidgets
	^self widgets select: [:w| w isKindOf: GbtSlotWidget] thenCollect: [:w| w subWidget]! !

!GbtCIELEditor methodsFor: 'ui actions' stamp: 'hk 11/1/2017 14:39'!
consistencyHelp! !

!GbtCIELEditor methodsFor: 'ui actions' stamp: 'hk 12/13/2017 17:21'!
content
	self cielSubWidgets do: [:e| e read]! !

!GbtCIELEditor methodsFor: 'initialization' stamp: 'hk 12/13/2017 17:24'!
initializeWidgets
	self instantiateModels: #(
		keyLegend 	LabelModel
		contentButton 	ButtonModel
		sourceButton 	ButtonModel).
	self keyLegend label: '<debug: meta-d, source: meta-e, content: esc>'.
	self contentButton 
		icon: (GbtIcons at: #content) ;
		action: [self content];
		help: 'calculated content';
		state: true.
	self sourceButton 
		icon: (GbtIcons at: #source) ;
		action: [self source];
		help: 'source';
		state: true.
	super initializeWidgets! !

!GbtCIELEditor methodsFor: 'initialization' stamp: 'hk 12/13/2017 17:38'!
nameAndButtonRow: aColumn
	aColumn newRow: [ :r | r 
				add: #voName   ;
				add: #keyLegend ;
				add: #contentButton width: 28;
				add: #sourceButton width: 28;
				add: #inspectUi width: 48;
				add: #inspectVo width: 48
			] height: self singleHeight 
! !

!GbtCIELEditor methodsFor: 'ui actions' stamp: 'hk 12/13/2017 15:46'!
source
	self cielSubWidgets do: [:e| e readInput]! !

!GbtThingEditor class methodsFor: 'instance creation' stamp: 'hk 1/23/2016 18:56'!
on: aVO 
	^self basicNew 
		slotVO: aVO; 
		initialize
! !

!GbtThingEditor class methodsFor: 'instance creation' stamp: 'hk 1/23/2016 19:11'!
on: aVO label: aString
	^self on: aVO! !

!GbtThingEditor class methodsFor: 'instance creation' stamp: 'hk 2/23/2016 15:55'!
on: aVO stopSlots: arrayOfSlotNames
	^self basicNew 
		slotVO: aVO; 
		stopSlots: arrayOfSlotNames;
		initialize
! !

!GbtThingEditor class methodsFor: 'specs' stamp: 'hk 1/15/2016 16:43'!
title
	^ 'Smart Thing Editor'! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 8/3/2017 15:19'!
addFromFull: aSlotName
	"add a fullThing slot to smartThing"
	self expand: aSlotName. 
	self assignSlot: aSlotName.
	self reBuildFor: aSlotName.

! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 5/14/2017 14:10'!
assignEmptySlot: slotName
	| wl widg |
	wl := self wLabelFor: slotName.
	widg := GbtEmptyWidget key: slotName.
	self assign: widg to: wl.
	self focusOrder add: widg! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 10/20/2017 12:16'!
assignSlot: slotName
	| newSlot tags widg pcoll |
	newSlot := self smartVO slotSVOAt: slotName. 
	tags := self smartVO tagsAtSlot: slotName.
	pcoll := (fullVO slotAt: slotName) 
		ifNil: [#()] 
		ifNotNil: [:sl| sl purposes].
	widg := GbtSlotWidget
		on: newSlot
		key: slotName
		for: pcoll
		tags: tags.
	self assign: widg to: (self wLabelFor: slotName) .
	widg putChangeFlagOn.	
	self focusOrder add: widg! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 5/13/2017 13:52'!
checkConsistency
	self smartVO checkConstraints.
	consistent value: self smartVO isConsistent.! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 5/19/2017 19:01'!
checkUndoRedo
	self smartVO next 
		ifNil: [self redoButton disable] 
		ifNotNil: [self redoButton enable].
	self smartVO previous
		ifNil: [self undoButton disable] 
		ifNotNil: [self undoButton enable] 
		! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 8/3/2017 16:34'!
chooseFromContext: aSlotName okAction: okBlock cancelAction: cancelBlock
	| ctxt dialogWindow |
	ctxt := (self contextChoiceOf: aSlotName)  second. 
	dialogWindow := (GbtListUI on: ctxt) openDialogWithSpec .
	dialogWindow 
		okAction: [okBlock value: dialogWindow model selection];
		cancelAction: cancelBlock;
		title: ctxt displayName  ;
		centeredRelativeTo: self currentWorld ;
		modalRelativeTo: self currentWorld! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 11/15/2017 17:15'!
consistencyHelp
	consistent  value ifNil: [^'unchecked'].
	consistent value ifTrue: [^'consistent'] .
	^self smartVO violationString! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 7/5/2016 20:16'!
consistencyIcon
	^(consistent value ifNil: [^GbtIcons at: #constrYellow ])
		ifTrue: [ GbtIcons at: #constrGreen] 
		ifFalse: [ GbtIcons at: #constrRed ]! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 5/12/2017 13:42'!
contentChanged
	^contentChanged! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 5/15/2017 23:04'!
contentChanged: aBoolean   
	^contentChanged value: aBoolean! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 10/16/2017 13:02'!
context
	^self smartVO embeddingContext ! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 10/16/2017 13:02'!
contextChoiceOf: aSlotName
	"answer the choice context if there or nil"

	^(self context ifNil: [^nil]) choiceContextAt: aSlotName ifAbsent: [].
! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 1/21/2016 18:53'!
editBlock: aBlock
	editBlock := aBlock! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 11/23/2017 11:28'!
editor1
	"DiEditor compatibility in tests"! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 11/23/2017 11:03'!
expand: aSlotName
	"expand smartVO, use choiceContext or thing templates"

	| choiceArr  choice  slot|
	slot := self smartVO expandSVO: aSlotName.  
	"new expand hook"
	(self expandBehaviorFor: aSlotName) 
		ifNil: ["here goes the template choice"]
		ifNotNil: [:beh| self smartVO evolve: aSlotName write: beh execute].
	choiceArr := self contextChoiceOf: aSlotName .
	choice := choiceArr isNotNil.
	"template choice"
	choice ifFalse: [slot isThing 
		ifFalse: [^self] 
		ifTrue: [^self expandTemplate: aSlotName]].
	"old choose mechanics - to be removed together with choice and choiceArr"
	choiceArr first isSymbol 
		ifTrue: [slot isSmartValue ifTrue: [^self expandSlot: aSlotName  use: choiceArr first]] 
		ifFalse: [slot isThing ifTrue: [^self expandThing: aSlotName  use: choiceArr first]].
	self notify: 'choice authoring error: slot mismatch'
	
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 10/16/2017 13:20'!
expandBehaviorFor: aSlotName
	| ctxt bName |
	ctxt := self context ifNil: [^nil].
	bName := ctxt expandHooks at: aSlotName ifAbsent: [^nil].
	^self context behaviors at: bName 
		ifAbsent: [self inform: 'Behavior ', bName, ' not found'. ^nil]
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 8/24/2017 18:14'!
expandSlot: aSlotName use: aSlot 

	self chooseFromContext: aSlotName 
		okAction: [: th | th ifNotNil: [(self smartVO slotSVOAt: aSlotName) value: (th perform: aSlot)]] 
		cancelAction: [] 
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 9/7/2017 16:19'!
expandSlot: aSlotName use: aSlot role: aRoleSymbol

	self chooseFromContext: aSlotName 
		okAction: [: th | th ifNotNil: [(self smartVO slotSVOAt: aSlotName) inputValue: (th slotSVOAt: aSlot) val asString. self smartVO embeddingContext assign: th toTxThing: aRoleSymbol]] 
		cancelAction: [] 
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 11/30/2017 13:34'!
expandTemplate: aSlotName
	| templates tNs new |
	tNs := (fullVO slotAt: aSlotName) thingTemplates asOrderedCollection.
	templates := (tNs collect: [:t| self smartVO bizApp thingNamed: t]) reject: [:e| e isNil].
	templates ifEmpty: [^self].
	new := GbtWidget chooseTemplateFrom: templates. 
	new ifNotNil: [self smartVO evolveNode: aSlotName write: new copy]
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 8/3/2017 16:09'!
expandThing: aSlotName use: aDecl

	self chooseFromContext: aSlotName 
		okAction: [: th |th ifNotNil: [self smartVO evolveNode: aSlotName write: (th save copyWith: aDecl)]] 
		cancelAction: [] 
! !

!GbtThingEditor methodsFor: 'api' stamp: 'hk 11/1/2016 20:01'!
initialExtent
	^600 @  (widgetHeight + self singleHeight + 6)
! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 11/1/2017 15:07'!
initializeLayout
	widgetHeight := 2 * self singleHeight.
	self layout: (SpecLayout composed newColumn: [ :c | 
		self nameAndButtonRow: c.
		self slotNames do: [ :sn | |w wl|
			wl := self wLabelFor: sn.
			w := widgets at: wl.
			c newRow: [ :r | r add: wl] height: w widgetHeight.
			widgetHeight := widgetHeight + (w widgetHeight) ].
		c newRow: [ :r | r add: #emptyLabel] ]).
	self needFullRebuild: false .
! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 1/23/2018 19:58'!
initializePresenter
	
	self slotwidgets do: #putChangeFlagOn.
	
	self someValueChanged whenChangedDo: 
		["berechne alle expressions/calcs neu"
		self slotwidgets do: #someValueHasChanged. 
		
		self summary label: self smartVO summaryEnriched.
		self voName label: self smartVO displayName. 
		consistent value: false.
		self checkUndoRedo].
	
	smartVO whenChangedDo: [self checkUndoRedo; contentChanged: true].
	
	consistent whenChangedDo: 
		[self constrButton icon: self consistencyIcon; help: self consistencyHelp]! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 1/23/2018 19:58'!
initializeWidgets
	|  |
	self instantiateModels: #( 
	emptyLabel			LabelModel
	voName					LabelModel
	summary				LabelModel
	constrButton			ButtonModel
	saveTemplateButton	ButtonModel
	saveButton			ButtonModel
	undoButton			ButtonModel
	redoButton			ButtonModel
	inspectUi				ButtonModel
	inspectVo				ButtonModel) .
	
	consistent := nil asValueHolder. 	
	someValueChanged := false asValueHolder. 	
	contentChanged := false asValueHolder. 	
	self voName label: self smartVO displayName.
	self summary label: self smartVO summaryEnriched.
	self constrButton 
		icon: (GbtIcons at: #constrYellow) ;
		action: [self checkConsistency];
		help: 'unchecked'   ;
		state: true .
	self saveTemplateButton 
		icon: (GbtIcons at: #saveTemplate) ;
		action: [self saveTemplate];
		help: 'save as template';
		state: true.
	self saveButton 
		icon: (GbtIcons at: #save) ;
		action: [self save];
		help: 'save';
		state: true.
	self undoButton 
		icon: (GbtIcons at: #undo) ;
		action: [self undo];
		help: 'undo';
		state: true;
		disable.
	self redoButton 
		icon: (GbtIcons at: #redo) ;
		action: [self redo];
		help: 'redo';
		state: true;
		disable.
	self inspectUi 
		icon: (GbtIcons default inspectIcon) ;
		label: ' UI';
		action: [self inspect ];
		state: true.
	self inspectVo
		icon: (GbtIcons default inspectIcon) ;
		label: ' VO';
		action: [self smartVO inspect];
		state: true.
	self focusOrder 
		add: self constrButton; 
		add: self saveTemplateButton; 
		add: self saveButton. 
	self slotNames do: [ :sn | 	
		(self smartVO hasSlotAt: sn)
			ifFalse:  [self assignEmptySlot: sn]
			ifTrue: [self assignSlot: sn]].
	self editBlock: self subWindowEditBlock .
	self slotEditBlock: editBlock.
	self initializeLayout
! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 11/1/2017 15:16'!
nameAndButtonRow: aColumn
	aColumn newRow: [ :r | r 
			add: #summary ;
			add: #voName;
			add: #emptyLabel;
			add: #undoButton width: 28;
			add: #redoButton width: 28;
			add: #inspectUi width: 48;
			add: #inspectVo width: 48;
			add: #constrButton width: 28 ;
			add: #saveTemplateButton width: 24 ;
			add: #saveButton width: 24 
			] height: self singleHeight 
! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 9/6/2017 17:46'!
reBuildAll
	| oldSlotNames newSlotNames |
	self needFullRebuild: false.
	self voName label: self smartVO displayName.
	oldSlotNames := (self slotwidgets collect: [ :sw | sw slotName ]) values.
	newSlotNames := self smartVO slotNames.
	oldSlotNames \ newSlotNames do: [ :sn | self assignEmptySlot: sn ].
	newSlotNames do: [ :sn | self assignSlot: sn].
	self readAllSlots .
	self initializeLayout.
	self buildWithSpec.
	self checkUndoRedo! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 9/6/2017 17:46'!
reBuildFor: aSLotName

	| wdgt |
	self needFullRebuild: false .
	self voName label: self smartVO displayName.
	wdgt := self widgetAt: aSLotName.
	[wdgt subWidget editBlock: slotEditBlock] ifError: [].
	self focusOrder add: (self widgetAt: aSLotName).
	self initializeLayout.	
	self buildWithSpec.
	self checkUndoRedo .

! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 2/23/2017 15:44'!
readAllSlots
	self slotwidgets do: [:w | w subWidget read]! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 8/18/2017 16:03'!
redo
	self smartVO becomeNext. 
	self reBuildAll.
	smartVO valueChanged! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 9/6/2017 17:46'!
remove: aSlotName
	"remove a slot from smartThing"
	| wl widg |
	wl := self wLabelFor: aSlotName .
	widg := GbtEmptyWidget key: aSlotName .
	self assign: widg to: wl .  
	self smartVO removeSlotAt: aSlotName.
	self needFullRebuild: false .
	self voName label: self smartVO displayName.
	self initializeLayout.			"in case a thing needed more space"
	self buildWithSpec.
	self checkUndoRedo .
	self someValueChanged: true 	"recalculate"
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 10/6/2016 15:40'!
resetEditButton
	self widgetsDo: [:w| [w subWidget resetEditButton] ifError: []]! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 9/6/2017 17:46'!
save
	self smartVO save.
 	smartVO valueChanged.
	self voName label: self smartVO displayName.
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 5/13/2017 13:55'!
saveTemplate
	self smartVO saveAsTemplate
! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 1/15/2016 18:43'!
singleHeight
	^self class toolbarHeight! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 6/20/2016 17:36'!
slotClass

	^GbtSlotWidget! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 10/6/2016 15:39'!
slotEditBlock: aBlock
	slotEditBlock := aBlock.
	self widgetsDo: [:w|  [w subWidget editBlock: aBlock] ifError: [] ].! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 7/13/2017 18:20'!
slotNames
	"union of smart & full slots minus stopSlots, but keep the sequence"
	| sns nsns |
	sns := fullVO slotNames asOrderedCollection. 
	nsns := self smartVO slotNames asOrderedCollection select: [:sn| (sns includes: sn) not].
	nsns  addAll: sns.
	nsns removeAll: self stopSlots .
	^nsns! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 5/13/2017 13:51'!
slotVO: anObject
	smartVO := anObject asValueHolder .
	fullVO := anObject fullThing! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 10/6/2016 15:31'!
slotwidgets
	^self widgets select: [:w |w isKindOf: GbtSlotWidget ]! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 5/13/2017 13:55'!
smartVO
	^smartVO value! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 5/13/2017 13:56'!
smartVO: anObject
	smartVO value: anObject! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 6/14/2016 13:54'!
someValueChanged
	^someValueChanged ! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 8/18/2017 15:58'!
someValueChanged: aBoolean
	"called when a widget is changed"   
	someValueChanged value: aBoolean.
	self contentChanged valueChanged! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 2/23/2016 15:56'!
stopSlots
	^stopSlots ifNil: [ #() ]! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 2/23/2016 15:46'!
stopSlots: anArrayOfSlotNames
	stopSlots := anArrayOfSlotNames! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 5/22/2017 13:14'!
subWindowEditBlock
	^[:vo| |subW| 
	(subW := self class on: vo) openWithSpec.
	"initializePresenter same as initializeRightPresenter"
	subW someValueChanged whenChangedDo: [self someValueChanged: true].
	subW contentChanged whenChangedDo: [ self someValueChanged: true ] ]
! !

!GbtThingEditor methodsFor: 'ui actions' stamp: 'hk 8/18/2017 16:03'!
undo
	self smartVO becomePrevious . 
	self reBuildAll.
	smartVO valueChanged! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 1/15/2016 17:39'!
wLabelFor: aSlotName
	^('lbl_', aSlotName) asSymbol! !

!GbtThingEditor methodsFor: 'accessing' stamp: 'hk 2/22/2017 13:18'!
widgetAt: aSlotName
	^self widgets at: (self wLabelFor: aSlotName) ifAbsent: []! !

!GbtThingEditor methodsFor: 'initialization' stamp: 'hk 11/1/2016 20:06'!
widgetHeight
	^widgetHeight 
! !

DynamicComposableModel subclass: #GbtUI
	instanceVariableNames: 'context mode modeToggler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtUI commentStamp: 'hk 11/21/2016 18:29' prior: 0!
I am an abstract GloConn UI on a context.

Instance Variables
	context:			<ActiveContextVO>		preset context
	mode:			<NewValueHolder>		rebuild on #edit / #txt / #sdBox change 
	modeToggler: 	<Dictionary> 				for mode switching
!

GbtUI subclass: #GbtAspectUI
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtAspectUI commentStamp: 'hk 11/21/2016 18:06' prior: 0!
I am a Gui for a fixed aspect of an item = my target.
depending on my context (allows add, allowsRemove, allowsChoice) I allow to add and remove the target. I need a target when instantiated !!

I have 3 modes:
	- #edit - with GbtThingEditor
	- #text - with a srollable text display
	-#sdBox - with the GbtCustomSDBoxWidget

Instance Variables
	target:		<NewValueHolder>		rebuild on target change 

====================================================

|  ctxt  superctxt  vo |
vo := ThingVO newOfType: 'Thing' define: { 
	{ #aspect . #thing: .   (ThingVO newOfType: 'Aspect' ) } }.
ctxt := AcPlainVO ofType: 'Context'  define: { 
	{ #uiSpec:at: . #GcAspectUI . #aspect } .
	{ #templates: . { vo } } } .
superctxt := AcPlainVO ofType: 'SuperContext' define: { 
	{ #uiSpec:at: .  GcItemWithTabsUI . #super } .
	{ #aspect:on: . ctxt . #aspect } .
	{ #vo: . vo } }.

(GcAspectUI  on:  superctxt)  openWithSpec!

!GbtAspectUI class methodsFor: 'instance creation' stamp: 'hk 11/21/2016 18:10'!
on: aContext mode: aSymbol
	^ self basicNew
		context: aContext;
		initialize;
		mode: aSymbol
! !

!GbtAspectUI methodsFor: 'initialization' stamp: 'hk 2/25/2016 15:34'!
addRemoveButton: r
	context allowsRemove ifFalse: [ ^self ]	.
	r  add: #removeButton width: 24! !

!GbtAspectUI methodsFor: 'ui actions' stamp: 'hk 8/3/2017 15:09'!
addTargetFrom: aTemplate

	| newNode |
	newNode := (aTemplate ifNil: [^self]) copy context: context; ensureBizId. 
	context container vo slotExpandAt: context targetSlotname put: newNode.
	self setAspectTarget.
	context createHook: newNode
! !

!GbtAspectUI methodsFor: 'initialization' stamp: 'hk 1/24/2018 15:39'!
assignSubWidget
	"assign modeEditor, go to next mode, if modeEditor does not work
	!!!!!!  we have a loop here if no editor works !!!!!!"
	| subW | 
	[subW := (self modeEditorOf: self target) on: self target stopSlots: self stopSlots]
		ifError: [^self nextMode; assignSubWidget ]. 
	self assign: subW to: #subWidget .
	self subWidget owner: self .
	self focusOrder add: subW! !

!GbtAspectUI methodsFor: 'ui actions' stamp: 'hk 2/25/2016 15:49'!
choose
	context allowsChoice 
		ifTrue: [ self chooseFromContext ] ifFalse: [ self chooseTemplate ]! !

!GbtAspectUI methodsFor: 'ui actions' stamp: 'hk 1/9/2017 20:49'!
chooseFromContext
	| dialogWindow |  
	dialogWindow := (GbtListUI on: context choiceContext) openDialogWithSpec .
	dialogWindow 
		okAction: [ self addTargetFrom: dialogWindow model selection] ;
		cancelAction: [ ] ;
		title: context choiceContext displayName  ;
		centeredRelativeTo: self 
! !

!GbtAspectUI methodsFor: 'ui actions' stamp: 'hk 11/30/2017 15:33'!
chooseTemplate
	
	| tmpl |
	tmpl := (GbtWidget chooseTemplateFrom: self thingTemplates) .
	tmpl ifNil: [^nil].
	^self addTargetFrom:  tmpl
		
! !

!GbtAspectUI methodsFor: 'testing' stamp: 'hk 3/1/2016 12:06'!
hasTarget  
	^true
! !

!GbtAspectUI methodsFor: 'initialization' stamp: 'hk 3/1/2016 12:05'!
initializeLayout
	self target 
		ifNotNil: [ self initializeTargetLayout ] 
		ifNil: [ self initializeNoTargetLayout ] 
! !

!GbtAspectUI methodsFor: 'initialization' stamp: 'hk 8/21/2015 17:56'!
initializeNoTargetLayout

	self identityLabel label:  'none'  .
 
	self layout: (SpecLayout composed newColumn: [ :c | 
		c newRow: [ :r | 
				r  add: #chooseButton width: 24 .
				r add: #identityLabel .
				r  add: #pInspect width: self class buttonWidth ] height: self class toolbarHeight. 
		c add: #emptyLabel height: 1] ) .
	self needFullRebuild: false .
! !

!GbtAspectUI methodsFor: 'initialization' stamp: 'hk 4/27/2015 18:25'!
initializePresenter

	target whenChangedDo: 
		[ self initializeLayout .
		self buildWithSpec ]
! !

!GbtAspectUI methodsFor: 'initialization' stamp: 'hk 2/11/2016 19:28'!
initializeTargetLayout
 	self assignSubWidget .	 
	self identityLabel label: self target bizId.
	
	self layout: (SpecLayout composed newColumn: [ :c | 
		c newRow: [ :r | 
			self addRemoveButton: r.
			r add: #toggleButton width: 28.
			r add: #identityLabel. 
			r  add: #pInspect width: self class buttonWidth] height: self class toolbarHeight .
		c newRow: [ :r | r add: #subWidget] .
		c newRow: [ :r | r add: #emptyLabel ] height: 1 ] ).
	self needFullRebuild: false 
! !

!GbtAspectUI methodsFor: 'initialization' stamp: 'hk 11/21/2016 18:18'!
initializeWidgets
	super initializeWidgets .
	self instantiateModels: #( 
		identityLabel 	LabelModel
		toggleButton 	ButtonModel 	
		removeButton 	ButtonModel 	
		chooseButton 	ButtonModel 	) .				
	self toggleButton 
		icon: (GbtIcons at: #toggle) ;
		action: [ self toggle ];
		state: true.
	self removeButton 
		icon: (GbtIcons at: #delete) ;
		action: [ self removeTarget ];
		state: true.
	self chooseButton 
		icon:  (GbtIcons at: #add);
		action: [ self choose ];
		state: true.
	target := nil asValueHolder .
	self initializeMode.
	self setAspectTarget.
	self initializeLayout! !

!GbtAspectUI methodsFor: 'ui actions' stamp: 'hk 11/26/2015 22:38'!
refresh
 	"user asks to refresh the Tab content"  
	target valueChanged! !

!GbtAspectUI methodsFor: 'ui actions' stamp: 'hk 2/17/2017 15:58'!
removeTarget 
	context container vo removeSlotAt: context targetSlotname .   
	self setAspectTarget ! !

!GbtAspectUI methodsFor: 'ui actions' stamp: 'hk 1/24/2018 15:25'!
setAspectTarget
	"set the old or new (aBoolean=true) target to the defined DomainVO aspect "
	self target: context setVOFromContainer.

	! !

!GbtAspectUI methodsFor: 'accessing' stamp: 'hk 3/1/2016 13:16'!
stopSlots
	context ifNil: [^#()]. 
	context blackboardSlot = #nil ifTrue: [^#()].  
	^{context blackboardSlot}
	! !

!GbtAspectUI methodsFor: 'accessing' stamp: 'hk 5/7/2015 15:39'!
target
	^ target value! !

!GbtAspectUI methodsFor: 'accessing' stamp: 'hk 2/3/2016 13:55'!
target: aVo
	target value: aVo! !

!GbtAspectUI methodsFor: 'accessing' stamp: 'hk 11/30/2017 15:43'!
thingTemplates
	^ context thingTemplates ! !

!GbtAspectUI methodsFor: 'initialization' stamp: 'hk 1/28/2016 11:34'!
widgetHeight
	"hack: dont know the widgetHeight al long as the aspect is empty"
 	^240! !

GbtAspectUI subclass: #GbtSelfAspectUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtSelfAspectUI commentStamp: 'hk 2/25/2016 16:44' prior: 0!
I am an AspectUI  meant for the aspect self. I
-  ignore the target target !

!GbtSelfAspectUI methodsFor: 'accessing' stamp: 'hk 10/31/2016 16:27'!
aspectOwner
	"I am in a tab in a tabmanager in an Item"
	^self owner owner owner! !

!GbtSelfAspectUI methodsFor: 'initialization' stamp: 'hk 7/15/2017 18:42'!
assignSubWidget
	super assignSubWidget .
	(self subWidget isKindOf: GbtUiTextWidget) ifTrue: [^self].
	self subWidget contentChanged whenChangedDo: [self aspectOwner contentChanged value: true] ! !

!GbtSelfAspectUI methodsFor: 'ui actions' stamp: 'hk 9/23/2016 12:15'!
setAspectTarget
	self target: context vo.

	! !

!GbtSelfAspectUI methodsFor: 'accessing' stamp: 'hk 3/1/2016 12:59'!
stopSlots
	^(context ifNil: [^#()]) aspectSlots ! !

GbtUI subclass: #GbtItemUI
	instanceVariableNames: 'contentChanged'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtItemUI commentStamp: 'hk 11/21/2016 18:05' prior: 0!
I am a general UI for editing one element of a list of things.
I have 2 modes:
	- #edit - with GbtThingEditor
	- #text - with a srollable text display

If my context has a blackboard subcontext, I also render the blackboard part.

    Instance Variables
	saved: 		<ValueHolder>

============================
(GbtItemUI on: (( GbtPlainAC newStruct: #bla) vo: (( GbtThing newStruct: #pro) copy; yourself); yourself)) openWithSpec!

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 1/9/2017 21:13'!
addBlackboardTo: aColumn
	aColumn newRow: [:r| r
		add: #emptyLabel width: 10;		"inset"
		newColumn: [:c| c add: #blackboard];
		add: #emptyLabel width: 10] 
			height: (widgets at: #blackboard) widgetHeight
	
	! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 1/23/2016 20:27'!
addContentTo: aRow
	aRow add: #item! !

!GbtItemUI methodsFor: 'accessing' stamp: 'hk 5/3/2017 12:13'!
blackboardContext
	^(context subcontextFor: context blackboardAspect) ifNil: [^GbtObject error: 'no subcontext ', context blackboardAspect] ! !

!GbtItemUI methodsFor: 'accessing' stamp: 'hk 5/12/2017 13:44'!
contentChanged
	^contentChanged! !

!GbtItemUI methodsFor: 'accessing' stamp: 'hk 1/10/2018 13:40'!
contentChanged: aBoolean
	contentChanged value: aBoolean! !

!GbtItemUI methodsFor: 'ui actions' stamp: 'hk 7/16/2017 22:13'!
deleteMyself  
	owner mayDelete 
		ifTrue: [owner deleteSelection] 
		ifFalse: [^self notify: 'no right to execute']! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 10/4/2017 11:50'!
iconRowFor: aColumn
	aColumn 	newRow: [ :r | r
		add:  #emptyLabel ;		
		add: #pEditBeh width: 80 ;
		add: #pInspect width: 80  ] height: self class toolbarHeight .
! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 2/26/2016 13:33'!
initializeAuthoredMenu
	| menuItems |
	menuItems := context menuItemsWrappedWith: [:s| self notify: s].
	self paneMenu addGroup: [:g | menuItems do: [:i| g addMenuItem: i]]
! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 2/17/2017 16:19'!
initializeBlackboard
	| sc ui |
	sc := self blackboardContext .
	sc isListAc ifTrue: [^self].
	sc vo: (context vo slotSVOExpandAt: sc targetSlotname).
	ui := sc newUI: #sdBox.
	self assign: ui to: #blackboard ! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 1/10/2018 13:41'!
initializeDynamicPresenter
	(self item contentChanged ifNil: [^self]) whenChangedDo: [self contentChanged: true]
! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 11/21/2016 19:39'!
initializeDynamicWidgets
	| subW |
	subW := self editor.
	self assign: subW to: #item .
	self focusOrder add: subW.
	self initializeDynamicPresenter.
	self initializeMenu! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 10/4/2017 11:59'!
initializeLayout
	self initializeDynamicWidgets .
	self layout: (SpecLayout composed newColumn: [ :c | 
		context hasBlackboard ifTrue: [self addBlackboardTo: c].		
		c newRow: [:r| r
			newColumn: [:c1| c1 add: #paneMenu];
			newColumn: [:c1| self iconRowFor: c1]] height: self singleHeight.
		c newRow: [ :r | 
			r add: #emptyLabel width: 10.		"inset"
			self addContentTo: r .
			r add: #emptyLabel width: 10] ] ).
	[self needFullRebuild: false] ifError: [  ]

! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 2/26/2016 13:33'!
initializeMenu
	self instantiateModels: #(paneMenu MenuModel).
	self paneMenu addGroup: [ :g |  self menuFor: g].
	self initializeAuthoredMenu .! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 10/4/2017 11:33'!
initializeStaticWidgets
	self initializeMode.
	self initializeInspectors 

! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 5/12/2017 13:44'!
initializeWidgets
	contentChanged := false asValueHolder .
	self instantiateModels: #(emptyLabel LabelModel).
	context hasBlackboard ifTrue: [self initializeBlackboard].
	self initializeStaticWidgets .
	context hasAutoloadPolicy ifTrue: [context loadVO]. 
	self initializeLayout! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 1/6/2017 18:38'!
menuFor: aMenuGroup
		aMenuGroup addItem: [ :i |  i
			icon: (GbtIcons at: #delete) ;
			description: 'delete' ;
			action: [ self deleteMyself] ] .
		aMenuGroup addItem: [ :i |  i
				description: 'toggle display' ;
				icon: (GbtIcons at: #toggle) ;
				action: [ self toggle ] ] ! !

!GbtItemUI methodsFor: 'initialization' stamp: 'hk 1/10/2018 13:39'!
refresh
	self contentChanged: true! !

!GbtItemUI methodsFor: 'ui actions' stamp: 'hk 7/8/2016 17:57'!
runStatistics
	self context runStatistics
! !

GbtItemUI subclass: #GbtItemWithTabsUI
	instanceVariableNames: 'tabManager hasBlackboard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtItemWithTabsUI commentStamp: 'hk 12/19/2017 13:01' prior: 0!
I am a UI for editing a process with aspects of a list of processes

Instance Variables
	tabManager: 		<TabManager>		does not work with DynamicSpec
	hasBlackboard: 	<Boolean>
		
====== Tests ======

(GcItemWithTabsUI on: (( AcPlainVO ofType: #bla) vo: (( ThingVO newOfType: #pro) copy; yourself); yourself)) openWithSpec!

!GbtItemWithTabsUI methodsFor: 'initialization' stamp: 'hk 1/23/2016 20:27'!
addContentTo: aRow
	aRow add: #tabManager! !

!GbtItemWithTabsUI methodsFor: 'initialization' stamp: 'hk 8/20/2016 18:04'!
initializeDynamicWidgets
	self initializeMenu! !

!GbtItemWithTabsUI methodsFor: 'initialization' stamp: 'hk 10/4/2017 16:48'!
initializeStaticWidgets
	self initializeInspectors .
	self initializeTabs ! !

!GbtItemWithTabsUI methodsFor: 'initialization' stamp: 'hk 12/19/2017 14:25'!
initializeTabs  

	| rIcon |
	tabManager := self newTabManager .  	
	rIcon := GbtIcons  at: #refresh .
	hasBlackboard := context vo isNotNil.
	hasBlackboard ifTrue: [self initializeVoTabIn: tabManager].		"special treatment for the vo-tab"
	context subcontexts do: [ :sc |  |key icon newTab ui contextVO tabVO|
		contextVO := context vo.  
		(sc isListAc or: [sc vo isNotNil]) ifFalse: 	"tab on aspect"
			[sc vo: (tabVO := contextVO slotSVOAt: sc targetSlotname)].
		key := sc displayName asSymbol.
		icon := GbtIcons  at: sc uiKey .
		ui := self newModelFor: sc .
		(newTab := self newTab) 
				label: key ;
				icon: icon ; 
				model: ui ;
				closeable: false ;
				actions: {(TabAction action: [ui refresh] icon: rIcon label: #refresh)} .
		hasBlackboard ifTrue: [newTab whenTabSelected: [self updateBlackboardWith: sc]].
		tabManager addTab: newTab .
		"set owner explicitely - can't set owner in TabManager"
		ui owner: self]
! !

!GbtItemWithTabsUI methodsFor: 'initialization' stamp: 'hk 8/20/2016 18:11'!
initializeVoTabIn: aTabManager  
	"initializue the first tab with my own vo"
	| rIcon key newTab ui|
	rIcon := GbtIcons  at: #refresh .
	key := context displayName asSymbol.
	ui := GbtSelfAspectUI basicNew context: self context.  
	"set owner explicitely - can't set owner in TabManager"
	ui owner: self; initialize.
	(newTab := self newTab) 
				label: key ;
				icon: (GbtIcons  at: context uiKey) ; 
				model: ui ;
				closeable: false ;
				whenTabSelected: [self updateBlackboardWith: context]; 
				actions: {(TabAction action: [ui refresh] icon: rIcon label: #refresh)} .
	aTabManager addTab: newTab .
	ui target: context vo. 
! !

!GbtItemWithTabsUI methodsFor: 'initialization' stamp: 'hk 1/6/2017 18:37'!
menuFor: aMenuGroup
		aMenuGroup addItem: [ :i |  i
			icon: (GbtIcons at: #delete) ;
			description: 'delete' ;
			action: [ self deleteMyself] ]! !

!GbtItemWithTabsUI methodsFor: 'initialization' stamp: 'hk 11/1/2016 17:15'!
newModelFor: aViewContext 
	"create the UImodel for the view, fall back, if there is no UIclass"
	
	Smalltalk at: aViewContext uiSpec ifAbsent: [^LabelModel new label: aViewContext displayName]. 
	^aViewContext newUI ! !

!GbtItemWithTabsUI methodsFor: 'accessing' stamp: 'hk 5/8/2015 13:38'!
tabManager
	^tabManager! !

!GbtItemWithTabsUI methodsFor: 'initialization' stamp: 'hk 3/1/2016 14:03'!
updateBlackboardWith: aContext
	| header |  
	context updateBlackboardWith: aContext. 
	header := widgets at: #blackboard ifAbsent: [^self].
	header refresh! !

GbtUI subclass: #GbtListUI
	instanceVariableNames: 'hasSubUI otherUserEdits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtListUI commentStamp: 'hk 1/9/2017 14:28' prior: 0!
I am a universal ListUI

Instance Variables
	hasSubUI:  		<Boolean>		#subUI is the dynamic widget for the list element


======== Tests ========

(GcListUI on: (( AcListVO ofType: #bla) asvo: (( ThingVO newOfType: #pro) copy; yourself ) ; yourself )) openWithSpec
!

GbtListUI subclass: #GbtListAndItemUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtListAndItemUI commentStamp: 'hk 11/9/2016 15:06' prior: 0!
I am a  ListUI that integrates the editor for the selected item.
I edit on selection.
!

!GbtListAndItemUI methodsFor: 'private' stamp: 'hk 1/9/2017 18:06'!
checkSelection  
	(self filteredList includes: self selection) ifFalse: 
		[self resetSelection.
		self removeEditor]
! !

!GbtListAndItemUI methodsFor: 'initialization' stamp: 'hk 6/20/2016 14:45'!
initialExtent
	"default extent when stand alone"
	^800 @ 600! !

!GbtListAndItemUI methodsFor: 'initialization' stamp: 'hk 1/9/2017 15:32'!
initialize
	self subcontext ifNil: [^self notify: 'no editor context defined'].
	super initialize! !

!GbtListAndItemUI methodsFor: 'initialization' stamp: 'hk 1/9/2017 21:15'!
initializeLayout
	self pIcon icon: self contextIcon  .	"changes dynamically"
	self layout: (SpecLayout composed newColumn: [ :c | 
		self iconRowFor: c .  
		self menuRow: c. 
		c newRow: [:r| r newColumn: [:cc| 
			self hasSubUI 
				ifTrue: 
					[cc add: #list bottom: 0.80 .
					cc addSplitter.
					cc add: #subUI top: 0.20] 
				ifFalse: 
					[cc add: #list bottom: 0.2 .
					cc addSplitter.
					cc add: #emptyLabel top: 0.8] ] ] ] ).
	self needFullRebuild: false .
! !

!GbtListAndItemUI methodsFor: 'initialization' stamp: 'hk 1/6/2017 18:16'!
initializeMenu
	self menuRow addGroup: 
		[ :g | g addItem: [ :i | i 
				icon: (GbtIcons at: #add) ;
				description: 'add copy';
				action: [ self newElement ] ] ].
	super initializeMenu.
! !

!GbtListAndItemUI methodsFor: 'initialization' stamp: 'hk 3/24/2017 19:21'!
initializePresenter
	self list whenSelectedItemChanged: 
		[:new :old| self switchEditorFrom: old to: new] .
	otherUserEdits whenChangedDo: [self checkSelection] .
	super initializePresenter ! !

!GbtListAndItemUI methodsFor: 'private' stamp: 'hk 5/12/2017 13:42'!
prepareEditor
	self assign: self subcontext newUI to: #subUI.
	self subUI contentChanged whenChangedDo: [self resetList].		"presenter"
	hasSubUI := true.
	self reBuild! !

!GbtListAndItemUI methodsFor: 'private' stamp: 'hk 1/9/2017 18:09'!
removeEditor   
	self hasSubUI ifFalse: [^self].
	self clearSubUI.
	self reBuild! !

!GbtListAndItemUI methodsFor: 'private' stamp: 'hk 9/8/2017 13:43'!
switchEditorFrom: oldSel to: newSel
	oldSel ifNotNil: [oldSel context: self context]. 
	newSel ifNil: [^self removeEditor] .
	self subcontext vo: newSel.
	self subcontext editHook: newSel.
	self prepareEditor .
	context checkDataPending . "eventually removes data pending flag"
 ! !

!GbtListUI methodsFor: 'ui actions' stamp: 'hk 11/30/2017 15:34'!
addListElement
	| newElement | 
	newElement := (self selection ifNil: [self chooseTemplateFrom: context thingTemplates])
		copy removeBizId.  
	context newEntry: newElement .	 
	self subcontext vo: newElement.
	self createHook: newElement. 
	self prepareEditor .
	self refresh

! !

!GbtListUI methodsFor: 'ui actions' stamp: 'hk 2/14/2017 14:58'!
addUlistElementFromAspect: aSelectedThing
	self setSelection: (context newEntryWithChoice: aSelectedThing) .
	self subcontext vo: self selection.
	self createHook: self selection.
	self prepareEditor .
	self refresh

! !

!GbtListUI methodsFor: 'ui actions' stamp: 'hk 2/15/2017 15:47'!
chooseTemplateFrom: aCollOfThings
	| res |
	aCollOfThings size = 1 ifTrue: [^aCollOfThings first ]. 
	res := (UIManager default chooseFrom: (aCollOfThings collect: #summary) values: aCollOfThings) .
	^(res	ifNil: [aCollOfThings first]) 
	! !

!GbtListUI methodsFor: 'private' stamp: 'hk 4/13/2015 12:41'!
clearSubUI
	hasSubUI := false! !

!GbtListUI methodsFor: 'accessing context' stamp: 'hk 4/30/2016 18:29'!
contextIcon
	^context hasDataPending 
		ifTrue:  [GbtIcons at: (context uiKey, 'Dirty') asSymbol]
		ifFalse: 	[GbtIcons at: context uiKey]
		
	
! !

!GbtListUI methodsFor: 'private' stamp: 'hk 9/23/2016 11:19'!
createHook: aThing
	self subcontext ifNil: [^self].
	self subcontext createHook: aThing! !

!GbtListUI methodsFor: 'ui actions' stamp: 'hk 5/13/2017 16:07'!
deleteSelection
	context deleteListElement: self selection .	
	self resetList; resetSelection .
	context checkDataPending .
	[self pLabel label: (owner context displayName)] ifError: ["below mainUI"] .
	self clearSubUI; reBuild! !

!GbtListUI methodsFor: 'ui actions' stamp: 'hk 1/9/2017 14:44'!
editSelection  
	self selection  ifNil: [^self] .
	self selection edit. 
	self resetList ! !

!GbtListUI methodsFor: 'accessing' stamp: 'hk 1/12/2017 18:22'!
filteredList  
	^context filteredListfrom: self textFilter text
! !

!GbtListUI methodsFor: 'accessing' stamp: 'hk 9/5/2017 12:03'!
filteredList: aSlotName for: aSelection
 	self list items: (self filteredList select: [ :e| (e slotTagged: aSlotName) val = aSelection ])! !

!GbtListUI methodsFor: 'testing' stamp: 'hk 11/1/2016 17:18'!
hasSubUI   
	^hasSubUI = true! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 1/9/2017 15:10'!
initialize
	context setUlistTemplates.		"transfer the templates"			
	super initialize.
! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 2/11/2016 12:15'!
initializeAuthoredMenu
	| menuItems |
	menuItems := context menuItemsWrappedWith: [:s| self notify: s].
	self menuRow addGroup: [:g| menuItems do: [:i| g addMenuItem: i]]! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 6/23/2016 10:49'!
initializeFilterLoadMenu
! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 5/19/2016 11:46'!
initializeLayout
	self pIcon icon: self contextIcon  .	"changes dynamically"
	self layout: (SpecLayout composed newColumn: [ :c | 
		self iconRowFor: c .  
		self hasSubUI 
			ifTrue: [ c add: #subUI ] 
			ifFalse: [self menuRow: c. 
						c add: #list] 
		] )  .
	self needFullRebuild: false .
! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 1/6/2017 18:15'!
initializeMenu
	context hasSimpleloadPolicy ifTrue: [self initializeSimpleLoadMenu].
	context hasFilterloadPolicy ifTrue: [self initializeFilterLoadMenu].
	self initializeAuthoredMenu .! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 1/12/2017 18:22'!
initializePresenter
	super initializePresenter .
	otherUserEdits whenChangedDo: [self resetList] .
	self textFilter whenTextChanged: [self resetList].
	context dataPending whenChangedDo: 
		[ self resetList ; reBuild ]
! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 6/23/2016 15:55'!
initializeSimpleLoadMenu
	self menuRow addGroup: [ :g| 
		g addItem: [ :i| i
				name: 'load all' ;
				action: [ context loadAll. self resetList]]]! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 8/3/2017 16:47'!
initializeWidgets
	| listW | 
	super initializeWidgets .
	listW := GbtTableListUI on: context template columns: context displayColumns.
	self assign: listW to: #list .  
	self list initialize.
	self assign: TextInputFieldModel new to: #textFilter	.
	self assign: MenuModel new to: #menuRow	.
	context hasAutoloadPolicy ifTrue: [context loadAll]. "list must be there"
	self resetList.
	self list resetDropDownLists. "made of loaded values"
	self pLabel label: context displayName .
	self textFilter
		autoAccept: true;
		ghostText: 'type to filter' .
	self initializeMenu .
	self focusOrder 
		add: self textFilter;
		add: self list .
	otherUserEdits := false asValueHolder.
	self initializeLayout.
	
! !

!GbtListUI methodsFor: 'testing' stamp: 'hk 1/6/2017 18:49'!
mayDelete
	^context userRight execute ! !

!GbtListUI methodsFor: 'initialization' stamp: 'hk 1/13/2017 17:37'!
menuRow: aColumn
	aColumn newRow: [ :r | r
		add: #textFilter width: self defaultWidth;
		add: #menuRow 
	] height: self singleHeight 
	
	 ! !

!GbtListUI methodsFor: 'ui actions' stamp: 'hk 3/22/2017 12:51'!
newElement    
	context userRight execute ifFalse: [^self notify: 'no right to execute'].
	context allowsAspectChoice ifTrue: [^self newElementFromAspectChoice].
	context allowsChoice ifTrue: [^self notify: 'not yet implemented' ]. 
	self addListElement
! !

!GbtListUI methodsFor: 'ui actions' stamp: 'hk 1/23/2017 12:49'!
newElementFromAspectChoice
	| dialogWindow | 
	(dialogWindow := (GbtListUI on: context choiceContext) openDialogWithSpec) 
		okAction:[self addUlistElementFromAspect: dialogWindow model selection];
		cancelAction: [ ] ;
		title: context choiceContext displayName  ;
		centeredRelativeTo: self 

! !

!GbtListUI methodsFor: 'accessing' stamp: 'hk 12/5/2016 13:26'!
otherUserEdits: aBoolean
	^otherUserEdits value: aBoolean 
! !

!GbtListUI methodsFor: 'private' stamp: 'hk 1/9/2017 16:04'!
prepareEditor! !

!GbtListUI methodsFor: 'ui actions' stamp: 'hk 8/9/2016 11:35'!
refresh  
	self resetList! !

!GbtListUI methodsFor: 'api' stamp: 'hk 12/5/2016 17:09'!
resetList  
	self list items: self filteredList! !

!GbtListUI methodsFor: 'api' stamp: 'hk 1/6/2017 19:00'!
resetSelection
	self list resetSelection! !

!GbtListUI methodsFor: 'api' stamp: 'hk 12/5/2016 16:13'!
selection
	^self list selectedItem! !

!GbtListUI methodsFor: 'api' stamp: 'hk 12/31/2016 18:50'!
setSelection: anItem   
	self list setSelectedItem: anItem! !

!GbtListUI methodsFor: 'accessing context' stamp: 'hk 4/13/2015 12:22'!
subcontext 
 	^context subcontext! !

GbtUI subclass: #GbtLoginUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtLoginUI commentStamp: 'hk 11/9/2016 15:07' prior: 0!
I am the UI for login.

I always work with the loginContext that is unique for a company!

!GbtLoginUI methodsFor: 'adding' stamp: 'hk 3/23/2017 10:37'!
addStatus: aString
	"display the limited historical status, most recent left"
	| st |
	aString ifEmpty: [ ^self ] . 
	st := aString, ' | ', self status text asString.
	st size > 200 ifTrue: [ st := (st first: 200) , ' ... ' ].
	self status text: st ! !

!GbtLoginUI methodsFor: 'initialization' stamp: 'hk 6/6/2017 16:29'!
initialize
	super initialize.
	self bizApp isCompiled ifFalse: [self error: 'bizApp is not compiled']! !

!GbtLoginUI methodsFor: 'initialization' stamp: 'hk 11/18/2016 11:56'!
initializeLayout 
	"EFA efa openLogin"
	self layout: (SpecLayout composed newColumn: [:c| c 
			newRow: [ :r | r add: #status] height: self singleHeight;
			newRow: [ :r | r add: #iconButton ]  ;		
			newRow: [ :r | r add: #empty; add: #loginNameLabel width: 40; add: #loginName width: 120; add: #passwordLabel width: 70; add: #password width: 120; add: #loginButton width: 120] height: self singleHeight ;	
			newRow: [ :r | r add: #legal ]  height: self singleHeight ]). ! !

!GbtLoginUI methodsFor: 'initialization' stamp: 'hk 1/18/2018 13:05'!
initializeWidgets
	self instantiateModels: #(
		empty 				LabelModel
		iconButton 		ButtonModel
		loginNameLabel	LabelModel
		loginName			TextInputFieldModel 
		passwordLabel	LabelModel
		password			TextInputFieldModel
		loginButton		ButtonModel
		legal 				ButtonModel
		status				TextInputFieldModel
		) .
	self status enabled: false .
	self loginNameLabel label: #name: .
	self passwordLabel label: '   password:' .
	self iconButton 
			icon: (GbtIcons at: context uiKey) ;
			state: true. 
	self legal 
			state: true; 
			enabled: false;
			label: self packageVersion, '   |   ', context legalText .
	self loginButton	 
			action: [ self loginAction ];
			state: true;
			label: #login. 
	self loginName autoAccept: true .
	self password autoAccept: true .
	self title: context displayName.
		
	self focusOrder 
		add: self loginName;
		add: self password;
		add: self loginButton.
	self needRebuild: false.
	self initializeLayout
! !

!GbtLoginUI methodsFor: 'ui actions' stamp: 'hk 6/7/2017 10:21'!
insideTransportConfigHack: aCtxt
	"this two line hack for insideTransport needs to be replaced by decent config behavior"
	(aCtxt svoName = #GCMainContext) ifFalse: [ ^self ].
	GbtApplicationTest configure: aCtxt! !

!GbtLoginUI methodsFor: 'ui actions' stamp: 'hk 8/9/2017 16:27'!
loginAction 
	| userName userApp |
	userName := self loginName text.
	(self bizApp hasUser: userName) ifFalse: [^self notify: userName, ' not registered as user'].
	self window close. 
	"next line because mainCtxtName is implicit without Gbt-Parser"
	self bizApp executable mainCtxtName: self context subcontexts first svoName.
	self context ui: nil. "UIs cannot be STONed"           
	userApp := self bizApp registerAppFor: userName.
	self insideTransportConfigHack: userApp mainContext . "needs to be removed"
	userApp open  ! !

!GbtLoginUI methodsFor: 'error handling' stamp: 'hk 11/18/2016 12:17'!
notify: aString
	"write the status line "
	self addStatus: aString! !

GbtUI subclass: #GbtMainUI
	instanceVariableNames: 'menu chosenWidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtMainUI commentStamp: 'hk 8/3/2016 13:41' prior: 0!
I am the GloConn main window model.

My subcontext related widgets must be addressed in action methods with the uiKey authored in  the subContext.
the menu is constructed by my subcontexts (BizApps)

Instance Variables
	chosenWidget:		<Symbol | nil>		the widget to be displayed next 
	menu:				<MenuModel>		main menu

===============================================
Das  gegenwärtige Design mit chosenWidget erzwingt Neuberechnen des Layouts, wenn sich der Inhalt des Hauptfensters ändert...   -  to be changed
siehe auch: addSubcontext und addSystemContext
!

GbtMainUI subclass: #GbtGloConnMainUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GbtGloConnMainUI commentStamp: 'hk 8/3/2016 13:37' prior: 0!
I am the old main window model.

the menu is hand written, NOT generated from DSL text 
!

!GbtGloConnMainUI methodsFor: 'initialization - menu' stamp: 'hk 4/30/2016 18:29'!
addCommunicationButtonGroup:g	
			g addItem: [  :i | i
				icon: (self contactsIcon) ;
				description: 'show contacts' ;
				action: [ self contactsAction ] ] .
			g addItem: [  :i | i
				icon: (GbtIcons default bizNetIcon) ;
				description: 'show biz net' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (GbtIcons default crmIcon );
				description: 'show CRM' ;
				action: [  ] ]  ! !

!GbtGloConnMainUI methodsFor: 'initialization - menu' stamp: 'hk 4/30/2016 18:29'!
addInvoicingButtonGroup:g 	
			g addItem: [  :i | i
				icon: (GbtIcons default invoicingIcon) ;
				description: 'show invoicing' ;
				action: [  ] ] ! !

!GbtGloConnMainUI methodsFor: 'initialization - menu' stamp: 'hk 4/30/2016 18:29'!
addMasterDataButtonGroup:g  	
			g addItem: [  :i | i
				icon: (GbtIcons default logisticsDataIcon) ;
				description: 'show logistics data' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (GbtIcons default taxIcon) ;
				description: 'show tax' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (GbtIcons default routeIcon) ;
				description: 'show routes' ;
				action: [  ] ] ! !

!GbtGloConnMainUI methodsFor: 'initialization - menu' stamp: 'hk 11/4/2016 13:22'!
addMiscellaneousButtonGroup: g
	g	addItem: [ :i | i
				icon: (GbtIcons default userSettingsIcon) ;
				description: 'user settings';
				action: [ self calcAction] ].
	g	addItem: [ :i | i
				icon: (GbtIcons default systemSettingsIcon) ;
				description: 'system settings';
				action: [ self inspect ] ].
	g	addItem: [ :i | i
				icon: (GbtIcons default learnCenterIcon) ;
				description: 'learn center';
				action: [ self calcAction] ].
	g	addItem: [ :i | i
				icon: (GbtIcons  default userIcon) ;
				description: 'evaluation / statistics';
				action: [ self context inspect ] ]! !

!GbtGloConnMainUI methodsFor: 'initialization - menu' stamp: 'hk 4/30/2016 18:29'!
addProcessButtonGroup: g 	
			g addItem: [  :i | i
				icon: (GbtIcons default dashIcon) ;
				description: 'show dash board' ;
				action: [ self dashboardAction] ] .
			g addItem: [  :i | i
				icon: self bizProcessesIcon ;
				description: 'show biz processes' ;
				action: [ self processesAction ]] ! !

!GbtGloConnMainUI methodsFor: 'initialization - menu' stamp: 'hk 4/30/2016 18:29'!
addTourButtonGroup: g 	
			g addItem: [  :i | i
				icon: (GbtIcons default taskOrdersIcon) ;
				description: 'show task orders' ;
				action: [ self taskOrdersAction ] ] .
			g addItem: [  :i | i
				icon: (GbtIcons default projectsIcon) ;
				description: 'show projects' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (GbtIcons default tourIcon) ;
				description: 'show tours' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (self supplierBizProcessesIcon) ;
				description: 'show supplier processes' ;
				action: [ self supplierProcessesAction ] ] ! !

!GbtGloConnMainUI methodsFor: 'initialization dynamic icons' stamp: 'hk 4/30/2016 18:29'!
bizProcessesIcon
	"a little dirty - icon keys used in authoring"
	
	| sc |
	sc := context subcontexts detect: [:e| e uiKey = #bizProcesses].
	^sc hasDataPending 
		ifTrue:  [GbtIcons default bizProcessesDirtyIcon]
		ifFalse: 	[GbtIcons default bizProcessesIcon]
! !

!GbtGloConnMainUI methodsFor: 'ui actions' stamp: 'hk 9/20/2016 17:50'!
calcAction
	self chosenWidget: #userSettings .
	self reBuild! !

!GbtGloConnMainUI methodsFor: 'ui actions' stamp: 'hk 9/20/2016 18:02'!
contactsAction
	self chosenWidget: #contacts.
	self contacts resetList! !

!GbtGloConnMainUI methodsFor: 'initialization dynamic icons' stamp: 'hk 4/30/2016 18:29'!
contactsIcon
	"a little dirty - icon keys used in authoring"
	
	| sc |
	sc := context subcontexts detect: [:e| e uiKey = #contacts].
	^sc hasDataPending 
		ifTrue:  [GbtIcons default contactsDirtyIcon]
		ifFalse: 	[GbtIcons default contactsIcon]
! !

!GbtGloConnMainUI methodsFor: 'ui actions' stamp: 'hk 9/20/2016 18:02'!
dashboardAction
	self chosenWidget: #dash! !

!GbtGloConnMainUI methodsFor: 'api' stamp: 'hk 1/9/2017 18:32'!
initialExtent
	^1680 @ 1200! !

!GbtGloConnMainUI methodsFor: 'initialization' stamp: 'hk 11/7/2016 11:53'!
initializeLayout 
	self layout: (SpecLayout composed newColumn: [ :c | c
			newRow: [ :r | r add: #logoButton] height: self logoHeight ;		"logo"
			newRow: [ :r | r add: #menu ] height: self singleHeight ;				"main menu buttons"
			newRow: [ :r | r add: #status; add: #clearButton width: 40 ] height: self singleHeight ;			"status line"
			add: chosenWidget value;		 					"the widget chosen via main menu"
			newRow: [ :r | r add: #legal ] height: self reducedHeight ] ).
	self needFullRebuild: false.! !

!GbtGloConnMainUI methodsFor: 'initialization - menu' stamp: 'hk 11/7/2016 12:51'!
initializeMainMenu 	
	(menu := MenuModel new) addGroup: [ :g |
		self addProcessButtonGroup: g .
		self addMenuGap: g width: self menuGap.
		self addTourButtonGroup: g .
		self addMenuGap: g width: self menuGap.
		self addInvoicingButtonGroup: g .
		self addMenuGap: g width: self menuGap.
		self addCommunicationButtonGroup: g .
		self addMenuGap: g width: self menuGap.
		self addMasterDataButtonGroup: g .
		self addMenuGap: g width: self menuGap.
		self addMiscellaneousButtonGroup: g .
	 	self addSystemContext: g ]! !

!GbtGloConnMainUI methodsFor: 'initialization' stamp: 'hk 9/20/2016 18:09'!
initializePresenter
	"must reBuild to change the icons"

	chosenWidget whenChangedDo: [ self reBuild ].
	(context subcontexts detect: [:e| e uiKey = #bizProcesses]) dataPending whenChangedDo: 
			[(self menu menuGroups first menuItems at: 2) icon: self bizProcessesIcon . self reBuild].
	(context subcontexts detect: [:e| e uiKey = #contacts]) dataPending whenChangedDo: 
			[(self menu menuGroups first menuItems at: 11) icon: self contactsIcon . self reBuild].
	(context subcontexts detect: [:e| e uiKey = #supplierBizProcesses]) dataPending whenChangedDo: 
			[(self menu menuGroups first menuItems at: 7) icon: self supplierBizProcessesIcon . self reBuild]
	

! !

!GbtGloConnMainUI methodsFor: 'initialization' stamp: 'hk 9/20/2016 20:08'!
initializeSubcontexts
	"to be refactored away - see addSubcontext:to:"
	context subcontexts do: [ :sc | self assign: sc newUI to: sc uiKey] ! !

!GbtGloConnMainUI methodsFor: 'constants' stamp: 'hk 4/12/2015 14:21'!
logoHeight
	^ 150! !

!GbtGloConnMainUI methodsFor: 'initialization' stamp: 'hk 8/3/2016 13:50'!
menuGap
		^160! !

!GbtGloConnMainUI methodsFor: 'api' stamp: 'hk 3/14/2017 10:37'!
openWithSpec
	| res |
	res := super openWithSpec.
	self window whenClosedDo: [GbtBizNetMockUp stopPolling ] .
	^res
! !

!GbtGloConnMainUI methodsFor: 'ui actions' stamp: 'hk 9/20/2016 18:02'!
processesAction
	self chosenWidget: #bizProcesses .
	self bizProcesses resetList! !

!GbtGloConnMainUI methodsFor: 'initialization dynamic icons' stamp: 'hk 4/30/2016 18:29'!
supplierBizProcessesIcon
	"a little dirty - icon keys used in authoring"
	
	| sc |
	sc := context subcontexts detect: [:e| e uiKey = #supplierBizProcesses].
	^sc hasDataPending 
		ifTrue:  [GbtIcons default supplierBizProcessesDirtyIcon]
		ifFalse: 	[GbtIcons default supplierBizProcessesIcon]
! !

!GbtGloConnMainUI methodsFor: 'ui actions' stamp: 'hk 9/20/2016 18:02'!
supplierProcessesAction
	self chosenWidget: #supplierBizProcesses ! !

!GbtGloConnMainUI methodsFor: 'ui actions' stamp: 'hk 9/20/2016 18:03'!
taskOrdersAction
	self chosenWidget: #taskOrders ! !

!GbtMainUI methodsFor: 'initialization' stamp: 'hk 8/26/2016 12:07'!
addMenuGap: g	width: aNumber
	 g addItem: [ :i | i
		enabled: false;
		icon: (Smalltalk ui icons blankIconOfWidth: aNumber)] ! !

!GbtMainUI methodsFor: 'ui actions' stamp: 'hk 12/9/2016 15:09'!
addStatus: aString
	"display a new status message to the left"
	
	| st |
	aString ifEmpty: [ ^self ] . 
	st := aString, ' | ', self status text asString.
	st size > 200 ifTrue: [ st := (st first: 200) , ' ... ' ].
	self status text: st ! !

!GbtMainUI methodsFor: 'initialization' stamp: 'hk 5/25/2017 16:35'!
addSubcontext: sc to: aMenuGroup
	|wgt key|   
	self assign: (wgt := sc newUI) to: (key := sc uiKey).
	self addMenuGap: aMenuGroup width: self menuGap.
	aMenuGroup addItem: [ :i | i
		icon:  (GbtIcons at: key) ;
		description: 'show ', sc svoName ;
		action:  [self chosenWidget: key.
					wgt resetList] ]! !

!GbtMainUI methodsFor: 'initialization' stamp: 'hk 3/15/2017 10:17'!
addSystemContext: aMenuGroup
	|subMenu mainMenu tmplEditor|
	tmplEditor :=  GbtTemplatesEditor basicNew.
	self assign: tmplEditor to: #templateEditor.
	tmplEditor initialize.
	subMenu := MenuModel new addGroup: [:g | g
			addItem: [:item | item
					name: 'templates' ; 
					action: [self chosenWidget: #templateEditor]];
			addItem: [:item| item name: #void]] .
	mainMenu := MenuItemModel new
		icon: (GbtIcons at: #settings);
		description: 'settings';
		subMenu: subMenu.
		
	self addMenuGap: aMenuGroup width: self menuGap.
	aMenuGroup addMenuItem: mainMenu .
	self addMenuGap: aMenuGroup width: 1000! !

!GbtMainUI methodsFor: 'accessing' stamp: 'hk 9/20/2016 17:48'!
chosenWidget
	^chosenWidget
! !

!GbtMainUI methodsFor: 'accessing' stamp: 'hk 9/20/2016 17:49'!
chosenWidget: aSymbol
	chosenWidget value: aSymbol
! !

!GbtMainUI methodsFor: 'ui actions' stamp: 'hk 7/28/2016 17:11'!
clearAction
		self status text: '' ! !

!GbtMainUI methodsFor: 'accessing' stamp: 'hk 11/7/2016 11:50'!
companyString
	"for the window headline"
	^([context vo company] ifError: [^'']), '   ', Date today asString, '   |   '! !

!GbtMainUI methodsFor: 'api' stamp: 'hk 1/3/2018 12:29'!
initialExtent
	"default extent when stand alone"
	^context extent ifNil: [800 @ 600]! !

!GbtMainUI methodsFor: 'initialization' stamp: 'hk 9/20/2016 18:01'!
initializeLayout 
	self layout: (SpecLayout composed newColumn: [ :c | c
			newRow: [ :r | r add: #menu ] height: self singleHeight ;				"main menu buttons"
			newRow: [ :r | r add: #status; add: #clearButton width: 40 ] height: self singleHeight ;			"status line"
			add: chosenWidget value	;						"the widget chosen via main menu"
			add: #legal height: self singleHeight] ). 
	self needFullRebuild: false.! !

!GbtMainUI methodsFor: 'initialization - menu' stamp: 'hk 9/20/2016 20:02'!
initializeMainMenu
	| menuGroup |
	menu := MenuModel new .
	menu addMenuGroup: (menuGroup := MenuGroupModel new) .
	context subcontexts do: [:sc | self addSubcontext: sc to: menuGroup ] .
	self addSystemContext: menuGroup ! !

!GbtMainUI methodsFor: 'initialization' stamp: 'hk 9/20/2016 18:03'!
initializePresenter
	chosenWidget whenChangedDo: [ self reBuild ]! !

!GbtMainUI methodsFor: 'initialization' stamp: 'hk 11/17/2016 12:45'!
initializeSubcontexts
	"context subcontexts do: [ :sc | self assign: sc newUI to: sc uiKey] "! !

!GbtMainUI methodsFor: 'initialization' stamp: 'hk 11/17/2016 12:46'!
initializeWidgets
		self instantiateModels: #(
		logoButton			ButtonModel
		emptyPane			ButtonModel
		legal				ButtonModel
		clearButton		ButtonModel
		status				TextInputFieldModel
		).
	self logoButton 
			icon: (GbtIcons at: context uiKey) ;
			state: true. 
	self clearButton
			action: [ self clearAction ];
			state: true;
			label: #clear .
	self legal 
			state: true; 
			enabled: false;
			label: self packageVersion, '   |   ', context legalText .
	chosenWidget := #emptyPane asValueHolder .
	self status enabled: false .
	self emptyPane 
		icon: (GbtIcons at: context uiKey) ; 
		state: true .
	self title: self titleString .
	self initializeMainMenu.
	self initializeSubcontexts .

	self initializeLayout ! !

!GbtMainUI methodsFor: 'accessing' stamp: 'hk 6/12/2016 20:18'!
menu
	^ menu! !

!GbtMainUI methodsFor: 'initialization' stamp: 'hk 8/2/2016 14:53'!
menuGap
		^(self initialExtent / (1 + context subcontexts size) / 2) x! !

!GbtMainUI methodsFor: 'error handling' stamp: 'hk 1/27/2017 14:18'!
notify: aString
	"write the status line "
	self addStatus: (aString withLineEndings: '\')! !

!GbtMainUI methodsFor: 'accessing' stamp: 'hk 11/7/2016 11:42'!
titleString
	^context displayName, '  |  ', self companyString, self userString! !

!GbtMainUI methodsFor: 'accessing' stamp: 'hk 11/7/2016 12:39'!
userString
	"for the window headline"
	^'user: ', context user! !

!GbtUI class methodsFor: 'instance creation' stamp: 'hk 4/13/2015 10:51'!
on: aContext
	^ self basicNew
		context: aContext;
		initialize! !

!GbtUI class methodsFor: 'instance creation' stamp: 'hk 1/31/2016 11:31'!
on: aContext mode: aSymbol
	^ self basicNew
		context: aContext;
		initialize! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 3/23/2017 10:30'!
bizApp
	^context bizApp! !

!GbtUI methodsFor: 'api' stamp: 'hk 7/19/2016 14:12'!
clearSubUI
	"default"! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 4/13/2015 10:52'!
context
	^context ! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 8/26/2015 10:32'!
context: aAC
	context := aAC .
	aAC ui: self! !

!GbtUI methodsFor: 'constants' stamp: 'hk 5/19/2016 11:56'!
defaultWidth
	^self class  buttonWidth *2! !

!GbtUI methodsFor: 'ui actions' stamp: 'hk 11/16/2017 17:12'!
editBehavior
	| list key res |
	list := context behaviors ifEmpty: [^self notify: 'no behavior'].
	list size >1 ifTrue: 
		[key := (UIManager default chooseFrom: list keys values: list keys)].  
	res := key ifNil: [list anyOne ] ifNotNil: [list at: key].
	res edit 
! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 12/31/2016 18:05'!
editor
	^self editorLoop: 1 ! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 1/24/2018 15:39'!
editorLoop: aCounter
	aCounter > 4 "no of modes" ifTrue: [ self notify:  'UI editor loop' ].
	^[(self modeEditorOf: context vo) on: context vo ] ifError: 
			[self nextMode. self editorLoop: aCounter +1 ]! !

!GbtUI methodsFor: 'testing' stamp: 'hk 3/1/2016 12:06'!
hasTarget  
	^false
! !

!GbtUI methodsFor: 'initialization' stamp: 'hk 10/4/2017 11:48'!
iconRowFor: aColumn
	aColumn 	newRow: [ :r | r
		add:  #pIcon width: 24 ;
		add:  #pLabel ;
		add: #pEditBeh width: 80 ;
		add: #pInspect width: 80  ] height: self class toolbarHeight .
! !

!GbtUI methodsFor: 'testing' stamp: 'hk 11/21/2016 18:14'!
inEdit  
	^ mode value = #edit
! !

!GbtUI methodsFor: 'api' stamp: 'hk 7/19/2017 14:46'!
initialExtent
	"default extent when stand alone"
	^770 @ 400! !

!GbtUI methodsFor: 'initialization' stamp: 'hk 10/4/2017 11:49'!
initializeInspectors
	self instantiateModels: #( 
		pEditBeh 		ButtonModel
		emptyLabel 	LabelModel
		pInspect		ButtonModel) .				
	self pInspect
		action: [context inspect];
		state: true;
		label: 'inspect Ctxt'.
	self pEditBeh
		action: [self editBehavior];
		state: true;
		label: 'edit CIEL'
! !

!GbtUI methodsFor: 'mode switching' stamp: 'hk 11/23/2017 09:21'!
initializeMode
	modeToggler := Dictionary newFromPairs: #(
		diEdit 	edit 		
		edit 		text
		text 		sdBox
		sdBox 		diEdit).
	mode := #diEdit asValueHolder.! !

!GbtUI methodsFor: 'initialization' stamp: 'hk 10/4/2017 11:52'!
initializeWidgets
	self instantiateModels: #( 
		pIcon			ButtonModel
		pLabel			LabelModel) .				
	self pLabel label: 'undefined'.
	self initializeInspectors! !

!GbtUI methodsFor: 'testing' stamp: 'hk 10/31/2016 17:47'!
isGbtUi
	^true
! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 11/21/2016 18:11'!
mode
	^ mode value! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 11/21/2016 18:11'!
mode: aSymbol
	mode value: aSymbol! !

!GbtUI methodsFor: 'mode switching' stamp: 'hk 11/21/2016 18:30'!
modeAfter: aSymbol
	^ modeToggler at: aSymbol! !

!GbtUI methodsFor: 'ui actions' stamp: 'hk 1/24/2018 15:55'!
modeEditorOf: aTarget
	"incomplete - GbtNoEditor needed when no read right"
	aTarget uiClassName ifNotNil: [:cls|^aTarget uiClass ].
	self context userRight write ifTrue: 
		[self mode = #diEdit ifTrue: [^GbtThingDiEditor].
		self mode = #edit ifTrue: [^GbtThingEditor]].
	self mode = #sdBox ifTrue: [^GbtCustomSDBoxWidget].
	mode value: #text.
	^GbtUiTextWidget! !

!GbtUI methodsFor: 'mode switching' stamp: 'hk 12/19/2017 14:43'!
nextMode   
	mode value: (self modeAfter: self mode)! !

!GbtUI methodsFor: 'error handling' stamp: 'hk 11/8/2016 19:57'!
notify: aString
	aString ifEmpty: [^self].
	owner notify: aString! !

!GbtUI methodsFor: 'instance creation' stamp: 'hk 4/11/2016 16:25'!
open
	^self openWithSpec! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 11/4/2016 17:51'!
packageVersion
	^self class package  mcPackage workingCopy versionInfo name! !

!GbtUI methodsFor: 'printing' stamp: 'hk 8/27/2015 19:38'!
printOn: aStream 	
	super printOn: aStream .
	aStream nextPutAll: ' on '; nextPutAll: context printString! !

!GbtUI methodsFor: 'api' stamp: 'hk 10/21/2015 17:54'!
reBuild
"Transcript cr; show: self className .
"	self initializeLayout.
	self needFullRebuild: false .
	self buildWithSpec
! !

!GbtUI methodsFor: 'constants' stamp: 'hk 4/13/2015 11:41'!
reducedHeight
	^self class toolbarHeight *0.8 ! !

!GbtUI methodsFor: 'ui actions' stamp: 'hk 8/11/2016 14:47'!
refresh! !

!GbtUI methodsFor: 'api' stamp: 'hk 7/19/2016 14:12'!
resetList
	"default"! !

!GbtUI methodsFor: 'constants' stamp: 'hk 4/13/2015 11:41'!
singleHeight
	^self class toolbarHeight ! !

!GbtUI methodsFor: 'ui actions' stamp: 'hk 12/19/2017 13:42'!
toggle
 	self nextMode ; reBuild 

! !

!GbtUI methodsFor: 'accessing' stamp: 'hk 11/7/2016 12:36'!
user
	^context user ifNil: [ 'n.n.' ] ! !

GbtUI subclass: #GcCalcUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GcCalcUI methodsFor: 'initialization' stamp: 'hk 1/23/2016 15:38'!
initializeLayout
	
	self layout: (SpecLayout composed newColumn: [ :c | 
		self iconRowFor: c .
		c 	newRow: [ :r | r  
				add: #emptyLabel ;
				add: #calculator  ;
				add: #emptyLabel ] height: 6.333 * self class toolbarHeight .
		c	add: #emptyLabel  ] ).
	self needFullRebuild: false.


! !

!GcCalcUI methodsFor: 'initialization' stamp: 'hk 4/30/2016 18:29'!
initializeWidgets
	super initializeWidgets .
	self pIcon icon: (GbtIcons at: context uiKey) .
	self pLabel label: context displayName  .
	self assign: SvoCalc new to: #calculator .	
	self initializeLayout! !

GbtUI subclass: #GcDashUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-context'!

!GcDashUI methodsFor: 'initialization' stamp: 'hk 1/23/2016 15:38'!
initializeLayout
 	self layout: (SpecLayout composed newColumn: [ :c | 
		self iconRowFor: c .
		c add: #dashButton ] ).	
	self needFullRebuild: false.
! !

!GcDashUI methodsFor: 'initialization' stamp: 'hk 4/30/2016 18:29'!
initializeWidgets
	super initializeWidgets .
	self pIcon icon: (GbtIcons at: context uiKey ) .
	self pLabel label: context displayName  .
	self assign: (ButtonModel new
				state: false;
				icon: (GbtIcons default dashboardIcon)) to: #dashButton.
	self initializeLayout! !

DynamicComposableModel subclass: #GbtUiTextWidget
	instanceVariableNames: 'smartVO'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing'!

!GbtUiTextWidget commentStamp: 'hk 1/24/2018 16:24' prior: 0!
I am a scrollable Text dislay that can be used in place of a GbtThingEditor

    Instance Variables
	smartVO:		<GbtSmartNode> 	
!

GbtUiTextWidget subclass: #GbtSourceWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing'!

!GbtSourceWidget commentStamp: 'hk 1/24/2018 16:25' prior: 0!
For GbtSource things I am much more appropriate than the GbtThingEditor
My smartVO is of type GbtSource (application specific)
implemented without Presenter notifications		
	
===============================================================

	GbtServer  initialize.	
	(GbtSourceWidget on: 
		(GbtSmartNode struct: #GbtSource  define:  { 
		{#summary 	.	'  #sourceName'}.
		{  #sourceName 	. #val:  .   'my test'}.
		{ #source  . #text:  .  '' }	})	) openWithSpec!

!GbtSourceWidget class methodsFor: 'as yet unclassified' stamp: 'hk 1/24/2018 12:25'!
on: aVO 
	^self basicNew 
		slotVO: aVO; 
		initialize! !

!GbtSourceWidget class methodsFor: 'as yet unclassified' stamp: 'hk 1/23/2018 19:39'!
on: aVO stopSlots: anObject
	^self on: aVO ! !

!GbtSourceWidget methodsFor: 'updating' stamp: 'hk 1/24/2018 16:17'!
checkUndoRedo
	smartVO next 
		ifNil: [self redoButton disable] 
		ifNotNil: [self redoButton enable].
	smartVO previous
		ifNil: [self undoButton disable] 
		ifNotNil: [self undoButton enable]! !

!GbtSourceWidget methodsFor: 'updating' stamp: 'hk 1/24/2018 16:37'!
contentChanged
	self readSource.
	self voName label: smartVO displayName.
	self checkUndoRedo ! !

!GbtSourceWidget methodsFor: 'initialization' stamp: 'hk 1/24/2018 13:34'!
initializeLayout
	self layout: (SpecLayout composed newColumn: [ :c | 
		self nameAndButtonRow: c.
		c add: #source.])! !

!GbtSourceWidget methodsFor: 'initialization' stamp: 'hk 1/24/2018 16:19'!
initializeWidgets

	self instantiateModels: #(
		voName					LabelModel
		summary				LabelModel
		source 				TextModel
		emptyLabel			LabelModel
		saveButton			ButtonModel
		undoButton			ButtonModel
		redoButton			ButtonModel
		inspectUi				ButtonModel
		inspectVo				ButtonModel) .
	self voName label: smartVO displayName.
	self summary label: smartVO summaryEnriched.
	self saveButton 
		icon: (GbtIcons at: #save) ;
		action: [self save];
		help: 'save';
		state: true.
	self undoButton 
		icon: (GbtIcons at: #undo) ;
		action: [self undo];
		help: 'undo';
		state: true;
		disable.
	self redoButton 
		icon: (GbtIcons at: #redo) ;
		action: [self redo];
		help: 'redo';
		state: true;
		disable.
	self inspectUi 
		icon: (GbtIcons default inspectIcon) ;
		label: ' UI';
		action: [self inspect ];
		state: true.
	self inspectVo
		icon: (GbtIcons default inspectIcon) ;
		label: ' VO';
		action: [smartVO inspect];
		state: true.
	self source acceptBlock: [:item | self writeSource: item ].
	self readSource .
	self initializeLayout
	

! !

!GbtSourceWidget methodsFor: 'initialization' stamp: 'hk 1/24/2018 16:21'!
nameAndButtonRow: aColumn
	aColumn newRow: [ :r | r 
			add: #summary ;
			add: #voName;
			add: #emptyLabel;
			add: #undoButton width: 28;
			add: #redoButton width: 28;
			add: #inspectUi width: 48;
			add: #inspectVo width: 48;
			add: #saveButton width: 24 
			] height: self class toolbarHeight 
! !

!GbtSourceWidget methodsFor: 'updating' stamp: 'hk 1/24/2018 16:18'!
readSource
	self source text = smartVO source ifTrue: [^self].
	self source text: smartVO source 
! !

!GbtSourceWidget methodsFor: 'actions' stamp: 'hk 1/24/2018 16:19'!
redo
	smartVO becomeNext. 
	self contentChanged  ! !

!GbtSourceWidget methodsFor: 'actions' stamp: 'hk 1/24/2018 16:19'!
save
	smartVO save.
 	self contentChanged ! !

!GbtSourceWidget methodsFor: 'actions' stamp: 'hk 1/24/2018 16:19'!
undo
	smartVO becomePrevious . 
	self contentChanged ! !

!GbtSourceWidget methodsFor: 'updating' stamp: 'hk 1/24/2018 16:22'!
whenChangedDo: aBlockClosure ! !

!GbtSourceWidget methodsFor: 'updating' stamp: 'hk 1/24/2018 16:19'!
writeSource: aValue
	"all GUI writes to slotVO must use #write - see evolve"  
	((smartVO slotSVOAt: #source) inputValue = aValue) ifTrue: [^self].
	smartVO evolveLeaf: #source write: aValue.
	self contentChanged 
	! !

!GbtUiTextWidget class methodsFor: 'instance creation' stamp: 'hk 11/9/2016 13:42'!
on: aVO 
	"for use instead of GcVOEditor"
	^self basicNew slotVO: aVO; initialize! !

!GbtUiTextWidget class methodsFor: 'instance creation' stamp: 'hk 2/23/2016 15:59'!
on: aVO stopSlots: anObject
	^self on: aVO ! !

!GbtUiTextWidget methodsFor: 'updating' stamp: 'hk 5/12/2017 13:42'!
contentChanged
	"compatibility with GbtThingEditor"
	^nil! !

!GbtUiTextWidget methodsFor: 'accessing' stamp: 'hk 7/1/2016 19:28'!
editor1
	"compatibility with GbtThingDiEditor"
	^nil! !

!GbtUiTextWidget methodsFor: 'initialization' stamp: 'hk 11/1/2016 17:25'!
initializeLayout
	self layout: (SpecLayout composed add: #text; yourself)
		! !

!GbtUiTextWidget methodsFor: 'initialization' stamp: 'hk 1/24/2018 16:08'!
initializeWidgets

	self instantiateModels:  #(text 	TextModel) .
	self  text text: smartVO asText .
	self initializeLayout .
	self needFullRebuild:  false.
	! !

!GbtUiTextWidget methodsFor: 'accessing' stamp: 'hk 1/24/2018 16:07'!
slotVO: anObject
	smartVO := anObject! !

DynamicComposableModel subclass: #SvoCalc
	instanceVariableNames: 'display button0 button1 button2 button3 button4 button5 button6 button7 button8 button9 buttonPlus buttonMinus buttonMult buttonDiv buttonEq buttonDot buttonSqr buttonLog buttonChange buttonClear previousNumber currentOperation operationPending'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Utilities'!

!SvoCalc commentStamp: 'hk 4/13/2015 17:37' prior: 0!
SvoCalc new openWithSpec

A SpoCalc is the Spec Demo Calculator enhanced.

Instance Variables
	display:				<TextInput>	the calculators input & display
	currentOperation:	<String>		the operation to be performed:  +  -  * / 
	operationPending:	<Bolean>		true after pressing +  -  * /  =
										means: new input expected
	previousNumber:	<Number | nil>	stores the first value entered
										no operation pending ifNil
			
	button0:			<Button>
	button1:			<Button>
	button2:			<Button>
	button3:			<Button>
	button4:			<Button>
	button5:			<Button>
	button6:			<Button>
	button7:			<Button>
	button8:			<Button>
	button9:			<Button>
	buttonChange:		<Button>
	buttonClear:		<Button>
	buttonDiv:			<Button>
	buttonDot:			<Button>
	buttonEq:			<Button>
	buttonLog:			<Button>
	buttonMinus:		<Button>
	buttonMult:			<Button>
	buttonPlus:			<Button>
	buttonSqr:			<Button>

!

!SvoCalc class methodsFor: 'specs' stamp: 'hk 1/5/2015 14:43'!
title 
	^ 'SVO Calculator'! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:01'!
addition
	buttonPlus
		label: '+';
		action: [ self operation: $+ ];
		state: true! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
button0
	^ button0! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
button1
	^ button1! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button2
	^ button2! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button3
	^ button3! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button4
	^ button4! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button5
	^ button5! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button6
	^ button6! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button7
	^ button7! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button8
	^ button8! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button9
	^ button9! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
buttonChange
	^ buttonChange! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
buttonClear
	^ buttonClear! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
buttonDiv
	^ buttonDiv! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
buttonDot
	^ buttonDot! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
buttonEq
	^ buttonEq! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
buttonLog
	^ buttonLog! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
buttonMinus
	^ buttonMinus! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
buttonMult
	^ buttonMult! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
buttonPlus
	^ buttonPlus! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
buttonSqr
	^ buttonSqr! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 18:02'!
changeSign
	buttonChange
		label: '+/ -';
		action: [ display label: display label asNumber negated asString ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/6/2014 16:13'!
clearDisplay
	buttonClear
		label: 'C';
		action: [ display label: '0' ];
		state: true! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/6/2014 14:56'!
defineDigitButton: aButton label: aString
	aButton
		label: aString;
		action: [ display label: (self newDisplayLabelFor: aString) asNumber asString  ];
		state: true! !

!SvoCalc methodsFor: 'button definition' stamp: 'hk 11/6/2014 14:57'!
defineDigitButtons
	button0
		label: '0' ;
		action: [ display label: (self newDisplayLabelFor: '0' )  ];
		state: true.
	self defineDigitButton: button1 label: '1'.
	self defineDigitButton: button2 label: '2'.
	self defineDigitButton: button3 label: '3'.
	self defineDigitButton: button4 label: '4'.
	self defineDigitButton: button5 label: '5'.
	self defineDigitButton: button6 label: '6'.
	self defineDigitButton: button7 label: '7'.
	self defineDigitButton: button8 label: '8'.
	self defineDigitButton: button9 label: '9'.
! !

!SvoCalc methodsFor: 'button definition' stamp: 'hk 11/5/2014 14:45'!
defineOtherButtons
	"basic arithmetic operations"
	self addition.
	self subtraction.
	self multiplication.
	self division.	
		
	"other arithmetic opertions"
	self squareRoot.
	self logarithm.
	self changeSign.	
		
	"remaining buttons"
	self clearDisplay.
	self enterDot.
	self equals! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:34'!
display
	^ display! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:06'!
division
	buttonDiv
		label: '/';
		action: [ self operation: $/ ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/6/2014 15:56'!
enterDot
	buttonDot
		label: '.';
		action: [display label: (self newDisplayLabelForDot )  ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/6/2014 16:12'!
equals
	buttonEq
		label: '=';
		action: [ operationPending := true. 
				previousNumber ifNotNil: 
					[display label: (previousNumber perform: currentOperation asSymbol with:  display label asNumber ) asString].
				previousNumber := nil ];
		state: true! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 4/13/2015 17:47'!
initialExtent
	"(4@4) is the size of the border"

	^ 251 @ 191 ! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 11/6/2014 15:36'!
initialize
	operationPending  := false.
	super initialize! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 11/5/2014 14:33'!
initializeDigitButtons
	button0 := self newButton.
	button1 := self newButton.
	button2 := self newButton.
	button3 := self newButton.
	button4 := self newButton.
	button5 := self newButton.
	button6 := self newButton.
	button7 := self newButton.
	button8 := self newButton.
	button9 := self newButton.
	self defineDigitButtons! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 1/25/2015 20:49'!
initializeLayout
	self layout: (SpecLayout composed
		newColumn: [ :column | column
						add: #display ;
						newRow: [ :row1 | row1
										add: #buttonClear;
										add: #buttonLog;
										add: #buttonChange;
										add: #buttonSqr ] height: 26;
						newRow: [ :row2 | row2
										add: #button1;
										add: #button2;
										add: #button3;
										add: #buttonDiv ] height: 26;
						newRow: [ :row3 | row3
										add: #button4;
										add: #button5;
										add: #button6;
										add: #buttonMult ] height: 26;
						newRow: [ :row4 | row4
										add: #button7;
										add: #button8;
										add: #button9;
										add: #buttonMinus ] height: 26;
						newRow: [ :row5 | row5
										add: #buttonDot;
										add: #button0;
										add: #buttonEq;
										add: #buttonPlus ] height: 26 ];
		yourself)! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 11/5/2014 14:46'!
initializeOtherButtons
	"instantiate the basic arithmetic buttons"

	buttonPlus := self newButton.
	buttonMinus := self newButton.
	buttonMult := self newButton.
	buttonDiv := self newButton.
	buttonEq := self newButton.	
		
	"instantiate the remaining buttons"
	buttonDot := self newButton.
	buttonSqr := self newButton.
	buttonLog := self newButton.
	buttonChange := self newButton.
	buttonClear := self newButton.
	
	self defineOtherButtons! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 1/25/2015 19:58'!
initializeWidgets 
	self initializeDigitButtons. 
	self initializeOtherButtons. 
	display := self newLabel.
	self initializeLayout ! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:17'!
logarithm
	buttonLog
		label: 'Log';
		action: [ display label: display label asNumber log asString ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 18:26'!
multiplication
	buttonMult
		label: 'x';
		action: [ self operation: $* ];
		state: true! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/6/2014 15:31'!
newDisplayLabelFor: aString
	^operationPending ifTrue: [operationPending  := false. aString ]  ifFalse: [ display label , aString ] ! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/6/2014 16:06'!
newDisplayLabelForDot
	^ (operationPending or: [display label isEmpty])
		ifTrue: [ operationPending := false.  '0.' ]
		ifFalse: [  (display label includes: $.) 
						ifTrue: [ display label ] 
						ifFalse:  [ display label,  '.' ] ]! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/6/2014 16:16'!
operation: aCharacter
	"Defines which operation will be performed: it can be a + / - x"

	previousNumber := display label asNumber.	
	currentOperation := aCharacter.				
	operationPending  := true.! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/5/2014 17:08'!
sqrCheck
	"checks whether we are attempting to calculate the square root of a negative
number"

	display label asNumber < 0
		ifTrue: [ display label: 'Error' ]
		ifFalse: [ display label: display label asNumber sqrt asString ]! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:07'!
squareRoot
	buttonSqr
		label: 'Sqr';
		action: [ self sqrCheck ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:05'!
subtraction
	buttonMinus
		label: '-';
		action: [ self operation: $- ];
		state: true! !

RTUMLClassBuilder subclass: #GbtDiagramBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Utilities'!

!GbtDiagramBuilder commentStamp: 'hk 5/26/2015 22:41' prior: 0!
I extend the RTUMLClassBuilder in order to show SVO classes with just the 'protocol protocol'!

!GbtDiagramBuilder class methodsFor: 'analysis' stamp: 'hk 11/16/2016 12:22'!
exampleAuthoringProtocol
	"self exampleAuthoringProtocol"

	TextModel new openWithSpec ; text: self new authoringProtocol! !

!GbtDiagramBuilder class methodsFor: 'analysis' stamp: 'hk 1/23/2018 15:39'!
exampleCIELParsers
	TextModel new openWithSpec ; text: GbtCielGrammar documentation! !

!GbtDiagramBuilder class methodsFor: 'analysis' stamp: 'hk 1/23/2018 15:39'!
exampleSELParsers
	TextModel new openWithSpec ; text: GbtSELGrammar documentation! !

!GbtDiagramBuilder class methodsFor: 'analysis' stamp: 'hk 8/16/2017 17:15'!
exampleSelectedThingTree
	"self exampleSelectedThingTree -	show all selected thing trees "

	| builder view |
	(builder := RTUMLClassBuilder new)
	 	addObjects: GbtServer default selectedNodesInHierarchy ;
		classname: #longName ;
		instanceVariables: #rtAttributes ;
		methodsNames: #rtSlots ;
		superclass: #container;
		methodselector: #yourself .
	builder	layout  tree.
"	builder lineShape arrowedLine.
"	view := builder view setDefaultMenu.
	RTZoomOutMove on: view . 
	builder build. 
	view openInWindowSized: 1600 @ 800 titled: 'Structure of Things'! !

!GbtDiagramBuilder class methodsFor: 'analysis' stamp: 'hk 8/16/2017 17:15'!
exampleShowContexts
	"create an Application first 
	self exampleShowContexts"

	| builder view |
	(builder := RTUMLClassBuilder new)
		addObjects: GbtServer default allContexts ;
		classname: #svoName ;
		instanceVariables: #rtAttributes ;
		methodsNames: #rtBehaviors ;
		methodselector: #yourself ;
		superclass: #container ;
		treeLayout.
	view := builder view setDefaultMenu.
	builder build.
	view openInWindowSized: 1600 @ 800 titled: 'Context Hierarchy'! !

!GbtDiagramBuilder class methodsFor: 'analysis' stamp: 'hk 11/16/2016 13:34'!
exampleShowSVOgui
	"self exampleShowSVOgui"

	| builder view |
	(builder := RTUMLClassBuilder new)
		addObjects: GbtUI withAllSubclasses;
		addObjects: (Array with: DynamicComposableModel) ;
		addObjects: GbtTableListUI withAllSubclasses;
		addObjects: GbtWidget withAllSubclasses;
		addObjects: GbtEmptyWidget withAllSubclasses;
		addObjects: GbtThingDiEditor withAllSubclasses;
		addObjects: GbtThingEditor withAllSubclasses;
		addObjects: GbtAddressBoxWidget withAllSubclasses;
		addObjects: GbtCustomSDBoxWidget withAllSubclasses;
		treeLayout.
	view := builder view setDefaultMenu.
	builder lineShape arrowedLine inverted.
	builder build.
	view openInWindowSized: 1200 @ 800 titled: 'GUI classes'! !

!GbtDiagramBuilder class methodsFor: 'analysis' stamp: 'hk 10/17/2017 13:17'!
exampleShowSVOmachine
	"self exampleShowSVOmachine"

	| builder view |
	(builder := RTUMLClassBuilder new)
		addObjects: GbtObject withAllSubclasses; 
		addObjects: {GbtSlotAssociation. GbtEvent. GbtEventQueue. GbtActionPipe. GbtServer. GbtBizNetMockUp. GbtReader. GbtPrimeThingMap. GbtTransaction. GbtTransactor. GbtRole};
		addObjects: GbtCell withAllSubclasses; 
		addObjects: GbtAction withAllSubclasses; 
		addObjects: {TGbtSerializer}; 
		treeLayout.
	view := builder view setDefaultMenu.
	builder lineShape arrowedLine inverted.
	builder build.
	view openInWindowSized: 1200 @ 800 titled: 'GbtSVO classes'! !

!GbtDiagramBuilder class methodsFor: 'analysis' stamp: 'hk 8/16/2017 17:15'!
exampleThings
	"self exampleThings -	show all things "

	| builder view |
	(builder := RTUMLClassBuilder new)
	 	addObjects: GbtServer default allThings;
		classname: #longName ;
		instanceVariables: #rtAttributes ;
		methodsNames: #rtSlots ;
		superclass: #container;
		methodselector: #yourself .
	builder	layout  tree.
"	builder lineShape arrowedLine.
"	view := builder view setDefaultMenu.
	RTZoomOutMove on: view . 
	builder build. 
	view openInWindowSized: 1600 @ 800 titled: 'Structure of Things'! !

!GbtDiagramBuilder methodsFor: 'accessing' stamp: 'hk 5/27/2015 11:22'!
attributesOf: object	
	^ object class methods select: [ :m | m protocol =  'authoring'] thenCollect: [ :m | m selector ]! !

!GbtDiagramBuilder methodsFor: 'authoring ' stamp: 'hk 5/3/2017 12:13'!
authoringProtocol
	| stream  |
	stream := TextStream on: (Text new: 10) .
	(GbtObject withAllSubclasses sort: [:a :b|a name < b name]) do: 
		[ :cls |  |mths|
			mths := self methodsForClass: cls class.
			self printMethods: mths on: stream forClass: cls class.
			mths := self methodsForClass: cls.
			self printMethods: mths on: stream forClass: cls].
	^stream contents ! !

!GbtDiagramBuilder methodsFor: 'accessing' stamp: 'hk 11/17/2015 20:08'!
methodsForClass: obj
	| protocols methods |
	protocols := obj protocols select: [ :p| p beginsWith: 'authoring' ].
	methods := SortedCollection new sortBlock: [ :a :b | a selector < b selector ].
	protocols do: [ :p| methods addAll: (obj methodsInProtocol: p) ].
	^ methods! !

!GbtDiagramBuilder methodsFor: 'authoring ' stamp: 'hk 11/16/2016 13:26'!
printMethods: mths on: aStream forClass: aClass
	mths ifNotEmpty: 
				[aStream nextPutAll: aClass name asText allBold; cr].
	mths do: [ :m | |cmt | 
				aStream nextPutAll: m selector asText allItalic; cr .
				cmt := m comment ifNil: [ 'comment missing' ].
				aStream tab ; nextPutAll: cmt; cr ] ! !

!StandardFileStream methodsFor: '*GBT-DSL' stamp: 'hk 8/30/2015 18:48'!
compressFile
	"Write a new file that has the data in me compressed in GZip format."
	| zipped buffer |

	self readOnly; binary.
	zipped := (self directory / self localName, 'gz') writeStream.
	zipped binary; setFileTypeToObject.
		"Type and Creator not to be text, so can be enclosed in an email"
	zipped := GZipWriteStream on: zipped.
	buffer := ByteArray new: 50000.
	'Compressing ', self fullName displayProgressFrom: 0 to: self size
		during: [:bar |
			[self atEnd] whileFalse: [
				bar current: self position.
				zipped nextPutAll: (self nextInto: buffer)].
			zipped close.
			self close].
	^zipped! !

DateModel subclass: #GbtDateModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-UI-Thing-Leaves'!

!GbtDateModel commentStamp: 'hk 8/2/2016 15:02' prior: 0!
I subclass DateModel to conform to Gbt layout!

!GbtDateModel class methodsFor: 'accessing' stamp: 'hk 7/31/2016 15:00'!
spec
	<spec: #default>
	"self example inspect"
	^ SpecLayout composed newRow: [ :row | row
			add: #dateLabel width: GbtWidget labelWidth ; 
			add: #dateModel;  
			add: #chooseDateButton width: 20] ! !

!GbtDateModel methodsFor: 'delegation' stamp: 'hk 10/20/2017 13:15'!
askForValue
	owner askForValue! !

!GbtDateModel methodsFor: 'delegation' stamp: 'hk 12/12/2017 14:24'!
read
	owner read! !

!GbtDateModel methodsFor: 'delegation' stamp: 'hk 10/20/2017 13:14'!
readInput
	owner readInput! !

!GbtDateModel methodsFor: 'api-events' stamp: 'hk 7/23/2017 13:58'!
whenDateChanged: aBlock
	"need to change the date check of acceptBlock to allow invalid dates"
	dateModel whenTextChanged: [:newText :oldText :announcement :anAnnouncer |
		aBlock cull: newText cull: oldText cull: announcement cull: anAnnouncer ]! !

!Trait methodsFor: '*GBT-DSL' stamp: 'hk 2/6/2017 18:43'!
rtmethods
	^self methods! !

!Text methodsFor: '*GBT-DSL' stamp: 'hk 2/6/2017 18:26'!
allItalic
	"Force this whole text to be bold."
	string size = 0 ifTrue: [^self].
	self makeItalicFrom: 1 to: string size! !

!Text methodsFor: '*GBT-DSL' stamp: 'hk 2/6/2017 18:25'!
makeItalicFrom: start to: stop

	^ self addAttribute: TextEmphasis italic from: start to: stop! !

Error subclass: #GbtError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

!GbtError commentStamp: 'hk 4/30/2016 18:33' prior: 0!
I am made to show up in the debugger - indicating an authoring error.

I am usually thrown on failed checks of authoring constructs!

GbtError subclass: #GbtParserError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

!GbtParserError commentStamp: 'hk 7/7/2017 12:53' prior: 0!
I am made to show up in parser production - indicating a production  error!

GbtParserError subclass: #GbtCIELError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

GbtCIELError subclass: #GbtCielExistsError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

!GbtCielExistsError methodsFor: 'as yet unclassified' stamp: 'hk 10/4/2017 12:32'!
messageText: signalerText
	"Set an exception's message text."

	messageText := 'Not found: ', signalerText! !

GbtCIELError subclass: #GbtCielTypeError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

!GbtCielTypeError methodsFor: 'as yet unclassified' stamp: 'hk 9/26/2017 15:58'!
messageText: signalerText
	"Set an exception's message text."

	messageText := 'Not a ', signalerText! !

GbtCIELError subclass: #GbtConstraintError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

!GbtConstraintError methodsFor: 'as yet unclassified' stamp: 'hk 9/26/2017 15:52'!
messageText: signalerText
	"Set an exception's message text."

	messageText := 'Constraints ', signalerText! !

GbtCIELError subclass: #GbtPUserAbortError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

!GbtPUserAbortError methodsFor: 'as yet unclassified' stamp: 'hk 9/26/2017 15:39'!
messageText: signalerText
	"Set an exception's message text."

	messageText := 'User abort ', signalerText! !

GbtParserError subclass: #GbtPContainerError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

!GbtPContainerError methodsFor: 'accessing' stamp: 'hk 7/25/2017 12:37'!
messageText: signalerText
	"Set an exception's message text."

	messageText := 'No Container ', signalerText! !

GbtParserError subclass: #GbtPDiv0Error
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

!GbtPDiv0Error methodsFor: 'accessing' stamp: 'hk 7/25/2017 12:41'!
messageText: signalerText
	"Set an exception's message text."

	messageText := 'Div0: ', signalerText! !

GbtParserError subclass: #GbtPTagError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

!GbtPTagError methodsFor: 'accessing' stamp: 'hk 8/16/2017 16:15'!
messageText: signalerText
	"Set an exception's message text."

	messageText := 'NaRef: ', signalerText! !

GbtParserError subclass: #GbtPTypeError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

GbtPTypeError subclass: #GbtPDateError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

!GbtPDateError methodsFor: 'accessing' stamp: 'hk 7/25/2017 12:41'!
messageText: signalerText
	"Set an exception's message text."

	messageText := 'NaD: ', signalerText! !

GbtPTypeError subclass: #GbtPNumberError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

!GbtPNumberError methodsFor: 'accessing' stamp: 'hk 7/25/2017 12:54'!
messageText: signalerText
	"Set an exception's message text."

	messageText := 'NaN: ', signalerText! !

GbtPTypeError subclass: #GbtPStringError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

!GbtPStringError methodsFor: 'accessing' stamp: 'hk 7/25/2017 12:51'!
messageText: signalerText
	"Set an exception's message text."

	messageText := 'NaStr: ', signalerText! !

GbtPTypeError subclass: #GbtPThingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

!GbtPThingError methodsFor: 'accessing' stamp: 'hk 7/25/2017 12:50'!
messageText: signalerText
	"Set an exception's message text."

	messageText := 'NaTh: ', signalerText! !

!GbtPTypeError methodsFor: 'accessing' stamp: 'hk 7/25/2017 12:56'!
messageText: signalerText
	"Set an exception's message text."

	messageText := 'NaRef: ', signalerText! !

ThemeIcons subclass: #GbtIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Utilities'!

GbtIcons class
	instanceVariableNames: 'default'!

!GbtIcons commentStamp: 'hk 11/25/2016 18:07' prior: 0!
GcIcons is a container for the GloConn icons.

Start from a png in your 'Icons'-Directory and 
1. add the filename (without extension) to the method normalSizeNames
2.  do:    < GbtIcons default createIconMethodsFromDirectory: 'Icons' >
move the newly created icon form to the resources icons protocol

to reset  do:  <  GbtIcons initialize >

to create an icon (png, 32x32) :
 https://iconverticons.com/online/


To write a png:
self default rowingTeamIcon writePNGFileNamed: 'rowingTeam.png'!

GbtIcons class
	instanceVariableNames: 'default'!

!GbtIcons class methodsFor: 'accessing' stamp: 'hk 12/13/2017 17:22'!
at: aKey
	(aKey = #add) ifTrue: [ ^Smalltalk ui icons smallAddIcon ].
	(aKey = #back) ifTrue: [ ^Smalltalk ui icons backIcon ].
	(aKey = #blank144) ifTrue: [ ^Smalltalk ui icons blankIconOfWidth: 144 ].
	(aKey = #edit) ifTrue: [ ^Smalltalk ui icons editIcon].
	(aKey = #delete) ifTrue: [ ^Smalltalk ui icons deleteIcon ].
	(aKey = #undo) ifTrue: [ ^Smalltalk ui icons smallUndoIcon ].
	(aKey = #redo) ifTrue: [ ^Smalltalk ui icons smallRedoIcon ].
	(aKey = #refresh) ifTrue: [ ^Smalltalk ui icons refreshIcon ].
	(aKey = #view) ifTrue: [ ^Smalltalk ui icons smallInspectItIcon ].
	(aKey = #text) ifTrue: [ ^GLMUIThemeExtraIcons glamorousBrowse].
	(aKey = #save) ifTrue: [ ^Smalltalk ui icons smallSaveIcon ].
	(aKey = #ask) ifTrue: [ ^Smalltalk ui icons smallQuestionIcon ].
	(aKey = #source) ifTrue: [ ^Smalltalk ui icons smallInspectIt ].
	(aKey = #content) ifTrue: [ ^Smalltalk ui icons smallObjects ].
	^self at: aKey ifAbsent: [Smalltalk ui icons questionIcon]
	! !

!GbtIcons class methodsFor: 'accessing' stamp: 'hk 11/25/2016 15:10'!
at: anIconSymbol ifAbsent: aBlock
	| sel |
	anIconSymbol ifNil: [^aBlock value].
	sel :=  (anIconSymbol, #Icon) asSymbol .
	(default respondsTo: sel) ifFalse: [^aBlock value].
	^default perform: sel! !

!GbtIcons class methodsFor: 'accessing' stamp: 'hk 11/25/2016 15:09'!
default
	^default ! !

!GbtIcons class methodsFor: 'class initialization' stamp: 'hk 11/25/2016 15:09'!
initialize
	default := self new! !

GbtIcons initialize!

!GbtIcons class methodsFor: 'class initialization' stamp: 'hk 10/12/2016 14:56'!
initializeImageIcon
	"replace the Pharo image by GloConn -  self initializeImageIcon "
	
	(World submorphs detect: [ :sm | sm isKindOf: ImageMorph ]) image: self default headerIcon! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 1/2/2018 19:32'!
GbtIcon16Icon
	"Private - Generated method"
	^self icons 
			at: #GbtIcon16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self GbtIcon16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 1/2/2018 19:32'!
GbtIcon16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/GbtIcon16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAACFUlEQVR42qXTTWsTURQG4GMi
rY0ialHBlVtFXKkLQbGo6D9w5UotiJtaEQTd2LoTXKgLQVvSVmzSD1qopiYqkSptUSKNMVPb
moQ0HxLTYZI7bSeZmXtfp3eK/oAceHgPl7t4N4cAbGkENTwA9jWCtFXOknmbzRcdBUnuiZzF
KmtguqGypdIcy5R/sHQ5IWUcqT9xxtY1RrF0DXeHGbrGdNzf1D2u43ZAg7IMzBRe49LEMbRH
zuFquE26FjmLy6GTmM59AM0s6uJ6b0HcHCiKjn5X58vf4srzrEikIcKlYXE0fEC0fTwiTkcP
SWeih8WJ9wdFpPBG0NtvZZy6F8OF7jmc73JdfBDH8TuzmI7bCKz0gN4Rdn7ywjdF0o4pDyhK
CBQHQbmqjYnFOiZ/1RFakuQ+vmCgxIDUehrPcq/QVxyFvzDyz4t8EKm1ZZCtfIV4dAN40gnx
uEPC01sQD9thJ2OwwSD4ZwDOP/FFAjZyFjZfAWn+fmSIkPV4kCVyeb1IO6n1jMHEKOp1giV8
juZNLTA5oWYGQZW+AF+mJp737OF52iUVtrY6b8QrvSFuY4gLkzjg5UKQBHhkmtYgJ20giAz5
kN22F9mmVlfLfreBfxIWRmAaBMva7mh22U4Da6PBEMjUKqqeUNTV5M//lAVV/55UTU1XbVFV
DSOh1urzaq2muOqKatSSqmVXVQKwuxHU6DR8zn8B5XmpnRIoTWwAAAAASUVORK5CYII='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 1/2/2018 19:39'!
GbtIcon96Icon
	"Private - Generated method"
	^self icons 
			at: #GbtIcon96Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self GbtIcon96IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 1/2/2018 19:39'!
GbtIcon96IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/GbtIcon96.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAAGAAAABgCAYAAADimHc4AAAABGdBTUEAALGPC/xhBQAAAAFz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=='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 1/2/2018 19:52'!
GbtIconBeh16Icon
	"Private - Generated method"
	^self icons 
			at: #GbtIconBeh16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self GbtIconBeh16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 1/2/2018 19:52'!
GbtIconBeh16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/GbtIconBeh16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAACLklEQVR42q3TS0hUURgH8M+Z
0LSCSqpF0CpoE9giFy5aVIitA4MCTeiBNlQ+kBlNBB1dRNSigh6UM77STDFInMBtrzEMcZjx
URhjakFd7nivNHfuvef7dzlXauNuOvDj/3HOWfw3HwHI2Qwz/00hxGbkG2V9AOzNBqnrQosv
29rsqmNFkvNM0tQMAa2/v0er8/u01o6A1tLWKLUG/VpD01Ut3B3SaGrRwI0XGtpHdbRtCL7U
0TigYv4HEOjw4eSDgzg3XIIzg8Uod5wdKUHZw0PwBS6B3i/oXNO1wnW9q1zb46rv+84XHic5
tgRuun2Ni8b2c2n0CJ94e5iPO0qjRXx07AD72qqZXn/6iWMtUygLTqO03XWqYxrF/ijeJWxc
v3kR1E/YMeFFfoSk7RMe0DNCZXMF6NuajVcLGUS+ZDD+WZLz6OxvKCYQ7gvhdKACVZ1XUBms
ls531qC8uQqPQk9AduIj+I4PuFcPvlsr4X4D+NZl2PEpCOhg8QaA8w+TYJ4EZH6A4F8gNdyD
r0RIejxIErm8Xiw6qT4dRQYjMA2CJQoceRvyYdqEtDEISnUPiiXKFcue3WKZdkorWwqdOxKp
rnFhY0iwSQLwCmaSAI9M0xoQpPY+dxoUILl1D5K5ha78fW6DcAQWhmGmCZa1zZHnsp0GFsEw
h0CmmlL0WEJZj8/9k5hX9Jm4Yqq6YvOakk7HFCMzqxhGwpVJKGkjrlj2mkIAdmXjvyxTTjb+
ALVSkkEXTmN+AAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 1/2/2018 19:52'!
GbtIconCtxt16Icon
	"Private - Generated method"
	^self icons 
			at: #GbtIconCtxt16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self GbtIconCtxt16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 1/2/2018 19:52'!
GbtIconCtxt16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/GbtIconCtxt16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAACMElEQVR42q3T30uTYRQH8OMW
mhZRSUV33RYVQdBFF6Hk39BdUKyMLgoVcTNMs4zI0MBIsSycKW7mpIKsZmFYiP0gMnVppHPL
GWWvm4/atvd9n/Pt9bEfN9HNOvDhezhX35tDzJz2LwB+5V9RygNgYyrI4+0QxaWVoryqRpSd
rVYqrL3IdUa0tnlEkhfFh89vRHBmWEzMDClBy/jXQSG+RwU5y87jUHU/nC1hFN34aBlHiXsS
h2tfo6ziCl588ePAvd3I9+fhyKNc5ah/Pw5270X/pyegU5WX2HF1lF2+BS72zCquTsGOa0E+
V3Wde2bu8M6Hmzn36Xbe17tVyendxnseb2F/5D5TgbMSu475kFc+gJzSPiXvdD92HL+LUmcd
vLMtoB7Cmmd2ZPWRsrrPBuoleKbbQa23fcivqEXBxUacvNCgFFY3wlFeg9b2LoTNCBrCbXBP
+9Ac6fytacqL8cUwSI69BdcVAvVOcH2JggYX+PIJyNFBmBBg+RzAKzC/VIClHIApv4G0Zjcm
iBCy2TBJpITsdnWbbeqCDh+SSYLBWZaMnzKhS0JC94Jibo8MU7qcsq2XU7RWiazItm4kYze7
pYkOyTpJwC6ZSQFsKnWjXVL0lhdBykJo5QaE0rOXZW5SDaLND2CgE3qcYBirLBnLTKuBsdSg
A6RHY9r8UEBbGBn9IzCmzb8b0fTovGbynBaPD2mJ5HstkQgsSwa0eGJEM8w5jQCsS8V/eaa0
VPwAEDmQfr11CuwAAAAASUVORK5CYII='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 1/3/2018 12:00'!
GbtIconEdit16Icon
	"Private - Generated method"
	^self icons 
			at: #GbtIconEdit16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self GbtIconEdit16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 1/3/2018 12:00'!
GbtIconEdit16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/GbtIconEdit16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAADAFBMVEUAAAD4+NbX5vxwoub0
1dj+/gDX5fz///////////8+vynz9+3T4/vw9f9jm+FypOf4+df4+dZBwCze69P399P01tn3
+NXz0tX//wP8/vHf69PwnrblBBP8/6r67/P++gDiAADV5Pzz09b//wL7/PHd6tFpnuXv9P1x
o+b67/DH2vPiAAbwoajy9u+65bX6+6c2vCBAvyo1NjWg5az7+weBr/NkuUHeAAC22/n7/gdF
gtD+/soKwgB1qO+DsPPW4v8AuwCh5q1IhNEOwwP7+wvhBhOY46b//8v7/An69wDhCRf7/grv
oLf7/6z81c36/635+QD8//L+/cTvna/d9t6Cr/P6+wBlukNHg9B7q/LN3vjfAAo9fM233Pn/
k3L+knDhAgKz2vnj8fz81svvoKLfAADvo6m4zuv+jmuc5Kn//8rG471dtjoMwgL8/ez7/gkA
vwDd9eL+/sj4+qn4+qr6/QCo5qcAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACT
8a9vAAABAHRSTlMA7fL+7f3yAREW/vLy8v7+7e3+8u3t7e397fL9/f3t/f3y7f3t8v7y/u3+
/f3y/v3+/v//////////////////////////////////////////////////////////////
/////////////////////////////wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA7+rj
EgAAAM9JREFUeJxiYEAH7EjAyIidHVnOyMgISHLCAZAPJBnUFZnY2Jh4eLmBfGEpVV2GqMhQ
U1M7W3sg38wsPCebQUtNg5mZnw/IF+LiMjTQY0iPibCycgLyHZxtbHILyhiSEmMtLID8EDdH
Y2PjzEKG5Iy4eCDfLzDI3do6qyiPISU1Acg3D/YP8La0zC8tZtDRBvJlFKRl5SVYWZVZ9RnS
oo2MXL3MfXw9XUxMPMJKGDSVWFhYRMXlJEUEGBkFxVSAHuBAAQxgDyEBAAAAAP//AwBgZCZd
vn5FfQAAAABJRU5ErkJggg=='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 1/3/2018 12:00'!
GbtIconTest16Icon
	"Private - Generated method"
	^self icons 
			at: #GbtIconTest16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self GbtIconTest16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 1/3/2018 12:00'!
GbtIconTest16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/GbtIconTest16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAADAFBMVEUAAAD19dLhAA1tn+Px
0dVCQ0D7+wD////////////U4/k7vCb//wDb6NDU4vnv0NL19tPx0tb19tL09NDhAA/37O30
9dHc6NDS4fnvz9HfAAPtnqVmm+LE1/A+vSluoOPs8friARD79wDQ4PhCQ0DfAAArthdgmN5v
oeTY5s34+e3c6NHa584zuR3v8+w9vCf3+KS34rJCQ0Cg5azhBhP7+wdkuUGBr/PhAAC22/m3
3Pn+knDeAABFgtD7/gcKwgD+/srhCBX7+wvfAAr7/AlmukThCReCr/PfAADvo6n/k3LhAgL+
jmtHg9DvoKJ7q/LN3vhXszSz2vn81su4zus9fM3j8fz69wCh5q37/gqDsPOY46b/lHMOwwP+
i2YAuwA1eMj//8vhAwOw2ff+/cR1qO9IhNH5+QD6+wBlukNdtjrG470MwgL4+qn+/sjd9eL6
/QCo5qec5Kn4+qr7/gn8/ez//8oAvwAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAN
wPvsAAABAHRSTlMA7f3+7f79ERYB8v798vLt7e3t7f3t7fLy7f39/v7+/vL9/fL9/f7+/vLt
8vL+8v79/v//////////////////////////////////////////////////////////////
//////////////////////////////8AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAPsoS
RwAAANdJREFUeJxiYEAHnJxGSICTEyiELADkckCAkRGUwaAgwcXHx6VsZKSpzcsrrqPHEODv
bm4elWpkFOhqZpaZlc0gKyPPzKyhbmSkJsfNra9ryBAS6mtrm5ZgZBQfa2+fU17IEBZkZWlp
lWxkFB1hbGxclM8Q7ONlbR0TZ2SUkujgUJZXyuDn4W1hkWRjZJQeaWdXUpDLIC0lwsSkqGqk
osTDxsbDZsDg6exoYuIGVBHuZGrqklHMIMrPwsIiKGnEKizAyCgkpsXADgGsrFAGhu8BAAAA
//8DAMg3KOFpdRHcAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 1/2/2018 19:52'!
GbtIconThing16Icon
	"Private - Generated method"
	^self icons 
			at: #GbtIconThing16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self GbtIconThing16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 1/2/2018 19:52'!
GbtIconThing16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/GbtIconThing16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAACIElEQVR42qXT3UtTYRwH8F8e
VLIIIjDoqtsiugqDAklKHF1G0VUXkYUFEQlBFBi9aBFYIPRCWpSVm25D7RWtMCxUWs6X+ULF
FJ1n4MvDmWdzO9s5z/Pt8Zn1D+wHH77fy+/NjwCsywXlfACKc0FGgpvjc445GZV0RfVQxDZj
KzDjKWb+mR82pxfHzKnFkDIthRdGTDNpmDQ4ZeGq18SN9jiur7nZEcclj4GJWaBff4fjb/fg
TPchVHaVKae7D+LEh33oi3wB9f+Oi7PPdHHxZVRcaM6qlv1U44wIhSG65r1id9c2UfZ1lyjt
2aEc6NkpSj5vF936e0Efh5ZQWjMMV+0oKm5lHa4NoeRKAH0jDjyLT0GfCJu+aSjqJWVjbx6o
h+CJukG6kUZ7KIbO8WV0jmW9kd07YmAhBoST03gcacGLqB/Pdd9/TXOtCK/Mghob7qPOtR8P
j1ag4Ui58uCYC7fL9+JJ/T0AK3Cc7zIDEOKHAqzmABy+BKqtqsIAEeY0DVNESkT2IZl3TlYD
8MNKE2xRJBWuWY8MJ1iZVtDdc+f5L8rnyYJibmhbeExKFG7lM0S8vvIyB9q4kyGZGheCFCBP
ZcZ2c6qRCx4RoVPLh5fy4JM6tAI0EeHavwUpgm1vkAqzHLnAXl3QBhoMBtkrt5u1+v3M4/Ot
Ur255TUL/AwyIMGSqVFmpSeZZU1kpSdYyhpntrPMCMDmXFCul/M7/wVBpZavPvBJ0gAAAABJ
RU5ErkJggg=='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
activity16Icon
	"Private - Generated method"
	^self icons 
			at: #activity16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self activity16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:24'!
activity16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/activity16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAAAMZJREFU
eJyckFkOgkAMhntJDSBbTIzeT3FBcb+AMQqn0HdtwXZARSWyNP+8fDNfpzOQ1Czg5boOx3Fs
27ZMs2MYuqa1C2EmPCsu6vgNmwhx3ZHiP/2KH137DQ1/CTdAO6C9JLlfy0fCFeAaWMMtJLdL
BSEAXEKqlQgUDdAHnAMuVAIJhW7WKIW868P7Bor6OAWcCeXQyWKWCb7ivDvJCeKEPUYcOuqv
0yIoiGNA71MQ59ylQyt/WgQPcKQy/BGq1AMAAP//AwAs9HOnEOo38QAAAABJRU5ErkJggg=='! !

!GbtIcons methodsFor: 'private - utilities from Pharo4' stamp: 'hk 11/4/2016 16:25'!
base64ContentsOfFileNamed: aString 
	"Private - convenient method"
	
	| file base64Contents |
	file := FileStream readOnlyFileNamed: aString.
	base64Contents := (Base64MimeConverter mimeEncode: file binary) contents.
	file close.
	^ base64Contents! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 15:48'!
beitragsMgmt16Icon
	"Private - Generated method"
	^self icons 
			at: #beitragsMgmt16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self beitragsMgmt16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 12/18/2016 15:36'!
beitragsMgmt16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/beitragsMgmt16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAADAFBMVEWeu1uhvmCfvF2VtFL+
/v79/f2dulmTsk+auFahvV+buVaMrEmZt1WOrkumwWePr0yNrE2gvF2XtlSrxW+HqUWux3SL
rEiTslCEp0KqxGytxnOXtVOux3OYtlSeu1qMrEyrxXGMrE2gvV6WtFOjv2OXtVSKq0iqxG6L
q0uow2mFqEOJqkjH2aaXtFjZ5b6YtlWJqkaSsU+ux3XI2aeIqkaGqEOWtVOUs1GwyXaVtFev
x3iIqUexyXuRsU+jv2LY5Lypw2udu1qlwGSivmGDpkGnwmiculiNrUqQsE3///8AAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAp
ZfUcAAABAHRSTlP/////////////////////////////////////////////////////////
/////////////////////////////////////////wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA9YbN
KwAAAM5JREFUeF4ti9V2wzAUBK9kZggzp5gys2xL1v7/D9WpO287Z5bm67KQo870ZdoZyaJc
k8gagT9+GpGRzb/NuBVn5hXjpMh8O1mOe3e98fLD9Ih8AbYtYillXGzBBYUKGb7aD0NzyF0Q
91hZlszjUC4ZMyhQWwi4MxoYCH1li7mwlY/cIO3gCWFbXOPZoUhjYGwmu3w32Ri41dSvoeG0
xSeSmh72qKNEH0kiBHs671qv/aA+Ehysmy5Vw0sL/1j3j0Oqqur9dLFK03S1uGjGLwcCLeh4
Dt1XAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
bizNetIcon
	"Private - Generated method"
	^self icons 
			at: #bizNetIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self bizNetIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
bizNetIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/bizNet.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
bizProcessesDirtyIcon
	"Private - Generated method"
	^self icons 
			at: #bizProcessesDirtyIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self bizProcessesDirtyIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
bizProcessesDirtyIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/bizProcessesDirty.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAAAjlJREFU
eJxcke1PUmEYxp+/LZXEEN8KaSu1D33oa8JBDSFeVCwy1xwrixLBrfpQwTly8PCOkCViKuNF
bH1AjWYtai0dA6LrcJBNn11jz/3c1+9+OZBEtjBwL3xlMtRvCl+djly7vzrwIDr0MHZjNjY4
E7tujhJCarVa85fIp4J9xmATMDg2b82tDc5Ebz56DxJ8w1c//L1b7wdweSIomwrJp8N2btfy
dgeAzr755etvG5sl5w6AXkMAgNwUjmwdVqr/UAbAUfG4dnrOdOjS+Xr0gT5j4FPuCDEACID5
1dab8OeTUuX8DtK7vm6df4HNIEZ65vX2EreL8QQhFEo8ZdJq6zqqk06NF8zewS8AL/05YR+7
J/vCncZl0ZMRhsRiQ+ZIp9ZLJOOcbCJAPV47/PFXvxDvMQSeL6eF0eFGCFNTEg1HOtQrYJrq
0vlt7gZgZVKY1uRIfPt5PG5d79X7LqlXiHiM7Tf60RGOUrkKk1TrfUangGFUVF3iskjl9otw
i+94yMURN2WJPXEmK9UqxjU5NvhWGl7zzuTk4sZJqcx3cyVRun2UJSLVMpj2UXcoka9/qLLN
ndJaP7QpmVK5gip4jGcKsMIGM2lV0m0UgxsKxNMFYfqD738A1P+WajCR7xhjYRBRDB5Jy7Cr
VUE3MIqZf7e9t19UWaLIYTFIRDWs8LQoXERMuS7cdgJD0CCVtFTNwiHTccq5Vf5RQfOGYadY
5SIfd/KSERqMoHrirE5TsMH8HwAA//8DAIen1LwgTsTSAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
bizProcessesIcon
	"Private - Generated method"
	^self icons 
			at: #bizProcessesIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self bizProcessesIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 16:34'!
bizProcessesIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/bizProcessesPane.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAAAlpJREFU
eJxUketTEmEUxt+/LZXEFC8kYpOXPvShrymLGmJcBSRrGocpi1LBmepDBayg3HeFLBFTGK42
ffBGY03UNOkwQPQsS8y0c2b2Pec8v+c9Z5fEs4VhE9OvDw8YmEEje31uc/heZPR+9MaD6Mh8
dMgcuWZipUZWMhsemWMhJtLZkFgbagIa++6tha2R+cjNh+9AgucAAwPgqi40ZGJIjzoAAAlK
UiNj8+YsbxIAVLbdz6c/lz1ZuMBLog+LdaFeTZAD+jRBALBh904q1T+1Wg3AWfG8Vn/iubNB
I9Ov4wbpVQdJt8qPl1gb/Jg/QxsAAoD55d5r5tNFqYJiJHEKe/jCnYju+ntUgSVPBg2051/t
r3pzGI8PpLzFEzqtsG7DnXQpfWAOjn8AeBHI8/vY1rPP3WkcVtYz/JBYbNTMds34SOe0V6IL
Uo+2Tr79Vi/FsNaztTQ/PdRIIWpGp9JLOhQbYJrRrQosuxuAlU5hWoM9/uX7+bR1u0/tv6LY
IMIpz4A2gBuhKJWrEIlmfE9dKWAYFa6r3ixa+aMi1MI76+TyhJuyRB87kpVqFeMa7DvcVUou
Fh1J/crORanM3eZMwrp90kME8jUw7ZPucPyw/qHKy+7UjPV9m4wulStwQTGWKUAKGcSkVeZq
o2icYBBLF/jpj7/+AlD/LdVQ/LBjygOBgKJRJC1jztZxVwOj6MW3+wdHRbklgh4WQwiohhSa
lnEnEVLOS7cdwJA0SJlLpPBAIVF5ZQubXHHcxQnGHEK5k3xIHHZOuMDwUW/8H/9akEH8FwAA
//8DALeE6UShyxMRAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
bizoffer16Icon
	"Private - Generated method"
	^self icons 
			at: #bizoffer16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self bizoffer16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:24'!
bizoffer16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/bizoffer16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAS9QTFRFVVVUUYK9U4S+Z5TIVYa/SXq2ToC7QXGv8fX5Rne0
P2+tWInAXV1bRHSyapfJY5LGf6DLYpHFVoe/X47EUoS+Pm6s9vj7QXCvXFxbS3y4Y2NiP26t
S324TH24P22sZZPHTX+6WorBY2NhRXazSHm1YY3BXV1cW1tZV4jAP2+uZGRieJvIT3+6z9vs
TH65R3i1Q3SxXIzCWoa8e53KUHy09fj7f6XPmLXZa5jKk7HWmrfa2uTwfKPPT4G7TH259vn7
eZvIUHu03+jzcp3NYWFgk7LXztvsZJDDpL/dfZ/Lf6bQXIi98vX5YI/ESnq2p8HeXY3DSXu3
You+RXWyVFRTW4vCbprL0t7taJXI2+XxPm2s0d3tfKLO4OjzianQkbDWh6fPYYq9lrTXQnKw
////uMR96QAAANlJREFUeNo0j9dSAkEURO9sDuScs0TFrCAoSlSQoGQUEPb+/ze4YznnqetU
P3QDmjRf64tWf7ylGRB990M7b6vYePtDg4rb70u3M86v+LjTfeczxT6fxH8myQ5CzSPoTMx1
YQ1VwrmwnQoVQynUXdwRTiTCsYbAkR5EnySCuYAlawmgh0inMPqIJFjjMRGJwtW5GMQZULAc
FAfwM1UzrCFm1B18GdY0E2raugS8lg0mLow3c6lyKPhlgyL7P9/pOaW08YY1TQt7n5W/t4hd
x0ssduM4o/lXgAEAeVw9p/dQn/oAAAAASUVORK5CYII='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
bizorder16Icon
	"Private - Generated method"
	^self icons 
			at: #bizorder16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self bizorder16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:24'!
bizorder16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/bizorder16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAW5QTFRFVYa/QnKwTX+6U4S+Rne0SXq2WorBS3y4WInAToC7
XY3DSHm15ez1UoS+P2+t8fX5R3i1YI/EV4jAQXGvTH24RXazW4vCPm6sQXCvP26tRHSyRHWy
fqLMVIW+YpHFQ3SxVoe/9vj7Z5TIS324f6DLT4G7Y5LGP22sX47ESnu3apfJTH65ianQWYi/
UHu0h6fP7PH4P2+u/v//YY3B2uXwfKDMTH253+jzRXWzT3+6mLXZtsvk2eTw8/b6z9vsfKPP
You+ztvssMbhSXu3eZvI0t7t9fj7UoO9YYq9a5jKWoa8fKLORXWy2uTwf6XPp8He9vn7k7LX
fZ/Ld57Ly9rrlbLXcp3Ne5/LWInB4OjzUHy0tMnhd5/M8PT4k7HWpL/d2+XxbprL0t/uPm2s
mrbYXIzCapLDYo/Escfgdp7NlrTXkbDWf6bQ8vX5dJ3L0d3tmrfaZJDDe53KSnq2eJvI8vb6
xtbpXIi9UYK9////3ao5iwAAAPZJREFUeNocj9OSRFEQBPvaHttc27btmbXt03+/5249ZWTU
QxUgTf/p+Pne0/qhz4CYHXJKudpiLVd62/DF3PJ1JfWj6/p9qrKWpeLRFVWnh5ZPHFXcRFg1
QA6pI1S8qCEZzqBJuIws7iB23YpyhnuAboVw4E4hdhy4wJF3CPQpxEjuIl5A0iDKIHxO59ki
2UYcnidFNh+AJVuQ6mwr4pXC1iXhF9pXeE2oSg3slaqCxrfAKxML8vZNIrGv2XwwNgv44THp
+DHi6EA8zWzRpdZCZ8S7Q/xmvMjEs3/O+roMR03TjIZnrP+3iJOFtnL5qDDm858AAwBtODzh
zhVjRQAAAABJRU5ErkJggg=='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
bizrequest16Icon
	"Private - Generated method"
	^self icons 
			at: #bizrequest16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self bizrequest16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:24'!
bizrequest16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/bizrequest16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAYBQTFRFfKPPz9vslrPXTH24eZvIP22sYI/FUHy0ToC7TX+6
U4S+SXq2QnKwVYa/Rne08fX5R3i1SHm1UoS+WorBS3y4P2+tQXGv8vb6fqLMV4jAP26tRHWy
Snu3Y5LGZ5TITH65apfJRXazQ3SxPm6sT4G7RHSyXY3Df6DL9vj7QXCvS324nrraX47EYou+
u8/m2uTwT3+6/v//RXWz9Pf6SXu38vX5/f7+YpHF+Pv8f6XPmLXZXIzCWIjAWInBSnq2ZZHF
0d3th6fPWoe9yNjrTHq0XYzDVoe/ZJDDvtHme53KWInAXIi9ianQiq3Uk7HWsMfhlrTXpL/d
8fX6f6bQ/P3+fZ/L4OjzP2+ubJPD1N/uYY3BapXHVIW+3+jzkbDWlbPYk7LXUoO99fj7a5jK
bprLVYO8mrfaVoO7RXWy7/T5cJfFT323cp3Np8HedJ3LxtfpWYnBja7T3ObyS3u2/v7+rsXg
9vn7ZpPGnrvbW4vB0t7tapbIXo3EYYq9UYK9////pEwR9wAAAP1JREFUeNocj1V3wlAYBD88
TggQ3F1a6q7U3d3djbrd/esl3ac587RDqG9viU5vV+7WDSYg32OPROMn8Wjk/M0Qx9Rbntu6
Wq59dJa783WxH3AfNKPLBzRm3YegiiZ/+vDwbi8B99NyheaZMDhS+x7L/qziaVxYpG2OCXKg
/9G9gI4dgU2QxcIxbVfumwRKGuOaaKCtyKfZ0StezCzNFy1UVUVPjOdaYeb4mEecoeFLxSWG
z4CqJyy6lFkakjIJRX32+y9cqpLIfBGmdCkZugGuW0JJaa3+1Pm7UdBHgU1JLzS0G3FOqy0V
9Hq9wZTV+V8LmHIOm82RMxn8J8AAZv1BA75Za2gAAAAASUVORK5CYII='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
constrGreenIcon
	"Private - Generated method"
	^self icons 
			at: #constrGreenIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self constrGreenIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 7/5/2016 20:16'!
constrGreenIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/constrGreen.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
constrRedIcon
	"Private - Generated method"
	^self icons 
			at: #constrRedIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self constrRedIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 7/5/2016 20:16'!
constrRedIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/constrRed.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
constrYellowIcon
	"Private - Generated method"
	^self icons 
			at: #constrYellowIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self constrYellowIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 7/5/2016 20:16'!
constrYellowIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/constrYellow.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
contactsDirtyIcon
	"Private - Generated method"
	^self icons 
			at: #contactsDirtyIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self contactsDirtyIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
contactsDirtyIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/contactsDirty.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
contactsIcon
	"Private - Generated method"
	^self icons 
			at: #contactsIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self contactsIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
contactsIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/contacts.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - utilities from Pharo4' stamp: 'hk 11/6/2016 13:06'!
createIconMethodsFromDirectory: directory 
	"Create the methods for the icons.
	(self createIconMethodsFromDirectory: '')."
	| normalSize smallSize |
	normalSize := self normalSizeNames.
	smallSize := self smallSizeNames.
	normalSize , smallSize
		do: [:each | self createIconMethodsFromFile: each directory: directory]! !

!GbtIcons methodsFor: 'private - utilities from Pharo4' stamp: 'hk 11/25/2016 14:11'!
createIconMethodsFromFile: aFileNamePrefix directory: directory 
	"Create the methods for the icon.
	aFileNamePrefix is the png file name prefix (without the .png suffix)
	directory is where the png file is"
	| iconContentsSourceTemplate iconSourceTemplate png base64 contentsSelector selector |
	iconContentsSourceTemplate := '{1}IconContents
	"Private - Method generated with the content of the file {2}"
	^ ''{3}'''.
	iconSourceTemplate := '{1}
	"Private - Generated method"
	^self icons 
			at: #{1}
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self {1}Contents readStream) ].'.
	png :=( directory asFileReference / aFileNamePrefix , 'png') fullName.
	[base64 := self base64ContentsOfFileNamed: png ]
		on: Error
		do: [base64 := nil].
	base64
		ifNotNil: [contentsSelector := (aFileNamePrefix , 'IconContents') asSymbol.
			((self respondsTo: contentsSelector)
					and: [(self perform: contentsSelector)
							= base64])
				ifFalse: [| contentsSource |
					contentsSource := iconContentsSourceTemplate format: {aFileNamePrefix. png. base64}.
					self class compile: contentsSource classified: '*Graphics-Resources-Theme-Icons'].
			selector := (aFileNamePrefix , 'Icon') asSymbol.
			(self respondsTo: selector)
				ifFalse: [| source |
					source := iconSourceTemplate format: {selector}.
					self class compile: source classified: 'private - icons']]! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
crmIcon
	"Private - Generated method"
	^self icons 
			at: #crmIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self crmIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
crmIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/crm.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
dashIcon
	"Private - Generated method"
	^self icons 
			at: #dashIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self dashIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
dashIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/dash.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
dashboardIcon
	"Private - Generated method"
	^self icons 
			at: #dashboardIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self dashboardIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 5/1/2015 18:55'!
dashboardIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo3.0.app/Contents/Resources/Icons/dashboard.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAA+gAAAH0CAIAAAAhSpB6AAAAAXNSR0IArs4c6QAA6ZZJREFU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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
downIcon
	"Private - Generated method"
	^self icons 
			at: #downIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self downIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 5/1/2015 18:55'!
downIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo3.0.app/Contents/Resources/Icons/down.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAAAAZ0Uk5T
AP8A/wD/N1gbfQAAAEJJREFUeJxi+E8iYBg+GhjWMBGD6KmBGD1YPE1QNZZQwq8ae7DiUY1d
A7IeLFJYNUD0YBfHpQGnQaRqAAAAAP//AwDrSk/69sF0oQAAAABJRU5ErkJggg=='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
efaIcon
	"Private - Generated method"
	^self icons 
			at: #efaIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self efaIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 11/4/2016 17:25'!
efaIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/efa.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAAfQAAABkCAMAAABHGTJPAAADAFBMVEUAAAAlJSUPDw8zMzMH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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
evaluationIcon
	"Private - Generated method"
	^self icons 
			at: #evaluationIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self evaluationIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
evaluationIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/evaluation.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0
WE1MOmNvbS5hZG9iZS54bXAAAAAAADw/eHBhY2tldCBiZWdpbj0i77u/IiBpZD0iVzVNME1w
Q2VoaUh6cmVTek5UY3prYzlkIj8+Cjx4OnhtcG1ldGEgeG1sbnM6eD0iYWRvYmU6bnM6bWV0
YS8iIHg6eG1wdGs9IlhNUCBDb3JlIDUuMS4yIj4KICAgPHJkZjpSREYgeG1sbnM6cmRmPSJo
dHRwOi8vd3d3LnczLm9yZy8xOTk5LzAyLzIyLXJkZi1zeW50YXgtbnMjIj4KICAgICAgPHJk
ZjpEZXNjcmlwdGlvbiByZGY6YWJvdXQ9IiIvPgogICA8L3JkZjpSREY+CjwveDp4bXBtZXRh
PgogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgIAogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAK
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgIAogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAgICAgICAgCjw/
eHBhY2tldCBlbmQ9InciPz4s45Y3AAABLElEQVR4nJSQyU6DUBSG+24ylRkqpIBxiEZfQoul
G5XGt4AHqFMtbK0JLQJu2jgsWbkUm2hN9CQ3JtKgV0++nJz/D19uQu3jn1NbyLP5e3f8sB1m
O+HtcfwIESMcRHcbl8nmIN0apLCPRvcYYeU8Xr24Wesn6/0ENtxPs9ffBON0bJ3FoCHgxrzQ
Hk6bJyPQEM71FCO8vM3tq4nWi/RetD+cQMQI2CkJRfHsOG3TbJqmYVkG7E7HKYriR6HV2tW0
ZV3XvmPbe9VCmqaKIquq0mgA6hcKNFmWVQiueyiKgiSJgCxLCBS7XXdRyPOcZRmOY3ke4ASB
R8ANDfTwQUnwPI+mKYah63UGABmBIvS+75eEIAgIYokkCYoCyDIE9GEYVvylv8wnAAAA//8D
ACsyWJVrlMHaAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 1/13/2017 19:38'!
gotoIcon
	"Private - Generated method"
	^self icons 
			at: #gotoIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self gotoIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 10/31/2015 17:34'!
gotoIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/goto.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAFFJREFU
eJxi+P//PwMlmCLNeA1ISk36D8IUuYAYQwg6kZAhRPkTnyFEBxYuQ0gKcWyGkBxt6IbQzwUU
hQFFsUBROqAoJVIlLxCDAQAAAP//AwDrwud9sF5rPAAAAABJRU5ErkJggg=='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
headerIcon
	"Private - Generated method"
	^self icons 
			at: #headerIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self headerIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 1/23/2016 16:20'!
headerIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/header.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAABkAAAACQCAYAAABQ4qeyAAAAAXNSR0IArs4c6QAAPdlJREFU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'! !

!GbtIcons methodsFor: 'initialization' stamp: 'hk 11/25/2016 15:10'!
initialize
	super initialize.
	name := #default! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
inspectIcon
	"Private - Generated method"
	^self icons 
			at: #inspectIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self inspectIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 19:55'!
inspectIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/inspect.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAaZJREFU
eJyUU01LQlEQNfEfiNHOhQR9UEaLSoICUQgDScKFgUhQG0kod27exk3RQrRNgaJJixamZCal
+VWGC+0tEoQgK3/Jqbn6zO9y4PC4w8x558ydKxI1wul0YhiIWsPj8eA5n0e5XP4XeJ6H1+uF
TqcD+zM112o1vFerXfj4qjXwyb6Uo1oicrlcdQI6dDZSjoiTvjOkDnYZKlf+thpSzghIUi+C
mxM37pbnUBwVo6AQI6EeB395+jcBSaRceMeCtFSMlHYJJeMCStMSpPfNzM5AgtefcyGbwbXF
iFuZBBGdGvmNFfCKEeRsW/0VvFUqyLqPETPpETWuIWZcRWJWxlSQjUflGPjTo+YwmwTCEMlz
ckrOikludEaKuEmDpF6Np00NsoccU9eXIGqte2YN2+uM5N5mRjGXYzWksOctCAQRu5V5Di8q
UdDO40UuQcqx19yHzptqmwEVxAPniKommp4fVJPIBH09F6xLgbBdMX8AcYedIXkRZJ4HEnAc
xxT0W+VeaFtlCnoYwhxa13rQgwqFQjAYDL+vktiGgdD8DQAA//8DAFho6hka/5odAAAAAElF
TkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
invoicingIcon
	"Private - Generated method"
	^self icons 
			at: #invoicingIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self invoicingIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
invoicingIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/invoicing.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
learnCenterIcon
	"Private - Generated method"
	^self icons 
			at: #learnCenterIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self learnCenterIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
learnCenterIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/learnCenter.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 6/6/2017 20:12'!
littleCompanyIcon
	"Private - Generated method"
	^self icons 
			at: #littleCompanyIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self littleCompanyIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 6/6/2017 20:12'!
littleCompanyIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/littleCompany.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAA4QAAAJYCAMAAAANG9jpAAAACXBIWXMAAC4jAAAuIwF4pT92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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
logisticsDataIcon
	"Private - Generated method"
	^self icons 
			at: #logisticsDataIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self logisticsDataIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
logisticsDataIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/logisticsData.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0
WE1MOmNvbS5hZG9iZS54bXAAAAAAADw/eHBhY2tldCBiZWdpbj0i77u/IiBpZD0iVzVNME1w
Q2VoaUh6cmVTek5UY3prYzlkIj8+Cjx4OnhtcG1ldGEgeG1sbnM6eD0iYWRvYmU6bnM6bWV0
YS8iIHg6eG1wdGs9IlhNUCBDb3JlIDUuMS4yIj4KICAgPHJkZjpSREYgeG1sbnM6cmRmPSJo
dHRwOi8vd3d3LnczLm9yZy8xOTk5LzAyLzIyLXJkZi1zeW50YXgtbnMjIj4KICAgICAgPHJk
ZjpEZXNjcmlwdGlvbiByZGY6YWJvdXQ9IiIvPgogICA8L3JkZjpSREY+CjwveDp4bXBtZXRh
PgogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgIAogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAK
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgIAogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAgICAgICAgCjw/
eHBhY2tldCBlbmQ9InciPz4s45Y3AAABRElEQVR4nMRSy06DQBTtp5mglA6PwUKh4wAFHx/m
TuNjoTGmatXSUls/AMpOjb/QlQs9k5nYLkyarpyc3Mw9jzthhsb3hqvxH4HP66vZYfZ6tI86
O0inWTxJeMG77+dnKvB2ejIKvDELPi4vvhaLlzSeZokE9sIdMajwqEBd16ij0AeLwCRmMCnE
DLOFO/Rzf1cF5vM5Kno5A3KxFxY8RMV+3O2AhzpsOypQVRUq+txzxVGBh3kKsHba4KE+UUsF
7klzYLUeHfPZFdTQo3Dkvit8HoUVPFR4VKBv7CDzYBkDm6DFpFUIq02gwqMCt7rWb27ftXRJ
rX+HG23rWNds23Qcm1IHcF0qIVvwUE2TLB+Oc06IkSTx6rA0TS3L7PUS8FDhWQbKsmSMyev6
XbjuKIpQwUOF5+9fY/03bLR+AAAA//8DACYlQgOJKbBxAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
minusIcon
	"Private - Generated method"
	^self icons 
			at: #minusIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self minusIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 5/6/2015 17:44'!
minusIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo3.0.app/Contents/Resources/Icons/minus.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAAA8AAAAPCAIAAAC0tAIdAAAAAXNSR0IArs4c6QAAAAZ0Uk5T
AP8A/wD/N1gbfQAAADVJREFUeJxi+A8HDAw4EVwJAXWoekhVTaRSMKK5aiIBHVQPkjChZcwj
eRmPOggAAAAA//8DADPQVbk+AZ3EAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'accessing' stamp: 'hk 1/3/2018 12:00'!
normalSizeNames
	^#(#activity16 					#beitragsMgmt16 				#bizNet 					#bizProcesses 
		#bizProcessesDirty 		#bizoffer16 						#bizorder16 				#bizrequest16 
		#constrGreen 				#constrRed 						#constrYellow 			#contacts 
		#contactsDirty 				#crm 								#dash 						#dashboard 
		#down 							#efa 								#evaluation 				#goto 
		#header 						#inspect 							#invoicing 				#learnCenter 
		#logisticsData 				#minus 							#plus 						#projects 
		#right 						#route 							#rower 					#rowingBoat 
		#rowingTeam 					#saveTemplate 					#servicedata16 			#settings 
		#statistics 					#statisticsE 					#supplierBizProcesses #supplierBizProcessesDirty 
		#supplierBizSubProcesses #supplierBizSubProcessesDirty 							#systemSettings 	
		#taskOrders 					#tax 								#toggle 					#tour 	
		#userSettings 				#walletBig 						#wallet 					#littleCompany
		#GbtIcon96 					#GbtIcon16 						#GbtIconThing16 		#GbtIconCtxt16
		#GbtIconBeh16 				#GbtIconTest16 					#GbtIconEdit16
	)! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
plusIcon
	"Private - Generated method"
	^self icons 
			at: #plusIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self plusIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 5/6/2015 17:44'!
plusIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo3.0.app/Contents/Resources/Icons/plus.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAAAAZ0Uk5T
AP8A/wD/N1gbfQAAAGVJREFUeJxi+E8iYICzmA4w4EcoGtDkfoPB199fMfUwYDX7NwxgSlFJ
w48fP4Cqv//+TpoN+DRAvAhEcO/CXYUsiKKBGECBBiLjgXrBSm0NmHp+/v4JVA0ksaclklIr
AAAA//8DAAPZuC+nylbiAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
projectsIcon
	"Private - Generated method"
	^self icons 
			at: #projectsIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self projectsIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
projectsIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/projects.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0
WE1MOmNvbS5hZG9iZS54bXAAAAAAADw/eHBhY2tldCBiZWdpbj0i77u/IiBpZD0iVzVNME1w
Q2VoaUh6cmVTek5UY3prYzlkIj8+Cjx4OnhtcG1ldGEgeG1sbnM6eD0iYWRvYmU6bnM6bWV0
YS8iIHg6eG1wdGs9IlhNUCBDb3JlIDUuMS4yIj4KICAgPHJkZjpSREYgeG1sbnM6cmRmPSJo
dHRwOi8vd3d3LnczLm9yZy8xOTk5LzAyLzIyLXJkZi1zeW50YXgtbnMjIj4KICAgICAgPHJk
ZjpEZXNjcmlwdGlvbiByZGY6YWJvdXQ9IiIvPgogICA8L3JkZjpSREY+CjwveDp4bXBtZXRh
PgogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgIAogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAK
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgIAogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAgICAgICAgCjw/
eHBhY2tldCBlbmQ9InciPz4s45Y3AAAB10lEQVR4nJSQa1PTQBSG+Wl2mqZpkl5yozRNmzZJ
KbZDAPsfVLyLCOqIiiiVovWCFnQAqYD6r/Rpu874lZ2Tnc173uecszv154Jriu/Fsf/yJHz9
Y7Z72to5n9/9tdj/3el0riwtLcbxfLvdmptrRlFYr9cE8PzY3zwJXg0b26eX35y1ez9jmIWF
GDdnlGZzNoqCWs0XwLOjyub3ehDUG42wO2bo0zuP2Tmj0Jys71cFsHHkVSoeBcIwgKEPs3XP
WuzbY/fWsEEWjwCeHrrlslutjhgqMRsmSObmvDWM0MniEcCTbzMThhrMxn14A65IYGUSdLKl
UlEAjw4cGP5dt8R9eAPerVqtUBWr57noZKenHQEYRsGyTMexi0VnjM2MSY+7bRyWUdAffy2u
H/wD8vmcYeQty7BtC4xKBD0ngYK+tm+vDkwB6LqWy2XBHg7MtYENSUPqre87nE3TYASyK3sF
AaiqomnqvU+5+3uFB58JY/WLOQl8BOWyWe3ux6wA0mlZUdK332t3PuiokP+HrquUI3urrwpA
kpKyLIHd7GdQMxmFnjgmgYJ+452y/DYtgETiUjKZAEulJEhZThHLOEamke/6rnytl7q6Iwng
QusvAAAA//8DAHgxvGkzet/4AAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 10/31/2015 17:32'!
rightIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/right.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAExJREFU
eJxi+P//PwMlmCLNOA1gWMP0H4YpNoCQIUQZgM8Qog3AZQhJBmAzhGQD0A0hywBkQ+jvgoGL
hYFLifg04zSAFAwAAAD//wMAy0mar7IWWmkAAAAASUVORK5CYII='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
routeIcon
	"Private - Generated method"
	^self icons 
			at: #routeIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self routeIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
routeIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/route.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
rowerIcon
	"Private - Generated method"
	^self icons 
			at: #rowerIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self rowerIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 7/11/2016 18:39'!
rowerIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/rower.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAACeklEQVR42qVTS0+TQRT9IsaA
EWMEpQj4SDBRK1DAUmriTlOVd3xrJGotxH+BIW4EF75QQqkkNBVbAXe0X99Nn9BWWdZABDal
XXRJArTfce4s2ijGmHiSydzJnHPm3pk7QndnV+9niyXjcbvhEO2S0+7A70O0ibCLIsWcQ1zS
kFYwT00lwSAx4J9Q4JJWcDmctJC2t7eRy+V2DEI4HMby0jII2WwWxCUNaQWWEgicXEBBHAqh
tLgErUolNjY28iYE0gpU198MFr8tQq1sge6RFpubm5R+fo+0fzTIZXmMCEv9Qut53LlxE1/j
8TyP9ncYbG1t5esjAsVXNRoc2FeKalkljlVVoV+nw9rqGs+iYODIZ/BLfWOjo6goK0dVhQwT
BgNS6+tou3wF6hYV1llMoKcVPC434iy9jyYTvszMYnZmhj3PJzQrGlHDTlbU1WN2ehoupxOp
VAqvX76CyWjkJj6PF8JCZB7jej0EQcDhg2WQlR/iJ9dUHkHt8RM4VXsSxUW7oX3wEE/6+vn+
nl1FmPgwgVg0CsHtcoHQ2daO+jNyErJ6q6FsasZRNu8v2Ys+7WM8HRjgRi2NTfwAw5gesVgM
+T5Ip9P4nkjA6/Eg4Pdj5ccKgsEgWLMgzVIPh8JUM2uoJUQXFpBMJuGlEgL+ABJMqFap0Nyg
wK1r19HT0YkG+Vl0tXfgNnvC+tNyaC5ewv2796A6p0RjXQPo7kLBEBn4pbXVVcmgH+dd92Jo
GCNv3mI+EsH7kXcYfj6EMCMaJyfxbHAQPp+XX2I0GpWCgYD0/5+pp6u712I2Z6gfRJtNss1Z
Ic7ZYLeJfKY1j60stlqJQ1+enjpD2p98LRel1b3ibgAAAABJRU5ErkJggg=='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
rowingBoatIcon
	"Private - Generated method"
	^self icons 
			at: #rowingBoatIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self rowingBoatIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 7/11/2016 18:42'!
rowingBoatIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/rowingBoat.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAAAAAA6mKC9AAAAkklEQVR4nGL49/ffv7//b97/
/+8/GDCAiD+/1l35/+cnRKDd0cM+IM/AyVR7z/8/IIE6BhEBX1V2dq5yqJZv3/a3vn3+9s2n
/3AzUI1lgIgjjAUKIBsLFkA1Fijw7RuyMQxA/ArZGJChr5CNgdiCZAxEAMl1YAGgMRb7/v8F
sv7CHPbq1n+gRf+AbgUAAAD//wMAc7LJd8YDaOkAAAAASUVORK5CYII='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 15:49'!
rowingTeamIcon
	"Private - Generated method"
	^self icons 
			at: #rowingTeamIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self rowingTeamIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 12/18/2016 15:36'!
rowingTeamIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/rowingTeam.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABIAAAASCAMAAABhEH5lAAADAFBMVEUAAAAAAAATExMUFBQc
HBw+Pj4oKCgpKSk7Ozs8PDwmJiZdXV1LS0tWVlZXV1dISEhzc3NpaWlhYWFgYGB6enpfX19u
bm58fHyVlZWBgYGQkJCampqUlJSNjY2Pj4+Tk5OXl5ecnJydnZ2zs7O8vLy7u7u4uLiurq6j
o6OqqqqkpKS0tLStra2xsbHR0dHMzMy/v7/Dw8PAwMDW1tbBwcHX19fIyMjKysrGxsba2trV
1dXd3d3Y2Njb29vc3NzJycn9/f36+vr+/v77+/v8/Pz5+fnu7u74+Pjy8vLs7Ozx8fHt7e3r
6+vw8PDp6eno6Oji4uL09PTg4ODn5+fv7+////8AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAABe
z1SeAAABAHRSTlMA////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////wAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAlCb4
RAAAAMVJREFUeF5jwAZC0QBJQg6ODiDKydkFtyqHUD1u/VAHp1BXAYlQJ6CQk4NjqCCjUChQ
kwEjkxtMlSGPsruHp5e3sCRYo5GUCC83K5u+tCQ3Hw+zDEjIR9ZLRVjVOFRN3VdU0tgPrNFf
jp+f3T80VJVflEUu1AUoZGLKIebPwmlmLs8VIMmoYQEUsrTyU9AMtLa0DLIR9/OztYM41UXL
J9QJaLG+NpACucvJJTRY0TkUROuYgc0CeTHUXjcU5EsXpZBQbAEIAHhxQBQgfcIRAAAAAElF
TkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
saveTemplateIcon
	"Private - Generated method"
	^self icons 
			at: #saveTemplateIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self saveTemplateIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 7/31/2016 14:27'!
saveTemplateIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/saveTemplate.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAAA8AAAAPCAMAAAAMCGV4AAADAFBMVEUAAP/P2utbeaq6y+S3
yeP3+flbeqpkgKeJm57kz51beavC0ufs8/nJ1uj4+Py/zuXh7fjJ1un+/fq1zvLh6PCXstjn
7PLs8PRee6q/z+Xc6fLh7faxvb+ls67b6PPV3+zb6fJwh6XO2uqKm5zV3+1zi6Tb5O/w8/Xw
8vV/k6Hz9fZgfqm7zORng6e+z+Zrhabs8/jr8/jP2+tbeqtkf6i5xdNhfamyw9vi7fdogqf2
+fnD0ue6zOTO2uvI1uhaeatYdZHC0ubc4+9shabb4+/P2+rs7/Ti6PCFl5/m7PN7kKJ3jaOD
lp/P2upwg4Z3jqN8kKK3w8aClaCGmJ+HmZ/P09gAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACD
DaLkAAAA0ElEQVR4nDTN11bCYBRE4SHJn3PSSE/ovWPBLqAoxQoKiL7/qxhY+l3tuRrgT6Hw
ycw//xOe5217vW+8dtqAEGIkBHfaO6ziZ8A0B2emyXH8he5bBDiOc5vPcxR18f4SAKVKrpSr
cBBssGy1AO2AZ4s1mo0ywAc35UYT1acU8FFLJe7Pa1XMLddyac+auNYphuOpQemERoZhHOPS
trMUhmG9TtkTm3Aty3fk+36xSLJ81EdGURRKzh41SiqDqwtJ1XXpQVdVSVelXwAAAP//AwDn
SBQv1S+HzgAAAABJRU5ErkJggg=='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
servicedata16Icon
	"Private - Generated method"
	^self icons 
			at: #servicedata16Icon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self servicedata16IconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:24'!
servicedata16IconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/servicedata16.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAANJQTFRF/ckA/LoA/LcAVVVU/cgA/cYA/LwA/ccA/coA/cQA
/csA///+//vv/L0A///9/LQA/LsA/L8A/LUA//ru/LkA/uF7YGBf/cUA/MAA//vw/c4e/LgA
/csZ/MEA/dhn/uys/coYVFRT/dFV/ddl/dhoXl5dWFhW/uB4/dNZ/c0c/uKC/u2u/uF+//vx
/L4AU1NS/cwb/cMA/LMA/ddg/LYAX19e/uB6/u2w/MIA//njTk5N/u60/dZiUFBO/c8f/uF8
/uOGUlJQWlpZ/dVdXFxb////0uKfMQAAAK9JREFUeNpcz9cOwjAMBdAkpSPQ0snoYu+99wb/
/y9RB4ki/JDIRze2QuCvCB63Qg6vY9AfChho2SvKRSMRwihDtCxmApKpJbCRVZQuwHYWVRPQ
dZT9+DtUgpKsqn6xuG6/Hh0xlPOS7P+ujeec6ykcwC7HO1eSpPr0fhYJY2KX3TTRopaiGMYS
QFEsiolK6FH6zANQL2TiSZOxXtIDYyvn87lTA3twTHPxgd96CzAAoh0uPJvuvM4AAAAASUVO
RK5CYII='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
settingsIcon
	"Private - Generated method"
	^self icons 
			at: #settingsIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self settingsIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 8/2/2016 14:28'!
settingsIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/settings.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAADAFBMVEX////N4MxnAADk+/9Q
AAAAAC/H4Ou3vbcAAAAAAHJwb5nb+//u7vJdAAD///svAADz4a7v17udzev85rvTkjg/b5pM
iL8ALi6lq7j3//94l8r/+98sW4PdpmFCAABZpNn/9/LPih+SXFsAAFDu7uX7+ND//NBviXnT
pmFuqtRxQSwATnulq8P7///M8v/mw5X7+/+3sZeIsat6LSz38vLH8v9Ll9S+n3dkmKYAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAADN
+a3qAAAAmElEQVR4nFzOxwKCMBBF0QEJvAioiAUroNh79/+/TCYmLJjlWdw35NWOPCKaLLqk
j+EyXjlpp9moYAa0p670DWQFgCHcwECOOdD3IF4aouSw32Cgy9yILXu3XeoyQ09adln+Pu6h
9Blao7WTFR+1Ffwfo2cOobaEBoqSm9o6GqA4VFunCrhcbp0r4PKbrvxH7X4AAAD//wMAK1sM
W0E51ZQAAAAASUVORK5CYII='! !

!GbtIcons methodsFor: 'accessing' stamp: 'hk 5/1/2015 18:41'!
smallSizeNames
	^#()! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
statisticsEIcon
	"Private - Generated method"
	^self icons 
			at: #statisticsEIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self statisticsEIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 7/12/2016 18:59'!
statisticsEIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/statisticsE.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAADAFBMVEX////9CAsAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAADZ
U1skAAABAHRSTlP//wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAKmfX
xgAAACxJREFUeJxiYMAEjCQJMOIQYIRzUQQYUQUYUQUYqS2A6TlkgCkNAAAA//8DAB1qAEZN
asOFAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
statisticsIcon
	"Private - Generated method"
	^self icons 
			at: #statisticsIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self statisticsIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 7/8/2016 17:47'!
statisticsIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/statistics.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAADAFBMVEX///8VoQUAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAADy
MgkXAAABAHRSTlP//wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAKmfX
xgAAACxJREFUeJxiYMAEjCQJMOIQYIRzUQQYUQUYUQUYqS2A6TlkgCkNAAAA//8DAB1qAEZN
asOFAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
supplierBizProcessesDirtyIcon
	"Private - Generated method"
	^self icons 
			at: #supplierBizProcessesDirtyIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self supplierBizProcessesDirtyIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:42'!
supplierBizProcessesDirtyIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/supplierBizProcessesDirty.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
supplierBizProcessesIcon
	"Private - Generated method"
	^self icons 
			at: #supplierBizProcessesIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self supplierBizProcessesIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:42'!
supplierBizProcessesIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/supplierBizProcesses.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
supplierBizSubProcessesDirtyIcon
	"Private - Generated method"
	^self icons 
			at: #supplierBizSubProcessesDirtyIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self supplierBizSubProcessesDirtyIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:42'!
supplierBizSubProcessesDirtyIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/supplierBizSubProcessesDirty.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
supplierBizSubProcessesIcon
	"Private - Generated method"
	^self icons 
			at: #supplierBizSubProcessesIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self supplierBizSubProcessesIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 3/1/2016 15:42'!
supplierBizSubProcessesIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/supplierBizSubProcesses.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
systemSettingsIcon
	"Private - Generated method"
	^self icons 
			at: #systemSettingsIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self systemSettingsIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
systemSettingsIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/systemSettings.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
taskOrdersIcon
	"Private - Generated method"
	^self icons 
			at: #taskOrdersIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self taskOrdersIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
taskOrdersIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/taskOrders.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
taxIcon
	"Private - Generated method"
	^self icons 
			at: #taxIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self taxIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
taxIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/tax.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
toggleIcon
	"Private - Generated method"
	^self icons 
			at: #toggleIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self toggleIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 1/29/2016 16:30'!
toggleIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/toggle.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAAAXNSR0IArs4c6QAAAEdJREFU
eJxiYACD+v/YIEQKBP/XM2CFQHF80mA5hv9AAkT+xwRgORIUYIUkKSDbDQwM0ADBAujlBoJB
TTCyCEU3AAAA//8DAMb8Gr/iPQwfAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
tourIcon
	"Private - Generated method"
	^self icons 
			at: #tourIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self tourIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
tourIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/tour.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0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'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 11/25/2016 14:12'!
userSettingsIcon
	"Private - Generated method"
	^self icons 
			at: #userSettingsIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self userSettingsIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 2/23/2016 18:51'!
userSettingsIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo4.0.app/Contents/Resources/Icons/userSettings.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAACSNpVFh0
WE1MOmNvbS5hZG9iZS54bXAAAAAAADw/eHBhY2tldCBiZWdpbj0i77u/IiBpZD0iVzVNME1w
Q2VoaUh6cmVTek5UY3prYzlkIj8+Cjx4OnhtcG1ldGEgeG1sbnM6eD0iYWRvYmU6bnM6bWV0
YS8iIHg6eG1wdGs9IlhNUCBDb3JlIDUuMS4yIj4KICAgPHJkZjpSREYgeG1sbnM6cmRmPSJo
dHRwOi8vd3d3LnczLm9yZy8xOTk5LzAyLzIyLXJkZi1zeW50YXgtbnMjIj4KICAgICAgPHJk
ZjpEZXNjcmlwdGlvbiByZGY6YWJvdXQ9IiIvPgogICA8L3JkZjpSREY+CjwveDp4bXBtZXRh
PgogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgIAogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAK
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgIAogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIAogICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgCiAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAKICAgICAgICAgICAgICAgICAgICAgICAgICAgCjw/
eHBhY2tldCBlbmQ9InciPz4s45Y3AAABLElEQVR4nJSQyU6DUBSG+24ylRkqpIBxiEZfQoul
G5XGt4AHqFMtbK0JLQJu2jgsWbkUm2hN9CQ3JtKgV0++nJz/D19uQu3jn1NbyLP5e3f8sB1m
O+HtcfwIESMcRHcbl8nmIN0apLCPRvcYYeU8Xr24Wesn6/0ENtxPs9ffBON0bJ3FoCHgxrzQ
Hk6bJyPQEM71FCO8vM3tq4nWi/RetD+cQMQI2CkJRfHsOG3TbJqmYVkG7E7HKYriR6HV2tW0
ZV3XvmPbe9VCmqaKIquq0mgA6hcKNFmWVQiueyiKgiSJgCxLCBS7XXdRyPOcZRmOY3ke4ASB
R8ANDfTwQUnwPI+mKYah63UGABmBIvS+75eEIAgIYokkCYoCyDIE9GEYVvylv8wnAAAA//8D
ACsyWJVrlMHaAAAAAElFTkSuQmCC'! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 12/18/2016 15:38'!
walletBigIcon
	"Private - Generated method"
	^self icons 
			at: #walletBigIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self walletBigIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 12/18/2016 15:47'!
walletBigIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/walletBig.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAAJgAAACYCAMAAAAvHNATAAAACXBIWXMAABcSAAAXEgFnn9JS
AAADAFBMVEX+/v77+/v6+vr8/PwAAAD9/v3///39/f0AAP/////y8vH4+fj39/f5+fn29vbw
8PD09PT9/f7z8/Ozs7P19fXc3Nzt7e2pqamUlJTg4ODl5eXe3t5sbGzp6env7+7FxcXq6urm
5uaioqKYmJhwcG/s7Ozr6+vX19dTU1Pi4+K/v7/d3d3h4uGTk5PS0tKLi4vf39+wsLDv7+/T
09NRUVFiYmLW1tbn5+dpaWm4uLjHx8fJycnBwcE0NDStra3Pz8/Z2dnU1NSkpKS1tbV9fX1z
dHPj4+Pk5OTLy8ugoKCdnZ29vb2rq6s8PDy8vLzR0dGamppERER3d3iDg4Pb29tOTk3MzMzC
wsLExMRWVlW+vr7Ozs5XV1dFRUVPT09lZmWsrKzV1dV6enmPj49hYGCRkZGmpqb+/f5BQUHa
2trDw8OlpaVbW1s4ODfY2NiQkJDIyMicnJyNjY2np6dISEiysrGfn598fHspKSnNzc3p6OiJ
iYmBgYGWlpbKyspZWVkyMjJeXl4WFhaXl5fQ0NAnJye7u7t+fn5DQ0NnZ2caGhodHR1ubm6O
jo5kZGQ2NjZ2dnaFhYVfX19/f39GRkYfHx9AQEBycnJra2s+Pj5dXV0TExNxcXF1dXWenp63
t7eCgoK6urqvr69YWFgrKyuHh4cvLy6oqKgsLCyAgH97e3s5OTmJiYiurq4wMDAhISFaWlqG
hoYlJSU7OzsQEBAGBgb09PJMTEwjIyPq6udLS0sMDAzu7urX19Q/PzuGhoL///wjIxf//v/M
zMitraqurqjY2NX49/bPz87R0c7l5eLp6OXn5+T7+/rFxsHa29cWEgAUFQf//vycnZipqqT9
/fv29/KTlI8kJxwgHAtaWD44Nh0gHABDPSv+//1qZ0lVVDF6e32Mj2l1bEsAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAABjkzNHAAABAHRSTlP/////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////8AAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAfma8XAAAGNVJREFUeJzsW/dfFknS7+d5iu2rJwCSQbIgIEEU
ERMqKmDCiDnnnOOqa855zWmjbtDN4fZub3cv5/zmnP+Rt7pnuqdnnnkQ1P2cP1wrPPPMdPdU
V33rW9UB9p3ntLC/tACJynMt2AvPXbEF44zRfyqcy//igoq4y60vjKtrxo0PZtW1nspvdmv7
Wt+0W6hnqk/GmdlYV+GGYFb38glXhXmvna9cCeYuTP2y36kH4aqjmnmbxwnGlMZsteivjOmx
OMOyNeHWmFPZaag1ZnamXsSNB9x4k79gvBuC8QSCmT++gnEfwbhRw0cwt7K95klsyvi6LO46
ztoGQHxNyd0ac2moi/KYx09c11PdDX7ljM6IfLzSGCljjJljVf5peqX2YEPLdjuNEO0Pibzy
+RTMrv688Vg8BL3lLwL+559gnzcee54FM9t2VQzBPG8z3h935d+5r2BWed69krkFixv2XzH2
lBhL9MT96YexrrrjHJH7YOwvH5IwuS+qvp+dKcWXNUncGX8PTUnfcdrHyciE2p5dEGfUn+xR
fiI6GummxugD58B7YeQH85A/kyDOJTgwbfOcn73AWHDomB3ZYwcHdOhhjla6oAsu5YJ3aETj
GmPsmZhSKCmj7tVZAGOoW7YFRFmVjKZgjzUldXISoDZGljwOo/EZZBekrFBN+h2S5Ufjk1kS
x5Tf72uqWCnH3oPsguF8gJwgSYR9YT4+LcaEsqLHPyGp9kzq/bcWaiXExs+8VoBarY/HGMP1
ACuCEqSxeSORPR3GSKy+6WcA9pYej1h4V7VC0Y3p2AOM4RSyfgytCq1bDMGeoJBYTa92APzw
5yWIP/U+W7EC/RHh29MkgJkRtNXZepWxJ08UhVi73wZoHFpoKauXqiUVgrWtFmugVA/aLOIu
TKH0DYA+UWlH3ovxmzM4e7KQJMTiFas+Bbh5MCb6T1L+adEZsmDGjDN59U2psUhGLBaLBKKR
1MK+NZmZmdXVmZkFhYXl4eTUgQNDFijZmySXvKb2SSxSWYs6JPWELqS2lh0gxL+1OWAxqcIf
yVS+YOzk2v85U3n283NwfdCSxnmNS5Y03ryzct5nh8EuD9577/DOj+fd7uifJrww9ir5Y8xm
F5aE4U05TwJ+KVZFf+q//y85KghLc2Fw9NJPTtOT//6/P3/3LviU73q+jyITh/cDbAigorUk
3AcD0Iuxx9OFECtTiPW9YcKGyjlFKUjPl2/7l//4r//9yf4Rue29182eMnTDO0MH/OLvfz5g
/daW6tyqmtzevTu/qZu9dXjRsAVTKzIYFrwC5/ox1G/hWA39DB7rju9YYuXl0MvnvZaqnI5u
lfRbdaw0+10p1t6335afzbXlfnj3ltx5cPdFx3+FYMNhKvYwVpL/DFxK72/94xdod0Zi5eac
swxztnXH8ZrfffllZtGbOfMAZrUTkyWxNSyJfq1RHm37iD3Muk2wtgHtV1pIxslQ0xPmlzSY
nH4NYOcIYtM11nNi2FfPAizc8QuYtas+4Ggio3MiVBbQC5KSktasoV+9tIK1CpCNBRjSpoFq
f4z7LIzdD+JSNw1LAK7tyELs1SvJAlfwjekk1nryrn5fCtZKEoLYrFEE5zOQu4I4CRNqidg9
SnfcM1DBXtWLVs4IdTu7sKJPNiHoZNjmRaFA3jKOLFj2OwqS9LwX02ZSaUw2urMLjnwk5Q6W
iGFinDH/iNwlGCUBe2uRdc+U0mSFIwnUOTXoYJ4PfpnEujo3Yvdtc7lGKMMtUIKuII7JfQAy
5ciw6RacG2HlloYpGfaGHR7BEoKfXhkeSfy0pILe3ItoXt6qEaTx/UkyExYZNfZdsCwFdWuh
nnZbZeoWli+H5lGWXMt2wsrBdClBocM8CTYM5noyWH+NiU4ib2wEOLE0TQU3upWafYLkOr3Z
UeDs2wTAN0NMex7d23YpjMoF6evmhbCyGiXsT34Fi2tsInRrbKKw9WMxJr3o+BCS4f08e24l
8TaV3OD78J58i6yLs49SngGCtB1IYScUoc3opON+AC8Jh+MYnUjQLFZmdt4mflqnhx8nmAQ4
Zs4UtDlJhR/xhpKXAAaNvUY6V/rB3h/BrJ99/c0MiSDtN8EhZQFbYxidALcb5OAw7xWAaWkK
9qZgHIuvvyLf0hXGSA+8fpugzperlVgkacrYDynbzBoG43RdynJg8W8J/MWwG1XeapFlnpVA
Yl4r5OdJM+KoGwBTUM8JTIxxIpmJaAjmozHqLDRYZM216ycFUGsr/OZigFtTEWfCMB15ceBn
8A2xG+PLF2agwQ7HYYS0HY5vhjEZUq7IUoDpLQpeXlNiDoxCl8bcUVEacZlgqT29uUERGVMq
KdbMj1LI/rSjUIlLgn36yj9QZiCgK2eFdsECeEski2kToeM3lhkHvg6wfJ/u0fVeapA66EG5
OeF1sakNpAkk1qL5f0An3QmMWkm3BhDHcvLq/Zo96dHwBuwl3vMQeqODMQyfvk+DqMqHlW0W
S6xbSKxqMx+L1xgug+UBee2rMRFrhhId3J6cJYjLHgzmkht8uKNcpjs4jSZZTNEHt+f1mLL2
aJupsfDaxRG2/kP4USEZmuLRlBOw6NcvODWY971LYQ7yhKYkK5aRura3ITpN0nbQrZfyrFuM
jxP+pwVTUegklAWZ8Z5MaCwmsp8cJH0S+dWSH7Wh08ojGGORIaRx5ga/MiXJlSFc8dKUgNY4
iTqVrLh8NCoyiDReSkHHHDZVlZxW4dEmsmy4XwZLfo1Sriqa6R2LOStN8aakgdyLMdOUTlWb
ZmB5u/0G6Qjh3ZSzzglII2IoyDA66ONf/dR5gx2W82FRgRaMbhQvop7+6QuLJV7sgLN2rmq2
M2iP4UiYbLf30IXoYDZF6w9fCyJz1LXsCAXwFJlEBAfvLjty+cLUlY1BpjVm+UYapQvDUL1J
3NlAcp38sXALjNL1ojqbke3nHo2RTy6EdcjjTSlGHaTkDU6p+CPFGkj+OaiIo/TLy5TbTfu7
AW177kdcfky+QSn/WFRvEnKNArhYIdyHIjxRz4Gv1WD9TUnxA44k207tCuLUfdZVkmtXTGfh
ZLQR5OETC6UVN5+ioNkQFAnO9hMKY1bDALnxjT/+mKE1RxGp16QHMKvYYomGQQDvxJQr6ezF
DX5hydV24PBkF1hCNvvwRe2MpKKDFK4PTRV3ZCbcuo6iOqWEdrBhekAH4N//fG/3ngNjGqwp
NWaJtGi45H2eDvBZEfXRK6lLwYJDiPZ5vGCUpM0CuNKGOk/hx8kPDm8IWx5eCpCudIkLCE5K
MIbVG+Gf//XfrDlJYy7xL7aQjmCMNHIqzasO9TaWMhIIhk1QFmPMizF60EnR9WIBKjDjOkpR
3129z17CfA1gqwq9pFuxTKcAg6ukSPeXz1x173PYgpgqSA9elbgU2OuTZcA+kVdiOvTRYUML
RnJVXYMLBwdar6YxVxEdOsk0Vl2HD1TqLCZMlfkBJ+2s2vSTCcPqU4Xt6+e3Y8UZIVdpUKhu
WDPAUNTxXqdrXq/kLHSZRh6nMcrHz8DrqYjK97OJNS5konJ/CvtXg0pfVkZTpzhJgPO31uKO
mB8lk82/gua5hErMIjNOf9HrjX6FY97d5qx4jTH8AIakop1MB4sOAdyrY5rMsPwGVBspJ8Pi
7+cr15a0S8mFmDwSuq4IdS3PE4IW/QDg9RLdSxempC7GwsuOYfUSAaYuvp6LNuZbiK2uWRyr
3HMuLAlqxMp+XpMocxdKazaItZMHq2lSjPUrAO6ODCDvRmEscE+uDdhFeyVmnRuHVsJT/z4l
9LuzEB2nYXgMRtpTIDXZjrwM/WzL2w5Gj2YvFnKtKEA7b3ql2qjieGX8lYiTHSnWSE26oH5n
loWEJcr7fAUwMxdd2mCxi1Bv7y/0PZi9eunwphAmn4fVUXvtVc69Q9XHpHcuFencxMMAO6fE
4pSaSGP4DtQalR0ew5OfUjQMTiJUPBzMbdGZvXZBmeXbApgYati+yaKrGSPbC8bBrbqopT8e
Hpw9g27/5GEfWIZt06jWZ5O/RgOWrkUVZvu3yvgpA5gFm1Hp3szHSJW9sZwS3yN1IXud0OkT
MyoXJpNS6kW2feeT3TnLBX+eX01h+86x9K3jp0w4JRKJxWPG//4/T8Ibq87S9a5yZzPNFEzj
2zUZIRDPSrOXrT1emXo7vZwcanUaMh7nQIGbNN3LGECTxwsNycJqqS07iDhnLc8/5ywQbhko
VLdfXFamp6BfPwlLoFVOj/R3I7vAVa1XobIBvRmTLPgqZLWdB7hawRRdYXD06huwcsP8Pj96
+Nb2S7B2GBcTj+EkVms/X7G4lzEMk0yF5jY0KhixUmxOQIVay1FeYzM0zoaJ34O9Q2PKbywn
zHpHBOoXfvynMnjfmvpQ6nJneNTyaDtXY3pRxXa5OIxRV2/BNB2j3RhjOJgikEKXt2CEDFdW
j25OItF6iyz9Tz/MHx2ySXA9TdBdteI7jKMLCqhHJfSZvmuaMg/gRZXmx5my30eUlVnzLq6D
nnDmAtiOX/zyVypI4xZocmG+W6akSdcB5SJejJHnDRHUGxc+ZMN6gG1jXq9C5UaOlXBBEa5B
TEpaI79GDl2J6Ibc/bJEQZzC5Kc0bVO+G5ePYZFcnOHuF1t6mAz9xcqcBoz6kEk1TcGZSoc6
ob+iXEOwrnmM4RhozNDb4fGCVcMGvabDrbxCpYy1UKM3IE20yOhN4VtjcShMsvedVWslkokx
d6KIxc3WGkc8+C0cpe0cEtQJSlpfO4+Rr5+7SKUSJsbE2k9uyLQYroA2dKGgGxjDAXArGc0Z
pnsyIiJ1jd4SW3CpqCA5qEJ2oDPAtDlU5oOB3JGLNkbNSJx1eJ7KnbqrsV5YuBYa0PHSOI1x
bNHzTfK2o3DiUP7VYxvSi0bvGxhUO3lWEZex+jdvEvP1Q2P8FFimOQrz0Vhc4WwNKexqyKtO
17wSk+epaSx9KRqkY83e6edffnnCpJaC1GCIhAsFUqrnTBMLoHCmjiukS1XvgRZjtac7gslp
bgNy5iuYMnYfuV1i83pK5pyl2VtuXlnkCFh5a8aKFTNnlJ2WX29sH5VseYs9ScGmzw9loPK8
bnolvgFHMpTgvl4pOAmWosaGja5oyujhW9O3bZ/Z2Gzs6F2vzFlQaJ8BYdGTVopH85wJ5lLn
Y0OS4LCMjWIOwhlLiDGqlPaD86E41St4RYo3Dxs7snTatjHpw4+3p1rnUWSzYpoHievYGRhs
pgiPM6WYReN8WO7z3LPOT3OhXDTciOkBGhLqHW1LLFJtsZzZMRwNF6Os+xojucqD4UNy+p1A
YwoMuA5K7bV7rj1d4cERUiUg9jCxXW7KMnzJYujuYoxjzcLioXA5xjQR+puSnoT2nCvAOJW7
reF9zHGrXPfEvpeul+hlqMeaUrDexum5s8j6StZ4UzrWqoN030xRd+bzlDQllibIvVahq/cu
Rii6is2EabsoCOu43oVgLHDqvcIuVIZbG/Q2jTIJpi0+FKU2wVaRNrEuNabviK3LPjCkYlFH
gbPWZzTxCEbV6+w1qgSCvdQRRuYSTGS34lgKQf/jjO4LhqHd8IOCCWJnniUWzGgSmvFhIfIE
4BdCjDf2IC3B3qfcQBp0l+M4rGvwEyQmwLv1VdD6B1S5ZwLwa8MMt1Z1XMO2I4MwW8c2rTFL
MMzq6ChHjlVwVu2bqobcrQWtaMFf2UBp6bjrNWJB26UxP6+UTSJ35iUbgdhjDD7jYtBtStwl
MC/C2UuS2w6mmWHd15Qc+QbYO5u4dbC5OZ3AlHZCKnK9+XqvJ47HMKcyonRu2SR6S2Tk2H70
bJW0SlrocQRLdtwh5hclImBwrsNmwpBkjyZ8+3wgIfyxdKdLnxwr4E4GRZbVMqd2E51/J2TH
pWLhHeuGBUzMdBWSrOA91lrU9dfYmL8pRENjDHeLZBqz1jpz0sdoDEMTgGYXjOsDCYk15sox
MTx9Y0b8opbVCGsXfWE+w4x5lExz/ABmBMz3e9qZLQLb4PO5NrZ868bHSisKcpwiz/34xkp8
fV6EGXRB0fVhiKLRTmslPF5j6kK2SOolefXseOcghP7nSxfOy+WY0hZXZiA37jhmDeRXJjt7
ctIZKbnGbNgfYI5e1aD0haOvlAuwdl2ijdRE2YWtMY6viW1DX43FrtxPdqaXYuEM2hELDotN
IK2AhBrrhV/mw0615t8NjXmoBlOuXYn6RkwcePhe0HSwFthD9n0TxunJguFc7h6S+BrMWwn5
Je6dQf/q/nvijEhzDrpv2iEpFy6Yexw4kbIRTJul5l+uNjqu6dqd0+FRmrEo62tK7taYYUrB
ZWvPKBWYIUnMCgYYIQkzFkIe4ggoiyrzJQpJovZvmqE2rPf1dLddhySXYBwnWylMnGBzJQNp
wcbD+QAGyqwZfleCcblCBUv1Tmq3BTMxJjYczp0yza8xVkrxRwkmF51KERvgUKp5dMYHNNYe
3NGx3JVn+grmwZhJF3J4pWIlzUsXLJgPVQ7GcF/zV/T1gNwJNx1eebRDFxgrlbN27Y2JMebD
YyrSCF20wfvKspouKPK82xjRfi3i/X5xVOBSsd45iKMLqy6mbrfCEGfalA5ddDMk2R50jIKf
dzQkRH9j9zd5JaWN5JhvGZs73o4s/Rffg7V1Ts6SqLafV3qAwYkYXo+H2BR5EMuuiMdhUxYW
b4LOBLMEBR0cvNg+cuRbLR6SXf2VjQB2JnpNmWPnEPJW4JSA/jtwOcB4YlNSljMCYFyKpvue
mdJHsNH25o4hWLBM5pz2C1vgu21YfhsWKMqMF4xbJ8dgWsTZqe+pYHZ1pmoxfvlok6MeeTfQ
ClP09C30iHJqCt8zglog5hFMjK/pMpwYoffgmJ9gDml4BfMzs1gsHumZ3uLBB1Vqd5gcAaox
5bSYNnmIVXdBueCC6bCx3jMXNd7mbhrHY74QxLTvDUpzwZpgVW7TLmehA+ShpLDzMR8itrWP
qcReb2V1Z+uZuaVOjDHRbbo8+umYUtxTYKIZJozGvh3WpkU8xkTExd63ACZxp0KPMeYrtzgI
sSfkVYeigMAjeCSmII2xBOqiHDr9IziyrJvq6oHG6PsF6wCdoTE1cFwGd9fhvk3ypKKPxki3
7Q/h8z4pzgTtWXmlePsoaxHaJZjVOLAH9otp/vKQ85RpJxPqGrEJbtehuQDwBF4ZF8StT0xu
PFGuFzI4cx5hnXDJpnet1UCj2HVx336A/X3RGItZp0dB3EdjHCfJwwOOJhQ7BW8Kl5wIS5LV
7pOjFvLn4PwOqOwX0knaU2nMV7DoxcNhPWxHMDwId2uw/RysR8a8giHmPgLY0teezj6lYNy/
UNTehSzk0bpQGJF+LaxMi5sYM4yMvAvT1zMjBnmr+FyZ3+M15nCWqoGpizf1FVwfYIbGxJ9C
dmInyIza1Jg8T3IKoE+hUtdTakzTR5B7eItIdoB31QvDG2EmD52iKYhrvUqoK7wa4OPZqGNQ
T0oCHtOCGRojIQo3Tc/Sk39rwLgUmveJ4wLLnAV6G12jjsD1yQYqnx5j/qakK4qG6erItvUc
6z+CDzB8B/o7L5eNMDUbYGMnms749KY0vdJQK8fiS6dT0Gwdeij2PQfAgyq9IUaapog4/j7A
9hQdggzBtKkc+3L1zanhjKZbf8BO8/908zgwYyugDkuajUPCUl0pOQD5B5l5DsHTlR/kTEz7
YSxxYVg4/cZA86wVpszmvD/Mco7Ni6Rj60I4PTTa3cNPiV6mr7oM4vYVjrWUozAmjhNQFj8J
dQvEdopAj5rsv+axcaSv+NMF8fhYqQQLV75bjGasxMKdcgHRNgBGBxyGvW9EtAa1nzoO69aL
YmsW98QjWJdI4HiSVMYNPIX6A81AmNJfRRmlqe0+u0xPz2PmMx/BIhc/qjEWQ4h0rZ1cCfpi
8Tc345mTD/qj2a9zX690CaabuIO4HYbEbsm4gJ5jYuddWJJq74KH+t0A2Faojvbo0MSeHcEm
xBh9hD6B19QhFky7CM2ZUi7EzpkAQyrMM5TPFmNdeqVk2Z2wzDrfJRb25aaWWPekOdDaKRH9
xxYqnD87r3TM7GV+W8G4+eiDF+V5EHHMbIU8YhBYP4iYvgTVyULzh7lNaWLsyZg/HrH2PRwP
cKw6RvLsgiO5yZiRnnmBrEig574tEnbVRfFj/seYUlhw8EYSJKfPtkfQvKQFS2EtnN0VVcf3
vi1TeuHpUyjVGnv/PQD4KL+0AEeLP+CowvgIFN9RV3e8z5xBdofH1AARoylN63KzxAGkkkFX
hoeMLNUDJX9TPiGPPcaUUmn2iSgRyDNsRjXH+m2YsiuCVRynHJZz65iDcl/1lH0bBNs1Khzt
eSHhjxIXYnxwqNXnR7A9w5hRI1GF7mCsy+6ejC6Ma+Pj28ZYDzVmUvi365XOM9+Q5KDUJZgL
/Mz1o4bgldiRrXshyXEf5z/3JAbM9Ygz7hJMe6bzTPsxdyqZdjMgoV4QZ8qk567Ygj2X5a+C
9bT8PwAAAP//AwAwYBzXGsKNWQAAAABJRU5ErkJggg=='! !

!GbtIcons methodsFor: 'private - icons' stamp: 'hk 12/18/2016 15:38'!
walletIcon
	"Private - Generated method"
	^self icons 
			at: #walletIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self walletIconContents readStream) ].! !

!GbtIcons methodsFor: 'resources icons' stamp: 'hk 12/18/2016 15:58'!
walletIconContents
	"Private - Method generated with the content of the file /Users/hartmut/Smalltalk/Pharo/Pharo5.0.app/Contents/Resources/Icons/wallet.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAACMElEQVR42o1T20pqURTd/+o3
+KZvlQrSi4ipICpeIG+U2/JSYlAImhh5R1+0EFS8oaZlNmJMzhbO0zkDFnuvy5xrjDHnUk5P
T3F/fw9VVXFzc/NnpJBKpbjGwX9tXb6qmkQul8PJyQmUbDYL4nA44H+hnWWswhuI1WqF9XqN
/X6P7+9v9Pt9dLtd9Ho97snabrfDz8+PzIvFInw+HxRSIrhJDAYD3N3dwe/34/r6GkajEefn
55pMoX55eYmXlxdQvkJ9xGg0QiaTQSKRgN1uRzQakSTPz2UUCgW0220J9Hq9eH9/x2w2g8lk
gnhQr9fh8XgQiUSE1sXFBT4/PxEMBdFsNsS4s7Mz2Z/P5yDK5TJcLhcUm80Gt9uN29tbPDw8
IBqNysGnpyc4HA7odDro9Xo8Pj6KeV9fX+JBPp8XSYrFYmGZxINqtQqn04nX11eYzWY5wAtI
mdhsNiDIuFQqiTQlHA6jVquh0WiI5qurK7LhnDQlGcEK8fbtdotAIECJ4plCd5ltOByCoFn8
55fuT6dTHmZ5mYC6hT4hElgWOspEmjlvb28IBoPChmDt5/MZ/WF/aI1Ec4+NJHSWyyWazSZa
rRYMBgMmkwkINhSDx+OxJueY4NgHnU5HnCZoZCgUAkGG6XQaHx8f7EZ+ZRCM1RjQHGYU/Var
VVo1FovRcW2fVWDwkQFjpZE0LBYLcB6Px1GpVGjavx+T9pyTySR94CIp02mW869nnjo+Z1Vi
GPsLGEFqmtmfG6sAAAAASUVORK5CYII='! !

!RTHTML5Exporter class methodsFor: '*GBT-DSL' stamp: 'hk 5/27/2015 15:55'!
export: aView  
	self new export: aView ! !

Object subclass: #GBTKnowHow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Utilities'!

!GBTKnowHow commentStamp: 'CC 7/8/2016 14:06' prior: 0!
Place to collect knwo how snipptes on using the GBTauthoring and modeling appropriately.!

!GBTKnowHow class methodsFor: 'classDeletion' stamp: 'CC 7/12/2016 10:43'!
classDeletion

"if a class X is removed, it may still have references to its methods which are directed to ObsleteX class. 
Importing class X anew might leave the references to methods of X pointing to ObsolteX. Try
Smalltalk fixObsoleteReferences"! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 8/16/2017 17:21'!
columns1
	"self columns1 edit"
	
	^GbtSmartNode struct: 'Columns1' define: {
		{ #c1 . #val: . 'value11'}.
		{ #c2 . #val: . 'value12'}.
	} full: {
	}
! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 8/16/2017 17:21'!
columns2
	"self columns2 edit"
	
	^GbtSmartNode struct: 'Columns2' define: {
		{ #c1 . #val: . 'value21'}.
		{ #c2 . #val: . 'value22'}.
	} full: {
	}
! !

!GBTKnowHow class methodsFor: 'icons' stamp: 'CC 7/8/2016 18:28'!
createIcons

"
x. Convert an icon to 32x32 pixels online through https://iconverticons.com/online/
1. create an iconName.png in Pharo subdirectory 'icon'. iconName.png should display as 32x32pixel imagecategory (download from somewhere, or use an icon editor).
2. In GbtIcons normalSizeNames 
add #iconName (in case of 16x16, add to smallSizeNames)
3. Create a resource method in GbtIcons using the expession found in the class comment





"! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 8/16/2017 17:15'!
exampleTableTestXRun
	"initialize, build main table test context, add policies for various core data, open ui"

	| ui ctx |
	GbtServer initialize.
	ctx := self tableTestXMain.
	ctx addPolicy: #TableRowNoPolicy prefix: 'R'.
	ctx addPolicy: #TableColumnNoPolicy prefix: 'C'.
	(ui:= ctx ui) title: ('TableTestX', ui title); open. 
! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 8/16/2017 17:21'!
lookupTestTabelle1
	"self lookupTestTabelle1 editD"
	"Note that a) slots evaluate to thing name userName:T47v2 or strings
	b) accessing slots with their name needs to convert strings into symbols using asSymbol
	c) table to be looked up needs reference to serve in calc or constraint expressions"
	
	^GbtSmartNode struct: 'Lookup1' define: {
		{ #tabelle1 . #thing: . self tabelle1}.
		{ #tabelle2 . #calc: . 'ref (#tabelle1)'}.	"ref resultiert in einem Thing, aber der Slotwert ist der Name des Things"
		{ #row . #enum: . #(#r2)}.
		{ #column . #enum: . #(c1)}.
		"Works"
		{ #constraintSlot . #constraint: .	'( GbtThing typed: #tabelle2 ) contains: ''Schmidt5'' at: ''r3''' }.
		{ #lookupSlot1 . #calc: .	'( GbtThing typed: #tabelle2 ) slotAt: ''r3'' asSymbol '}. "alt"
		{ #lookupSlot1 . #calc: .	'ref( ref(#tabelle2) #r3)'}. "neu"
		{ #lookupSlot2 . #calc: .	'((( GbtThing typed: #tabelle2 ) slotAt: #row asSymbol) slotAt: #column asSymbol)'}. "alt ???"		
		{ #lookupSlot2 . #calc: .	'ref(ref(ref(#tabelle2) #r1) #c1)'}. "neu"		
		{ #lookupSlot3 . #calc: .	' ( GbtThing typed: #tabelle2 ) r3'}. "alt"
		{ #lookupSlot3 . #calc: .	' ref(#tabelle2) #r3)'}. "neu"
		{ #lookupSlot33 . #calc: .	'( ( GbtThing typed: #tabelle2 ) perform: #row )perform: #column'}. "alt"
		{ #lookupSlot4 . #calc: .	' ( GbtThing typed: #tabelle2 ) tableValueAtRow: #row atColumn: #column '}. "alt"
		"Does not work"
		{ #lookupSlot10 . #calc: .	' ( GbtThing typed: #tabelle2 ) slotAt: r3 asString'}. "geht nicht"
		{ #lookupSlot11 . #calc: .	' ( GbtThing typed: #tabelle2 ) slotAt: r3 '}. "geht nicht"
		{ #lookupSlot12 . #calc: .	' ( GbtThing typed: #tabelle2 ) #row asSymbol'}. "geht nicht"
	} ! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 8/16/2017 17:21'!
tabelle1
	"self tabelle1 editD"
	
	^GbtSmartNode struct: 'Tabelle1' define: {
		{ #r1 . #thing: . self columns1}.
		{ #r2 . #thing: . self columns2}.
		{ #r3 . #val: . 'Schmidt5'}.
	} full: {
	}
! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 3/22/2017 13:14'!
tableTestXContext
	"comment stating purpose of message"
	
	^GbtPlainAC struct: 'TableTestContext' define: {
		{#displayAs: . 'TableTestX'  } .
		{#uiSpec:icon: . #GbtItemUI . #beitragsMgmt16}.
		{#vo: . self tableX} .
		{#loadPolicy: . #autoload } .
		{#menu:items: . #Beitragsmanagement . #(#'Do Something 1' #'Do Something 2') }.
		}
! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 3/14/2017 13:01'!
tableTestXMain
	"self tableTestX" 
	^GbtPlainAC struct: 'TableTestXMainContext' define: {
		{#aspect:on: . self tableTestXContext . nil  } .
		{#uiSpec:icon: . #GbtMainUI . #main} }! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 8/21/2017 17:36'!
tableX
	"self tableX editD"
	
	^GbtSmartNode struct: 'TableX' define: {
		{ #info1 . #val: . ' #tableRows '}.
		{ #tableRows . #listOf: . self tableXColumn }.
		{ #tableRowsRef . #ref: . 'ref (#tableRows)' }.
		{ #rowIndex . #val: . '' }.
		{ #columnIndex . #val: . '' }.
		{ #cellValue . #ref: . 'ref (ref (#tableRowsRef) #rowIndex:tableColumns:columnIndex.cell)' }.
	} full: {
	}
! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 8/21/2017 17:36'!
tableXCell
	"self cell1 edit"
	
	^GbtSmartNode struct: 'TableXCell' define: {
		{ #summary . '#cell' }.
		{ #idNumberPolicy . #TableColumnNoPolicy }.
		{ #cell . #no: . ' '}.
	} full: {
	}
! !

!GBTKnowHow class methodsFor: 'tables' stamp: 'hk 8/16/2017 17:21'!
tableXColumn
	"self tableXColumn edit"
	
	^GbtSmartNode struct: 'TableXColumn' define: {
		{ #idNumberPolicy . #TableRowNoPolicy }.
		{ #tableColumns . #listOf: . self tableXCell }.
	} full: {
	}
! !

Object subclass: #GbtAction
	instanceVariableNames: 'pipe params'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtAction commentStamp: 'hk 12/16/2016 14:31' prior: 0!
Each behavior is made out of actions.
Actions - executed by my doOn: method - are chained with a pipe.
The position of a named variable in the signature of an action is relevant. The variable name may be: 
- a global thingName of thing, context, or declarative or 
- one of these special names: thing, context, contextVO, pool
(thing = pipe thing, context = pipe context, contextVO = pipe context vo, pool = add to pipe context pool )
-  the variable content may be a Thing, another SVO  or a global name, that will be resolved

    Instance Variables
	params:		<Array of String>		my parameters
	pipe:		<GbtActionPipe>		I am working on. Contains context, thing & variables
					
    special conventions:
when called, 
	pipe context 		always contains the context I am executed in 
	pipe thing 		eventually contains an argument
	pipe getVar: 		more arguments may be found in my (named) varaibles
when irrelevant use 'void'!

!GbtAction class methodsFor: 'instance creation' stamp: 'hk 1/4/2017 17:40'!
actionNames
	^#(GbtActionRefresh 		REFRESH
	GbtActionHalt 				HALT
	GbtActionCheck 				CHECK
	#GbtActionCommit			COMMIT
	"creating things"
	GbtActionAssureVO			ASSUREVO
	GbtActionAssureThing 		ASSURETH
	GbtActionNewVO				NEWVO		
	GbtActionConstraints		CONSTRAINTS
	GbtActionBehaviors			BEHAVIORS
	"messaging actions"
	GbtActionGetEvent			GETEVENT
	GbtActionPushTo 			PUSHTO
	GbtActionMatch 				MATCH
	GbtActionEmbed 				EMBED 
	GbtActionToList 			TOLIST
	GbtActionCompose 			COMPOSE 
	GbtActionSendTo 			SENDTO 
	"processing"
	GbtActionContext 			CONTEXT 
	GbtActionTransform			TRANSFORM
	GbtActionBehavior			BEHAVIOR
	GbtActionAssign				ASSIGN
	#GbtActionReadSlot			READSLOT
	GbtActionAssignDateToday	ASSIGNTODAY
	GbtActionAssignUser		ASSIGNUSER
	GbtActionSetSaveCtxt		SAVECONTEXT
	GbtActionAssignDecl		ASSIGNDECL
	GbtActionAssignVal			ASSIGNVAL
	GbtActionWriteSlot			WRITESLOT
	GbtActionAddToList			ADD2L
	GbtActionAskFrom 			ASKFROM			
	"map / reduce (list processing)"
	GbtActionMapBigList		MAPBL
	GbtActionMap					MAP
	GbtActionAlter				ALTER
	GbtActionApply				APPLY
	GbtActionAskTemplate		ASKTMPL
	GbtActionAskElement		ASKELEM
	GbtActionAskRole			ASKROLE
	GbtActionFilter				FILTER
	GbtActionFreeze				FREEZE
	GbtActionReduce 			REDUCE
	GbtActionReduceAdd			REDADD
	GbtActionAddToBigList		ADDBL
	"for constraints"
	GbtActionSlot	 			SLOT
	"service calls"			
	GbtActionPDF					TOPDF
	GbtActionEdit 				EDIT
	)! !

!GbtAction class methodsFor: 'private' stamp: 'hk 1/1/2016 19:39'!
classDict
	^Dictionary newFromPairs: self actionNames reversed! !

!GbtAction class methodsFor: 'documentation' stamp: 'hk 6/2/2016 11:21'!
documentation
	"self documentation"
	| stream dict comment index |
	(stream := TextStream on: (Text new: 10)) 
		nextPutAll: self name asText allBold; cr; 
		nextPutAll: self comment; cr.
	stream nextPutAll: GbtActionPipe name asText allBold; cr; 
		nextPutAll: GbtActionPipe comment; cr; cr.
	(dict := self classDict) keysSortedSafely do: [ :k |  |clsname|
		clsname := dict at: k .
		comment := (Smalltalk at: clsname) comment.
		(index := comment findString: 'Instance Variables') > 0
			ifTrue: [ comment := comment first: index -1] .
		stream nextPutAll: (k, ' : class ', clsname) asText allBold; cr;
				nextPutAll: comment trimRight; cr; cr].
	^stream contents! !

!GbtAction class methodsFor: 'instance creation' stamp: 'hk 12/8/2015 13:31'!
for: aParameter
	^self new for: aParameter! !

!GbtAction class methodsFor: 'private' stamp: 'hk 1/1/2016 19:38'!
nameDict
	^Dictionary newFromPairs: self actionNames! !

!GbtAction class methodsFor: 'instance creation' stamp: 'hk 8/22/2016 14:45'!
newFor: aSourceArray
	| classname |
	classname := self classDict at: aSourceArray first 
			ifAbsent: [self error: 'action ', aSourceArray  first, ' not provided'] .  
	^(Smalltalk at: classname) for: aSourceArray second
! !

!GbtAction methodsFor: 'executing' stamp: 'hk 9/25/2016 14:30'!
abort: aString
	aString ifNil: [^pipe abort: ''].
	GbtLogger log: #ABORT text: {self actionName . aString}.
	^pipe abort: self actionName, ' ', aString! !

!GbtAction methodsFor: 'accessing' stamp: 'hk 1/6/2016 13:21'!
actionName
	"ActionAspect new actionName"
	^self class nameDict at: self className! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 5/7/2017 21:54'!
context: aCtxtNameOrVar 
	"answer the context named by aCtxtNameOrVar or nil"
	| ctxt |
	(aCtxtNameOrVar = #context) ifTrue: 
		[^pipe context].
	^(ctxt := self getVar: aCtxtNameOrVar) ifString: 
		[pipe context bizApp contextNamed: ctxt].
	! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 9/24/2017 15:39'!
declFromVar: aParameter 
	^(pipe getVar: aParameter) ifNil: [pipe context bizApp directiveNamed: aParameter].
! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 9/24/2017 15:39'!
declsFromVar: aParameterOrArray 
	| decls param |
	(decls := pipe getVar: aParameterOrArray) ifNotNil: [^decls].
	(param := aParameterOrArray) isSymbol ifTrue: [param := {aParameterOrArray}].
	^param collect: [:p| pipe context bizApp directiveNamed: p].
! !

!GbtAction methodsFor: 'executing' stamp: 'hk 12/8/2015 16:57'!
doOn: aPipe
	^self subclassResponsibility ! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 8/30/2016 11:32'!
ensurePath: pathOrSymbol
	^pathOrSymbol ifString: [{pathOrSymbol}]! !

!GbtAction methodsFor: 'error handling' stamp: 'hk 5/3/2017 12:13'!
error: aString
	^GbtObject error: aString! !

!GbtAction methodsFor: 'instance creation' stamp: 'hk 8/22/2016 14:45'!
for: aStringOrArray
	aStringOrArray isString ifTrue: 
		[params := {aStringOrArray}. ^self].
	aStringOrArray isArray ifTrue:
		[params := aStringOrArray]! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 8/29/2016 13:09'!
getVar: aSymbol 	
	^(pipe getVar: aSymbol asSymbol) ifNil: [aSymbol] ! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 1/4/2017 13:43'!
listContext: aCtxtNameOrVar 
	"answer the big list context named by aCtxtNameOrVar"
	| ctxt |
	(ctxt := self context: aCtxtNameOrVar) ifNil: [^nil] .
	^(ctxt isListAc) ifTrue: [ctxt] ifFalse: [] ! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 11/2/2016 16:15'!
plainContext: aCtxtNameOrVar 
	"answer the plain context named by aCtxtNameOrVar"
	| ctxt |
	ctxt := self context: aCtxtNameOrVar.
	^(ctxt isListAc) ifFalse: [ctxt] ifTrue: []
! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 6/7/2017 10:53'!
primeListContext: aCtxtNameOrVar 
	"answer the big list context named by aCtxtNameOrVar"
	| ctxt |
	(ctxt := self context: aCtxtNameOrVar).
	^(ctxt ifNil: [^nil]) isPrimeListAc ifTrue: [ctxt] ifFalse: []! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 4/24/2017 16:40'!
setVar: aVariable to: aThing
	(aVariable = #thing) ifTrue: [^pipe thing: aThing].
	(aVariable = #contextVO) ifTrue: [^pipe context vo: aThing].
	(aVariable = #pool) ifTrue: [^pipe context addPoolThing: aThing].
	(pipe context hasTxThing: aVariable) ifTrue: [^pipe context assign: aThing toTxThing: aVariable].
	^pipe setVar: aVariable to: aThing.	
! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 5/7/2017 22:02'!
thingFromParam: aParameter 
	"answer the thing named by aParameter or nil. role names preceed parameters"
	(aParameter = #thing) ifTrue: [^pipe thing]. 				"may be nil"
	(aParameter = #contextVO) ifTrue: [^pipe context vo]. 	"may be nil"
	(pipe context hasTxThing: aParameter) ifTrue: [^pipe context txThingAt: aParameter].
	^(self getVar: aParameter)ifString: [pipe context bizApp thingNamed: aParameter].
! !

!GbtAction methodsFor: 'accessing args' stamp: 'hk 5/7/2017 22:02'!
thingsFromVar: aParameterOrArray 
	"answer an array of things from either #variable or #(Name1 Name2 ..)"
	| thing param |
	thing := pipe getVar: aParameterOrArray. 
	thing ifNotNil: [^thing isArray ifTrue: [thing] ifFalse: [{thing}]].	"not a var"
	(param := aParameterOrArray) isSymbol ifTrue: [param := {aParameterOrArray}].
	^param collect: [:p| pipe context bizApp thingNamed: p].
! !

GbtAction subclass: #GbtActionAddToBigList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionAddToBigList commentStamp: 'hk 8/29/2016 15:26' prior: 0!
I add all processed  list elements to the bigList of  context.
context is the global name of a Context or a variable holding a context.

Syntax: 	ADDBL   context !

!GbtActionAddToBigList methodsFor: 'executing' stamp: 'hk 6/7/2017 10:53'!
doOn: aPipe
	| ctxt  list context |
	pipe := aPipe copy.
	list := pipe list. 
	context := params first.
	ctxt := (self primeListContext: context) ifNil: 
		[^self abort: context, ' no big list context found' ] .
	list do: [:e|  ctxt newEntry: e . e store].
	ctxt refreshUI.  
	^ pipe! !

GbtAction subclass: #GbtActionAlter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionAlter commentStamp: 'hk 8/29/2016 16:41' prior: 0!
I transform the list using the declarative with a fixed source: thing.
If the thing is not found, all sources of the declarative are cleared.

Syntax: 	ALTER   #( thing declarative )
	
related to TRANSFORM!

!GbtActionAlter methodsFor: 'executing' stamp: 'hk 5/10/2017 15:20'!
doOn: aPipe
	|decl th  |
	pipe := aPipe copy. 
	(decl := self declFromVar: params second) ifNil: 
		[^self abort: params second, ' not found'].
	th := self thingFromParam: params first.  
	decl sources: th.	"clears the sources if th isNil" 
	^ pipe list: (decl transform: pipe list)! !

GbtActionAlter subclass: #GbtActionTransform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionTransform commentStamp: 'hk 8/29/2016 16:41' prior: 0!
I make a 'varDecl copyWithSource: varThing' and assign it to varRes

Syntax: 	TRANSFORM  varThing varDecl varRes 
	
related to ALTER!

!GbtActionTransform methodsFor: 'executing' stamp: 'hk 5/10/2017 15:36'!
doOn: aPipe
	|comb thing |
	pipe := aPipe copy.
	thing := (self thingFromParam: params first)
		ifNil: [^self abort: params first, ' not found' ] .  
	comb := (self declFromVar: params second) ifNil: 
		[^pipe abort: params second,' not found'].  
	self setVar: params third to: (comb transform: thing).
	^pipe! !

GbtAction subclass: #GbtActionApply
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionApply commentStamp: 'hk 9/25/2016 14:42' prior: 0!
I call the behavior in the context with each list element in turn as an argument arg1. 
list elements are replaced by the results of the behavior.

Syntax: 	APPLY   #(context behavior { arg2 arg3 ...  } )  	{ arg2 arg3 ...  }  = optional
		
related to BEHAVIOR!

!GbtActionApply methodsFor: 'executing' stamp: 'hk 5/7/2017 22:32'!
doOn: aPipe
	|behav ctxt in out behavior arguments |  
	pipe := aPipe copy.  
	(ctxt := self plainContext: params first) ifNil:
		[^self abort: ctxt, ' not plain or not found']. 
	behavior := params second.
	behav := ctxt behaviors at: behavior ifAbsent: 
		[^pipe abort: behavior, ' missing']. 
	arguments := (params allButFirst:2) collect: [:p|self getVar: p].
	in := pipe list.  
	out := in collect: [:e| |res|
		res := behav execute:  {e}, arguments . 
		(res = #aborted) ifTrue: [^self abort: behavior, ' aborted' ] .
		res].    
	^ pipe list: out! !

GbtActionApply subclass: #GbtActionBehavior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionBehavior commentStamp: 'hk 8/29/2016 16:45' prior: 0!
I execute the behaviour named by key , as defined in context.

Syntax: 	BEHAVIOR  #(context key  {arg1 arg 2 ...} )       {arg1 arg 2 ...} = optional
	
related to APPLY!

!GbtActionBehavior methodsFor: 'executing' stamp: 'hk 8/29/2016 15:49'!
doOn: aPipe
	| key args e ctxt |
	pipe := aPipe copy.
	ctxt := (self plainContext: params first) ifNil: 
		[^self abort: params first,' not found'  ] . 
	key := self getVar: params second.
	args := (params allButFirst:2) collect: [:p|self getVar: p].
	e := pipe thing.
	ctxt doBehavior: key withArgs: ({e}, args) .
	^pipe ! !

GbtAction subclass: #GbtActionAskTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionAskTemplate commentStamp: 'hk 12/17/2016 13:15' prior: 0!
I assign one of the templates of a big list context to the variable .
When the context has more than one template, the user is asked.

Syntax: 	 ASKTMPL   #(context  variable )     or 
		ASKTMPL   #(context  selVar   variable ) 	where  selVar contains a selector !

GbtActionAskTemplate subclass: #GbtActionAskElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionAskElement commentStamp: 'hk 12/17/2016 13:15' prior: 0!
I assign one of the elements of a big list context to  a variable.
When the context has more than one element, the user is asked.

Syntax: 	  ASKELEM   #(context   variable ) or 
		  ASKELEM   #(context  selVar   variable ) 	where  selVar contains a selector !

!GbtActionAskElement methodsFor: 'executing' stamp: 'hk 1/23/2017 13:05'!
getElementsFrom: ctxt
	^ctxt getList ifEmpty: [' no elements found'] ! !

GbtActionAskTemplate subclass: #GbtActionAskFrom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionAskFrom commentStamp: 'hk 9/27/2016 16:23' prior: 0!
I assign one of the elements of 
- the array in variable or 
- the pipe:thing:slotname-list  to the  variable.
When the list has more than one element, the user is asked.

Syntax: 	 ASKFROM  #( array  variable ) 			array = variable | slotname!

!GbtActionAskFrom methodsFor: 'executing' stamp: 'hk 1/23/2017 13:06'!
getList
	"^a list or String if Error"
	| thing var slot slotname | 
	slotname := params first asSymbol.
	var := self getVar: slotname.
	(var = slotname) ifFalse: [^var].
	thing := pipe thing ifNil: [^'no pipe thing'] .
	slot := [thing perform: slotname] ifError: 
					[^slotname, ' not found' ] .
	^[slot getList] ifError: [^slotname, ' is not a list']
		! !

GbtActionAskTemplate subclass: #GbtActionAskRole
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionAskRole commentStamp: 'hk 12/17/2016 13:36' prior: 0!
I assign one of the elements of a big list context to  a role.
When the context has more than one element, the user is asked.

Syntax: 	  ASKROLE   #(context   role ) or 
		  ASKROLE   #(context  selVar   role ) 	where  selVar contains a selector !

!GbtActionAskRole methodsFor: 'executing' stamp: 'hk 1/23/2017 13:06'!
getElementsFrom: ctxt
	^ctxt getList ifEmpty: [' no elements found'] ! !

!GbtActionAskRole methodsFor: 'executing' stamp: 'hk 3/2/2017 16:07'!
writeElement: elem
	"no copy to a role"
	(pipe context knowsTxThing: params last) 
		ifTrue: [pipe context assign: elem toTxThing: params last]! !

!GbtActionAskTemplate methodsFor: 'executing' stamp: 'hk 1/5/2017 13:39'!
askUser: elements
	^UIManager default 
		chooseFrom: (elements collect: [:t| t summaryEnriched] )
		values: elements
		title: elements first contextName! !

!GbtActionAskTemplate methodsFor: 'executing' stamp: 'hk 8/23/2017 18:14'!
doOn: aPipe
	| elements elem selector|
	pipe := aPipe copy.
	(elements := self getList) ifString: [^self abort: elements]. 
	params size = 3 ifTrue: 
		[selector := self getVar: params second.
		elements := elements select: [:e|e contains: selector]]. 
	elements ifEmpty: [^self abort: 'no element found in ',params first].
	elem := (elements size = 1)
		ifTrue:  [elements anyOne]
		ifFalse: [(self askUser: elements) ifNil: [^self abort:'']].
	self writeElement: elem.
	^ pipe! !

!GbtActionAskTemplate methodsFor: 'executing' stamp: 'hk 11/30/2017 15:33'!
getElementsFrom: ctxt
	^ctxt thingTemplates ifEmpty: [^' no template found'] ! !

!GbtActionAskTemplate methodsFor: 'executing' stamp: 'hk 6/7/2017 10:53'!
getList
	| ctxt |
	(ctxt := self primeListContext: params first) ifNil: 
		[^params first, ' not found or no big list' ] .
	^self getElementsFrom: ctxt! !

!GbtActionAskTemplate methodsFor: 'executing' stamp: 'hk 12/17/2016 13:34'!
writeElement: elem
	self setVar: params last asSymbol to: elem copy! !

GbtAction subclass: #GbtActionAssign
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionAssign commentStamp: 'hk 12/15/2016 16:58' prior: 0!
I assign  things  to a var 

Syntax: 	ASSIGN   #( things   var)  		things may be  one thing or an array of things!

!GbtActionAssign methodsFor: 'executing' stamp: 'hk 9/27/2016 17:26'!
doOn: aPipe
	| th |
	pipe := aPipe copy.
	th := self thingsFromVar: params first .
	(th size = 1) ifTrue: [th := th first].
	self setVar: params second to: th.
	^ pipe! !

GbtActionAssign subclass: #GbtActionAssignDateToday
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionAssignDateToday commentStamp: 'hk 12/15/2016 16:48' prior: 0!
I write Date today in  the given slot of thing or pipe thing or contextVO to the given value 

Syntax: 	ASSIGNTODAY  #( thing path)  or 
		ASSIGNTODAY #( path)  ,    			where path  =  slot  |  {slot1 slot2 ... }
	!

!GbtActionAssignDateToday methodsFor: 'executing' stamp: 'hk 9/4/2017 13:14'!
doOn: aPipe
	| thing path setter |
	pipe := aPipe copy.
	path := self ensurePath: params last.
	setter := path last.
	path := path allButLast.
	thing := params size > 1 
		ifTrue: [self thingFromParam: params first]
		ifFalse: [pipe thing ifNil: [pipe context vo]].
	thing := thing atFullPath: path.
	thing perform: setter asMutator with: Date today asString.
	^ pipe! !

GbtActionAssign subclass: #GbtActionAssignDecl
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionAssignDecl commentStamp: 'hk 8/30/2016 10:42' prior: 0!
I assign a declarative  to a variable.

Syntax: 	ASSIGNDECL   #( decl variable)!

!GbtActionAssignDecl methodsFor: 'executing' stamp: 'hk 9/27/2016 16:51'!
doOn: aPipe
	|  decls |
	pipe := aPipe copy.
	decls := (self declsFromVar: params first asSymbol) .
	(decls size =1) ifTrue: [decls := decls first].
	pipe setVar: params second to: decls.	
	^ pipe! !

GbtActionAssign subclass: #GbtActionAssignUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionAssignUser commentStamp: 'hk 1/4/2017 16:32' prior: 0!
I write the context user  in  the given slot of thing or pipe thing or contextVO to the given value 

Syntax: 	ASSIGNUSER  #( thing path)  or 
		ASSIGNUSER  #( path)  ,    			where path  =  slot  |  {slot1 slot2 ... }
	!

!GbtActionAssignUser methodsFor: 'executing' stamp: 'hk 9/4/2017 13:14'!
doOn: aPipe
	| thing path setter |
	pipe := aPipe copy.
	path := self ensurePath: params last.
	setter := path last.
	path := path allButLast.
	thing := params size > 1 
		ifTrue: [self thingFromParam: params first]
		ifFalse: [pipe thing ifNil: [pipe context vo]].
	thing := thing atFullPath: path.
	thing perform: setter asMutator with: pipe context user.
	^ pipe! !

GbtActionAssign subclass: #GbtActionAssignVal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionAssignVal commentStamp: 'hk 8/30/2016 11:43' prior: 0!
I mutate the given slot of thing or pipe thing or contextVO to the given value 

Syntax: 	ASSIGNVAL  #(val thing path)  or 
		ASSIGNVAL #(val path)  ,    			where path  =  slot  |  {slot1 slot2 ... }
	!

!GbtActionAssignVal methodsFor: 'executing' stamp: 'hk 9/4/2017 13:14'!
doOn: aPipe
	| thing   value path setter |
	pipe := aPipe copy.
	value := self getVar: params first.
	path := self ensurePath: params last.
	setter := path last.
	path := path allButLast.
	thing := params size > 2 
		ifTrue: [self thingFromParam: params second]
		ifFalse: [pipe thing ifNil: [pipe context vo]].
	thing := thing atFullPath: path.
	thing perform: setter asMutator with: value.
	^ pipe! !

GbtActionAssign subclass: #GbtActionReadSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionReadSlot commentStamp: 'hk 12/16/2016 18:32' prior: 0!
I assign the slotName content  of the thing or pipe thing to a variable.

Syntax: 	READSLOT   #( thing  path  variable)        path = slot |  # (slot 2 slot 3 ... )
or 		READSLOT   #( path  variable)        		   path = slot |  #( slot 2 slot 3 ... )
!

!GbtActionReadSlot methodsFor: 'executing' stamp: 'hk 9/4/2017 13:14'!
doOn: aPipe
	| context thing path |
	pipe := aPipe copy.
	context := aPipe context.
	thing := params size > 2
		ifTrue: [self thingFromParam: params first] 
		ifFalse: [pipe thing ifNil: [context vo]].
	path := params at: params size -1.
	path := path ifString: [{path}].
	self setVar: params last to: (thing atFullPath: path).
	^ pipe! !

GbtActionAssign subclass: #GbtActionSetSaveCtxt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionSetSaveCtxt commentStamp: 'hk 1/4/2017 17:33' prior: 0!
I change the saveContext of thing

Syntax: 	SAVECONTEXT  #( thing context)  !

!GbtActionSetSaveCtxt methodsFor: 'executing' stamp: 'hk 4/24/2017 16:23'!
doOn: aPipe
	| thing ctxt |
	pipe := aPipe copy.
	thing := (self thingFromParam: params first) ifNil: 
		[^self abort: params first, ' not found' ] ..
	ctxt := (self context: params second) ifNil: 
		[^self abort: params second,' not found'].
	thing saveContext: ctxt.
	^ pipe! !

GbtActionAssign subclass: #GbtActionWriteSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionWriteSlot commentStamp: 'hk 12/15/2016 18:12' prior: 0!
I copy  a variable  to the  slot given by thing and path.
	
Syntax: 	WRITESLOT   #(var thing path)  or 
		WRITESLOT   #(var path)  ,    			where path  =  slot  |  {slot1 slot2 ... }!

GbtActionWriteSlot subclass: #GbtActionAddToList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionAddToList commentStamp: 'hk 9/23/2016 14:02' prior: 0!
I add  a variable  to the  listSlot of the context vo.
the variable contains a thing or a thingName 

Syntax: 	ADD2L   #(variable  listSlot)!

!GbtActionAddToList methodsFor: 'executing' stamp: 'hk 11/6/2017 21:06'!
doOn: aPipe
	| content cvo slotName list |
	pipe := aPipe copy.
	(content := self thingFromParam: params first) ifNil:
		 [^self abort: content,' neither thing nor list'].
	slotName := self getVar: params second.
	cvo := pipe context vo ifNil: [^self abort: 'no context VO'].
	[list := cvo perform: slotName] ifError: [^self abort: slotName, ' is no Ulist'].
	(list isKindOf: GbtNodeList) ifFalse: [^self abort: slotName, ' is no Ulist'].
	list newEntry: content copy.
	^ pipe! !

!GbtActionWriteSlot methodsFor: 'executing' stamp: 'hk 9/4/2017 13:14'!
doOn: aPipe
	| content path setter th |    
	pipe := aPipe copy.
	path := self ensurePath: params last.
	setter := path last.
	path := path allButLast.
	th := params size > 2 
		ifTrue: [self thingFromParam: params second]
		ifFalse: ["pipe thing ifNil: ["pipe context vo"]"].
	th ifNil: [^self abort: 'no thing or context VO'].
	th := th atFullPath: path. 
	content := self getVar: params first.  
	th perform: setter asMutator with: content copy.  
	^ pipe! !

GbtAction subclass: #GbtActionAssureThing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionAssureThing commentStamp: 'hk 9/25/2016 14:50' prior: 0!
I set the thing to be the contextVO ifNil

Syntax: 	ASSURETH  void  !

!GbtActionAssureThing methodsFor: 'executing' stamp: 'hk 9/25/2016 14:54'!
doOn: aPipe
	"assure my thing"
	pipe := aPipe copy.
	pipe thing ifNotNil: [^pipe].
	pipe context vo ifNil: [self abort: 'no context vo'].
	^pipe thing: pipe context vo! !

GbtAction subclass: #GbtActionAssureVO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionAssureVO commentStamp: 'hk 8/29/2016 12:51' prior: 0!
I assign the context vo using aspect and the container context

Syntax: 	ASSUREVO  void  !

!GbtActionAssureVO methodsFor: 'executing' stamp: 'hk 11/23/2017 17:01'!
assureVOfor: aContext
	aContext vo ifNotNil: [^self]. 
	(aContext container isListAc) 
		ifFalse: [aContext setVOFromContainer]
		ifTrue: [self newVOfor: aContext]
! !

!GbtActionAssureVO methodsFor: 'executing' stamp: 'hk 8/29/2016 12:52'!
doOn: aPipe
	"assure my context vo"
	pipe := aPipe copy.
	self assureVOfor: pipe context.
	^pipe ! !

!GbtActionAssureVO methodsFor: 'instance creation' stamp: 'hk 8/29/2016 12:08'!
newVOfor: aContext
	(aContext container isListAc) 
		ifFalse: [^nil].
	aContext vo: (aContext container newEntry) 
! !

GbtActionAssureVO subclass: #GbtActionNewVO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionNewVO commentStamp: 'hk 8/29/2016 15:40' prior: 0!
I  create a new list element in  the context's container 
and assign that new element to my context vo

Syntax: 	NEWVO  void !

!GbtActionNewVO methodsFor: 'executing' stamp: 'hk 10/11/2016 16:37'!
doOn: aPipe
	"create a new vo for the context "
	pipe := aPipe copy.
	(self newVOfor: pipe context) ifNil: 
		[^self abort: pipe context svoName,' not a list context'].
	^pipe ! !

GbtActionAssureVO subclass: #GbtActionSlot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionSlot commentStamp: 'hk 8/29/2016 15:46' prior: 0!
I assure my context vo, thing and getter of the pipe. 
 -   Used for constraints.

Syntax: 	SLOT  getter 			
	!

!GbtActionSlot methodsFor: 'executing' stamp: 'hk 8/29/2016 13:09'!
doOn: aPipe
	"assure thing and getter in the pipe"
	| getter ctxt |
	pipe := aPipe copy.
	getter := self getVar: params first.
	ctxt := pipe context.
	self assureVOfor: ctxt.
	pipe thing: ctxt vo.
	^pipe slot: getter.
! !

GbtAction subclass: #GbtActionBehaviors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionBehaviors commentStamp: 'hk 8/29/2016 15:52' prior: 0!
I execute the named (by keys) parameterless behaviours of the contex.
(only the same pipe thing is available in all called behaviors)

Syntax: 	BEHAVIORS  #(key1 key2 key3 ... )!

!GbtActionBehaviors methodsFor: 'executing' stamp: 'hk 8/23/2016 14:32'!
doOn: aPipe
	pipe := aPipe copy.
	pipe context doBehaviors: params.
	^pipe ! !

GbtActionBehaviors subclass: #GbtActionConstraints
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionConstraints commentStamp: 'hk 8/29/2016 15:52' prior: 0!
I execute the  constraints named by keys

Syntax: 	CONSTRAINTS  #(key1 key2 key3 ...)!

!GbtActionConstraints methodsFor: 'executing' stamp: 'hk 8/23/2016 14:32'!
doOn: aPipe
	pipe := aPipe copy.
	pipe context doConstraints: params.
	^pipe ! !

GbtAction subclass: #GbtActionCheck
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionCheck commentStamp: 'hk 12/16/2016 15:44' prior: 0!
I check the consistency of pipe thing and abort if not consistent

Syntax: 	CHECK  hint
!

!GbtActionCheck methodsFor: 'executing' stamp: 'hk 11/15/2017 17:15'!
doOn: aPipe
	| hint |
	pipe := aPipe copy. 
	hint := self getVar: params first.
	(pipe thing checkConstraints = true) ifTrue: [^pipe].  
	^self abort: pipe thing violationString! !

GbtAction subclass: #GbtActionCommit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionCommit commentStamp: 'hk 12/16/2016 17:26' prior: 0!
I save the contexts workspace, ie context vo and all role things 

Syntax: 	COMMIT  void !

!GbtActionCommit methodsFor: 'as yet unclassified' stamp: 'hk 5/5/2017 19:01'!
doOn: aPipe
	pipe := aPipe copy.
	pipe context store.  
	^ pipe! !

GbtAction subclass: #GbtActionCompose
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionCompose commentStamp: 'hk 12/16/2016 18:05' prior: 0!
I compose the sources:  
- context vo  and 
- all context pool Things 
- all things in vars 
using the declarative

Syntax: 	COMPOSE   declarative   or
		COMPOSE  #(declarative   vars)   where  vars =  var1 { var2 var 3 ... }!

!GbtActionCompose methodsFor: 'executing' stamp: 'hk 5/10/2017 15:36'!
doOn: aPipe
	|vo comb ctxt srcs |
	pipe := aPipe copy.
	ctxt := aPipe context.
	comb := (self declFromVar: params first) ifNil: 
		[^self abort: params first,' not found'].
	srcs := params allButFirst collect: [:p| self thingFromParam: p ].
	comb sources: (ctxt allPoolThings addAll: srcs; yourself). 
	vo := comb transform: ctxt vo. 
	^pipe thing: vo ! !

GbtAction subclass: #GbtActionContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionContext commentStamp: 'hk 8/29/2016 16:19' prior: 0!
I set the new context.

Syntax: 	CONTEXT  context
!

!GbtActionContext methodsFor: 'executing' stamp: 'hk 8/29/2016 16:21'!
doOn: aPipe
	| context  |  
	pipe := aPipe copy.
	context := (self context: params first) ifNil: 
		[^self abort: params first,' not found' ] .
	^pipe context: context! !

GbtAction subclass: #GbtActionEdit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionEdit commentStamp: 'hk 8/29/2016 16:21' prior: 0!
I open an editor on the thing  in variable

Syntax: 	EDIT  variable
	!

!GbtActionEdit methodsFor: 'executing' stamp: 'hk 4/24/2017 16:23'!
doOn: aPipe
	|thing |
	pipe := aPipe copy.
	thing := (self thingFromParam: params first) ifNil: 
		[^self abort: params first, ' not found'] .
	thing edit.
	^pipe ! !

GbtAction subclass: #GbtActionEmbed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionEmbed commentStamp: 'hk 8/29/2016 16:26' prior: 0!
I embed the thing data into the context vo using combinator

Syntax: 	EMBED  #(variable combinator )!

!GbtActionEmbed methodsFor: 'executing' stamp: 'hk 11/23/2017 17:24'!
doOn: aPipe
	|thing comb  |
	pipe := aPipe copy.
	thing := (self thingFromParam: params first) ifNil: 
		[^self abort: params first, ' not found'] .
	comb := (self declFromVar: params second) ifNil: 
		[^self abort: params second,' not found'].   
	pipe context vo embed: thing with: comb.  
	^pipe! !

GbtAction subclass: #GbtActionFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionFilter commentStamp: 'hk 8/22/2016 13:45' prior: 0!
I filter the list with the  constraint

Syntax: 	FILTER   constraint !

!GbtActionFilter methodsFor: 'executing' stamp: 'hk 5/10/2017 15:14'!
doOn: aPipe
	| filter res |
	pipe := aPipe copy.
	(filter := self thingFromParam: params first) ifNil: 	
		[^self abort: filter, ' not found'].
	res := filter filter: pipe list .  
	^ pipe list: res! !

GbtAction subclass: #GbtActionFreeze
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionFreeze commentStamp: 'hk 2/11/2017 16:12' prior: 0!
I freeze all calc slots of my input, i.e. make val slots of these
if I work on a list, the result list is frozen.
If I work on a thing, the result is in pipe thing

Syntax: 	FREEZE   target          target =   list  | thing   |  contextVO  |  a variable ...!

!GbtActionFreeze methodsFor: 'executing' stamp: 'hk 4/24/2017 16:23'!
doOn: aPipe
	|th|
	pipe := aPipe copy. 
	params first = #list ifTrue:
		[^pipe list: (pipe list collect: [:e| e copyFreeze])] .
	th := self thingFromParam: params first.
	^pipe thing: th copyFreeze
! !

GbtAction subclass: #GbtActionGetEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionGetEvent commentStamp: 'hk 8/29/2016 16:52' prior: 0!
I read the event with content of type in thingVar and put it into the pipe

Syntax: 	GETEVENT  thingVar!

!GbtActionGetEvent methodsFor: 'executing' stamp: 'hk 8/29/2016 16:51'!
doOn: aPipe
	| context thing ext type|
	pipe := aPipe copy.
	type := self getVar: params first.
	context := aPipe context.
	context eventQueue forType: type do: 
		[:evt| thing := evt content. ext := evt isExternal].
	thing ifNil: [^self abort: nil "empty event" ].  
	^pipe thing: thing ; external: ext! !

GbtAction subclass: #GbtActionHalt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionHalt commentStamp: 'hk 12/16/2016 15:48' prior: 0!
I am used for debugging

Syntax: 	HALT  hint
!

!GbtActionHalt methodsFor: 'executing' stamp: 'hk 12/16/2016 15:47'!
doOn: aPipe
	| hint |
	pipe := aPipe copy. 
	hint := self getVar: params first.
	pipe halt: hint, pipe printString. 
	^pipe ! !

!GbtActionHalt methodsFor: 'instance creation' stamp: 'hk 12/16/2016 15:45'!
xfor: anArg
	hint := anArg asSymbol! !

GbtAction subclass: #GbtActionMapBigList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionMapBigList commentStamp: 'hk 8/29/2016 16:54' prior: 0!
I assign the bigList of a context to my list.

Syntax: 	MAPBL  context 
	
related to MAP!

GbtActionMapBigList subclass: #GbtActionMap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionMap commentStamp: 'hk 8/29/2016 16:57' prior: 0!
I assign the Ulist slot of varThing to my list.

Syntax: 	MAP   #(varThing  slot)
	
related to MAPBL!

!GbtActionMap methodsFor: 'executing' stamp: 'hk 4/24/2017 16:23'!
doOn: aPipe
	|  slotname thing ulist |
	pipe := aPipe copy.
	thing := (self thingFromParam: params first) ifNil:
		[^self abort: params first,' not found'].
	slotname := self getVar: params second.  
	ulist := [thing perform: slotname] ifError: [thing].
	^pipe list: ulist list! !

!GbtActionMapBigList methodsFor: 'executing' stamp: 'hk 6/7/2017 10:53'!
doOn: aPipe
	| context |
	pipe := aPipe copy.
	context := (self primeListContext: params first) 
		ifNil: [^self abort: params first,' not found'].
	^pipe list: context getList! !

GbtAction subclass: #GbtActionMatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionMatch commentStamp: 'hk 8/30/2016 10:04' prior: 0!
I match the bizId in the slot of  thing with my list context's list elements. 
If none is found, I create a new list element. 

Syntax: 	MATCH #( thing  slot) 				slot holds  a bizId to match!

!GbtActionMatch methodsFor: 'executing' stamp: 'hk 4/24/2017 16:23'!
doOn: aPipe
	|context subcontext bizID thing|
	pipe := aPipe copy.
	thing := (self thingFromParam: params first) ifNil: 
		[^self abort: params first,' not a thing'].
	bizID := [thing perform: params second asSymbol] ifError: [].
	context := (self listContext: #context) ifNil: 
		[^self abort: 'no list context']. 
	"find the process with bizID or create it and assign it to subcontext"
	subcontext := self subcontextWith: bizID of: context .
	^pipe context: subcontext! !

!GbtActionMatch methodsFor: 'executing' stamp: 'hk 12/19/2016 17:30'!
subcontextWith: bizID of: context
	"side effects for pipe new and the process found"
	| subcontext found process  |
	subcontext := context subcontext.
	found := context processWithBizId: bizID. 	"bizId may be nil"
	process := found first.
	subcontext vo: process.
	found second ifTrue: [subcontext createHook: process] .  
	(pipe external = true) ifTrue:	
		[process setDataPending].
	pipe new: found second.
	^subcontext! !

GbtAction subclass: #GbtActionPDF
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionPDF commentStamp: 'hk 8/23/2016 13:20' prior: 0!
I fill a given (source) pdf form with the data from my inThing and create target

Syntax: TOPFD  #( filename   slotnameOfLabelStickerThing)
!

!GbtActionPDF methodsFor: 'executing' stamp: 'hk 8/1/2017 17:04'!
doOn: aPipe
	| thing target pdfContent |  
	pipe := aPipe copy.
	target := params first.
	pdfContent := params second.
	thing := pipe thing.
	thing ifNil: [^self abort: self actionName,' nothing to paste'].   
	GbtService 
		pdfLabel: target 
		with: ((thing slotSVOAt: pdfContent) leafSVOs collect: [:s| s asString]).
	^ pipe! !

GbtAction subclass: #GbtActionPushTo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionPushTo commentStamp: 'hk 8/30/2016 10:28' prior: 0!
I attach a new event with the thing or pipe thing to the  context eventQueue .

Syntax: 	PUSHTO  context    or   PUSHTO  #(thing  context)!

!GbtActionPushTo methodsFor: 'executing' stamp: 'hk 4/24/2017 16:23'!
doOn: aPipe
	| thing context ext|  
	pipe := aPipe copy.
	thing := (params size > 1)
		ifTrue: [self thingFromParam: params first] 
		ifFalse: [pipe thing].
	thing ifNil: [^self abort: ' no thing to push']. 
	context := (self context: params last) ifNil: 
		[^self abort: 'no target context' ] .
	ext := aPipe external.
	context receive: ((GbtEvent command: thing) external: ext).
	^pipe context: context ! !

GbtAction subclass: #GbtActionReduce
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionReduce commentStamp: 'hk 8/30/2016 11:02' prior: 0!
I assign  the list elements to the Ulist slotName of the thing or the  context vo.
see also ActionAddToBigList

Syntax: 	REDUCE  #(thing slotname)!

!GbtActionReduce methodsFor: 'executing' stamp: 'hk 4/24/2017 16:23'!
doOn: aPipe
	| context list thing slotname |
	pipe := aPipe copy.
	slotname := params second asSymbol.
	context := aPipe context.
	thing := (self thingFromParam: params first) ifNil: 
		[^self abort: params first,' not found'] .
	list := pipe list.
	pipe list do: [:e| (thing slotSVOAt: slotname) newEntry: e].
	context refreshUI. 
	^ pipe! !

GbtActionReduce subclass: #GbtActionReduceAdd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionReduceAdd commentStamp: 'hk 8/30/2016 11:12' prior: 0!
I add  the list elements to the Ulist slotName of the thing
see also ActionAddToBigList

Syntax: 	REDADD #(thing slotname)!

!GbtActionReduceAdd methodsFor: 'executing' stamp: 'hk 5/5/2017 19:32'!
doOn: aPipe
	| thing slotname ulist  |
	pipe := aPipe copy.  
	slotname := params second asSymbol.
	thing := (self thingFromParam: params first) ifNil: 
		[^self abort: params first,' not found'] .
	ulist := thing perform: slotname .
	pipe list do: [:e| ulist newEntry: e].
	thing save.
	pipe context refreshUI. 
	^ pipe! !

GbtAction subclass: #GbtActionRefresh
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionRefresh commentStamp: 'hk 8/25/2016 14:16' prior: 0!
I update the GUI for current context .

Syntax: 	REFRESH   void !

!GbtActionRefresh methodsFor: 'executing' stamp: 'hk 8/25/2016 14:16'!
doOn: aPipe
	pipe := aPipe copy.
	pipe context refreshUI.
	^ pipe! !

GbtAction subclass: #GbtActionSendTo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionSendTo commentStamp: 'hk 8/22/2016 19:41' prior: 0!
final action - I bizNet send a new event with my thing to the receiver as defined  by the path on my context vo.
a prototype hack. has to be unified with sendTo.

Syntax: 	SENDTO  #(path )  		path = slot1 slot2 slot3 ... 
				
to do: 
in BizNet the receiver is identified not by its company  name but its bizNetID
what about an internal sendTo ?  one might specify a contexct !!!

!GbtActionSendTo methodsFor: 'executing' stamp: 'hk 9/4/2017 13:14'!
doOn: aPipe
	| thing rec ev path |  
	pipe := aPipe copy.
	path := params.
	((thing := pipe thing) isKindOf: GbtSmartNode) ifFalse: 
		[^self abort: self actionName,' nothing to send'].
	rec := aPipe context vo atFullPath: path.
	ev := (GbtEvent command: thing) receiver: rec.
	pipe context notify: (GbtBizNetMockUp send: ev) .
	^pipe! !

GbtAction subclass: #GbtActionToList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionToList commentStamp: 'hk 8/30/2016 11:46' prior: 0!
I am a final action for external events - add the var to the current context's list
I mark context and thing as changed.

Syntax: 	TOLIST  var
	!

!GbtActionToList methodsFor: 'executing' stamp: 'hk 4/24/2017 16:23'!
doOn: aPipe
	| thing |
	pipe := aPipe copy.
	thing := (self thingFromParam: params first) ifNil:
		[^self abort: params first,' missing'].
	pipe context isListAc ifFalse: 
		[^self abort: ' no list context'].
	pipe context newEntry: thing.
	(pipe external = true) ifTrue: [thing setDataPending].
	^pipe! !

Object subclass: #GbtActionPipe
	instanceVariableNames: 'context new external abort thing variables list slot userName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtActionPipe commentStamp: 'hk 11/7/2016 19:53' prior: 0!
I define the action pipe objects .
Context, new, external must always be there.

    Instance Variables
	context:		<ActiveContextVO>		to be operated in, includes context vo
	external:		<Boolean|nil>			origin of this action, true if external
	new:		<Boolean|nil>			for matches: no hit --> creation; new = true
	thing:		<ThingVO|nil|String>		 content to be processed
	slot: 		<Symbol | nil>			a slotname - used for constraints
	list:			<Coll of ThingVO|nil|>		list to be processed
	abort: 		<String|nil>				error string;         self abort = Boolean
	variables: 	<OrderedIdentityDictionary>	of named stored Things or values (arguments)
	userName:  	<String>					 aName !

!GbtActionPipe class methodsFor: 'instance creation' stamp: 'hk 11/7/2016 19:53'!
thing: aThing context: aContext new: bool1 ext: bool2 
	^self new 	
		thing: aThing;
		context: aContext;
		user: aContext user;
		new: bool1;
		external: bool2! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 1/6/2016 12:54'!
abort
	^abort isNotNil! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 1/6/2016 13:59'!
abort: aString
	abort := aString.
	aString ifNotEmpty: [context notify: aString]! !

!GbtActionPipe methodsFor: 'accessing arguments' stamp: 'hk 8/24/2016 17:22'!
addArgs: argArray for: nameArray
	argArray ifEmpty: [^self].
	nameArray size < argArray size ifTrue: [^self notify: 'not enough arguments defined'].
	1 to: argArray size do: [:i| self setVar: (nameArray at: i) to: (argArray at: i)].
! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 12/30/2015 14:04'!
context
	^ context! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 12/30/2015 14:10'!
context:  anActiveContextVO
	context  := anActiveContextVO! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 12/30/2015 14:04'!
external
	^ external! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 12/30/2015 14:09'!
external: aBoolean
	external := aBoolean! !

!GbtActionPipe methodsFor: 'accessing variables' stamp: 'hk 5/5/2017 19:47'!
getVar: aName 
	aName = #thing ifTrue: [^self thing].
	aName = #contextVO ifTrue: [^self context vo].
	^self variables at: aName ifAbsent: []! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 8/18/2016 11:28'!
list
	^ list! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 8/18/2016 13:07'!
list: aListOfThings
	list := aListOfThings ! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 12/30/2015 14:04'!
new
	^ new! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 12/30/2015 14:09'!
new: aBoolean
	new := aBoolean! !

!GbtActionPipe methodsFor: 'printing' stamp: 'hk 7/14/2017 16:27'!
printString 
	^ 'Context: ', context svoName, ', Vars: ', variables printString! !

!GbtActionPipe methodsFor: 'accessing variables' stamp: 'hk 8/24/2016 17:23'!
setVar: aName to: anObject
	self variables add: aName asSymbol -> anObject! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 8/23/2016 13:32'!
slot
	^ slot! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 8/23/2016 13:32'!
slot: aSymbol
	slot := aSymbol asSymbol! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 6/1/2016 10:39'!
thing
	^ thing! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 8/18/2016 11:27'!
thing: aGbtThing
	thing := aGbtThing! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 11/8/2016 09:37'!
user
	^userName ifNil: [ '' ]! !

!GbtActionPipe methodsFor: 'accessing' stamp: 'hk 11/7/2016 19:52'!
user: aName
	userName := aName ! !

!GbtActionPipe methodsFor: 'accessing variables' stamp: 'hk 7/27/2016 17:49'!
variables
	^variables ifNil: [ variables := OrderedIdentityDictionary new ]! !

Object subclass: #GbtBizNetMockUp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Messaging'!

GbtBizNetMockUp class
	instanceVariableNames: 'pollProcess pollProcesses'!

!GbtBizNetMockUp commentStamp: 'hk 11/11/2016 13:41' prior: 0!
I am the BizNet mockup.

protocol:
-  register (in order to receive events) 
-  send  (events)

    class instance variables:
	pollProcesses 		<Coll of Process> 		per company
											started on registering (at app startup), 
											receives all events!

GbtBizNetMockUp class
	instanceVariableNames: 'pollProcess pollProcesses'!

!GbtBizNetMockUp class methodsFor: 'accessing' stamp: 'hk 1/9/2018 14:00'!
messageDir
	^GbtServer default messageDir ! !

!GbtBizNetMockUp class methodsFor: 'error handling' stamp: 'hk 11/1/2016 14:59'!
notifyA: anArrayOfString
	self notify: (String withAll: (anArrayOfString flatCollect: [:s|s]))
! !

!GbtBizNetMockUp class methodsFor: 'protocol' stamp: 'hk 8/16/2017 17:21'!
poll: aCompany to: aContext
	| processedFiles |
	processedFiles := OrderedCollection new.
	(self messageDir / aCompany ) children do: 
		[ :c |   |fileContent th|
		fileContent := c readStreamDo: [ :stream | stream contents ] .
		[th := (GbtSmartNode fromString: fileContent).
		th content registerWith: aContext bizApp.
		aContext receive: th.
		processedFiles add: c ] 
			ifError: [self notifyA: {'could not process message: '. c basename. #from. c creationTime asString}]].
	processedFiles copy do: [ :c | (processedFiles remove: c) delete ]! !

!GbtBizNetMockUp class methodsFor: 'accessing' stamp: 'hk 11/10/2016 14:54'!
pollProcesses
	^pollProcesses ifNil: [pollProcesses := Dictionary new]! !

!GbtBizNetMockUp class methodsFor: 'protocol' stamp: 'hk 2/5/2017 14:24'!
registerCompany: aCompany with: aContext
	"self register: 'ABCcompany' 
	received things are put in the contextVOs of aContext"
	
	(self messageDir / aCompany) ensureCreateDirectory .	
	self pollProcesses add: aCompany -> [[true] whileTrue: 
		[(Delay forSeconds: 1) wait. self poll: aCompany to: aContext]
			] fork

! !

!GbtBizNetMockUp class methodsFor: 'protocol' stamp: 'hk 9/18/2017 14:51'!
send: anEvent 
	| dir rec |
	anEvent stonify; external: true.
	(rec := anEvent receiver) isString ifFalse: [ ^ 'receiver not a String' ] .
	(rec := anEvent receiver) isEmpty ifTrue: [ ^ 'receiver is empty' ] .
	(dir := self messageDir / rec ) exists ifTrue: [ self write: anEvent to: dir ] ifFalse: [ ^rec, ' is not registered'  ].
	^'done'
! !

!GbtBizNetMockUp class methodsFor: 'protocol' stamp: 'hk 11/10/2016 14:56'!
stopPolling
	"BizNet stopPolling"
	self pollProcesses valuesDo: [:p| p terminate].
	pollProcesses := nil! !

!GbtBizNetMockUp class methodsFor: 'protocol' stamp: 'hk 2/6/2017 20:32'!
write: anEvent to: aFileReference
	"serialize aThing and write it to the directory aFileReference"   
	(aFileReference / anEvent eventType)  writeStreamDo: [ :stream | stream nextPutAll: anEvent toString ].! !

Object subclass: #GbtCell
	uses: TGbtBareID
	instanceVariableNames: 'container id cache frozen inputValue uiClassName templates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Things'!

GbtCell class
	uses: TGbtBareID classTrait
	instanceVariableNames: 'bareID'!

!GbtCell commentStamp: 'hk 11/27/2017 21:18' prior: 0!
I am a typeless  leaf in a Behavior.
My subclasses are typed leafs  in Things


    Instance Variables
	id:				<Integer>
	container		<GbtSmartNode>		the node I am in
	inputValue:		<String>        			 the  expression to be evaluated
	cache:			<Association>		the evaluated output value with evolveCount as key
	frozen 			<nil | true> 			can be frozen once !!
	uiClassName 	<Symbol> 			name of uiClass other than the default


Implementation Points
I double the container protocol of GbtObject

!

GbtCell class
	uses: TGbtBareID classTrait
	instanceVariableNames: 'bareID'!

GbtCell subclass: #GbtBehaviorCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Things'!

!GbtBehaviorCell commentStamp: 'hk 11/16/2017 11:27' prior: 0!
I am a cell in a behavior 
with a different exeption handling:

in super getValue all errors  are displayed in the cell.
In behaviors a constraint error shall also be displayed in the app.
This is achieved by raising a GbtBehaviorNotification
!

!GbtBehaviorCell methodsFor: 'cache - Parse' stamp: 'hk 12/11/2017 17:04'!
compiler     
	^GbtCielCompiler ! !

!GbtBehaviorCell methodsFor: 'gbtDecompile' stamp: 'hk 12/1/2017 02:08'!
gbtName
	^''! !

!GbtBehaviorCell methodsFor: 'as yet unclassified' stamp: 'hk 11/26/2017 14:33'!
getValue
	"a behavior informs the user of the first cell error"
	
	^[self compile: inputValue] on: Error do: [:ex| 
			GbtBehaviorNotification signal: ex messageText]! !

!GbtCell class methodsFor: 'accessing' stamp: 'hk 9/28/2017 13:21'!
bareID
	^bareID ifNil: [bareID :=0]! !

!GbtCell class methodsFor: 'accessing' stamp: 'hk 9/28/2017 13:15'!
bareID: anInt
	bareID := anInt! !

!GbtCell class methodsFor: 'accessing' stamp: 'hk 8/20/2017 15:05'!
uiClass
	^ GbtStringWidget ! !

!GbtCell class methodsFor: 'instance creation' stamp: 'hk 11/30/2017 17:25'!
withValue: aStringOrArray
	"aString for old authoring code. Parser will always send anArray"
	|res|
	res := self new.
	aStringOrArray isArray 	
		ifTrue:  [res inputValue: aStringOrArray first.
					aStringOrArray allButFirst do: [:t| res addTemplate: t]] 
		ifFalse: [res inputValue: aStringOrArray asString].
	^res  
	! !

!GbtCell methodsFor: 'comparing' stamp: 'hk 8/19/2017 18:10'!
= anotherValueVO
	^anotherValueVO class = self class and: [self inputValue = anotherValueVO inputValue]! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 11/30/2017 16:12'!
addTemplate: aString
	^self templates add: aString ! !

!GbtCell methodsFor: 'cache - Parse' stamp: 'hk 8/19/2017 17:43'!
cache
	^cache value! !

!GbtCell methodsFor: 'cache - Parse' stamp: 'hk 8/19/2017 17:42'!
cache: aValue 
	| evolveCount |
	evolveCount := container ifNil: [] ifNotNil: [container evolveCount].
	cache := evolveCount -> aValue! !

!GbtCell methodsFor: 'cache - Parse' stamp: 'hk 8/23/2017 16:30'!
cacheIsVaild 
	cache ifNil: [^false]. 	"cache must be filled when frozen"
	frozen = true ifTrue: [^true].
	container ifNil: [^false].
	^cache key = container evolveCount! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 6/22/2016 16:17'!
classInitial
	^#L! !

!GbtCell methodsFor: 'cache - Parse' stamp: 'hk 12/12/2017 14:27'!
compile: expr     
	| comp | 
	comp := self compiler new container: self container.
	^comp parse: expr onError: self parseFailBlock! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 12/11/2017 17:04'!
compiler     
	^self subclassResponsibility ! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 8/10/2017 15:56'!
container
	^container ! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 8/10/2017 15:56'!
container: aNode 
	container := aNode! !

!GbtCell methodsFor: 'gbt helper' stamp: 'hk 1/22/2018 19:26'!
debugVal
	| val |
	(val := self val) ifString: [^self inform: val].
	(val isKindOf: GbtFrame) ifTrue: [[val edit] ifError: [val inspect]].
	self getValue ! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 8/10/2017 16:05'!
defaultUiClass
	"default widget class"
	^self class uiClass! !

!GbtCell methodsFor: 'cache - Parse' stamp: 'hk 8/21/2017 20:59'!
freeze
	self val. "fill cache"
	frozen := true! !

!GbtCell methodsFor: 'gbtDecompile' stamp: 'hk 12/1/2017 02:08'!
gbtName
	self subclassResponsibility ! !

!GbtCell methodsFor: 'gbtDecompile' stamp: 'hk 11/3/2017 14:11'!
gbtSlotSource: aName on: aStream
	"return an extra attribute string in addition to the intended side effect"
	aStream nextPutAll: self gbtName; space.
	aStream nextPutAll: aName; tab.
	aStream nextPut: $:; space.
	aStream nextPutAll: self inputValue .
	^''
! !

!GbtCell methodsFor: 'cache - Parse' stamp: 'hk 11/25/2017 16:24'!
getValue
	"a cell informs the user of any error"
	
	^[self compile: inputValue] on: Error do: [:ex| ex messageText]! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 10/29/2017 14:29'!
ghostText
	^self gbtName ! !

!GbtCell methodsFor: 'comparing' stamp: 'hk 8/19/2017 17:50'!
hash
	^self inputValue hash! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 9/28/2017 13:14'!
id: anInt
	id := anInt! !

!GbtCell methodsFor: 'initialization' stamp: 'hk 8/10/2017 16:31'!
initialize
	super initialize.
	self setID! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 10/30/2017 13:39'!
inputValue
	^inputValue ! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 11/30/2017 16:21'!
inputValue: aString   
	inputValue = aString asString ifTrue: [^self].
	self invalidateCache.  
	inputValue := aString asString.
	self addTemplate: inputValue
	! !

!GbtCell methodsFor: 'cache - Parse' stamp: 'hk 11/23/2017 09:09'!
invalidateCache
	(frozen = true) ifFalse: [cache := nil].! !

!GbtCell methodsFor: 'testing' stamp: 'hk 8/22/2017 12:57'!
isConstraint
	^false! !

!GbtCell methodsFor: 'testing' stamp: 'hk 10/30/2017 13:39'!
isFilled
	"used for constraints"
	inputValue ifNil: [^false].
	inputValue isNumber ifTrue: [^inputValue isZero not].
	inputValue isString ifTrue: [^inputValue isNotEmpty].
	^true! !

!GbtCell methodsFor: 'testing' stamp: 'hk 8/10/2017 16:04'!
isNode
	^false! !

!GbtCell methodsFor: 'testing' stamp: 'hk 11/9/2017 12:00'!
isNodeList
	^false! !

!GbtCell methodsFor: 'testing' stamp: 'hk 10/19/2017 13:06'!
isParseMock
	^false! !

!GbtCell methodsFor: 'testing' stamp: 'hk 8/22/2017 13:16'!
isReference
	^false! !

!GbtCell methodsFor: 'testing' stamp: 'hk 8/19/2017 17:40'!
isSmartValue
	^true! !

!GbtCell methodsFor: 'testing' stamp: 'hk 8/10/2017 16:04'!
isThing
	^false! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 11/30/2017 16:05'!
list
	"enum compatibility"
	^self templates asArray! !

!GbtCell methodsFor: 'cache - Parse' stamp: 'hk 8/21/2017 15:36'!
parseFailBlock
	"this block is evaluated on parse failures"
	^[:msg :pos|  msg, ' at: ', pos printString]! !

!GbtCell methodsFor: 'copying' stamp: 'hk 11/30/2017 15:09'!
postCopy
	super postCopy.
	self setID .
	cache := cache copy.
	container := nil.  
	inputValue := inputValue copy.
	templates := templates copy.
	self invalidateCache 
! !

!GbtCell methodsFor: 'printing' stamp: 'hk 10/30/2017 13:39'!
printOn: aStream
	aStream nextPutAll: self classInitial asString.
	aStream nextPutAll: id asString.
	aStream nextPutAll: ': '.
	aStream nextPutAll: (inputValue ifNil: [''])! !

!GbtCell methodsFor: 'printing' stamp: 'hk 5/24/2017 16:16'!
printString
	^self printStringLimitedTo: 33! !

!GbtCell methodsFor: 'printing' stamp: 'hk 10/30/2017 13:39'!
printVal
	^inputValue ifNil: [ '' ]! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 8/10/2017 16:12'!
replaceContainer: aNode 
	self container: aNode! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 9/22/2017 14:20'!
svoName
	"needed by SEL"
	^nil! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 11/30/2017 16:01'!
templates
	^templates ifNil: [templates := Set new]! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 11/27/2017 21:31'!
uiClass
	^ uiClassName ifNil: [ self defaultUiClass  ] ifNotNil: [ Smalltalk at: uiClassName ]! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 11/28/2017 17:40'!
uiClassName: aClassName
	uiClassName := aClassName ! !

!GbtCell methodsFor: 'accessing' stamp: 'hk 11/25/2017 16:07'!
val
	| res | 
	self cacheIsVaild ifTrue: [^self cache].
	res := self getValue.  
	self cache: res.
	^res
! !

GbtCell subclass: #GbtDate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Things'!

!GbtDate commentStamp: 'hk 8/22/2017 13:07' prior: 0!
I am a GbtSmartValue of Date type 


====== Tests ======  see Date class

GbtDate new inputValue:  '2012.06.15'  
GbtDate new inputValue: '6.15.2012' 
GbtDate new inputValue: '6/15/2012' 
GbtDate new inputValue: '15 June 2012'
GbtDate new inputValue: 'June 15 2012'
GbtDate new inputValue: ' 6 15 2012'
GbtDate new inputValue: '2012-06-15'
GbtDate new inputValue: '2012 06 15'

GbtDate new inputValue: Date today  
!

!GbtDate class methodsFor: 'accessing' stamp: 'hk 5/11/2016 12:41'!
uiClass
	^GbtDateWidget! !

!GbtDate class methodsFor: 'instance creation' stamp: 'hk 8/24/2017 18:26'!
withDate: aString
	^ self new inputValue: aString! !

!GbtDate methodsFor: 'cache - Parse' stamp: 'hk 9/17/2017 14:57'!
compiler     
	^GbtSELDateCompiler! !

!GbtDate methodsFor: 'gbtDecompile' stamp: 'hk 10/29/2017 14:25'!
gbtName
	^'date'! !

GbtCell subclass: #GbtNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Things'!

!GbtNumber commentStamp: 'hk 8/22/2017 13:08' prior: 0!
I am a GbtSmartValue of Number type !

!GbtNumber class methodsFor: 'accessing' stamp: 'hk 2/15/2017 11:39'!
uiClass
	^ GbtNumberWidget ! !

!GbtNumber methodsFor: 'cache - Parse' stamp: 'hk 9/17/2017 14:57'!
compiler     
	^GbtSELNumberCompiler ! !

!GbtNumber methodsFor: 'gbtDecompile' stamp: 'hk 10/29/2017 14:26'!
gbtName
	^'no'! !

!GbtNumber methodsFor: 'accessing' stamp: 'hk 8/21/2017 16:47'!
ghostText
	^'number'! !

!GbtNumber methodsFor: 'testing' stamp: 'hk 8/21/2017 16:50'!
isFilled
	"used for constraints"
	[self val isZero not] ifError: [^false]! !

!GbtNumber methodsFor: 'cache - Parse' stamp: 'hk 8/21/2017 15:38'!
parseFailBlock
	^[:msg :pos| GbtPNumberError signal: 'at ', pos printString]! !

GbtCell subclass: #GbtPredicate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Things'!

!GbtPredicate commentStamp: 'hk 8/22/2017 13:05' prior: 0!
I am a GbtSmartValue of Boolean type 

!

GbtPredicate subclass: #GbtConstraintCell
	instanceVariableNames: 'violationString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Things'!

!GbtConstraintCell commentStamp: 'hk 10/30/2017 13:37' prior: 0!
I am a GbtPredicate used as Constraint 

the expression (my value) shall  evaluate to true or false. 
 
    Instance Variables
	violationString:		<String> 	ifNil, the inputValue is used to indicate the violation
!

!GbtConstraintCell methodsFor: 'accessing' stamp: 'hk 11/15/2017 17:24'!
errorString
	^self printVal! !

!GbtConstraintCell methodsFor: 'gbtDecompile' stamp: 'hk 10/29/2017 14:28'!
gbtName
	^'constraint'! !

!GbtConstraintCell methodsFor: 'gbtDecompile' stamp: 'hk 10/30/2017 13:25'!
gbtSlotSource: aName on: aStream
 	super gbtSlotSource: aName on: aStream.
	violationString ifNil: [^''].
	^'ifViolated: ', violationString

	! !

!GbtConstraintCell methodsFor: 'testing' stamp: 'hk 8/22/2017 13:01'!
isConstraint
	^true! !

!GbtConstraintCell methodsFor: 'accessing' stamp: 'hk 8/22/2017 13:01'!
violationString
	^violationString ifNil: self printVal! !

!GbtConstraintCell methodsFor: 'accessing' stamp: 'hk 8/22/2017 13:01'!
violationString: aString
	violationString := aString! !

!GbtPredicate methodsFor: 'cache - Parse' stamp: 'hk 9/17/2017 14:57'!
compiler     
	^GbtSELPredicateCompiler ! !

!GbtPredicate methodsFor: 'gbtDecompile' stamp: 'hk 10/29/2017 14:29'!
gbtName
	^'bool'! !

GbtCell subclass: #GbtReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Things'!

!GbtReference commentStamp: 'hk 8/22/2017 13:10' prior: 0!
I am a GbtSmartValue with a  reference. 
My type is  the reference  type
!

!GbtReference class methodsFor: 'as yet unclassified' stamp: 'hk 7/27/2017 12:29'!
uiClass
	^ GbtStringWidget ! !

!GbtReference methodsFor: 'cache - Parse' stamp: 'hk 9/17/2017 14:57'!
compiler     
	^GbtSELRefCompiler! !

!GbtReference methodsFor: 'gbtDecompile' stamp: 'hk 10/29/2017 14:33'!
gbtName
	^'ref'! !

!GbtReference methodsFor: 'accessing' stamp: 'hk 8/21/2017 21:30'!
ghostText
	^'reference'! !

!GbtReference methodsFor: 'testing' stamp: 'hk 8/22/2017 13:17'!
isReference
	^true! !

GbtCell subclass: #GbtString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Things'!

!GbtString commentStamp: 'hk 8/22/2017 13:11' prior: 0!
I am a GbtSmartValue of string type. 
(no line breaks expected)!

!GbtString methodsFor: 'cache - Parse' stamp: 'hk 9/17/2017 14:57'!
compiler     
	^GbtSELStringCompiler! !

!GbtString methodsFor: 'gbtDecompile' stamp: 'hk 10/29/2017 14:33'!
gbtName
	^'val'! !

!GbtString methodsFor: 'accessing' stamp: 'hk 8/21/2017 21:30'!
ghostText
	^'string'! !

GbtString subclass: #GbtText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Things'!

!GbtText commentStamp: 'hk 8/22/2017 13:14' prior: 0!
I am a GbtSmartValue of text type. 
( line breaks expected)!

!GbtText class methodsFor: 'accessing' stamp: 'hk 5/11/2016 12:41'!
uiClass
	^GbtTextWidget! !

!GbtText methodsFor: 'gbtDecompile' stamp: 'hk 10/29/2017 14:35'!
gbtName
	^'text'! !

!GbtText methodsFor: 'gbtDecompile' stamp: 'hk 1/3/2018 11:02'!
getValue
	"a text will not be compiled"
	
	^ inputValue! !

Object subclass: #GbtCodeSize
	instanceVariableNames: 'vars methods loc classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Utilities'!

!GbtCodeSize commentStamp: 'hk 1/19/2018 12:48' prior: 0!
I help counting classes, LOC, methods and variables.
I can be added and subtracted.  

Instance Variables
	classes:			<Integer>
	loc:				<Integer>
	methods:		<Integer>
	vars:			<Integer>

Machine + Tests + Apps + Tests - Icons:
(GbtCodeSize newOn: (Smalltalk allClasses select: [:cls| cls category beginsWith: 'GBT-DSL' ])) 
-  (GbtCodeSize newOn: GbtIcons )
 a GbtCodeSize: 286 Klassen; 16994 LOC; 455 Variablen; 3084 Methoden 

Machine - Parser:
(GbtCodeSize newOn: (Smalltalk allClasses select: [:cls| cls category beginsWith: 'GBT-DSL-M' ])) 
 a GbtCodeSize: 51 Klassen; 3500 LOC; 131 Variablen; 961 Methoden 

Parser 
 (GbtCodeSize  newOnCategoryOf:  GbtBasicGrammar) 
 a GbtCodeSize: 23 Klassen; 1211 LOC; 215 Variablen; 394 Methoden 
 Klassen; 617 LOC; 11 Variablen; 97 Methoden

UI
(GbtCodeSize newOn: (Smalltalk allClasses select: [:cls| cls category beginsWith: 'GBT-DSL-UI' ])) 
 a GbtCodeSize: 31 Klassen; 2183 LOC; 57 Variablen; 447 Methoden

Tests:
 (GbtCodeSize  newOnCategoryOf:  GbtTests) + 
(GbtCodeSize  newOnCategoryOf:  GbtGUITests) +
(GbtCodeSize  newOnCategoryOf:  GbtClearPermanentTraces ) +
(GbtCodeSize  newOnCategoryOf:  GbtTestBasicGrammar)
 a GbtCodeSize: 63 Klassen; 4033 LOC; 3 Variablen; 523 Methoden 

================ detail ==================

Things:
 (GbtCodeSize newOnCategoryOf: GbtObject) + (GbtCodeSize newOnCategoryOf: GbtSmartNode) +
  (GbtCodeSize newOn: TGbtSerializer)  +    (GbtCodeSize newOn: TGbtEvolve) +   (GbtCodeSize newOn: TGbtThingMeta)
 a GbtCodeSize: 34 Klassen; 1924 LOC; 57 Variablen; 509 Methoden 

Context & Behavior:
 (GbtCodeSize  newOnCategoryOf:  GbtActiveContext) + 
(GbtCodeSize  newOnCategoryOf:  GbtAction) +
(GbtCodeSize  newOnCategoryOf:  GbtDirective) 
 a GbtCodeSize: 57 Klassen; 1879 LOC; 56 Variablen; 429 Methoden 

Runtime & Messaging:
 (GbtCodeSize  newOnCategoryOf:  GbtRuntime) + 
(GbtCodeSize  newOnCategoryOf:  GbtEvent) +
(GbtCodeSize  newOnCategoryOf:  GbtServer) 
 a GbtCodeSize: 11 Klassen; 633 LOC; 44 Variablen; 169 Methoden 

Tools:
 (GbtCodeSize  newOnCategoryOf:  GbtIcons ) -
( GbtCodeSize newOn: {GBTKnowHow . GbtIcons . SvoCalc })
 a GbtCodeSize: 4 Klassen; 239 LOC; 7 Variablen; 35 Methoden 

Icons:
 GbtCodeSize newOn: GbtIcons 
 a GbtCodeSize: 1 Klassen; 7756 LOC; 1 Variablen; 126 Methoden

App InsideTransport with Test:
 (GbtCodeSize  newOnCategoryOf: GCMain) + 
 (GbtCodeSize  newOnCategoryOf: IntegrationTestThings) + 
(GbtCodeSize  newOnCategoryOf: GCDirectives )  
 a GbtCodeSize: 38 Klassen; 2840 LOC; 2 Variablen; 384 Methoden 

App Rolodex:
 (GbtCodeSize  newOn: Rolodex  ) 
 a GbtCodeSize: 1 Klassen; 53 LOC; 0 Variablen; 8 Methoden 

App LittleCompany + HelloWorld:
 (GbtCodeSize  newOnCategoryOf: Rolodex )  
 a GbtCodeSize: 4 Klassen; 138 LOC; 0 Variablen; 23 Methoden 

InsideTransport AppTests:
GbtCodeSize  newOnCategoryOf: GbtApplicationTest
 a GbtCodeSize: 4 Klassen; 637 LOC; 1 Variablen; 114 Methoden 

App EFA:
 (GbtCodeSize  newOnCategoryOf: EFA) 
 a GbtCodeSize: 15 Klassen; 1125 LOC; 0 Variablen; 86 Methoden 

App BuddyWallet:
 (GbtCodeSize  newOnCategoryOf: BuddyWallet )  
 a GbtCodeSize: 1 Klassen; 222 LOC; 0 Variablen; 16 Methoden 

App Forum:
 (GbtCodeSize  newOnCategoryOf: GbtForumA  )  
 a GbtCodeSize: 2 Klassen; 94 LOC; 0 Variablen; 13 Methoden 

App SDE
 (GbtCodeSize  newOnCategoryOf: GbtSdeCompiler  )  
 a GbtCodeSize: 2 Klassen; 269 LOC; 0 Variablen; 11 Methoden
!

!GbtCodeSize class methodsFor: 'instance creation' stamp: 'hk 5/6/2015 11:22'!
newOn: aClassOrCollectionOfClasses

	| size |
	(aClassOrCollectionOfClasses isCollection) 
		ifFalse: [^self new sizeOfClass: aClassOrCollectionOfClasses].
	size := self newOn: (aClassOrCollectionOfClasses first).
	aClassOrCollectionOfClasses allButFirst do: [:cls| size + (self newOn: cls)].
	^size! !

!GbtCodeSize class methodsFor: 'instance creation' stamp: 'hk 5/13/2010 14:48'!
newOnCategoryOf: aClass

	^self new sizeOfCategory: aClass! !

!GbtCodeSize class methodsFor: 'instance creation' stamp: 'hk 9/20/2016 12:31'!
newOnHierarchyOf: aClass
	^(self newOn: aClass) + (self new sizeOfSubclassesOf: aClass)! !

!GbtCodeSize methodsFor: 'arithmetic' stamp: 'hk 2/10/2015 13:25'!
+ anSvoCodeSize

	vars := vars + (anSvoCodeSize vars).
	methods  := methods + (anSvoCodeSize methods).
	loc := loc + (anSvoCodeSize loc).
	classes := classes + (anSvoCodeSize classes).! !

!GbtCodeSize methodsFor: 'arithmetic' stamp: 'hk 2/10/2015 13:25'!
- anSvoCodeSize

	vars := vars - (anSvoCodeSize vars).
	methods  := methods - (anSvoCodeSize methods).
	loc := loc - (anSvoCodeSize loc).
	classes := classes - (anSvoCodeSize classes).! !

!GbtCodeSize methodsFor: 'accessing' stamp: 'hk 5/10/2010 23:42'!
classes
	^classes! !

!GbtCodeSize methodsFor: 'initialization' stamp: 'hk 9/20/2016 11:31'!
initialize
	super initialize.
	loc := 0.
	vars := 0.
	methods := 0.
	classes := 0.
! !

!GbtCodeSize methodsFor: 'accessing' stamp: 'hk 5/10/2010 19:18'!
loc
	^loc! !

!GbtCodeSize methodsFor: 'accessing' stamp: 'hk 5/10/2010 19:17'!
methods
	^methods! !

!GbtCodeSize methodsFor: 'printing' stamp: 'hk 11/9/2016 15:14'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: ': ';
		nextPutAll: classes printString, ' Klassen; ';
		nextPutAll: loc printString, ' LOC; ';
		nextPutAll: vars printString, ' Variablen; ';
		nextPutAll: methods printString, ' Methoden'
	! !

!GbtCodeSize methodsFor: 'initialization' stamp: 'hk 11/9/2016 13:30'!
sizeOfCategory: aClass

	(SystemOrganization listAtCategoryNamed: aClass category)
		do: [:cls | self + (self class newOn:(Smalltalk at: cls)) ].
! !

!GbtCodeSize methodsFor: 'initialization' stamp: 'hk 11/9/2016 14:47'!
sizeOfClass: aClass
	loc := aClass linesOfCode .  
	vars := ((aClass instVarNames size) + (aClass classVarNames size) + (aClass class instVarNames size)).
	methods := aClass numberOfMethods .
	classes := 1.! !

!GbtCodeSize methodsFor: 'initialization' stamp: 'hk 11/9/2016 13:30'!
sizeOfSubclassesOf: aClass

	aClass subclassesDo: [:cls |self + (self class newOn: cls)]! !

!GbtCodeSize methodsFor: 'accessing' stamp: 'hk 5/10/2010 19:17'!
vars
	^vars ! !

Object subclass: #GbtEvent
	uses: TGbtSerializer
	instanceVariableNames: 'msgType eventType sender receiver content replyContext external'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Messaging'!

!GbtEvent commentStamp: 'hk 12/7/2015 15:18' prior: 0!
I am an event / a message  in an ActiveService or in BizNet.

    Instance Variables
	content:		<ThingVO>
	msgType:	<String>		#request, #reply, #command, #notification
	eventType:	<String>		Thing userName
	receiver:		<String>		e.g. Company Name or BizNetId
	sender:		<String>		e.g. Company Name or BizNetId
	replyContext:<String>		(request, reply only)  local context userName
	external: 	<Boolean> !

GbtEvent class
	uses: TGbtSerializer classTrait
	instanceVariableNames: ''!

!GbtEvent class methodsFor: 'instance creation' stamp: 'hk 10/11/2016 16:37'!
command: aThing
	^self new 	
		content: aThing;
		msgType: #command;
		eventType: aThing svoName ! !

!GbtEvent class methodsFor: 'deserializing' stamp: ''!
fromString: aSerializedNode 
	^STON fromString: aSerializedNode ! !

!GbtEvent class methodsFor: 'instance creation' stamp: 'hk 10/11/2016 16:37'!
notification: aThing
	^self new 	
		content: aThing;
		msgType: #notification;
		eventType: aThing svoName ! !

!GbtEvent class methodsFor: 'instance creation' stamp: 'hk 10/11/2016 16:37'!
request: aThing
	^self new 	
		content: aThing;
		msgType: #request;
		eventType: aThing svoName ! !

!GbtEvent class methodsFor: 'instance creation' stamp: 'hk 10/11/2016 16:37'!
response: aThing
	^self new 	
		content: aThing;
		msgType: #response;
		eventType: aThing svoName ! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
content
	^ content! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 9/18/2017 14:49'!
content: anObject
	content := anObject ! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
eventType
	^ eventType! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
eventType: anObject
	eventType := anObject! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 12/7/2015 15:18'!
external: aBoolean
	external := aBoolean ! !

!GbtEvent methodsFor: 'testing' stamp: 'hk 11/2/2016 15:26'!
isExternal
	^external ifNil: [false]! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
msgType
	^ msgType! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
msgType: anObject
	msgType := anObject! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
receiver
	^ receiver! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
receiver: anObject
	receiver := anObject! !

!GbtEvent methodsFor: 'save - retrieve - remove' stamp: 'hk 11/29/2016 16:49'!
registerWithStore
	"not for events"! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
replyContext
	^ replyContext! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
replyContext: anObject
	replyContext := anObject! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
sender
	^ sender! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 10/25/2015 18:03'!
sender: anObject
	sender := anObject! !

!GbtEvent methodsFor: 'serializing' stamp: ''!
serializedNodes2Store
	^self versionedNodes2Store collect: [:n| n stripped toString]
! !

!GbtEvent methodsFor: 'accessing' stamp: 'hk 9/18/2017 14:49'!
stonify
	content := content copyForSton! !

!GbtEvent methodsFor: 'serializing' stamp: ''!
toString
	^STON toStringPretty: self! !

Object subclass: #GbtEventQueue
	instanceVariableNames: 'queue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Messaging'!

!GbtEventQueue commentStamp: 'hk 10/25/2015 19:03' prior: 0!
I am the eventQueue of a context.
Preliminary I am implemented with an OrderedCollection!

!GbtEventQueue methodsFor: 'queue' stamp: 'hk 12/9/2015 12:20'!
forType: typeName do: aBlock 
	"execute and consume the event"
	| evt |
	evt := queue detect: [:ev | ev eventType = typeName] ifNone: [^self].
	aBlock value: evt.
	queue remove: evt! !

!GbtEventQueue methodsFor: 'initialization' stamp: 'hk 10/24/2015 16:56'!
initialize
	super initialize.
	queue :=	OrderedCollection new .
! !

!GbtEventQueue methodsFor: 'queue' stamp: 'hk 12/7/2015 15:16'!
push: aSVOEvent
	queue add: aSVOEvent .! !

Object subclass: #GbtExecutable
	instanceVariableNames: 'contexts fullThings policies thingCache tecNoPolicy reader mainCtxtName directives server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Server'!

!GbtExecutable commentStamp: 'hk 1/8/2018 19:17' prior: 0!
I hold all artefacts generated by compiling a Gbt program and as such executable - plus  the thing Cache.
I am filled on demand after a successful compile and copied to the user BizApp on start of a user app.

    Instance Variables
	server: 			<GbtServer>
	declaratives:		<Dictionary > 	svoName 	->  	GbtDeclarative
	contexts:		<Dictionary > 	svoName 	->  	GbtActiveContext 
	fullThings:		<Dictionary > 	svoName 	->  	GbtThing  (full things only)
	policies: 			<Dictionary > 	context svoName 	->  	 GbtNoPolicy  (filled by default)
	thingCache:		<Dictionary > 	svoName 	->  	Collection of GbtThing  by id and version
	tecNoPolicy: 		<GbtNoPolicy >	for the technical thing id
	reader: 			<GbtReader>		similar to a Datomic reader
	mainCtxtName: 	<String> 		svoName of main context (to be opened)!

!GbtExecutable class methodsFor: 'instance creation' stamp: 'hk 1/8/2018 20:30'!
newOn: aServer
	^self basicNew server: aServer; initialize! !

!GbtExecutable methodsFor: 'program store' stamp: 'hk 5/24/2017 14:37'!
add: anSVO full: aFullVO
	" Things only "
	(self thingsAt: anSVO svoName) addLast: anSVO.  
	fullThings at: aFullVO svoName 
		ifPresent: [self inform: aFullVO svoName, ' created again'] 
		ifAbsent: [fullThings at: aFullVO svoName put: aFullVO] 
! !

!GbtExecutable methodsFor: 'program store' stamp: 'hk 6/7/2017 13:33'!
addAC: anAC  
	contexts at: anAC svoName ifPresent: 
		[ self inform: 'context ', anAC svoName, ' added again'].		
	mainCtxtName  := anAC svoName. "the last entry wins"
	^contexts  at: anAC svoName put: anAC 
! !

!GbtExecutable methodsFor: 'program store' stamp: 'hk 9/24/2017 15:54'!
addDirective: anSVO 
	directives at: anSVO svoName ifPresent: 
		[self error: 'Directive exists'].		
	^directives at: anSVO svoName put: anSVO 
! !

!GbtExecutable methodsFor: 'program store' stamp: 'hk 3/15/2017 15:12'!
allContexts
	^contexts values asOrderedCollection! !

!GbtExecutable methodsFor: 'program store' stamp: 'hk 9/24/2017 15:53'!
allDirectives
	^directives values asOrderedCollection! !

!GbtExecutable methodsFor: 'template editor' stamp: 'hk 11/30/2017 15:20'!
allFsvosWithTemplates
	"answer all full things with templates for the template editor"
	^fullThings values
		select: [ :th | th slotValues anySatisfy: [ :a | a thingTemplates isNotEmpty ] ]! !

!GbtExecutable methodsFor: 'program store' stamp: 'hk 1/11/2018 12:12'!
allFullThings
	^fullThings values asOrderedCollection! !

!GbtExecutable methodsFor: 'program store' stamp: 'hk 3/21/2017 12:53'!
allThings
	^thingCache values flatCollect: #yourself as: OrderedCollection! !

!GbtExecutable methodsFor: 'program store' stamp: 'hk 3/15/2017 15:13'!
contextNamed: anACname  ifAbsent: absentBlock
	^contexts at: anACname ifAbsent: [^absentBlock value].! !

!GbtExecutable methodsFor: 'private' stamp: 'hk 3/15/2017 15:23'!
contextNoPolicyOf: anACname  
	^policies at: anACname ifAbsentPut: [GbtNoPolicy new]! !

!GbtExecutable methodsFor: 'program store' stamp: 'hk 9/24/2017 15:48'!
directiveNamed: aName ifAbsent: absentBlock
	^directives at: aName ifAbsent: [^absentBlock value]  ! !

!GbtExecutable methodsFor: 'initialization' stamp: 'hk 1/8/2018 20:31'!
initialize    
	contexts := Dictionary new: 4 .
	policies := Dictionary new: 4 .
	directives := Dictionary new: 4 .
	fullThings := Dictionary new: 4 .
	thingCache := Dictionary new: 4 .
	tecNoPolicy := GbtNoPolicy  new 	
		last: SmallInteger maxVal;
		yourself .
	reader := GbtReader newOn: server. 

! !

!GbtExecutable methodsFor: 'accessing' stamp: 'hk 3/22/2017 12:07'!
mainCtxtName
	^mainCtxtName! !

!GbtExecutable methodsFor: 'accessing' stamp: 'hk 6/6/2017 17:41'!
mainCtxtName: aCtxtName
	mainCtxtName := aCtxtName ! !

!GbtExecutable methodsFor: 'accessing' stamp: 'hk 3/21/2017 13:59'!
reader
	^reader  ! !

!GbtExecutable methodsFor: 'analysis' stamp: 'hk 3/20/2017 12:49'!
rootFullThings
	"self rootFullThings"
	^(thingCache values flatCollect: [ :c | c collect: [:e|e fullThing]] as: Set)
		select: [:e| e isNotNil and: [e container isNil]]
	
! !

!GbtExecutable methodsFor: 'analysis' stamp: 'hk 10/13/2017 13:55'!
selectedNodesInHierarchy
	"user selects one tree - or all "
	"self selectedNodesInHierarchy"
	| sel roots |
	roots := self rootFullThings asArray.
	sel := UIManager default 
				chooseFrom: (roots collect: [:e|e svoName]) 
				values:  roots 
				message: 'select a root full Thing or cancel for all'.
	sel ifNotNil: [roots := {sel}].
	^roots flatCollect: [:n| n allStructureNodes  ]! !

!GbtExecutable methodsFor: 'accessing' stamp: 'hk 1/8/2018 19:19'!
server: aServer
	server := aServer   ! !

!GbtExecutable methodsFor: 'accessing' stamp: 'hk 3/20/2017 17:41'!
tecNoPolicy
	^tecNoPolicy! !

!GbtExecutable methodsFor: 'thing cache' stamp: 'hk 9/7/2017 15:17'!
thingDefinedAs: aName ifAbsent: absentBlock
	"answer the svo with aName = svoName:id-version or svoName(with lowest id-version)"

	|thingColl nm idv arr |
	nm := aName. 
	idv := nil.
	aName ifNotNil: 
		[arr := aName substrings: ':'.
		arr size > 1 ifTrue: 
			[nm := arr first.
			idv := arr second]].
	thingColl := (self thingsAt: nm) ifEmpty: [^absentBlock value].
	idv ifNil: [^thingColl first].		"^ the oldest one"
	^thingColl detect: [:e| e autoName = idv] ifNone: [absentBlock value]
	! !

!GbtExecutable methodsFor: 'initialization' stamp: 'hk 3/20/2017 12:27'!
thingsAt: aSvoName
	^thingCache at: aSvoName ifAbsentPut: [OrderedCollection new]! !

!GbtExecutable methodsFor: 'program store' stamp: 'hk 9/24/2017 15:39'!
type: aType named: aName ifAbsent: aBlock
	aType = #decl ifTrue: [^self directiveNamed: aName ifAbsent: aBlock].
	aType = #thing ifTrue: [^self thingDefinedAs: aName ifAbsent: aBlock].
	aType = #fullThing ifTrue: [^fullThings at: aName ifAbsent: aBlock].
	aType = #context ifTrue: [^self contextNamed: aName ifAbsent: aBlock]
	
! !

!GbtExecutable methodsFor: 'thing cache' stamp: 'hk 3/20/2017 12:41'!
withBizId: aBizId
	"answer the thing with aBizId and the highest version"
	|coll|
	coll := OrderedCollection new. 
	thingCache valuesDo: [:c| coll addAll: (c select: [:e| e bizId = aBizId])]. 
	^coll 
		ifEmpty: [nil] 
		ifNotEmpty: [(coll sorted: [:a :b | b version <= a version]) first] .
! !

Object subclass: #GbtLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Utilities'!

GbtLogger class
	instanceVariableNames: 'started indent tokenDict'!

!GbtLogger commentStamp: 'hk 4/30/2016 18:42' prior: 0!
I log to the transcript:
- with time
- allowing a log token
- and a log text
- and indenting the log!

GbtLogger class
	instanceVariableNames: 'started indent tokenDict'!

!GbtLogger class methodsFor: 'accessing' stamp: 'hk 1/11/2016 19:08'!
indent
	^indent ifNil: [indent := 0]! !

!GbtLogger class methodsFor: 'logging' stamp: 'hk 1/11/2016 19:11'!
log: aToken text: aStringOrArray
	| logArray |
	logArray := aStringOrArray isString ifTrue: [{aStringOrArray}] ifFalse: [aStringOrArray] .
	Transcript cr; show: Time now print24.
	self indent timesRepeat: [Transcript tab] .
	Transcript show: aToken; tab.
	logArray do: [ :s | Transcript show: s printString; tab].
! !

!GbtLogger class methodsFor: 'logging' stamp: 'hk 1/11/2016 19:07'!
logBegin: aToken text: aStringOrArray
	| nooft |
	started = true ifFalse: [ ^self ]. 
	nooft := (self tokenDict at: aToken ifAbsentPut: [0]).
	self tokenDict at: aToken put: nooft +1 .
	indent := self indent +1 .
	self log: 'BEGIN.',aToken text: aStringOrArray! !

!GbtLogger class methodsFor: 'logging' stamp: 'hk 11/1/2016 13:15'!
logEnd: aToken text: aStringOrArray
	| nooft |
	started = true ifFalse: [ ^self ]. 
	nooft := self tokenDict at: aToken ifAbsent: [^Transcript cr; show: 'error: no BEGIN of '; show: aToken].
	self tokenDict at: aToken put: nooft - 1 .
	self log: 'END ',aToken text: aStringOrArray.
	indent := self indent - 1 .! !

!GbtLogger class methodsFor: 'logging' stamp: 'hk 11/8/2016 17:26'!
start
	"SVOLogger start"
	self transcriptWindows ifEmpty:
		[Transcript open 
			setLabel: 'SVO LOG';
			extent: 600 @ 900].
	started := true.
	indent := 0.! !

!GbtLogger class methodsFor: 'logging' stamp: 'hk 11/1/2016 13:16'!
stop
	"SVOLogger stop"
	Transcript cr; show: Time now print24; tab; show: 'STOPPED, indent = '; show: indent asString .
	started := false! !

!GbtLogger class methodsFor: 'accessing' stamp: 'hk 1/11/2016 15:23'!
tokenDict
	^tokenDict ifNil: [tokenDict := Dictionary new]! !

!GbtLogger class methodsFor: 'accessing' stamp: 'hk 11/8/2016 17:24'!
transcriptWindows
	^SystemWindow allInstances select: [:w| w model isKindOf:  ThreadSafeTranscript ]! !

Object subclass: #GbtNoPolicy
	instanceVariableNames: 'prefix getter last bareID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Server'!

!GbtNoPolicy commentStamp: 'hk 3/29/2017 15:17' prior: 0!
I represent any number policy.
My default uses nextStringID without prefix.
next gives the next integer.

    Instance Variables
	bareID:		<Integer>
	last: 		<Integer> 		99 max SmallInteger maxValue
	prefix : 		<String> 		 instance specific for technical id
	getter : 		<Selector>
	svoName: 	<String> 		semantic part of name
!

!GbtNoPolicy methodsFor: 'comparing' stamp: 'hk 8/27/2015 11:15'!
< aPolicyNo
	^self number < aPolicyNo number! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 3/30/2017 12:21'!
adaptTo: anID   
	"used while reading from a database"
	bareID := bareID max: anID squeezeOutNumber		"a very simple strategy"! !

!GbtNoPolicy methodsFor: 'protocol' stamp: 'hk 3/29/2017 15:03'!
alphaCapID
	^self nextAlphaID:  65 
	
	"|gen res| 
	gen := self new getter: #alphaCapID.
	res := gen nextID.
	36 timesRepeat: [res := res,gen nextID].
	res "
! !

!GbtNoPolicy methodsFor: 'protocol' stamp: 'hk 3/29/2017 15:04'!
alphaSmallID
	^self nextAlphaID: 97 
		
	"|gen res| 
	gen := self new getter: #alphaSmallID.
	res := gen nextID.
	36 timesRepeat: [res := res,gen nextID].
	res "! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 6/22/2016 16:17'!
classInitial
	^#P! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 2/20/2016 16:06'!
getter: aSymbol 
	getter := aSymbol! !

!GbtNoPolicy methodsFor: 'initialization' stamp: 'hk 11/17/2016 16:53'!
initialize 
	super initialize.
	bareID := 0.
	self last: 9999.
	prefix := ''.
	getter := #nextStringID! !

!GbtNoPolicy methodsFor: 'testing' stamp: 'hk 7/17/2015 17:35'!
isNoPolicy
	^true! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 11/17/2016 16:43'!
last
 	^last! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 11/17/2016 16:43'!
last: anInteger
 	last := anInteger ! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 11/17/2016 17:07'!
next   
	^bareID := (bareID + 1) \\last! !

!GbtNoPolicy methodsFor: 'protocol' stamp: 'hk 3/29/2017 14:54'!
nextAlphaID: offset
	"turn the number into Alpha. offset = 97 (small) and 65 (Caps)"
	
	| int running resid res char |
	int := self next -1. 	"start with 0"
	running := int \\ 26.	"26 Chars"
	resid := int // 26.	"that many times"
	res := ''.
	char := Character value:  running + offset .
	resid +1 timesRepeat: [res := res, char asString].
	^res
	
	"|gen res| 
	gen := self new.
	res := gen nextAlphaID: 97. 52 timesRepeat: [res := res,gen nextID].
	res "
! !

!GbtNoPolicy methodsFor: 'protocol' stamp: 'hk 5/22/2017 12:15'!
nextID   
	^self perform: getter! !

!GbtNoPolicy methodsFor: 'protocol' stamp: 'hk 3/29/2017 15:01'!
nextStringID
	^prefix, self next asString
	
	"|gen res| 
	gen := self new prefix: #abc.
	res := gen nextAlphaID: 97. 
	12 timesRepeat: [res := res,gen nextStringID].
	res "
! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 11/17/2016 16:52'!
number 
	^bareID ! !

!GbtNoPolicy methodsFor: 'copying' stamp: 'hk 11/17/2016 16:52'!
postCopy
	super postCopy.
	bareID := bareID copy.
	prefix := prefix copy.
	getter := getter copy.
! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 5/29/2017 13:35'!
prefix
	^prefix ! !

!GbtNoPolicy methodsFor: 'accessing' stamp: 'hk 11/17/2016 16:36'!
prefix: aString
	prefix := aString.
	getter := #nextStringID! !

Object subclass: #GbtObject
	instanceVariableNames: 'version id container dataPending bizApp svoName appName transient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

!GbtObject commentStamp: 'hk 1/19/2018 11:27' prior: 0!
I am an abstract GBT Object. 

My names consists of 2 parts separated by a colon: 
1.  svoName (or 'default' ) .  
2. The autoName is technical and consists of Id and version
     Id starts with (T,  U , D ,  L,  P,  B,  AC) for Thing, Ulist, Declarative, Leaf, Policy, Behavior, pushActiveContext 
     followed by a running integer
     version (starts with a 'v' followed by a running integer'


Instance Variables
	bizApp:			<GbtBizApp>				the application I am part of
	container:		<GbtObject | nil>			used in hierarchies
	svoName:		<String>					semantic part of name, #default = default
	id:				<Integer>				unique for instances of class
	version:			<Integer>				starting at '0'
	dataPending: 	<NewValueHolder> 		on true or false	for  uncommitted  things received by bizNet
	transient: 		<NewValueHolder|nil> 	true on evolve  |  false  on new version
				
			
Implementation point 
	only transient nodes can be stored - and thereby be versionned!

GbtObject subclass: #GbtActiveContext
	instanceVariableNames: 'uiSpec displayName uiKey targetSlotname menuBehaviors choiceContext createBehaviors ui constraintBehaviors eventQueue receiveBehaviors choiceSlot behaviors voChange pool choiceDict displayColumns loadPolicy loaded saveBehaviors editBehaviors removeBehaviors user templates userRight extent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Contexts'!

!GbtActiveContext commentStamp: 'hk 1/26/2018 13:41' prior: 0!
I am an abstract GBT Program Object. 
I represent a DDD bounded Context - also DCI Context.
I am active in that I receive messages in my eventQueue.
My templates are default elements for 
-  list elements (GbtPrimeListAC) or
-  aspects of a  thing (GbtPlainAC subcontext)
My pool data are  visible in all subcontexts.
I carry the context behaviors.

Instance Variables
	displayName: 		<String>					for the GUI
	displayColumns: 		<Array of Symbol>		for display in lists
	ui:					<GbtUI>					my UISpecModel 
	uiSpec:				<Symbol>				my Spec class name
	uiKey:				<Symbol>				key for Spec & Icon lookup
	targetSlotname: 		<Symbol | nil>			slot of the container vo for subcontext 	
	pool: 				<OrderedCollection of GbtSmartNode | GbtDirective>		
	eventQueue:			<GbtEventQueue>		the FIFO queue of events
	policy: 				<GbtDefaultPolicy|nil> 	for bizId
	templates:			<Coll of GbtThing | nil>	filled in authoring or by user
 	extent: 				<Point> 					extent for ui  window
	loadPolicy: 			<Symbol>				autoload simpleload filterload
	loaded: 				<Boolean>				vo or list loaded from db
	user: 				<String>					name of user
	userRight: 			<GbtRight>				rights  of user 
	voChange: 			<#addOnly | #addyRemove | #none | nil> 		for ui control
my behaviors						
	behaviors: 			<Dictionary of Symbol -> GbtBehavior>
	menuBehaviors: 		<OrderedCollection  of Symbol or Association> 	#menu -> #submenus
	saveBehaviors:		<OrderedCollection of Symbol> 	executed on save of vo
	deleteBehaviors:		<OrderedCollection of Symbol> 	executed on delete of vo
	editBehaviors:		<OrderedCollection of Symbol> 	executed on edit of vo
	receiveBehaviors:	<OrderedCollection of Symbol> 	executed on receive of an event
	createBehaviors:		<OrderedCollection of Symbol> 
	constraintBehaviors:	<OrderedCollection of Symbol>
	expandHooks: 		<OrderedIdentityDictionary> 		of slot -> behavior
for choice in Ulists of Things and vo of subcontext			(depricated)
	choiceContext: 		<AcList>							from which to choose an  element  
	choiceSlot:			<Symbol> 						for which to choose an  element
	choiceDict:			<IdentityDictionary> 				of slot -> {nil | Symbol | Declarative . Context} 

================================
Refaktoring?
templates for UlistAC  is transferred to the Ulist - cannot author at Ulist with St-DSL
!

GbtActiveContext subclass: #GbtAbstractListAC
	instanceVariableNames: 'subcontext filterSlots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Contexts'!

!GbtAbstractListAC commentStamp: 'hk 12/28/2017 13:59' prior: 0!
I am an abstract  list context.
GbtPlainAC is the subContext for any list element.

Instance Variables
	subcontext:		<GbtPlainAC>				context for a list item
	filterSlots: 		<Collection of String> 		!

!GbtAbstractListAC methodsFor: 'private' stamp: 'hk 12/5/2016 19:57'!
addToList: aThing
	self subclassResponsibility ! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 9/6/2017 17:31'!
checkDataPending
	self list detect: [ :sc | sc hasDataPending ] ifNone: [ self removeDataPending ].
	 container ifNotNil: [:c|c checkDataPending]
! !

!GbtAbstractListAC methodsFor: 'parsing' stamp: 'hk 11/16/2017 16:29'!
cielSelectors
	^super cielSelectors, #(list) ! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 11/30/2016 12:03'!
deleteListElement: aVO
	^self subclassResponsibility 
	! !

!GbtAbstractListAC methodsFor: 'accessing' stamp: 'hk 1/13/2017 15:54'!
displayColumns
	^displayColumns ifNil: [#()]! !

!GbtAbstractListAC methodsFor: 'gbtDecompile' stamp: 'hk 11/3/2017 18:31'!
displayColumnsString
	|stream|
	stream := WriteStream on: ''.
	self displayColumns do: [:clmn|
		clmn isString "or Array"
			ifTrue: [stream nextPutAll: clmn; space] 
			ifFalse: [stream nextPutAll: (self pairOfArray: clmn)]].
	^stream contents! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 10/16/2015 20:08'!
doConstraints
	"no constraints in list contexts"! !

!GbtAbstractListAC methodsFor: 'authoring' stamp: 'hk 1/12/2017 18:18'!
filterBy:	 oneOrMoreSlotName
	"creates a filter for each given slot"
	
	filterSlots := self checkStringMakeColl: oneOrMoreSlotName. 
! !

!GbtAbstractListAC methodsFor: 'accessing' stamp: 'hk 1/12/2017 12:38'!
filterSlots
	^filterSlots ifNil: [^#()]
! !

!GbtAbstractListAC methodsFor: 'accessing' stamp: 'hk 1/23/2017 13:04'!
filteredListfrom: aString
	"use the St String pattern matcher to answer a part of my list"
	aString ifEmpty: [^self getList] .
	^self getList select: [:elem| elem contains: '*',aString,'*']
! !

!GbtAbstractListAC methodsFor: 'gbtDecompile' stamp: 'hk 1/18/2018 12:26'!
gbtListSourceOn: aStream
	self source: #listColumns for: self displayColumnsString on: aStream. 
	self source: #listPrefix for: self noPolicyPrefix on: aStream. 
	self subcontext ifNotNil: [:sc| self source: #subcontext for: sc svoName on: aStream]. 

! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 1/23/2017 13:02'!
getList
	^self list! !

!GbtAbstractListAC methodsFor: 'testing' stamp: 'hk 1/5/2017 14:09'!
hasSubcontext
	^subcontext isNotNil! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 3/2/2017 16:07'!
hasTxThing: aSymbol
	^false! !

!GbtAbstractListAC methodsFor: 'testing' stamp: 'hk 9/15/2015 17:10'!
isListAc
	^true! !

!GbtAbstractListAC methodsFor: 'testing' stamp: 'hk 5/31/2017 14:15'!
isPlaceholder
	"for parsing"
	^false! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 11/10/2017 18:12'!
list
	^self subclassResponsibility ! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 11/6/2017 21:10'!
newEntry
	^self newEntry: self template copy ! !

!GbtAbstractListAC methodsFor: 'authoring' stamp: 'hk 11/13/2017 13:54'!
newEntry: aThing   
	^self newEntryAll: {aThing}! !

!GbtAbstractListAC methodsFor: 'authoring' stamp: 'hk 11/13/2017 13:49'!
newEntryAll: aThingList   
	aThingList do: [:th| self addToList: (th context: self; ensureBizId)]. 
	ui ifNotNil: [ui resetList; setSelection: aThingList last].
	^aThingList last! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 2/17/2017 16:24'!
newEntryWithChoice: aSelectedThing   
	^self newEntry slotExpandAt: choiceSlot put: aSelectedThing copy ensureBizId

! !

!GbtAbstractListAC methodsFor: 'gbtDecompile' stamp: 'hk 11/3/2017 18:32'!
pairOfArray: clmArray
	^ '(', clmArray first, ' ', clmArray second, ')'! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 1/5/2016 14:33'!
processWithBizId: identifier
	"find the list element whose bizId matches the identifier"

	|  process new |
	process := self list detect: [:e| identifier = e bizId ] ifNone: [].
	new := process ifNil: [process := self newEntry. true ] ifNotNil: [false]	.
	^Array with: process with: new
! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 11/15/2017 13:30'!
refreshUI
	ui refresh.
	self subcontext ifNotNil: [:sc| sc refreshUI]! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 2/1/2016 14:31'!
setUlistTemplates
	"take the authored template and assign it to the UlistVO"
! !

!GbtAbstractListAC methodsFor: 'accessing' stamp: 'hk 8/19/2015 15:36'!
subcontext
	^subcontext! !

!GbtAbstractListAC methodsFor: 'authoring' stamp: 'hk 5/29/2017 17:23'!
subcontext:	aCfPlainVO
	"tell the context for my list elements"
	
	self check: [(aCfPlainVO isKindOf: GbtObject) or: [aCfPlainVO isKindOf: GbtPlainAC] ] toBe: #aCfPlainVOOrGbtObject .
	subcontext :=	aCfPlainVO.
	aCfPlainVO  container: self
! !

!GbtAbstractListAC methodsFor: 'gbtDecompile' stamp: 'hk 11/7/2017 12:23'!
subjectOn: aStream
	self templateNames ifNotEmpty: [:t| 
		aStream nextPutAll: ' of '. 
		t asStringOn: aStream delimiter: ' '. 
		aStream space]! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 11/30/2016 12:24'!
uiSelection
	^(ui ifNil: [^nil]) selection! !

!GbtAbstractListAC methodsFor: 'api' stamp: 'hk 7/13/2017 18:42'!
uiSelection: anItem  
	(ui ifNil: [^self]) setSelection: anItem.! !

!GbtAbstractListAC methodsFor: 'accessing' stamp: 'hk 9/5/2017 12:03'!
valuesOf: aFilterSlotName
	^(self list collect: [:e| [(e slotTagged: aFilterSlotName) val] ifError: []] as: Set) asArray
! !

GbtAbstractListAC subclass: #GbtNodeListAC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Contexts'!

!GbtNodeListAC commentStamp: 'hk 11/6/2017 21:07' prior: 0!
I am bound to a little list, represented by a UlistVO and its template!

!GbtNodeListAC methodsFor: 'private' stamp: 'hk 11/6/2017 21:08'!
addToList: aThing     
	^self nodeList newEntry: aThing! !

!GbtNodeListAC methodsFor: 'api' stamp: 'hk 11/6/2017 21:08'!
deleteListElement: aVO
	"remove my list element aVO"
	self removeHook: aVO.
	^self nodeList removeSlot: aVO .
	! !

!GbtNodeListAC methodsFor: 'gbtDecompile' stamp: 'hk 11/8/2017 12:25'!
gbtListSourceOn: aStream
	super gbtListSourceOn: aStream .
	self source: #elderSlot for: targetSlotname on: aStream. ! !

!GbtNodeListAC methodsFor: 'gbtDecompile' stamp: 'hk 11/6/2017 21:08'!
gbtType
	^#nodeList! !

!GbtNodeListAC methodsFor: 'api' stamp: 'hk 11/6/2017 21:08'!
list
	^self nodeList list
			! !

!GbtNodeListAC methodsFor: 'accessing' stamp: 'hk 1/2/2018 17:12'!
nodeList
	"my container is a plain context, I represent the aspect uListSlotname"
	
	| ctrVO |
	ctrVO := (container vo ifNil: [^self error: self svoName, ' no container vo']).
	[^ctrVO slotSVOAt: targetSlotname] ifError: [container notify: 'no aspect ', targetSlotname asString ]
			! !

!GbtNodeListAC methodsFor: 'analyzing' stamp: 'hk 8/30/2015 12:46'!
rtAttributes
	^Array with: ('list: ', #aUlist ) withAll: super rtAttributes   ! !

!GbtNodeListAC methodsFor: 'api' stamp: 'hk 12/29/2017 17:57'!
setUlistTemplates
	"take the authored templates and assign it to the UlistVO"

	(self nodeList ifNil: [^self error: self svoName, ' cannot find list slot in container vo']) addTemplate: self template
			! !

!GbtNodeListAC methodsFor: 'accessing' stamp: 'hk 11/30/2017 15:35'!
template
	^(self thingTemplates ifEmpty: [^nil]) first! !

!GbtNodeListAC methodsFor: 'authoring' stamp: 'hk 11/6/2017 17:41'!
template: aThing for: slotName
	"tell the slotName that holds my list"
	
	self check: [ slotName isSymbol] toBe: #aSymbol.
	self check: [ aThing isNode] toBe: #aThing.
	
	self templates: aThing .
	targetSlotname := slotName
	! !

GbtAbstractListAC subclass: #GbtPrimeListAC
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Contexts'!

!GbtPrimeListAC commentStamp: 'hk 9/14/2017 15:19' prior: 0!
I am bound to a big list, represented by the copies of my asvo.


Instance Variables
	list: 				<OrderedCollection of GbtThing>	sort by bizId ?!

!GbtPrimeListAC methodsFor: 'private' stamp: 'hk 12/13/2016 17:25'!
addToList: aThing
	^self list add: aThing! !

!GbtPrimeListAC methodsFor: 'api' stamp: 'hk 1/9/2017 15:49'!
deleteListElement: aVO
	"remove my list element aVO"
	self removeHook: aVO.
	^aVO delete! !

!GbtPrimeListAC methodsFor: 'gbtDecompile' stamp: 'hk 10/30/2017 13:53'!
gbtType
	^#primeList! !

!GbtPrimeListAC methodsFor: 'api' stamp: 'hk 7/14/2017 20:49'!
getList
	^self list reject: [:e| e deleted]! !

!GbtPrimeListAC methodsFor: 'initialization' stamp: 'hk 7/21/2016 17:33'!
initialize
	super initialize.
	list := OrderedCollection new! !

!GbtPrimeListAC methodsFor: 'testing' stamp: 'hk 6/7/2017 10:51'!
isPrimeListAc
	^true! !

!GbtPrimeListAC methodsFor: 'api' stamp: 'hk 7/21/2016 17:37'!
list
	^list! !

!GbtPrimeListAC methodsFor: 'api' stamp: 'hk 5/25/2017 17:46'!
loadAll 
	|theList| 
	loaded ifNotNil: [ ^self ].
	self template ifNil: [^self].  
	theList := self userRight allowedSubColl: (self bizApp loadList: self template svoName).
	theList do: [ :e| self newEntry: e ]. 
	loaded := true
! !

!GbtPrimeListAC methodsFor: 'private' stamp: 'hk 12/2/2016 14:26'!
replace: oldThing by: newThing   
	| i |
	i := list indexOf: oldThing ifAbsent: [^oldThing ].
	newThing context: self; ensureBizId.
	^list at: i put: newThing
! !

!GbtPrimeListAC methodsFor: 'private' stamp: 'hk 9/7/2017 19:00'!
replacePrimeThing: oldThing by: newThing
	"check if subcontexts hold oldThing, too
	PRE: svoName and id of oldThing and newThing are identical"

	| oV nV |   
	(oV := oldThing version) = (nV := newThing version) ifTrue: ["sender system" ^self].
	(oV := oldThing version) < (nV := newThing version) ifFalse: [^self notify: 'illegal version update of ', oldThing svoName,' : ', oV asString, ' -> ', nV asString].    
	self uiSelection = oldThing 
		ifTrue: [self uiSelection: newThing].
	self replace: oldThing by: newThing
! !

!GbtPrimeListAC methodsFor: 'analysing' stamp: 'hk 10/11/2016 16:37'!
rtAttributes
	| arr |
	arr := OrderedCollection 
		with: 'template: ', (self template  ifNil: '' ifNotNil: [self template svoName]) 
		with: 'list size = ', list size printString.
	arr addAll: super rtAttributes.
	^arr  ! !

!GbtPrimeListAC methodsFor: 'api' stamp: 'hk 9/8/2017 13:16'!
updatePrimeThing: aThing
	"external update: aThing is new in self list or is a new version of a list element"
	| oldThing |  
	oldThing := self list detect: 
		[:elem| elem nameAndId = aThing nameAndId and: [elem deleted not]] ifNone: [].
	aThing context: self.
	aThing bizApp: self bizApp.
	self bizApp addThing: aThing.
	oldThing 
		ifNil: [self newEntry: aThing]
		ifNotNil: [self replacePrimeThing: oldThing by: aThing].
	aThing setOtherUserEdits: true.	"this updates the GUI"

! !

!GbtActiveContext class methodsFor: 'depricated' stamp: 'hk 8/16/2017 17:15'!
definedAs: aName 
	^GbtServer default contextNamed: aName ! !

!GbtActiveContext class methodsFor: 'depricated' stamp: 'hk 8/16/2017 17:15'!
definedAs: aName for: userName 
	^(GbtServer default appAt: userName) contextNamed: aName ! !

!GbtActiveContext class methodsFor: 'depricated' stamp: 'hk 11/6/2017 16:43'!
new: aString 
	^(GbtServer default) addAC: (self basicNew 
		svoName: aString ; 
		initialize; 
		setID; 
		yourself)
		! !

!GbtActiveContext class methodsFor: 'parser production' stamp: 'hk 1/8/2018 14:44'!
new: aString  define: defArray
	^(GbtServer default) addAC: (self basicNew 
		svoName: aString ; 
		appName: GbtServer currentAppName;
		initialize; 
		setID; 
		defineFrom: defArray)
		! !

!GbtActiveContext class methodsFor: 'depricated' stamp: 'hk 8/16/2017 17:15'!
struct: aString define: definitionArray
	"answer the context typed aString. If new, define it. do not make a copy"
	
	^(GbtServer default) type: #context named: aString ifAbsent: [self new: aString define: definitionArray]  
		! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 9/27/2017 13:35'!
addBehavior: aGbtBehavior
	
	behaviors add: aGbtBehavior svoName -> (aGbtBehavior  container: self)! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 12/16/2016 14:18'!
addPoolThing: aGbtThing
	self poolThings add: aGbtThing! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 11/30/2017 15:33'!
addTemplate: aNameOrThings
	"tell the template"

	self thingTemplates add: aNameOrThings 
! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 12/13/2016 14:04'!
allPoolThings
	"answer all GbtThings from the pool
	include pools of all contexts above"
	
	|res|
	res := self poolThings copy.
	self isContainerRoot ifFalse: [res addAll: self container allPoolThings].
	^res! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 11/2/2016 15:30'!
allowsAdd
	^voChange = #addOnly | (voChange = #addyRemove)! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 2/27/2016 16:22'!
allowsAspectChoice
	^choiceContext isNotNil & choiceSlot isNotNil! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 2/25/2016 15:19'!
allowsChoice
	^choiceContext isNotNil! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 2/25/2016 15:18'!
allowsRemove
	^voChange = #addyRemove! !

!GbtActiveContext methodsFor: 'parsing' stamp: 'hk 11/9/2017 19:29'!
atFullPath: aStringInArray
	"smartNode compatibility"
	^self atSmartPath: aStringInArray! !

!GbtActiveContext methodsFor: 'parsing' stamp: 'hk 1/12/2018 14:36'!
atSmartPath: aStringInArray
	"smartNode compatibility"
	| sel |
	sel := aStringInArray last asSymbol.  
	(behaviors keys includes: sel) ifTrue: 
		[^behaviors at: sel].
	^self perform: sel! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 8/8/2016 14:21'!
behavior: aName actions: definitionArray
	"tell a behavior "

	self behavior: aName arguments: #() actions: definitionArray! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 9/27/2017 13:35'!
behavior: aName arguments: argArray actions: definitionArray
	"tell a behavior "
	
	self addBehavior: (GbtBehavior newStruct: aName arguments: argArray define: definitionArray) ! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 8/9/2016 12:02'!
behavior: aName reuse: oldName modify: definitionArray 
	"reuse a behavior "
	| oldBeh newBeh |
	self check: [ aName isString ] toBe: #aString .
	self check: [ oldName isString ] toBe: #aString .
	self check: [ definitionArray isArray ] toBe: #anArray .
	self check: [ (oldBeh := behaviors at: oldName) isKindOf: GbtBehavior ] toBe: #aBehavior .
	
	newBeh := oldBeh copy rename: aName modify: definitionArray.
	behaviors add: aName -> (newBeh container: self)! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 1/14/2018 14:32'!
behaviorColl
	"not the constraints"
	^self behaviors values asOrderedCollection! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 8/22/2017 12:57'!
behaviors
	"not the constraints"
	^behaviors reject: [:e| (e isConstraint) ]! !

!GbtActiveContext methodsFor: 'parsing' stamp: 'hk 11/6/2017 17:34'!
behaviors: nameArray
	"tell all behavior names (parsing)"
	
	nameArray do: [:nme| self addBehavior: (GbtParseMock svoName: nme)]
	 ! !

!GbtActiveContext methodsFor: 'gbtDecompile' stamp: 'hk 1/25/2018 19:05'!
behaviorsString
	^String streamContents: [:s | self behaviors keys asStringOn: s delimiter: ' ']! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 5/13/2017 16:07'!
checkDataPending
	self subclassResponsibility ! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 6/9/2015 12:52'!
choiceContext
	^choiceContext ! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 6/14/2016 15:05'!
choiceContextAt: aSlotName ifAbsent: absentBlock
	"answer the context to choose a thing"
	^self choiceDict at: aSlotName ifAbsent: absentBlock! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 6/13/2016 11:27'!
choiceDict
	^choiceDict ifNil: [ choiceDict := IdentityDictionary new ]! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 1/13/2018 17:21'!
choiceName
	^self displayName ! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 2/25/2016 15:20'!
choiceSlot
	^ choiceSlot! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 2/27/2016 14:54'!
chooseFor: aSlotName 
	"aSlotName is the slot to which the view transformed selection will be attached"
	self check: [ aSlotName isSymbol ] toBe: #aSymbol.
	
	choiceSlot := aSlotName! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 12/14/2016 12:06'!
chooseFor: aSlotName from: aChoiceContext 
	"aSlotName is the slot to which the selection will be attached"
	
	self chooseFor: aSlotName use: nil from: aChoiceContext ! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 9/24/2017 15:56'!
chooseFor: aSlotName use: aDirectiveOrSymbol from: aChoiceContext 
	"aSlotName shall be filled 
	- either with the value of the chosen things slot named aDirectiveOrSymbol  
	- or with the chosen thing transformed by the Directive aDirectiveOrSymbol
	- or with the chosen thing itself (when aDirectiveOrSymbol isNil) "
	
	self check: [aDirectiveOrSymbol isNil or: [aDirectiveOrSymbol isSymbol or: [aDirectiveOrSymbol isKindOf: GbtDirective]]] toBe: #aDirectiveOrSymbol.
	self check: [ aSlotName isSymbol ] toBe: #aSymbol.
	self check: [aChoiceContext isKindOf: GbtAbstractListAC] toBe: #aListContext.
	
	self choiceDict add: aSlotName -> {aDirectiveOrSymbol . aChoiceContext}! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 5/11/2016 14:19'!
chooseWith: aChoiceContext 
	"tell the context and herewith editor used to choose new content"
	self check: [aChoiceContext isKindOf: GbtAbstractListAC] toBe: #aListContext.
	
	choiceContext := aChoiceContext.
! !

!GbtActiveContext methodsFor: 'parsing' stamp: 'hk 11/30/2017 15:42'!
cielSelectors
	^#(thingTemplates template user) ! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 6/22/2016 16:16'!
classInitial
	^#AC! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 6/3/2016 14:33'!
constraint: aName left: definitionArray right: anotherArray
	"tell a behavior "
	self check: [ aName isString ] toBe: #aString .
	self check: [ definitionArray isArray ] toBe: #anArray .
	self check: [ anotherArray isArray ] toBe: #anArray .
	
	behaviors add: aName -> ((GbtConstraint new defineLeft: definitionArray right: anotherArray named: aName) container: self)
! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 8/22/2017 12:57'!
constraints

	^behaviors select: [:e| e isConstraint ]! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 5/11/2016 14:19'!
constraints: arrayOfSymbol 
	"tell the create behaviors"
	self check: [ arrayOfSymbol isArray ] toBe: #anArray.
	self check: [ self isKindOf: GbtPlainAC ] toBe: #aPlainContext.
	
	constraintBehaviors addAll: arrayOfSymbol
! !

!GbtActiveContext methodsFor: 'gbtDecompile' stamp: 'hk 11/1/2017 17:56'!
createBehaviorsString
	^String streamContents: [:s | createBehaviors asStringOn: s delimiter: ' ']! !

!GbtActiveContext methodsFor: 'hooks' stamp: 'hk 9/23/2016 13:50'!
createHook: aThing
"	createBehaviors do: [:e| ((self behaviors at: e) execute: {aThing})]"
	
	createBehaviors do: [:e| (behaviors at: e) execute].
	constraintBehaviors do: [:e| (self constraints at: e) execute]! !

!GbtActiveContext methodsFor: 'initialization' stamp: 'hk 1/7/2016 14:09'!
defineFrom: definitionArray
	definitionArray do: 
		[ :elem | |sel|
		sel := elem first asSymbol.
		(self respondsTo: sel) ifFalse: [self error: 'no such define: ',sel].
		self perform: elem first asSymbol withArguments: elem allButFirst]! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 7/12/2017 14:17'!
display: anArrayOfSymbol 
	"tell the array defining my list columns "
	
	displayColumns := anArrayOfSymbol ! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 2/27/2016 15:15'!
displayAs: aString
	"tell the GUI display string"
	self check: [ aString isString ] toBe: #aString.
	
	displayName := aString! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/7/2017 11:48'!
displayName
	^displayName ifNil: [self svoName "the default"]! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 9/23/2016 13:42'!
doBehavior: key withArgs: args
	"do the behavior key with args"
	^(self behaviors at: key) execute: args
! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 9/23/2016 13:42'!
doBehaviors: aCollOfKeys 
	"do the behaviors aCollOfKeys"
	
	(self behaviors keys intersection: aCollOfKeys) do: [:e| (self behaviors at: e) execute]
! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 9/23/2016 13:42'!
doConstraints: aCollOfKeys

	(self constraints keys intersection: aCollOfKeys) do: [:e| (self constraints at: e) execute]! !

!GbtActiveContext methodsFor: 'hooks' stamp: 'hk 9/23/2016 13:38'!
editHook: aThing
	editBehaviors do: [:beh| ((self behaviors at: beh) execute: {aThing})]! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 10/24/2015 16:49'!
eventQueue
	^eventQueue! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 12/14/2016 17:39'!
extent
	^extent! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 12/14/2016 17:20'!
extent: aPoint
	"tell the window extent"
	self check: [aPoint isKindOf: Point] toBe: #aPoint.
	
	extent := aPoint! !

!GbtActiveContext methodsFor: 'gbtDecompile' stamp: 'hk 11/1/2017 18:04'!
gbtListSourceOn: aStream
! !

!GbtActiveContext methodsFor: 'gbtDecompile' stamp: 'hk 11/1/2017 18:04'!
gbtPlainSourceOn: aStream
! !

!GbtActiveContext methodsFor: 'gbtDecompile' stamp: 'hk 1/26/2018 13:07'!
gbtSourceOn: aStream
	aStream 
		nextPutAll: self gbtType; space;
		nextPutAll: self svoName; space. 
	self subjectOn: aStream.
	aStream nextPut: ${ ; cr.
	self source: #displayAs for: displayName on: aStream. 
	self source: #icon for: uiKey on: aStream.
	self source: #uiSpec for: uiSpec on: aStream. 
	self source: #windowSize for: extent on: aStream.
	self source: #poolThings for: self poolThingNamesString on: aStream.
	self source: #loadPolicy for: loadPolicy on: aStream. 	
	self gbtListSourceOn: aStream. 	
	self gbtPlainSourceOn: aStream. 	
	self menus do: [:ma|
		 self source: #menu for: (self menu2String: ma) on: aStream].
	self source: #behaviors for: self behaviorsString on: aStream. 	
	self source: #onCreate for: self createBehaviorsString on: aStream. 	
	aStream tab; nextPut: $} ; cr.
! !

!GbtActiveContext methodsFor: 'gbtDecompile' stamp: 'hk 10/30/2017 13:56'!
gbtType
	self subclassResponsibility ! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 7/29/2016 12:28'!
hasAutoloadPolicy
	^loadPolicy = #autoload! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 7/29/2016 12:28'!
hasFilterloadPolicy
	^loadPolicy = #filterload! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 7/29/2016 12:28'!
hasSimpleloadPolicy
	^loadPolicy = #simpleload! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 1/5/2017 14:11'!
hasSubcontext
	^false! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 11/30/2017 15:33'!
hasTemplates
	^self thingTemplates isNotEmpty! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 3/2/2017 16:07'!
hasTxThing: aSymbol
	self subclassResponsibility ! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 1/26/2018 13:51'!
icon: aUikey
	"aUikey identifies the icon shown"
	
	uiKey := (aUikey ifNil: [^self]) asSymbol! !

!GbtActiveContext methodsFor: 'initialization' stamp: 'hk 11/14/2016 16:19'!
initialize
	super initialize.
	behaviors := Dictionary new.
	menuBehaviors := OrderedCollection new.
	saveBehaviors := OrderedCollection new.
	removeBehaviors := OrderedCollection new.
	editBehaviors := OrderedCollection new.
	receiveBehaviors := OrderedCollection new.
	createBehaviors := OrderedCollection new.
	constraintBehaviors := OrderedCollection new.
	eventQueue :=	GbtEventQueue new . 
! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 11/9/2016 12:58'!
isActiveContext
	^true! !

!GbtActiveContext methodsFor: 'testing' stamp: 'hk 6/7/2017 10:51'!
isPrimeListAc
	^false! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 10/11/2016 16:37'!
key
	"synonym for template editor"
	^self svoName ! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 1/26/2018 14:18'!
loadPolicy: aSymbol
	"one of autoload simpleload filterload"
	
	aSymbol ifNil: [^self].
	self check: [#(autoload simpleload filterload) includes: aSymbol] toBe: #autoOrSimpleOrFilterload .
	loadPolicy := aSymbol ! !

!GbtActiveContext methodsFor: 'gbtDecompile' stamp: 'hk 11/1/2017 17:49'!
menu2String: aMenuAssoc
	^aMenuAssoc key, ' ', (String streamContents: [:s | aMenuAssoc value asStringOn: s delimiter: ' '])
! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 1/26/2018 13:32'!
menu: aSymbolOrArray 
	"tell a menu of a behavior"
	
	aSymbolOrArray isSymbol ifTrue: 	
		[^self menu: aSymbolOrArray  asSymbol items: #()].
	aSymbolOrArray ifEmpty: [^self].
	self menu: aSymbolOrArray first items: aSymbolOrArray allButFirst
! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 7/12/2017 14:15'!
menu: aSymbol items: anArrayOfSymbol
	"tell a menu of several behaviors"
	self check: [ anArrayOfSymbol isArray] toBe: #anArray.
	
	menuBehaviors add: aSymbol asSymbol -> anArrayOfSymbol 
! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 5/30/2017 14:47'!
menuFor: aMB wrapWith: aBlock
	"answer my menu items. aMB is aSymbol -> Array of Symbol (may be empty)"
	
	|menuItem|
	menuItem := MenuItemModel new name: aMB key.
	aMB value 
		ifEmpty: [menuItem action: [aBlock value: ((behaviors at: aMB key) execMenu)]] 
		ifNotEmpty:	[menuItem subMenu: (MenuModel new addGroup: [:g| 
			aMB value do: [:k| 
				g addItem: [:item| item
					name: k; 
					action: [aBlock value: ((behaviors at: k) execMenu)]]]])].
	^menuItem
						
						
			
! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 2/11/2016 12:08'!
menuItemsWrappedWith: aBlock
	"answer my menu items"

	^menuBehaviors collect: [:mb| self menuFor: mb wrapWith: aBlock]
! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 5/29/2017 13:57'!
menus 	
	^menuBehaviors 
! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 11/9/2016 13:08'!
newEntry: aThing
	self subclassResponsibility ! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 4/13/2015 10:39'!
newUI
	^(Smalltalk at: uiSpec) on: self! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 1/31/2016 11:32'!
newUI: aSymbol
	^(Smalltalk at: uiSpec) on: self mode: aSymbol! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 8/16/2017 17:15'!
nextBizID
	"bizID is company-app global. Thus the AppServer is responsible"
	^ GbtServer default nextIdOfContextNoPolicy: svoName ! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 3/17/2017 17:23'!
noPolicyGetter: aSelector
	self check: [ aSelector isSymbol ] toBe: #aSymbol.
	^self bizApp contextNoPolicyOf: svoName getter: aSelector
! !

!GbtActiveContext methodsFor: 'gbtDecompile' stamp: 'hk 11/1/2017 17:27'!
noPolicyPrefix
	^self bizApp policyPrefixOf: svoName 
! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 1/26/2018 14:04'!
noPolicyPrefix: aString
	self check: [ aString isString ] toBe: #aString.
	aString ifEmpty: [^self].
	^self bizApp contextNoPolicyOf: svoName prefix: aString
! !

!GbtActiveContext methodsFor: 'error handling' stamp: 'hk 11/8/2016 19:57'!
notify: aString
	"delegate notification to the ui"
	aString ifEmpty: [^self].
	(ui ifNil: [container]) notify: aString! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 9/27/2017 12:46'!
onEditDo: arrayOfSymbol 
	"tell the edit behaviors"
	self check: [arrayOfSymbol allSatisfy: [:e| e isSymbol]] toBe: #anArrayOfSymbol.
	
	editBehaviors addAll: arrayOfSymbol
! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 2/27/2016 15:18'!
onReceiveDo: arrayOfSymbol 
	"tell the receive behaviors"
	self check: [arrayOfSymbol allSatisfy: [:e| e isSymbol]] toBe: #anArrayOfSymbol.
	
	receiveBehaviors addAll: arrayOfSymbol
! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 9/22/2016 18:51'!
onRemoveDo: arrayOfSymbol 
	"tell the receive behaviors"
	self check: [arrayOfSymbol allSatisfy: [:e| e isSymbol]] toBe: #anArrayOfSymbol.
	
	removeBehaviors addAll: arrayOfSymbol
! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 9/21/2016 15:34'!
onSaveDo: arrayOfSymbol 
	"tell the receive behaviors"
	self check: [arrayOfSymbol allSatisfy: [:e| e isSymbol]] toBe: #anArrayOfSymbol.
	
	saveBehaviors addAll: arrayOfSymbol
! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 10/4/2017 12:39'!
poolFrameNamed: aString ifAbsent: aBlock
	^self poolThings detect: [:th| th svoName = aString] ifNone: [aBlock value]! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/1/2017 16:02'!
poolThingNames
	^self poolThings collect: [:t| t svoName]! !

!GbtActiveContext methodsFor: 'gbtDecompile' stamp: 'hk 11/1/2017 16:07'!
poolThingNamesString
	^String streamContents: [:s | self poolThingNames asStringOn: s delimiter: ' ']! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 12/13/2016 14:04'!
poolThings
	"create the pool if necessary"
	^pool ifNil: [ OrderedCollection new]! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 1/12/2017 12:27'!
poolThings: aCollOfThings
	"define the pool Things"
	
	pool := self checkThingMakeColl: aCollOfThings! !

!GbtActiveContext methodsFor: 'copying' stamp: 'hk 5/10/2015 14:15'!
postCopy
	super postCopy .
	self inform: 'contexts should not be copied'! !

!GbtActiveContext methodsFor: 'printing' stamp: 'hk 10/11/2016 16:37'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPut: $ ; nextPutAll: self svoName! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 8/5/2016 16:30'!
receive: anEvent
	eventQueue push: anEvent .
	receiveBehaviors do: [ :e | (behaviors at: e ifAbsent: [self error: 'no behavior ',e]) execute ] ! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 8/9/2016 11:36'!
refreshUI
	"automatic behaviors may need to update the GUI"
	self subclassResponsibility ! !

!GbtActiveContext methodsFor: 'initialization' stamp: 'hk 11/30/2017 15:33'!
release
	super release.
	self thingTemplates do: #release .
	behaviors valuesDo: #release
! !

!GbtActiveContext methodsFor: 'pending data' stamp: 'hk 9/8/2017 17:08'!
removeDataPending
	super removeDataPending .
	(self container ifNil: [ ^self ]) removeDataPending ! !

!GbtActiveContext methodsFor: 'hooks' stamp: 'hk 9/23/2016 13:38'!
removeHook: aThing
	removeBehaviors do: [:beh| ((self behaviors at: beh) execute: {aThing})]! !

!GbtActiveContext methodsFor: 'parsing' stamp: 'hk 11/9/2017 09:56'!
replaceBehavior: aBeh
	"replace a newly compiled behavior - no copy"
	self behaviors do: [:beh | 
		(beh ~= aBeh and: [beh svoName = aBeh svoName]) ifTrue: 
			[beh becomeForward: (aBeh container: self)]]! !

!GbtActiveContext methodsFor: 'parsing' stamp: 'hk 11/9/2017 09:38'!
replaceDirective: aDir
	"replace a newly compiled directive"
	self poolThings do: [:dir | 
		(dir ~= aDir and: [dir svoName = aDir svoName]) ifTrue: 
			[ dir becomeForward: aDir copy]]! !

!GbtActiveContext methodsFor: 'parsing' stamp: 'hk 11/30/2017 15:33'!
replaceThing: aThing
	"replace a newly compiled thing"
	(self poolThings union: self thingTemplates) do: [:tmpl | 
		(tmpl ~= aThing and: [tmpl svoName = aThing svoName]) ifTrue: 
			[tmpl becomeForward: aThing copy.
			tmpl context: self]]! !

!GbtActiveContext methodsFor: 'analyzing' stamp: 'hk 11/15/2016 20:49'!
rtAttributes
	^{ 'uiSpec: ', (self uiSpec ifNil: #nil) . 'user: ', self user}! !

!GbtActiveContext methodsFor: 'analyzing' stamp: 'hk 9/27/2017 13:27'!
rtBehaviors
	| bs |
	bs := OrderedCollection new.
	behaviors do: [ :pB | bs add: pB svoName ].
	^bs! !

!GbtActiveContext methodsFor: 'hooks' stamp: 'hk 9/23/2016 13:38'!
saveHook: aThing
	saveBehaviors do: [:beh| ((self behaviors at: beh) execute: {aThing})]! !

!GbtActiveContext methodsFor: 'pending data' stamp: 'hk 6/1/2016 14:25'!
setDataPending
	super setDataPending .
	(self container ifNil: [ ^self ]) setDataPending ! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 1/5/2017 14:07'!
setOtherUserEdits: aBoolean     
	" update gui"
	(ui isKindOf: GbtListUI) 
		ifTrue: [^ui otherUserEdits: aBoolean].
	((container ifNil: [^self]) ui isKindOf: GbtListUI) 
		ifTrue: [container ui otherUserEdits: aBoolean]
	! !

!GbtActiveContext methodsFor: 'gbtDecompile' stamp: 'hk 1/26/2018 13:13'!
source: aKey for: aStringOrPointOrNil on: aStream
	aStringOrPointOrNil ifNil: [^self].
	aStringOrPointOrNil asString ifEmpty: [^self].
	aStream tab;
		nextPutAll: aKey; tab;
		nextPut: $: ; space;
		nextPutAll: aStringOrPointOrNil asString; cr! !

!GbtActiveContext methodsFor: 'gbtDecompile' stamp: 'hk 11/7/2017 12:23'!
subjectOn: aStream! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 5/6/2015 14:50'!
targetSlotname
	^ targetSlotname! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 5/6/2015 14:50'!
targetSlotname: aSymbol
	targetSlotname := aSymbol! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/30/2017 15:33'!
template
	^(self thingTemplates ifEmpty: [^nil]) first! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/30/2017 15:33'!
templateNames
	^self thingTemplates collect: [:t| t svoName]! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 6/8/2017 14:19'!
templates: oneOrMoreThings
	"tell the templates "

	templates := self checkThingMakeColl: oneOrMoreThings .
! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/30/2017 15:33'!
thingTemplates
	^templates ifNil: [templates := OrderedCollection new]! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 3/21/2017 14:51'!
ui
	^ui ifNil: [self uiSpecClass on: self] ! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 8/26/2015 10:40'!
ui: aGcUI
	ui := aGcUI ! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 4/13/2015 10:31'!
uiKey
	^ uiKey! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/7/2016 11:02'!
uiSpec
	^uiSpec ifNil: [ self error: 'uiSpec not authored' ]! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 1/26/2018 13:50'!
uiSpec: aClassName 
	"tell the Spec model of this context"
	
	uiSpec := (aClassName ifNil: [^self]) asSymbol! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 5/27/2017 15:21'!
uiSpec: aClassName icon: aUikey
	"tell the Spec model of this context. 
	aUikey identifies the icon shown"
	
	self uiSpec: aClassName .
	self icon: aUikey asSymbol! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/7/2016 11:09'!
uiSpecClass
	^Smalltalk at: self uiSpec ! !

!GbtActiveContext methodsFor: 'api' stamp: 'hk 6/7/2017 10:52'!
updatePrimeThing: aThing
	"delegate the update from item context to big list context"

	(container ifNil: [^self notify: 'failed: updateBigThing in ',self svoName]) updatePrimeThing: aThing! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/8/2016 10:07'!
user
	^user ifNil: [ '' ]! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/7/2016 12:44'!
user: aName    
	user := aName! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 3/14/2017 14:49'!
userRight
	^userRight ifNil: [ "default" GbtRight new]! !

!GbtActiveContext methodsFor: 'accessing' stamp: 'hk 11/22/2016 09:43'!
userRight: aGbtRight
	userRight := aGbtRight ! !

!GbtActiveContext methodsFor: 'authoring' stamp: 'hk 2/27/2016 15:16'!
voChange: aSymbol
	self check: [ aSymbol isSymbol ] toBe: #aSymbol.
	
	voChange  := aSymbol! !

GbtActiveContext subclass: #GbtPlainAC
	instanceVariableNames: 'subcontexts blackboardAspect legaltext txThings expandHooks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Contexts'!

!GbtPlainAC commentStamp: 'hk 10/31/2017 13:11' prior: 0!
I am a normal (plain) context.
For execution things are bound to me with roles. 
A special role is contextVO, that holds the thing to be edited by the user.
Further roles may be authored. Behaviors access all role things by the role name.
Since there may be many different views on my contextVO, 
I hold a subcontext for each (view) aspect of my contextVO

Instance Variables
	txThings:		<Dictionary>				holding all tx relevant  things including contextVO
	subcontexts: 	<OrderedCollection of GbtActiveContext>		GbtPlainAC | GbtUlistAC of aspects
	sendViews: 		<Dictionary of GbtDeclarative>					for bizNet receives &  sends: 
																- view userName used for sends: 
																- dict key used for receives
	blackboardAspect:	<aString>								vo slotName of blackboard
	legaltext: 			<String>

=====================================================

	txThings not needed with CIEL, only with action language 
	should be removed !!!!!!!

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 5/31/2017 14:01'!
addSubcontext: aCf 
	"tell a subcontext of one of my VO's aspects / subnodes)"

	aCf container: self .
	subcontexts add: aCf! !

!GbtPlainAC methodsFor: 'authoring' stamp: 'hk 5/31/2017 14:04'!
aspect: aCf on: aSlotName
	"tell a subcontext of one of my VO's aspects / subnodes).
	and to which slot of my VO it belongs "
	
	self check: [aCf isActiveContext] toBe: #aContext.
	self check: [aSlotName isNil or: [aSlotName isString]] toBe: #aString .

	self addSubcontext: (aCf targetSlotname: aSlotName)! !

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 12/19/2017 13:59'!
aspectSlots
	^subcontexts collect: [ :sc| sc targetSlotname ] thenSelect: [:sn| sn isNotNil ]! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 3/2/2017 16:07'!
assign: aThing toTxThing: aSymbol
	
	(self knowsTxThing: aSymbol) ifFalse: [^self notify: aSymbol, ' is not a role']. 
	txThings add: aSymbol -> aThing! !

!GbtPlainAC methodsFor: 'gbtDecompile' stamp: 'hk 11/1/2017 17:39'!
assoc2String: anAssoc
	^anAssoc key, ' ', anAssoc value! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 1/27/2016 17:29'!
blackboardAspect
	
	^blackboardAspect ! !

!GbtPlainAC methodsFor: 'authoring' stamp: 'hk 1/27/2016 17:21'!
blackboardAspect: aCf on: aSlotName
	"tell the aspect / slot of my header info"
	
	blackboardAspect := aSlotName .
	self aspect: aCf on: aSlotName! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 2/29/2016 13:17'!
blackboardContext
	^self subcontextFor:  blackboardAspect ! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 2/29/2016 18:39'!
blackboardSlot
	
	^blackboardAspect ifNil: [ #nil ]! !

!GbtPlainAC methodsFor: 'authoring' stamp: 'hk 12/31/2016 14:57'!
blackboardSlot: aSlotName
	"tell the blackboard slotName"
	self check: [aSlotName isString] toBe: #aString .
	
	blackboardAspect := aSlotName! !

!GbtPlainAC methodsFor: 'changes' stamp: 'hk 9/6/2017 17:31'!
checkDataPending

	| scDPending  voDPending selfPending |		
	selfPending := self hasDataPending.
	scDPending := subcontexts detect: [:sc| sc hasDataPending]  
		ifFound: [true] ifNone: [false]. 
	self vo ifNotNil: [:th| 
		voDPending := th hasDataPending. 
		((scDPending | voDPending) & selfPending not) ifTrue: [^self setDataPending]].
	(scDPending not & selfPending) ifTrue: [^self removeDataPending].
	(scDPending & selfPending not) ifTrue: [^self setDataPending]! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 1/8/2018 18:33'!
commit: aCollOfThings
	"store aCollOfThings"
	self bizApp  
		transact: (aCollOfThings collect: [:th| th serializedNodes2Store]) 
		as: self user ! !

!GbtPlainAC methodsFor: 'parsing' stamp: 'hk 10/16/2017 12:52'!
createBehaviors: arrayOfSymbol 
	"tell the create behaviors"
	self check: [ arrayOfSymbol isArray ] toBe: #anArray.
	
	createBehaviors addAll: arrayOfSymbol
! !

!GbtPlainAC methodsFor: 'parsing' stamp: 'hk 1/26/2018 14:00'!
expandHook: pairOfSymbol 	
	pairOfSymbol ifNil: [^self].
	self expandHooks add: 
		pairOfSymbol first asSymbol -> pairOfSymbol second
! !

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 10/16/2017 13:04'!
expandHooks
	^expandHooks ifNil: [expandHooks := IdentityDictionary new]! !

!GbtPlainAC methodsFor: 'gbtDecompile' stamp: 'hk 1/10/2018 15:59'!
gbtPlainSourceOn: aStream
	self source: #subcontexts for: self subcontextsString on: aStream. 	
	self expandHooks associationsDo: [:ha|
		 self source: #onExpand for: (self assoc2String: ha) on: aStream].
	self source: #legalText for: self legalText on: aStream. 	
! !

!GbtPlainAC methodsFor: 'gbtDecompile' stamp: 'hk 10/30/2017 13:55'!
gbtType
	^#plain! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 1/23/2016 15:16'!
hasBlackboard
	
	^blackboardAspect isNotNil ! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 3/2/2017 16:07'!
hasTxThing: aSymbol
	
	^(self knowsTxThing: aSymbol) and: [(txThings at: aSymbol) isNotNil]! !

!GbtPlainAC methodsFor: 'initialize-release' stamp: 'hk 6/8/2017 14:23'!
initialize
	super initialize .
	subcontexts := OrderedCollection new.
	txThings := Dictionary newFromPairs: { #contextVO . nil } .
! !

!GbtPlainAC methodsFor: 'testing' stamp: 'hk 5/31/2017 14:15'!
isPlaceholder
	"for parsing"
	^false! !

!GbtPlainAC methodsFor: 'testing' stamp: 'hk 11/15/2017 13:01'!
isPlainAc
	"for parsing"
	^true! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 3/2/2017 16:07'!
knowsTxThing: aSymbol
	
	^txThings keys includes: aSymbol! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 11/9/2016 16:01'!
legalText
	^legaltext ifNil: ''

! !

!GbtPlainAC methodsFor: 'authoring' stamp: 'hk 12/31/2016 14:55'!
legalText: aString 
	self check: [aString isString] toBe: #aString .

	legaltext := aString 

! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 3/22/2017 17:47'!
loadVO
	| theList |
	loaded ifNotNil: [ ^self ].
	theList := self userRight allowedSubColl: (self bizApp loadList: self vo svoName).
	theList do: [ :e| self newEntry: e ].  "should only be one"
	loaded := true

! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 5/30/2017 15:37'!
newEntry: aThing   
	"for load strategy - PlainAC>>loadVO"
	self vo: aThing
	! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 5/25/2017 16:28'!
open  
	ui := self ui.
	(ui extent: self extent; yourself) openWithSpec centered.
	self registerWithBizNet! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 8/9/2016 11:32'!
refreshUI
	(ui ifNil: [^self]) refresh.
	self subcontexts do: [:sc| sc refreshUI]! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 3/15/2017 11:43'!
registerWithBizNet
	[GbtBizNetMockUp registerCompany: self vo company with: self] ifError:
		[self notify: 'no BizNet' ]! !

!GbtPlainAC methodsFor: 'initialize-release' stamp: 'hk 6/8/2017 14:23'!
release
	super release .
	txThings valuesDo: #release
! !

!GbtPlainAC methodsFor: 'parsing' stamp: 'hk 11/9/2017 09:36'!
replaceThing: aThing
	"replace a newly compiled thing"
	super replaceThing: aThing.
	self txThings  do: [:tmpl | 
		(tmpl ~= aThing and: [tmpl svoName = aThing svoName]) ifTrue: 
			[tmpl becomeForward: aThing copy.
			tmpl context: self]]! !

!GbtPlainAC methodsFor: 'analyzing' stamp: 'hk 10/11/2016 16:37'!
rtAttributes
	^Array with: 'vo: ', (self vo  ifNil: #nil ifNotNil: [self vo svoName]) 
		withAll: super rtAttributes   ! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 2/17/2017 15:50'!
setVOFromContainer
	| aspect |
	container ifNil: [^self error: 'no container'] .
	container vo ifNil: [^self error: 'no vo in container'] .
	aspect := container vo slotSVOAt: targetSlotname ifAbsent: [].
	self vo: aspect .
	^aspect! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 9/25/2017 15:59'!
store
	self commit: self txThings ! !

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 1/27/2016 17:49'!
subcontextFor: aSlot
	^subcontexts detect: [ :sc | sc targetSlotname = aSlot ] ifNone: [  ]! !

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 4/13/2015 10:37'!
subcontexts
	^subcontexts! !

!GbtPlainAC methodsFor: 'parsing' stamp: 'hk 5/31/2017 14:12'!
subcontexts: arrayOfAc
	arrayOfAc do: [:cf| self addSubcontext: cf ]! !

!GbtPlainAC methodsFor: 'gbtDecompile' stamp: 'hk 11/4/2017 22:15'!
subcontextsString
	|str|
	str := WriteStream on: ''.
	self subcontexts do: [:sc| str nextPutAll: sc svoName; space].
	^str contents! !

!GbtPlainAC methodsFor: 'gbtDecompile' stamp: 'hk 11/7/2017 12:38'!
subjectOn: aStream
	self vo ifNil: [^self].
	aStream nextPutAll: 'on '. 
	aStream nextPutAll: self vo svoName; space! !

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 11/2/2016 16:02'!
tabcontexts
	^subcontexts reject: [:sc| (sc targetSlotname = blackboardAspect)]! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 11/7/2017 13:01'!
txThingAt: aSymbol
	^txThings at: aSymbol! !

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 11/7/2017 13:01'!
txThings
	^txThings values select: [:v| v isNotNil] ! !

!GbtPlainAC methodsFor: 'authoring' stamp: 'hk 7/12/2017 14:17'!
txThings: arrayOfSymbol
	
	arrayOfSymbol do: [:k| txThings add: k asSymbol -> nil]! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 2/17/2017 15:50'!
updateBlackboardWith: aTabContext
	"show the tab blackboard content, else the process blackboard content"
	| bbThing ctxt|  
	ctxt := (aTabContext isListAc or: [aTabContext vo isNil or: [aTabContext = self]]) 
		ifTrue: [self]
		ifFalse: [aTabContext]. 
	bbThing := ctxt vo slotSVOAt: ctxt blackboardSlot ifAbsent: [^self].
	self blackboardContext vo: bbThing ! !

!GbtPlainAC methodsFor: 'accessing' stamp: 'hk 3/14/2017 14:56'!
userRight
	^(container ifNil: [^super userRight] ) userRight! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 3/2/2017 16:04'!
vo
	^txThings at: #contextVO! !

!GbtPlainAC methodsFor: 'api' stamp: 'hk 11/7/2017 12:44'!
vo: aVO
	"tell my contextVO - thing|nil"	

	self assign: aVO toTxThing: #contextVO.

	(ui isNil not and: [ui hasTarget]) ifTrue: [ ui target: aVO ].
	(aVO ifNil: [ ^self ]) context: self ! !

GbtObject subclass: #GbtBehavior
	instanceVariableNames: 'actions arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtBehavior commentStamp: 'hk 9/27/2017 13:26' prior: 0!
I represent a behavior 
- made from actions (ActionVO)
- bound to a context

    Instance Variables
	actions: 			<OrderedCollection>		of Pairs (ActionName params)
	arguments:		<Array of Symbol>		!

!GbtBehavior class methodsFor: 'instance creation' stamp: 'hk 12/18/2016 12:09'!
newStruct: aName arguments: argArray define: definitionArray
	^self new define: aName arguments: argArray actions: definitionArray! !

!GbtBehavior methodsFor: 'accessing' stamp: 'hk 2/10/2016 14:24'!
actions 
	^actions ifNil: [ actions := OrderedCollection new ]! !

!GbtBehavior methodsFor: 'accessing' stamp: 'hk 8/8/2016 14:13'!
arguments
	^arguments ifNil: [#()]! !

!GbtBehavior methodsFor: 'accessing' stamp: 'hk 6/22/2016 16:16'!
classInitial
	^#B! !

!GbtBehavior methodsFor: 'define' stamp: 'hk 9/27/2017 13:23'!
define: aName arguments: argArray actions: definitionArray
	"create the actions defined in aSourceString"
	|  source |
	self check: [ aName isString ] toBe: #aString.
	self check: [ definitionArray isArray ] toBe: #anArray.
	self check: [ argArray isArray ] toBe: #anArray.

	svoName :=	aName asSymbol.
	source := definitionArray asOrderedCollection .
	arguments := argArray.
	[source isNotEmpty] whileTrue: 
		[self actions add: (source removeFirst: 2 )]
! !

!GbtBehavior methodsFor: 'executing' stamp: 'hk 2/14/2017 13:50'!
exec: collOfActions with: argArray
	"answer aString 'aborted' in case of error or {GbtThing . slotName} - used for constraints"	
	| pipe acts |
	acts := collOfActions collect: [:a| GbtAction newFor: a] .
	self logBegin: ''.
	pipe := GbtActionPipe thing: nil context: container new: false ext: false.	"container = context"
	argArray ifNotEmpty: 
		[pipe thing: argArray first.	
		pipe addArgs: argArray allButFirst for: self arguments].
	acts do: [ :a | pipe abort ifFalse: [pipe := a doOn: pipe] ]. 
	self logEnd: (pipe abort ifTrue: ['aborted'] ifFalse: ['']).    
	^pipe abort 
		ifTrue: [ {#aborted . #void} ] 
		ifFalse: [{pipe thing . (pipe slot)}]
! !

!GbtBehavior methodsFor: 'executing' stamp: 'hk 8/9/2016 10:23'!
execMenu
	"the notify block that wraps the menu expects aString"
	| res |
	res := self execute.
	^res isString ifTrue:[res] ifFalse: ['']! !

!GbtBehavior methodsFor: 'executing' stamp: 'hk 11/22/2016 09:48'!
execute
	container userRight execute ifFalse: [^'no right to execute'].
	^self execute: #()! !

!GbtBehavior methodsFor: 'executing' stamp: 'hk 12/15/2016 16:24'!
execute: argArray
	"^ theThing only"
	^(self exec: self actions with: argArray ) first! !

!GbtBehavior methodsFor: 'testing' stamp: 'hk 11/9/2016 13:00'!
isGbtBehavior
	^true! !

!GbtBehavior methodsFor: 'testing' stamp: 'hk 5/31/2017 14:17'!
isPlaceholder
	"for parsing"
	^false! !

!GbtBehavior methodsFor: 'executing' stamp: 'hk 9/27/2017 13:29'!
logBegin: aText 
	GbtLogger logBegin: self class name,' : ', svoName text: aText.
! !

!GbtBehavior methodsFor: 'executing' stamp: 'hk 9/27/2017 13:29'!
logEnd: aText 
	GbtLogger logEnd: self class name, ' : ', svoName text: aText.
! !

!GbtBehavior methodsFor: 'copying' stamp: 'hk 6/5/2016 13:44'!
postCopy
	super postCopy .
	actions := actions copy! !

!GbtBehavior methodsFor: 'define' stamp: 'hk 9/27/2017 13:24'!
rename: aSymbol modify: aSourceArray 
	"modify the actions. same sequence required"

	| source |
	svoName := aSymbol asSymbol.
	source := aSourceArray asOrderedCollection.
	actions := actions collect: [ :arr| |act parms|
		act := source at: 1 ifAbsent: [] .
		parms := source at: 2 ifAbsent: [] . 
		arr first = act 
			ifTrue: [source removeFirst: 2.
						{ act . parms }]
			ifFalse: [arr] ].
! !

GbtBehavior subclass: #GbtConstraint
	instanceVariableNames: 'rightActions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Actions-Beh-depr'!

!GbtConstraint commentStamp: 'hk 2/11/2016 12:58' prior: 0!
I am a binary constraint .
I hold  2 sequences of actions.
I execute these actions and compare the results.

predicate
I test the 2 arguments on equality 
& operator
I replace a nil argument by the other one

====================================
proposed refaktoring:
- hold a BehaviorVO for each constraint leg instead of subclassing
!

!GbtConstraint methodsFor: 'private' stamp: 'hk 8/16/2017 17:21'!
assign: aThingOrValue to: aNode with: aSlotName
	"assign aThingOrValue to an empty slot"
	| setter |
	setter := (aSlotName, ':') asSymbol.
	(aThingOrValue isKindOf: GbtSmartNode) ifTrue: 
		[^ aNode define: aSlotName  thing: aThingOrValue ].
	aNode perform: setter with: aThingOrValue.
! !

!GbtConstraint methodsFor: 'define' stamp: 'hk 11/2/2016 16:08'!
defineLeft: aSourceArray right: anotherArray named: aSymbol
	"create the actions defined in aSourceString"

	| source |
	self define: aSymbol arguments: #() actions: aSourceArray.
	source := anotherArray asOrderedCollection.
	[ source isNotEmpty] whileTrue: [ self rightActions add: (source removeFirst: 2) ]! !

!GbtConstraint methodsFor: 'executing' stamp: 'hk 8/24/2016 16:45'!
execLeft
	"^ anArray of thing and slot"
	^self exec: actions with: #()! !

!GbtConstraint methodsFor: 'executing' stamp: 'hk 8/24/2016 16:45'!
execRight
	"^ anArray of thing and slot"
	^self exec: rightActions with: #()! !

!GbtConstraint methodsFor: 'executing' stamp: 'hk 9/27/2017 13:28'!
execute 
	"binary constraints: eval left & right actions. 
	if only one is empty, fill it such that the contraint is obeyed.
	notify if left & right are not equal"

	| left right res getterLeft  resLeft getterRight  resRight  evalLeft evalRight |	
	self logBegin: ''.
	(evalLeft := self execLeft)
		isString ifTrue: [GbtLogger logEnd: self class name,' : ', svoName text: 'no execution'. ^evalLeft] .
	(evalRight := self execRight)
		isString ifTrue: [GbtLogger logEnd: self class name,' : ', svoName text: 'no execution'. ^evalRight].
	resLeft := evalLeft first. 			resRight := evalRight first. 
	getterLeft := evalLeft second. 	getterRight := evalRight second. 
		
	left := self nilOrSlot: getterLeft of: resLeft.
	right := self nilOrSlot: getterRight of: resRight.
	res := 'fulfilled'.
	left isNil
		ifTrue:  [right ifNil: [GbtLogger logEnd: self class name,' : ', svoName text: 'nil'. ^res ] ]
		ifFalse: [(right isNotNil and: [left = right]) ifTrue: 
							[GbtLogger logEnd: self class name,' : ', svoName text: 'ok'. ^res ]] .
	res := #violated.
	left ifNil: [self assign: right copy to: resLeft with: getterLeft.
					res := 'assigned left' ].  
	right  ifNil: [self assign: left copy to: resRight with: getterRight.
					res := 'assigned right'].	
	self logEnd: res.	
	res = #violated ifTrue: [self notifyA: {#CONSTRAINT. svoName. #on. self container svoName. #violated}].
	^res
! !

!GbtConstraint methodsFor: 'testing' stamp: 'hk 8/22/2017 12:57'!
isConstraint
	^true! !

!GbtConstraint methodsFor: 'private' stamp: 'hk 8/23/2017 16:43'!
nilOrSlot: getter of: aVO
	"test the getter. answer the content, if present, nil else"
	| slotA |
	getter ifNil: [^nil].
	aVO ifNil: [^nil].
	(aVO respondsTo: getter)	ifTrue: [^aVO perform: getter].
	(slotA := aVO slotAt: getter) ifNil: [^nil].
	slotA isFilled ifFalse: [^nil].
	slotA isSmartValue ifTrue: [^slotA value val].
	slotA isNode ifTrue: [^slotA value ].
	self error: 'something missed'! !

!GbtConstraint methodsFor: 'accessing' stamp: 'hk 2/10/2016 16:12'!
rightActions 
	^rightActions ifNil: [ rightActions := OrderedCollection new ]! !

GbtObject subclass: #GbtFrame
	instanceVariableNames: 'idNumberPolicy summary slots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

!GbtFrame commentStamp: 'hk 8/23/2017 17:36' prior: 0!
I am a frame with slots, either those of a GbtSmartNode or of a GbtDeclarative. 

I can define all slots of a GbtSmartNode, slots are  GbtSlotAssociations with leaves (GbtSmartValue) or other nodes (GbtSmartNode)  

I also am a superclass of GbtDeclarative (that's why i hold slots, idNumberPolicy , summary)

    Instance Variables
	slots:				<OrderedDictionary of GbtSlotAssociation>		slotName -> slotAssoc		
	idNumberPolicy:		<String>			name of policy for appID   				(built-in slot)
	summary: 			<String>			short description (for GUI)  			(built-in slot)
!

GbtFrame subclass: #GbtCielBehavior
	uses: TGbtBareID
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Contexts'!

GbtCielBehavior class
	uses: TGbtBareID classTrait
	instanceVariableNames: 'bareID'!

!GbtCielBehavior commentStamp: 'hk 1/23/2018 13:25' prior: 0!
I am a container for  CIEL slots (GbtSmartValues) of context behavior.

My editor api allows to open a thingEditor on me and debug my expressions

Implementation points:  

I may have arbitrarily many arguments arg1, arg2, arg3, ...
These are represented by CIEL cells named arg1, arg2, ...
An argument cell may contain an expression, the default.
I may be called with more arguments than I have.
Those extra arguments are ignored!

GbtCielBehavior class
	uses: TGbtBareID classTrait
	instanceVariableNames: 'bareID'!

!GbtCielBehavior class methodsFor: 'accessing' stamp: 'hk 9/28/2017 13:28'!
bareID
	^bareID ifNil: [bareID :=0]! !

!GbtCielBehavior class methodsFor: 'accessing' stamp: 'hk 9/28/2017 13:28'!
bareID: anInt
	bareID := anInt! !

!GbtCielBehavior class methodsFor: 'id' stamp: ''!
incrementBareID
	"leaf IDs are constrained to an image !!"
	
	self bareID: (self bareID + 1) \\65536.
	^self bareID! !

!GbtCielBehavior class methodsFor: 'parser creation' stamp: 'hk 9/30/2017 21:18'!
new: aString def: slotArray 
	^self basicNew 
		svoName: aString ; 
		initialize; 
		setID; 
		addSlots: slotArray;
		yourself! !

!GbtCielBehavior class methodsFor: 'instance creation' stamp: 'hk 9/28/2017 14:15'!
new: aString define: defArray 
	^self basicNew 
		svoName: aString ; 
		initialize; 
		setID; 
		defineWith: defArray;
		yourself! !

!GbtCielBehavior methodsFor: 'authoring' stamp: 'hk 10/18/2017 15:58'!
addSlots: slotArray
	slotArray do: [:sl|self writeSlot: sl]! !

!GbtCielBehavior methodsFor: 'executing' stamp: 'hk 1/18/2018 13:49'!
basicExecute   
	^[(self slotSVOAt: svoName asSymbol ifAbsent: [^'missing slot: ',svoName]) val] 
			on: GbtBehaviorNotification 
			do: [:ex| self notify: ex messageText]! !

!GbtCielBehavior methodsFor: 'authoring' stamp: 'hk 11/16/2017 11:17'!
define: slotName  ciel: aString
	"define ciel slot"
	
	slots at: slotName 
			put: (GbtSlotAssociation 								
						key: slotName asSymbol 
						value: ((GbtBehaviorCell withValue: aString)
						 				container: self))! !

!GbtCielBehavior methodsFor: 'authoring' stamp: 'hk 9/28/2017 13:34'!
defineWith: defArray
	defArray do: [:def|self define: def first ciel: def second]! !

!GbtCielBehavior methodsFor: 'editor api compatibility' stamp: 'hk 11/1/2017 14:57'!
displayName
	"smartNode compatibility in editor"
	^svoName! !

!GbtCielBehavior methodsFor: 'utility' stamp: 'hk 11/1/2017 14:53'!
edit
	(GbtCIELEditor on: self) openWithSpec! !

!GbtCielBehavior methodsFor: 'evolve' stamp: 'hk 1/18/2018 13:36'!
evolveCount
	"Behaviors do not evolve"
	^nil! !

!GbtCielBehavior methodsFor: 'editor api compatibility' stamp: 'hk 10/3/2017 13:46'!
evolveLeaf: slotName write: aValue
	"smartNode compatibility in editor"  
	
	^(self slotSVOAt: slotName) 
		inputValue: aValue; 
		invalidateCache; 
		yourself! !

!GbtCielBehavior methodsFor: 'executing' stamp: 'hk 1/18/2018 13:50'!
execMenu
	"the notify block that wraps the menu expects aString"
	| res |
	res := self execute.
	res ifString: [^res].
	^''! !

!GbtCielBehavior methodsFor: 'executing' stamp: 'hk 1/22/2018 18:40'!
execute
 	^self executeWith: #()
	! !

!GbtCielBehavior methodsFor: 'executing' stamp: 'hk 1/23/2018 13:21'!
executeWith: argArray
	"user may have defined argument slots arg1 ... argn"
	
	self invalidateCaches. 
	1 to: argArray size do: [:i| |arg argName|
		arg := argArray at: i.	
		argName := 'arg', i printString.
		"write and validate arg cache only if such an arg exists"
		(self slotSVOAt: argName) ifNotNil: [:sl| sl cache: arg]].  
	^self basicExecute ! !

!GbtCielBehavior methodsFor: 'editor api compatibility' stamp: 'hk 11/1/2017 14:57'!
fullThing
	"smartNode compatibility in editor - ^self"
! !

!GbtCielBehavior methodsFor: 'gbtDecompile' stamp: 'hk 11/3/2017 13:22'!
gbtSourceOn: aStream
	aStream 
		nextPutAll: 'behavior ';
		nextPutAll: self svoName; 
		nextPutAll: ' {'; cr.
	slots do: [:s| 
		aStream tab. 
		s gbtSlotSourceOn: aStream].
	aStream tab; nextPut: $}; cr
	
		
	! !

!GbtCielBehavior methodsFor: 'executing' stamp: 'hk 11/13/2017 13:19'!
invalidateCaches
	self slots valuesDo: [:sa| sa value invalidateCache]! !

!GbtCielBehavior methodsFor: 'initialization' stamp: ''!
setID
	self id: self class incrementBareID! !

!GbtCielBehavior methodsFor: 'editor api compatibility' stamp: 'hk 11/1/2017 14:59'!
summaryEnriched
	"smartNode compatibility in editor"
	^''! !

!GbtCielBehavior methodsFor: 'editor api compatibility' stamp: 'hk 11/1/2017 15:34'!
valuesOf: aList
	^#()! !

GbtFrame subclass: #GbtDirective
	instanceVariableNames: 'sources originalSmart tmpSources'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Directives'!

!GbtDirective commentStamp: 'hk 11/10/2017 12:41' prior: 0!
I am 
viewOn: 		- a view on a thing. 
transform: 	- a transformer from a source node  structure into a target node (=my own) structure.
paste:onto: 	- a reader of target data (of my own structure) to be copied into my source. 
combine: 	- a combiner of more than one thing.
In a mathematical sense I am - together with my source - a combinator functional.
In this implementation I am normally not copied , but my sources are replaced.

I can define such that any of my  slots contains
	- a tag , i.e a slotName or tag of a source slot 
	- a GbtDirective  in order to span a tree myself (just like a smart node)
	- a tag AND a Directive that can transform each element of the list in slot 'tag''
the tags should be unique, only the first (according to the source's search strategy) tag is found.

Instance variables:
	sources: 			<Coll of GbtSmartNode>	the durable source
	tmpSources: 		<Coll of GbtSmartNode>	temp source  lives during combine:

My summary and  idNumberPolicy 	will be used for the result of transform/combine: ifNotNil
!

!GbtDirective class methodsFor: 'parser production' stamp: 'hk 1/8/2018 14:45'!
new: svoName def: defArray tags: tagArray 
	"parser production"
	^(GbtServer default) addDirective: 
		(self new 
			svoName: svoName; 
			appName:  GbtServer currentAppName;
			defineIntrinsicsWith: defArray;
			defineTagsWith: tagArray ;
			setID;
			yourself) 
! !

!GbtDirective class methodsFor: 'instance creation' stamp: 'hk 9/24/2017 15:55'!
new: aString define: definitionArray
	"answer the Directive typed aString. If new, define it"

	^GbtServer default addDirective: (self basicNew svoName: aString; initialize; setID; defineFrom: definitionArray) 
		! !

!GbtDirective class methodsFor: 'accessing' stamp: 'hk 5/5/2017 15:54'!
type
	^#decl! !

!GbtDirective methodsFor: 'printing' stamp: 'hk 1/13/2018 17:20'!
choiceName
	self svoName! !

!GbtDirective methodsFor: 'accessing' stamp: 'hk 6/22/2016 16:17'!
classInitial
	^#D! !

!GbtDirective methodsFor: 'initialization' stamp: 'hk 9/2/2015 11:55'!
clearSources
	sources := OrderedCollection new! !

!GbtDirective methodsFor: 'initialization' stamp: 'hk 9/22/2017 15:04'!
clearTmpSources
	tmpSources := OrderedCollection new! !

!GbtDirective methodsFor: 'api' stamp: 'hk 11/23/2017 10:33'!
compose: oneOrMoreThings 
	"transform one or combine moreThings with my declarations into a new Thing named like me"
	"an existing thing with my svoName works like a default"

	|  smartThing|
	tmpSources := self checkThingMakeColl: oneOrMoreThings .	"temp source"
	smartThing := GbtSmartNode struct: svoName.	"will use an existing thing by name"
	smartThing fullVO: #self.  						"because it gets a new structure"
	self copySourcesOn: smartThing. 
	summary ifNil: [smartThing summary: (sources, tmpSources collect: [:s|s summaryEnriched]) asCommaString] . 
	self clearTmpSources.  
	^smartThing.
! !

!GbtDirective methodsFor: 'api' stamp: 'hk 1/23/2018 14:42'!
copy: aThingOrList onto: aTarget
	"paste each of aThingOrList onto a new copy of aTarget"

	| res tList|   
	tList := aThingOrList isCollection ifTrue: [aThingOrList] ifFalse: [{aThingOrList}].
	res := tList collect: [:t| self paste: t onto: aTarget copy].
	^aThingOrList isCollection ifTrue: [res] ifFalse: [res first]! !

!GbtDirective methodsFor: 'copying' stamp: 'hk 5/7/2017 22:50'!
copyBuildinSlotsOn: emptyThing
	self idNumberPolicy ifNotNil: [:p| emptyThing idNumberPolicy: p].
	emptyThing bizApp: self bizApp.
	summary ifNotNil: [:s| emptyThing summary: s].! !

!GbtDirective methodsFor: 'copying' stamp: 'hk 11/20/2017 18:28'!
copySourcesOn: emptyThing
	"paste all projected source slots into emptyThing"

	self copyBuildinSlotsOn: emptyThing.	
	self slots do: [:sa|   
		(self slotSVOAt: sa key) ifNotNil: [:t| 		"ignore slots not found"
			emptyThing writeSlot: (GbtSlotAssociation 
				key: sa key 
				value: t copy)]] .
	^emptyThing 
! !

!GbtDirective methodsFor: 'accessing slots' stamp: 'hk 9/24/2017 15:38'!
declSlots
	^slots select: [ :s |s isDirective ]
	! !

!GbtDirective methodsFor: 'define' stamp: 'hk 7/30/2015 17:12'!
define: aSlotName 
	"define a slot projecting from a slotName"
	
	self define: aSlotName tag: aSlotName asSymbol! !

!GbtDirective methodsFor: 'authoring ' stamp: 'hk 10/18/2017 15:58'!
define: slotName decl: aDirective
	"define a slot projecting from a tag"
	
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [aDirective isDirective] toBe: #aDirective.

	self writeSlot: (GbtSlotAssociation key: slotName asSymbol value: aDirective)! !

!GbtDirective methodsFor: 'authoring ' stamp: 'hk 10/18/2017 15:58'!
define: slotName list: anArray
	"define a slot for transforming a list"
	
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [(anArray first isString)&(anArray second isDirective)] toBe: #anArrayOfTagAndDirective.
	self check: [(anArray at: 3 ifAbsent: [GbtSmartNode new]) isThing] toBe: #aThingOrNil.

	self writeSlot: (GbtSlotAssociation key: slotName asSymbol value: anArray)! !

!GbtDirective methodsFor: 'authoring ' stamp: 'hk 10/18/2017 15:58'!
define: slotName tag: aSymbol
	"define a slot projecting from a tag"
	
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [aSymbol isNil or: [aSymbol isSymbol] ] toBe: #SymbolOrNil.

	self writeSlot: (GbtSlotAssociation key: slotName asSymbol value: aSymbol)! !

!GbtDirective methodsFor: 'define' stamp: 'hk 5/3/2017 17:22'!
defineFrom: spec   
	spec do: [ :defArray | defArray size = 1 
		ifTrue: [ self perform: #define:  withArguments: defArray ] 	"tags"
		ifFalse: [self defineWith: defArray  ] ] 							"others"! !

!GbtDirective methodsFor: 'parser production' stamp: 'hk 5/8/2017 19:38'!
defineIntrinsicsWith: defArray 
	defArray do: [:e| self defineIntrinsicWith: e]! !

!GbtDirective methodsFor: 'parser production' stamp: 'hk 5/8/2017 19:43'!
defineSlotsWith: slotArray 
	slotArray do: [:e| self perform: #define dsl: e]! !

!GbtDirective methodsFor: 'parser production' stamp: 'hk 5/9/2017 11:02'!
defineTagsWith: tagArray 
	tagArray do: [:e| self define: e key asSymbol tag: e value asSymbol]! !

!GbtDirective methodsFor: 'define' stamp: 'hk 5/5/2017 18:22'!
defineWith: defArray   
	(self defineIntrinsicWith: defArray) ifTrue: [ ^self ].
	defArray second ifNil: [^self error: 'unknown define for ', self svoName].
	defArray second = #tag: ifTrue: [^self perform: #define:tag: withArguments: (defArray copyWithoutIndex: 2)].
	defArray second = #decl: ifTrue: [^self perform: #define:decl: withArguments: (defArray copyWithoutIndex: 2)].
	defArray second = #list: ifTrue: [^self perform: #define:list: withArguments: (defArray copyWithoutIndex: 2)].
	self perform: #define: dsl: defArray! !

!GbtDirective methodsFor: 'reflective operations' stamp: 'hk 11/30/2017 16:23'!
doesNotUnderstand: aMessage 
	"answer the slot res the value named by aMessage 
	or change a valueSlot"
	
	| sel getter result |
	sel := aMessage selector.
	getter := (sel trimRight: [ :c | c = $: ]) asSymbol .
	result := self slotSVOAt: getter ifAbsent: "not my node"
			[^super doesNotUnderstand: aMessage] .	
	sel isKeyword ifTrue:		"is setter"
		[ ^result isSmartValue 	"is leaf"
			ifTrue: [ result inputValue: aMessage argument] 
			ifFalse: [super doesNotUnderstand: aMessage]].

	^result isSmartValue ifTrue: [ result val ] ifFalse: [ result]
	! !

!GbtDirective methodsFor: 'gbtDecompile' stamp: 'hk 11/3/2017 14:00'!
gbtSourceOn: aStream
	aStream 
		nextPutAll: 'directive ';
		nextPutAll: self svoName; 
		nextPutAll: ' {'; cr.
	slots do: [:s| 
		aStream tab. 
		s gbtDirectiveSlotSourceOn: aStream].
	aStream tab; nextPut: $}; cr
	
		
	! !

!GbtDirective methodsFor: 'initialization' stamp: 'hk 9/22/2017 15:04'!
initialize
	super initialize.
	self clearSources.
	self clearTmpSources! !

!GbtDirective methodsFor: 'testing' stamp: 'hk 9/24/2017 15:38'!
isDirective
	^true! !

!GbtDirective methodsFor: 'private' stamp: 'hk 11/6/2017 21:06'!
listSlotAt: arrayOfTagAndDeclAndFilter ifAbsent: aBlock 
	"the tag target is a Ulist. answer a transformed (by decl) Ulist"
	
	| tag decl uList filter |  
	tag := arrayOfTagAndDeclAndFilter first.
	decl := arrayOfTagAndDeclAndFilter second.
	filter := arrayOfTagAndDeclAndFilter at: 3 ifAbsent: [].
	uList := self sourceSlotAt: tag ifAbsent: [^aBlock].
	(uList isKindOf: GbtNodeList) ifFalse: [^aBlock].
	^decl newList: uList filteredBy: filter
	! !

!GbtDirective methodsFor: 'private' stamp: 'hk 11/6/2017 21:06'!
newList: uList filteredBy: aFilterThing
	"answer a new Ulist with elements transdformed by me and filtered "
	| newList declName|
	newList := GbtNodeList new.
	declName := svoName.		"memorize name"
	uList list do: 	[:e| 	 	"need a unique name for each directive / list element ..."
		self svoName: declName, e bizId . 	"pre: UList element must have bizID"
		newList newEntry: (self transform: e )].
	self svoName: declName.	"restore memorized name"
	^newList
	! !

!GbtDirective methodsFor: 'api' stamp: 'hk 11/11/2017 16:40'!
paste: aThing onto: target
	"paste the data of aThing into target, but keep protected slots of target"

	self tagSlots do: 
		[ :s | |oldSlot k t | 
		k := s key. t := s value.
		t isSymbol 
			ifFalse: ["or aDirective" t paste: (aThing perform: k) onto: target ] 
			ifTrue: 
				[([aThing perform: k] ifError: ["no source"]) copy ifNotNil: [:newSlot| 
					oldSlot := target slotSVOAt: t. 		
					((newSlot isKindOf: GbtSmartNode) and:[oldSlot isKindOf: GbtSmartNode])
						ifTrue: [newSlot embedProtectedSlotsOf: oldSlot].
					target perform: t asMutator with: newSlot ]]].
	^target! !

!GbtDirective methodsFor: 'copying' stamp: 'hk 5/10/2017 17:00'!
postCopy
	super postCopy.
	self declSlots keysAndValuesDo: [ :k :v| slots at: k put: v copyValue ].
	self clearSources 
	! !

!GbtDirective methodsFor: 'printing' stamp: 'hk 8/3/2015 15:46'!
printOn: aStream
	aStream nextPutAll: self longName "substrings first" ! !

!GbtDirective methodsFor: 'accessing slots' stamp: 'hk 9/25/2017 16:24'!
slotSVOAt: aSlotName ifAbsent: aBlock
	"for view functionality: answer the projected source leaf or node.
	or the own smartNode like slot"

	| sv |
	sv := (self slotAt: aSlotName) value.
	sv isSymbol ifTrue: "answer the source leaf or node if not private"
		[^self sourceSlotAt: sv ifAbsent: aBlock].	
	sv isArray ifTrue: "answer a transformed list node"
		[^self listSlotAt: sv ifAbsent: aBlock].
	sv isDirective ifTrue: "answer a node transformed by the directive in this slot"
		[^sv compose: (tmpSources, sources)]! !

!GbtDirective methodsFor: 'private' stamp: 'hk 11/20/2017 18:44'!
sourceSlotAt: tag ifAbsent: aBlock 
	"answer the slot VO, i.e. own node or source node.
	note that a further source node with same tag will be masked"
	
	| res  |  
	tmpSources, sources do: [ :s | "sequence is critical: first sources win"  
		((s respondsTo: tag) and: [(s perform: tag) ~= #nil ]) ifTrue: [^GbtString withValue: (s perform: tag )].	"for direct attributes like bizId"
		res := s slotTagged: tag.
		res ifNotNil: [^res]].
	 ^aBlock value
  ! !

!GbtDirective methodsFor: 'initialization' stamp: 'hk 1/12/2017 12:27'!
sources: oneOrMoreThing   
	"set a single source or a list thereof. clear with nil"
	
	oneOrMoreThing ifNil: [^self clearSources].	
	sources := (self checkThingMakeColl: oneOrMoreThing) ! !

!GbtDirective methodsFor: 'accessing slots' stamp: 'hk 9/24/2017 15:38'!
tagSlots
	^slots select: [ :s | s isTag  or: [s isDirective] ]
	! !

!GbtDirective methodsFor: 'api' stamp: 'hk 11/10/2017 13:05'!
transform: aThingOrList
	"transform (using compose) a thing or list of things"

	aThingOrList isCollection
		ifTrue: [ ^ aThingOrList collect: [ :e | self compose: e] ].
	^ self compose: aThingOrList! !

!GbtDirective methodsFor: 'api' stamp: 'hk 11/24/2017 15:34'!
transform: aThingOrList withSource: aThingList
	"combine aThingOrList of things using complementing sources of aThingList"
	
	aThingList ifEmpty: [^self transform: aThingOrList].
	aThingOrList isCollection
		ifTrue: [ ^ aThingOrList collect: [ :e | self compose: {e}, aThingList] ].
	^ self compose: {aThingOrList}, aThingList! !

!GbtDirective methodsFor: 'api' stamp: 'hk 9/24/2017 15:42'!
viewOn: aThingOrList 
	"answer a new Directive with sources aThingOrList.
	used as 
	-	a projector - eg in an editor - or
	-	a partly defined transformation"
	
	^self copy sources: aThingOrList! !

!GbtFrame class methodsFor: 'retrieving' stamp: 'hk 9/24/2017 15:48'!
definedAs: aName
	"answer the Directive or Thing with aName. Also see #definedAs:idAbsent"
	
	^ self definedAs: aName ifAbsent: [] ! !

!GbtFrame class methodsFor: 'retrieving' stamp: 'hk 8/16/2017 17:15'!
definedAs: aName ifAbsent: absentBlock
	"answer the Type named svoName"
	
	^GbtServer default type: self type named: aName ifAbsent: absentBlock! !

!GbtFrame class methodsFor: 'accessing' stamp: 'hk 5/5/2017 16:21'!
new: aString define: definitionArray
	^self subclassResponsibility ! !

!GbtFrame class methodsFor: 'authoring' stamp: 'hk 5/5/2017 16:19'!
struct: aString define: definitionArray
	"answer the type aString. If new, define it"

	^self definedAs: aString ifAbsent: [self new: aString define: definitionArray] 
		! !

!GbtFrame class methodsFor: 'accessing' stamp: 'hk 5/5/2017 15:54'!
type
	^self subclassResponsibility ! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 8/22/2017 13:26'!
allReferenceSlots
	"answer a collection of all slot values (SVO) with tag or slotName aTag"

	| coll |
	coll := (self slotValues select: [:s| s isReference]) asOrderedCollection.
	self subnodes do: [ :sn | coll addAll: (sn allReferenceSlots)].
	^ coll! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 9/5/2017 13:11'!
allSlotSVOsTagged: aTag
	"answer a collection of all slot values (SVO) with tag or slotName aTag"

	| coll |
	coll := (slots select: [:s| s hasTag: aTag]) collect: [:s| s value].
	coll := coll values asOrderedCollection.
	self subnodes do: [ :sn | coll addAll: (sn allSlotSVOsTagged: aTag)].
	^ coll! !

!GbtFrame methodsFor: 'CIEL parser' stamp: 'hk 1/14/2018 15:00'!
atSmartPath: aSelector
	"thing compatibility"  
	^self perform: aSelector first asSymbol! !

!GbtFrame methodsFor: 'copying' stamp: 'hk 2/20/2017 18:23'!
copySlots
	slots := slots copy.! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 12/19/2016 17:44'!
define: slotName constraint: aStringWithTags
	self define: slotName constraint: aStringWithTags ifViolated: nil! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 10/18/2017 15:58'!
define: slotName constraint: aStringWithTags ifViolated: aString
	"define a slot that calculates from tagged slots"
	
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [aStringWithTags isString] toBe: #String.
	
	self writeSlot: ((GbtSlotAssociation 
					key: slotName asSymbol 
					value: ((GbtConstraintCell withValue: aStringWithTags) violationString: aString))
					purposes: #();
					tags:  #() )! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:38'!
define: slotName date: aStringOrDate
	"define a date slot"
	
	self define: slotName  date: aStringOrDate for: #() tag: #()! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:38'!
define: slotName date: aStringOrDate for: aColl 
	"define a date slot"
	
	self define: slotName  date: aStringOrDate for: aColl tag: #()! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:38'!
define: slotName  date: aStringOrDate for: anArray tag: tagOrColl
	"define a tagged date slot"

	self define: slotName  date: aStringOrDate for: anArray tag: tagOrColl private: nil! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 10/18/2017 15:58'!
define: slotName  date: aString for: anArray tag: tagOrColl private: aBool
	"define a date slot"

	| tagArr |
	self check: [slotName isString] toBe: #StringOrSymbol.
	tagArr := self checkStringMakeColl: tagOrColl .
	self check: [anArray isCollection & (anArray isString not)] toBe: #aCollection.
	
	self writeSlot: ((GbtSlotAssociation 
					key: slotName asSymbol 
					value: (GbtDate withDate: aString))
					purposes: anArray;
					tags: tagArr;
					protected: aBool)! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:38'!
define: slotName date: aStringOrDate private: aBool
	"define a date slot"
	
	self define: slotName  date: aStringOrDate for: #() tag: #() private: aBool! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:38'!
define: slotName  date: aStringOrDate tag: tagOrColl
	"define a tagged date slot"

	self define: slotName  date: aStringOrDate for: #() tag: tagOrColl! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:37'!
define: slotName enum: arrayOfString
	"define a enumeration slot"
	
	self define: slotName  enum: arrayOfString for: #() tag: #() ! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:37'!
define: slotName enum: arrayOfString for: aColl
	"define a enumeration slot"
	
	self define: slotName  enum: arrayOfString for: aColl tag: #() ! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:37'!
define: slotName  enum: arrayOfString for: anArray tag: tagOrColl 
	"define a tagged enumeration slot"
	
	self define: slotName  enum: arrayOfString for: anArray tag: tagOrColl private: nil! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 11/30/2017 17:30'!
define: slotName  enum: arrayOfString for: anArray tag: tagOrColl private: aBool
	"define a enumeration slot"
	
	| tagArr |
	self check: [slotName isString] toBe: #StringOrSymbol.
	tagArr := self checkStringMakeColl: tagOrColl .
	self check: [anArray isCollection & (anArray isString not)] toBe: #aCollection.

	self writeSlot: ((GbtSlotAssociation 
					key: slotName asSymbol 
					value: ((GbtString withValue: arrayOfString) uiClassName: #GbtChoiceWidget))
					purposes: anArray;
					tags: tagArr;
					protected: aBool)! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:37'!
define: slotName enum: arrayOfString private: aBool
	"define a enumeration slot"
	
	self define: slotName  enum: arrayOfString for: #() tag: #() private: aBool! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:37'!
define: slotName  enum: arrayOfString tag: tagOrColl 
	"define a tagged enumeration slot"
	
	self define: slotName  enum: arrayOfString for: #() tag: tagOrColl ! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 11/30/2017 17:29'!
define: slotName enumSelect: aStringOrNumber
	"select an enum item as default"
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [aStringOrNumber isString | aStringOrNumber isNumber] toBe: #aStringOrNumber.

	((self slotTagged: slotName) ifNil: [^self inform: slotName,' not found'])
		inputValue: aStringOrNumber
	
	
	 ! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 8/26/2017 12:44'!
define: slotName list: aList of: oneOrMoreAsvo 
	"define a list slot of a single type or union type"

	self define: slotName list: aList of: oneOrMoreAsvo display: #() for: #() tag: #() private: nil! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 11/6/2017 21:06'!
define: slotName  list: element of: template display: anArray for: aColl tag: tagOrColl private: aBool
	"define a tagged list slot with elements and templates"
	
	| list elements coll tagArr |
	self check: [slotName isString] toBe: #StringOrSymbol.
	elements := element asCollection.
	anArray ifNotNil: 
		[self check: [anArray asCollection allSatisfy: [:e|e isSymbol]] toBe: #anArrayOfSymbols].
	coll := aColl ifNil: [ #() ].
	self check: [coll isCollection & (coll isString not)] toBe: #aCollection.
	self check: [elements  allSatisfy: [:e| e isKindOf: GbtSmartNode ]] toBe: #aCollectionOfThings.
	tagArr := self checkStringMakeColl: tagOrColl .

	list :=  (GbtNodeList withTemplates: template) displayColumns: anArray .
	elements do: [ :e |list newEntry: e ] .
	self writeSlot: ((GbtSlotAssociation 
					key: slotName asSymbol 
					value:  list  )
					purposes: coll;
					tags: tagArr;
					protected: aBool ) ! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 1/7/2016 16:39'!
define: slotName listOf: oneOrMoreAsvo 
	"define a list slot of a single type or union type"

	self define: slotName listOf: oneOrMoreAsvo for: nil ! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 1/7/2016 16:38'!
define: slotName listOf: oneOrMoreAsvo display: anArray
	"define a list slot of a single type or union type"

	self define: slotName listOf: oneOrMoreAsvo for: nil display: anArray! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 6/30/2016 13:06'!
define: slotName listOf: oneOrMoreAsvo for: aPurposeColl 
	"define a list slot of a single type or union type"
	self define: slotName listOf: oneOrMoreAsvo for: aPurposeColl display: nil! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/21/2017 19:33'!
define: slotName listOf: oneOrMoreAsvo for: aColl display: anArray
	"define a list slot of a single type or union type"

	self define: slotName list: #() of: oneOrMoreAsvo display: anArray for: aColl tag: #() private: nil! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:34'!
define: slotName no: aNumber 
	"define an interval slot"
	
	self define: slotName no: aNumber tag: #()! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:33'!
define: slotName no: aNumber for: aColl
	"define an interval slot"

	self define: slotName no: aNumber for: aColl tag: #()! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 10/18/2017 15:58'!
define: slotName no: aNumber for: anArray tag: tagOrColl 
	"define a tagged interval slot"
	
	| tagArr |
	self check: [slotName isString] toBe: #StringOrSymbol.
	tagArr := self checkStringMakeColl: tagOrColl .
	self check: [anArray isCollection & (anArray isString not)] toBe: #aCollection.
	self check: [aNumber isNil or: [aNumber isString or: [aNumber isNumber]]] toBe: #aNumberOrString.

	self writeSlot: ((GbtSlotAssociation 
					key: slotName asSymbol 
					value: (GbtNumber new inputValue: aNumber))
					purposes: anArray;
					tags: tagArr )! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 8/21/2017 15:46'!
define: slotName no: aNumber tag: tagOrColl
	"define an interval slot"
	
	self define: slotName no: aNumber for: #() tag: tagOrColl! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 8/21/2017 17:16'!
define: slotName  ref: aStringWithTags 
	"define a slot that calculates from tagged slots"

	self define: slotName ref: aStringWithTags for: #() tag: #() ! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 8/21/2017 17:16'!
define: slotName  ref: aStringWithTags for: aColl
	"define a slot that calculates from tagged slots"

	self define: slotName  ref: aStringWithTags for: aColl tag: #()! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 10/18/2017 15:58'!
define: slotName ref: aStringWithTags for: anArray tag: tagOrColl 
	"define a slot that calculates from tagged slots"
	
	| tagArr |
	self check: [slotName isString] toBe: #StringOrSymbol.
	self check: [aStringWithTags isString] toBe: #String.
	tagArr := self checkStringMakeColl: tagOrColl .
	self check: [anArray isCollection & (anArray isString not)] toBe: #aCollection.
	
	self writeSlot: ((GbtSlotAssociation 
					key: slotName asSymbol 
					value: (GbtReference withValue: aStringWithTags))
					purposes: anArray;
					tags: tagArr)! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 8/21/2017 17:16'!
define: slotName  ref: aStringWithTags tag: tagOrColl 
	"define a slot that calculates from tagged slots"
	
	self define: slotName ref: aStringWithTags for: #() tag: tagOrColl ! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:32'!
define: slotName text: aText
	"define a text slot"
	
	self define: slotName text: aText tag: #()! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:32'!
define: slotName text: aText for: aColl
	"define a text slot"
	
	self define: slotName text: aText for: aColl tag: #()! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:31'!
define: slotName  text: aText for: anArray tag: tagOrColl 
	"define a tagged text slot"
	self define: slotName  text: aText for: anArray tag: tagOrColl private: nil! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 11/30/2017 15:01'!
define: slotName  text: aText for: anArray tag: tagOrColl private: aBoolean
	"define a text slot"
	
	| tagArr |
	self check: [slotName isString] toBe: #StringOrSymbol.
	tagArr := self checkStringMakeColl: tagOrColl .
	self check: [anArray isCollection & (anArray isString not)] toBe: #aCollection.


	self writeSlot: ((GbtSlotAssociation 
					key: slotName asSymbol 
					value: (GbtText withValue: aText))
					purposes: anArray;
					tags: tagArr;
					protected: aBoolean)! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:32'!
define: slotName text: aText private: aBoolean
	"define a text slot"
	
	self define: slotName text: aText for: #() tag: #() private: aBoolean! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:32'!
define: slotName  text: aText tag: tagOrColl 
	"define a tagged text slot"
	
	self define: slotName  text: aText for: #() tag: tagOrColl 
! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:23'!
define: slotName thing: aGbtThing
	"define a subnode slot"
	
	self define: slotName thing: aGbtThing tag: #()! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:22'!
define: slotName thing: aGbtThing for: aColl
	"define a subnode slot"
	
	self define: slotName thing: aGbtThing for: aColl tag: #()! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:30'!
define: slotName  thing: aSmartThing for: anArray tag: tagOrColl 
	"define a tagged subnode slot in a master (full thing) tree "
	
	self define: slotName  thing: aSmartThing for: anArray tag: tagOrColl private: nil! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 11/30/2017 14:31'!
define: slotName  thing: aThing for: anArray tag: tagOrColl private: aBoolean
	"define a subnode slot in a master (full thing) tree "
	
	| node assoc tagArr |
	self check: [slotName isString] toBe: #StringOrSymbol.
	tagArr := self checkStringMakeColl: tagOrColl .
	self check: [anArray isCollection & (anArray isString not)] toBe: #aCollection.
	node := self isSmart ifTrue: [aThing] ifFalse: [aThing fullThing].
	assoc := (GbtSlotAssociation 								
					key: slotName asSymbol 
					value: node)
					purposes: anArray;
					tags: tagArr;
					protected: aBoolean.
	self isSmart ifFalse: [assoc thingTemplates: {aThing longName}].
	self writeSlot: assoc! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:22'!
define: slotName thing: aGbtThing private: aBoolean
	"define a subnode slot"
	
	self define: slotName thing: aGbtThing for: #() tag: #() private: aBoolean! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:30'!
define: slotName  thing: aGbtThing tag: tagOrColl 
	"define a tagged subnode slot"
	
	self define: slotName  thing: aGbtThing for: #() tag: tagOrColl 
! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 6/30/2015 20:11'!
define: slotName val: aString
	"define a value slot"
	
	self define: slotName val: aString tag: nil! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:21'!
define: slotName val: aString for: aColl
	"define a value slot for purposes aColl"
	
	self define: slotName  val: aString for: aColl tag: #()! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:29'!
define: slotName  val: aString for: anArray tag: tagOrColl 
	"define a tagged value slot"
	
	self define: slotName  val: aString for: anArray tag: tagOrColl private: nil! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 10/18/2017 15:58'!
define: slotName  val: aString for: anArray tag: tagOrColl private: aBool
	"define a value slot"
	
	| tagArr |
	self check: [slotName isString] toBe: #StringOrSymbol.
	tagArr := self checkStringMakeColl: tagOrColl .
	self check: [anArray isCollection & (anArray isString not)] toBe: #aCollection.

	self writeSlot: ((GbtSlotAssociation 
					key: slotName asSymbol 
					value: (GbtString withValue: aString) )
					purposes: anArray;
					tags:  tagArr ;
					protected: aBool)! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 4/15/2017 14:20'!
define: slotName val: aString private: aBool
	"define a value slot"
	
	self define: slotName val: aString for: #() tag: #() private: aBool! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 10/31/2015 18:39'!
define: slotName  val: aString tag: aSymbol 
	"define a tagged value slot"
	
	self define: slotName  val: aString for: #() tag: aSymbol ! !

!GbtFrame methodsFor: 'define' stamp: 'hk 5/5/2017 18:20'!
defineIntrinsicWith: defArray
	"intrinsic slots known by decls and smart things"
	defArray first = #name ifTrue: [self error: '<name> not allowed as slotName'].		"Spec constraint"
	defArray first = #label ifTrue: [self error: '<label> not allowed as slotName'].	"Spec constraint"
	defArray first = #idNumberPolicy ifTrue: [self idNumberPolicy: defArray second. ^true].
	defArray first = #summary ifTrue: [self summary: defArray second. ^true].
	^false! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 5/14/2017 14:32'!
hasSlotAt: aSlotName 
	^(self slotAt: aSlotName) isNotNil
! !

!GbtFrame methodsFor: 'accessing' stamp: 'hk 8/10/2016 16:24'!
idNumberPolicy
	^idNumberPolicy! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 5/3/2017 17:18'!
idNumberPolicy: aName
	aName ifNil: [ ^self ].
	self check: [ aName isString ] toBe: #aString.
	idNumberPolicy := aName asSymbol  . ! !

!GbtFrame methodsFor: 'initialization' stamp: 'hk 9/24/2017 15:19'!
initialize
	super initialize.
	self initializeSlots! !

!GbtFrame methodsFor: 'initialization' stamp: 'hk 9/24/2017 15:19'!
initializeSlots
	slots := OrderedIdentityDictionary new! !

!GbtFrame methodsFor: 'testing' stamp: 'hk 5/31/2017 14:16'!
isPlaceholder
	"for parsing"
	^false! !

!GbtFrame methodsFor: 'define' stamp: 'hk 2/9/2016 14:13'!
perform: aSelector dsl: subArr
	| sel args |
	sel := aSelector.
	args := subArr .
	subArr size > 1 ifTrue: 	
		[sel := (sel, (subArr at: 2)) asSymbol.
		args := subArr copyWithoutIndex: 2 ].
	(self respondsTo: sel) ifFalse: [self error: 'cannot author ', sel].
	self perform: sel asSymbol withArguments: args asArray! !

!GbtFrame methodsFor: 'copying' stamp: 'hk 5/10/2017 16:52'!
postCopy
	super postCopy.
	self copySlots! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 9/5/2017 16:57'!
protectedSlots
	^ (slots select: [:a |a isProtected and: [a value isNotNil] ]) values! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 2/17/2017 16:03'!
slotAt: aSlotName 
	"answer the slot, i.e. the Association"
	^self slotAt: aSlotName ifAbsent: []
! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 9/28/2017 18:41'!
slotAt: aSlotName ifAbsent: aBlock
	"answer the GbtSlotAssociation"
	^slots at: aSlotName asSymbol ifAbsent: [aBlock value].
	! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 5/3/2017 15:19'!
slotNames
	^ slots keys! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 9/24/2017 15:18'!
slotSVOAt: aSlotName
	^ self slotSVOAt: aSlotName ifAbsent: [ ]! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 2/17/2017 16:04'!
slotSVOAt: aSlotName ifAbsent: aBlock
	"answer the slot value (SVO)"
	^(self slotAt: aSlotName ifAbsent: [^aBlock value]) value! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 10/19/2017 13:02'!
slotSVOAt: aSlotName put: aVal
	"PRE slot exists"
	^(self slotAt: aSlotName ifAbsent: [self error: 'no slot ',aSlotName]) value: aVal! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 5/3/2017 15:19'!
slotValues
	^ slots values! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 5/19/2017 18:17'!
slotWith: aSVO   
	^slots detect: [:s| s value value == aSVO] ifNone: [^nil]! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 9/24/2017 15:18'!
slots
	^ slots! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 9/24/2017 15:19'!
slots: aNewDictionary
	slots := aNewDictionary! !

!GbtFrame methodsFor: 'accessing' stamp: 'hk 1/11/2018 12:21'!
summary
	^summary ifNil: [ self svoName ]! !

!GbtFrame methodsFor: 'authoring' stamp: 'hk 5/3/2017 17:01'!
summary: aString
	aString ifNil: [^self].
	self check: [aString isString] toBe: #aString.  
	summary := aString! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 5/3/2017 15:20'!
tagsAtSlot: aSlotName 
	"answer the tags of slot aSlotName or nil"
	^self tagsAtSlot: aSlotName ifAbsent: []
! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 5/3/2017 15:20'!
tagsAtSlot: aSlotName ifAbsent: aBlock
	"answer the tags of the slotAssociation"
	^(self slotAt: aSlotName ifAbsent: [^aBlock value]) tags! !

!GbtFrame methodsFor: 'accessing slots' stamp: 'hk 10/18/2017 15:58'!
writeSlot: aGbtSlotAssociation
	aGbtSlotAssociation container: self.
	slots at: aGbtSlotAssociation key put: aGbtSlotAssociation! !

GbtFrame subclass: #GbtSmartNode
	uses: TGbtSerializer + TGbtEvolve + TGbtThingMeta
	instanceVariableNames: 'context purposes smart fullVO searchStrategy deleted consistent constraintViolationString defaultPolicy otherUserEdits saveContext next previous evolveCounter originalSmart bizId constraintErrorString uiClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Things'!

!GbtSmartNode commentStamp: 'hk 11/27/2017 21:16' prior: 0!
I am a node in the tree of a (semantic) Domain Thing. 
My root node's svoName is the name of the Domain Thing.
My slots are  GbtSlotAssociations with leaves (GbtSmartValue) or other nodes (GbtSmartNode)  

I come as an intertwined doublet  with my  full node (of same structure) that knows my potential structure.

Instance variables:
	bizId:			<nil | String>						application ID
	consistent: 		<nil|Boolean>					after testing constraints 
	constraintViolationString	<String>					All violations
	context: 			<Array | nil> 						of {AC svoName  .  AC user}
 	defaultPolicy: 	< GbtNoPolicy>
	deleted: 			<Boolean|nil>					will be saved but not be read in, nil = false
	evolveCounter:	<nil / integer> 					for  GbtEvolve trait
	fullVO 			<#self | Array of Symbol | nil>		Array of svoName autoName
	next:  			<GbtSmartNode | nil>				next node of my evolution (for  GbtEvolve trait)
	originalSmart: 	<GbtSmartNode | nil>				full thing only:  original smart thing 
	otherUserEdits: 	<Boolean>						true if edited/created by  other  user / same db			
	previous:		<GbtSmartNode | nil>				previous node of my evolution (for  GbtEvolve trait)
	purposes: 		<OrderedCollection of String>		usage of the thing
	saveContext: 	<Array | nil> 						used for save notifications           -             fishy !!!!!!
	searchStrategy 	<nil | Symbol>					nil: breadth search, notNil: depth first
	smart:			<Boolean> 						false for my full node, true for my smart self
	uiClassName 	<Symbol> 						name of uiClass other than the default
								
the longName is of the form  svoName,':', autoname =   \w+:[T|U][0-9]+v[0-9]+
 !

GbtSmartNode class
	uses: TGbtSerializer classTrait + TGbtEvolve classTrait + TGbtThingMeta classTrait
	instanceVariableNames: ''!

GbtSmartNode subclass: #GbtNodeList
	instanceVariableNames: 'templates displayColumns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Things'!

!GbtNodeList commentStamp: 'hk 10/30/2017 13:43' prior: 0!
I am a node thing that treats its subnodes as a list.
The slotNames are defined by my numberPolicy.
I am transparent for Directives as View.

    Instance Variables
	templates		<Collection of ThingVO.longName>		templates for  exemplars
	displayColumns:	<Array of Symbol>					slotNames to display

displayColumns can be authored with symbols or pairs. Needs to be resolved.

!

!GbtNodeList class methodsFor: 'instance creation' stamp: 'hk 3/21/2017 14:09'!
new
	^self basicNew initialize; setID; yourself
! !

!GbtNodeList class methodsFor: 'authoring' stamp: 'hk 3/14/2017 13:01'!
struct: aString define: definitionArray
	^self shouldNotImplement ! !

!GbtNodeList class methodsFor: 'accessing' stamp: 'hk 5/11/2016 12:46'!
uiClass
	^ GbtListWidget ! !

!GbtNodeList class methodsFor: 'authoring' stamp: 'hk 4/21/2017 21:15'!
withTemplates: stringOrThingOrArrayOf
	"names with parser - things with St-DSL"
	^self new templates: stringOrThingOrArrayOf.
! !

!GbtNodeList methodsFor: 'authoring' stamp: 'hk 12/29/2017 18:55'!
addTemplate: aASVO
	"tell a template"
	aASVO ifString: [templates add: aASVO. ^self].
	templates add: aASVO longName ! !

!GbtNodeList methodsFor: 'accessing' stamp: 'hk 6/22/2016 16:22'!
classInitial
	^#U! !

!GbtNodeList methodsFor: 'accessing' stamp: 'hk 10/30/2017 12:59'!
displayColumns
	^displayColumns ifNil: [#()]! !

!GbtNodeList methodsFor: 'accessing' stamp: 'hk 8/10/2015 17:34'!
displayColumns: anArray
	"tell the slots to be displayed in the list"
	
	displayColumns := anArray ! !

!GbtNodeList methodsFor: 'printing' stamp: 'hk 10/30/2017 12:59'!
displayStringFor: item
	"answer the row content of an Ulist item for my UIclass"
	
	| stream |
	stream := WriteStream on: ''.
	(item displayArrayFrom: self displayColumns) do: [ :str | stream nextPutAll: str; space; space ].
	^stream contents! !

!GbtNodeList methodsFor: 'accessing' stamp: 'hk 4/30/2016 18:03'!
enrichFromTags: aString
	"ignore aString. Just take the summaries of my elements"
	
	| res |  
	(res := WriteStream on: '') nextPutAll: ' -- ' . 
	self list do: [ :e| res nextPutAll: (e enrichFromTags: e summary) . res nextPutAll: ' -- ' ].
	^res contents! !

!GbtNodeList methodsFor: 'gbtDecompile' stamp: 'hk 1/25/2018 18:44'!
gbtSlotSource: aName on: aStream
	aStream nextPutAll: 'list'; space.
	aStream nextPutAll: aName; tab.
	aStream nextPut: $:; space.
	self templates do: [:t| aStream nextPutAll: t; space].
	^String streamContents: [:s | self displayColumns asStringOn: s delimiter: ' ']
		
	! !

!GbtNodeList methodsFor: 'initialization' stamp: 'hk 12/29/2017 18:00'!
initialize
	super initialize.
	svoName := #Ulist.
	templates := Set new! !

!GbtNodeList methodsFor: 'testing' stamp: 'hk 11/6/2017 21:07'!
isNodeList
	^true! !

!GbtNodeList methodsFor: 'testing' stamp: 'hk 1/24/2016 12:49'!
isThing
	^false! !

!GbtNodeList methodsFor: 'api' stamp: 'hk 10/24/2015 19:20'!
list
	"UlistVO new list"
	^self subnodes asOrderedCollection! !

!GbtNodeList methodsFor: 'api' stamp: 'hk 6/25/2015 10:38'!
listSize
	^self list size! !

!GbtNodeList methodsFor: 'api' stamp: 'hk 3/22/2017 18:22'!
newEntry
	"add a list element from the first or only template"
	
	^self newEntry: self templateThing copy 
	! !

!GbtNodeList methodsFor: 'authoring' stamp: 'hk 11/9/2017 11:29'!
newEntry: aThing
	"add a subnode / list element in a UlistVO"

	self check: [ aThing isNode ] toBe: #GbtSmartNode.
	self evolveAddSlot: ((GbtSlotAssociation 
							key: (self defaultPolicy nextID asSymbol) 
							value: aThing ) 
						purposes: aThing purposes).   
	^ aThing ! !

!GbtNodeList methodsFor: 'api' stamp: 'hk 7/30/2016 14:46'!
newEntry: aThing with: aPurpose
	"add a subnode / list element in a UlistVO. 
	Set aPurpose to be the first purpose"

	aThing purpose: aPurpose.
	self newEntry: aThing! !

!GbtNodeList methodsFor: 'authoring' stamp: 'hk 11/22/2017 17:13'!
newEntryAll: aThingList
	"add a subnode / list element in a UlistVO"

	aThingList do: [:th| self newEntry: th].
	^ (aThingList ifEmpty: [^self]) last ! !

!GbtNodeList methodsFor: 'copying' stamp: 'hk 2/15/2016 21:27'!
postCopy
	super postCopy.
	templates := templates copy.
	displayColumns := displayColumns copy .

	! !

!GbtNodeList methodsFor: 'printing' stamp: 'hk 8/24/2016 19:15'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' (' .
	aStream nextPutAll: self list size printString.
	aStream nextPutAll: ' items)'! !

!GbtNodeList methodsFor: 'save - retrieve - remove' stamp: 'hk 11/2/2016 15:18'!
saveTemplate: aThing   
	self addTemplate: aThing! !

!GbtNodeList methodsFor: 'analysing' stamp: 'hk 4/21/2017 21:04'!
structureNodes 
	"full things only"
	^self templateThings collect: [:t| t fullThing ]! !

!GbtNodeList methodsFor: 'accessing' stamp: 'hk 5/5/2017 15:29'!
templateThing
	^self bizApp thingNamed: self templates first! !

!GbtNodeList methodsFor: 'accessing' stamp: 'hk 5/5/2017 15:29'!
templateThingOf: aLongName
	^self bizApp thingNamed: aLongName! !

!GbtNodeList methodsFor: 'api' stamp: 'hk 12/29/2017 18:01'!
templateThings
	^self templates collect: [:ln| self bizApp thingNamed: ln ]! !

!GbtNodeList methodsFor: 'api' stamp: 'hk 12/29/2017 18:01'!
templates
	^templates asOrderedCollection! !

!GbtNodeList methodsFor: 'authoring' stamp: 'hk 12/29/2017 18:36'!
templates: stringOrThingOrArrayOf
	"replace all templates by these ones"
	
	((stringOrThingOrArrayOf isKindOf: Array)
		ifTrue: [stringOrThingOrArrayOf] 
		ifFalse: [{stringOrThingOrArrayOf}])
			do: [:e| self addTemplate: e]! !

!GbtSmartNode class methodsFor: 'retrieving' stamp: 'hk 5/5/2017 16:33'!
copy: aName 
	"answer a copy of the smart Thing aName or nil"
	^self copy: aName ifAbsent: []! !

!GbtSmartNode class methodsFor: 'retrieving' stamp: 'hk 5/5/2017 16:33'!
copy: aName ifAbsent: absentBlock
	^(self definedAs: aName ifAbsent: [^absentBlock value]) copy
		
! !

!GbtSmartNode class methodsFor: 'deserializing' stamp: ''!
fromString: aSerializedNode 
	^STON fromString: aSerializedNode ! !

!GbtSmartNode class methodsFor: 'instance creation' stamp: 'hk 8/26/2017 13:10'!
new: smartName 
	"define a new bare smart thing"
	
	^self basicNew svoName: smartName; initialize; setID.! !

!GbtSmartNode class methodsFor: 'parser production' stamp: 'hk 1/8/2018 14:42'!
new: smartName def: defArray add: smartSlotArray full: fullSlotArray
	"parser production : compose a new smart thing together with its full thing"
	
	| fullName fullThing smartThing|
	fullName := 'F', smartName.
	smartThing := self basicNew svoName: smartName; initialize; setID; fullVO: fullName; smart: true.
	fullThing := self basicNew svoName: fullName; initialize; setID; fullVO: #self; originalSmart: smartThing.
	defArray do: [:ar| 
		smartThing defineWith: ar.
		fullThing defineWith: ar].
	fullThing addSmart: smartSlotArray addFull: fullSlotArray.
	(GbtServer default) add: smartThing full: fullThing.  
	^smartThing ! !

!GbtSmartNode class methodsFor: 'instance creation' stamp: 'hk 5/5/2017 16:02'!
new: smartName define: smartDefArray 
	"define a new smart thing together with its full thing"
	
	^self new: smartName define: smartDefArray full: #()! !

!GbtSmartNode class methodsFor: 'instance creation' stamp: 'hk 8/26/2017 13:18'!
new: smartName define: smartDefArray full: restOfDefArray
	"define a new smart thing together with its full thing"
	
	| fullName fullThing smartThing|
	fullName := 'F', smartName.
	smartThing := (self new: smartName) fullVO: fullName.
	fullThing  := (self new: fullName) smart: false; originalSmart: smartThing.
	fullThing defineSmart: smartDefArray defineFull: restOfDefArray.
	GbtServer default add: smartThing full: fullThing.  
	^smartThing ! !

!GbtSmartNode class methodsFor: 'authoring' stamp: 'hk 5/5/2017 16:22'!
struct: aString define: smartDefArray 
	"answer a copy of the defined smart thing"

	^(super struct: aString define: smartDefArray) copy! !

!GbtSmartNode class methodsFor: 'authoring' stamp: 'hk 3/17/2017 20:06'!
struct: aString define: smartDefArray full: restDefArray
	"answer a copy of the thing typed aString - create and define the copy master if new"

	^(self definedAs: aString ifAbsent: 
		[self new: aString define: smartDefArray full: restDefArray]) copy! !

!GbtSmartNode class methodsFor: 'instance creation' stamp: 'hk 5/25/2017 18:10'!
transient
	"define a new smart thing. Don not store in BizApp.
	set its full thing to #self to enable edit during debug"
	
	^self basicNew initialize fullVO: #self! !

!GbtSmartNode class methodsFor: 'accessing' stamp: 'hk 5/5/2017 15:54'!
type
	^#thing! !

!GbtSmartNode class methodsFor: 'accessing' stamp: 'hk 5/11/2016 12:44'!
uiClass
	^ GbtVoWidget ! !

!GbtSmartNode methodsFor: 'comparing' stamp: 'hk 5/3/2017 17:46'!
= anotherThing
	"compares values on slot level" 
	anotherThing class = self class ifFalse: [^false].
	anotherThing svoName = self svoName ifFalse: [^false].
	slots size = anotherThing slots size ifFalse: [^false].
	self slotNames = anotherThing slotNames ifFalse: [ ^false ].
	self slotNames do: [:sn|
		((slots at: sn) value = ((anotherThing slots at: sn) value))
			ifFalse: [^false]].
	^true! !

!GbtSmartNode methodsFor: 'meta path' stamp: ''!
addNodesTo: nodesToVisit withPath: aPath
	"breadth-first search: add subnodes to nodesToVisit "

	self slots do: [ :a |  |p|
		p := aPath copy add: a key; yourself.
		nodesToVisit add: {p . a} ].
! !

!GbtSmartNode methodsFor: 'smart' stamp: 'hk 2/17/2017 16:12'!
addSlotsFor: definitionArray
	definitionArray do: [:sn | self smartAddSlotSVO: sn] 
			! !

!GbtSmartNode methodsFor: 'parser production' stamp: 'hk 10/18/2017 15:58'!
addSmart: smartSlotArray addFull: fullSlotArray
	"parser production : (called only once on full thing) add slots to the smart & full thing"
	
	smartSlotArray do: [ :slot| originalSmart writeSlot: slot ].
	fullSlotArray do: [ :slot| self writeSlot: slot ]
		! !

!GbtSmartNode methodsFor: 'accessing leaf slots' stamp: 'hk 11/9/2017 15:46'!
allConstraintSVOs
	"answer all GbtConstraintLeafs in my hierarchy!!"
	| coll |
	coll := (self leafSVOs select: [:s| s isConstraint]) asOrderedCollection.
	self subnodes do: [:sn| coll addAll: (sn allConstraintSVOs)] .
	^ coll! !

!GbtSmartNode methodsFor: 'accessing leaf slots' stamp: 'hk 4/30/2017 18:37'!
allLeafSVOs
	| coll |
	coll := self leafSVOs asOrderedCollection.
	self subnodes do: [ :sn | coll addAll: (sn allLeafSVOs)] .
	^ coll! !

!GbtSmartNode methodsFor: 'ui helper' stamp: 'hk 11/30/2017 15:33'!
allSlotAssocsWithTemplates
	"GbtThing allFsvosWithTemplates"
	^(self slots select: [:a| a isNode and: [a thingTemplates isNotEmpty]]) values! !

!GbtSmartNode methodsFor: 'analysing' stamp: 'hk 11/16/2016 14:08'!
allStructureNodes
	"answer a collection of all structure nodes (full things for analysis)"
	
	^(self structureNodes flatCollect: [:n| n allStructureNodes] as: OrderedCollection) add: self; yourself
! !

!GbtSmartNode methodsFor: 'ui helper' stamp: 'hk 11/2/2016 12:42'!
asText
	^self asTextIndented: 0 aspect: ''! !

!GbtSmartNode methodsFor: 'ui helper' stamp: 'hk 2/17/2017 16:28'!
asTextIndented: int aspect: key

	| txt |
	txt := TextStream on: (Text new: 10) .
	txt tab: int ; nextPutAll: ((key, '  ', self svoName) asText addAttribute: TextEmphasis italic) .
	self leafCollBy3 do:  [ :ar3 | 
			txt crtab: (int + 2) . 
			1 to: ar3 size do: 
			[ :i | txt nextPutAll: ((ar3 at: i) at: 1) ; nextPut: $: ; space:2 ; nextPutAll: ((ar3 at: i) at: 2) ; tab; tab  ]  ] .
	txt cr.
	self nodeSlots do: [ :s | txt nextPutAll:  (s value asTextIndented: int + 1 aspect: s key) ].
	^txt contents
	! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 3/25/2017 12:57'!
askForNewTemplateSummary
	^UIManager default request: 'Please type new summary' initialAnswer: self summary
! !

!GbtSmartNode methodsFor: 'meta-smart path' stamp: ''!
atFullPath: aSmartPathArray
	"^nil or the result of accessing self with aSmartPathArray 					-			 used by GbtActions 
	POST as a side effect the branch denoted by aSmartPathArray exists"
	
	| res |
	res := self.  
	aSmartPathArray do: [:tag| res := res perform: tag asSymbol].
	^res! !

!GbtSmartNode methodsFor: 'meta-smart path' stamp: ''!
atSmartPath: aSmartPathArray
	"^ the result of accessing self with aSmartPathArray.
	a smartPathArray may start with 'G' or 'L' denoting global- or localRoot
	this method has NO side effects"
	
	| start spa |
	start := self.
	spa := aSmartPathArray.
	spa ifNotEmpty: [
		(spa first = #G) ifTrue: [start := self globalRoot. spa := spa allButFirst].
		(spa first = #L) ifTrue: [start := self localRoot. spa := spa allButFirst]].
	^start atSmartPath: spa with: OrderedCollection new! !

!GbtSmartNode methodsFor: 'evolve' stamp: ''!
becomeNext
	"become my next; set my previous. insert a new previous"

	self next ifNil: [^self].
	self previous: (self shallowCopy previous: self previous).
	self previous slots: self slots.
	self slots: self next slots.
	self setEvolveCountFromNext.
	self next: self next next.
	self buildContainerHierarchy ! !

!GbtSmartNode methodsFor: 'evolve' stamp: ''!
becomePrevious
	"become my previous; insert a new next"
	
	self previous ifNil: [^self].
	self next: (self shallowCopy next: self next).
	self next slots: self slots.
	self slots: self previous slots.
	self setEvolveCountFromPrevious.
	self previous: self previous previous.
	self buildContainerHierarchy ! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 9/8/2017 16:56'!
bizApp
	^bizApp ifNil: [(self container ifNil: [^super bizApp]) bizApp].
! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 2/11/2016 19:30'!
bizId
	^bizId asString! !

!GbtSmartNode methodsFor: 'authoring' stamp: 'hk 11/29/2016 14:05'!
bizId: aBizId
	bizId := aBizId! !

!GbtSmartNode methodsFor: 'meta path' stamp: ''!
broadPathTo: aTag onPath: aPath with: nodesToVisit
	"^<nil|OrderedCollection of Symbol>, the path of the node or leaf with the unique tag or slotName aTag"

	self addNodesTo: nodesToVisit withPath: aPath.

	[nodesToVisit isNotEmpty] whileTrue: [ | a p |
		a := nodesToVisit first at: 2.
		p := nodesToVisit first at: 1.
		(a hasTag: aTag) ifTrue: 
			[^{ #success . p} ] .
		a value ifNotNil: [:v | 
			v isNode ifTrue: 
				[v addNodesTo: nodesToVisit withPath: p]].
		nodesToVisit removeFirst ].
	^{ #failure . aPath}! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 8/10/2017 16:13'!
buildContainerHierarchy
	"use the top down slot relations to write all bottom up container relations
	1. after read from disk, where only the slot relations are stored
	2. in case of undo/redo in editors, because evolve only keeps the slot history"
	slots do: [:sa| 
		(sa value ifString: [self error: sa value, ' not loaded']) replaceContainer: self. 
		sa value isNode ifTrue: [sa value buildContainerHierarchy]]! !

!GbtSmartNode methodsFor: 'constraints' stamp: 'hk 11/15/2017 17:33'!
checkConstraints
	"fill the constraintViolationString and answer true, if consistent, false or nil"
	| constraints fulfilled violated errors stream |
	fulfilled := OrderedCollection new.
	violated := OrderedCollection new.
	errors := OrderedCollection new. 
	(constraints := self allConstraintSVOs) do:
		[:c| |res|  "res = Boolean | errorString | nil"
		res := [c val] ifError: [].
		(res = true) ifTrue: [fulfilled add: c].
		(res = false) ifTrue: [violated add: c].
		(res = true | (res = false)) ifFalse: [errors add: c]].  
	consistent := errors 
		ifEmpty: [fulfilled size = constraints size]
		ifNotEmpty: [].
	stream := WriteStream with: 'error: '.
	errors do: 
		[:c| stream << String cr << c errorString].
	constraintErrorString := stream contents.
	stream := WriteStream with: 'violated: '.
	violated do: 
		[:c| stream << String cr << c violationString].
	constraintViolationString := stream contents.
	^consistent
! !

!GbtSmartNode methodsFor: 'printing' stamp: 'hk 1/24/2018 17:56'!
choiceName
	^self longName, ' : ', self summaryEnriched! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 6/22/2016 16:17'!
classInitial
	^#T! !

!GbtSmartNode methodsFor: 'evolve' stamp: ''!
clearEvolution
	self previous ifNotNil: [:p| p clearEvolution].
	self next ifNotNil: [:n| n clearEvolution].
	self previous: nil.
	self next: nil.
	self resetEvolveCount! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 11/9/2017 11:51'!
container: anObjectOrNil
	anObjectOrNil ifNotNil: [container ifNotNil: 
			[self inform: 'double used in ', anObjectOrNil svoName]]. 
	super container: anObjectOrNil! !

!GbtSmartNode methodsFor: 'testing' stamp: 'hk 9/26/2017 15:23'!
contains: aStringOrColl
	aStringOrColl ifString:
	[^self containsOne: aStringOrColl].
	aStringOrColl do: [:str| (self containsOne: str) ifFalse: [^false]].
	^true! !

!GbtSmartNode methodsFor: 'XLS helper' stamp: 'hk 8/19/2017 17:40'!
contains: aValue at: aTag
	"answer true if any slot with tag or slotName aTag contains aValue"
	^(self allSlotSVOsTagged: aTag) 
		anySatisfy: [:e| e isSmartValue and: [e val = aValue]]! !

!GbtSmartNode methodsFor: 'testing' stamp: 'hk 9/26/2017 15:20'!
containsOne: aString
	"answer true if i contain aString"
^(self allLeafSVOs select: [:leaf| aString match: leaf val asString]) isNotEmpty
	! !

!GbtSmartNode methodsFor: 'accessing context' stamp: 'hk 12/13/2016 15:55'!
context
	^context! !

!GbtSmartNode methodsFor: 'accessing context' stamp: 'hk 11/8/2016 10:04'!
context: anAC
	context := {anAC svoName . anAC user}! !

!GbtSmartNode methodsFor: 'accessing context' stamp: 'hk 1/5/2017 13:39'!
contextName
	^(context ifNil: [^'']) first! !

!GbtSmartNode methodsFor: 'authoring' stamp: 'hk 11/2/2016 13:43'!
copy
	"needs to show up in authoring protocol"
	
	^super copy ! !

!GbtSmartNode methodsFor: 'copying' stamp: 'hk 8/18/2017 16:40'!
copyEvolveCount 
 	evolveCounter := evolveCounter copy! !

!GbtSmartNode methodsFor: 'copying' stamp: 'hk 3/25/2017 12:50'!
copyForSton
	^self shallowCopy postCopyForSton! !

!GbtSmartNode methodsFor: 'copying' stamp: 'hk 8/21/2017 21:05'!
copyFreeze
	^self copy freezeSlots

! !

!GbtSmartNode methodsFor: 'copying' stamp: 'hk 5/25/2017 18:37'!
copyTransient
	^self shallowCopy postCopyTransient! !

!GbtSmartNode methodsFor: 'copying' stamp: 'hk 9/24/2017 15:56'!
copyWith: aDirective
	"creates a 'projection' using the Directive"
	^aDirective 
		ifNil:  [self copy]
		ifNotNil: [aDirective transform: self]! !

!GbtSmartNode methodsFor: 'authoring' stamp: 'hk 10/11/2016 16:39'!
copyWithName: aUserName
	"answer a copy with another userName aName"
	
	| un cp |
	un := svoName.
	svoName := aUserName.
	cp := self copy .		"inserts in asvoDict with userName"
	svoName := un .
	^cp

! !

!GbtSmartNode methodsFor: 'meta path' stamp: ''!
deepPathTo: aTag onPath: aPath 
	"^<nil|OrderedCollection of Symbol>, the path of the node or leaf with the unique tag or slotName aTag"

	| res |  
	self slots do: [ :a | 
		(a hasTag: aTag) ifTrue: 
			[^{ #success . aPath add: a key; yourself} ] .
		a value ifNotNil: [:v | |p|
			v isNode ifTrue: 
				[(p := aPath copy) add: a key.
				res := v deepPathTo: aTag onPath: p .
				(res at: 1) = #success ifTrue: [^res] ] ] ].
	^{ #failure . aPath}! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 11/17/2016 16:21'!
defaultPolicy
	"any Ulist needs a default policy"

	^defaultPolicy ifNil: [defaultPolicy := GbtNoPolicy new]! !

!GbtSmartNode methodsFor: 'define' stamp: 'hk 11/27/2017 21:15'!
defineBuildInFromWith: defArray
	"one slot - answer true if applied"
	defArray first = #purpose ifTrue: [self purpose: defArray second. ^true].
	defArray first = #purposes ifTrue: [self purposes: defArray second. ^true].  
	defArray first = #uiClassName ifTrue: [self uiClassName: defArray second. ^true].
	^ false
			! !

!GbtSmartNode methodsFor: 'define' stamp: 'hk 5/19/2017 19:13'!
defineSmart: smartDefArray defineFull: restOfDefArray
	"operate on full thing once. define the smart & full thing"
	
	smartDefArray do: [ :spec|  
			originalSmart defineWith: spec .
			self defineWith: spec].
	restOfDefArray do: [ :spec| 
			self defineWith: spec].
	originalSmart clearEvolution 
		! !

!GbtSmartNode methodsFor: 'define' stamp: 'hk 5/5/2017 18:21'!
defineWith: defArray
	"one slot"
	(self defineIntrinsicWith: defArray) ifTrue: [ ^self ]. 
	(self defineBuildInFromWith: defArray) ifTrue: [ ^self ]. 
	self perform: #define: dsl: defArray! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 9/6/2017 17:49'!
delete
	deleted := true.
	self beTransient.
	self  store! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 6/30/2016 14:38'!
deleted
	^deleted ifNil: [false]! !

!GbtSmartNode methodsFor: 'ui helper' stamp: 'hk 1/13/2017 16:54'!
displayArrayFrom: displayColumns

	displayColumns ifEmpty: 
		[^Array with: self displayId with: self summaryEnriched].
	^Array with: self displayId withAll: (self resolvedArrayFrom: displayColumns)
! !

!GbtSmartNode methodsFor: 'printing' stamp: 'hk 9/6/2017 17:45'!
displayId
	^self prefix, self bizId ! !

!GbtSmartNode methodsFor: 'printing' stamp: 'hk 9/6/2017 17:46'!
displayName
	^self prefix, self longName, self postfix! !

!GbtSmartNode methodsFor: 'embedding' stamp: 'hk 9/5/2017 16:48'!
embed: aThing with: aView
	"fill myself with data of aThing keeping my private data"
	
	aView paste: aThing onto: self! !

!GbtSmartNode methodsFor: 'embedding' stamp: 'hk 9/5/2017 17:18'!
embedProtectedSlotsOf: aThing
	"copy all protected slots of aThing into myself" 
	
	aThing slots do: [:sa|   
		sa isProtected 
			ifTrue: [self evolveAddSlot: sa copyValue] 
			ifFalse: [(sa isNode and: [sa value protectedSlots isNotEmpty]) ifTrue: 
					[self slotAt: sa key ifAbsent: [self evolveAddSlot: (sa copy value: sa value smartCopy; yourself)].
					(self slotSVOAt: sa key) embedProtectedSlotsOf: sa value ]]]! !

!GbtSmartNode methodsFor: 'accessing context' stamp: 'hk 9/8/2017 16:09'!
embeddingContext
	"ctxt = #(svoName  user)"
	| ctxt | 
	ctxt := self nextUptreeContext ifNil: [^nil]. 
	^self bizApp contextNamed: ctxt first ! !

!GbtSmartNode methodsFor: 'tag substitution' stamp: 'hk 11/4/2017 21:17'!
enrichFromTags: aString 
	"find the tags in my container node and replace these by corresponding slot values. Answer a single line
	aString may contain space separated substrings of colon separated strings"
	
	| stream |   
	stream := WriteStream on: ''.
	aString substrings do: 
		[:str| str first = $# 
					ifFalse: [ stream nextPutAll: str]
					ifTrue: 	[stream nextPutAll: (self resolveTag: str allButFirst) asString].
		stream space ].  
	^stream contents
	 ! !

!GbtSmartNode methodsFor: 'tag substitution' stamp: 'hk 7/18/2017 13:23'!
enrichFromTagsQuoted: aString 
	"find the tags in my container node and replace these by corresponding slot values. Answer a single line
	aString may contain space separated substrings of colon separated strings"
	
	| stream |
	stream := WriteStream on: ''.
	aString substrings do: 
		[:str| str first = $# 
					ifFalse: [ stream nextPutAll: str]
					ifTrue: 	[stream nextPutAll: (self resolveTag: str allButFirst) printString].
		stream space ].
	^stream contents
	 ! !

!GbtSmartNode methodsFor: 'authoring' stamp: 'hk 2/27/2016 16:17'!
ensureBizId   
	"bizId is never changed"
	bizId ifNil: [self setBizId] ! !

!GbtSmartNode methodsFor: 'constraints' stamp: 'hk 11/15/2017 17:23'!
errorString
	^constraintErrorString ifNil: [ '' ]! !

!GbtSmartNode methodsFor: 'evolve' stamp: 'hk 9/6/2017 17:49'!
evolve
	"is called before writing a slot. Also see GbtWidget.write"
	
	self previous: self shallowCopy copyEvolveCount.
	self copySlots.
	self beTransient .
	self incrEvolveCount.
	^self previous 

! !

!GbtSmartNode methodsFor: 'evolve' stamp: ''!
evolve: aSlotName write: aValue
	"set the slot value"
	"PRE aSlotName denotes an existing leaf slot"
	
	([aValue isThing] ifError: [false]) ifTrue: [^self evolveNode: aSlotName write: aValue].
	^self evolveLeaf: aSlotName write: aValue
	
! !

!GbtSmartNode methodsFor: 'evolve' stamp: 'hk 7/19/2017 14:36'!
evolveCount
	^evolveCounter! !

!GbtSmartNode methodsFor: 'evolve' stamp: ''!
evolveLeaf: aSlotName write: aValue
	"set the slot value"
	"PRE aSlotName denotes an existing leaf slot"
	
	|vo previous newVO | 
	vo := self slotSVOAt: aSlotName.
	previous := self evolve.
	newVO := vo copy inputValue: aValue; container: self.
	self slots at: aSlotName put: 
		((self slots at: aSlotName) copy value: newVO ).
	vo container: previous.
	self next: nil.
	^newVO


! !

!GbtSmartNode methodsFor: 'evolve' stamp: ''!
evolveNode: aSlotName write: aThing
	"^nil if slot is missing, set the slot value (SVO) otherwise
	PRE node slot aSlotName exists"
	
	| sv previous |
	([aThing isNode] ifError: [false]) ifFalse: [^self error: 'NaThing: ', aThing asString].
	previous := self evolve.
	sv := self slotSVOAt: aSlotName.
	self slots at: aSlotName put: ((self slots at: aSlotName) copy value: aThing).
	aThing container: self.
	sv replaceContainer: previous.
	self next: nil.
! !

!GbtSmartNode methodsFor: 'evolve' stamp: 'hk 9/18/2017 21:39'!
evolveRemoveSlot: aGbtSlotAssociation
	| prev |
	prev := self evolve.
	self slots removeKey: (aGbtSlotAssociation container: prev) key! !

!GbtSmartNode methodsFor: 'smart' stamp: 'hk 2/17/2017 16:17'!
expandSVO: aGetter
	^self slotSVOAt: aGetter ifAbsent: [self smartAddSlotSVO: aGetter]
! !

!GbtSmartNode methodsFor: 'constraints' stamp: 'hk 11/9/2017 18:22'!
filter: aThingList
	"answer a copy of aThingList filterd by my constraints"

	^aThingList select: [:e| (e testWith: self) = true ]! !

!GbtSmartNode methodsFor: 'copying' stamp: 'hk 8/21/2017 21:05'!
freezeSlots
	slots do: [:slot| slot value isNode 
			ifTrue: [ slot value freezeSlots ]
			ifFalse: [ slot value freeze ] ] ! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 8/16/2017 17:15'!
fullThing
	"anyOne - there should be only one element"  
	fullVO = #self ifTrue: [^self].
	^self bizApp type: #fullThing named: fullVO ifAbsent: [GbtServer default type: #fullThing named: fullVO ifAbsent: []]! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 8/2/2016 17:06'!
fullVO: aFullThingName
	fullVO := aFullThingName! !

!GbtSmartNode methodsFor: 'gbtDecompile' stamp: 'hk 10/29/2017 14:58'!
gbtBizIdPolicyOn: aStream
	self idNumberPolicy ifNil: [^self].
	aStream tab;
		nextPutAll: 'bizIdPolicy'; tab; 
		nextPutAll: ': ';
		nextPutAll: self idNumberPolicy ; cr.
		
	! !

!GbtSmartNode methodsFor: 'gbtDecompile' stamp: 'hk 10/29/2017 14:58'!
gbtPurposesOn: aStream
	self purposes ifEmpty: [^self].
	aStream tab;
		nextPutAll: 'purposes'; tab; 
		nextPutAll: ': '.
	self purposes do: [:p| aStream nextPutAll: p].
	aStream cr.
		
	! !

!GbtSmartNode methodsFor: 'gbtDecompile' stamp: 'hk 11/6/2017 19:12'!
gbtSlotSource: aName on: aStream
	"write the source of the original thing"
	aStream nextPutAll: 'node'; space.
	aStream nextPutAll: aName; tab.
	aStream nextPut: $:; space.
	aStream nextPutAll: self originalSmart svoName.
	^''
		
	! !

!GbtSmartNode methodsFor: 'gbtDecompile' stamp: 'hk 1/10/2018 14:40'!
gbtSourceOn: aStream
	"write the source of the original thing"
	aStream 
		nextPutAll: 'thing ';
		nextPutAll: self svoName; cr.
	self gbtSummaryOn: aStream.
	self gbtPurposesOn: aStream.
	self gbtBizIdPolicyOn: aStream.
	self gbtUiOn: aStream.
	aStream tab; nextPut: ${; cr.
	self fullThing slots do: [:sa| 
		aStream tab. 
		(self fullThing originalSmart slotAt: sa key) ifNotNil: [aStream nextPut: $*].
		sa gbtSlotSourceOn: aStream ].
	aStream tab; nextPut: $}; cr
	
		
	! !

!GbtSmartNode methodsFor: 'gbtDecompile' stamp: 'hk 11/3/2017 18:07'!
gbtSummaryOn: aStream
	self summary ifEmpty: [^self].
	aStream tab;
		nextPutAll: 'summary'; tab; 
		nextPutAll: ': ';
		nextPutAll: self summary; 
		cr
		
	! !

!GbtSmartNode methodsFor: 'gbtDecompile' stamp: 'hk 11/27/2017 21:14'!
gbtUiOn: aStream
	self uiClassName ifNil: [^self].
	aStream tab;
		nextPutAll: 'ui'; tab; 
		nextPutAll: ': ';
		nextPutAll: self uiClassName; cr.
		
	! !

!GbtSmartNode methodsFor: 'testing' stamp: 'hk 8/30/2015 12:12'!
hasSubnodes
	^self subnodes isNotEmpty! !

!GbtSmartNode methodsFor: 'comparing' stamp: 'hk 11/9/2016 13:44'!
hash
	^self class hash bitXor: slots hash ! !

!GbtSmartNode methodsFor: 'evolve' stamp: 'hk 1/19/2018 12:11'!
incrEvolveCount 
	"needs to go up to root because semantics is just as dirty (some slots have changed)"
 	evolveCounter := (evolveCounter ifNil: [0]) +1.   
	(container ifNil: [^self]) incrEvolveCount ! !

!GbtSmartNode methodsFor: 'initialization' stamp: 'hk 9/7/2017 15:57'!
initialize
	super initialize.
	fullVO := #self.
	smart := true! !

!GbtSmartNode methodsFor: 'constraints' stamp: 'hk 7/25/2016 12:57'!
isConsistent
	"true | false | nil (in case of error)"
	^consistent! !

!GbtSmartNode methodsFor: 'testing' stamp: 'hk 9/3/2015 18:22'!
isNode
	^true! !

!GbtSmartNode methodsFor: 'testing' stamp: 'hk 11/25/2015 14:44'!
isSmart
	^smart ifNil: [ false ]! !

!GbtSmartNode methodsFor: 'testing' stamp: 'hk 1/24/2016 12:49'!
isThing
	^true! !

!GbtSmartNode methodsFor: 'ui helper' stamp: 'hk 11/22/2016 16:25'!
leafCollBy3
"GcExample initSVO. GcExample email valueCollBy3"
	| res size ar |  
	res := OrderedCollection new.
	ar := self leafPairsColl asArray.
	size := ar size . 
	1 to: size by: 3 do: 
		[ :a |  | o arr | 
		o := (a+3) min: (size+1) .
		arr := Array new: (o - a) .
		a to: o-1 do: [ :i | arr at: (i-1 \\ 3 +1) put: (ar at: i) ] .
		res add: arr ] .
	 ^res! !

!GbtSmartNode methodsFor: 'accessing leaf slots' stamp: 'hk 2/17/2017 16:07'!
leafNames
	^ self leafs collect: [:s| s key]! !

!GbtSmartNode methodsFor: 'ui helper' stamp: 'hk 8/1/2017 17:10'!
leafPairsColl
	| ar |
	ar := OrderedCollection new .
	self leafs  do: [:s| ar add: {s key . s value val asString}].  
	 ^ar ! !

!GbtSmartNode methodsFor: 'accessing leaf slots' stamp: 'hk 2/17/2017 16:07'!
leafSVOs
	^ self leafs collect: [:s| s value]! !

!GbtSmartNode methodsFor: 'accessing leaf slots' stamp: 'hk 11/30/2017 12:14'!
leafs
	^slots select: [ :s | s value isKindOf: GbtCell]  ! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 6/30/2016 13:22'!
listIndex
	^(self purposes ifEmpty: [^self bizId ]) first! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 5/23/2017 13:19'!
next
	^next! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 5/23/2017 13:19'!
next: newerGbtObject
	"remember what was here before going to previous"

	next := newerGbtObject ! !

!GbtSmartNode methodsFor: 'accessing context' stamp: 'hk 11/9/2017 17:29'!
nextUptreeContext
	"^name and user of the context of the thing I am node of"
	^context ifNil: [(container ifNil: [^nil]) nextUptreeContext ]! !

!GbtSmartNode methodsFor: 'accessing subnodes' stamp: 'hk 2/17/2017 16:28'!
nodeNames
	^ self nodeSlots collect: [:s| s key ] ! !

!GbtSmartNode methodsFor: 'accessing subnodes' stamp: 'hk 8/16/2017 17:21'!
nodeSlots
	^ (slots select: [ :s | s value isKindOf: GbtSmartNode ]) values! !

!GbtSmartNode methodsFor: 'accessing leaf slots' stamp: 'hk 8/27/2017 13:18'!
numbersTaggedWith: aTag
	"answer a collection of all numerical slot values with aTag"
	
	^(self allSlotSVOsTagged: aTag) select: [:e| e val isNumber] thenCollect: [:e| e val] ! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 8/23/2017 16:58'!
originalSmart
	^originalSmart ifNil: [originalSmart := self smartCopy]! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 8/23/2017 16:58'!
originalSmart: aSmartThng
	originalSmart := aSmartThng! !

!GbtSmartNode methodsFor: 'pending data' stamp: 'hk 9/7/2017 15:56'!
otherUserEdits
	^otherUserEdits ifNil: [false]
! !

!GbtSmartNode methodsFor: 'pending data' stamp: 'hk 9/7/2017 18:36'!
otherUserEdits: aBoolean
	otherUserEdits := aBoolean.
! !

!GbtSmartNode methodsFor: 'meta path' stamp: ''!
pathTo: aTag 
	"^<nil|OrderedCollection of Symbol>, the path to the node or leaf with aTag"
	| res |
	self searchStrategy
		ifNotNil: [res := self deepPathTo: aTag onPath: OrderedCollection new]
		ifNil: [res := self broadPathTo: aTag onPath: OrderedCollection new with: OrderedCollection new].
	^(res at: 1) = #success
		ifTrue: [res at: 2] 	"the path"
		ifFalse: [nil]! !

!GbtSmartNode methodsFor: 'copying' stamp: 'hk 5/25/2017 17:58'!
postCopy
	"copy and store in bizApp"
	self postCopyTransient.
	self bizApp addThing: self! !

!GbtSmartNode methodsFor: 'copying' stamp: 'hk 9/7/2017 16:52'!
postCopyForSton
	"recursive postCopy for STON"
	self resetFields.
	self copySlots .
	slots keysAndValuesDo: [:k :sl | |vc| 
		sl isNode 
			ifTrue: [vc := sl value copyForSton]
			ifFalse: [vc := sl value copy container: nil] .
		slots at: k put: (sl copy value: vc)]
! !

!GbtSmartNode methodsFor: 'copying' stamp: 'hk 9/7/2017 16:52'!
postCopyForStore
	"single node postCopy for store: replace subnodes by longName strings"
	self resetFields.
	slots := slots collect: [:sa| (sa value isKindOf: GbtSmartNode) 
		ifTrue: [sa copy value: sa value longName]
		ifFalse: [sa copy value: (sa value copy container: nil)]].
! !

!GbtSmartNode methodsFor: 'copying' stamp: 'hk 9/7/2017 18:39'!
postCopyTransient
	"copy and store in bizApp"
	super postCopy.
	context := nil.
	previous := next := nil.
	purposes := purposes copy.
	slots do: [:a| slots at: a key put: a copyValue].
	slots do: [:a|	a value container: self].
	self beTransient.
	dataPending := nil.
	otherUserEdits := nil.
! !

!GbtSmartNode methodsFor: 'printing' stamp: 'hk 9/6/2017 18:03'!
postfix
	^self isTransient ifTrue: ['*']ifFalse: ['']! !

!GbtSmartNode methodsFor: 'printing' stamp: 'hk 9/7/2017 16:01'!
prefix
	^(self hasDataPending or: [self otherUserEdits]) ifTrue: [ '*' ] ifFalse: [ '' ]! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 5/23/2017 13:18'!
previous
	^previous! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 5/23/2017 13:18'!
previous: oldGbtObject
	"remember what was here before"

	previous := oldGbtObject! !

!GbtSmartNode methodsFor: 'printing' stamp: 'hk 8/11/2015 16:46'!
printOn: aStream
	aStream nextPutAll: self longName ! !

!GbtSmartNode methodsFor: 'authoring' stamp: 'hk 5/3/2017 17:00'!
purpose: aString
	"put the purpose aString first"
	aString ifNil: [ ^self ].
	self check: [ aString isString ] toBe: #aString.
	self purposes 
		remove: aString ifAbsent: [];
		addFirst: aString! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 11/13/2015 17:49'!
purposes 
	^purposes ifNil: [purposes := OrderedCollection new]! !

!GbtSmartNode methodsFor: 'authoring' stamp: 'hk 2/7/2017 17:40'!
purposes: anArrayOfString
	purposes := anArrayOfString asOrderedCollection! !

!GbtSmartNode methodsFor: 'ui helper' stamp: 'hk 1/9/2018 20:54'!
refreshUI  
	self embeddingContext ifNotNil: [:c| c refreshUI]! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 3/24/2017 16:38'!
registerWith: anApp
	"add self & all subnodes to asvo dictionary"
	anApp addThing: self . 
	self bizApp: anApp.
	self subnodes do: [:sn| sn registerWith: anApp]! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 2/17/2017 15:59'!
remove  
	"remove self & save container "
	container ifNil: [ ^self ].
	container removeSlot: self ; save.! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 12/3/2016 15:06'!
removeBizId
	bizId := nil! !

!GbtSmartNode methodsFor: 'pending data' stamp: 'hk 9/8/2017 17:05'!
removeDataPending
	super removeDataPending . 
	(self embeddingContext ifNil: [ ^self ]) removeDataPending 
	! !

!GbtSmartNode methodsFor: 'pending data' stamp: 'hk 9/7/2017 15:57'!
removeOtherUserEdits
	self otherUserEdits ifTrue: [self setOtherUserEdits: false].
	
	! !

!GbtSmartNode methodsFor: 'accessing slots writing' stamp: 'hk 7/29/2017 14:37'!
removeSlot: aSVO   
	self evolveRemoveSlot: ((self slotWith: aSVO) ifNil: [^nil]) .
	^aSVO

! !

!GbtSmartNode methodsFor: 'accessing slots writing' stamp: 'hk 7/29/2017 14:37'!
removeSlotAt: aSlotName   
	| slot |
	slot := self slotAt: aSlotName ifAbsent: [^nil] .
	self evolveRemoveSlot: slot
! !

!GbtSmartNode methodsFor: 'authoring' stamp: 'hk 9/18/2017 21:38'!
removeSmart: aSlotNameOrKey
	"remove the first slot aSlotName found in hierarchy"

	| sa |
	sa := self slotAssocOf: aSlotNameOrKey.
	sa  container slots removeKey:  sa  key
		
! !

!GbtSmartNode methodsFor: 'evolve' stamp: 'hk 8/20/2017 14:30'!
resetEvolveCount 
 	evolveCounter := 0.
	self leafSVOs do: [:l| l invalidateCache]! !

!GbtSmartNode methodsFor: 'copying' stamp: 'hk 9/7/2017 17:29'!
resetFields
	context := nil.
	container := nil.
	originalSmart := nil. 
	previous := next := nil.
	bizApp := nil.
! !

!GbtSmartNode methodsFor: 'tag substitution' stamp: 'hk 11/23/2017 14:58'!
resolveTag: aSmartPath
	"replace aSmartPath by its slot content asString"

	| val |  
	[val := self atSmartPath: (aSmartPath substrings: ':')] 
				on: Error do: [val := #nil].
	(val isKindOf: GbtSmartNode) ifTrue: [val := val enrichFromTags: val summary].	 
	^val ifNil: ['-' printString]
! !

!GbtSmartNode methodsFor: 'tag substitution' stamp: 'hk 1/20/2017 18:47'!
resolveToSmartPath: aLookupString 
	"replace the substrings by their corresponding slot values and construct a smartPath. 
	first substring may be special: #R for 'root'"
	
	| root reducedString smartPath |
	root := aLookupString substrings first = '#R'.
	reducedString := root
		ifTrue: [self globalRoot enrichFromTags: (aLookupString copyReplaceTokens: '#R' with: ' ')]
		ifFalse: [self enrichFromTags: aLookupString]. 
	smartPath := reducedString withBlanksCondensed copyReplaceAll: ' ' with: ':' asTokens: false.
	^(root ifTrue: ['R:'] ifFalse: ['']), smartPath
	 ! !

!GbtSmartNode methodsFor: 'ui helper' stamp: 'hk 10/30/2017 12:58'!
resolvedArrayFrom: displayColumns
	| arr | 
	arr := Array new: displayColumns size .
	1 to: arr size do: [ :i | arr at: i put: (([self resolveTag: (displayColumns at: i)] ifError: ['--- ? ---']))].
	^arr! !

!GbtSmartNode methodsFor: 'accessing context' stamp: 'hk 9/7/2017 16:15'!
rootContext
	"ctxt = #(svoName  user)"
	| ctxt |
	ctxt := self globalRoot context ifNil: [^nil]. 
	^self bizApp contextNamed: ctxt first ! !

!GbtSmartNode methodsFor: 'analysing' stamp: 'hk 5/24/2017 15:03'!
rtSlots
	^self slots collect: [:s| s key, ': ', s value value value printString ]
! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 9/7/2017 19:07'!
save  
	self isTransient ifFalse: [^self].
	self saveHook.  "only for user edits"  
	(self rootContext ifNil: [self]) store! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 11/30/2017 15:33'!
saveAsPrimeListTemplate
	"save & store me as template in my big list"
	| ctxt smmry| 
	ctxt := (self embeddingContext ifNil: [^self]) container.
	(ctxt isKindOf: GbtPrimeListAC) ifFalse: [^self]. 
	smmry := self askForNewTemplateSummary ifNil: [^self] .
	ctxt thingTemplates add: (self copy summary: smmry) ! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 6/7/2017 10:53'!
saveAsTemplate
	"save & store me as template in full thing"
	container 
		ifNil: [self saveAsPrimeListTemplate]
		ifNotNil: [container saveTemplate: self]
! !

!GbtSmartNode methodsFor: 'accessing context' stamp: 'hk 1/4/2017 17:40'!
saveContext: anAC
	saveContext := {anAC svoName . anAC user}! !

!GbtSmartNode methodsFor: 'accessing context' stamp: 'hk 3/25/2017 12:05'!
saveContextName
	saveContext ifNil: [^nil].
	^saveContext first! !

!GbtSmartNode methodsFor: 'accessing context' stamp: 'hk 1/4/2017 18:08'!
saveContextNames
	| res |
	res := OrderedCollection new.
	context ifNotNil: [res add: context first].
	saveContext ifNotNil: [res add: saveContext first].
	^res! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 9/7/2017 16:19'!
saveHook 
	^(self embeddingContext ifNil: [^self]) saveHook: self
! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 11/30/2017 14:32'!
saveTemplate: aThing   
	| key template |
	key := (slots detect: [:s| s value = aThing]) key.
	template := aThing copy askForNewTemplateSummary.
	template store.
	(self fullThing slotAt: key ifAbsent: [^self]) addThingTemplate: template longName
! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 11/30/2017 13:02'!
saveValueTemplates
	self leafs do: [:a| (self fullThing slotAt: a key) addValueTemplate: a value inputValue]
! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 2/7/2017 16:07'!
searchStrategy
	^ searchStrategy! !

!GbtSmartNode methodsFor: 'serializing' stamp: ''!
serializedNodes2Store
	^self versionedNodes2Store collect: [:n| n stripped toString]
! !

!GbtSmartNode methodsFor: 'initialization' stamp: 'hk 9/7/2017 16:19'!
setBizId   
	self embeddingContext ifNil: [bizId := self defaultPolicy nextID. ^self].
	bizId  := self embeddingContext nextBizID
! !

!GbtSmartNode methodsFor: 'pending data' stamp: 'hk 9/7/2017 16:19'!
setDataPending
	super setDataPending .
	(self embeddingContext ifNil: [ ^self ]) setDataPending 
	! !

!GbtSmartNode methodsFor: 'evolve' stamp: 'hk 1/19/2018 12:17'!
setEvolveCountFromNext
	evolveCounter := self next evolveCount! !

!GbtSmartNode methodsFor: 'evolve' stamp: 'hk 1/19/2018 12:17'!
setEvolveCountFromPrevious
	evolveCounter := self previous evolveCount! !

!GbtSmartNode methodsFor: 'pending data' stamp: 'hk 9/7/2017 18:38'!
setOtherUserEdits: aBoolean
	"update the correspondig list"

	self otherUserEdits: aBoolean.
	(self embeddingContext ifNil: [^self]) setOtherUserEdits: aBoolean .
! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 1/19/2018 11:26'!
setSubtreeTransient
	self beTransient.
	self subnodes do: [:sn| sn setSubtreeTransient ]! !

!GbtSmartNode methodsFor: 'meta' stamp: ''!
slotAssocOf: aSelectorOrTag
	"answer the node and slotAssoc of aSlotName|tag, 
	smartAddBranch will raise an error, when called with a non-full-existing tag or slotName
	POST smart thing is grown"

	| path slotNameOrTag |
	slotNameOrTag := (aSelectorOrTag trimRight: [ :c | c = $: ]) asSymbol.
	path := (self pathTo: slotNameOrTag) ifNil: 
		[self smartAddBranch: slotNameOrTag.
		self pathTo: slotNameOrTag].
	^self slotAssocOnPath: path ! !

!GbtSmartNode methodsFor: 'meta path' stamp: ''!
slotAssocOnPath: aPath
	"answer the subNode slot aSlotName. 
	PRE aPath is valid and isNotEmpty"
	
	| res |
	res := self slotAt: aPath first asSymbol.
	^res value slotAssocOnPath: (aPath allButFirst ifEmpty: [^res])! !

!GbtSmartNode methodsFor: 'accessing slots writing' stamp: 'hk 1/19/2018 17:19'!
slotAt: aSlotName write: aThingOrValue
	"write a slot evolution conform"
	(self slotSVOAt: aSlotName ifAbsent: [^nil]) isSmartValue 
		ifTrue:  [self  evolveLeaf: aSlotName write: aThingOrValue ]
		ifFalse: [self evolveNode: aSlotName write: aThingOrValue ].
	self globalRoot allReferenceSlots do: [:sl| sl value invalidateCache]! !

!GbtSmartNode methodsFor: 'accessing slots writing' stamp: 'hk 8/22/2017 12:51'!
slotExpandAt: aSlotName put: aThingOrGbtValueLeaf
	"set the slotAssociation value"
	self expandSVO: aSlotName.
	self slotAt: aSlotName write: aThingOrGbtValueLeaf
	
! !

!GbtSmartNode methodsFor: 'meta path' stamp: ''!
slotOnPath: aPath
	"answer the subNode slot addressed by aPath. 
	PRE aPath is valid and isNotEmpty"
	
	^(self slotAssocOnPath: aPath) value! !

!GbtSmartNode methodsFor: 'accessing slots' stamp: 'hk 2/17/2017 16:19'!
slotSVOExpandAt: aSlotName 
	"answer the slot SVO or nil"
	^self slotSVOAt: aSlotName ifAbsent: [self expandSVO: aSlotName]
! !

!GbtSmartNode methodsFor: 'meta' stamp: ''!
slotTagged: aSymbol
	^self slotOnPath: ((self pathTo: aSymbol) ifNil: [^nil]) ! !

!GbtSmartNode methodsFor: 'accessing slots' stamp: 'hk 8/19/2017 17:40'!
slotValueAt: aSlotName 
	"get the slot value or nil. If slot value isLeaf, return its val"
	| assoc val |
	assoc := self slotAt: aSlotName ifAbsent: [^nil].
	val := assoc value ifNil: [^nil].
	^val isSmartValue ifTrue: [val val] ifFalse: [val]
	
! !

!GbtSmartNode methodsFor: 'accessing leaf slots' stamp: 'hk 8/27/2017 13:18'!
slotValuesTaggedWith: aTag
	"answer a collection of all slot values with aTag"
	
	^(self allSlotSVOsTagged: aTag) collect: [:e| e val] ! !

!GbtSmartNode methodsFor: 'smart' stamp: 'hk 11/25/2015 14:43'!
smart: aBoolean
	smart := aBoolean! !

!GbtSmartNode methodsFor: 'meta' stamp: ''!
smartAddBranch: aSlotNameOrTag 

	| startNode refNode path|
	startNode := self.
	refNode := self fullThing. 
	path := (refNode pathTo: aSlotNameOrTag) ifNil: [ self error: 'no path to ',aSlotNameOrTag ].
	path do: [ :slotn |  |sn |
			sn := slotn asSymbol.
			startNode := startNode slotSVOAt: sn ifAbsent: [startNode smartAddSlotSVO: sn].
			refNode := refNode slotSVOAt: sn]! !

!GbtSmartNode methodsFor: 'smart' stamp: 'hk 8/24/2017 18:03'!
smartAddSlotSVO: aSlotName
	"add the full things slot aSlotName. 
	for subnodes take the subnode's original smart"
	
	| sn sa newSlotAssoc node |
	sn := aSlotName asSymbol.
	sa := self fullThing slotAt: sn ifAbsent: [ self error: self svoName , ' has no master slot: ' , aSlotName ].
	node := sa value ifNil: [ self error: 'no master content in ' , aSlotName ].
	newSlotAssoc := sa copy.
	node isNode ifTrue: [newSlotAssoc value: node originalSmart copy].
	self evolveAddSlot: newSlotAssoc.	
	^ self slotSVOAt: aSlotName! !

!GbtSmartNode methodsFor: 'copying' stamp: 'hk 11/2/2016 13:52'!
smartCopy
	^self copy initializeSlots smart: true
	! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 1/8/2018 18:43'!
store
	self bizApp transact: {self serializedNodes2Store} as: self user! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 1/19/2018 11:26'!
storeSubtree   
	"single thing store: store the complete tree" 
	self setSubtreeTransient ; store! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 3/25/2017 12:42'!
stripped
	"for a single node"
	^self shallowCopy postCopyForStore ! !

!GbtSmartNode methodsFor: 'analysing' stamp: 'hk 10/26/2016 10:42'!
structureNodes 
	"full things only"
	^self subnodes! !

!GbtSmartNode methodsFor: 'accessing subnodes' stamp: 'hk 1/5/2016 11:32'!
subnodeAt: aSlotName 
	"answer the subnode content"
	^self subnodeAt: aSlotName ifAbsent: [  ] ! !

!GbtSmartNode methodsFor: 'accessing subnodes' stamp: 'hk 2/17/2017 16:28'!
subnodeAt: aSlotName ifAbsent: aBlock
	"answer the subnode content"
	^(self nodeSlots detect: [:s| s key = aSlotName] ifNone: aBlock) value! !

!GbtSmartNode methodsFor: 'accessing subnodes' stamp: 'hk 2/17/2017 16:28'!
subnodes
	^ self nodeSlots collect: [:s| s value ] ! !

!GbtSmartNode methodsFor: 'tag substitution' stamp: 'hk 2/18/2016 14:39'!
summaryEnriched   
	"start same node above to resolve the tags in summary string"
	^self enrichFromTags: self summary! !

!GbtSmartNode methodsFor: 'tag substitution' stamp: 'hk 2/7/2017 16:53'!
testAndEnrichFromTags: aString
	^aString substrings first = '#R'
		ifTrue: [self globalRoot enrichFromTags: (aString copyReplaceTokens: '#R' with: ' ' )]
		ifFalse: [self enrichFromTags: aString ]! !

!GbtSmartNode methodsFor: 'constraints' stamp: 'hk 11/9/2017 17:13'!
testWith: aConstraintThing
	"test myself with aConstraintThing. answer true, false or nil (in case of errors).
	self and aConstraintThing need to be combined - to resolve references & lookups"
	
	| testThing constraints|	
	aConstraintThing ifNil: [ ^true ].
	testThing := GbtSmartNode transient.
	testThing writeSlot: (GbtSlotAssociation key: #thingToTest value: self copyTransient).  
	constraints := aConstraintThing copyTransient.
	testThing writeSlot: (GbtSlotAssociation key: #constr value: constraints). 
	^constraints checkConstraints ! !

!GbtSmartNode methodsFor: 'ui helper' stamp: 'hk 7/1/2016 12:28'!
titleArrayFrom: titleColumns

	titleColumns ifNil: [^Array with: 'bizId' with: 'summary' ].
	^Array with: 'bizId' withAll: titleColumns
! !

!GbtSmartNode methodsFor: 'serializing' stamp: ''!
toString
	^STON toStringPretty: self! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 11/27/2017 21:16'!
uiClass
	^uiClassName ifNil: [ self defaultUiClass  ] ifNotNil: [ Smalltalk at: uiClassName ]! !

!GbtSmartNode methodsFor: 'authoring' stamp: 'hk 11/27/2017 21:16'!
uiClassName
	^uiClassName! !

!GbtSmartNode methodsFor: 'authoring' stamp: 'hk 11/27/2017 21:16'!
uiClassName: aClassName
	aClassName ifNil: [^self].
	self check: [ (Smalltalk at: aClassName asSymbol) isClass ] toBe: #aUiClass.  
	uiClassName := aClassName asSymbol! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 1/19/2018 11:18'!
updateVersion
	transient := false. 
	self nextVersion .
	self removeDataPending.
	self setOtherUserEdits: false.
	self clearEvolution.
	self saveValueTemplates! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 9/7/2017 16:15'!
user   
	"user of my context"
	^(self rootContext) 
		ifNil: [''] 
		ifNotNil: [:ctxt| ctxt user]! !

!GbtSmartNode methodsFor: 'accessing' stamp: 'hk 6/18/2017 17:31'!
val
	^self! !

!GbtSmartNode methodsFor: 'ui helper' stamp: 'hk 11/30/2017 13:31'!
valuesOf: aValueSlot  
	^(self fullThing slotAt: aValueSlot ifAbsent: [^#()]) value templates asOrderedCollection! !

!GbtSmartNode methodsFor: 'save - retrieve - remove' stamp: 'hk 9/6/2017 17:51'!
versionedNodes2Store
	"version all dirty nodes and answer the newly versioned branch for store"
	| res |
	self isTransient ifFalse: [^#()]. 
	self updateVersion. 
	res := OrderedCollection with: self.
	self subnodes do: [:sn| res addAll: sn versionedNodes2Store].
	^res 



	
! !

!GbtSmartNode methodsFor: 'constraints' stamp: 'hk 11/15/2017 17:15'!
violationString
	^constraintViolationString ifNil: [ '' ]! !

!GbtSmartNode methodsFor: 'analysing' stamp: 'hk 2/26/2017 13:49'!
writeFullThingStructureHierarchy
	"rewrite all container links in the hierarchy - caution - only full things tolerate that"

	self structureNodes do: [:sn| sn container: self; writeFullThingStructureHierarchy] 
! !

!GbtObject class methodsFor: 'checking' stamp: 'hk 1/7/2016 16:19'!
check: aBlock toBe: aSymbol	
	[aBlock value ifFalse: [ self error ] ] 
		ifError: [ ^self error: aSymbol , ' expected'].
! !

!GbtObject class methodsFor: 'checking' stamp: 'hk 1/12/2017 16:17'!
checkNoMakeString: aStringOrNumber
	self check: [aStringOrNumber asString asNumber isNumber] toBe: #aNumberString.
	^aStringOrNumber asString! !

!GbtObject class methodsFor: 'checking' stamp: 'hk 4/15/2017 14:44'!
checkStringMakeColl: oneOrMoreStrings
	| coll |
	oneOrMoreStrings ifNil: [^{}].
	oneOrMoreStrings ifString: [^{oneOrMoreStrings}].
	[coll := oneOrMoreStrings	collect: [:e| e asString]]	ifError: [ ^self error: 'one or more Strings expected'].
	^coll! !

!GbtObject class methodsFor: 'checking' stamp: 'hk 6/2/2017 16:06'!
checkThingMakeColl: oneOrMoreThings
	| coll |
	coll := oneOrMoreThings asOrderedCollection.
	self check: [coll allSatisfy: [ :e | e isKindOf: GbtObject] ] toBe: #aCollectionOfThings.
	^coll! !

!GbtObject class methodsFor: 'error handling' stamp: 'hk 5/12/2016 21:20'!
error: aString
	^GbtError signal: aString! !

!GbtObject class methodsFor: 'authoring' stamp: 'hk 5/5/2017 16:29'!
struct: aString 
	"answer an empty GbtObject named aString. If new, create it"

	^self struct: aString define: #()
		! !

!GbtObject class methodsFor: 'authoring' stamp: 'hk 3/14/2017 13:01'!
struct: aString define: anArray
	^self subclassResponsibility 
		! !

!GbtObject class methodsFor: 'accessing' stamp: 'hk 9/3/2015 18:26'!
uiClass
	^nil! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 1/3/2018 16:34'!
appName: aString
	appName := aString! !

!GbtObject methodsFor: 'printing' stamp: 'hk 9/7/2017 15:17'!
autoName
	^self classInitialAndId , self versionString ! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 1/19/2018 11:18'!
beTransient  
	transient := true. 
	container ifNotNil: [:c| c beTransient ]! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 1/9/2018 13:02'!
bizApp
	"the GbtBizApp for my user is my programStore"
	^bizApp ifNil: [GbtServer appNamed: appName]! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 3/23/2017 14:35'!
bizApp: aGbtBizApp
	bizApp := aGbtBizApp ! !

!GbtObject methodsFor: 'checking' stamp: 'hk 1/7/2016 16:20'!
check: aBlock toBe: aSymbol	
	self class check: aBlock toBe: aSymbol	
! !

!GbtObject methodsFor: 'checking' stamp: 'hk 1/12/2017 16:23'!
checkNoMakeString: aStringOrNumber
	^self class checkNoMakeString: aStringOrNumber! !

!GbtObject methodsFor: 'checking' stamp: 'hk 1/12/2017 12:28'!
checkStringMakeColl: oneOrMoreStrings
	^self class checkStringMakeColl: oneOrMoreStrings! !

!GbtObject methodsFor: 'checking' stamp: 'hk 1/12/2017 12:27'!
checkThingMakeColl: oneOrMoreThings
	^self class checkThingMakeColl: oneOrMoreThings! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 6/22/2016 16:18'!
classInitial
	^self subclassResponsibility ! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 6/22/2016 17:12'!
classInitialAndId
	^self classInitial , id asString ! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 5/28/2015 14:53'!
container
	^ container! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 11/9/2017 11:14'!
container: anObjectOrNil
	container := anObjectOrNil! !

!GbtObject methodsFor: 'pending data' stamp: 'hk 11/1/2016 16:27'!
dataPending
	^dataPending ifNil: [dataPending := false asValueHolder]! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 1/23/2016 19:15'!
defaultUiClass
	"default widget class"
	^self class uiClass! !

!GbtObject methodsFor: 'utility' stamp: 'hk 4/30/2016 16:48'!
edit
	(GbtThingEditor on: self) openWithSpec! !

!GbtObject methodsFor: 'utility' stamp: 'hk 4/30/2016 16:48'!
editD
	(GbtThingDiEditor on: self) openWithSpec! !

!GbtObject methodsFor: 'error handling' stamp: 'hk 1/7/2016 16:20'!
error: aString
	^self class error: aString! !

!GbtObject methodsFor: 'gbtDecompile' stamp: 'hk 10/30/2017 13:50'!
gbtSource
	| str |
	str := WriteStream on: ''.
	self gbtSourceOn: str.
	^str contents
	
		
	! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 12/13/2016 15:21'!
globalRoot
	"answer the root of the complete container hierarchy"
	
	^(container ifNil: [^self]) globalRoot! !

!GbtObject methodsFor: 'pending data' stamp: 'hk 6/8/2015 15:39'!
hasDataPending
	^self dataPending value = true! !

!GbtObject methodsFor: 'testing' stamp: 'hk 11/27/2017 21:21'!
hasUI
	^self uiClass isNotNil! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 8/26/2015 16:42'!
id
	^ id! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 9/28/2017 13:27'!
id: anInt
	id := anInt! !

!GbtObject methodsFor: 'initialization' stamp: 'hk 9/24/2017 15:19'!
initialize
	super initialize.
	self initializeFields! !

!GbtObject methodsFor: 'initialization' stamp: 'hk 1/19/2018 11:18'!
initializeFields
	container := nil .
	self resetVersion .
	dataPending := nil .
	transient := false! !

!GbtObject methodsFor: 'testing' stamp: 'hk 11/9/2016 12:58'!
isActiveContext
	^false! !

!GbtObject methodsFor: 'testing' stamp: 'hk 8/22/2017 12:57'!
isConstraint
	^false! !

!GbtObject methodsFor: 'testing' stamp: 'hk 11/29/2016 13:33'!
isContainerRoot
	^container isNil! !

!GbtObject methodsFor: 'testing' stamp: 'hk 9/24/2017 15:38'!
isDirective
	^false! !

!GbtObject methodsFor: 'testing' stamp: 'hk 12/31/2015 13:49'!
isFilled
	"used for constraints"
	^false! !

!GbtObject methodsFor: 'testing' stamp: 'hk 11/9/2016 12:59'!
isGbtBehavior
	^false! !

!GbtObject methodsFor: 'testing' stamp: 'hk 9/15/2015 17:10'!
isListAc
	^false! !

!GbtObject methodsFor: 'testing' stamp: 'hk 7/17/2015 17:35'!
isNoPolicy
	^false! !

!GbtObject methodsFor: 'testing' stamp: 'hk 4/15/2015 17:15'!
isNode
	"used for slot navigation in DomainVO"
	^false! !

!GbtObject methodsFor: 'testing' stamp: 'hk 11/6/2017 21:07'!
isNodeList
	^false! !

!GbtObject methodsFor: 'testing' stamp: 'hk 10/19/2017 12:18'!
isParseMock
	^false! !

!GbtObject methodsFor: 'testing' stamp: 'hk 5/31/2017 14:14'!
isPlaceholder
	"for parsing"
	^true! !

!GbtObject methodsFor: 'testing' stamp: 'hk 11/15/2017 13:01'!
isPlainAc
	^false! !

!GbtObject methodsFor: 'testing' stamp: 'hk 12/1/2015 21:02'!
isSmart
	"used to identify a smart thing"
	^false  ! !

!GbtObject methodsFor: 'testing' stamp: 'hk 8/19/2017 17:40'!
isSmartValue
	"used for slot navigation in DomainVO"
	^false! !

!GbtObject methodsFor: 'testing' stamp: 'hk 7/4/2016 15:27'!
isSumLeaf
	"used for slot navigation in DomainVO"
	^false! !

!GbtObject methodsFor: 'testing' stamp: 'hk 1/24/2016 12:50'!
isThing
	^false! !

!GbtObject methodsFor: 'testing' stamp: 'hk 1/19/2018 11:18'!
isTransient
	^transient ifNil: [false]! !

!GbtObject methodsFor: 'testing' stamp: 'hk 4/15/2015 17:14'!
isValue
	"used for slot navigation in DomainVO"
	^false! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 11/6/2017 21:07'!
localRoot
	"answer the root of the fixed container hierarchy"
	
	(container ifNil: [^self]) isNodeList ifTrue: [^self].
	^container localRoot! !

!GbtObject methodsFor: 'printing' stamp: 'hk 11/1/2016 16:30'!
longName
	^String withAll: ({self svoName. ':'. self autoName} flatCollect: [:s|s])! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 9/7/2017 15:14'!
nameAndId
	^self svoName, self classInitialAndId! !

!GbtObject methodsFor: 'saving' stamp: 'hk 4/5/2015 13:20'!
nextVersion
	^version := version  +1! !

!GbtObject methodsFor: 'error handling' stamp: 'hk 11/4/2016 13:06'!
notify: aString
	container notify: aString! !

!GbtObject methodsFor: 'error handling' stamp: 'hk 11/1/2016 15:00'!
notifyA: anArrayOfString
	self notify: (String withAll: (anArrayOfString flatCollect: [:s|s]))
! !

!GbtObject methodsFor: 'copying' stamp: 'hk 5/6/2017 17:09'!
postCopy
	self setID .
	self initializeFields.
	bizApp := bizApp copy.
	svoName := svoName copy! !

!GbtObject methodsFor: 'initialization' stamp: 'hk 3/27/2017 12:52'!
release
	super release.
	container := nil 
! !

!GbtObject methodsFor: 'pending data' stamp: 'hk 9/6/2017 17:31'!
removeDataPending
	"the final implementation needs a kind of reference count"
	self dataPending value ifTrue: [self dataPending value: false]! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 2/15/2017 10:57'!
replaceContainer: anObjectOrNil
	container := anObjectOrNil! !

!GbtObject methodsFor: 'private' stamp: 'hk 4/5/2015 13:20'!
resetVersion
	version := 0! !

!GbtObject methodsFor: 'analyzing' stamp: 'hk 6/7/2015 13:31'!
rtAttributes
	^{ ( 'id: ', self id asString) . ( 'version: ', self version asString)}! !

!GbtObject methodsFor: 'analyzing' stamp: 'hk 5/28/2015 13:13'!
rtSlots
	^#()! !

!GbtObject methodsFor: 'pending data' stamp: 'hk 9/6/2017 18:02'!
setDataPending   
	"the final implementation needs a kind of reference count in contexts"
	self dataPending value ifFalse: [self dataPending value: true]
! !

!GbtObject methodsFor: 'initialization' stamp: 'hk 3/29/2017 15:47'!
setID
	id := self bizApp tecNoPolicy nextID ! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 4/25/2017 13:50'!
svoName
	^ svoName ifNil: [#default]! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 4/25/2017 13:48'!
svoName: aString
	svoName := aString! !

!GbtObject methodsFor: 'utility' stamp: 'hk 11/15/2017 14:34'!
userDebug
	self edit
! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 4/3/2015 18:11'!
version
	^version! !

!GbtObject methodsFor: 'accessing' stamp: 'hk 6/22/2016 17:14'!
versionString
	^'v', self version asString! !

GbtObject subclass: #GbtParseMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

!GbtParseMock commentStamp: 'hk 11/7/2017 13:23' prior: 0!
I am used by the compiler to be replaced by a real GbtObject of the same name.
!

!GbtParseMock class methodsFor: 'as yet unclassified' stamp: 'hk 11/6/2017 17:33'!
svoName: aName
	^self new svoName: aName! !

!GbtParseMock methodsFor: 'accessing' stamp: 'hk 11/7/2017 13:25'!
context: dummy
	"needed in protocol to add aThing to a Context.
	the real assignment is done on replacing with the real Thing"! !

!GbtParseMock methodsFor: 'reflective operations' stamp: 'hk 10/17/2017 16:54'!
doesNotUnderstand: aMessage
	GbtParserError signal: svoName, ' not linked'
	! !

!GbtParseMock methodsFor: 'testing' stamp: 'hk 10/19/2017 12:19'!
isParseMock
	^true! !

Object subclass: #GbtPrimeThingMap
	uses: TGbtAccessSerialized
	instanceVariableNames: 'lines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Server'!

!GbtPrimeThingMap commentStamp: 'hk 4/6/2017 17:26' prior: 0!
I represent a primeThingMap file in a GbtStore.
The primeThingMap file declares the newest versions of all primeThings of a given svoName.
I am  used to update the primeThingMap file in a write transaction and to read all parts of the current  thing in a retrieval.
I may be  created by reading the file; then I'm updated and I am written to the file  .
This file is organized as one line per primeThing.
Each line starts with the longName of the root thing, followed by all node longNames.


    Instance Variables
	lines:		<Dictionary> 		of classInitialAndId  -> Coll of longNames
!

GbtPrimeThingMap class
	uses: TGbtAccessSerialized classTrait
	instanceVariableNames: ''!

!GbtPrimeThingMap class methodsFor: 'longName parts' stamp: ''!
classInitialAndIdOf: aLongName
	^(self matchesOf: aLongName)
		subexpression: 3	
	

	! !

!GbtPrimeThingMap class methodsFor: 'instance creation' stamp: 'hk 5/11/2017 12:39'!
fromString: aMultiLineString 
	^self new fromString: aMultiLineString ! !

!GbtPrimeThingMap class methodsFor: 'private' stamp: ''!
matchesOf: aLongName
	"values are longNames of the Form (\w+)\:([T|U]\d+)(v\d+) 
	answer the matches of the parts"
	^ '(\w+)\:([T|U]\w*\d+)(v\d+)' asRegex matchesPrefix: aLongName; yourself! !

!GbtPrimeThingMap class methodsFor: 'longName parts' stamp: ''!
svoNameOf: aLongName
	^(self matchesOf: aLongName)
		subexpression: 2	
	

	! !

!GbtPrimeThingMap class methodsFor: 'longName parts' stamp: ''!
versionOf: aLongName
	^(self matchesOf: aLongName)
		subexpression: 4	
	

	! !

!GbtPrimeThingMap methodsFor: 'adding' stamp: 'hk 4/28/2017 11:31'!
addRoot: aPathOfSerializedThings
	"update the line for aPathOfThings"
	| key newValues oldValues |  
	key := (self classInitialAndIdOf: aPathOfSerializedThings first) asSymbol.
	newValues := aPathOfSerializedThings collect: [:sn| self longNameOf: sn].
	oldValues := (lines at: key ifAbsent: [#(dummy)]) allButFirst. 
	self at: key put: (self merge: oldValues into: newValues)
	! !

!GbtPrimeThingMap methodsFor: 'accessing' stamp: 'hk 4/28/2017 11:37'!
at: aKey
	"answer the line for key aKey"
	^lines at: aKey ! !

!GbtPrimeThingMap methodsFor: 'accessing' stamp: 'hk 4/28/2017 11:29'!
at: aKey put: aString
	lines at: aKey asSymbol put: aString! !

!GbtPrimeThingMap methodsFor: 'accessing serialized node' stamp: ''!
classInitialAndIdOf: aSerializedNode 
	"aSerializedNode classInitialAndId "
	| searchString |
	searchString := '#id\s\:\s\''(\w+)\''\,'.
	^ 'T',	((searchString asRegex search: aSerializedNode; yourself) subexpression: 2) ! !

!GbtPrimeThingMap methodsFor: 'reading' stamp: 'hk 5/11/2017 12:39'!
fromString: aMultiLineString 
	"read the file content"
	aMultiLineString linesDo: [:line|  |words|
		words := line substrings.
		self at: (self class classInitialAndIdOf: words first) put: words]
	! !

!GbtPrimeThingMap methodsFor: 'initialization' stamp: 'hk 1/30/2017 14:13'!
initialize
	lines := OrderedIdentityDictionary new! !

!GbtPrimeThingMap methodsFor: 'accessing' stamp: 'hk 1/30/2017 14:28'!
keys
	^lines keys ! !

!GbtPrimeThingMap methodsFor: 'accessing' stamp: 'hk 1/28/2017 12:39'!
lines
	^ lines! !

!GbtPrimeThingMap methodsFor: 'accessing serialized node' stamp: ''!
longNameOf: aSerializedNode
	"aSerializedNode longName"
	^(self svoNameOf: aSerializedNode), ':', (self classInitialAndIdOf: aSerializedNode), (self versionStringOf: aSerializedNode)! !

!GbtPrimeThingMap methodsFor: 'adding' stamp: 'hk 1/30/2017 15:20'!
merge: oldValues into: newValues
	"keep all old values whose classInitialAndId is NOT replaced by a new value
	the long name of the root thing remains in first place"
	| res ciids |
	res := newValues.
	ciids := newValues collect: [ :nv| self class classInitialAndIdOf: nv ].
	oldValues do: [:ov| 
		(ciids includes: (self class classInitialAndIdOf: ov))
			ifFalse: [ res add: ov ] ].
	^res
	
	

	! !

!GbtPrimeThingMap methodsFor: 'accessing serialized node' stamp: ''!
svoNameOf: aSerializedNode
	"aSerializedNode svoName"
	^('#svoName\s\:\s[''|#](\w+)' asRegex search: aSerializedNode; yourself) subexpression: 2 ! !

!GbtPrimeThingMap methodsFor: 'writing' stamp: 'hk 1/30/2017 13:38'!
toString
	"create the file content"
	| str |
	str := WriteStream with: ''.
	lines keysAndValuesDo: [:k :v|  
		v do: [:e| str nextPutAll: e; ensureASpace].
		str cr	].
	^str contents
	
	! !

!GbtPrimeThingMap methodsFor: 'accessing serialized node' stamp: ''!
versionStringOf: aSerializedNode 
	"aSerializedNode versionString"
	^ 'v',	(('#version\s\:\s([0-9]+)' asRegex search: aSerializedNode; yourself) subexpression: 2)! !

Object subclass: #GbtReader
	instanceVariableNames: 'server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Runtime'!

!GbtReader commentStamp: 'hk 1/8/2018 19:18' prior: 0!
I am the reader for Things - similar to Datomic reader.
reading does not interfere with  transactions (writing))


    Instance Variables
	server:		<GbtServer>
!

!GbtReader class methodsFor: 'as yet unclassified' stamp: 'hk 1/8/2018 19:18'!
newOn: aServer
	^self new server: aServer! !

!GbtReader methodsFor: 'private' stamp: 'hk 2/26/2017 13:50'!
lineThingFrom: aCollOfLongNames
	"the first name is name of the root thing"
	| nodes|  
	nodes := aCollOfLongNames collect: [:sn| self loadNode: sn].
	self resolve: nodes first with: nodes allButFirst .
	^nodes first buildContainerHierarchy
	! !

!GbtReader methodsFor: 'api' stamp: 'hk 1/8/2018 19:20'!
loadList: svoName 
	"load all most recent versions from the subFolders of folder userName"
	| dir all primeThingMap|
	dir := (server thingsDir / svoName) ensureCreateDirectory.
	primeThingMap := server primeThingMapOf: dir.
	all := primeThingMap lines values collect: [:line| self lineThingFrom: line asOrderedCollection]. 
	^all reject: [:th| th deleted]
! !

!GbtReader methodsFor: 'private' stamp: 'hk 4/6/2017 17:24'!
loadNode: longName
	"load all most recent versions from the subFolders of folder userName"
	^self loadNode: (GbtPrimeThingMap svoNameOf: longName) 
			id: (GbtPrimeThingMap classInitialAndIdOf: longName) 
			version: (GbtPrimeThingMap versionOf: longName)! !

!GbtReader methodsFor: 'private' stamp: 'hk 1/8/2018 19:20'!
loadNode: svoName id: aClassInitialAndId version: aVersionString
	"basic load all most recent versions from the subFolders of folder userName"
	| dir file|
	dir := (server thingsDir / svoName / aClassInitialAndId) 
					ensureCreateDirectory.
	(file := dir / aVersionString) asFileReference exists ifFalse: 
		[^self error: svoName, ':', aClassInitialAndId, aVersionString, ' not found' ].
	^GbtSmartNode fromString: file readStream contents
! !

!GbtReader methodsFor: 'private' stamp: 'hk 2/17/2017 16:02'!
resolve: aThing with: aCollOfNodes
	aCollOfNodes ifEmpty: [^self].  
	aThing slotNames do: [:sn| |longName |
		longName := aThing slotSVOAt: sn.                 
		aCollOfNodes 
			detect:  [:n| n longName = longName]
			ifFound: [:n| 			"do not set dirty"
						(aThing slotAt: sn) value: n.	
						self resolve: n with: (aCollOfNodes copy remove: n; yourself)]]
! !

!GbtReader methodsFor: 'accessing' stamp: 'hk 1/8/2018 19:18'!
server: aServer
	server := aServer! !

Object subclass: #GbtRole
	instanceVariableNames: 'read write execute filter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Contexts'!

!GbtRole commentStamp: 'hk 1/4/2017 17:03' prior: 0!
I represent a group of  rights and filters for various contexts.
I am associated to a user such that a context on regristration will receive a GbtRight.


    Instance Variables
	filter:		<Dictionary> 				of ACname ->  FilterThing,  e.g. for filtering lists
	read: 		<Collection  of Symbol> 	the AC's svoNames
	write: 		<Collection  of Symbol> 	special symbols are 
	execute: 	<Collection  of Symbol> 	#all   and  #none!

GbtRole subclass: #GbtRight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Contexts'!

!GbtRight commentStamp: 'hk 11/22/2016 21:19' prior: 0!
I represent the  rights and filters for a context's user.

 Instance Variables redefined
	filters:		<GbtThing| nil> 		the filterThing, e.g. for filtering lists
	read: 		<Boolean> 		
	write: 		<Boolean> 		
	execute: 	<Boolean> 		
Accessors of the superclass are used!

!GbtRight methodsFor: 'accessing' stamp: 'hk 1/4/2017 17:05'!
allowedSubColl: aCollOfThing
	^aCollOfThing select: [:th| self allows: th]! !

!GbtRight methodsFor: 'accessing' stamp: 'hk 8/1/2017 13:52'!
allows: aThing
	^(aThing testWith: filter) ifNil: [false]! !

!GbtRight methodsFor: 'accessing' stamp: 'hk 11/22/2016 09:45'!
execute
	^execute ! !

!GbtRight methodsFor: 'accessing' stamp: 'hk 1/4/2017 17:03'!
filterThing: aFilterThing
	filter := aFilterThing ! !

!GbtRight methodsFor: 'initialization' stamp: 'hk 11/22/2016 21:19'!
initialize
	read := true.
	write := true.
	execute := true.
! !

!GbtRight methodsFor: 'accessing' stamp: 'hk 11/22/2016 09:45'!
read
	^read ! !

!GbtRight methodsFor: 'accessing' stamp: 'hk 11/22/2016 09:45'!
write
	^write ! !

!GbtRole class methodsFor: 'instance creation' stamp: 'hk 11/21/2016 16:54'!
forExecute
	^self new ! !

!GbtRole class methodsFor: 'instance creation' stamp: 'hk 11/21/2016 16:56'!
forRead
	^self new writeNone! !

!GbtRole class methodsFor: 'instance creation' stamp: 'hk 11/21/2016 17:12'!
forRead: coll1 
	^self forRead: coll1 write: #() 
! !

!GbtRole class methodsFor: 'instance creation' stamp: 'hk 11/21/2016 17:11'!
forRead: coll1 write: coll2 
	^self forRead: coll1 write: coll2 execute: #()
! !

!GbtRole class methodsFor: 'instance creation' stamp: 'hk 11/21/2016 17:10'!
forRead: coll1 write: coll2 execute: execColl
	| writeColl readColl |
	(writeColl := coll2 asSet) addAll: execColl.
	(readColl := coll1 asSet) addAll: writeColl.
	^self new 
		read: readColl;
		write: writeColl;
		execute: execColl;
		yourself! !

!GbtRole class methodsFor: 'instance creation' stamp: 'hk 11/21/2016 16:55'!
forWrite
	^self new executeNone! !

!GbtRole class methodsFor: 'instance creation' stamp: 'hk 11/21/2016 17:12'!
forWrite: coll1 
	^self forRead: coll1 write: coll1
! !

!GbtRole methodsFor: 'api' stamp: 'hk 8/16/2017 17:21'!
addFilter: aStringWithTags for: anACname
	| filterThing key |
	filterThing := filter at: anACname 
		ifAbsentPut: [GbtSmartNode basicNew initialize].
	key := (filterThing slots size +1) asString asSymbol.
	filterThing	define: key constraint: aStringWithTags.
		! !

!GbtRole methodsFor: 'accessing' stamp: 'hk 11/21/2016 17:04'!
execute: aCollOfACnames
	execute := aCollOfACnames! !

!GbtRole methodsFor: 'accessing' stamp: 'hk 11/21/2016 16:55'!
executeNone
	execute := #(none)! !

!GbtRole methodsFor: 'initialization' stamp: 'hk 1/4/2017 17:03'!
initialize
	read := #(#all).
	write := #(all).
	execute := #(all).
	filter := Dictionary new.! !

!GbtRole methodsFor: 'testing' stamp: 'hk 11/21/2016 16:53'!
mayExecute: anACname
	^(execute includes: #all) 
		or: [execute includes: anACname]! !

!GbtRole methodsFor: 'testing' stamp: 'hk 11/21/2016 16:52'!
mayRead: anACname
	^(self mayWrite: anACname) or: 
		[(read includes: #all) 
			or: [read includes: anACname]]! !

!GbtRole methodsFor: 'testing' stamp: 'hk 11/21/2016 16:53'!
mayWrite: anACname
	^(self mayExecute: anACname) or: 
		[(write includes: #all) 
			or: [write includes: anACname]]! !

!GbtRole methodsFor: 'accessing' stamp: 'hk 11/21/2016 17:03'!
read: aCollOfACnames
	read := aCollOfACnames! !

!GbtRole methodsFor: 'accessing' stamp: 'hk 11/21/2016 16:56'!
readNone
	self writeNone.
	read := #(none)! !

!GbtRole methodsFor: 'api' stamp: 'hk 1/4/2017 17:03'!
rightOf: anACname
	^GbtRight new  
		execute: (self mayExecute: anACname);
		write: (self mayWrite: anACname) ;
		read: (self mayRead: anACname) ;
		filterThing: (filter at: anACname ifAbsent: [])
		! !

!GbtRole methodsFor: 'accessing' stamp: 'hk 11/21/2016 17:03'!
write: aCollOfACnames
	write := aCollOfACnames! !

!GbtRole methodsFor: 'accessing' stamp: 'hk 11/21/2016 16:56'!
writeNone
	self executeNone.
	write := #(none)! !

Object subclass: #GbtRuntime
	uses: TGbtExecutable
	instanceVariableNames: 'user userRole executable appName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Runtime'!

!GbtRuntime commentStamp: 'hk 1/8/2018 18:57' prior: 0!
I am the central store of a users app instance. 
I hold the program:
- contexts with policies,
- declaratives  and
- fullThings
and I hold a cache of all things read from the db and created anew.

I come to life on log in and die on  log out

    Instance Variables
	appName:  		<String>
	programStore:	<GbtProgramStore > 	
	user:			<String>			userName
	userRole:		<GbtRole>
			
initializeForUserApp  simulates the network transport of the programStore!

GbtRuntime class
	uses: TGbtExecutable classTrait
	instanceVariableNames: ''!

!GbtRuntime methodsFor: 'executable' stamp: ''!
add: anSVO full: aFullVO   
	self executable add: anSVO full: aFullVO! !

!GbtRuntime methodsFor: 'executable' stamp: ''!
addAC: anAC 
	^self executable addAC: anAC ! !

!GbtRuntime methodsFor: 'executable' stamp: ''!
addDirective: anSVO 
	^self executable addDirective: anSVO ! !

!GbtRuntime methodsFor: 'thing cache' stamp: ''!
addThing: anSVO 
	self tecNoPolicy adaptTo: anSVO id.
	^(self executable thingsAt: anSVO svoName) addLast: anSVO 
! !

!GbtRuntime methodsFor: 'executable' stamp: ''!
allContexts
	^self executable allContexts! !

!GbtRuntime methodsFor: 'executable' stamp: ''!
allDirectives
	^self executable allDirectives! !

!GbtRuntime methodsFor: 'executable' stamp: ''!
allFsvosWithTemplates
	^self executable allFsvosWithTemplates! !

!GbtRuntime methodsFor: 'template editor' stamp: ''!
allSlotAssocsWithTemplates
	^self allACsWithTemplates! !

!GbtRuntime methodsFor: 'accessing' stamp: 'hk 1/8/2018 18:56'!
appName: anAppName
	appName := anAppName ! !

!GbtRuntime methodsFor: 'executable' stamp: ''!
contextNamed: anACname  
	^self type: #context named: anACname ifAbsent: []! !

!GbtRuntime methodsFor: 'executable' stamp: ''!
contextNoPolicyOf: anACname  
	^self executable contextNoPolicyOf: anACname  ! !

!GbtRuntime methodsFor: 'executable' stamp: ''!
contextNoPolicyOf: anACname getter: aSelector
	"set the getter"
	(self executable contextNoPolicyOf: anACname) getter: aSelector ! !

!GbtRuntime methodsFor: 'executable' stamp: ''!
contextNoPolicyOf: anACname prefix: aString
	"set the prefix"
	(self executable contextNoPolicyOf: anACname) prefix: aString! !

!GbtRuntime methodsFor: 'executable' stamp: ''!
directiveNamed: aName 
	"answer the decl with aName "

	^self type: #decl named: aName ifAbsent: []! !

!GbtRuntime methodsFor: 'accessing' stamp: 'hk 8/9/2017 16:27'!
executable
	^executable
	! !

!GbtRuntime methodsFor: 'executable' stamp: ''!
fullThingNamed: aName
	^self type: #fullThing named: aName ifAbsent: []! !

!GbtRuntime methodsFor: 'executable' stamp: ''!
hasContext: anACName
	(self contextNamed: anACName) ifNil: [^false].
	^true! !

!GbtRuntime methodsFor: 'initialization' stamp: 'hk 9/24/2017 15:53'!
initializeForUserApp: aProgramStore
	executable := STON fromString:(STON toString: aProgramStore).  
	executable tecNoPolicy prefix: user.
	self allContexts do: [:ctxt| 
		ctxt 
			user: self user; 
			userRight: (userRole rightOf: ctxt svoName);
			bizApp: self].
	self allThings do: [:th |
		th bizApp: self ].
	self allDirectives do: [:decl |
		decl bizApp: self ].! !

!GbtRuntime methodsFor: 'executable' stamp: ''!
mainContext  
	^self type: #context named: self executable mainCtxtName ifAbsent: []! !

!GbtRuntime methodsFor: 'executable' stamp: ''!
nextIdOfContextNoPolicy: anACname  
	^(self contextNoPolicyOf: anACname) nextID! !

!GbtRuntime methodsFor: 'api' stamp: 'hk 8/9/2017 16:27'!
open
	(self contextNamed: executable mainCtxtName) open ! !

!GbtRuntime methodsFor: 'initialization' stamp: 'hk 3/24/2017 21:05'!
stonConvert: aProgramStore
	"this is for a programStore, cf. GbtTransactor"
	^STON fromString:(STON toString: aProgramStore)! !

!GbtRuntime methodsFor: 'template editor' stamp: ''!
svoName
	"used by the template editor"  
	^'Context Templates'! !

!GbtRuntime methodsFor: 'thing cache' stamp: ''!
thingNamed: aName 
	"answer the svo with aName = svoName:id-version or svoName(with lowest id-version)"
	^self type: #thing named: aName ifAbsent: []! !

!GbtRuntime methodsFor: 'api' stamp: 'hk 1/9/2018 13:02'!
transact: anArrayOfPathOfThings as: aUser
	"transactions must be handled by the company common server"
	(GbtServer appNamed: appName)
		transact: anArrayOfPathOfThings as: aUser! !

!GbtRuntime methodsFor: 'accessing' stamp: 'hk 3/21/2017 16:34'!
user
	^user ! !

!GbtRuntime methodsFor: 'accessing' stamp: 'hk 3/14/2017 13:10'!
user: aName
	user := aName! !

!GbtRuntime methodsFor: 'accessing' stamp: 'hk 3/14/2017 15:44'!
userRole
	^userRole ! !

!GbtRuntime methodsFor: 'accessing' stamp: 'hk 3/14/2017 13:15'!
userRole: aRole
	userRole :=  aRole! !

Object subclass: #GbtServer
	uses: TGbtExecutable
	instanceVariableNames: 'transactor appName userDict appDict primeThingMapDict executable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Server'!

GbtServer class
	uses: TGbtExecutable classTrait
	instanceVariableNames: 'namedInstances currentAppName'!

!GbtServer commentStamp: 'hk 1/9/2018 13:56' prior: 0!
I am the central app component (server) for all  user apps: 
- I hold the  users (configured) with user roles & rights and the userApps already started
- I am responsible for the technical  thing id policy,
- I hold the compiled Gbt program (that is copied to the user app on startup)
- I also hold the transactor that writes things and informs other users about thing changes

I come to life with the first user and die after the last user has logged out

In Test and Development I also serve as the bizApp for the unknown user  <default>''

 Instance Variables
	appName: 			<String>				appName
	transactor: 			<GbtTransactor>		similar to a Datomic transactor
	executable:  	 		<GbtExecutable>		will be copied on user app start
	userDict:			<Dictionary> 			of Name -> userRole 
	appDict:				<Dictionary> 			of Name -> bizApp
	primeThingMapDict: 	<Dictionary> 			of svoName ->  GbtRootMap	(= rootMap file cache)
	
Class Variables 
	namedInstances: 		<Dictionary of GbtBizAppServer> 	key = appName
	currentAppName: 	<String>
		
Persistence (via GbtTransactor):
	users
	programStore
	own config parameters
	bizApp config parameters
	!

GbtServer class
	uses: TGbtExecutable classTrait
	instanceVariableNames: 'namedInstances currentAppName'!

!GbtServer class methodsFor: 'CIEL service' stamp: 'hk 1/11/2018 18:43'!
appBehaviorsOf: appName
	"^all behaviors - representation should be direct" 
	| ctxts res|
	ctxts := self appContextsOf: appName.
	res := OrderedCollection new.
	ctxts do: [:ctxt| res addAll: ctxt behaviors].
	^res! !

!GbtServer class methodsFor: 'CIEL service' stamp: 'hk 1/11/2018 18:36'!
appContextsOf: appName
	"^all contexts" 
	^(self appNamed: appName) executable allContexts! !

!GbtServer class methodsFor: 'instance management' stamp: 'hk 1/9/2018 13:02'!
appNamed: aName
	aName ifNil: [^self default].
	^namedInstances at: aName ifAbsent: [self default]! !

!GbtServer class methodsFor: 'CIEL service' stamp: 'hk 1/11/2018 18:37'!
appProjectorsOf: appName
	"^all contexts" 
	^(self appNamed: appName) executable allDirectives! !

!GbtServer class methodsFor: 'CIEL service' stamp: 'hk 1/11/2018 12:18'!
appThingsOf: appName
	"^all full things" 
	^(self appNamed: appName) executable allFullThings! !

!GbtServer class methodsFor: 'instance creation' stamp: 'hk 1/9/2018 13:40'!
clearAll
	self clearAll: #default! !

!GbtServer class methodsFor: 'class initialization' stamp: 'hk 1/9/2018 14:24'!
clearAll: appName
	(self appNamed: appName)
		clearStore;
		clearMessages.
	self initialize: appName ! !

!GbtServer class methodsFor: 'class initialization' stamp: 'hk 1/9/2018 13:28'!
clearStore
	self clearStore: #default! !

!GbtServer class methodsFor: 'class initialization' stamp: 'hk 1/9/2018 13:28'!
clearStore: appName
	(self appNamed: appName)
		clearStore
! !

!GbtServer class methodsFor: 'accessing' stamp: 'hk 1/5/2018 20:52'!
currentAppName
	^currentAppName! !

!GbtServer class methodsFor: 'accessing' stamp: 'hk 1/9/2018 13:05'!
currentAppName: aName
	currentAppName := aName! !

!GbtServer class methodsFor: 'instance management' stamp: 'hk 1/9/2018 13:02'!
default
	^self appNamed: currentAppName ! !

!GbtServer class methodsFor: 'class initialization' stamp: 'hk 1/9/2018 14:34'!
exampleInitializeAll
	self instanceNames do: [:n| 
			(self appNamed: n)
				clearStore;
				clearMessages].
	namedInstances := Dictionary new.
	self initialize: #default! !

!GbtServer class methodsFor: 'instance creation' stamp: 'hk 1/9/2018 13:07'!
initialize
	^self initialize: #default.
! !

GbtServer initialize!

!GbtServer class methodsFor: 'instance creation' stamp: 'hk 1/9/2018 13:06'!
initialize: anAppName
	self currentAppName: anAppName.
	^self initializeInstance! !

!GbtServer class methodsFor: 'instance creation' stamp: 'hk 1/9/2018 14:08'!
initializeInstance
	^namedInstances at: currentAppName put: (self basicNew appName: currentAppName; initialize) ! !

!GbtServer class methodsFor: 'accessing' stamp: 'hk 1/9/2018 20:29'!
instanceNames
	"self instanceNames"
	^namedInstances keys! !

!GbtServer methodsFor: 'accessing' stamp: 'hk 3/23/2017 11:07'!
activeUsers
	^appDict keys! !

!GbtServer methodsFor: 'executable' stamp: ''!
add: anSVO full: aFullVO   
	self executable add: anSVO full: aFullVO! !

!GbtServer methodsFor: 'executable' stamp: ''!
addAC: anAC 
	^self executable addAC: anAC ! !

!GbtServer methodsFor: 'thing cache' stamp: ''!
addThing: anSVO 
	self tecNoPolicy adaptTo: anSVO id.
	^(self executable thingsAt: anSVO svoName) addLast: anSVO 
! !

!GbtServer methodsFor: 'api' stamp: 'hk 3/23/2017 11:04'!
addUser: aName withRole: aRole
	userDict at: aName put: aRole
! !

!GbtServer methodsFor: 'executable' stamp: ''!
allContexts
	^self executable allContexts! !

!GbtServer methodsFor: 'executable' stamp: ''!
allDirectives
	^self executable allDirectives! !

!GbtServer methodsFor: 'executable' stamp: ''!
allFsvosWithTemplates
	^self executable allFsvosWithTemplates! !

!GbtServer methodsFor: 'template editor' stamp: ''!
allSlotAssocsWithTemplates
	^self allACsWithTemplates! !

!GbtServer methodsFor: 'accessing' stamp: 'hk 3/23/2017 14:26'!
appAt: aUser
	aUser = '' ifTrue: [^self].
	^appDict at: aUser ifAbsent: []! !

!GbtServer methodsFor: 'accessing' stamp: 'hk 1/8/2018 18:56'!
appName: anAppName
	appName := anAppName ! !

!GbtServer methodsFor: 'accessing' stamp: 'hk 3/23/2017 11:08'!
appUsers
	^userDict keys! !

!GbtServer methodsFor: 'initialize' stamp: 'hk 1/9/2018 13:17'!
clearMessages
	self messageDir ensureDeleteAllChildren.
! !

!GbtServer methodsFor: 'initialize' stamp: 'hk 1/9/2018 13:19'!
clearStore
	self thingsDir ensureDeleteAllChildren.
	self txDir ensureDeleteAllChildren.
! !

!GbtServer methodsFor: 'executable' stamp: ''!
contextNamed: anACname  
	^self type: #context named: anACname ifAbsent: []! !

!GbtServer methodsFor: 'executable' stamp: ''!
contextNoPolicyOf: anACname  
	^self executable contextNoPolicyOf: anACname  ! !

!GbtServer methodsFor: 'executable' stamp: ''!
contextNoPolicyOf: anACname getter: aSelector
	"set the getter"
	(self executable contextNoPolicyOf: anACname) getter: aSelector ! !

!GbtServer methodsFor: 'executable' stamp: ''!
contextNoPolicyOf: anACname prefix: aString
	"set the prefix"
	(self executable contextNoPolicyOf: anACname) prefix: aString! !

!GbtServer methodsFor: 'executable' stamp: ''!
directiveNamed: aName 
	"answer the decl with aName "

	^self type: #decl named: aName ifAbsent: []! !

!GbtServer methodsFor: 'accessing' stamp: 'hk 8/9/2017 16:27'!
executable
	^executable
	! !

!GbtServer methodsFor: 'executable' stamp: ''!
fullThingNamed: aName
	^self type: #fullThing named: aName ifAbsent: []! !

!GbtServer methodsFor: 'executable' stamp: ''!
hasContext: anACName
	(self contextNamed: anACName) ifNil: [^false].
	^true! !

!GbtServer methodsFor: 'accessing' stamp: 'hk 3/23/2017 11:08'!
hasUser: aUserName
	^userDict includesKey: aUserName! !

!GbtServer methodsFor: 'initialize' stamp: 'hk 1/8/2018 19:19'!
initialize    
	transactor := GbtTransactor newOn: self. 
	executable := GbtExecutable  newOn: self.
	userDict := Dictionary new.
	appDict := Dictionary new.
	primeThingMapDict := Dictionary new.! !

!GbtServer methodsFor: 'executable' stamp: ''!
mainContext  
	^self type: #context named: self executable mainCtxtName ifAbsent: []! !

!GbtServer methodsFor: 'accessing' stamp: 'hk 1/9/2018 13:13'!
messageDir
	^(FileSystem workingDirectory / appName / 'messageDir') ensureCreateDirectory ! !

!GbtServer methodsFor: 'executable' stamp: ''!
nextIdOfContextNoPolicy: anACname  
	^(self contextNoPolicyOf: anACname) nextID! !

!GbtServer methodsFor: 'accessing' stamp: 'hk 4/6/2017 17:32'!
primeThingMapAt: aSvoName
	^primeThingMapDict at: aSvoName ifAbsentPut: [self primeThingMapFromFileFor: aSvoName]  ! !

!GbtServer methodsFor: 'accessing' stamp: 'hk 1/8/2018 19:10'!
primeThingMapFromFileFor: aSvoName
	| dir res |
	dir := (self thingsDir / aSvoName) ensureCreateDirectory .
	(dir / 'primeThingMap') asFileReference exists 
		ifFalse: [ res := '' ]
		ifTrue: [(dir / 'primeThingMap') readStreamDo: 
						[ :stream | res := stream contents ]].
	^GbtPrimeThingMap fromString: res.
! !

!GbtServer methodsFor: 'accessing' stamp: 'hk 1/8/2018 20:32'!
primeThingMapOf: svoNameDir
	"answer the directoryEntries of all things with svoName"
	| primeThingMapFile res |
	(primeThingMapFile := svoNameDir / 'primeThingMap') asFileReference exists 
		ifTrue: [primeThingMapFile readStreamDo: [:str| res := str contents]]
		ifFalse: [res := ''].
	^GbtPrimeThingMap fromString: res.
! !

!GbtServer methodsFor: 'api' stamp: 'hk 1/8/2018 18:55'!
registerAppFor: userName
	| role bizApp| 
	role := userDict at: userName.
	appDict at: userName ifPresent: [self notify: 'should not run twice'].
	bizApp := GbtRuntime new
		appName: appName;
		user: userName;
	 	userRole: role.
	appDict at: userName put: bizApp.
	^bizApp initializeForUserApp: self executable
! !

!GbtServer methodsFor: 'api' stamp: 'hk 3/23/2017 11:12'!
removeUser: aName 
	userDict removeKey: aName ifAbsent: [] .
! !

!GbtServer methodsFor: 'accessing' stamp: 'hk 3/23/2017 11:12'!
roleOf: aUserName
	^(userDict at: aUserName) userRole! !

!GbtServer methodsFor: 'template editor' stamp: ''!
svoName
	"used by the template editor"  
	^'Context Templates'! !

!GbtServer methodsFor: 'thing cache' stamp: ''!
thingNamed: aName 
	"answer the svo with aName = svoName:id-version or svoName(with lowest id-version)"
	^self type: #thing named: aName ifAbsent: []! !

!GbtServer methodsFor: 'accessing' stamp: 'hk 1/8/2018 19:10'!
thingsDir
	^(FileSystem workingDirectory / appName / 'things') ensureCreateDirectory ! !

!GbtServer methodsFor: 'api' stamp: 'hk 1/8/2018 18:35'!
transact: anArrayOfPathOfThings as: aUser
	transactor transact: anArrayOfPathOfThings as: aUser! !

!GbtServer methodsFor: 'accessing' stamp: 'hk 1/23/2017 14:34'!
transactor
	^transactor ! !

!GbtServer methodsFor: 'accessing' stamp: 'hk 1/8/2018 19:08'!
txDir
	^(FileSystem workingDirectory / appName / 'tx') ensureCreateDirectory ! !

Object subclass: #GbtService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-Utilities'!

!GbtService commentStamp: 'hk 5/17/2016 11:01' prior: 0!
I contain microServices for GBT apps!

!GbtService class methodsFor: 'pdf' stamp: 'hk 2/11/2017 16:26'!
pdfLabel: arg1 with: arg2
	| tmp1 tmp2 tmp3 tmp4 tmp5 tmp7 tmp11 |
	tmp5 := arg2 asOrderedCollection.
	tmp4 := self streamNamed: arg1.
	tmp1 := PDFDocument new.
	tmp3 := PDFTimesFont size: 14 pt.
	tmp2 := PDFPage new.
	tmp2
		add:
			((PDFRectElement from: 1 mm @ 1 mm dimension: 90 mm @ 45 mm)
				drawColor: (PDFColor new setGreyLevel: 200));
		add:
			(PDFJpegElement
				from: 3 mm @ 3 mm
				dimension: 86 mm @ 7.74 mm
				fromStream: 'icons/header.jpg' asFileReference readStream).
	tmp7 := 20 mm.
	tmp5 size - 1
		timesRepeat: [ | tmp9 |
			tmp9 := PDFTextElement new.
			tmp9
				font: tmp3;
				from: 10 mm @ tmp7.
			tmp2 add: (tmp9 text: tmp5 removeFirst).
			tmp7 := tmp7 + 5 mm ].
	tmp11 := PDFTextElement new.
	tmp11
		font: tmp3;
		from: 10 mm @ (tmp7 + 2 mm).
	tmp2 add: (tmp11 text: tmp5 removeFirst).
	tmp1
		add: tmp2;
		exportTo: tmp4.
	UIManager default inform: 'pdf created'! !

!GbtService class methodsFor: 'private' stamp: 'hk 5/19/2016 11:26'!
streamNamed: aName
	"get the FileStream of file aName"

	(FileSystem workingDirectory / 'pdf') ensureCreateDirectory.
	^ FileStream newFileNamed: 'pdf/' , aName, '.pdf'! !

Object subclass: #GbtSlotAssociation
	instanceVariableNames: 'assoc purposes templates tagArray protected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Things'!

!GbtSlotAssociation commentStamp: 'hk 11/30/2017 15:16' prior: 0!
I represent a vlaue in a slot dictionary.
Note our copy semantics: must copy the association values, too.

Instance Variables
	assoc: 			<Association> 					my content
	tagCollection:	<Collection of Symbol | nil>
	purposes:		<nil|Array of String>
	protected: 		<Boolean|nil>					against Declarative>>paste:onto:  nil = false
	templates: 		<Collection of GbtThing>			node templates in full things
	
semantic specials:						
	the first purpose is the selected one!!
	#hasKeyOrTag determines how a slot is found in a Thing.  slotName overrides a tag.

Implementation hints
	There is a problem with OrderedIdentityDictionary>>associationsSelect
	used in GbtThing>>constraintSlots, leafSlots etc.
	is  replaces the GbtSlotAssociations in slots by Associations during select
	
===============================
implementation hints:

	templates:  is used for the value templates stored in GbtCell!

!GbtSlotAssociation class methodsFor: 'instance creation' stamp: 'hk 2/16/2017 09:56'!
key: aKey value: aValue
	^self new key: aKey value: aValue! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 11/30/2017 14:32'!
addThingTemplate: aLongName
	self templates add: aLongName ! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 11/30/2017 16:10'!
addValueTemplate: aString
	self value addTemplate: aString! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 9/18/2017 21:41'!
container
	^(self value ifNil: [^nil]) container! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 9/18/2017 21:39'!
container: aThing
	self value ifNil: [^self].
	self value ifString: [^self] .
	self value isArray ifTrue: [^self] .
	self value replaceContainer: aThing ! !

!GbtSlotAssociation methodsFor: 'copying' stamp: 'hk 2/3/2017 15:16'!
copyValue
	^self copy value: self value copy! !

!GbtSlotAssociation methodsFor: 'gbtDecompile' stamp: 'hk 11/4/2017 21:39'!
gbtDirectiveSlotSourceOn: aStream
	(self key = self value) ifTrue: [^aStream nextPutAll: self key;cr].
	self value ifString: 
		[^aStream 
			nextPutAll: 'tag ';
			nextPutAll: self key;
			nextPutAll: ' : ';
			nextPutAll: self value; cr].
 	aStream 
		nextPutAll: self key;
		nextPutAll: ' : '.
	self value isArray ifTrue: [aStream 
			nextPutAll: self value first; 
			nextPut: $  ;
			nextPutAll: self value second svoName.
			^self].
	aStream nextPutAll: self value svoName
		
! !

!GbtSlotAssociation methodsFor: 'gbtDecompile' stamp: 'hk 11/3/2017 14:08'!
gbtSlotSourceOn: aStream
	|comma bracket attributes|
	comma := false.
	bracket := false.
	attributes := self value gbtSlotSource: self key on: aStream.
	"the source is already written!! attributes are inserted now:"
	attributes ifNotEmpty: [:x|
		bracket ifFalse: [aStream space; nextPut: ${. bracket := true].
		comma ifTrue: [aStream nextPut: $,; space].
		aStream nextPutAll: attributes.
		comma := true].
	self purposes ifNotEmpty: [:ps| 
		bracket ifFalse: [aStream space; nextPut: ${. bracket := true].
		aStream nextPutAll: 'purposes: '.
		ps do: [:p| aStream nextPutAll: p; space ].
		comma := true].
	self tags ifNotEmpty: [:ts| 
		bracket ifFalse: [aStream space; nextPut: ${. bracket := true].
		comma ifTrue: [aStream nextPut: $,; space].
		aStream nextPutAll: 'tags: '.
		ts do: [:t| aStream nextPutAll: t; space ].
		comma := true].
	self isProtected ifTrue: [
		bracket ifFalse: [aStream space; nextPut: ${. bracket := true].
		comma ifTrue: [aStream nextPut: $,; space].
		aStream nextPutAll: 'protected: true'].
	bracket ifTrue: [aStream nextPut: $}].
 	aStream cr
! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 9/5/2017 13:14'!
hasTag: aTag
	"slotName or tag?"
	aTag ifNil: [^false].
	self key = aTag ifTrue: [^true] .
	tagArray ifNil: [^false].
	aTag ifNil: [^false].
	^tagArray includes: aTag ! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 8/22/2017 12:57'!
isConstraint
	^self isGbtObject and: [self value isConstraint]! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 9/24/2017 15:38'!
isDirective
	^self value isKindOf: GbtDirective! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 8/19/2017 17:40'!
isFilled
	self value ifNil: [^false].
	self isSmartValue ifTrue: [^self value isFilled].
	^true! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 10/17/2017 16:52'!
isGbtObject
	^self value isKindOf: GbtFrame! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 5/31/2017 14:38'!
isNode
	^self isGbtObject and: [self value isNode]! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 9/5/2017 16:56'!
isProtected
	^protected ifNil: [^false]! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 10/17/2017 13:17'!
isReference
	^(self value isKindOf: GbtCell) and: [self value isReference ]! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 10/17/2017 13:17'!
isSmartValue
	^self value isKindOf: GbtCell! !

!GbtSlotAssociation methodsFor: 'testing' stamp: 'hk 9/24/2017 15:47'!
isTag
	"tag in a Directive?"
	^self value isSymbol! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 2/15/2017 18:48'!
key
	^assoc key! !

!GbtSlotAssociation methodsFor: 'initialization' stamp: 'hk 2/16/2017 09:56'!
key: aKey value: aValue
	assoc := aKey -> aValue! !

!GbtSlotAssociation methodsFor: 'copying' stamp: 'hk 2/24/2017 13:14'!
postCopy
	super postCopy.
	tagArray := tagArray copy.
	purposes := purposes copy.
	assoc := assoc key -> assoc value.
	templates := nil.
! !

!GbtSlotAssociation methodsFor: 'printing' stamp: 'hk 5/3/2017 13:32'!
printOn: aStream
	"Store my assoc in the format (key->value)"
	aStream nextPutAll: self key.
	aStream nextPutAll: ' >> '.
	aStream nextPutAll: self value printString.
! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 9/14/2017 12:22'!
protected: aBoolean
	protected := aBoolean ifString: [aBoolean = #true]! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 10/31/2015 17:44'!
purposes 
	"the array of purposes"
	^(purposes ifNil: [ ^#() ]) ! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 1/4/2016 14:56'!
purposes: anArray
	"purposes describe the use of a slot"

	 purposes := anArray! !

!GbtSlotAssociation methodsFor: 'printing' stamp: 'hk 2/16/2017 09:53'!
storeOn: aStream
	"Store my assoc in the format (key->value)"
	aStream nextPutAll: 'Gbt'.
	assoc storeOn: aStream! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 10/30/2017 00:10'!
tags
	"answer the tagCollection or nil"
	^tagArray ifNil: [ #() ]! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 4/15/2017 14:42'!
tags: aCollOfSymbol
	"tags used in authoring are protected here"
	tagArray := aCollOfSymbol asArray! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 11/30/2017 15:14'!
templates: aCollOfValues
	"parsing - value templates"
	aCollOfValues do: [:e| self addValueTemplate: e]! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 11/30/2017 14:31'!
thingTemplates 
	"the coll of thing templates (for nodes in full things)"
	^templates ifNil: [templates := Set new] ! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 11/30/2017 14:30'!
thingTemplates: aCollOfLongNames
	templates := aCollOfLongNames asSet! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 11/28/2017 17:44'!
ui: aUiClassName
	self value uiClassName: aUiClassName asSymbol! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 2/15/2017 18:50'!
value
	^assoc value! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 2/15/2017 18:50'!
value: aValue
	assoc value: aValue! !

!GbtSlotAssociation methodsFor: 'accessing' stamp: 'hk 12/1/2017 02:43'!
valueTemplates 
	"the coll of value templates "
	^self value templates ! !

Object subclass: #GbtTransaction
	instanceVariableNames: 'user timeStamp id thingLongNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Server'!

!GbtTransaction commentStamp: 'hk 12/12/2016 14:39' prior: 0!
I am a record in the transaction table (see datomic for concepts)

    Instance Variables
	thingLongNames: 	<Collection> 		of thing-node longNames:  svoNames, id's and versions
	timeStamp:			<DateAndTime>
	user:				<String>			user name
	id: 					<Integer> 		the transaction ID!

!GbtTransaction class methodsFor: 'instance creation' stamp: 'hk 1/8/2018 18:41'!
id: anId for: aUser 
	^self new 
		id: anId;
		user: aUser! !

!GbtTransaction methodsFor: 'accessing' stamp: 'hk 1/24/2017 17:45'!
addThingLongName: aLongName
	thingLongNames add: aLongName ! !

!GbtTransaction methodsFor: 'accessing' stamp: 'hk 12/12/2016 13:36'!
id
	^id! !

!GbtTransaction methodsFor: 'accessing' stamp: 'hk 1/8/2018 18:41'!
id: anId
	id := anId! !

!GbtTransaction methodsFor: 'initialization' stamp: 'hk 1/8/2018 18:42'!
initialize
	timeStamp := DateAndTime now.
	thingLongNames := OrderedCollection new.! !

!GbtTransaction methodsFor: 'accessing' stamp: 'hk 12/12/2016 14:38'!
thingLongNames
	^thingLongNames ! !

!GbtTransaction methodsFor: 'serializing' stamp: ''!
toString
	^STON toStringPretty: self! !

!GbtTransaction methodsFor: 'accessing' stamp: 'hk 12/11/2016 13:59'!
user: aName
	user := aName! !

Object subclass: #GbtTransactor
	uses: TGbtAccessSerialized
	instanceVariableNames: 'txID mutex server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-Server'!

!GbtTransactor commentStamp: 'hk 1/8/2018 19:05' prior: 0!
I am the writer for Things - similar to Datomic transactor.
writing is additional, preserves all previous writings - with one exception: 
the rootMap file is changed on each write, this needs a transaction with a db lock .

I manage the notification of other users.
the file system db variant is organized in 
- 	current.things.svoName (directory)
	rootMap (file)
	v1 (directory)
	...
	vn (directory)
where n is the highest version


    Instance Variables
	server: 		<GbtServer>
	mutex:		<Object>
	txID:		<Object>
!

GbtTransactor class
	uses: TGbtAccessSerialized classTrait
	instanceVariableNames: ''!

!GbtTransactor class methodsFor: 'longName parts' stamp: ''!
classInitialAndIdOf: aLongName
	^(self matchesOf: aLongName)
		subexpression: 3	
	

	! !

!GbtTransactor class methodsFor: 'private' stamp: ''!
matchesOf: aLongName
	"values are longNames of the Form (\w+)\:([T|U]\d+)(v\d+) 
	answer the matches of the parts"
	^ '(\w+)\:([T|U]\w*\d+)(v\d+)' asRegex matchesPrefix: aLongName; yourself! !

!GbtTransactor class methodsFor: 'instance creation' stamp: 'hk 1/8/2018 19:04'!
newOn: aServer
	^self new server: aServer! !

!GbtTransactor class methodsFor: 'longName parts' stamp: ''!
svoNameOf: aLongName
	^(self matchesOf: aLongName)
		subexpression: 2	
	

	! !

!GbtTransactor class methodsFor: 'longName parts' stamp: ''!
versionOf: aLongName
	^(self matchesOf: aLongName)
		subexpression: 4	
	

	! !

!GbtTransactor methodsFor: 'accessing serialized node' stamp: ''!
classInitialAndIdOf: aSerializedNode 
	"aSerializedNode classInitialAndId "
	| searchString |
	searchString := '#id\s\:\s\''(\w+)\''\,'.
	^ 'T',	((searchString asRegex search: aSerializedNode; yourself) subexpression: 2) ! !

!GbtTransactor methodsFor: 'private' stamp: 'hk 1/23/2017 14:05'!
critical: aBlock
	mutex critical: aBlock! !

!GbtTransactor methodsFor: 'initialization' stamp: 'hk 1/23/2017 14:05'!
initialize
	txID := 0.
	mutex := Mutex new.
	! !

!GbtTransactor methodsFor: 'accessing serialized node' stamp: ''!
longNameOf: aSerializedNode
	"aSerializedNode longName"
	^(self svoNameOf: aSerializedNode), ':', (self classInitialAndIdOf: aSerializedNode), (self versionStringOf: aSerializedNode)! !

!GbtTransactor methodsFor: 'private' stamp: 'hk 1/23/2017 14:05'!
nextTxId
	^(txID := txID+1) asString! !

!GbtTransactor methodsFor: 'api' stamp: 'hk 9/8/2017 13:13'!
notify: aTx from: aUser to: users
	| things|    
	things := (aTx thingLongNames collect: [:n| 
		(GbtServer default appAt: aUser) type: #thing named: n ifAbsent: []])
			select: [:th| 
				th isNotNil and: [th isContainerRoot]] .  
	users do: [:u|self notify: u withAll: things storedBy: aUser]! !

!GbtTransactor methodsFor: 'notification' stamp: 'hk 9/7/2017 18:55'!
notify: aUser with: aThing storedBy: sUser
	"notify saveContext of all users, thing context of other users"
	| toNotify recApp sendApp|  
	sendApp := GbtServer default appAt: sUser.
	recApp := GbtServer default appAt: aUser.
	toNotify := aThing saveContextNames collect: 
		[:scn| recApp contextNamed: scn].
	aThing saveContextName ifNotNil: 
		[:scn| toNotify add: (sendApp contextNamed: scn )].
	toNotify do: [:ctxt| (ctxt userRight allows: aThing) ifTrue:
		[ctxt updatePrimeThing: (self stonConvert: aThing)] ]

! !

!GbtTransactor methodsFor: 'notification' stamp: 'hk 3/24/2017 17:02'!
notify: aUser withAll: things storedBy: sUser
	things do: [:th| self notify: aUser with: th storedBy: sUser]! !

!GbtTransactor methodsFor: 'accessing' stamp: 'hk 1/8/2018 19:05'!
server: aServer
	server := aServer! !

!GbtTransactor methodsFor: 'private' stamp: 'hk 3/25/2017 12:50'!
stonConvert: aThing
	"for Things: a copy preserving id & version"
	^(STON fromString:(STON toStringPretty: aThing copyForSton)) buildContainerHierarchy! !

!GbtTransactor methodsFor: 'private' stamp: 'hk 1/8/2018 19:11'!
storeNode: aSerializedThing 
	"do we need to store the tx id with the thing?"
	| dir subDir |
	dir := server thingsDir / (self svoNameOf: aSerializedThing) .
	dir ensureCreateDirectory .
	subDir := dir / (self classInitialAndIdOf: aSerializedThing) .
	subDir ensureCreateDirectory .
	subDir / (self versionStringOf: aSerializedThing) 
		writeStreamDo: [ :str| str nextPutAll: aSerializedThing]! !

!GbtTransactor methodsFor: 'private' stamp: 'hk 4/6/2017 17:28'!
storePath: serializedNodes tx: aTx
	serializedNodes ifNotEmpty: 
		[self updatePrimeThingMap: serializedNodes].
	serializedNodes do: [:sn|
		aTx addThingLongName: (self longNameOf: sn).
		self storeNode: sn]! !

!GbtTransactor methodsFor: 'private' stamp: 'hk 1/8/2018 19:08'!
storeTx: aTx
	| dir |
	dir := server txDir.
	dir ensureCreateDirectory .
	(dir / aTx id) writeStreamDo: 
		[:str| str nextPutAll: (aTx toString) ]! !

!GbtTransactor methodsFor: 'accessing serialized node' stamp: ''!
svoNameOf: aSerializedNode
	"aSerializedNode svoName"
	^('#svoName\s\:\s[''|#](\w+)' asRegex search: aSerializedNode; yourself) subexpression: 2 ! !

!GbtTransactor methodsFor: 'api' stamp: 'hk 2/4/2017 13:57'!
transact: anArrayOfSerializedBranches as: aUser
	self transact: anArrayOfSerializedBranches as: aUser notify: #all! !

!GbtTransactor methodsFor: 'private' stamp: 'hk 1/8/2018 19:06'!
transact: anArrayOfSerializedBranches as: aUser notify: users
	"ensure reentrancy .  store root only for simplicity"

	| tx usrs |
	tx := GbtTransaction id: self nextTxId for: aUser.

	self critical: 
		[ anArrayOfSerializedBranches do: [:path| self storePath: path tx: tx].
		self storeTx: tx].

	users = #current ifTrue: [ ^ self ].
	usrs := users = #all
		ifTrue: [server activeUsers  ]
		ifFalse: [ users ].  
	self notify: tx from: aUser to: usrs! !

!GbtTransactor methodsFor: 'private' stamp: 'hk 1/8/2018 20:40'!
updatePrimeThingMap: aPathOfSerializedThings 
	| dir primeThingMap svoName |
	svoName := self svoNameOf: aPathOfSerializedThings first .
	dir := (server thingsDir / svoName) ensureCreateDirectory . 
	primeThingMap := server primeThingMapAt: svoName.
	primeThingMap addRoot: aPathOfSerializedThings .
	(dir / 'primeThingMap') ensureDelete.
	dir / 'primeThingMap' writeStreamDo: [ :stream | stream nextPutAll: primeThingMap toString ].
	
	! !

!GbtTransactor methodsFor: 'accessing serialized node' stamp: ''!
versionStringOf: aSerializedNode 
	"aSerializedNode versionString"
	^ 'v',	(('#version\s\:\s([0-9]+)' asRegex search: aSerializedNode; yourself) subexpression: 2)! !

!Object methodsFor: '*GBT-DSL' stamp: 'hk 11/16/2016 13:29'!
ifString: aBlock
	"convenience - evaluate aBlock if I am a String"

	self isString ifTrue: [ ^aBlock value ] ! !

Object subclass: #SVO2
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'GBT-DSL'!

!SVO2 class methodsFor: 'development support' stamp: 'hk 9/30/2016 19:05'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!SVO2 class methodsFor: 'private' stamp: 'hk 9/30/2016 19:05'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!SVO2 class methodsFor: 'private' stamp: 'hk 9/30/2016 19:05'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!SVO2 class methodsFor: 'private' stamp: 'hk 9/30/2016 19:05'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!SVO2 class methodsFor: 'metacello tool support' stamp: 'hk 9/30/2016 19:05'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!SVO2 class methodsFor: 'loading' stamp: 'hk 9/30/2016 19:05'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!SVO2 class methodsFor: 'loading' stamp: 'hk 9/30/2016 19:05'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!SVO2 class methodsFor: 'loading' stamp: 'hk 9/30/2016 19:05'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!SVO2 class methodsFor: 'accessing' stamp: 'hk 9/30/2016 19:05'!
project

	^self new project! !

!SVO2 class methodsFor: 'development support' stamp: 'hk 9/30/2016 19:05'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!SVO2 methodsFor: 'accessing' stamp: 'hk 9/30/2016 19:05'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!SVO2 methodsFor: 'accessing' stamp: 'hk 9/30/2016 19:05'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

PackageManifest subclass: #ManifestSVO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL'!

!ManifestSVO commentStamp: '<historical>' prior: 0!
I store metadata for this package. These meta data are used by other tools such as the SmalllintManifestChecker and the critics Browser!

!ManifestSVO class methodsFor: 'code-critics' stamp: 'hk 11/2/2016 16:26'!
ruleRBCodeCruftLeftInMethodsRuleV1FalsePositive
	^ #(#(#(#RGMethodDefinition #(#GbtActionHalt #doOn: #false)) #'2016-11-02T16:26:44.488425+01:00') )! !

!ManifestSVO class methodsFor: 'code-critics' stamp: 'hk 1/18/2018 13:53'!
ruleRBStringConcatenationRuleV1FalsePositive
	^ #(#(#(#RGMethodDefinition #(#GbtCielBehavior #executeWith: #false)) #'2018-01-18T13:53:25.44733+01:00') )! !

Notification subclass: #GbtBehaviorNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL-M-core'!

GbtIcons initialize!

GbtServer initialize!
